/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=ke[me[I]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const f=new Map,R=new Map,L=new Map,b=new Map;function y(S,D){S.has(D.detail)||S.set(D.detail,-D.timestamp)}function g(S,D){const w=S.get(D.detail);w&&(w>=0||S.set(D.detail,w+D.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((S,D)=>S.timestamp-D.timestamp));for(const S of A)switch(S.type){case 10:y(f,S);break;case 11:case 12:g(f,S);break;case 21:y(R,S);break;case 22:g(R,S);break;case 33:y(L,S);break;case 34:g(L,S);break;case 31:y(b,S);break;case 32:g(b,S);break}let P=0;L.forEach(S=>P+=S);function $(S){const D=[];return S.forEach((w,u)=>D.push([u,w])),D}return{amdLoad:$(f),amdInvoke:$(R),nodeRequire:$(L),nodeEval:$(b),nodeRequireTotal:P}}static toMarkdownTable(f,R){let L="";const b=[];return f.forEach((y,g)=>{b[g]=y.length}),R.forEach(y=>{y.forEach((g,A)=>{typeof g>"u"&&(g=y[A]="-");const P=g.toString().length;b[A]=Math.max(P,b[A])})}),f.forEach((y,g)=>{L+=`| ${y+" ".repeat(b[g]-y.toString().length)} `}),L+=`|
`,f.forEach((y,g)=>{L+=`| ${"-".repeat(b[g])} `}),L+=`|
`,R.forEach(y=>{y.forEach((g,A)=>{typeof g<"u"&&(L+=`| ${g+" ".repeat(b[A]-g.toString().length)} `)}),L+=`|
`}),L}}e.$T=I}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(w,u,o){const i=F(w,u);if(i!==-1)return w[i]}e.$eb=I;function F(w,u,o=w.length-1){for(let i=o;i>=0;i--){const n=w[i];if(u(n))return i}return-1}e.$fb=F;function f(w,u){const o=R(w,u);return o===-1?void 0:w[o]}e.$gb=f;function R(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?n=a+1:r=a}return n-1}e.$hb=R;function L(w,u){const o=b(w,u);return o===w.length?void 0:w[o]}e.$ib=L;function b(w,u,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);u(w[a])?r=a:n=a+1}return n}e.$jb=b;function y(w,u,o=0,i=w.length){const n=b(w,u,o,i);return n===w.length?-1:n}e.$kb=y;class g{static{this.assertInvariants=!1}constructor(u){this.e=u,this.c=0}findLastMonotonous(u){if(g.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!u(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=u}const o=R(this.e,u,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$lb=g;function A(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>0&&(o=n)}return o}e.$mb=A;function P(w,u){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];u(n,o)>=0&&(o=n)}return o}e.$nb=P;function $(w,u){return A(w,(o,i)=>-u(o,i))}e.$ob=$;function S(w,u){if(w.length===0)return-1;let o=0;for(let i=1;i<w.length;i++){const n=w[i];u(n,w[o])>0&&(o=i)}return o}e.$pb=S;function D(w,u){for(const o of w){const i=u(o);if(i!==void 0)return i}}e.$qb=D}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(L,b){const y=Object.create(null);for(const g of L){const A=b(g);let P=y[A];P||(P=y[A]=[]),P.push(g)}return y}e.$J=I;function F(L,b){const y=[],g=[];for(const A of L)b.has(A)||y.push(A);for(const A of b)L.has(A)||g.push(A);return{removed:y,added:g}}e.$K=F;function f(L,b){const y=[],g=[];for(const[A,P]of L)b.has(A)||y.push(P);for(const[A,P]of b)L.has(A)||g.push(P);return{removed:y,added:g}}e.$L=f;function R(L,b){const y=new Set;for(const g of b)L.has(g)&&y.add(g);return y}e.$M=R}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function I(L){return(b,y,g)=>{let A=null,P=null;if(typeof g.value=="function"?(A="value",P=g.value):typeof g.get=="function"&&(A="get",P=g.get),!P)throw new Error("not supported");g[A]=L(P,y)}}function F(L,b,y){let g=null,A=null;if(typeof y.value=="function"?(g="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(g="get",A=y.get),!A)throw new Error("not supported");const P=`$memoize$${b}`;y[g]=function(...$){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[P]}}e.$nh=F;function f(L,b,y){return I((g,A)=>{const P=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...S){this[$]||(this[$]=y?y():void 0),clearTimeout(this[P]),b&&(this[$]=b(this[$],...S),S=[this[$]]),this[P]=setTimeout(()=>{g.apply(this,S),this[$]=y?y():void 0},L)}})}e.$oh=f;function R(L,b,y){return I((g,A)=>{const P=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,S=`$throttle$lastRun$${A}`,D=`$throttle$pending$${A}`;return function(...w){if(this[$]||(this[$]=y?y():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...w)),this[D])return;const u=this[S]+L;u<=Date.now()?(this[S]=Date.now(),g.apply(this,[this[$]]),this[$]=y?y():void 0):(this[D]=!0,this[P]=setTimeout(()=>{this[D]=!1,this[S]=Date.now(),g.apply(this,[this[$]]),this[$]=y?y():void 0},u-Date.now()))}})}e.$ph=R}),define(ke[8],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=I,e.$W=new I;function F(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=f;function R(a){g(a)||e.$W.onUnexpectedError(a)}e.$Z=R;function L(a){g(a)||e.$W.onUnexpectedExternalError(a)}e.$1=L;function b(a){if(a instanceof Error){const{name:t,message:s}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=b;const y="Canceled";function g(a){return a instanceof A?!0:a instanceof Error&&a.name===y&&a.message===y}e.$3=g;class A extends Error{constructor(){super(y),this.name=this.message}}e.$4=A;function P(){const a=new Error(y);return a.name=a.message,a}e.$5=P;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=$;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=S;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=D;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class u extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=u;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$bb=r}),define(ke[19],Se([1,0,8,121]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function f(H,X=0){return H[H.length-(1+X)]}e.$rb=f;function R(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$sb=R;function L(H,X,Y=($e,ne)=>$e===ne){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let $e=0,ne=H.length;$e<ne;$e++)if(!Y(H[$e],X[$e]))return!1;return!0}e.$tb=L;function b(H,X){const Y=H.length-1;X<Y&&(H[X]=H[Y]),H.pop()}e.$ub=b;function y(H,X,Y){return g(H.length,$e=>Y(H[$e],X))}e.$vb=y;function g(H,X){let Y=0,$e=H-1;for(;Y<=$e;){const ne=(Y+$e)/2|0,de=X(ne);if(de<0)Y=ne+1;else if(de>0)$e=ne-1;else return ne}return-(Y+1)}e.$wb=g;function A(H,X,Y){if(H=H|0,H>=X.length)throw new TypeError("invalid index");const $e=X[Math.floor(X.length*Math.random())],ne=[],de=[],ee=[];for(const he of X){const pe=Y(he,$e);pe<0?ne.push(he):pe>0?de.push(he):ee.push(he)}return H<ne.length?A(H,ne,Y):H<ne.length+ee.length?ee[0]:A(H-(ne.length+ee.length),de,Y)}e.$xb=A;function P(H,X){const Y=[];let $e;for(const ne of H.slice(0).sort(X))!$e||X($e[0],ne)!==0?($e=[ne],Y.push($e)):$e.push(ne);return Y}e.$yb=P;function*$(H,X){let Y,$e;for(const ne of H)$e!==void 0&&X($e,ne)?Y.push(ne):(Y&&(yield Y),Y=[ne]),$e=ne;Y&&(yield Y)}e.$zb=$;function S(H,X){for(let Y=0;Y<=H.length;Y++)X(Y===0?void 0:H[Y-1],Y===H.length?void 0:H[Y])}e.$Ab=S;function D(H,X){for(let Y=0;Y<H.length;Y++)X(Y===0?void 0:H[Y-1],H[Y],Y+1===H.length?void 0:H[Y+1])}e.$Bb=D;function w(H,X,Y){const $e=[];function ne(he,pe,Pe){if(pe===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=pe,B.toInsert.push(...Pe)):$e.push({start:he,deleteCount:pe,toInsert:Pe})}let de=0,ee=0;for(;;){if(de===H.length){ne(de,0,X.slice(ee));break}if(ee===X.length){ne(de,H.length-de,[]);break}const he=H[de],pe=X[ee],Pe=Y(he,pe);Pe===0?(de+=1,ee+=1):Pe<0?(ne(de,1,[]),de+=1):Pe>0&&(ne(de,0,[pe]),ee+=1)}return $e}e.$Cb=w;function u(H,X,Y){const $e=w(H,X,Y),ne=[],de=[];for(const ee of $e)ne.push(...H.slice(ee.start,ee.start+ee.deleteCount)),de.push(...ee.toInsert);return{removed:ne,added:de}}e.$Db=u;function o(H,X,Y){if(Y===0)return[];const $e=H.slice(0,Y).sort(X);return n(H,X,$e,Y,H.length),$e}e.top=o;function i(H,X,Y,$e,ne){return Y===0?Promise.resolve([]):new Promise((de,ee)=>{(async()=>{const he=H.length,pe=H.slice(0,Y).sort(X);for(let Pe=Y,B=Math.min(Y+$e,he);Pe<he;Pe=B,B=Math.min(B+$e,he)){if(Pe>Y&&await new Promise(J=>setTimeout(J)),ne&&ne.isCancellationRequested)throw new I.$4;n(H,X,pe,Pe,B)}return pe})().then(de,ee)})}e.$Fb=i;function n(H,X,Y,$e,ne){for(const de=Y.length;$e<ne;$e++){const ee=H[$e];if(X(ee,Y[de-1])<0){Y.pop();const he=(0,F.$jb)(Y,pe=>X(ee,pe)<0);Y.splice(he,0,ee)}}}function r(H){return H.filter(X=>!!X)}e.$Gb=r;function a(H){let X=0;for(let Y=0;Y<H.length;Y++)H[Y]&&(H[X]=H[Y],X+=1);H.length=X}e.$Hb=a;function t(H,X,Y){H.splice(Y,0,H.splice(X,1)[0])}e.$Ib=t;function s(H){return!Array.isArray(H)||H.length===0}e.$Jb=s;function d(H){return Array.isArray(H)&&H.length>0}e.$Kb=d;function c(H,X=Y=>Y){const Y=new Set;return H.filter($e=>{const ne=X($e);return Y.has(ne)?!1:(Y.add(ne),!0)})}e.$Lb=c;function l(H){const X=new Set;return Y=>{const $e=H(Y);return X.has($e)?!1:(X.add($e),!0)}}e.$Mb=l;function h(H,X){return H.length>0?H[0]:X}e.$Nb=h;function k(H,X){return H.length>0?H[H.length-1]:X}e.$Ob=k;function C(H,X,Y=($e,ne)=>$e===ne){let $e=0;for(let ne=0,de=Math.min(H.length,X.length);ne<de&&Y(H[ne],X[ne]);ne++)$e++;return $e}e.$Pb=C;function m(H){return[].concat(...H)}e.$Qb=m;function p(H,X){let Y=typeof X=="number"?H:0;typeof X=="number"?Y=H:(Y=0,X=H);const $e=[];if(Y<=X)for(let ne=Y;ne<X;ne++)$e.push(ne);else for(let ne=Y;ne>X;ne--)$e.push(ne);return $e}e.$Rb=p;function v(H,X,Y){return H.reduce(($e,ne)=>($e[X(ne)]=Y?Y(ne):ne,$e),Object.create(null))}e.$Sb=v;function E(H,X){return H.push(X),()=>N(H,X)}e.$Tb=E;function N(H,X){const Y=H.indexOf(X);if(Y>-1)return H.splice(Y,1),X}e.$Ub=N;function z(H,X,Y){const $e=H.slice(0,X),ne=H.slice(X);return $e.concat(Y,ne)}e.$Vb=z;function M(H,X){let Y;if(typeof X=="number"){let $e=X;Y=()=>{const ne=Math.sin($e++)*179426549;return ne-Math.floor(ne)}}else Y=Math.random;for(let $e=H.length-1;$e>0;$e-=1){const ne=Math.floor(Y()*($e+1)),de=H[$e];H[$e]=H[ne],H[ne]=de}}e.$Wb=M;function T(H,X){const Y=H.indexOf(X);Y>-1&&(H.splice(Y,1),H.unshift(X))}e.$Xb=T;function j(H,X){const Y=H.indexOf(X);Y>-1&&(H.splice(Y,1),H.push(X))}e.$Yb=j;function O(H,X){for(const Y of X)H.push(Y)}e.$Zb=O;function V(H,X){return Array.isArray(H)?H.map(X):X(H)}e.$1b=V;function te(H){return Array.isArray(H)?H:[H]}e.$2b=te;function fe(H){return H[Math.floor(Math.random()*H.length)]}e.$3b=fe;function Z(H,X,Y){const $e=G(H,X),ne=H.length,de=Y.length;H.length=ne+de;for(let ee=ne-1;ee>=$e;ee--)H[ee+de]=H[ee];for(let ee=0;ee<de;ee++)H[ee+$e]=Y[ee]}e.$4b=Z;function Q(H,X,Y,$e){const ne=G(H,X);let de=H.splice(ne,Y);return de===void 0&&(de=[]),Z(H,ne,$e),de}e.$5b=Q;function G(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}var oe;(function(H){function X(de){return de<0}H.isLessThan=X;function Y(de){return de<=0}H.isLessThanOrEqual=Y;function $e(de){return de>0}H.isGreaterThan=$e;function ne(de){return de===0}H.isNeitherLessOrGreaterThan=ne,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function x(H,X){return(Y,$e)=>X(H(Y),H($e))}e.$6b=x;function Ee(...H){return(X,Y)=>{for(const $e of H){const ne=$e(X,Y);if(!oe.isNeitherLessOrGreaterThan(ne))return ne}return oe.neitherLessOrGreaterThan}}e.$7b=Ee;const le=(H,X)=>H-X;e.$8b=le;const q=(H,X)=>(0,e.$8b)(H?1:0,X?1:0);e.$9b=q;function U(H){return(X,Y)=>-H(X,Y)}e.$0b=U;class ie{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let Y=this.c;for(;Y<this.g.length&&X(this.g[Y]);)Y++;const $e=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,$e}takeFromEndWhile(X){let Y=this.d;for(;Y>=0&&X(this.g[Y]);)Y--;const $e=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const Y=this.g.slice(this.c,this.c+X);return this.c+=X,Y}}e.$$b=ie;class be{static{this.empty=new be(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(Y=>(X(Y),!0))}toArray(){const X=[];return this.iterate(Y=>(X.push(Y),!0)),X}filter(X){return new be(Y=>this.iterate($e=>X($e)?Y($e):!0))}map(X){return new be(Y=>this.iterate($e=>Y(X($e))))}some(X){let Y=!1;return this.iterate($e=>(Y=X($e),!Y)),Y}findFirst(X){let Y;return this.iterate($e=>X($e)?(Y=$e,!1):!0),Y}findLast(X){let Y;return this.iterate($e=>(X($e)&&(Y=$e),!0)),Y}findLastMaxBy(X){let Y,$e=!0;return this.iterate(ne=>(($e||oe.isGreaterThan(X(ne,Y)))&&($e=!1,Y=ne),!0)),Y}}e.$_b=be}),define(ke[60],Se([1,0,8]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function F(y,g){if(!y)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=F;function f(y,g="Unreachable"){throw new Error(g)}e.$4c=f;function R(y){if(!y)throw new I.$bb("Assertion Failed")}e.$5c=R;function L(y){if(!y()){debugger;y(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$6c=L;function b(y,g){let A=0;for(;A<y.length-1;){const P=y[A],$=y[A+1];if(!g(P,$))return!1;A++}return!0}e.$7c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(F){const f=this;let R=!1,L;return function(){return R||(R=!0,L=F.apply(f,arguments)),L}}e.$cb=I}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=void 0;class I{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$FM=I,e.$GM=new I("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=f;const R=Object.freeze([]);function L(){return R}F.empty=L;function*b(a){yield a}F.single=b;function y(a){return f(a)?a:b(a)}F.wrap=y;function g(a){return a||R}F.from=g;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=A;function P(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=P;function $(a){return a[Symbol.iterator]().next().value}F.first=$;function S(a,t){for(const s of a)if(t(s))return!0;return!1}F.some=S;function D(a,t){for(const s of a)if(t(s))return s}F.find=D;function*w(a,t){for(const s of a)t(s)&&(yield s)}F.filter=w;function*u(a,t){let s=0;for(const d of a)yield t(d,s++)}F.map=u;function*o(...a){for(const t of a)for(const s of t)yield s}F.concat=o;function i(a,t,s){let d=s;for(const c of a)d=t(d,c);return d}F.reduce=i;function*n(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}F.slice=n;function r(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const d=a[Symbol.iterator]();for(let c=0;c<t;c++){const l=d.next();if(l.done)return[s,F.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return d}}]}F.consume=r})(I||(e.Iterable=I={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,s=!1){let d=0;const c=t.length;let l="",h=0,k=16,C=0;function m(T){let j=0,O=0;for(;j<T;){const V=t.charCodeAt(d);if(V>=48&&V<=57)O=O*16+V-48;else if(V>=65&&V<=70)O=O*16+V-65+10;else if(V>=97&&V<=102)O=O*16+V-97+10;else break;d++,j++}return j<T&&(O=-1),O}function p(T){d=T,l="",h=0,k=16,C=0}function v(){const T=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&g(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&g(t.charCodeAt(d)))for(d++;d<t.length&&g(t.charCodeAt(d));)d++;else return C=3,t.substring(T,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&g(t.charCodeAt(d))){for(d++;d<t.length&&g(t.charCodeAt(d));)d++;j=d}else C=3;return t.substring(T,j)}function E(){let T="",j=d;for(;;){if(d>=c){T+=t.substring(j,d),C=2;break}const O=t.charCodeAt(d);if(O===34){T+=t.substring(j,d),d++;break}if(O===92){if(T+=t.substring(j,d),d++,d>=c){C=2;break}switch(t.charCodeAt(d++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const te=m(4);te>=0?T+=String.fromCharCode(te):C=4;break}default:C=5}j=d;continue}if(O>=0&&O<=31)if(y(O)){T+=t.substring(j,d),C=2;break}else C=6;d++}return T}function N(){if(l="",C=0,h=d,d>=c)return h=c,k=17;let T=t.charCodeAt(d);if(b(T)){do d++,l+=String.fromCharCode(T),T=t.charCodeAt(d);while(b(T));return k=15}if(y(T))return d++,l+=String.fromCharCode(T),T===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),k=14;switch(T){case 123:return d++,k=1;case 125:return d++,k=2;case 91:return d++,k=3;case 93:return d++,k=4;case 58:return d++,k=6;case 44:return d++,k=5;case 34:return d++,l=E(),k=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<c&&!y(t.charCodeAt(d));)d++;return l=t.substring(j,d),k=12}if(t.charCodeAt(d+1)===42){d+=2;const O=c-1;let V=!1;for(;d<O;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,V=!0;break}d++}return V||(d++,C=1),l=t.substring(j,d),k=13}return l+=String.fromCharCode(T),d++,k=16}case 45:if(l+=String.fromCharCode(T),d++,d===c||!g(t.charCodeAt(d)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=v(),k=11;default:for(;d<c&&z(T);)d++,T=t.charCodeAt(d);if(h!==d){switch(l=t.substring(h,d),l){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return l+=String.fromCharCode(T),d++,k=16}}function z(T){if(b(T)||y(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let T;do T=N();while(T>=12&&T<=15);return T}return{setPosition:p,getPosition:()=>d,scan:s?M:N,getToken:()=>k,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>C}}e.$1m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,s){const d=[],c=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function C(m,p,v,E){h.value=m,h.offset=p,h.length=v,h.type=E,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:(m,p)=>{if(s<=m)throw c;l=void 0,k=s>m,d.push("")},onObjectProperty:(m,p,v)=>{if(s<p||(C(m,p,v,"property"),d[d.length-1]=m,s<=p+v))throw c},onObjectEnd:(m,p)=>{if(s<=m)throw c;l=void 0,d.pop()},onArrayBegin:(m,p)=>{if(s<=m)throw c;l=void 0,d.push(0)},onArrayEnd:(m,p)=>{if(s<=m)throw c;l=void 0,d.pop()},onLiteralValue:(m,p,v)=>{if(s<p||(C(m,p,v,a(m)),s<=p+v))throw c},onSeparator:(m,p,v)=>{if(s<=p)throw c;if(m===":"&&l&&l.type==="property")l.colonOffset=p,k=!1,l=void 0;else if(m===","){const E=d[d.length-1];typeof E=="number"?d[d.length-1]=E+1:(k=!0,d[d.length-1]=""),l=void 0}}})}catch(m){if(m!==c)throw m}return{path:d,previousNode:l,isAtPropertyKey:k,matches:m=>{let p=0;for(let v=0;p<m.length&&v<d.length;v++)if(m[p]===d[v]||m[p]==="*")p++;else if(m[p]!=="**")return!1;return p===m.length}}}e.$2m=P;function $(t,s=[],d=R.DEFAULT){let c=null,l=[];const h=[];function k(m){Array.isArray(l)?l.push(m):c!==null&&(l[c]=m)}return n(t,{onObjectBegin:()=>{const m={};k(m),h.push(l),l=m,c=null},onObjectProperty:m=>{c=m},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const m=[];k(m),h.push(l),l=m,c=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:k,onError:(m,p,v)=>{s.push({error:m,offset:p,length:v})}},d),l[0]}e.$3m=$;function S(t,s=[],d=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(m){c.type==="property"&&(c.length=m-c.offset,c=c.parent)}function h(m){return c.children.push(m),m}n(t,{onObjectBegin:m=>{c=h({type:"object",offset:m,length:-1,parent:c,children:[]})},onObjectProperty:(m,p,v)=>{c=h({type:"property",offset:p,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:m,offset:p,length:v,parent:c})},onObjectEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,l(m+p)},onArrayBegin:(m,p)=>{c=h({type:"array",offset:m,length:-1,parent:c,children:[]})},onArrayEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,l(m+p)},onLiteralValue:(m,p,v)=>{h({type:a(m),offset:p,length:v,parent:c,value:m}),l(p+v)},onSeparator:(m,p,v)=>{c.type==="property"&&(m===":"?c.colonOffset=p:m===","&&l(p))},onError:(m,p,v)=>{s.push({error:m,offset:p,length:v})}},d);const C=c.children[0];return C&&delete C.parent,C}e.$4m=S;function D(t,s){if(!t)return;let d=t;for(const c of s)if(typeof c=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===c){d=h.children[1],l=!0;break}if(!l)return}else{const l=c;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}e.$5m=D;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}e.$6m=w;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const s=Object.create(null);for(const d of t.children){const c=d.children[1];c&&(s[d.children[0].value]=u(c))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$7m=u;function o(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}e.$8m=o;function i(t,s,d=!1){if(o(t,s,d)){const c=t.children;if(Array.isArray(c))for(let l=0;l<c.length&&c[l].offset<=s;l++){const h=i(c[l],s,d);if(h)return h}return t}}e.$9m=i;function n(t,s,d=R.DEFAULT){const c=L(t,!1);function l(x){return x?()=>x(c.getTokenOffset(),c.getTokenLength()):()=>!0}function h(x){return x?Ee=>x(Ee,c.getTokenOffset(),c.getTokenLength()):()=>!0}const k=l(s.onObjectBegin),C=h(s.onObjectProperty),m=l(s.onObjectEnd),p=l(s.onArrayBegin),v=l(s.onArrayEnd),E=h(s.onLiteralValue),N=h(s.onSeparator),z=l(s.onComment),M=h(s.onError),T=d&&d.disallowComments,j=d&&d.allowTrailingComma;function O(){for(;;){const x=c.scan();switch(c.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:T||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(x){case 12:case 13:T?V(10):z();break;case 16:V(1);break;case 15:case 14:break;default:return x}}}function V(x,Ee=[],le=[]){if(M(x),Ee.length+le.length>0){let q=c.getToken();for(;q!==17;){if(Ee.indexOf(q)!==-1){O();break}else if(le.indexOf(q)!==-1)break;q=O()}}}function te(x){const Ee=c.getTokenValue();return x?E(Ee):C(Ee),O(),!0}function fe(){switch(c.getToken()){case 11:{let x=0;try{x=JSON.parse(c.getTokenValue()),typeof x!="number"&&(V(2),x=0)}catch{V(2)}E(x);break}case 7:E(null);break;case 8:E(!0);break;case 9:E(!1);break;default:return!1}return O(),!0}function Z(){return c.getToken()!==10?(V(3,[],[2,5]),!1):(te(!1),c.getToken()===6?(N(":"),O(),oe()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Q(){k(),O();let x=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(x||V(4,[],[]),N(","),O(),c.getToken()===2&&j)break}else x&&V(6,[],[]);Z()||V(4,[],[2,5]),x=!0}return m(),c.getToken()!==2?V(7,[2],[]):O(),!0}function G(){p(),O();let x=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(x||V(4,[],[]),N(","),O(),c.getToken()===4&&j)break}else x&&V(6,[],[]);oe()||V(4,[],[4,5]),x=!0}return v(),c.getToken()!==4?V(8,[4],[]):O(),!0}function oe(){switch(c.getToken()){case 3:return G();case 1:return Q();case 10:return te(!0);default:return fe()}}return O(),c.getToken()===17?d.allowEmptyContent?!0:(V(4,[],[]),!1):oe()?(c.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$0m=n;function r(t,s){const d=L(t),c=[];let l,h=0,k;do switch(k=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:h!==k&&c.push(t.substring(h,k)),s!==void 0&&c.push(d.getTokenValue().replace(/[^\r\n]/g,s)),h=d.getPosition();break}while(l!==17);return c.join("")}e.$$m=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(R){this.element=R,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let R=this.a;for(;R!==I.Undefined;){const L=R.next;R.prev=I.Undefined,R.next=I.Undefined,R=L}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const b=new I(R);if(this.a===I.Undefined)this.a=b,this.b=b;else if(L){const g=this.b;this.b=b,b.prev=g,g.next=b}else{const g=this.a;this.a=b,b.next=g,g.prev=b}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(b))}}shift(){if(this.a!==I.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==I.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==I.Undefined&&R.next!==I.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===I.Undefined&&R.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):R.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):R.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==I.Undefined;)yield R.element,R=R.next}}e.$2c=F}),define(ke[28],Se([1,0]),function(me,e){"use strict";var I,F,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function R(i,n,r){let a=i.get(n);return a===void 0&&(a=r,i.set(n,a)),a}e.$wc=R;function L(i){const n=[];return i.forEach((r,a)=>{n.push(`${a} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=L;function b(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=b;class y{constructor(n,r){this.uri=n,this.value=r}}function g(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,r){if(this[I]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=r??A.a;else if(g(n)){this.b=new Map,this.c=r??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,r){return this.b.set(this.c(n),new y(n,r)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class P{constructor(n,r){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(r),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,r){this.a.forEach((a,t)=>n.call(r,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class S{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,r=0){const a=this.a.get(n);if(a)return r!==0&&this.j(a,r),a.value}set(n,r,a=0){let t=this.a.get(n);if(t)t.value=r,a!==0&&this.j(t,a);else{switch(t={key:n,value:r,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.a.get(n);if(r)return this.a.delete(n),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,r){const a=this.e;let t=this.b;for(;t;){if(r?n.bind(r)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.key,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}values(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.value,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}entries(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:[a.key,a.value],done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>n;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const r=n.next,a=n.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}n.next=void 0,n.previous=void 0,this.e++}j(n,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(r===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((r,a)=>{n.push([a,r])}),n}fromJSON(n){this.clear();for(const[r,a]of n)this.set(r,a)}}e.$Bc=S;class D extends S{constructor(n,r=1){super(),this.k=n,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=D;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let r=this.a.get(n)||0;return r===0?!1:(r--,r===0?this.a.delete(n):this.a.set(n,r),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class u{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[r,a]of n)this.set(r,a)}clear(){this.a.clear(),this.b.clear()}set(n,r){this.a.set(n,r),this.b.set(r,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const r=this.a.get(n);return r===void 0?!1:(this.a.delete(n),this.b.delete(r),!0)}forEach(n,r){this.a.forEach((a,t)=>{n.call(r,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=u;class o{constructor(){this.a=new Map}add(n,r){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(r)}delete(n,r){const a=this.a.get(n);a&&(a.delete(r),a.size===0&&this.a.delete(n))}forEach(n,r){const a=this.a.get(n);a&&a.forEach(r)}get(n){const r=this.a.get(n);return r||new Set}}e.$Fc=o}),define(ke[3],Se([1,0,19,73,28,74,51]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let y=null;class g{constructor(){this.b=new Map}static{this.a=0}c(E){let N=this.b.get(E);return N||(N={parent:null,source:null,isSingleton:!1,value:E,idx:g.a++},this.b.set(E,N)),N}trackDisposable(E){const N=this.c(E);N.source||(N.source=new Error().stack)}setParent(E,N){const z=this.c(E);z.parent=N}markAsDisposed(E){this.b.delete(E)}markAsSingleton(E){this.c(E).isSingleton=!0}f(E,N){const z=N.get(E);if(z)return z;const M=E.parent?this.f(this.c(E.parent),N):E;return N.set(E,M),M}getTrackedDisposables(){const E=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,E).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(E=10,N){let z;if(N)z=N;else{const V=new Map,te=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,V).isSingleton);if(te.length===0)return;const fe=new Set(te.map(Z=>Z.value));if(z=te.filter(Z=>!(Z.parent&&fe.has(Z.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function M(V){function te(Z,Q){for(;Z.length>0&&Q.some(G=>typeof G=="string"?G===Z[0]:Z[0].match(G));)Z.shift()}const fe=V.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return te(fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),fe.reverse()}const T=new f.$Fc;for(const V of z){const te=M(V);for(let fe=0;fe<=te.length;fe++)T.add(te.slice(0,fe).join(`
`),V)}z.sort((0,I.$6b)(V=>V.idx,I.$8b));let j="",O=0;for(const V of z.slice(0,E)){O++;const te=M(V),fe=[];for(let Z=0;Z<te.length;Z++){let Q=te[Z];Q=`(shared with ${T.get(te.slice(0,Z+1).join(`
`)).size}/${z.length} leaks) at ${Q}`;const oe=T.get(te.slice(0,Z).join(`
`)),x=(0,F.$J)([...oe].map(Ee=>M(Ee)[Z]),Ee=>Ee);delete x[te[Z]];for(const[Ee,le]of Object.entries(x))fe.unshift(`    - stacktraces of ${le.length} other leaks continue with ${Ee}`);fe.unshift(Q)}j+=`


==================== Leaking disposable ${O}/${z.length}: ${V.value.constructor.name} ====================
${fe.join(`
`)}
============================================================

`}return z.length>E&&(j+=`


... and ${z.length-E} more leaking disposables

`),{leaks:z,details:j}}}e.$Gc=g;function A(v){y=v}if(e.$Hc=A,b){const v="__is_disposable_tracked__";A(new class{trackDisposable(E){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{E[v]||console.log(N)},3e3)}setParent(E,N){if(E&&E!==t.None)try{E[v]=!0}catch{}}markAsDisposed(E){if(E&&E!==t.None)try{E[v]=!0}catch{}}markAsSingleton(E){}})}function P(v){return y?.trackDisposable(v),v}e.$Ic=P;function $(v){y?.markAsDisposed(v)}e.$Jc=$;function S(v,E){y?.setParent(v,E)}function D(v,E){if(y)for(const N of v)y.setParent(N,E)}function w(v){return y?.markAsSingleton(v),v}e.$Kc=w;function u(v){return typeof v.dispose=="function"&&v.dispose.length===0}e.$Lc=u;function o(v){if(L.Iterable.is(v)){const E=[];for(const N of v)if(N)try{N.dispose()}catch(z){E.push(z)}if(E.length===1)throw E[0];if(E.length>1)throw new AggregateError(E,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}e.$Mc=o;function i(v){for(const E of v)u(E)&&E.dispose();return[]}e.$Nc=i;function n(...v){const E=r(()=>o(v));return D(v,E),E}e.$Oc=n;function r(v){const E=P({dispose:(0,R.$cb)(()=>{$(E),v()})});return E}e.$Pc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(E){if(!E)return E;if(E===this)throw new Error("Cannot register a disposable on itself!");return S(E,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(E),E}delete(E){if(E){if(E===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(E),E.dispose()}}deleteAndLeak(E){E&&this.f.has(E)&&(this.f.delete(E),S(E,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),S(this.q,this)}dispose(){$(this),this.q.dispose()}B(E){if(E===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(E)}}e.$Rc=t;class s{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(E){this.b||E===this.a||(this.a?.dispose(),E&&S(E,this),this.a=E)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const E=this.a;return this.a=void 0,E&&S(E,null),E}}e.$Sc=s;class d{constructor(E){this.a=new s,this.b=!1,this.a.value=E}get value(){return this.a.value}set value(E){this.b||E===this.a.value||(this.a.value=E)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=d;class c{constructor(E){this.b=E,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(E){let N=E;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,$(this))},this}}e.$Vc=l;class h{constructor(){this.a=new Map}acquire(E,...N){let z=this.a.get(E);z||(z={counter:0,object:this.b(E,...N)},this.a.set(E,z));const{object:M}=z,T=(0,R.$cb)(()=>{--z.counter===0&&(this.c(E,z.object),this.a.delete(E))});return z.counter++,{object:M,dispose:T}}}e.$Wc=h;class k{constructor(E){this.a=E}async acquire(E,...N){const z=this.a.acquire(E,...N);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(M){throw z.dispose(),M}}}e.$Xc=k;class C{constructor(E){this.object=E}dispose(){}}e.$Yc=C;function m(v){const E=new a;try{v(E)}finally{E.dispose()}}e.$Zc=m;class p{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(E){return this.a.has(E)}get size(){return this.a.size}get(E){return this.a.get(E)}set(E,N,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(E)?.dispose(),this.a.set(E,N)}deleteAndDispose(E){this.a.get(E)?.dispose(),this.a.delete(E)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(X,Y){for(var $e=0;$e<Y.length;$e++){var ne=Y[$e];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(X,ne.key,ne)}}function I(X,Y,$e){return Y&&e(X.prototype,Y),$e&&e(X,$e),Object.defineProperty(X,"prototype",{writable:!1}),X}function F(X,Y){if(X){if(typeof X=="string")return f(X,Y);var $e=Object.prototype.toString.call(X).slice(8,-1);if($e==="Object"&&X.constructor&&($e=X.constructor.name),$e==="Map"||$e==="Set")return Array.from(X);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return f(X,Y)}}function f(X,Y){(Y==null||Y>X.length)&&(Y=X.length);for(var $e=0,ne=new Array(Y);$e<Y;$e++)ne[$e]=X[$e];return ne}function R(X,Y){var $e=typeof Symbol<"u"&&X[Symbol.iterator]||X["@@iterator"];if($e)return($e=$e.call(X)).next.bind($e);if(Array.isArray(X)||($e=F(X))||Y&&X&&typeof X.length=="number"){$e&&(X=$e);var ne=0;return function(){return ne>=X.length?{done:!0}:{done:!1,value:X[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function b(X){me.defaults=X}var y=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(Y){return $[Y]};function D(X,Y){if(Y){if(y.test(X))return X.replace(g,S)}else if(A.test(X))return X.replace(P,S);return X}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(X){return X.replace(w,function(Y,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(X,Y){X=typeof X=="string"?X:X.source,Y=Y||"";var $e={replace:function(de,ee){return ee=ee.source||ee,ee=ee.replace(o,"$1"),X=X.replace(de,ee),$e},getRegex:function(){return new RegExp(X,Y)}};return $e}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(X,Y,$e){if(X){var ne;try{ne=decodeURIComponent(u($e)).replace(n,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}Y&&!r.test($e)&&($e=l(Y,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(X,Y){t[" "+X]||(s.test(X)?t[" "+X]=X+"/":t[" "+X]=m(X,"/",!0)),X=t[" "+X];var $e=X.indexOf(":")===-1;return Y.substring(0,2)==="//"?$e?Y:X.replace(d,"$1")+Y:Y.charAt(0)==="/"?$e?Y:X.replace(c,"$1")+Y:X+Y}var h={exec:function(){}};function k(X){for(var Y=1,$e,ne;Y<arguments.length;Y++){$e=arguments[Y];for(ne in $e)Object.prototype.hasOwnProperty.call($e,ne)&&(X[ne]=$e[ne])}return X}function C(X,Y){var $e=X.replace(/\|/g,function(ee,he,pe){for(var Pe=!1,B=he;--B>=0&&pe[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ne=$e.split(/ \|/),de=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>Y)ne.splice(Y);else for(;ne.length<Y;)ne.push("");for(;de<ne.length;de++)ne[de]=ne[de].trim().replace(/\\\|/g,"|");return ne}function m(X,Y,$e){var ne=X.length;if(ne===0)return"";for(var de=0;de<ne;){var ee=X.charAt(ne-de-1);if(ee===Y&&!$e)de++;else if(ee!==Y&&$e)de++;else break}return X.slice(0,ne-de)}function p(X,Y){if(X.indexOf(Y[1])===-1)return-1;for(var $e=X.length,ne=0,de=0;de<$e;de++)if(X[de]==="\\")de++;else if(X[de]===Y[0])ne++;else if(X[de]===Y[1]&&(ne--,ne<0))return de;return-1}function v(X){X&&X.sanitize&&!X.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function E(X,Y){if(Y<1)return"";for(var $e="";Y>1;)Y&1&&($e+=X),Y>>=1,X+=X;return $e+X}function N(X,Y,$e,ne){var de=Y.href,ee=Y.title?D(Y.title):null,he=X[1].replace(/\\([\[\]])/g,"$1");if(X[0].charAt(0)!=="!"){ne.state.inLink=!0;var pe={type:"link",raw:$e,href:de,title:ee,text:he,tokens:ne.inlineTokens(he)};return ne.state.inLink=!1,pe}return{type:"image",raw:$e,href:de,title:ee,text:D(he)}}function z(X,Y){var $e=X.match(/^(\s+)(?:```)/);if($e===null)return Y;var ne=$e[1];return Y.split(`
`).map(function(de){var ee=de.match(/^\s+/);if(ee===null)return de;var he=ee[0];return he.length>=ne.length?de.slice(ne.length):de}).join(`
`)}var M=function(){function X($e){this.options=$e||me.defaults}var Y=X.prototype;return Y.space=function(ne){var de=this.rules.block.newline.exec(ne);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},Y.code=function(ne){var de=this.rules.block.code.exec(ne);if(de){var ee=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:m(ee,`
`)}}},Y.fences=function(ne){var de=this.rules.block.fences.exec(ne);if(de){var ee=de[0],he=z(ee,de[3]||"");return{type:"code",raw:ee,lang:de[2]?de[2].trim():de[2],text:he}}},Y.heading=function(ne){var de=this.rules.block.heading.exec(ne);if(de){var ee=de[2].trim();if(/#$/.test(ee)){var he=m(ee,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ee=he.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ee,tokens:this.lexer.inline(ee)}}},Y.hr=function(ne){var de=this.rules.block.hr.exec(ne);if(de)return{type:"hr",raw:de[0]}},Y.blockquote=function(ne){var de=this.rules.block.blockquote.exec(ne);if(de){var ee=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},Y.list=function(ne){var de=this.rules.block.list.exec(ne);if(de){var ee,he,pe,Pe,B,J,re,ae,_,ge,ye,je,We=de[1].trim(),et=We.length>1,Ze={type:"list",raw:"",ordered:et,start:et?+We.slice(0,-1):"",loose:!1,items:[]};We=et?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=et?We:"[*+-]");for(var rt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(je=!1,!(!(de=rt.exec(ne))||this.rules.block.hr.test(ne)));){if(ee=de[0],ne=ne.substring(ee.length),ae=de[2].split(`
`,1)[0],_=ne.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=ae.trimLeft()):(Pe=de[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=ae.slice(Pe),Pe+=de[1].length),J=!1,!ae&&/^ *$/.test(_)&&(ee+=_+`
`,ne=ne.substring(_.length+1),je=!0),!je)for(var nt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ne&&(ge=ne.split(`
`,1)[0],ae=ge,this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(ae)||Ve.test(ae)||nt.test(ae)||Ae.test(ne)));){if(ae.search(/[^ ]/)>=Pe||!ae.trim())ye+=`
`+ae.slice(Pe);else if(!J)ye+=`
`+ae;else break;!J&&!ae.trim()&&(J=!0),ee+=ge+`
`,ne=ne.substring(ge.length+1)}Ze.loose||(re?Ze.loose=!0:/\n *\n *$/.test(ee)&&(re=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(ye),he&&(pe=he[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:ee,task:!!he,checked:pe,loose:!1,text:ye}),Ze.raw+=ee}Ze.items[Ze.items.length-1].raw=ee.trimRight(),Ze.items[Ze.items.length-1].text=ye.trimRight(),Ze.raw=Ze.raw.trimRight();var Le=Ze.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ze.items[B].tokens=this.lexer.blockTokens(Ze.items[B].text,[]);var Xe=Ze.items[B].tokens.filter(function(ce){return ce.type==="space"}),ue=Xe.every(function(ce){for(var Ie=ce.raw.split(""),Ke=0,Ge=R(Ie),_e;!(_e=Ge()).done;){var st=_e.value;if(st===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ze.loose&&Xe.length&&ue&&(Ze.loose=!0,Ze.items[B].loose=!0)}return Ze}},Y.html=function(ne){var de=this.rules.block.html.exec(ne);if(de){var ee={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(de[0]):D(de[0]);ee.type="paragraph",ee.text=he,ee.tokens=this.lexer.inline(he)}return ee}},Y.def=function(ne){var de=this.rules.block.def.exec(ne);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ee=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:de[0],href:de[2],title:de[3]}}},Y.table=function(ne){var de=this.rules.block.table.exec(ne);if(de){var ee={type:"table",header:C(de[1]).map(function(re){return{text:re}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=de[0];var he=ee.align.length,pe,Pe,B,J;for(pe=0;pe<he;pe++)/^ *-+: *$/.test(ee.align[pe])?ee.align[pe]="right":/^ *:-+: *$/.test(ee.align[pe])?ee.align[pe]="center":/^ *:-+ *$/.test(ee.align[pe])?ee.align[pe]="left":ee.align[pe]=null;for(he=ee.rows.length,pe=0;pe<he;pe++)ee.rows[pe]=C(ee.rows[pe],ee.header.length).map(function(re){return{text:re}});for(he=ee.header.length,Pe=0;Pe<he;Pe++)ee.header[Pe].tokens=this.lexer.inline(ee.header[Pe].text);for(he=ee.rows.length,Pe=0;Pe<he;Pe++)for(J=ee.rows[Pe],B=0;B<J.length;B++)J[B].tokens=this.lexer.inline(J[B].text);return ee}}},Y.lheading=function(ne){var de=this.rules.block.lheading.exec(ne);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},Y.paragraph=function(ne){var de=this.rules.block.paragraph.exec(ne);if(de){var ee=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ee,tokens:this.lexer.inline(ee)}}},Y.text=function(ne){var de=this.rules.block.text.exec(ne);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},Y.escape=function(ne){var de=this.rules.inline.escape.exec(ne);if(de)return{type:"escape",raw:de[0],text:D(de[1])}},Y.tag=function(ne){var de=this.rules.inline.tag.exec(ne);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):D(de[0]):de[0]}},Y.link=function(ne){var de=this.rules.inline.link.exec(ne);if(de){var ee=de[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var he=m(ee.slice(0,-1),"\\");if((ee.length-he.length)%2===0)return}else{var pe=p(de[2],"()");if(pe>-1){var Pe=de[0].indexOf("!")===0?5:4,B=Pe+de[1].length+pe;de[2]=de[2].substring(0,pe),de[0]=de[0].substring(0,B).trim(),de[3]=""}}var J=de[2],re="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);ae&&(J=ae[1],re=ae[3])}else re=de[3]?de[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),N(de,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Y.reflink=function(ne,de){var ee;if((ee=this.rules.inline.reflink.exec(ne))||(ee=this.rules.inline.nolink.exec(ne))){var he=(ee[2]||ee[1]).replace(/\s+/g," ");if(he=de[he.toLowerCase()],!he||!he.href){var pe=ee[0].charAt(0);return{type:"text",raw:pe,text:pe}}return N(ee,he,ee[0],this.lexer)}},Y.emStrong=function(ne,de,ee){ee===void 0&&(ee="");var he=this.rules.inline.emStrong.lDelim.exec(ne);if(he&&!(he[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=he[1]||he[2]||"";if(!pe||pe&&(ee===""||this.rules.inline.punctuation.exec(ee))){var Pe=he[0].length-1,B,J,re=Pe,ae=0,_=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_.lastIndex=0,de=de.slice(-1*ne.length+Pe);(he=_.exec(de))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(J=B.length,he[3]||he[4]){re+=J;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+J)%3)){ae+=J;continue}if(re-=J,!(re>0)){if(J=Math.min(J,J+re+ae),Math.min(Pe,J)%2){var ge=ne.slice(1,Pe+he.index+J);return{type:"em",raw:ne.slice(0,Pe+he.index+J+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=ne.slice(2,Pe+he.index+J-1);return{type:"strong",raw:ne.slice(0,Pe+he.index+J+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},Y.codespan=function(ne){var de=this.rules.inline.code.exec(ne);if(de){var ee=de[2].replace(/\n/g," "),he=/[^ ]/.test(ee),pe=/^ /.test(ee)&&/ $/.test(ee);return he&&pe&&(ee=ee.substring(1,ee.length-1)),ee=D(ee,!0),{type:"codespan",raw:de[0],text:ee}}},Y.br=function(ne){var de=this.rules.inline.br.exec(ne);if(de)return{type:"br",raw:de[0]}},Y.del=function(ne){var de=this.rules.inline.del.exec(ne);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},Y.autolink=function(ne,de){var ee=this.rules.inline.autolink.exec(ne);if(ee){var he,pe;return ee[2]==="@"?(he=D(this.options.mangle?de(ee[1]):ee[1]),pe="mailto:"+he):(he=D(ee[1]),pe=he),{type:"link",raw:ee[0],text:he,href:pe,tokens:[{type:"text",raw:he,text:he}]}}},Y.url=function(ne,de){var ee;if(ee=this.rules.inline.url.exec(ne)){var he,pe;if(ee[2]==="@")he=D(this.options.mangle?de(ee[0]):ee[0]),pe="mailto:"+he;else{var Pe;do Pe=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(Pe!==ee[0]);he=D(ee[0]),ee[1]==="www."?pe="http://"+he:pe=he}return{type:"link",raw:ee[0],text:he,href:pe,tokens:[{type:"text",raw:he,text:he}]}}},Y.inlineText=function(ne,de){var ee=this.rules.inline.text.exec(ne);if(ee){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):D(ee[0]):ee[0]:he=D(this.options.smartypants?de(ee[0]):ee[0]),{type:"text",raw:ee[0],text:he}}},X}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=k({},T),T.gfm=k({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=k({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=i(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=i(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=i(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=i(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=i(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=i(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=i(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=i(j.reflink).replace("label",j._label).replace("ref",T._label).getRegex(),j.nolink=i(j.nolink).replace("ref",T._label).getRegex(),j.reflinkSearch=i(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=k({},j),j.pedantic=k({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=k({},j.normal,{escape:i(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=i(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=k({},j.gfm,{br:i(j.br).replace("{2,}","*").getRegex(),text:i(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(X){return X.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(X){var Y="",$e,ne,de=X.length;for($e=0;$e<de;$e++)ne=X.charCodeAt($e),Math.random()>.5&&(ne="x"+ne.toString(16)),Y+="&#"+ne+";";return Y}var te=function(){function X($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:T.normal,inline:j.normal};this.options.pedantic?(ne.block=T.pedantic,ne.inline=j.pedantic):this.options.gfm&&(ne.block=T.gfm,this.options.breaks?ne.inline=j.breaks:ne.inline=j.gfm),this.tokenizer.rules=ne}X.lex=function(ne,de){var ee=new X(de);return ee.lex(ne)},X.lexInline=function(ne,de){var ee=new X(de);return ee.inlineTokens(ne)};var Y=X.prototype;return Y.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Y.blockTokens=function(ne,de){var ee=this;de===void 0&&(de=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(re,ae,_){return ae+"    ".repeat(_.length)});for(var he,pe,Pe,B;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(he=re.call({lexer:ee},ne,de))?(ne=ne.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.space(ne)){ne=ne.substring(he.raw.length),he.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(he);continue}if(he=this.tokenizer.code(ne)){ne=ne.substring(he.raw.length),pe=de[de.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(he);continue}if(he=this.tokenizer.fences(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.heading(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.hr(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.blockquote(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.list(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.html(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.def(ne)){ne=ne.substring(he.raw.length),pe=de[de.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.lheading(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,ae=ne.slice(1),_=void 0;ee.options.extensions.startBlock.forEach(function(ge){_=ge.call({lexer:this},ae),typeof _=="number"&&_>=0&&(re=Math.min(re,_))}),re<1/0&&re>=0&&(Pe=ne.substring(0,re+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){pe=de[de.length-1],B&&pe.type==="paragraph"?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(he),B=Pe.length!==ne.length,ne=ne.substring(he.raw.length);continue}if(he=this.tokenizer.text(ne)){ne=ne.substring(he.raw.length),pe=de[de.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):de.push(he);continue}if(ne){var J="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,de},Y.inline=function(ne,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ne,tokens:de}),de},Y.inlineTokens=function(ne,de){var ee=this;de===void 0&&(de=[]);var he,pe,Pe,B=ne,J,re,ae;if(this.tokens.links){var _=Object.keys(this.tokens.links);if(_.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)_.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,J.index)+"["+E("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,J.index)+"["+E("a",J[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,J.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(re||(ae=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(he=ye.call({lexer:ee},ne,de))?(ne=ne.substring(he.raw.length),de.push(he),!0):!1}))){if(he=this.tokenizer.escape(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.tag(ne)){ne=ne.substring(he.raw.length),pe=de[de.length-1],pe&&he.type==="text"&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):de.push(he);continue}if(he=this.tokenizer.link(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(he.raw.length),pe=de[de.length-1],pe&&he.type==="text"&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):de.push(he);continue}if(he=this.tokenizer.emStrong(ne,B,ae)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.codespan(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.br(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.del(ne)){ne=ne.substring(he.raw.length),de.push(he);continue}if(he=this.tokenizer.autolink(ne,V)){ne=ne.substring(he.raw.length),de.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ne,V))){ne=ne.substring(he.raw.length),de.push(he);continue}if(Pe=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=ne.slice(1),We=void 0;ee.options.extensions.startInline.forEach(function(et){We=et.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ne.substring(0,ye+1))}(),he=this.tokenizer.inlineText(Pe,O)){ne=ne.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(ae=he.raw.slice(-1)),re=!0,pe=de[de.length-1],pe&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):de.push(he);continue}if(ne){var ge="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return de},I(X,null,[{key:"rules",get:function(){return{block:T,inline:j}}}]),X}(),fe=function(){function X($e){this.options=$e||me.defaults}var Y=X.prototype;return Y.code=function(ne,de,ee){var he=(de||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(ne,he);pe!=null&&pe!==ne&&(ee=!0,ne=pe)}return ne=ne.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+D(he,!0)+'">'+(ee?ne:D(ne,!0))+`</code></pre>
`:"<pre><code>"+(ee?ne:D(ne,!0))+`</code></pre>
`},Y.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},Y.html=function(ne){return ne},Y.heading=function(ne,de,ee,he){if(this.options.headerIds){var pe=this.options.headerPrefix+he.slug(ee);return"<h"+de+' id="'+pe+'">'+ne+"</h"+de+`>
`}return"<h"+de+">"+ne+"</h"+de+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(ne,de,ee){var he=de?"ol":"ul",pe=de&&ee!==1?' start="'+ee+'"':"";return"<"+he+pe+`>
`+ne+"</"+he+`>
`},Y.listitem=function(ne){return"<li>"+ne+`</li>
`},Y.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(ne){return"<p>"+ne+`</p>
`},Y.table=function(ne,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+de+`</table>
`},Y.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},Y.tablecell=function(ne,de){var ee=de.header?"th":"td",he=de.align?"<"+ee+' align="'+de.align+'">':"<"+ee+">";return he+ne+("</"+ee+`>
`)},Y.strong=function(ne){return"<strong>"+ne+"</strong>"},Y.em=function(ne){return"<em>"+ne+"</em>"},Y.codespan=function(ne){return"<code>"+ne+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(ne){return"<del>"+ne+"</del>"},Y.link=function(ne,de,ee){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return ee;var he='<a href="'+D(ne)+'"';return de&&(he+=' title="'+de+'"'),he+=">"+ee+"</a>",he},Y.image=function(ne,de,ee){if(ne=a(this.options.sanitize,this.options.baseUrl,ne),ne===null)return ee;var he='<img src="'+ne+'" alt="'+ee+'"';return de&&(he+=' title="'+de+'"'),he+=this.options.xhtml?"/>":">",he},Y.text=function(ne){return ne},X}(),Z=function(){function X(){}var Y=X.prototype;return Y.strong=function(ne){return ne},Y.em=function(ne){return ne},Y.codespan=function(ne){return ne},Y.del=function(ne){return ne},Y.html=function(ne){return ne},Y.text=function(ne){return ne},Y.link=function(ne,de,ee){return""+ee},Y.image=function(ne,de,ee){return""+ee},Y.br=function(){return""},X}(),Q=function(){function X(){this.seen={}}var Y=X.prototype;return Y.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(ne,de){var ee=ne,he=0;if(this.seen.hasOwnProperty(ee)){he=this.seen[ne];do he++,ee=ne+"-"+he;while(this.seen.hasOwnProperty(ee))}return de||(this.seen[ne]=he,this.seen[ee]=0),ee},Y.slug=function(ne,de){de===void 0&&(de={});var ee=this.serialize(ne);return this.getNextSafeSlug(ee,de.dryrun)},X}(),G=function(){function X($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new Q}X.parse=function(ne,de){var ee=new X(de);return ee.parse(ne)},X.parseInline=function(ne,de){var ee=new X(de);return ee.parseInline(ne)};var Y=X.prototype;return Y.parse=function(ne,de){de===void 0&&(de=!0);var ee="",he,pe,Pe,B,J,re,ae,_,ge,ye,je,We,et,Ze,rt,nt,Ae,Ne,Ve,Le=ne.length;for(he=0;he<Le;he++){if(ye=ne[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ee+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(_="",ae="",B=ye.header.length,pe=0;pe<B;pe++)ae+=this.renderer.tablecell(this.parseInline(ye.header[pe].tokens),{header:!0,align:ye.align[pe]});for(_+=this.renderer.tablerow(ae),ge="",B=ye.rows.length,pe=0;pe<B;pe++){for(re=ye.rows[pe],ae="",J=re.length,Pe=0;Pe<J;Pe++)ae+=this.renderer.tablecell(this.parseInline(re[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(ae)}ee+=this.renderer.table(_,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),ee+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,et=ye.loose,B=ye.items.length,ge="",pe=0;pe<B;pe++)rt=ye.items[pe],nt=rt.checked,Ae=rt.task,Ze="",rt.task&&(Ne=this.renderer.checkbox(nt),et?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Ne+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Ne+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Ne}):Ze+=Ne),Ze+=this.parse(rt.tokens,et),ge+=this.renderer.listitem(Ze,Ae,nt);ee+=this.renderer.list(ge,je,We);continue}case"html":{ee+=this.renderer.html(ye.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;he+1<Le&&ne[he+1].type==="text";)ye=ne[++he],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ee+=de?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return ee},Y.parseInline=function(ne,de){de=de||this.renderer;var ee="",he,pe,Pe,B=ne.length;for(he=0;he<B;he++){if(pe=ne[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){ee+=Pe||"";continue}switch(pe.type){case"escape":{ee+=de.text(pe.text);break}case"html":{ee+=de.html(pe.text);break}case"link":{ee+=de.link(pe.href,pe.title,this.parseInline(pe.tokens,de));break}case"image":{ee+=de.image(pe.href,pe.title,pe.text);break}case"strong":{ee+=de.strong(this.parseInline(pe.tokens,de));break}case"em":{ee+=de.em(this.parseInline(pe.tokens,de));break}case"codespan":{ee+=de.codespan(pe.text);break}case"br":{ee+=de.br();break}case"del":{ee+=de.del(this.parseInline(pe.tokens,de));break}case"text":{ee+=de.text(pe.text);break}default:{var J='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},X}();function oe(X,Y,$e){if(typeof X>"u"||X===null)throw new Error("marked(): input parameter is undefined or null");if(typeof X!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(X)+", string expected");if(typeof Y=="function"&&($e=Y,Y=null),Y=k({},oe.defaults,Y||{}),v(Y),$e){var ne=Y.highlight,de;try{de=te.lex(X,Y)}catch(B){return $e(B)}var ee=function(J){var re;if(!J)try{Y.walkTokens&&oe.walkTokens(de,Y.walkTokens),re=G.parse(de,Y)}catch(ae){J=ae}return Y.highlight=ne,J?$e(J):$e(null,re)};if(!ne||ne.length<3||(delete Y.highlight,!de.length))return ee();var he=0;oe.walkTokens(de,function(B){B.type==="code"&&(he++,setTimeout(function(){ne(B.text,B.lang,function(J,re){if(J)return ee(J);re!=null&&re!==B.text&&(B.text=re,B.escaped=!0),he--,he===0&&ee()})},0))}),he===0&&ee();return}function pe(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+D(B.message+"",!0)+"</pre>";throw B}try{var Pe=te.lex(X,Y);if(Y.walkTokens){if(Y.async)return Promise.all(oe.walkTokens(Pe,Y.walkTokens)).then(function(){return G.parse(Pe,Y)}).catch(pe);oe.walkTokens(Pe,Y.walkTokens)}return G.parse(Pe,Y)}catch(B){pe(B)}}oe.options=oe.setOptions=function(X){return k(oe.defaults,X),b(oe.defaults),oe},oe.getDefaults=L,oe.defaults=me.defaults,oe.use=function(){for(var X=arguments.length,Y=new Array(X),$e=0;$e<X;$e++)Y[$e]=arguments[$e];var ne=k.apply(void 0,[{}].concat(Y)),de=oe.defaults.extensions||{renderers:{},childTokens:{}},ee;Y.forEach(function(he){if(he.extensions&&(ee=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=de.renderers?de.renderers[Pe.name]:null;B?de.renderers[Pe.name]=function(){for(var J=arguments.length,re=new Array(J),ae=0;ae<J;ae++)re[ae]=arguments[ae];var _=Pe.renderer.apply(this,re);return _===!1&&(_=B.apply(this,re)),_}:de.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Pe.level]?de[Pe.level].unshift(Pe.tokenizer):de[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?de.startBlock?de.startBlock.push(Pe.start):de.startBlock=[Pe.start]:Pe.level==="inline"&&(de.startInline?de.startInline.push(Pe.start):de.startInline=[Pe.start]))}Pe.childTokens&&(de.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=oe.defaults.renderer||new fe,B=function(ae){var _=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.renderer[ae].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var J in he.renderer)B(J);ne.renderer=Pe}(),he.tokenizer&&function(){var Pe=oe.defaults.tokenizer||new M,B=function(ae){var _=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.tokenizer[ae].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var J in he.tokenizer)B(J);ne.tokenizer=Pe}(),he.walkTokens){var pe=oe.defaults.walkTokens;ne.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),pe&&(B=B.concat(pe.call(this,Pe))),B}}ee&&(ne.extensions=de),oe.setOptions(ne)})},oe.walkTokens=function(X,Y){for(var $e=[],ne=function(){var pe=ee.value;switch($e=$e.concat(Y.call(oe,pe)),pe.type){case"table":{for(var Pe=R(pe.header),B;!(B=Pe()).done;){var J=B.value;$e=$e.concat(oe.walkTokens(J.tokens,Y))}for(var re=R(pe.rows),ae;!(ae=re()).done;)for(var _=ae.value,ge=R(_),ye;!(ye=ge()).done;){var je=ye.value;$e=$e.concat(oe.walkTokens(je.tokens,Y))}break}case"list":{$e=$e.concat(oe.walkTokens(pe.items,Y));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[pe.type]?oe.defaults.extensions.childTokens[pe.type].forEach(function(We){$e=$e.concat(oe.walkTokens(pe[We],Y))}):pe.tokens&&($e=$e.concat(oe.walkTokens(pe.tokens,Y)))}},de=R(X),ee;!(ee=de()).done;)ne();return $e},oe.parseInline=function(X,Y){if(typeof X>"u"||X===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof X!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(X)+", string expected");Y=k({},oe.defaults,Y||{}),v(Y);try{var $e=te.lexInline(X,Y);return Y.walkTokens&&oe.walkTokens($e,Y.walkTokens),G.parseInline($e,Y)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+D(ne.message+"",!0)+"</pre>";throw ne}},oe.Parser=G,oe.parser=G.parse,oe.Renderer=fe,oe.TextRenderer=Z,oe.Lexer=te,oe.lexer=te.lex,oe.Tokenizer=M,oe.Slugger=Q,oe.parse=oe;var x=oe.options,Ee=oe.setOptions,le=oe.use,q=oe.walkTokens,U=oe.parseInline,ie=oe,be=G.parse,H=te.lex;me.Lexer=te,me.Parser=G,me.Renderer=fe,me.Slugger=Q,me.TextRenderer=Z,me.Tokenizer=M,me.getDefaults=L,me.lexer=H,me.marked=oe,me.options=x,me.parse=ie,me.parseInline=U,me.parser=be,me.setOptions=Ee,me.use=le,me.walkTokens=q,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[76],Se([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const F=new I.$Cc(1e4);function f(g){return y(g,"NFC",F)}e.$ul=f;const R=new I.$Cc(1e4);function L(g){return y(g,"NFD",R)}e.$vl=L;const b=/[^\u0000-\u0080]/;function y(g,A,P){if(!g)return g;const $=P.get(g);if($)return $;let S;return b.test(g)?S=g.normalize(A):S=g,P.set(g,S),S}e.$wl=function(){const g=/[\u0300-\u036f]/g;return function(A){return L(A).replace(g,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function I(b,y,g){return Math.min(Math.max(b,y),g)}e.$Ul=I;function F(b,y){return(y+b%y)%y}e.rot=F;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=f;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=R;class L{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const g=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=L}),function(){function me(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function L(y){R.push(y,Date.now())}function b(){const y=[];for(let g=0;g<R.length;g+=2)y.push({name:R[g],startTime:R[g+1]});return y}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(f+L.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var f=e[F]={i:F,l:!1,exports:{}};return me[F].call(f.exports,f,f.exports,I),f.l=!0,f.exports}return I.m=me,I.c=e,I.d=function(F,f,R){I.o(F,f)||Object.defineProperty(F,f,{enumerable:!0,get:R})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,f){if(1&f&&(F=I(F)),8&f||4&f&&typeof F=="object"&&F&&F.__esModule)return F;var R=Object.create(null);if(I.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:F}),2&f&&typeof F!="string")for(var L in F)I.d(R,L,function(b){return F[b]}.bind(null,L));return R},I.n=function(F){var f=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(f,"a",f),f},I.o=function(F,f){return Object.prototype.hasOwnProperty.call(F,f)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var f;e=me.exports=le,f=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],y=e.src=[],g=0,A=g++;y[A]="0|[1-9]\\d*";var P=g++;y[P]="[0-9]+";var $=g++;y[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=g++;y[S]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var D=g++;y[D]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var w=g++;y[w]="(?:"+y[A]+"|"+y[$]+")";var u=g++;y[u]="(?:"+y[P]+"|"+y[$]+")";var o=g++;y[o]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var i=g++;y[i]="(?:-?("+y[u]+"(?:\\."+y[u]+")*))";var n=g++;y[n]="[0-9A-Za-z-]+";var r=g++;y[r]="(?:\\+("+y[n]+"(?:\\."+y[n]+")*))";var a=g++,t="v?"+y[S]+y[o]+"?"+y[r]+"?";y[a]="^"+t+"$";var s="[v=\\s]*"+y[D]+y[i]+"?"+y[r]+"?",d=g++;y[d]="^"+s+"$";var c=g++;y[c]="((?:<|>)?=?)";var l=g++;y[l]=y[P]+"|x|X|\\*";var h=g++;y[h]=y[A]+"|x|X|\\*";var k=g++;y[k]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[o]+")?"+y[r]+"?)?)?";var C=g++;y[C]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[i]+")?"+y[r]+"?)?)?";var m=g++;y[m]="^"+y[c]+"\\s*"+y[k]+"$";var p=g++;y[p]="^"+y[c]+"\\s*"+y[C]+"$";var v=g++;y[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var E=g++;y[E]="(?:~>?)";var N=g++;y[N]="(\\s*)"+y[E]+"\\s+",b[N]=new RegExp(y[N],"g");var z=g++;y[z]="^"+y[E]+y[k]+"$";var M=g++;y[M]="^"+y[E]+y[C]+"$";var T=g++;y[T]="(?:\\^)";var j=g++;y[j]="(\\s*)"+y[T]+"\\s+",b[j]=new RegExp(y[j],"g");var O=g++;y[O]="^"+y[T]+y[k]+"$";var V=g++;y[V]="^"+y[T]+y[C]+"$";var te=g++;y[te]="^"+y[c]+"\\s*("+s+")$|^$";var fe=g++;y[fe]="^"+y[c]+"\\s*("+t+")$|^$";var Z=g++;y[Z]="(\\s*)"+y[c]+"\\s*("+s+"|"+y[k]+")",b[Z]=new RegExp(y[Z],"g");var Q=g++;y[Q]="^\\s*("+y[k]+")\\s+-\\s+("+y[k]+")\\s*$";var G=g++;y[G]="^\\s*("+y[C]+")\\s+-\\s+("+y[C]+")\\s*$";var oe=g++;y[oe]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)f(x,y[x]),b[x]||(b[x]=new RegExp(y[x]));function Ee(_,ge){if(_ instanceof le)return _;if(typeof _!="string"||_.length>R||!(ge?b[d]:b[a]).test(_))return null;try{return new le(_,ge)}catch{return null}}function le(_,ge){if(_ instanceof le){if(_.loose===ge)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(_,ge);f("SemVer",_,ge),this.loose=ge;var ye=_.trim().match(ge?b[d]:b[a]);if(!ye)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<L)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(_,ge){var ye=Ee(_,ge);return ye?ye.version:null},e.clean=function(_,ge){var ye=Ee(_.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(_){return f("SemVer.compare",this.version,this.loose,_),_ instanceof le||(_=new le(_,this.loose)),this.compareMain(_)||this.comparePre(_)},le.prototype.compareMain=function(_){return _ instanceof le||(_=new le(_,this.loose)),U(this.major,_.major)||U(this.minor,_.minor)||U(this.patch,_.patch)},le.prototype.comparePre=function(_){if(_ instanceof le||(_=new le(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=_.prerelease[ge];if(f("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},le.prototype.inc=function(_,ge){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new le(_,ye).inc(ge,je).version}catch{return null}},e.diff=function(_,ge){if(X(_,ge))return null;var ye=Ee(_),je=Ee(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var q=/^[0-9]+$/;function U(_,ge){var ye=q.test(_),je=q.test(ge);return ye&&je&&(_=+_,ge=+ge),ye&&!je?-1:je&&!ye?1:_<ge?-1:_>ge?1:0}function ie(_,ge,ye){return new le(_,ye).compare(new le(ge,ye))}function be(_,ge,ye){return ie(_,ge,ye)>0}function H(_,ge,ye){return ie(_,ge,ye)<0}function X(_,ge,ye){return ie(_,ge,ye)===0}function Y(_,ge,ye){return ie(_,ge,ye)!==0}function $e(_,ge,ye){return ie(_,ge,ye)>=0}function ne(_,ge,ye){return ie(_,ge,ye)<=0}function de(_,ge,ye,je){var We;switch(ge){case"===":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_===ye;break;case"!==":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_!==ye;break;case"":case"=":case"==":We=X(_,ye,je);break;case"!=":We=Y(_,ye,je);break;case">":We=be(_,ye,je);break;case">=":We=$e(_,ye,je);break;case"<":We=H(_,ye,je);break;case"<=":We=ne(_,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function ee(_,ge){if(_ instanceof ee){if(_.loose===ge)return _;_=_.value}if(!(this instanceof ee))return new ee(_,ge);f("comparator",_,ge),this.loose=ge,this.parse(_),this.semver===he?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(_,ge){return U(ge,_)},e.major=function(_,ge){return new le(_,ge).major},e.minor=function(_,ge){return new le(_,ge).minor},e.patch=function(_,ge){return new le(_,ge).patch},e.compare=ie,e.compareLoose=function(_,ge){return ie(_,ge,!0)},e.rcompare=function(_,ge,ye){return ie(ge,_,ye)},e.sort=function(_,ge){return _.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(_,ge){return _.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=be,e.lt=H,e.eq=X,e.neq=Y,e.gte=$e,e.lte=ne,e.cmp=de,e.Comparator=ee;var he={};function pe(_,ge){if(_ instanceof pe)return _.loose===ge?_:new pe(_.raw,ge);if(_ instanceof ee)return new pe(_.value,ge);if(!(this instanceof pe))return new pe(_,ge);if(this.loose=ge,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Pe(_){return!_||_.toLowerCase()==="x"||_==="*"}function B(_,ge,ye,je,We,et,Ze,rt,nt,Ae,Ne,Ve,Le){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(rt=Pe(nt)?"":Pe(Ae)?"<"+(+nt+1)+".0.0":Pe(Ne)?"<"+nt+"."+(+Ae+1)+".0":Ve?"<="+nt+"."+Ae+"."+Ne+"-"+Ve:"<="+rt)).trim()}function J(_,ge){for(var ye=0;ye<_.length;ye++)if(!_[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<_.length;ye++)if(f(_[ye].semver),_[ye].semver!==he&&_[ye].semver.prerelease.length>0){var je=_[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function re(_,ge,ye){try{ge=new pe(ge,ye)}catch{return!1}return ge.test(_)}function ae(_,ge,ye,je){var We,et,Ze,rt,nt;switch(_=new le(_,je),ge=new pe(ge,je),ye){case">":We=be,et=ne,Ze=H,rt=">",nt=">=";break;case"<":We=H,et=$e,Ze=be,rt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(_,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Ne=ge.set[Ae],Ve=null,Le=null;if(Ne.forEach(function(Xe){Xe.semver===he&&(Xe=new ee(">=0.0.0")),Ve=Ve||Xe,Le=Le||Xe,We(Xe.semver,Ve.semver,je)?Ve=Xe:Ze(Xe.semver,Le.semver,je)&&(Le=Xe)}),Ve.operator===rt||Ve.operator===nt||(!Le.operator||Le.operator===rt)&&et(_,Le.semver)||Le.operator===nt&&Ze(_,Le.semver))return!1}return!0}ee.prototype.parse=function(_){var ge=this.loose?b[te]:b[fe],ye=_.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+_);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new le(ye[2],this.loose):this.semver=he},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(_){return f("Comparator.test",_,this.loose),this.semver===he||(typeof _=="string"&&(_=new le(_,this.loose)),de(_,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(_,ge){if(!(_ instanceof ee))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new pe(_.value,ge),re(this.value,ye,ge);if(_.operator==="")return ye=new pe(this.value,ge),re(_.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),et=this.semver.version===_.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),rt=de(this.semver,"<",_.semver,ge)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),nt=de(this.semver,">",_.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return je||We||et&&Ze||rt||nt},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(_){var ge=this.loose;_=_.trim(),f("range",_,ge);var ye=ge?b[G]:b[Q];_=_.replace(ye,B),f("hyphen replace",_),_=_.replace(b[Z],"$1$2$3"),f("comparator trim",_,b[Z]),_=(_=(_=_.replace(b[N],"$1~")).replace(b[j],"$1^")).split(/\s+/).join(" ");var je=ge?b[te]:b[fe],We=_.split(" ").map(function(et){return function(Ze,rt){return f("comp",Ze),Ze=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){f("caret",Ve,Le);var Xe=Le?b[V]:b[O];return Ve.replace(Xe,function(ue,ce,Ie,Ke,Ge){var _e;return f("caret",Ve,ue,ce,Ie,Ke,Ge),Pe(ce)?_e="":Pe(Ie)?_e=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?_e=ce==="0"?">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+".0 <"+(+ce+1)+".0.0":Ge?(f("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+Ge+" <"+(+ce+1)+".0.0"):(f("no pr"),_e=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+" <"+(+ce+1)+".0.0"),f("caret return",_e),_e})}(Ne,Ae)}).join(" ")}(Ze,rt),f("caret",Ze),Ze=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){var Xe=Le?b[M]:b[z];return Ve.replace(Xe,function(ue,ce,Ie,Ke,Ge){var _e;return f("tilde",Ve,ue,ce,Ie,Ke,Ge),Pe(ce)?_e="":Pe(Ie)?_e=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?_e=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":Ge?(f("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=">="+ce+"."+Ie+"."+Ke+Ge+" <"+ce+"."+(+Ie+1)+".0"):_e=">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0",f("tilde return",_e),_e})}(Ne,Ae)}).join(" ")}(Ze,rt),f("tildes",Ze),Ze=function(nt,Ae){return f("replaceXRanges",nt,Ae),nt.split(/\s+/).map(function(Ne){return function(Ve,Le){Ve=Ve.trim();var Xe=Le?b[p]:b[m];return Ve.replace(Xe,function(ue,ce,Ie,Ke,Ge,_e){f("xRange",Ve,ue,ce,Ie,Ke,Ge,_e);var st=Pe(Ie),lt=st||Pe(Ke),wt=lt||Pe(Ge);return ce==="="&&wt&&(ce=""),st?ue=ce===">"||ce==="<"?"<0.0.0":"*":ce&&wt?(lt&&(Ke=0),wt&&(Ge=0),ce===">"?(ce=">=",lt?(Ie=+Ie+1,Ke=0,Ge=0):wt&&(Ke=+Ke+1,Ge=0)):ce==="<="&&(ce="<",lt?Ie=+Ie+1:Ke=+Ke+1),ue=ce+Ie+"."+Ke+"."+Ge):lt?ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(ue=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",ue),ue})}(Ne,Ae)}).join(" ")}(Ze,rt),f("xrange",Ze),Ze=function(nt,Ae){return f("replaceStars",nt,Ae),nt.trim().replace(b[oe],"")}(Ze,rt),f("stars",Ze),Ze}(et,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(et){return!!et.match(je)})),We=We.map(function(et){return new ee(et,ge)})},pe.prototype.intersects=function(_,ge){if(!(_ instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return _.set.some(function(We){return We.every(function(et){return je.intersects(et,ge)})})})})},e.toComparators=function(_,ge){return new pe(_,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new le(_,this.loose));for(var ge=0;ge<this.set.length;ge++)if(J(this.set[ge],_))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(_,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return _.forEach(function(Ze){et.test(Ze)&&(je&&We.compare(Ze)!==-1||(We=new le(je=Ze,ye)))}),je},e.minSatisfying=function(_,ge,ye){var je=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return _.forEach(function(Ze){et.test(Ze)&&(je&&We.compare(Ze)!==1||(We=new le(je=Ze,ye)))}),je},e.validRange=function(_,ge){try{return new pe(_,ge).range||"*"}catch{return null}},e.ltr=function(_,ge,ye){return ae(_,ge,"<",ye)},e.gtr=function(_,ge,ye){return ae(_,ge,">",ye)},e.outside=ae,e.prerelease=function(_,ge){var ye=Ee(_,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(_,ge,ye){return _=new pe(_,ye),ge=new pe(ge,ye),_.intersects(ge)},e.coerce=function(_){if(_ instanceof le)return _;if(typeof _!="string")return null;var ge=_.match(b[v]);return ge==null?null:Ee((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,f=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(u){if(I===setTimeout)return setTimeout(u,0);if((I===R||!I)&&setTimeout)return I=setTimeout,setTimeout(u,0);try{return I(u,0)}catch{try{return I.call(null,u,0)}catch{return I.call(this,u,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:R}catch{I=R}try{F=typeof clearTimeout=="function"?clearTimeout:L}catch{F=L}})();var y,g=[],A=!1,P=-1;function $(){A&&y&&(A=!1,y.length?g=y.concat(g):P=-1,g.length&&S())}function S(){if(!A){var u=b($);A=!0;for(var o=g.length;o;){for(y=g,g=[];++P<o;)y&&y[P].run();P=-1,o=g.length}y=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===L||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(u)}}function D(u,o){this.fun=u,this.array=o}function w(){}f.nextTick=function(u){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];g.push(new D(u,o)),g.length!==1||A||b(S)},D.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(u){return[]},f.binding=function(u){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(u){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(R){return new F(R)}constructor(R){this.c=I&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=F}),define(ke[4],Se([1,0,8,74,3,75,38]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const b=!1,y=!1;var g;(function(m){m.None=()=>f.$Rc.None;function p(de){if(y){const{onDidAddListener:ee}=de,he=D.create();let pe=0;de.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),ee?.()}}}function v(de,ee){return fe(de,()=>{},0,void 0,!0,void 0,ee)}m.defer=v;function E(de){return(ee,he=null,pe)=>{let Pe=!1,B;return B=de(J=>{if(!Pe)return B?B.dispose():Pe=!0,ee.call(he,J)},null,pe),Pe&&B.dispose(),B}}m.once=E;function N(de,ee,he){return V((pe,Pe=null,B)=>de(J=>pe.call(Pe,ee(J)),null,B),he)}m.map=N;function z(de,ee,he){return V((pe,Pe=null,B)=>de(J=>{ee(J),pe.call(Pe,J)},null,B),he)}m.forEach=z;function M(de,ee,he){return V((pe,Pe=null,B)=>de(J=>ee(J)&&pe.call(Pe,J),null,B),he)}m.filter=M;function T(de){return de}m.signal=T;function j(...de){return(ee,he=null,pe)=>{const Pe=(0,f.$Oc)(...de.map(B=>B(J=>ee.call(he,J))));return te(Pe,pe)}}m.any=j;function O(de,ee,he,pe){let Pe=he;return N(de,B=>(Pe=ee(Pe,B),Pe),pe)}m.reduce=O;function V(de,ee){let he;const pe={onWillAddFirstListener(){he=de(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};ee||p(pe);const Pe=new n(pe);return ee?.add(Pe),Pe.event}function te(de,ee){return ee instanceof Array?ee.push(de):ee&&ee.add(de),de}function fe(de,ee,he=100,pe=!1,Pe=!1,B,J){let re,ae,_,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){re=de(et=>{ge++,ae=ee(ae,et),pe&&!_&&(We.fire(ae),ae=void 0),ye=()=>{const Ze=ae;ae=void 0,_=void 0,(!pe||ge>1)&&We.fire(Ze),ge=0},typeof he=="number"?(clearTimeout(_),_=setTimeout(ye,he)):_===void 0&&(_=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,re.dispose()}};J||p(je);const We=new n(je);return J?.add(We),We.event}m.debounce=fe;function Z(de,ee=0,he){return m.debounce(de,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],ee,void 0,!0,void 0,he)}m.accumulate=Z;function Q(de,ee=(pe,Pe)=>pe===Pe,he){let pe=!0,Pe;return M(de,B=>{const J=pe||!ee(B,Pe);return pe=!1,Pe=B,J},he)}m.latch=Q;function G(de,ee,he){return[m.filter(de,ee,he),m.filter(de,pe=>!ee(pe),he)]}m.split=G;function oe(de,ee=!1,he=[],pe){let Pe=he.slice(),B=de(ae=>{Pe?Pe.push(ae):re.fire(ae)});pe&&pe.add(B);const J=()=>{Pe?.forEach(ae=>re.fire(ae)),Pe=null},re=new n({onWillAddFirstListener(){B||(B=de(ae=>re.fire(ae)),pe&&pe.add(B))},onDidAddFirstListener(){Pe&&(ee?setTimeout(J):J())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return pe&&pe.add(re),re.event}m.buffer=oe;function x(de,ee){return(pe,Pe,B)=>{const J=ee(new le);return de(function(re){const ae=J.evaluate(re);ae!==Ee&&pe.call(Pe,ae)},void 0,B)}}m.chain=x;const Ee=Symbol("HaltChainable");class le{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(he=>(ee(he),he)),this}filter(ee){return this.f.push(he=>ee(he)?he:Ee),this}reduce(ee,he){let pe=he;return this.f.push(Pe=>(pe=ee(pe,Pe),pe)),this}latch(ee=(he,pe)=>he===pe){let he=!0,pe;return this.f.push(Pe=>{const B=he||!ee(Pe,pe);return he=!1,pe=Pe,B?Pe:Ee}),this}evaluate(ee){for(const he of this.f)if(ee=he(ee),ee===Ee)break;return ee}}function q(de,ee,he=pe=>pe){const pe=(...re)=>J.fire(he(...re)),Pe=()=>de.on(ee,pe),B=()=>de.removeListener(ee,pe),J=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}m.fromNodeEventEmitter=q;function U(de,ee,he=pe=>pe){const pe=(...re)=>J.fire(he(...re)),Pe=()=>de.addEventListener(ee,pe),B=()=>de.removeEventListener(ee,pe),J=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return J.event}m.fromDOMEventEmitter=U;function ie(de){return new Promise(ee=>E(de)(ee))}m.toPromise=ie;function be(de){const ee=new n;return de.then(he=>{ee.fire(he)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}m.fromPromise=be;function H(de,ee,he){return ee(he),de(pe=>ee(pe))}m.runAndSubscribe=H;function X(de,ee){let he=null;function pe(B){he?.dispose(),he=new f.$Qc,ee(B,he)}pe(void 0);const Pe=de(B=>pe(B));return(0,f.$Pc)(()=>{Pe.dispose(),he?.dispose()})}m.runAndSubscribeWithStore=X;class Y{constructor(ee,he){this._observable=ee,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};he||p(pe),this.emitter=new n(pe),he&&he.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,he){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(de,ee){return new Y(de,ee).emitter.event}m.fromObservable=$e;function ne(de){return ee=>{let he=0,pe=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(de.reportChanges(),pe&&(pe=!1,ee()))},handlePossibleChange(){},handleChange(){pe=!0}};return de.addObserver(Pe),de.reportChanges(),{dispose(){de.removeObserver(Pe)}}}}m.fromObservableLight=ne})(g||(e.Event=g={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new L.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=A;let P=-1;function $(m){const p=P;return P=m,{dispose(){P=p}}}e.$Qd=$;class S{constructor(p,v=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=v,this.g=0}dispose(){this.f?.clear()}check(p,v){const E=this.threshold;if(E<=0||v<E)return;this.f||(this.f=new Map);const N=this.f.get(p.value)||0;if(this.f.set(p.value,N+1),this.g-=1,this.g<=0){this.g=E*.5;let z,M=0;for(const[T,j]of this.f)(!z||M<j)&&(z=T,M=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${M}):`),console.warn(z)}return()=>{const z=this.f.get(p.value)||0;this.f.set(p.value,z-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class u{constructor(p){this.value=p,this.id=w++}}const o=2,i=(m,p)=>{if(m instanceof u)p(m);else for(let v=0;v<m.length;v++){const E=m[v];E&&p(E)}};class n{constructor(p){this.w=0,this.f=p,this.g=P>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,v,E)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Rc.None;if(this.m)return f.$Rc.None;v&&(p=p.bind(v));const N=new u(p);let z,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=D.create(),z=this.g.check(N.stack,this.w+1)),b&&(N.stack=M??D.create()),this.t?this.t instanceof u?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,f.$Pc)(()=>{z?.(),this.x(N)});return E instanceof f.$Qc?E.add(T):Array.isArray(E)&&E.push(T),T},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,E=v.indexOf(p);if(E===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[E]=void 0;const N=this.u.current===this;if(this.w*o<=v.length){let z=0;for(let M=0;M<v.length;M++)v[M]?v[z++]=v[M]:N&&(this.u.end--,z<this.u.i&&this.u.i--);v.length=z}}y(p,v){if(!p)return;const E=this.f?.onListenerError||I.$Z;if(!E){p.value(v);return}try{p.value(v)}catch(N){E(N)}}z(p){const v=p.current.t;for(;p.i<p.end;)this.y(v[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof u)this.y(this.t,p);else{const v=this.u;v.enqueue(this,p,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const r=()=>new a;e.$Sd=r;class a{constructor(){this.i=-1,this.end=0}enqueue(p,v,E){this.i=0,this.end=E,this.current=p,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,v,E){if(this.t)for(this.h||(this.h=new R.$2c),i(this.t,N=>this.h.push([N.value,p]));this.h.size>0&&!v.isCancellationRequested;){const[N,z]=this.h.shift(),M=[],T={...z,token:v,waitUntil:j=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");E&&(j=E(j,N)),M.push(j)}};try{N(T)}catch(j){(0,I.$Z)(j);continue}Object.freeze(M),await Promise.allSettled(M).then(j=>{for(const O of j)O.status==="rejected"&&(0,I.$Z)(O.reason)})}}}e.$Td=t;class s extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new R.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=s;class d extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=d;class c extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$Wd=c;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const v={event:p,listener:null};this.h.push(v),this.g&&this.m(v);const E=()=>{this.g&&this.o(v);const N=this.h.indexOf(v);this.h.splice(N,1)};return(0,f.$Pc)((0,F.$cb)(E))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(v=>this.f.fire(v))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=l;class h{constructor(p,v,E,N){this.f=new f.$Qc;const z=this.f.add(new l),M=this.f.add(new f.$1c);function T(j){M.set(j,z.add(N(j)))}for(const j of p)T(j);this.f.add(v(j=>{T(j)})),this.f.add(E(j=>{M.deleteAndDispose(j)})),this.event=z.event}dispose(){this.f.dispose()}}e.$Yd=h;class k{constructor(){this.f=[]}wrapEvent(p){return(v,E,N)=>p(z=>{const M=this.f[this.f.length-1];M?M.push(()=>v.call(E,z)):v.call(E,z)},void 0,N)}bufferEvents(p){const v=[];this.f.push(v);const E=p();return this.f.pop(),v.forEach(N=>N()),E}}e.$Zd=k;class C{constructor(){this.f=!1,this.g=g.None,this.h=f.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=C}),define(ke[21],Se([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const F=Object.freeze(function(b,y){const g=setTimeout(b.bind(y),0);return{dispose(){clearTimeout(g)}}});var f;(function(b){function y(g){return g===b.None||g===b.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}b.isCancellationToken=y,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$2d=L}),define(ke[162],Se([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class F{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new I.$2d,y=this.b(b.token);return this.a={promise:y,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ae=F;class f{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const y=JSON.stringify(b);return this.b!==y&&(this.b=y,this.a=this.c(b)),this.a}}e.$Be=f;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const y=this.b(b);return this.a.set(b,y),y}}e.$Ce=R}),define(ke[98],Se([1,0,8,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function f(r){const a=r;return a?typeof a.read=="function":!1}e.$3d=f;function R(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=R;function L(r){const a=r;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=L;function b(r,a){return new y(r,a)}e.$6d=b;class y{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(r,a){const t=[];let s;for(;(s=r.read())!==null;)t.push(s);return a(t)}e.$7d=g;function A(r,a,t){const s=[];let d;for(;(d=r.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const c=d;return d=void 0,c}return r.read()}}}e.$8d=A;function P(r,a){return new Promise((t,s)=>{const d=[];$(r,{onData:c=>{a&&d.push(c)},onError:c=>{a?s(c):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$9d=P;function $(r,a,t){r.on("error",s=>{t?.isCancellationRequested||a.onError(s)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",s=>{t?.isCancellationRequested||a.onData(s)})}e.$0d=$;function S(r,a){return new Promise((t,s)=>{const d=new F.$Qc,c=[],l=C=>{if(c.push(C),c.length>a)return d.dispose(),r.pause(),t({stream:r,buffer:c,ended:!1})},h=C=>(d.dispose(),s(C)),k=()=>(d.dispose(),t({stream:r,buffer:c,ended:!0}));d.add((0,F.$Pc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,F.$Pc)(()=>r.removeListener("end",k))),r.on("end",k),d.add((0,F.$Pc)(()=>r.removeListener("data",l))),r.on("data",l)})}e.$$d=S;function D(r,a){const t=b(a);return t.end(r),t}e.$_d=D;function w(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}e.$ae=w;function u(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$be=u;function o(r,a,t){const s=b(t);return $(r,{onData:d=>s.write(a.data(d)),onError:d=>s.error(a.error?a.error(d):d),onEnd:()=>s.end()}),s}e.$ce=o;function i(r,a,t){let s=!1;return{read:()=>{const d=a.read();return s?d:(s=!0,d!==null?t([r,d]):r)}}}e.$de=i;function n(r,a,t){let s=!1;const d=b(t);return $(a,{onData:c=>s?d.write(c):(s=!0,d.write(t([r,c]))),onError:c=>d.error(c),onEnd:()=>{s||(s=!0,d.write(r)),d.end()}}),d}e.$ee=n}),define(ke[22],Se([1,0,48,98]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const f=typeof Buffer<"u",R=new I.$U(()=>new Uint8Array(256));let L,b;class y{static alloc(v){return f?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return f&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,E){return!(E?.dontUseNodeBuffer||!1)&&f?new y(Buffer.from(v)):(L||(L=new TextEncoder),new y(L.encode(v)))}static fromByteArray(v){const E=y.alloc(v.length);for(let N=0,z=v.length;N<z;N++)E.buffer[N]=v[N];return E}static concat(v,E){if(typeof E>"u"){E=0;for(let M=0,T=v.length;M<T;M++)E+=v[M].byteLength}const N=y.alloc(E);let z=0;for(let M=0,T=v.length;M<T;M++){const j=v[M];N.set(j,z),z+=j.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=y.alloc(this.byteLength);return v.set(this),v}toString(){return f?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(v,E){return new y(this.buffer.subarray(v,E))}set(v,E){if(v instanceof y)this.buffer.set(v.buffer,E);else if(v instanceof Uint8Array)this.buffer.set(v,E);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),E);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),E);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return $(this.buffer,v)}writeUInt32BE(v,E){S(this.buffer,v,E)}readUInt32LE(v){return D(this.buffer,v)}writeUInt32LE(v,E){w(this.buffer,v,E)}readUInt8(v){return u(this.buffer,v)}writeUInt8(v,E){o(this.buffer,v,E)}indexOf(v,E=0){return g(this.buffer,v instanceof y?v.buffer:v,E)}}e.$fe=y;function g(p,v,E=0){const N=v.byteLength,z=p.byteLength;if(N===0)return 0;if(N===1)return p.indexOf(v[0]);if(N>z-E)return-1;const M=R.value;M.fill(v.length);for(let V=0;V<v.length;V++)M[v[V]]=v.length-V-1;let T=E+v.length-1,j=T,O=-1;for(;T<z;)if(p[T]===v[j]){if(j===0){O=T;break}T--,j--}else T+=Math.max(v.length-j,M[p[T]]),j=v.length-1;return O}e.$ge=g;function A(p,v){return p[v+0]<<0>>>0|p[v+1]<<8>>>0}e.$he=A;function P(p,v,E){p[E+0]=v&255,v=v>>>8,p[E+1]=v&255}e.$ie=P;function $(p,v){return p[v]*2**24+p[v+1]*2**16+p[v+2]*2**8+p[v+3]}e.$je=$;function S(p,v,E){p[E+3]=v,v=v>>>8,p[E+2]=v,v=v>>>8,p[E+1]=v,v=v>>>8,p[E]=v}e.$ke=S;function D(p,v){return p[v+0]<<0>>>0|p[v+1]<<8>>>0|p[v+2]<<16>>>0|p[v+3]<<24>>>0}e.$le=D;function w(p,v,E){p[E+0]=v&255,v=v>>>8,p[E+1]=v&255,v=v>>>8,p[E+2]=v&255,v=v>>>8,p[E+3]=v&255}e.$me=w;function u(p,v){return p[v]}e.$ne=u;function o(p,v,E){p[E]=v}e.$oe=o;function i(p){return F.$7d(p,v=>y.concat(v))}e.$pe=i;function n(p){return F.$be(p)}e.$qe=n;function r(p){return F.$9d(p,v=>y.concat(v))}e.$re=r;async function a(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await r(p.stream)])}e.$se=a;function t(p){return F.$_d(p,v=>y.concat(v))}e.$te=t;function s(p){return F.$ce(p,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}e.$ue=s;function d(p){return F.$6d(v=>y.concat(v),p)}e.$ve=d;function c(p,v){return F.$de(p,v,E=>y.concat(E))}e.$we=c;function l(p,v){return F.$ee(p,v,E=>y.concat(E))}e.$xe=l;function h(p){let v=0,E=0,N=0;const z=new Uint8Array(Math.floor(p.length/4*3)),M=j=>{switch(E){case 3:z[N++]=v|j,E=0;break;case 2:z[N++]=v|j>>>2,v=j<<6,E=3;break;case 1:z[N++]=v|j>>>4,v=j<<4,E=2;break;default:v=j<<2,E=1}};for(let j=0;j<p.length;j++){const O=p.charCodeAt(j);if(O>=65&&O<=90)M(O-65);else if(O>=97&&O<=122)M(O-97+26);else if(O>=48&&O<=57)M(O-48+52);else if(O===43||O===45)M(62);else if(O===47||O===95)M(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${p[j]}`)}}const T=N;for(;E>0;)M(0);return y.wrap(z).slice(0,T)}e.$ye=h;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:p},v=!0,E=!1){const N=E?C:k;let z="";const M=p.byteLength%3;let T=0;for(;T<p.byteLength-M;T+=3){const j=p[T+0],O=p[T+1],V=p[T+2];z+=N[j>>>2],z+=N[(j<<4|O>>>4)&63],z+=N[(O<<2|V>>>6)&63],z+=N[V&63]}if(M===1){const j=p[T+0];z+=N[j>>>2],z+=N[j<<4&63],v&&(z+="==")}else if(M===2){const j=p[T+0],O=p[T+1];z+=N[j>>>2],z+=N[(j<<4|O>>>4)&63],z+=N[O<<2&63],v&&(z+="=")}return z}e.$ze=m}),define(ke[13],Se([1,0,162,48]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Fe=f;const R=/{(\d+)}/g;function L(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(Ve,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Ne.length?Ve:Ne[Xe]})}e.$Ge=L;const b=/{([^}]+)}/g;function y(Ae,Ne){return Object.keys(Ne).length===0?Ae:Ae.replace(b,(Ve,Le)=>Ne[Le]??Ve)}e.$He=y;function g(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ie=g;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=A;function P(Ae,Ne){let Ve=0;const Le=Ne.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&Ve++;return Ve}e.$Ke=P;function $(Ae,Ne,Ve="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${Ve}`}e.$Le=$;function S(Ae,Ne=" "){const Ve=D(Ae,Ne);return w(Ve,Ne)}e.$Me=S;function D(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$Ne=D;function w(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Xe=Le,ue=-1;for(;ue=Ae.lastIndexOf(Ne,Xe-1),!(ue===-1||ue+Ve!==Xe);){if(ue===0)return"";Xe=ue}return Ae.substring(0,Xe)}e.$Oe=w;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=u;function o(Ae){return Ae.replace(/\*/g,"")}e.$Qe=o;function i(Ae,Ne,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Re=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Se=n;function r(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Te=r;function a(Ae){for(let Ne=0,Ve=Ae.length;Ne<Ve;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Ue=a;function t(Ae,Ne=0,Ve=Ae.length){for(let Le=Ne;Le<Ve;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,Ve)}e.$Ve=t;function s(Ae,Ne=Ae.length-1){for(let Ve=Ne;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$We=s;function d(Ae,Ne,Ve){const Le=[];let Xe=0;for(const ue of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Xe,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");Xe=ue.index+ue[0].length,Le.push(Ve(ue[0],...ue.slice(1),ue.index,Ae,ue.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(ue=>ue.join(""))}e.$Xe=d;function c(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ye=c;function l(Ae,Ne,Ve=0,Le=Ae.length,Xe=0,ue=Ne.length){for(;Ve<Le&&Xe<ue;Ve++,Xe++){const Ke=Ae.charCodeAt(Ve),Ge=Ne.charCodeAt(Xe);if(Ke<Ge)return-1;if(Ke>Ge)return 1}const ce=Le-Ve,Ie=ue-Xe;return ce<Ie?-1:ce>Ie?1:0}e.$Ze=l;function h(Ae,Ne){return k(Ae,Ne,0,Ae.length,0,Ne.length)}e.$1e=h;function k(Ae,Ne,Ve=0,Le=Ae.length,Xe=0,ue=Ne.length){for(;Ve<Le&&Xe<ue;Ve++,Xe++){let Ke=Ae.charCodeAt(Ve),Ge=Ne.charCodeAt(Xe);if(Ke===Ge)continue;if(Ke>=128||Ge>=128)return l(Ae.toLowerCase(),Ne.toLowerCase(),Ve,Le,Xe,ue);m(Ke)&&(Ke-=32),m(Ge)&&(Ge-=32);const _e=Ke-Ge;if(_e!==0)return _e}const ce=Le-Ve,Ie=ue-Xe;return ce<Ie?-1:ce>Ie?1:0}e.$2e=k;function C(Ae){return Ae>=48&&Ae<=57}e.$3e=C;function m(Ae){return Ae>=97&&Ae<=122}e.$4e=m;function p(Ae){return Ae>=65&&Ae<=90}e.$5e=p;function v(Ae,Ne){return Ae.length===Ne.length&&k(Ae,Ne)===0}e.$6e=v;function E(Ae,Ne){const Ve=Ne.length;return Ne.length>Ae.length?!1:k(Ae,Ne,0,Ve)===0}e.$7e=E;function N(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return Ve}e.$8e=N;function z(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;const Xe=Ae.length-1,ue=Ne.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Xe-Le)!==Ne.charCodeAt(ue-Le))return Le;return Ve}e.$9e=z;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$0e=M;function T(Ae){return 56320<=Ae&&Ae<=57343}e.$$e=T;function j(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$_e=j;function O(Ae,Ne,Ve){const Le=Ae.charCodeAt(Ve);if(M(Le)&&Ve+1<Ne){const Xe=Ae.charCodeAt(Ve+1);if(T(Xe))return j(Le,Xe)}return Le}e.$af=O;function V(Ae,Ne){const Ve=Ae.charCodeAt(Ne-1);if(T(Ve)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return j(Le,Ve)}return Ve}class te{get offset(){return this.e}constructor(Ne,Ve=0){this.c=Ne,this.d=Ne.length,this.e=Ve}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=V(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=O(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$bf=te;class fe{get offset(){return this.c.offset}constructor(Ne,Ve=0){this.c=new te(Ne,Ve)}nextGraphemeLength(){const Ne=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Ne.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const ue=Ve.offset,ce=Ne.getGraphemeBreakType(Ve.nextCodePoint());if(ae(Xe,ce)){Ve.setOffset(ue);break}Xe=ce}return Ve.offset-Le}prevGraphemeLength(){const Ne=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Ne.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const ue=Ve.offset,ce=Ne.getGraphemeBreakType(Ve.prevCodePoint());if(ae(ce,Xe)){Ve.setOffset(ue);break}Xe=ce}return Le-Ve.offset}eol(){return this.c.eol()}}e.$cf=fe;function Z(Ae,Ne){return new fe(Ae,Ne).nextGraphemeLength()}e.$df=Z;function Q(Ae,Ne){return new fe(Ae,Ne).prevGraphemeLength()}e.$ef=Q;function G(Ae,Ne){Ne>0&&T(Ae.charCodeAt(Ne))&&Ne--;const Ve=Ne+Z(Ae,Ne);return[Ve-Q(Ae,Ve),Ve]}e.$ff=G;function oe(Ae){const Ne=new fe(Ae);let Ve=0;for(;!Ne.eol();)Ve++,Ne.nextGraphemeLength();return Ve}e.$gf=oe;let x;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(Ae){return x||(x=Ee()),x.test(Ae)}e.$hf=le;const q=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return q.test(Ae)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ie(Ae){return e.$jf.test(Ae)}e.$kf=ie;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$lf=be;function H(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$mf=H;function X(Ae,Ne){if(Ae.length<Ne)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Ne);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$nf=X;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function ne(Ae){return Ae&&(Ae=Ae.replace(Y,"").replace($e,"")),Ae}e.$of=ne,e.$pf=String.fromCharCode(65279);function de(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$qf=de;function ee(Ae){return de(Ae)?Ae.substr(1):Ae}e.$rf=ee;function he(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const Ve=Ne.length,Le=Ae.toLowerCase();let Xe=0,ue=-1;for(;Xe<Ve;){const ce=Le.indexOf(Ne[Xe],ue+1);if(ce<0)return!1;ue=ce,Xe++}return!0}e.$sf=he;function pe(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$tf=pe;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$uf=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Ne--;while(Ne>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$vf=B;function J(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$wf=J;function re(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$xf=re;function ae(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var _;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const Ve=this.d,Le=Ve.length/3;let Xe=1;for(;Xe<=Le;)if(Ne<Ve[3*Xe])Xe=2*Xe;else if(Ne>Ve[3*Xe+1])Xe=2*Xe+1;else return Ve[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Ne){if(Ae===0)return 0;const Ve=We(Ae,Ne);if(Ve!==void 0)return Ve;const Le=new te(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$yf=je;function We(Ae,Ne){const Ve=new te(Ne,Ae);let Le=Ve.prevCodePoint();for(;et(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!H(Le))return;let Xe=Ve.offset;return Xe>0&&Ve.prevCodePoint()===8205&&(Xe=Ve.offset),Xe}function et(Ae){return 127995<=Ae&&Ae<=127999}var Ze;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$zf="\xA0";class rt{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Be(Ne=>{function Ve(_e){const st=new Map;for(let lt=0;lt<_e.length;lt+=2)st.set(_e[lt],_e[lt+1]);return st}function Le(_e,st){const lt=new Map(_e);for(const[wt,Ue]of st)lt.set(wt,Ue);return lt}function Xe(_e,st){if(!_e)return st;const lt=new Map;for(const[wt,Ue]of _e)st.has(wt)&&lt.set(wt,Ue);return lt}const ue=this.c.value;let ce=Ne.filter(_e=>!_e.startsWith("_")&&_e in ue);ce.length===0&&(ce=["_default"]);let Ie;for(const _e of ce){const st=Ve(ue[_e]);Ie=Xe(Ie,st)}const Ke=Ve(ue._common),Ge=Le(Ke,Ie);return new rt(Ge)})}static getInstance(Ne){return rt.d.get(Array.from(Ne))}static{this.e=new F.$U(()=>Object.keys(rt.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=rt;class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Ne){return nt.e().has(Ne)}static get codePoints(){return nt.e()}}e.$Bf=nt}),define(ke[124],Se([1,0,28,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function f(...ee){return function(he,pe){for(let Pe=0,B=ee.length;Pe<B;Pe++){const J=ee[Pe](he,pe);if(J)return J}return null}}e.or=f,e.$Ij=R.bind(void 0,!1),e.$Jj=R.bind(void 0,!0);function R(ee,he,pe){if(!pe||pe.length<he.length)return null;let Pe;return ee?Pe=F.$7e(pe,he):Pe=pe.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function L(ee,he){const pe=he.toLowerCase().indexOf(ee.toLowerCase());return pe===-1?null:[{start:pe,end:pe+ee.length}]}e.$Kj=L;function b(ee,he){return y(ee.toLowerCase(),he.toLowerCase(),0,0)}e.$Lj=b;function y(ee,he,pe,Pe){if(pe===ee.length)return[];if(Pe===he.length)return null;if(ee[pe]===he[Pe]){let B=null;return(B=y(ee,he,pe+1,Pe+1))?o({start:Pe,end:Pe+1},B):null}return y(ee,he,pe,Pe+1)}function g(ee){return 97<=ee&&ee<=122}function A(ee){return 65<=ee&&ee<=90}e.$Mj=A;function P(ee){return 48<=ee&&ee<=57}function $(ee){return ee===32||ee===9||ee===10||ee===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>S.add(ee.charCodeAt(0)));function D(ee){return $(ee)||S.has(ee)}function w(ee,he){return ee===he||D(ee)&&D(he)}function u(ee){return g(ee)||A(ee)||P(ee)}function o(ee,he){return he.length===0?he=[ee]:ee.end===he[0].start?he[0].start=ee.start:he.unshift(ee),he}function i(ee,he){for(let pe=he;pe<ee.length;pe++){const Pe=ee.charCodeAt(pe);if(A(Pe)||P(Pe)||pe>0&&!u(ee.charCodeAt(pe-1)))return pe}return ee.length}function n(ee,he,pe,Pe){if(pe===ee.length)return[];if(Pe===he.length)return null;if(ee[pe]!==he[Pe].toLowerCase())return null;{let B=null,J=Pe+1;for(B=n(ee,he,pe+1,Pe+1);!B&&(J=i(he,J))<he.length;)B=n(ee,he,pe+1,J),J++;return B===null?null:o({start:Pe,end:Pe+1},B)}}function r(ee){let he=0,pe=0,Pe=0,B=0,J=0;for(let ye=0;ye<ee.length;ye++)J=ee.charCodeAt(ye),A(J)&&he++,g(J)&&pe++,u(J)&&Pe++,P(J)&&B++;const re=he/ee.length,ae=pe/ee.length,_=Pe/ee.length,ge=B/ee.length;return{upperPercent:re,lowerPercent:ae,alphaPercent:_,numericPercent:ge}}function a(ee){const{upperPercent:he,lowerPercent:pe}=ee;return pe===0&&he>.6}function t(ee){const{upperPercent:he,lowerPercent:pe,alphaPercent:Pe,numericPercent:B}=ee;return pe>.2&&he<.8&&Pe>.6&&B<.2}function s(ee){let he=0,pe=0,Pe=0,B=0;for(let J=0;J<ee.length;J++)Pe=ee.charCodeAt(J),A(Pe)&&he++,g(Pe)&&pe++,$(Pe)&&B++;return(he===0||pe===0)&&B===0?ee.length<=30:he<=5}function d(ee,he){if(!he||(he=he.trim(),he.length===0)||!s(ee)||he.length>60)return null;const pe=r(he);if(!t(pe)){if(!a(pe))return null;he=he.toLowerCase()}let Pe=null,B=0;for(ee=ee.toLowerCase();B<he.length&&(Pe=n(ee,he,0,B))===null;)B=i(he,B+1);return Pe}e.$Nj=d;function c(ee,he,pe=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(ee=ee.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=l(ee,he,0,B,pe))===null;)B=h(he,B+1);return Pe}e.$Oj=c;function l(ee,he,pe,Pe,B){if(pe===ee.length)return[];if(Pe===he.length)return null;if(w(ee.charCodeAt(pe),he.charCodeAt(Pe))){let J=null,re=Pe+1;if(J=l(ee,he,pe+1,Pe+1,B),!B)for(;!J&&(re=h(he,re))<he.length;)J=l(ee,he,pe+1,re,B),re++;return J?ee.charCodeAt(pe)!==he.charCodeAt(Pe)?J:o({start:Pe,end:Pe+1},J):null}else return null}function h(ee,he){for(let pe=he;pe<ee.length;pe++)if(D(ee.charCodeAt(pe))||pe>0&&D(ee.charCodeAt(pe-1)))return pe;return ee.length}const k=f(e.$Jj,d,L),C=f(e.$Jj,d,b),m=new I.$Cc(1e4);function p(ee,he,pe=!1){if(typeof ee!="string"||typeof he!="string")return null;let Pe=m.get(ee);Pe||(Pe=new RegExp(F.$Pe(ee),"i"),m.set(ee,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:pe?C(ee,he):k(ee,he)}e.$Pj=p;function v(ee,he){const pe=be(ee,ee.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?N(pe):null}e.$Qj=v;function E(ee,he,pe,Pe,B,J){const re=Math.min(13,ee.length);for(;pe<re;pe++){const ae=be(ee,he,pe,Pe,B,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ae)return ae}return[0,J]}e.$Rj=E;function N(ee){if(typeof ee>"u")return[];const he=[],pe=ee[1];for(let Pe=ee.length-1;Pe>1;Pe--){const B=ee[Pe]+pe,J=he[he.length-1];J&&J.end===B?J.end=B+1:he.push({start:B,end:B+1})}return he}e.$Sj=N;const z=128;function M(){const ee=[],he=[];for(let pe=0;pe<=z;pe++)he[pe]=0;for(let pe=0;pe<=z;pe++)ee.push(he.slice(0));return ee}function T(ee){const he=[];for(let pe=0;pe<=ee;pe++)he[pe]=0;return he}const j=T(2*z),O=T(2*z),V=M(),te=M(),fe=M(),Z=!1;function Q(ee,he,pe,Pe,B){function J(ae,_,ge=" "){for(;ae.length<_;)ae=ge+ae;return ae}let re=` |   |${Pe.split("").map(ae=>J(ae,3)).join("|")}
`;for(let ae=0;ae<=pe;ae++)ae===0?re+=" |":re+=`${he[ae-1]}|`,re+=ee[ae].slice(0,B+1).map(_=>J(_.toString(),3)).join("|")+`
`;return re}function G(ee,he,pe,Pe){ee=ee.substr(he),pe=pe.substr(Pe),console.log(Q(te,ee,ee.length,pe,pe.length)),console.log(Q(fe,ee,ee.length,pe,pe.length)),console.log(Q(V,ee,ee.length,pe,pe.length))}function oe(ee,he){if(he<0||he>=ee.length)return!1;const pe=ee.codePointAt(he);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$mf(pe)}}function x(ee,he){if(he<0||he>=ee.length)return!1;switch(ee.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function Ee(ee,he,pe){return he[ee]!==pe[ee]}function le(ee,he,pe,Pe,B,J,re=!1){for(;he<pe&&B<J;)ee[he]===Pe[B]&&(re&&(j[he]=B),he+=1),B+=1;return he===pe}e.$Tj=le;var q;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(q||(q={}));var U;(function(ee){ee.Default=[-100,0];function he(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}ee.isDefault=he})(U||(e.FuzzyScore=U={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,pe){this.firstMatchCanBeWeak=he,this.boostFullMatch=pe}}e.$Uj=ie;function be(ee,he,pe,Pe,B,J,re=ie.default){const ae=ee.length>z?z:ee.length,_=Pe.length>z?z:Pe.length;if(pe>=ae||J>=_||ae-pe>_-J||!le(he,pe,ae,B,J,_,!0))return;H(ae,_,pe,J,he,B);let ge=1,ye=1,je=pe,We=J;const et=[!1];for(ge=1,je=pe;je<ae;ge++,je++){const Ne=j[je],Ve=O[je],Le=je+1<ae?O[je+1]:_;for(ye=Ne-J+1,We=Ne;We<Le;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,ue=!1;We<=Ve&&(Xe=X(ee,he,je,pe,Pe,B,We,_,J,V[ge-1][ye-1]===0,et));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ue=!0,ce=Xe+te[ge-1][ye-1]);const Ie=We>Ne,Ke=Ie?te[ge][ye-1]+(V[ge][ye-1]>0?-5:0):0,Ge=We>Ne+1&&V[ge][ye-1]>0,_e=Ge?te[ge][ye-2]+(V[ge][ye-2]>0?-5:0):0;if(Ge&&(!Ie||_e>=Ke)&&(!ue||_e>=ce))te[ge][ye]=_e,fe[ge][ye]=3,V[ge][ye]=0;else if(Ie&&(!ue||Ke>=ce))te[ge][ye]=Ke,fe[ge][ye]=2,V[ge][ye]=0;else if(ue)te[ge][ye]=ce,fe[ge][ye]=1,V[ge][ye]=V[ge-1][ye-1]+1;else throw new Error("not possible")}}if(Z&&G(ee,pe,Pe,J),!et[0]&&!re.firstMatchCanBeWeak)return;ge--,ye--;const Ze=[te[ge][ye],J];let rt=0,nt=0;for(;ge>=1;){let Ne=ye;do{const Ve=fe[ge][Ne];if(Ve===3)Ne=Ne-2;else if(Ve===2)Ne=Ne-1;else break}while(Ne>=1);rt>1&&he[pe+ge-1]===B[J+ye-1]&&!Ee(Ne+J-1,Pe,B)&&rt+1>V[ge][Ne]&&(Ne=ye),Ne===ye?rt++:rt=1,nt||(nt=Ne),ge--,ye=Ne-1,Ze.push(ye)}_===ae&&re.boostFullMatch&&(Ze[0]+=2);const Ae=nt-ae;return Ze[0]-=Ae,Ze}e.$Vj=be;function H(ee,he,pe,Pe,B,J){let re=ee-1,ae=he-1;for(;re>=pe&&ae>=Pe;)B[re]===J[ae]&&(O[re]=ae,re--),ae--}function X(ee,he,pe,Pe,B,J,re,ae,_,ge,ye){if(he[pe]!==J[re])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return re===pe-Pe?je=ee[pe]===B[re]?7:5:Ee(re,B,J)&&(re===0||!Ee(re-1,B,J))?(je=ee[pe]===B[re]?7:5,We=!0):oe(J,re)&&(re===0||!oe(J,re-1))?je=5:(oe(J,re-1)||x(J,re-1))&&(je=5,We=!0),je>1&&pe===Pe&&(ye[0]=!0),We||(We=Ee(re,B,J)||oe(J,re-1)||x(J,re-1)),pe===Pe?re>_&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,re+1===ae&&(je-=We?3:5),je}function Y(ee,he,pe,Pe,B,J,re){return ne(ee,he,pe,Pe,B,J,!0,re)}e.$Wj=Y;function $e(ee,he,pe,Pe,B,J,re){return ne(ee,he,pe,Pe,B,J,!1,re)}e.$Xj=$e;function ne(ee,he,pe,Pe,B,J,re,ae){let _=be(ee,he,pe,Pe,B,J,ae);if(_&&!re)return _;if(ee.length>=3){const ge=Math.min(7,ee.length-1);for(let ye=pe+1;ye<ge;ye++){const je=de(ee,ye);if(je){const We=be(je,je.toLowerCase(),pe,Pe,B,J,ae);We&&(We[0]-=3,(!_||We[0]>_[0])&&(_=We))}}}return _}function de(ee,he){if(he+1>=ee.length)return;const pe=ee[he],Pe=ee[he+1];if(pe!==Pe)return ee.slice(0,he)+Pe+pe+ee.slice(he+2)}}),define(ke[52],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function F(o){return f(o,0)}e.$Ji=F;function f(o,i){switch(typeof o){case"object":return o===null?R(349,i):Array.isArray(o)?y(o,i):g(o,i);case"string":return b(o,i);case"boolean":return L(o,i);case"number":return R(o,i);case"undefined":return R(937,i);default:return R(617,i)}}e.$Ki=f;function R(o,i){return(i<<5)-i+o|0}e.$Li=R;function L(o,i){return R(o?433:863,i)}function b(o,i){i=R(149417,i);for(let n=0,r=o.length;n<r;n++)i=R(o.charCodeAt(n),i);return i}e.$Mi=b;function y(o,i){return i=R(104579,i),o.reduce((n,r)=>f(r,n),i)}function g(o,i){return i=R(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=b(r,n),f(o[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Ni=A;var P;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function $(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function S(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function D(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function w(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):D((o>>>0).toString(16),i/4)}e.$Oi=w;class u{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=i.charCodeAt(0),d=0);;){let c=s;if(I.$0e(s))if(d+1<n){const l=i.charCodeAt(d+1);I.$$e(l)?(d++,c=I.$_e(s,l)):c=65533}else{t=s;break}else I.$$e(s)&&(c=65533);if(a=this.w(r,a,c),d++,d<n)s=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=u.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,$(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,s=this.n,d=this.o,c,l,h;for(let k=0;k<80;k++)k<20?(c=a&t|~a&s,l=1518500249):k<40?(c=a^t^s,l=1859775393):k<60?(c=a&t|a&s|t&s,l=2400959708):(c=a^t^s,l=3395469782),h=$(r,5)+c+d+l+i.getUint32(k*4,!1)&4294967295,d=s,s=t,t=$(a,30),a=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$Pi=u}),define(ke[39],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(F||(F={})),function(f){const R="error",L="warning",b="warn",y="info",g="ignore";function A($){return $?I.$6e(R,$)?f.Error:I.$6e(L,$)||I.$6e(b,$)?f.Warning:I.$6e(y,$)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function P($){switch($){case f.Error:return R;case f.Warning:return L;case f.Info:return y;default:return g}}f.toString=P}(F||(F={})),e.default=F}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class f{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const D=S.charCodeAt(0),w=this.b.charCodeAt(this.c);return D-w}value(){return this.b[this.c]}}e.$Xh=f;class R{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,F.$Ze)(S,this.b,0,S.length,this.c,this.d):(0,F.$2e)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=R;class L{constructor(S=!0,D=!0){this.f=S,this.g=D}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let D=S.length-1;D>=0;D--,this.c--){const w=this.b.charCodeAt(D);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,F.$Ze)(S,this.b,0,S.length,this.d,this.e):(0,F.$2e)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=L;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class y{constructor(S,D){this.f=S,this.g=D,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,F.$1e)(S,this.c.scheme);if(this.d[this.e]===2)return(0,F.$1e)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,F.$Ye)(S,this.c.query);if(this.d[this.e]===5)return(0,F.$Ye)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=y;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class P{static forUris(S=()=>!1,D=()=>!1){return new P(new y(S,D))}static forPaths(S=!1){return new P(new L(void 0,!S))}static forStrings(){return new P(new f)}static forConfigKeys(){return new P(new R)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,D){if(D){const w=D.slice(0);(0,I.$Wb)(w);for(const u of w)this.set(u,S)}else{const w=S.slice(0);(0,I.$Wb)(w);for(const u of w)this.set(u[0],u[1])}}set(S,D){const w=this.b.reset(S);let u;this.c||(this.c=new g,this.c.segment=w.value());const o=[];for(u=this.c;;){const n=w.cmp(u.segment);if(n>0)u.left||(u.left=new g,u.left.segment=w.value()),o.push([-1,u]),u=u.left;else if(n<0)u.right||(u.right=new g,u.right.segment=w.value()),o.push([1,u]),u=u.right;else if(w.hasNext())w.next(),u.mid||(u.mid=new g,u.mid.segment=w.value()),o.push([0,u]),u=u.mid;else break}const i=u.value;u.value=D,u.key=S;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],s=o[n+1][0];if(t===1&&s===1)o[n][1]=r.rotateLeft();else if(t===-1&&s===-1)o[n][1]=r.rotateRight();else if(t===1&&s===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&s===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(S){return this.d(S)?.value}d(S){const D=this.b.reset(S);let w=this.c;for(;w;){const u=D.cmp(w.segment);if(u>0)w=w.left;else if(u<0)w=w.right;else if(D.hasNext())D.next(),w=w.mid;else break}return w}has(S){const D=this.d(S);return!(D?.value===void 0&&D?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,D){const w=this.b.reset(S),u=[];let o=this.c;for(;o;){const i=w.cmp(o.segment);if(i>0)u.push([-1,o]),o=o.left;else if(i<0)u.push([1,o]),o=o.right;else if(w.hasNext())w.next(),u.push([0,o]),o=o.mid;else break}if(o){if(D?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(u.length>0){const[n,r]=u[u.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=u.length-1;i>=0;i--){const n=u[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),u[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),u[i][1]=n.rotateRight()),i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const D=this.b.reset(S);let w=this.c,u;for(;w;){const o=D.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(D.hasNext())D.next(),u=w.value||u,w=w.mid;else break}return w&&w.value||u}findSuperstr(S){return this.g(S,!1)}g(S,D){const w=this.b.reset(S);let u=this.c;for(;u;){const o=w.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(w.hasNext())w.next(),u=u.mid;else return u.mid?this.h(u.mid):D?u.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[D,w]of this)S(w,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const D=[];return this.j(S,D),D[Symbol.iterator]()}j(S,D){S&&(S.left&&this.j(S.left,D),S.value&&D.push([S.key,S.value]),S.mid&&this.j(S.mid,D),S.right&&this.j(S.right,D))}_isBalanced(){const S=D=>{if(!D)return!0;const w=D.balanceFactor();return w<-1||w>1?!1:S(D.left)&&S(D.right)};return S(this.c)}}e.$2h=P}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function I(a){return typeof a=="string"}e.$Cf=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Df=F;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=f;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=R;function L(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=L;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=b;function y(a){return a===!0||a===!1}e.$If=y;function g(a){return typeof a>"u"}e.$Jf=g;function A(a){return!P(a)}e.$Kf=A;function P(a){return g(a)||a===null}e.$Lf=P;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=$;function S(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=S;function D(...a){const t=[];for(let s=0;s<a.length;s++){const d=a[s];if(P(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}e.$Of=D;const w=Object.prototype.hasOwnProperty;function u(a){if(!f(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Pf=u;function o(a){return typeof a=="function"}e.$Qf=o;function i(...a){return a.length>0&&a.every(o)}e.$Rf=i;function n(a,t){const s=Math.min(a.length,t.length);for(let d=0;d<s;d++)r(a[d],t[d])}e.$Sf=n;function r(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=r}),define(ke[78],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=void 0;const F=Object.create(null);function f(b,y){if((0,I.$Cf)(y)){const g=F[y];if(g===void 0)throw new Error(`${b} references an unknown codicon: ${y}`);y=g}return F[b]=y,{id:b}}function R(){return F}e.$Yj=R;function L(){return Object.values(e.$1j)}e.$Zj=L,e.$1j={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function F(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?F(r):r}),i}e.$an=F;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(R.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Ff)(a)&&i.push(a)}}return o}e.$bn=f;const R=Object.prototype.hasOwnProperty;function L(o,i){return b(o,i,new Set)}e.$cn=L;function b(o,i,n){if((0,I.$Lf)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(b(t,i,n));return a}if((0,I.$Ef)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)R.call(o,t)&&(a[t]=b(o[t],i,n));return n.delete(o),a}return o}function y(o,i,n=!0){return(0,I.$Ef)(o)?((0,I.$Ef)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,I.$Ef)(o[r])&&(0,I.$Ef)(i[r])?y(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$dn=y;function g(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!g(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!g(a,t))return!1;for(n=0;n<a.length;n++)if(!g(o[a[n]],i[a[n]]))return!1}return!0}e.$en=g;function A(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,I.$Ef)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$fn=A;function P(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],s=i[a];g(t,s)||(n[a]=s)}),n}e.$gn=P;function $(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.$hn=$;function S(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.$in=S;function D(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$jn=D;function w(o){const i=[];for(const n of D(o))typeof o[n]=="function"&&i.push(n);return i}e.$kn=w;function u(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.$ln=u}),define(ke[61],Se([1,0,78]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var F;(function(L){function b(y){return y&&typeof y=="object"&&typeof y.id=="string"}L.isThemeColor=b})(F||(e.ThemeColor=F={}));function f(L){return{id:L}}e.$2j=f;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function y(i){const n=b.exec(i.id);if(!n)return y(I.$1j.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}L.asClassNameArray=y;function g(i){return y(i).join(" ")}L.asClassName=g;function A(i){return"."+y(i).join(".")}L.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}L.isThemeIcon=P;const $=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function S(i){const n=$.exec(i);if(!n)return;const[,r]=n;return{id:r}}L.fromString=S;function D(i){return{id:i}}L.fromId=D;function w(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}L.modify=w;function u(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=u;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const R="$(",L=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function y(o){return o.replace(b,(i,n)=>n?i:`\\${i}`)}e.$3j=y;const g=new RegExp(`\\\\${L.source}`,"g");function A(o){return o.replace(g,i=>`\\${i}`)}e.$4j=A;const P=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(P,(i,n,r,a)=>r?i:n||a||"")}e.$5j=$;function S(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$6j=S;const D=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){D.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=D.lastIndex,t=D.exec(o),s=o.substring(a,t?.index);if(s.length>0){i+=s;for(let d=0;d<s.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$7j=w;function u(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$Pj)(o,r,n);const t=(0,F.$Ne)(r," "),s=r.length-t.length,d=(0,I.$Pj)(o,t,n);if(d)for(const c of d){const l=a[c.start+s]+s;c.start+=l,c.end+=l}return d}e.$8j=u}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var I;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(R){return R<0?0:R>255?255:R|0}e.$De=F;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Ee=f}),define(ke[32],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(f){return I.test(f)}e.$hg=F,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(b){for(let y=0;y<b.length;y++)b[y]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,g="";return g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g}}()}),define(ke[165],Se([1,0,19,51,32]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.$6s=void 0;function R(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$6s=R;function L(P,$,S){const D={id:(0,f.$ig)(),name:P,uri:$,data:S};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$7s=L;class b{constructor(){this.a=new Map}get size(){let $=0;for(const S of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const S=[...this.a.keys()];return F.Iterable.some(this,([D,w])=>w.asFile())&&S.push("files"),A(y($),S)}get($){return this.a.get(this.b($))?.[0]}append($,S){const D=this.a.get($);D?D.push(S):this.a.set(this.b($),[S])}replace($,S){this.a.set(this.b($),[S])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,S]of this.a)for(const D of S)yield[$,D]}b($){return y($)}}e.$8s=b;function y(P){return P.toLowerCase()}function g(P,$){return A(y(P),$.map(y))}e.$9s=g;function A(P,$){if(P==="*/*")return $.length>0;if($.includes(P))return!0;const S=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[D,w,u]=S;return u==="*"?$.some(o=>o.startsWith(w+"/")):!1}e.$0s=Object.freeze({create:P=>(0,I.$Lb)(P.map($=>$.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$0s.split(P).filter($=>!$.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function F(b,y,g,A=1){let P=!1;return new Promise($=>{const S=setTimeout(()=>{if(!P)return P=!0,$(0)},g);f(b,y,A,D=>{if(!P)return P=!0,clearTimeout(S),$(D)})})}e.$kg=F;function f(b,y,g,A){if(y===0)return A(0);const P=new I.Socket;P.once("connect",()=>(L(P),f(b+g,y-1,g,A))),P.once("data",()=>{}),P.once("error",$=>(L(P),$.code!=="ECONNREFUSED"?f(b+g,y-1,g,A):A(b))),P.connect(b,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,y,g,A="127.0.0.1"){let P=!1,$,S=1;const D=I.createServer({pauseOnConnect:!0});function w(u,o){P||(P=!0,D.removeAllListeners(),D.close(),$&&clearTimeout($),o(u))}return new Promise(u=>{$=setTimeout(()=>{w(0,u)},g),D.on("listening",()=>{w(b,u)}),D.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<y?(b++,S++,D.listen(b,A)):w(0,u)}),D.on("close",()=>{w(0,u)}),D.listen(b,A)})}e.$mg=R;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(y){console.error(y)}}}),define(ke[126],Se([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=void 0;class F{constructor(b){const y=(0,I.$De)(b);this.c=y,this.a=F.d(y),this.b=new Map}static d(b){const y=new Uint8Array(256);return y.fill(b),y}set(b,y){const g=(0,I.$De)(y);b>=0&&b<256?this.a[b]=g:this.b.set(b,g)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Xs=F;var f;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new F(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Ys=R}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.StringEOL=void 0;var I;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(f){let R=0,L=0,b=0,y=0;for(let g=0,A=f.length;g<A;g++){const P=f.charCodeAt(g);P===13?(R===0&&(L=g),R++,g+1<A&&f.charCodeAt(g+1)===10?(y|=2,g++):y|=3,b=g+1):P===10&&(y|=1,R===0&&(L=g),R++,b=g+1)}return R===0&&(L=f.length),[R,L,f.length-b,y]}e.$at=F}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class I{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new I(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return I.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return I.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return I.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const L=f.lineNumber|0,b=R.lineNumber|0;if(L===b){const y=f.column|0,g=R.column|0;return y-g}return L-b}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new I(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$zs=I}),define(ke[29],Se([1,0,53]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class F{constructor(R,L,b,y){R>b||R===b&&L>y?(this.startLineNumber=b,this.startColumn=y,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=b,this.endColumn=y)}isEmpty(){return F.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return F.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return F.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return F.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return F.plusRange(this,R)}static plusRange(R,L){let b,y,g,A;return L.startLineNumber<R.startLineNumber?(b=L.startLineNumber,y=L.startColumn):L.startLineNumber===R.startLineNumber?(b=L.startLineNumber,y=Math.min(L.startColumn,R.startColumn)):(b=R.startLineNumber,y=R.startColumn),L.endLineNumber>R.endLineNumber?(g=L.endLineNumber,A=L.endColumn):L.endLineNumber===R.endLineNumber?(g=L.endLineNumber,A=Math.max(L.endColumn,R.endColumn)):(g=R.endLineNumber,A=R.endColumn),new F(b,y,g,A)}intersectRanges(R){return F.intersectRanges(this,R)}static intersectRanges(R,L){let b=R.startLineNumber,y=R.startColumn,g=R.endLineNumber,A=R.endColumn;const P=L.startLineNumber,$=L.startColumn,S=L.endLineNumber,D=L.endColumn;return b<P?(b=P,y=$):b===P&&(y=Math.max(y,$)),g>S?(g=S,A=D):g===S&&(A=Math.min(A,D)),b>g||b===g&&y>A?null:new F(b,y,g,A)}equalsRange(R){return F.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(R){return new I.$zs(R.endLineNumber,R.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(R){return new I.$zs(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new F(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new F(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(R){return new F(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(R){return new F(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new F(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new F(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new F(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const g=R.startLineNumber|0,A=L.startLineNumber|0;if(g===A){const P=R.startColumn|0,$=L.startColumn|0;if(P===$){const S=R.endLineNumber|0,D=L.endLineNumber|0;if(S===D){const w=R.endColumn|0,u=L.endColumn|0;return w-u}return S-D}return P-$}return g-A}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$As=F}),define(ke[168],Se([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0;class F{static insert(R,L){return{range:new I.$As(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$Bs=F}),define(ke[169],Se([1,0,53,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.SelectionDirection=void 0;var f;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends F.$As{constructor(b,y,g,A){super(b,y,g,A),this.selectionStartLineNumber=b,this.selectionStartColumn=y,this.positionLineNumber=g,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,y){return b.selectionStartLineNumber===y.selectionStartLineNumber&&b.selectionStartColumn===y.selectionStartColumn&&b.positionLineNumber===y.positionLineNumber&&b.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,y):new R(b,y,this.startLineNumber,this.startColumn)}getPosition(){return new I.$zs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$zs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,y){return this.getDirection()===0?new R(b,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,y)}static fromPositions(b,y=b){return new R(b.lineNumber,b.column,y.lineNumber,y.column)}static fromRange(b,y){return y===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,y){if(b&&!y||!b&&y)return!1;if(!b&&!y)return!0;if(b.length!==y.length)return!1;for(let g=0,A=b.length;g<A;g++)if(!this.selectionsEqual(b[g],y[g]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,y,g,A,P){return P===0?new R(b,y,g,A):new R(g,A,b,y)}}e.$Cs=R}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0,e.$0r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.WordCharacterClass=void 0;var F;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class f extends I.$Xs{constructor(b){super(0);for(let y=0,g=b.length;y<g;y++)this.set(b.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.$Zs=f;function R(L){const b={};return y=>(b.hasOwnProperty(y)||(b[y]=L(y)),b[y])}e.$1s=R(L=>new f(L))}),define(ke[127],Se([1,0,51,3,75]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.$as=e.$_r=e.$$r=void 0,e.$$r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$$r)P.indexOf(S)>=0||($+="\\"+S);return $+="\\s]+)",new RegExp($,"g")}e.$_r=R();function L(P){let $=e.$_r;if(P&&P instanceof RegExp)if(P.global)$=P;else{let S="g";P.ignoreCase&&(S+="i"),P.multiline&&(S+="m"),P.unicode&&(S+="u"),$=new RegExp(P.source,S)}return $.lastIndex=0,$}e.$as=L;const b=new f.$2c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const $=b.unshift(P);return(0,F.$Pc)($)}e.$bs=y;function g(P,$,S,D,w){if(w||(w=I.Iterable.first(b)),S.length>w.maxLen){let r=P-w.maxLen/2;return r<0?r=0:D+=r,S=S.substring(r,P+w.maxLen/2),g(P,$,S,D,w)}const u=Date.now(),o=P-1-D;let i=-1,n=null;for(let r=1;!(Date.now()-u>=w.timeBudget);r++){const a=o-w.windowSize*r;$.lastIndex=Math.max(0,a);const t=A($,S,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:D+1+n.index,endColumn:D+1+n.index+n[0].length};return $.lastIndex=0,r}return null}e.$cs=g;function A(P,$,S,D){let w;for(;w=P.exec($);){const u=w.index||0;if(u<=S&&P.lastIndex>=S)return w;if(D>0&&u>D)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.IndentAction=void 0;var I;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let y=0,g=b.notIn.length;y<g;y++)switch(b.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,y){if(b.getTokenCount()===0)return!0;const g=b.findTokenIndexAtOffset(y-2),A=b.getStandardTokenType(g);return this.isOK(A)}g(b,y){for(let g=b;g<=y;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$wt=F;class f{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of b)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.$xt=f;function R(L,b,y){L.has(b)?L.get(b).push(y):L.set(b,[y])}}),define(ke[173],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HZ=e.$GZ=e.$FZ=e.State=void 0;var F;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class f{constructor(D,w,u){const o=new Uint8Array(D*w);for(let i=0,n=D*w;i<n;i++)o[i]=u;this.a=o,this.rows=D,this.cols=w}get(D,w){return this.a[D*this.cols+w]}set(D,w,u){this.a[D*this.cols+w]=u}}class R{constructor(D){let w=0,u=0;for(let i=0,n=D.length;i<n;i++){const[r,a,t]=D[i];a>w&&(w=a),r>u&&(u=r),t>u&&(u=t)}w++,u++;const o=new f(u,w,0);for(let i=0,n=D.length;i<n;i++){const[r,a,t]=D[i];o.set(r,a,t)}this.a=o,this.b=w}nextState(D,w){return w<0||w>=this.b?0:this.a.get(D,w)}}e.$FZ=R;let L=null;function b(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var y;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let g=null;function A(){if(g===null){g=new I.$Xs(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<S.length;w++)g.set(S.charCodeAt(w),1);const D=".,;:";for(let w=0;w<D.length;w++)g.set(D.charCodeAt(w),2)}return g}class P{static a(D,w,u,o,i){let n=i-1;do{const r=w.charCodeAt(n);if(D.get(r)!==2)break;n--}while(n>o);if(o>0){const r=w.charCodeAt(o-1),a=w.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:u,startColumn:o+1,endLineNumber:u,endColumn:n+2},url:w.substring(o,n+1)}}static computeLinks(D,w=b()){const u=A(),o=[];for(let i=1,n=D.getLineCount();i<=n;i++){const r=D.getLineContent(i),a=r.length;let t=0,s=0,d=0,c=1,l=!1,h=!1,k=!1,C=!1;for(;t<a;){let m=!1;const p=r.charCodeAt(t);if(c===13){let v;switch(p){case 40:l=!0,v=0;break;case 41:v=l?0:1;break;case 91:k=!0,h=!0,v=0;break;case 93:k=!1,v=h?0:1;break;case 123:C=!0,v=0;break;case 125:v=C?0:1;break;case 39:case 34:case 96:d===p?v=1:d===39||d===34||d===96?v=0:v=1;break;case 42:v=d===42?1:0;break;case 124:v=d===124?1:0;break;case 32:v=k?0:1;break;default:v=u.get(p)}v===1&&(o.push(P.a(u,r,i,s,t)),m=!0)}else if(c===12){let v;p===91?(h=!0,v=0):v=u.get(p),v===1?m=!0:c=13}else c=w.nextState(c,p),c===0&&(m=!0);m&&(c=1,l=!1,h=!1,C=!1,s=t+1,d=p),t++}c===13&&o.push(P.a(u,r,i,s,a))}return o}}e.$GZ=P;function $(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:P.computeLinks(S)}e.$HZ=$}),define(ke[79],Se([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.ModelConstants=e.PositionAffinity=e.$Su=e.TrackedRangeStickiness=e.$Ru=e.$Qu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var f;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var y;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var g;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$en)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Qu=A;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Ru=P;var $;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function S(r){return r&&typeof r.read=="function"}e.$Su=S;var D;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var w;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class u{constructor(a,t,s,d,c,l){this.identifier=a,this.range=t,this.text=s,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=c,this._isTracked=l}}e.$Tu=u;class o{constructor(a,t,s){this.regex=a,this.wordSeparators=t,this.simpleSearch=s}}e.$Uu=o;class i{constructor(a,t,s){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.$Vu=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$Wu=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class I{constructor(u,o){this.piece=u,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return f(this.right);let u=this;for(;u.parent!==e.$sB&&u.parent.left!==u;)u=u.parent;return u.parent===e.$sB?e.$sB:u.parent}prev(){if(this.left!==e.$sB)return R(this.left);let u=this;for(;u.parent!==e.$sB&&u.parent.right!==u;)u=u.parent;return u.parent===e.$sB?e.$sB:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=I;var F;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$sB=new I(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function f(w){for(;w.left!==e.$sB;)w=w.left;return w}e.$tB=f;function R(w){for(;w.right!==e.$sB;)w=w.right;return w}e.$uB=R;function L(w){return w===e.$sB?0:w.size_left+w.piece.length+L(w.right)}function b(w){return w===e.$sB?0:w.lf_left+w.piece.lineFeedCnt+b(w.right)}function y(){e.$sB.parent=e.$sB}function g(w,u){const o=u.right;o.size_left+=u.size_left+(u.piece?u.piece.length:0),o.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=o.left,o.left!==e.$sB&&(o.left.parent=u),o.parent=u.parent,u.parent===e.$sB?w.root=o:u.parent.left===u?u.parent.left=o:u.parent.right=o,o.left=u,u.parent=o}e.$vB=g;function A(w,u){const o=u.left;u.left=o.right,o.right!==e.$sB&&(o.right.parent=u),o.parent=u.parent,u.size_left-=o.size_left+(o.piece?o.piece.length:0),u.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),u.parent===e.$sB?w.root=o:u===u.parent.right?u.parent.right=o:u.parent.left=o,o.right=u,u.parent=o}e.$wB=A;function P(w,u){let o,i;if(u.left===e.$sB?(i=u,o=i.right):u.right===e.$sB?(i=u,o=i.left):(i=f(u.right),o=i.right),i===w.root){w.root=o,o.color=0,u.detach(),y(),w.root.parent=e.$sB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===u?(o.parent=i.parent,D(w,o)):(i.parent===u?o.parent=i:o.parent=i.parent,D(w,o),i.left=u.left,i.right=u.right,i.parent=u.parent,i.color=u.color,u===w.root?w.root=i:u===u.parent.left?u.parent.left=i:u.parent.right=i,i.left!==e.$sB&&(i.left.parent=i),i.right!==e.$sB&&(i.right.parent=i),i.size_left=u.size_left,i.lf_left=u.lf_left,D(w,i)),u.detach(),o.parent.left===o){const a=L(o),t=b(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const s=a-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,S(w,o.parent,s,d)}}if(D(w,o.parent),n){y();return}let r;for(;o!==w.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,g(w,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(w,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,g(w,o.parent),o=w.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(w,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,g(w,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(w,o.parent),o=w.root));o.color=0,y()}e.$xB=P;function $(w,u){for(D(w,u);u!==w.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const o=u.parent.parent.right;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,g(w,u)),u.parent.color=0,u.parent.parent.color=1,A(w,u.parent.parent))}else{const o=u.parent.parent.left;o.color===1?(u.parent.color=0,o.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,A(w,u)),u.parent.color=0,u.parent.parent.color=1,g(w,u.parent.parent))}w.root.color=0}e.$yB=$;function S(w,u,o,i){for(;u!==w.root&&u!==e.$sB;)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}e.$zB=S;function D(w,u){let o=0,i=0;if(u!==w.root){for(;u!==w.root&&u===u.parent.right;)u=u.parent;if(u!==w.root)for(u=u.parent,o=L(u.left)-u.size_left,i=b(u.left)-u.lf_left,u.size_left+=o,u.lf_left+=i;u!==w.root&&(o!==0||i!==0);)u.parent.left===u&&(u.parent.size_left+=o,u.parent.lf_left+=i),u=u.parent}}e.$AB=D}),define(ke[175],Se([1,0,19,125]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=e.$1u=e.$Zu=void 0;class f{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,g){y=(0,F.$Ee)(y);const A=this.a,P=this.b,$=g.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y),y+$),this.a.set(g,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,g){return y=(0,F.$Ee)(y),g=(0,F.$Ee)(g),this.a[y]===g?!1:(this.a[y]=g,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,g){y=(0,F.$Ee)(y),g=(0,F.$Ee)(g);const A=this.a,P=this.b;if(y>=A.length)return!1;const $=A.length-y;return g>=$&&(g=$),g===0?!1:(this.a=new Uint32Array(A.length-g),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y+g),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,F.$Ee)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),y>=this.a.length&&(y=this.a.length-1);for(let A=g;A<=y;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let g=0,A=this.a.length-1,P=0,$=0,S=0;for(;g<=A;)if(P=g+(A-g)/2|0,$=this.b[P],S=$-this.a[P],y<S)A=P-1;else if(y>=$)g=P+1;else break;return new L(P,y-S)}}e.$Zu=f;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const g=this.e[y],A=g>0?this.d[g-1]:0;return new L(g,y-A)}removeValues(y,g){this.a.splice(y,g),this.f(y)}insertValues(y,g){this.a=(0,I.$Vb)(this.a,y,g),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,g=this.a.length;y<g;y++){const A=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+A;for(let $=0;$<A;$++)this.e[P+$]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,g){this.a[y]!==g&&(this.a[y]=g,this.f(y))}}e.$1u=R;class L{constructor(y,g){this.index=y,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=g}}e.$2u=L}),define(ke[176],Se([1,0,13,53,175]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3u=void 0;class R{constructor(b,y,g,A){this.d=b,this.f=y,this.g=g,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const y=b.changes;for(const g of y)this.o(g.range),this.p(new F.$zs(g.range.startLineNumber,g.range.startColumn),g.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,y=this.f.length,g=new Uint32Array(y);for(let A=0;A<y;A++)g[A]=this.f[A].length+b;this.j=new f.$Zu(g)}}n(b,y){this.f[b]=y,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,y){if(y.length===0)return;const g=(0,I.$Te)(y);if(g.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]+this.f[b.lineNumber-1].substring(b.column-1));return}g[g.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]);const A=new Uint32Array(g.length-1);for(let P=1;P<g.length;P++)this.f.splice(b.lineNumber+P-1,0,g[P]),A[P-1]=g[P].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$3u=R}),define(ke[99],Se([1,0,13,171,53,29,79]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=void 0;const b=999;class y{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=g(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new L.$Uu(n,this.wordSeparators?(0,F.$1s)(this.wordSeparators):null,r?this.searchString:null)}}e.$BB=y;function g(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$CB=g;function A(o,i,n){if(!n)return new L.$Ru(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new L.$Ru(o,r)}e.$DB=A;class P{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class ${static findMatches(i,n,r,a,t){const s=n.parseSearchRequest();return s?s.regex.multiline?this.b(i,r,new u(s.wordSeparators,s.regex),a,t):this.c(i,r,s,a,t):[]}static a(i,n,r,a,t,s){let d,c=0;a?(c=a.findLineFeedCountBeforeOffset(t),d=n+t+c):d=n+t;let l;if(a){const m=a.findLineFeedCountBeforeOffset(t+s.length)-c;l=d+s.length+m}else l=d+s.length;const h=i.getPositionAt(d),k=i.getPositionAt(l);return new R.$As(h.lineNumber,h.column,k.lineNumber,k.column)}static b(i,n,r,a,t){const s=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),c=i.getEOL()===`\r
`?new P(d):null,l=[];let h=0,k;for(r.reset(0);k=r.next(d);)if(l[h++]=A(this.a(i,s,d,c,k.index,k[0]),k,a),h>=t)return l;return l}static c(i,n,r,a,t){const s=[];let d=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,l,n.startLineNumber,n.startColumn-1,d,s,a,t),s}const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,c,n.startLineNumber,n.startColumn-1,d,s,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&d<t;l++)d=this.d(r,i.getLineContent(l),l,0,d,s,a,t);if(d<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,l,n.endLineNumber,0,d,s,a,t)}return s}static d(i,n,r,a,t,s,d,c){const l=i.wordSeparators;if(!d&&i.simpleSearch){const C=i.simpleSearch,m=C.length,p=n.length;let v=-m;for(;(v=n.indexOf(C,v+m))!==-1;)if((!l||w(l,n,p,v,m))&&(s[t++]=new L.$Ru(new R.$As(r,v+1+a,r,v+1+m+a),null),t>=c))return t;return t}const h=new u(i.wordSeparators,i.regex);let k;h.reset(0);do if(k=h.next(n),k&&(s[t++]=A(new R.$As(r,k.index+1+a,r,k.index+1+k[0].length+a),k,d),t>=c))return t;while(k);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,s,a):this.f(i,r,s,a)}static e(i,n,r,a){const t=new f.$zs(n.lineNumber,1),s=i.getOffsetAt(t),d=i.getLineCount(),c=i.getValueInRange(new R.$As(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),l=i.getEOL()===`\r
`?new P(c):null;r.reset(n.column-1);const h=r.next(c);return h?A(this.a(i,s,c,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new f.$zs(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s),c=this.g(r,d,s,n.column,a);if(c)return c;for(let l=1;l<=t;l++){const h=(s+l-1)%t,k=i.getLineContent(h+1),C=this.g(r,k,h+1,1,a);if(C)return C}return null}static g(i,n,r,a,t){i.reset(a-1);const s=i.next(n);return s?A(new R.$As(r,s.index+1,r,s.index+1+s[0].length),s,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new u(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,s,a):this.j(i,r,s,a)}static h(i,n,r,a){const t=this.b(i,new R.$As(1,1,n.lineNumber,n.column),r,a,10*b);if(t.length>0)return t[t.length-1];const s=i.getLineCount();return n.lineNumber!==s||n.column!==i.getLineMaxColumn(s)?this.h(i,new f.$zs(s,i.getLineMaxColumn(s)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s).substring(0,n.column-1),c=this.k(r,d,s,a);if(c)return c;for(let l=1;l<=t;l++){const h=(t+s-l-1)%t,k=i.getLineContent(h+1),C=this.k(r,k,h+1,a);if(C)return C}return null}static k(i,n,r,a){let t=null,s;for(i.reset(0);s=i.next(n);)t=A(new R.$As(r,s.index+1,r,s.index+1+s[0].length),s,a);return t}}e.$EB=$;function S(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r);if(o.get(s)!==0)return!0}return!1}function D(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r+a-1);if(o.get(s)!==0)return!0}return!1}function w(o,i,n,r,a){return S(o,i,n,r,a)&&D(o,i,n,r,a)}e.$FB=w;class u{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){I.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$GB=u}),define(ke[128],Se([1,0,53,29,79,174,99]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const b=65535;function y(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class g{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function A(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const s=o.charCodeAt(a);s===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:s===10&&(n[r++]=a+1)}return i?y(n):n}e.$HB=A;function P(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,s=!0;for(let c=0,l=i.length;c<l;c++){const h=i.charCodeAt(c);h===13?c+1<l&&i.charCodeAt(c+1)===10?(t++,o[n++]=c+2,c++):(r++,o[n++]=c+1):h===10?(a++,o[n++]=c+1):s&&h!==9&&(h<32||h>126)&&(s=!1)}const d=new g(y(o),r,a,t,s);return o.length=0,d}e.$IB=P;class ${constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$JB=$;class S{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$KB=S;class D{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$sB&&i.iterate(i.root,r=>(r!==R.$sB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class u{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=R.$sB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,s=i.length;t<s;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new $(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,r=n-Math.floor(n/3),a=r*2;let t="",s=0;const d=[];if(this.iterate(this.root,c=>{const l=this.R(c),h=l.length;if(s<=r||s+h<a)return t+=l,s+=h,!0;const k=t.replace(/\r\n|\r|\n/g,i);return d.push(new S(k,A(k))),t=l,s=h,!0}),s>0){const c=t.replace(/\r\n|\r|\n/g,i);d.push(new S(c,A(c)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new D(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===R.$sB)return!0;const t=this.R(a),s=t.length,d=i.G(n),c=i.G(n+s),l=i.getValueInRange2(d,c);return n+=s,t===l})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==R.$sB;)if(a.left!==R.$sB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==R.$sB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const s=this.getOffsetAt(r+1,1),d=a-s;return new I.$zs(r+1,d+1)}return new I.$zs(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$sB){const t=this.getOffsetAt(r+1,1),s=a-i-t;return new I.$zs(r+1,s+1)}else n=n.right;return new I.$zs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,c=this.a[d.piece.bufferIndex].buffer,l=this.u(d.piece.bufferIndex,d.piece.start);return c.substring(l+i.remainder,l+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let s=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==R.$sB;){const d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){s+=d.substring(c,c+n.remainder);break}else s+=d.substr(c,r.piece.length);r=r.next()}return s}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===R.$sB)return!0;const s=t.piece;let d=s.length;if(d===0)return!0;const c=this.a[s.bufferIndex].buffer,l=this.a[s.bufferIndex].lineStarts,h=s.start.line,k=s.end.line;let C=l[h]+s.start.column;if(a&&(c.charCodeAt(C)===10&&(C++,d--),i[n++]=r,r="",a=!1,d===0))return!0;if(h===k)return!this.f&&c.charCodeAt(C+d-1)===13?(a=!0,r+=c.substr(C,d-1)):r+=c.substr(C,d),!0;r+=this.f?c.substring(C,Math.max(C,l[h+1]-this.e)):c.substring(C,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let m=h+1;m<k;m++)r=this.f?c.substring(l[m],l[m+1]-this.e):c.substring(l[m],l[m+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&c.charCodeAt(l[k]+s.end.column-1)===13?(a=!0,s.end.column===0?n--:r=c.substr(l[k],s.end.column-1)):r=c.substr(l[k],s.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,s,d,c,l,h,k){const C=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),v=this.u(i.piece.bufferIndex,s);let E;const N={line:0,column:0};let z,M;n._wordSeparators?(z=C.buffer.substring(p,v),M=T=>T+p,n.reset(0)):(z=C.buffer,M=T=>T,n.reset(p));do if(E=n.next(z),E){if(M(E.index)>=v)return h;this.s(i,M(E.index)-m,N);const T=this.t(i.piece.bufferIndex,t,N),j=N.line===t.line?N.column-t.column+a:N.column+1,O=j+E[0].length;if(k[h++]=(0,L.$DB)(new F.$As(r+T,j,r+T,O),E,c),M(E.index)+E[0].length>=v||h>=l)return h}while(E);return h}findMatchesLineByLine(i,n,r,a){const t=[];let s=0;const d=new L.$GB(n.wordSeparators,n.regex);let c=this.H(i.startLineNumber,i.startColumn);if(c===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(c.node,c.remainder);const k=this.s(l.node,l.remainder);if(c.node===l.node)return this.findMatchesInNode(c.node,d,i.startLineNumber,i.startColumn,h,k,n,r,a,s,t),t;let C=i.startLineNumber,m=c.node;for(;m!==l.node;){const v=this.t(m.piece.bufferIndex,h,m.piece.end);if(v>=1){const N=this.a[m.piece.bufferIndex].lineStarts,z=this.u(m.piece.bufferIndex,m.piece.start),M=N[h.line+v],T=C===i.startLineNumber?i.startColumn:1;if(s=this.findMatchesInNode(m,d,C,T,h,this.s(m,M-z),n,r,a,s,t),s>=a)return t;C+=v}const E=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(E,i.endColumn-1);return s=this.n(n,d,N,i.endLineNumber,E,s,t,r,a),t}if(s=this.n(n,d,this.getLineContent(C).substr(E),C,E,s,t,r,a),s>=a)return t;C++,c=this.H(C,1),m=c.node,h=this.s(c.node,c.remainder)}if(C===i.endLineNumber){const v=C===i.startLineNumber?i.startColumn-1:0,E=this.getLineContent(C).substring(v,i.endColumn-1);return s=this.n(n,d,E,i.endLineNumber,v,s,t,r,a),t}const p=C===i.startLineNumber?i.startColumn:1;return s=this.findMatchesInNode(l.node,d,C,p,h,k,n,r,a,s,t),t}n(i,n,r,a,t,s,d,c,l){const h=i.wordSeparators;if(!c&&i.simpleSearch){const C=i.simpleSearch,m=C.length,p=r.length;let v=-m;for(;(v=r.indexOf(C,v+m))!==-1;)if((!h||(0,L.$FB)(h,r,p,v,m))&&(d[s++]=new f.$Ru(new F.$As(a,v+1+t,a,v+1+m+t),null),s>=l))return s;return s}let k;n.reset(0);do if(k=n.next(r),k&&(d[s++]=(0,L.$DB)(new F.$As(a,k.index+1+t,a,k.index+1+k[0].length+t),k,c),s>=l))return s;while(k);return s}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$sB){const{node:a,remainder:t,nodeStartOffset:s}=this.G(i),d=a.piece,c=d.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&s+d.length===i&&n.length<b){this.F(a,n),this.y();return}if(s===i)this.o(n,a),this.h.validate(i);else if(s+a.piece.length>i){const h=[];let k=new $(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),this.u(c,d.end)-this.u(c,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const v={line:k.start.line+1,column:0};k=new $(k.bufferIndex,v,k.end,this.t(k.bufferIndex,v,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const v=this.s(a,t-1);this.C(a,v),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const C=this.w(n);k.length>0&&this.S(a,k);let m=a;for(let p=0;p<C.length;p++)m=this.S(m,C[p]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let s=1;s<a.length;s++)t=this.S(t,a[s])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$sB)return;const r=this.G(i),a=this.G(i+n),t=r.node,s=a.node;if(t===s){const C=this.s(t,r.remainder),m=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,R.$xB)(this,t),this.N(p),this.y();return}this.D(t,m),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,C),this.O(t),this.y();return}this.E(t,C,m),this.y();return}const d=[],c=this.s(t,r.remainder);this.C(t,c),this.h.validate(i),t.piece.length===0&&d.push(t);const l=this.s(s,a.remainder);this.D(s,l),s.piece.length===0&&d.push(s);const h=t.next();for(let C=h;C!==R.$sB&&C!==s;C=C.next())d.push(C);const k=t.piece.length===0?t.prev():t;this.v(d),this.O(k),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const s=n.piece,d={line:s.start.line+1,column:0},c=new $(s.bufferIndex,d,s.end,this.t(s.bufferIndex,d,s.end),s.length-1);n.piece=c,i+=`
`,(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let s=a.length-2;s>=0;s--)t=this.T(t,a[s]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let s=1;s<r.length;s++)t=this.S(t,r[s]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,s=this.a[t].lineStarts,c=s[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,k=0,C=0,m=0;for(;l<=h&&(k=l+(h-l)/2|0,m=s[k],k!==h);)if(C=s[k+1],c<m)h=k-1;else if(c>=C)l=k+1;else break;return r?(r.line=k,r.column=c-m,null):{line:k,column:c-m}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],s=a[r.line]+r.column;if(t>s+1)return r.line-n.line;const d=s-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$xB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const C=i.charCodeAt(b-1);let m;C===13||C>=55296&&C<=56319?(m=i.substring(0,b-1),i=i.substring(b-1)):(m=i.substring(0,b),i=i.substring(b));const p=A(m);h.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:m.length-p[p.length-1]},p.length-1,m.length)),this.a.push(new S(m,p))}const k=A(i);return h.push(new $(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new S(i,k)),h}let n=this.a[0].buffer.length;const r=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<r.length;h++)r[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<r.length;h++)r[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[s],c={line:s,column:d},l=new $(0,a,c,this.t(0,a,c),t-n);return this.g=c,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const s=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=d.substring(c+s,c+r.piece.length);else{const l=this.B(r,i-t.nodeStartLineNumber);return d.substring(c+s,c+l-n)}}else{let s=0;const d=i;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const c=this.B(r,i-r.lf_left-2),l=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,k=this.u(r.piece.bufferIndex,r.piece.start);return s+=r.size_left,this.h.set({node:r,nodeStartOffset:s,nodeStartLineNumber:d-(i-1-r.lf_left)}),h.substring(k+c,k+l-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const c=this.B(r,i-r.lf_left-2),l=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);a=l.substring(h+c,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$sB;){const s=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),c=this.u(r.piece.bufferIndex,r.piece.start);return a+=s.substring(c,c+d-n),a}else{const d=this.u(r.piece.bufferIndex,r.piece.start);a+=s.substr(d,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==R.$sB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const s=this.t(i.piece.bufferIndex,r.start,a);if(s!==t)return{index:s,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),s=n,d=this.u(r.bufferIndex,s),c=this.t(r.bufferIndex,r.start,s),l=c-a,h=d-t,k=r.length+h;i.piece=new $(r.bufferIndex,r.start,s,c,k),(0,R.$zB)(this,i,h,l)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),s=n,d=this.t(r.bufferIndex,s,r.end),c=this.u(r.bufferIndex,s),l=d-a,h=t-c,k=r.length+h;i.piece=new $(r.bufferIndex,s,r.end,d,k),(0,R.$zB)(this,i,h,l)}E(i,n,r){const a=i.piece,t=a.start,s=a.end,d=a.length,c=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new $(a.bufferIndex,a.start,l,h,k),(0,R.$zB)(this,i,k-d,h-c);const C=new $(a.bufferIndex,r,s,this.t(a.bufferIndex,r,s),this.u(a.bufferIndex,s)-this.u(a.bufferIndex,r)),m=this.S(i,C);this.N(m)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let m=0;m<t.length;m++)t[m]+=a;if(r){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const s=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[s],c={line:s,column:d},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,c),C=k-h;i.piece=new $(i.piece.bufferIndex,i.piece.start,c,k,l),this.g=c,(0,R.$zB)(this,i,n.length,C)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==R.$sB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),s=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,s),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$sB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),s=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:s}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$sB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$sB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const s=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new $(i.piece.bufferIndex,i.piece.start,t,d,s),(0,R.$zB)(this,i,-1,-1),i.piece.length===0&&r.push(i);const c={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,c,n.piece.end);n.piece=new $(n.piece.bufferIndex,c,n.piece.end,h,l),(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let C=0;C<r.length;C++)(0,R.$xB)(this,r[C])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,R.$xB)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},s=a.length-1,d=this.t(a.bufferIndex,t,a.end);r.piece=new $(a.bufferIndex,t,a.end,d,s),(0,R.$zB)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$sB)return n(R.$sB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$sB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.right===R.$sB)i.right=r,r.parent=i;else{const t=(0,R.$tB)(i.right);t.left=r,r.parent=t}return(0,R.$yB)(this,r),r}T(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.left===R.$sB)i.left=r,r.parent=i;else{const a=(0,R.$uB)(i.left);a.right=r,r.parent=a}return(0,R.$yB)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$LB=u}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8=e.$u8=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$u8=I;class F{constructor(R){this.identifier=R}}e.$v8=F}),define(ke[178],Se([1,0,4,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,y){return this.a.set(b,y),this.handleChange([b]),(0,F.$Pc)(()=>{this.a.get(b)===y&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,y){this.b.get(b)?.dispose();const g=new R(this,b,y);return this.b.set(b,g),(0,F.$Pc)(()=>{const A=this.b.get(b);!A||A!==g||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const y=this.get(b);if(y)return y;const g=this.b.get(b);return!g||g.isResolved?null:(await g.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const g=this.b.get(b);return!!(!g||g.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$_s=f;class R extends F.$Rc{get isResolved(){return this.c}constructor(b,y,g){super(),this.f=b,this.g=y,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class R extends F.$Rc{constructor($,S="",D="",w=!0,u){super(),this.h=this.B(new I.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=S,this.u=D,this.w=w,this.C=u}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,S){this.C&&await this.C($)}}e.$Ai=R;class L extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new I.$Rd),this.onWillRun=this.f.event,this.m=this.B(new I.$Rd),this.onDidRun=this.m.event}async run($,S){if(!$.enabled)return;this.f.fire({action:$});let D;try{await this.u($,S)}catch(w){D=w}this.m.fire({action:$,error:D})}async u($,S){await $.run(S)}}e.$Bi=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let S=[];for(const D of $)D.length&&(S.length?S=[...S,new b,...D]:S=D);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=b;class y{get actions(){return this.a}constructor($,S,D,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=S,this.class=w,this.a=D}async run(){}}e.$Di=y;class g extends R{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,f.localize(0,null),void 0,!1)}}e.$Ei=g;function A(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...$)=>P.run(...$),tooltip:P.label}}e.$Fi=A}),define(ke[181],Se([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const F=60,f=F*60,R=f*24,L=R*7,b=R*30,y=R*365;function g(P,$,S,D){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,g(new Date().getTime()+w*1e3,!1));if(!D&&w<30)return(0,I.localize)(1,null);let u;return w<F?(u=w,$?u===1?S?(0,I.localize)(2,null,u):(0,I.localize)(3,null,u):S?(0,I.localize)(4,null,u):(0,I.localize)(5,null,u):u===1?S?(0,I.localize)(6,null,u):(0,I.localize)(7,null,u):S?(0,I.localize)(8,null,u):(0,I.localize)(9,null,u)):w<f?(u=Math.floor(w/F),$?u===1?S?(0,I.localize)(10,null,u):(0,I.localize)(11,null,u):S?(0,I.localize)(12,null,u):(0,I.localize)(13,null,u):u===1?S?(0,I.localize)(14,null,u):(0,I.localize)(15,null,u):S?(0,I.localize)(16,null,u):(0,I.localize)(17,null,u)):w<R?(u=Math.floor(w/f),$?u===1?S?(0,I.localize)(18,null,u):(0,I.localize)(19,null,u):S?(0,I.localize)(20,null,u):(0,I.localize)(21,null,u):u===1?S?(0,I.localize)(22,null,u):(0,I.localize)(23,null,u):S?(0,I.localize)(24,null,u):(0,I.localize)(25,null,u)):w<L?(u=Math.floor(w/R),$?u===1?(0,I.localize)(26,null,u):(0,I.localize)(27,null,u):u===1?(0,I.localize)(28,null,u):(0,I.localize)(29,null,u)):w<b?(u=Math.floor(w/L),$?u===1?S?(0,I.localize)(30,null,u):(0,I.localize)(31,null,u):S?(0,I.localize)(32,null,u):(0,I.localize)(33,null,u):u===1?S?(0,I.localize)(34,null,u):(0,I.localize)(35,null,u):S?(0,I.localize)(36,null,u):(0,I.localize)(37,null,u)):w<y?(u=Math.floor(w/b),$?u===1?S?(0,I.localize)(38,null,u):(0,I.localize)(39,null,u):S?(0,I.localize)(40,null,u):(0,I.localize)(41,null,u):u===1?S?(0,I.localize)(42,null,u):(0,I.localize)(43,null,u):S?(0,I.localize)(44,null,u):(0,I.localize)(45,null,u)):(u=Math.floor(w/y),$?u===1?S?(0,I.localize)(46,null,u):(0,I.localize)(47,null,u):S?(0,I.localize)(48,null,u):(0,I.localize)(49,null,u):u===1?S?(0,I.localize)(50,null,u):(0,I.localize)(51,null,u):S?(0,I.localize)(52,null,u):(0,I.localize)(53,null,u))}e.$jm=g;function A(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=A}),define(ke[183],Se([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function R(P,$){return $&&(P.stack||P.stacktrace)?f.localize(0,null,b(P),L(P.stack)||L(P.stacktrace)):b(P)}function L(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?f.localize(1,null,P.message):P.message||f.localize(2,null)}function y(P=null,$=!1){if(!P)return f.localize(3,null);if(Array.isArray(P)){const S=I.$Gb(P),D=y(S[0],$);return S.length>1?f.localize(4,null,D,S.length):D}if(F.$Cf(P))return P;if(P.detail){const S=P.detail;if(S.error)return R(S.error,$);if(S.exception)return R(S.exception,$)}return P.stack?R(P,$):P.message?P.message:f.localize(5,null)}e.$Gi=y;function g(P){const $=P;return $ instanceof Error&&Array.isArray($.actions)}e.$Hi=g;function A(P,$){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=$,S}e.$Ii=A}),define(ke[184],Se([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[12],Se([1,0,184]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,f=!1,R=!1,L=!1,b=!1,y=!1,g=!1,A=!1,P=!1,$=!1,S,D=e.$g,w=e.$g,u,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof navigator=="object"&&!a)o=navigator.userAgent,F=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,y=!0,S=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,D=S,w=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",f=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=r,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,D=e.$g;const m=n.env.VSCODE_NLS_CONFIG;if(m)try{const p=JSON.parse(m),v=p.availableLanguages["*"];S=p.locale,w=p.osLocale,D=v||e.$g,u=p._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=s;let d=0;f?d=1:F?d=3:R&&(d=2),e.$i=F,e.$j=f,e.$k=R,e.$l=L,e.$m=b,e.$n=g,e.$o=y,e.$p=y&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=$,e.$t=P,e.$u=d,e.$v=o,e.$w=D;var c;(function(m){function p(){return e.$w}m.value=p;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=v;function E(){return e.$w==="en"}m.isDefault=E})(c||(e.Language=c={})),e.$x=S,e.$y=w,e.$z=u,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const m=[];i.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let E=0,N=m.length;E<N;E++){const z=m[E];if(z.id===v.data.vscodeScheduleAsyncWork){m.splice(E,1),z.callback();return}}});let p=0;return v=>{const E=++p;m.push({id:E,callback:v}),i.postMessage({vscodeScheduleAsyncWork:E},"*")}}return m=>setTimeout(m)})();var l;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=f||A?2:F?1:3;let h=!0,k=!1;function C(){if(!k){k=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,h=new Uint16Array(m.buffer)[0]===(2<<8)+1}return h}e.$D=C,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const R=f.process;F={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ke[16],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,f=97,R=90,L=122,b=46,y=47,g=92,A=58,P=63;class $ extends Error{constructor(s,d,c){let l;typeof d=="string"&&d.indexOf("not ")===0?(l="must not be",d=d.replace(/^not /,"")):l="must be";const h=s.indexOf(".")!==-1?"property":"argument";let k=`The "${s}" ${h} ${l} of type ${d}`;k+=`. Received type ${typeof c}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,s){if(t===null||typeof t!="object")throw new $(s,"Object",t)}function D(t,s){if(typeof t!="string")throw new $(s,"string",t)}const w=I.$cc==="win32";function u(t){return t===y||t===g}function o(t){return t===y}function i(t){return t>=F&&t<=R||t>=f&&t<=L}function n(t,s,d,c){let l="",h=0,k=-1,C=0,m=0;for(let p=0;p<=t.length;++p){if(p<t.length)m=t.charCodeAt(p);else{if(c(m))break;m=y}if(c(m)){if(!(k===p-1||C===1))if(C===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==b||l.charCodeAt(l.length-2)!==b){if(l.length>2){const v=l.lastIndexOf(d);v===-1?(l="",h=0):(l=l.slice(0,v),h=l.length-1-l.lastIndexOf(d)),k=p,C=0;continue}else if(l.length!==0){l="",h=0,k=p,C=0;continue}}s&&(l+=l.length>0?`${d}..`:"..",h=2)}else l.length>0?l+=`${d}${t.slice(k+1,p)}`:l=t.slice(k+1,p),h=p-k-1;k=p,C=0}else m===b&&C!==-1?++C:C=-1}return l}function r(t,s){S(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${t}${c}`:c}e.$ec={resolve(...t){let s="",d="",c=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],D(h,"path"),h.length===0)continue}else s.length===0?h=I.cwd():(h=I.env[`=${s}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==s.toLowerCase()&&h.charCodeAt(2)===g)&&(h=`${s}\\`));const k=h.length;let C=0,m="",p=!1;const v=h.charCodeAt(0);if(k===1)u(v)&&(C=1,p=!0);else if(u(v))if(p=!0,u(h.charCodeAt(1))){let E=2,N=E;for(;E<k&&!u(h.charCodeAt(E));)E++;if(E<k&&E!==N){const z=h.slice(N,E);for(N=E;E<k&&u(h.charCodeAt(E));)E++;if(E<k&&E!==N){for(N=E;E<k&&!u(h.charCodeAt(E));)E++;(E===k||E!==N)&&(m=`\\\\${z}\\${h.slice(N,E)}`,C=E)}}}else C=1;else i(v)&&h.charCodeAt(1)===A&&(m=h.slice(0,2),C=2,k>2&&u(h.charCodeAt(2))&&(p=!0,C=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(c){if(s.length>0)break}else if(d=`${h.slice(C)}\\${d}`,c=p,p&&s.length>0)break}return d=n(d,!c,"\\",u),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){D(t,"path");const s=t.length;if(s===0)return".";let d=0,c,l=!1;const h=t.charCodeAt(0);if(s===1)return o(h)?"\\":t;if(u(h))if(l=!0,u(t.charCodeAt(1))){let C=2,m=C;for(;C<s&&!u(t.charCodeAt(C));)C++;if(C<s&&C!==m){const p=t.slice(m,C);for(m=C;C<s&&u(t.charCodeAt(C));)C++;if(C<s&&C!==m){for(m=C;C<s&&!u(t.charCodeAt(C));)C++;if(C===s)return`\\\\${p}\\${t.slice(m)}\\`;C!==m&&(c=`\\\\${p}\\${t.slice(m,C)}`,d=C)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),d=2,s>2&&u(t.charCodeAt(2))&&(l=!0,d=3));let k=d<s?n(t.slice(d),!l,"\\",u):"";return k.length===0&&!l&&(k="."),k.length>0&&u(t.charCodeAt(s-1))&&(k+="\\"),c===void 0?l?`\\${k}`:k:l?`${c}\\${k}`:`${c}${k}`},isAbsolute(t){D(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return u(d)||s>2&&i(d)&&t.charCodeAt(1)===A&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let h=0;h<t.length;++h){const k=t[h];D(k,"path"),k.length>0&&(s===void 0?s=d=k:s+=`\\${k}`)}if(s===void 0)return".";let c=!0,l=0;if(typeof d=="string"&&u(d.charCodeAt(0))){++l;const h=d.length;h>1&&u(d.charCodeAt(1))&&(++l,h>2&&(u(d.charCodeAt(2))?++l:c=!1))}if(c){for(;l<s.length&&u(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.$ec.normalize(s)},relative(t,s){if(D(t,"from"),D(s,"to"),t===s)return"";const d=e.$ec.resolve(t),c=e.$ec.resolve(s);if(d===c||(t=d.toLowerCase(),s=c.toLowerCase(),t===s))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===g;)h--;const k=h-l;let C=0;for(;C<s.length&&s.charCodeAt(C)===g;)C++;let m=s.length;for(;m-1>C&&s.charCodeAt(m-1)===g;)m--;const p=m-C,v=k<p?k:p;let E=-1,N=0;for(;N<v;N++){const M=t.charCodeAt(l+N);if(M!==s.charCodeAt(C+N))break;M===g&&(E=N)}if(N!==v){if(E===-1)return c}else{if(p>v){if(s.charCodeAt(C+N)===g)return c.slice(C+N+1);if(N===2)return c.slice(C+N)}k>v&&(t.charCodeAt(l+N)===g?E=N:N===2&&(E=3)),E===-1&&(E=0)}let z="";for(N=l+E+1;N<=h;++N)(N===h||t.charCodeAt(N)===g)&&(z+=z.length===0?"..":"\\..");return C+=E,z.length>0?`${z}${c.slice(C,m)}`:(c.charCodeAt(C)===g&&++C,c.slice(C,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$ec.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const d=s.charCodeAt(2);if(d!==P&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(i(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return t},dirname(t){D(t,"path");const s=t.length;if(s===0)return".";let d=-1,c=0;const l=t.charCodeAt(0);if(s===1)return u(l)?t:".";if(u(l)){if(d=c=1,u(t.charCodeAt(1))){let C=2,m=C;for(;C<s&&!u(t.charCodeAt(C));)C++;if(C<s&&C!==m){for(m=C;C<s&&u(t.charCodeAt(C));)C++;if(C<s&&C!==m){for(m=C;C<s&&!u(t.charCodeAt(C));)C++;if(C===s)return t;C!==m&&(d=c=C+1)}}}}else i(l)&&t.charCodeAt(1)===A&&(d=s>2&&u(t.charCodeAt(2))?3:2,c=d);let h=-1,k=!0;for(let C=s-1;C>=c;--C)if(u(t.charCodeAt(C))){if(!k){h=C;break}}else k=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,s){s!==void 0&&D(s,"ext"),D(t,"path");let d=0,c=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let k=s.length-1,C=-1;for(h=t.length-1;h>=d;--h){const m=t.charCodeAt(h);if(u(m)){if(!l){d=h+1;break}}else C===-1&&(l=!1,C=h+1),k>=0&&(m===s.charCodeAt(k)?--k===-1&&(c=h):(k=-1,c=C))}return d===c?c=C:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=d;--h)if(u(t.charCodeAt(h))){if(!l){d=h+1;break}}else c===-1&&(l=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){D(t,"path");let s=0,d=-1,c=0,l=-1,h=!0,k=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(s=c=2);for(let C=t.length-1;C>=s;--C){const m=t.charCodeAt(C);if(u(m)){if(!h){c=C+1;break}continue}l===-1&&(h=!1,l=C+1),m===b?d===-1?d=C:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||l===-1||k===0||k===1&&d===l-1&&d===c+1?"":t.slice(d,l)},format:r.bind(null,"\\"),parse(t){D(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let c=0,l=t.charCodeAt(0);if(d===1)return u(l)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(u(l)){if(c=1,u(t.charCodeAt(1))){let E=2,N=E;for(;E<d&&!u(t.charCodeAt(E));)E++;if(E<d&&E!==N){for(N=E;E<d&&u(t.charCodeAt(E));)E++;if(E<d&&E!==N){for(N=E;E<d&&!u(t.charCodeAt(E));)E++;E===d?c=E:E!==N&&(c=E+1)}}}}else if(i(l)&&t.charCodeAt(1)===A){if(d<=2)return s.root=s.dir=t,s;if(c=2,u(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;c=3}}c>0&&(s.root=t.slice(0,c));let h=-1,k=c,C=-1,m=!0,p=t.length-1,v=0;for(;p>=c;--p){if(l=t.charCodeAt(p),u(l)){if(!m){k=p+1;break}continue}C===-1&&(m=!1,C=p+1),l===b?h===-1?h=p:v!==1&&(v=1):h!==-1&&(v=-1)}return C!==-1&&(h===-1||v===0||v===1&&h===C-1&&h===k+1?s.base=s.name=t.slice(k,C):(s.name=t.slice(k,h),s.base=t.slice(k,C),s.ext=t.slice(h,C))),k>0&&k!==c?s.dir=t.slice(0,k-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const s=I.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...t){let s="",d=!1;for(let c=t.length-1;c>=-1&&!d;c--){const l=c>=0?t[c]:a();D(l,"path"),l.length!==0&&(s=`${l}/${s}`,d=l.charCodeAt(0)===y)}return s=n(s,!d,"/",o),d?`/${s}`:s.length>0?s:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y,d=t.charCodeAt(t.length-1)===y;return t=n(t,!s,"/",o),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const c=t[d];D(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":e.$fc.normalize(s)},relative(t,s){if(D(t,"from"),D(s,"to"),t===s||(t=e.$fc.resolve(t),s=e.$fc.resolve(s),t===s))return"";const d=1,c=t.length,l=c-d,h=1,k=s.length-h,C=l<k?l:k;let m=-1,p=0;for(;p<C;p++){const E=t.charCodeAt(d+p);if(E!==s.charCodeAt(h+p))break;E===y&&(m=p)}if(p===C)if(k>C){if(s.charCodeAt(h+p)===y)return s.slice(h+p+1);if(p===0)return s.slice(h+p)}else l>C&&(t.charCodeAt(d+p)===y?m=p:p===0&&(m=0));let v="";for(p=d+m+1;p<=c;++p)(p===c||t.charCodeAt(p)===y)&&(v+=v.length===0?"..":"/..");return`${v}${s.slice(h+m)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y;let d=-1,c=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===y){if(!c){d=l;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&D(s,"ext"),D(t,"path");let d=0,c=-1,l=!0,h;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let k=s.length-1,C=-1;for(h=t.length-1;h>=0;--h){const m=t.charCodeAt(h);if(m===y){if(!l){d=h+1;break}}else C===-1&&(l=!1,C=h+1),k>=0&&(m===s.charCodeAt(k)?--k===-1&&(c=h):(k=-1,c=C))}return d===c?c=C:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===y){if(!l){d=h+1;break}}else c===-1&&(l=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){D(t,"path");let s=-1,d=0,c=-1,l=!0,h=0;for(let k=t.length-1;k>=0;--k){const C=t.charCodeAt(k);if(C===y){if(!l){d=k+1;break}continue}c===-1&&(l=!1,c=k+1),C===b?s===-1?s=k:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||c===-1||h===0||h===1&&s===c-1&&s===d+1?"":t.slice(s,c)},format:r.bind(null,"/"),parse(t){D(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===y;let c;d?(s.root="/",c=1):c=0;let l=-1,h=0,k=-1,C=!0,m=t.length-1,p=0;for(;m>=c;--m){const v=t.charCodeAt(m);if(v===y){if(!C){h=m+1;break}continue}k===-1&&(C=!1,k=m+1),v===b?l===-1?l=m:p!==1&&(p=1):l!==-1&&(p=-1)}if(k!==-1){const v=h===0&&d?1:h;l===-1||p===0||p===1&&l===k-1&&l===h+1?s.base=s.name=t.slice(v,k):(s.name=t.slice(v,l),s.base=t.slice(v,k),s.ext=t.slice(l,k))}return h>0?s.dir=t.slice(0,h-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const f=new I.$U(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),R=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(C,m,p=!1){const v=C||"",E=m||"",N=f.value.collator.compare(v,E);return f.value.collatorIsNumeric&&N===0&&v!==E?v<E?-1:1:N}e.$nq=b;function y(C,m){const p=R.value.collator;return C=C||"",m=m||"",r(p,C,m)}e.$oq=y;function g(C,m){const p=R.value.collator;return C=C||"",m=m||"",d(C,m)||r(p,C,m)}e.$pq=g;function A(C,m){const p=R.value.collator;return C=C||"",m=m||"",s(C,m)||r(p,C,m)}e.$qq=A;function P(C,m){return C=C||"",m=m||"",C===m?0:C<m?-1:1}e.$rq=P;function $(C,m){const[p,v]=i(C),[E,N]=i(m);let z=f.value.collator.compare(v,N);if(z===0){if(f.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(z=f.value.collator.compare(p,E),f.value.collatorIsNumeric&&z===0&&p!==E)return p<E?-1:1}return z}e.$sq=$;function S(C,m){C=C||"",m=m||"";const p=n(C),v=n(m),E=R.value.collator,N=L.value.collator;return r(N,p,v)||r(E,C,m)}e.$tq=S;function D(C,m){C=C||"",m=m||"";const p=n(C),v=n(m),E=R.value.collator,N=L.value.collator;return r(N,p,v)||d(C,m)||r(E,C,m)}e.$uq=D;function w(C,m){C=C||"",m=m||"";const p=n(C),v=n(m),E=R.value.collator,N=L.value.collator;return r(N,p,v)||s(C,m)||r(E,C,m)}e.$vq=w;function u(C,m){C=C||"",m=m||"";const p=n(C).toLowerCase(),v=n(m).toLowerCase();return p!==v?p<v?-1:1:C!==m?C<m?-1:1:0}e.$wq=u;const o=/^(.*?)(\.([^.]*))?$/;function i(C,m=!1){const p=C?o.exec(C):[];let v=[p&&p[1]||"",p&&p[3]||""];return m&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function n(C){const m=C?o.exec(C):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function r(C,m,p){const v=C.compare(m,p);return v!==0?v:m.length!==p.length?m.length<p.length?-1:1:0}function a(C){const m=C.charAt(0);return m.toLocaleUpperCase()!==m}function t(C){const m=C.charAt(0);return m.toLocaleLowerCase()!==m}function s(C,m){return a(C)&&t(m)?-1:t(C)&&a(m)?1:0}function d(C,m){return t(C)&&a(m)?-1:a(C)&&t(m)?1:0}function c(C,m,p=!1){return p||(C=C&&C.toLowerCase(),m=m&&m.toLowerCase()),C===m?0:C<m?-1:1}function l(C,m,p=!1){const v=C.split(F.sep),E=m.split(F.sep),N=v.length-1,z=E.length-1;let M,T;for(let j=0;;j++){if(M=N===j,T=z===j,M&&T)return b(v[j],E[j],p);if(M)return-1;if(T)return 1;const O=c(v[j],E[j],p);if(O!==0)return O}}e.$xq=l;function h(C,m,p){const v=C.toLowerCase(),E=m.toLowerCase(),N=k(C,m,p);if(N)return N;const z=v.endsWith(p),M=E.endsWith(p);if(z!==M)return z?-1:1;const T=b(v,E);return T!==0?T:v.localeCompare(E)}e.$yq=h;function k(C,m,p){const v=C.toLowerCase(),E=m.toLowerCase(),N=v.startsWith(p),z=E.startsWith(p);if(N!==z)return N?-1:1;if(N&&z){if(v.length<E.length)return-1;if(v.length>E.length)return 1}return 0}e.$zq=k}),define(ke[33],Se([1,0,16,12,13,18]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function L(h){return h===47||h===92}e.$Uf=L;function b(h){return h.replace(/[\\/]/g,I.$fc.sep)}e.$Vf=b;function y(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Wf=y;function g(h,k=I.$fc.sep){if(!h)return"";const C=h.length,m=h.charCodeAt(0);if(L(m)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let v=3;const E=v;for(;v<C&&!L(h.charCodeAt(v));v++);if(E!==v&&!L(h.charCodeAt(v+1))){for(v+=1;v<C;v++)if(L(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,k)}}return k}else if(o(m)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+k:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<C;p++)if(L(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Xf=g;function A(h){if(!F.$i||!h||h.length<5)return!1;let k=h.charCodeAt(0);if(k!==92||(k=h.charCodeAt(1),k!==92))return!1;let C=2;const m=C;for(;C<h.length&&(k=h.charCodeAt(C),k!==92);C++);return!(m===C||(k=h.charCodeAt(C+1),isNaN(k)||k===92))}e.$Yf=A;const P=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(h,k=F.$i){const C=k?P:$;return!(!h||h.length===0||/^\s+$/.test(h)||(C.lastIndex=0,C.test(h))||k&&S.test(h)||h==="."||h===".."||k&&h[h.length-1]==="."||k&&h.length!==h.trim().length||h.length>255)}e.$Zf=D;function w(h,k,C){const m=h===k;return!C||m?m:!h||!k?!1:(0,f.$6e)(h,k)}e.$1f=w;function u(h,k,C,m=I.sep){if(h===k)return!0;if(!h||!k||k.length>h.length)return!1;if(C){if(!(0,f.$7e)(h,k))return!1;if(k.length===h.length)return!0;let v=k.length;return k.charAt(k.length-1)===m&&v--,h.charAt(v)===m}return k.charAt(k.length-1)!==m&&(k+=m),h.indexOf(k)===0}e.$2f=u;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$3f=o;function i(h,k){return F.$i&&h.endsWith(":")&&(h+=I.sep),(0,I.$hc)(h)||(h=(0,I.$ic)(k,h)),h=(0,I.$gc)(h),F.$i?(h=(0,f.$Oe)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,f.$Oe)(h,I.sep),h||(h=I.sep)),h}e.$4f=i;function n(h){const k=(0,I.$gc)(h);return F.$i?h.length>3?!1:r(k)&&(h.length===2||k.charCodeAt(2)===92):k===I.$fc.sep}e.$5f=n;function r(h,k=F.$i){return k?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$6f=r;function a(h,k=F.$i){return r(h,k)?h[0]:void 0}e.$7f=a;function t(h,k,C){return k.length>h.length?-1:h===k?0:(C&&(h=h.toLowerCase(),k=k.toLowerCase()),h.indexOf(k))}e.$8f=t;function s(h){const k=h.split(":");let C,m,p;for(const v of k){const E=Number(v);(0,R.$Gf)(E)?m===void 0?m=E:p===void 0&&(p=E):C=C?[C,v].join(":"):v}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.$9f=s;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,k,C=8){let m="";for(let v=0;v<C;v++){let E;v===0&&F.$i&&!k&&(C===3||C===4)?E=c:E=d,m+=E.charAt(Math.floor(Math.random()*E.length))}let p;return k?p=`${k}-${m}`:p=m,h?(0,I.$ic)(h,p):p}e.$0f=l}),define(ke[130],Se([1,0,129,124,52,16,12,13]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0;const y=0,g=[y,[]];function A(V,te,fe,Z){if(!V||!te)return g;const Q=V.length,G=te.length;if(Q<G)return g;const oe=V.toLowerCase();return P(te,fe,G,V,oe,Q,Z)}e.$Aq=A;function P(V,te,fe,Z,Q,G,oe){const x=[],Ee=[];for(let ie=0;ie<fe;ie++){const be=ie*G,H=be-G,X=ie>0,Y=V[ie],$e=te[ie];for(let ne=0;ne<G;ne++){const de=ne>0,ee=be+ne,he=ee-1,pe=H+ne-1,Pe=de?x[he]:0,B=X&&de?x[pe]:0,J=X&&de?Ee[pe]:0;let re;!B&&X?re=0:re=$(Y,$e,Z,Q,ne,J),re&&B+re>=Pe&&(oe||X||Q.startsWith(te,ne))?(Ee[ee]=J+1,x[ee]=B+re):(Ee[ee]=y,x[ee]=Pe)}}const le=[];let q=fe-1,U=G-1;for(;q>=0&&U>=0;){const ie=q*G+U;Ee[ie]===y||(le.push(U),q--),U--}return[x[fe*G-1],le.reverse()]}function $(V,te,fe,Z,Q,G){let oe=0;if(!S(te,Z[Q]))return oe;if(oe+=1,G>0&&(oe+=G*5),V===fe[Q]&&(oe+=1),Q===0)oe+=8;else{const x=D(fe.charCodeAt(Q-1));x?oe+=x:(0,F.$Mj)(fe.charCodeAt(Q))&&G===0&&(oe+=2)}return oe}function S(V,te){return V===te?!0:V==="/"||V==="\\"?te==="/"||te==="\\":!1}function D(V){switch(V){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function u(V,te,fe=0,Z=0){const Q=te;return Q.values&&Q.values.length>1?o(V,Q.values,fe,Z):i(V,te,fe,Z)}e.$Bq=u;function o(V,te,fe,Z){let Q=0;const G=[];for(const oe of te){const[x,Ee]=i(V,oe,fe,Z);if(typeof x!="number")return w;Q+=x,G.push(...Ee)}return[Q,C(G)]}function i(V,te,fe,Z){const Q=(0,F.$Vj)(te.original,te.originalLowercase,fe,V,V.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$Sj)(Q)]:w}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=1<<16;function s(V,te,fe,Z){const Q=Z.values?Z.values:[Z];return(0,f.$Ji)({[Z.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:V,description:te,allowNonContiguousMatches:fe}})}function d(V,te,fe,Z,Q){if(!V||!te.normalized)return n;const G=Z.getItemLabel(V);if(!G)return n;const oe=Z.getItemDescription(V),x=s(G,oe,fe,te),Ee=Q[x];if(Ee)return Ee;const le=c(G,oe,Z.getItemPath(V),te,fe);return Q[x]=le,le}e.$Cq=d;function c(V,te,fe,Z,Q){const G=!fe||!Z.containsPathSeparator;return fe&&(L.$k?Z.pathNormalized===fe:(0,b.$6e)(Z.pathNormalized,fe))?{score:r,labelMatch:[{start:0,end:V.length}],descriptionMatch:te?[{start:0,end:te.length}]:void 0}:Z.values&&Z.values.length>1?l(V,te,fe,Z.values,G,Q):h(V,te,fe,Z,G,Q)}function l(V,te,fe,Z,Q,G){let oe=0;const x=[],Ee=[];for(const le of Z){const{score:q,labelMatch:U,descriptionMatch:ie}=h(V,te,fe,le,Q,G);if(q===y)return n;oe+=q,U&&x.push(...U),ie&&Ee.push(...ie)}return{score:oe,labelMatch:C(x),descriptionMatch:C(Ee)}}function h(V,te,fe,Z,Q,G){if(Q||!te){const[oe,x]=A(V,Z.normalized,Z.normalizedLowercase,G&&!Z.expectContiguousMatch);if(oe){const Ee=(0,F.$Jj)(Z.normalized,V);let le;if(Ee){le=a;const q=Math.round(Z.normalized.length/V.length*100);le+=q}else le=t;return{score:le+oe,labelMatch:Ee||k(x)}}}if(te){let oe=te;fe&&(oe=`${te}${R.sep}`);const x=oe.length,Ee=`${oe}${V}`,[le,q]=A(Ee,Z.normalized,Z.normalizedLowercase,G&&!Z.expectContiguousMatch);if(le){const U=k(q),ie=[],be=[];return U.forEach(H=>{H.start<x&&H.end>x?(ie.push({start:0,end:H.end-x}),be.push({start:H.start,end:x})):H.start>=x?ie.push({start:H.start-x,end:H.end-x}):be.push(H)}),{score:le,labelMatch:ie,descriptionMatch:be}}}return n}function k(V){const te=[];if(!V)return te;let fe;for(const Z of V)fe&&fe.end===Z?fe.end+=1:(fe={start:Z,end:Z+1},te.push(fe));return te}function C(V){const te=V.sort((Q,G)=>Q.start-G.start),fe=[];let Z;for(const Q of te)!Z||!m(Z,Q)?(Z=Q,fe.push(Q)):(Z.start=Math.min(Z.start,Q.start),Z.end=Math.max(Z.end,Q.end));return fe}function m(V,te){return!(V.end<te.start||te.end<V.start)}function p(V,te,fe,Z,Q,G){const oe=d(V,fe,Z,Q,G),x=d(te,fe,Z,Q,G),Ee=oe.score,le=x.score;if((Ee===r||le===r)&&Ee!==le)return Ee===r?-1:1;if(Ee>t||le>t){if(Ee!==le)return Ee>le?-1:1;if(Ee<a&&le<a){const Y=E(oe.labelMatch,x.labelMatch);if(Y!==0)return Y}const H=Q.getItemLabel(V)||"",X=Q.getItemLabel(te)||"";if(H.length!==X.length)return H.length-X.length}if(Ee!==le)return Ee>le?-1:1;const q=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(q&&!U)return-1;if(U&&!q)return 1;const ie=v(V,oe,Q),be=v(te,x,Q);return ie&&be&&ie!==be?be>ie?-1:1:N(V,te,fe,Q)}e.$Dq=p;function v(V,te,fe){let Z=-1,Q=-1;if(te.descriptionMatch&&te.descriptionMatch.length?Z=te.descriptionMatch[0].start:te.labelMatch&&te.labelMatch.length&&(Z=te.labelMatch[0].start),te.labelMatch&&te.labelMatch.length){if(Q=te.labelMatch[te.labelMatch.length-1].end,te.descriptionMatch&&te.descriptionMatch.length){const G=fe.getItemDescription(V);G&&(Q+=G.length)}}else te.descriptionMatch&&te.descriptionMatch.length&&(Q=te.descriptionMatch[te.descriptionMatch.length-1].end);return Q-Z}function E(V,te){if(!V&&!te||(!V||!V.length)&&(!te||!te.length))return 0;if(!te||!te.length)return-1;if(!V||!V.length)return 1;const fe=V[0].start,Q=V[V.length-1].end-fe,G=te[0].start,x=te[te.length-1].end-G;return Q===x?0:x<Q?1:-1}function N(V,te,fe,Z){const Q=Z.getItemLabel(V)||"",G=Z.getItemLabel(te)||"",oe=Z.getItemDescription(V),x=Z.getItemDescription(te),Ee=Q.length+(oe?oe.length:0),le=G.length+(x?x.length:0);if(Ee!==le)return Ee-le;const q=Z.getItemPath(V),U=Z.getItemPath(te);return q&&U&&q.length!==U.length?q.length-U.length:Q!==G?(0,I.$yq)(Q,G,fe.normalized):oe&&x&&oe!==x?(0,I.$yq)(oe,x,fe.normalized):q&&U&&q!==U?(0,I.$yq)(q,U,fe.normalized):0}function z(V){return V.startsWith('"')&&V.endsWith('"')}const M=" ";function T(V){typeof V!="string"&&(V="");const te=V.toLowerCase(),{pathNormalized:fe,normalized:Z,normalizedLowercase:Q}=j(V),G=fe.indexOf(R.sep)>=0,oe=z(V);let x;const Ee=V.split(M);if(Ee.length>1)for(const le of Ee){const q=z(le),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=j(le);ie&&(x||(x=[]),x.push({original:le,originalLowercase:le.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:q}))}return{original:V,originalLowercase:te,pathNormalized:fe,normalized:Z,normalizedLowercase:Q,values:x,containsPathSeparator:G,expectContiguousMatch:oe}}e.$Eq=T;function j(V){let te;L.$i?te=V.replace(/\//g,R.sep):te=V.replace(/\\/g,R.sep);const fe=(0,b.$Qe)(te).replace(/\s|"/g,"");return{pathNormalized:te,normalized:fe,normalizedLowercase:fe.toLowerCase()}}function O(V){return Array.isArray(V)?T(V.map(te=>te.original).join(M)):T(V.original)}e.$Fq=O}),define(ke[100],Se([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=e.$Wr=void 0,e.$Wr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const P=(0,I.$nc)(A),$=F[P.toLowerCase()];return $!==void 0?$:L(A)}e.$Xr=R;function L(A){const P=(0,I.$nc)(A);return f[P.toLowerCase()]}e.$Yr=L;function b(A){for(const P in f)if(f[P]===A)return P}e.$Zr=b;const y=/^(.+)\/(.+?)(;.+)?$/;function g(A,P){const $=y.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:P?void 0:A}e.$1r=g}),define(ke[101],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var F;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(F||(e.Source=F={}));var f;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R(b,...y){const g=y.reduce(($,S)=>($[S]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!g[$]).forEach($=>{for(let S=0;S<A.length;S++)if($.search(A[S])!==-1){delete b[$];break}})}e.$Fl=R;function L(b){b&&(delete b.DEBUG,I.$j&&delete b.DYLD_LIBRARY_PATH,I.$k&&delete b.LD_PRELOAD)}e.$Gl=L}),define(ke[2],Se([1,0,16,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function b(c,l){if(!c.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!f.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(c,l){return!c&&!l?"file":c}function g(c,l){switch(c){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const A="",P="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(l){return l instanceof S?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,k,C,m,p=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=y(l,p),this.authority=h||A,this.path=g(this.scheme,k||A),this.query=C||A,this.fragment=m||A,b(this,p))}get fsPath(){return r(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:k,path:C,query:m,fragment:p}=l;return h===void 0?h=this.scheme:h===null&&(h=A),k===void 0?k=this.authority:k===null&&(k=A),C===void 0?C=this.path:C===null&&(C=A),m===void 0?m=this.query:m===null&&(m=A),p===void 0?p=this.fragment:p===null&&(p=A),h===this.scheme&&k===this.authority&&C===this.path&&m===this.query&&p===this.fragment?this:new u(h,k,C,m,p)}static parse(l,h=!1){const k=$.exec(l);return k?new u(k[2]||A,d(k[4]||A),d(k[5]||A),d(k[7]||A),d(k[9]||A),h):new u(A,A,A,A,A)}static file(l){let h=A;if(F.$i&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const k=l.indexOf(P,2);k===-1?(h=l.substring(2),l=P):(h=l.substring(2,k),l=l.substring(k)||P)}return new u("file",h,l,A,A)}static from(l,h){return new u(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return F.$i&&l.scheme==="file"?k=S.file(I.$ec.join(r(l,!0),...h)).path:k=I.$fc.join(l.path,...h),l.with({path:k})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof S)return l;{const h=new u(l);return h._formatted=l.external??null,h._fsPath=l._sep===w?l.fsPath??null:null,h}}else return l}}e.URI=S;function D(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}e.$uc=D;const w=F.$i?1:void 0;class u extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(c,l,h){let k,C=-1;for(let m=0;m<c.length;m++){const p=c.charCodeAt(m);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||l&&p===47||h&&p===91||h&&p===93||h&&p===58)C!==-1&&(k+=encodeURIComponent(c.substring(C,m)),C=-1),k!==void 0&&(k+=c.charAt(m));else{k===void 0&&(k=c.substr(0,m));const v=o[p];v!==void 0?(C!==-1&&(k+=encodeURIComponent(c.substring(C,m)),C=-1),k+=v):C===-1&&(C=m)}}return C!==-1&&(k+=encodeURIComponent(c.substring(C))),k!==void 0?k:c}function n(c){let l;for(let h=0;h<c.length;h++){const k=c.charCodeAt(h);k===35||k===63?(l===void 0&&(l=c.substr(0,h)),l+=o[k]):l!==void 0&&(l+=c[h])}return l!==void 0?l:c}function r(c,l){let h;return c.authority&&c.path.length>1&&c.scheme==="file"?h=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?l?h=c.path.substr(1):h=c.path[1].toLowerCase()+c.path.substr(2):h=c.path,F.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=r;function a(c,l){const h=l?n:i;let k="",{scheme:C,authority:m,path:p,query:v,fragment:E}=c;if(C&&(k+=C,k+=":"),(m||C==="file")&&(k+=P,k+=P),m){let N=m.indexOf("@");if(N!==-1){const z=m.substr(0,N);m=m.substr(N+1),N=z.lastIndexOf(":"),N===-1?k+=h(z,!1,!1):(k+=h(z.substr(0,N),!1,!1),k+=":",k+=h(z.substr(N+1),!1,!0)),k+="@"}m=m.toLowerCase(),N=m.lastIndexOf(":"),N===-1?k+=h(m,!1,!0):(k+=h(m.substr(0,N),!1,!0),k+=m.substr(N))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const N=p.charCodeAt(1);N>=65&&N<=90&&(p=`/${String.fromCharCode(N+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const N=p.charCodeAt(0);N>=65&&N<=90&&(p=`${String.fromCharCode(N+32)}:${p.substr(2)}`)}k+=h(p,!0,!1)}return v&&(k+="?",k+=h(v,!1,!1)),E&&(k+="#",k+=l?E:i(E,!1,!1)),k}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(c){return c.match(s)?c.replace(s,l=>t(l)):c}}),define(ke[185],Se([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function F(g){const A=g;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$4p=F;function f(g){const A=[];let P;try{const $=JSON.parse(g.arguments),S=$[$.length-1];S&&S.__$stack&&($.pop(),P=S.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",g.arguments)}return{args:A,stack:P}}e.$5p=f;function R(g){if(typeof g!="string")return R(f(g).stack);const A=g;if(A){const P=L(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if($&&$.length===4)return{uri:I.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$6p=R;function L(g){if(!g)return g;const A=g.indexOf(`
`);return A===-1?g:g.substring(0,A)}function b(g,A){const{args:P,stack:$}=f(g),S=typeof P[0]=="string"&&P.length===1;let D=L($);D&&(D=`(${D.trim()})`);let w=[];if(typeof P[0]=="string"?D&&S?w=[`%c[${A}] %c${P[0]} %c${D}`,y("blue"),y(""),y("grey")]:w=[`%c[${A}] %c${P[0]}`,y("blue"),y(""),...P.slice(1)]:w=[`%c[${A}]%`,y("blue"),...P],D&&!S&&w.push(D),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,w)}e.log=b;function y(g){return`color: ${g}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function f(y){return JSON.stringify(y,L)}e.$qh=f;function R(y){let g=JSON.parse(y);return g=b(g),g}e.$rh=R;function L(y,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function b(y,g=0){if(!y||g>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return F.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof I.$fe||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let A=0;A<y.length;++A)y[A]=b(y[A],g+1);else for(const A in y)Object.hasOwnProperty.call(y,A)&&(y[A]=b(y[A],g+1))}return y}e.$sh=b}),define(ke[17],Se([1,0,8,12,2]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var R;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$$f="vscode-tkn",e.$_f="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${R.vscodeRemoteResource}`}set(A,P,$){this.a[A]=P,this.b[A]=$}setConnectionToken(A,P){this.c[A]=P}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(u){return I.$Z(u),A}const P=A.authority;let $=this.a[P];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const S=this.b[P],D=this.c[P];let w=`path=${encodeURIComponent(A.path)}`;return typeof D=="string"&&(w+=`&${e.$_f}=${encodeURIComponent(D)}`),f.URI.from({scheme:F.$o?this.d:R.vscodeRemoteResource,authority:`${$}:${S}`,path:this.f,query:w})}}e.$ag=new L,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class b{static{this.a=e.$fg}asBrowserUri(A){const P=this.b(A,me);return this.uriToBrowserUri(P)}uriToBrowserUri(A){return A.scheme===R.vscodeRemote?e.$ag.rewrite(A):A.scheme===R.file&&(F.$m||F.$q===`${R.vscodeFileResource}://${b.a}`)?A.with({scheme:R.vscodeFileResource,authority:A.authority||b.a,query:null,fragment:null}):A}asFileUri(A){const P=this.b(A,me);return this.uriToFileUri(P)}uriToFileUri(A){return A.scheme===R.vscodeFileResource?A.with({scheme:R.file,authority:A.authority!==b.a?A.authority:null,query:null,fragment:null}):A}b(A,P){return f.URI.isUri(A)?A:f.URI.parse(P.toUrl(A))}}e.$gg=new b;var y;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const P="vscode-coi";function $(D){let w;typeof D=="string"?w=new URL(D).searchParams:D instanceof URL?w=D.searchParams:f.URI.isUri(D)&&(w=new URL(D.toString(!0)).searchParams);const u=w?.get(P);if(u)return A.get(u)}g.getHeadersFromQuery=$;function S(D,w,u){if(!globalThis.crossOriginIsolated)return;const o=w&&u?"3":u?"2":"1";D instanceof URLSearchParams?D.set(P,o):D[P]=o}g.addSearchParam=S})(y||(e.COI=y={}))}),define(ke[186],Se([1,0,159,17,12,2]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class L{constructor($,S,D){this.id=$,this.dependencies=S,this.callback=D}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,S,D)=>{typeof $!="string"&&(D=S,S=$,$=null),(typeof S!="object"||!Array.isArray(S))&&(D=S,S=null),this.c.push(new L($,S,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const S=await(this.a?this.i($):this.b?this.h($):this.j($));if(!S)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h($){return new Promise((S,D)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const u=()=>{w.removeEventListener("load",o),w.removeEventListener("error",i)},o=n=>{u(),S(this.c.pop())},i=n=>{u(),D(n)};w.addEventListener("load",o),w.addEventListener("error",i),this.f&&($=this.f.createScriptURL($)),w.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(w)})}i($){return new Promise((S,D)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),S(this.c.pop())}catch(w){D(w)}})}async j($){try{const S=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,u=R.URI.parse($).fsPath,o=S.readFileSync(u).toString(),i=w.wrap(o.replace(/^#!.*/,""));return new D.Script(i).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const y=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function A(P,$,S){if(I.$S){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[P]&&(P=g[P]);const D=`${P}/${$}`;if(y.has(D))return y.get(D);let w;if(/^\w[\w\d+.-]*:\/\//.test(D))w=D;else{const n=`${S&&!f.$o?F.$dg:F.$cg}/${D}`;w=F.$gg.asBrowserUri(n).toString(!0)}const u=b.INSTANCE.load(w);return y.set(D,u),u}else return await new Promise((D,w)=>{me([P],D,w)})}e.$OC=A}),define(ke[23],Se([1,0,33,17,16,12,13,2]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function y(S){return(0,b.$vc)(S,!0)}e.$ng=y;class g{constructor(D){this.a=D}compare(D,w,u=!1){return D===w?0:(0,L.$Ye)(this.getComparisonKey(D,u),this.getComparisonKey(w,u))}isEqual(D,w,u=!1){return D===w?!0:!D||!w?!1:this.getComparisonKey(D,u)===this.getComparisonKey(w,u)}getComparisonKey(D,w=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,w,u=!1){if(D.scheme===w.scheme){if(D.scheme===F.Schemas.file)return I.$2f(y(D),y(w),this.a(D))&&D.query===w.query&&(u||D.fragment===w.fragment);if((0,e.$Eg)(D.authority,w.authority))return I.$2f(D.path,w.path,this.a(D),"/")&&D.query===w.query&&(u||D.fragment===w.fragment)}return!1}joinPath(D,...w){return b.URI.joinPath(D,...w)}basenameOrAuthority(D){return(0,e.$wg)(D)||D.authority}basename(D){return f.$fc.basename(D.path)}extname(D){return f.$fc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let w;return D.scheme===F.Schemas.file?w=b.URI.file(f.$lc(y(D))).path:(w=f.$fc.dirname(D.path),D.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),w="/")),D.with({path:w})}normalizePath(D){if(!D.path.length)return D;let w;return D.scheme===F.Schemas.file?w=b.URI.file(f.$gc(y(D))).path:w=f.$fc.normalize(D.path),D.with({path:w})}relativePath(D,w){if(D.scheme!==w.scheme||!(0,e.$Eg)(D.authority,w.authority))return;if(D.scheme===F.Schemas.file){const i=f.$kc(y(D),y(w));return R.$i?I.$Vf(i):i}let u=D.path||"/";const o=w.path||"/";if(this.a(D)){let i=0;for(const n=Math.min(u.length,o.length);i<n&&!(u.charCodeAt(i)!==o.charCodeAt(i)&&u.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);u=o.substr(0,i)+u.substr(i)}return f.$fc.relative(u,o)}resolvePath(D,w){if(D.scheme===F.Schemas.file){const u=b.URI.file(f.$jc(y(D),w));return D.with({authority:u.authority,path:u.path})}return w=I.$Wf(w),D.with({path:f.$fc.resolve(D.path,w)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,w){return D===w||D!==void 0&&w!==void 0&&(0,L.$6e)(D,w)}hasTrailingPathSeparator(D,w=f.sep){if(D.scheme===F.Schemas.file){const u=y(D);return u.length>I.$Xf(u).length&&u[u.length-1]===w}else{const u=D.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,w=f.sep){return(0,e.$Fg)(D,w)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,w=f.sep){let u=!1;if(D.scheme===F.Schemas.file){const o=y(D);u=o!==void 0&&o.length===I.$Xf(o).length&&o[o.length-1]===w}else{w="/";const o=D.path;u=o.length===1&&o.charCodeAt(o.length-1)===47}return!u&&!(0,e.$Fg)(D,w)?D.with({path:D.path+"/"}):D}}e.$og=g,e.$pg=new g(()=>!1),e.$qg=new g(S=>S.scheme===F.Schemas.file?!R.$k:!0),e.$rg=new g(S=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function A(S,D){const w=[];for(let u=0;u<S.length;u++){const o=D(S[u]);S.some((i,n)=>n===u?!1:(0,e.$tg)(o,D(i)))||w.push(S[u])}return w}e.$Ig=A;var P;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function D(w){const u=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&u.set(r,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&u.set(S.META_DATA_MIME,i),u}S.parseMetaData=D})(P||(e.DataUri=P={}));function $(S,D,w){if(D){let u=S.path;return u&&u[0]!==f.$fc.sep&&(u=f.$fc.sep+u),S.with({scheme:w,authority:D,path:u})}return S.with({scheme:w})}e.$Jg=$}),define(ke[11],Se([1,0,21,8,4,3,23,12,163]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Kg=g;function A(be){const H=new I.$2d,X=be(H.token),Y=new Promise(($e,ne)=>{const de=H.token.onCancellationRequested(()=>{de.dispose(),H.dispose(),ne(new F.$4)});Promise.resolve(X).then(ee=>{de.dispose(),H.dispose(),$e(ee)},ee=>{de.dispose(),H.dispose(),ne(ee)})});return new class{cancel(){H.cancel()}then($e,ne){return Y.then($e,ne)}catch($e){return this.then(void 0,$e)}finally($e){return Y.finally($e)}}}e.$Lg=A;function P(be,H,X){return new Promise((Y,$e)=>{const ne=H.onCancellationRequested(()=>{ne.dispose(),Y(X)});be.then(Y,$e).finally(()=>ne.dispose())})}e.$Mg=P;function $(be,H){return new Promise((X,Y)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),Y(new F.$4)});be.then(X,Y).finally(()=>$e.dispose())})}e.$Ng=$;async function S(be){let H=-1;const X=be.map((Y,$e)=>Y.then(ne=>(H=$e,ne)));try{return await Promise.race(X)}finally{be.forEach((Y,$e)=>{$e!==H&&Y.cancel()})}}e.$Og=S;function D(be,H,X){let Y;const $e=setTimeout(()=>{Y?.(void 0),X?.()},H);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(ne=>Y=ne)])}e.$Pg=D;function w(be){return new Promise((H,X)=>{const Y=be();g(Y)?Y.then(H,X):H(Y)})}e.$Qg=w;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const X=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(X,X).then(Y)})}return new Promise((X,Y)=>{this.b.then(X,Y)})}return this.a=H(),new Promise((X,Y)=>{this.a.then($e=>{this.a=null,X($e)},$e=>{this.a=null,Y($e)})})}dispose(){this.f=!0}}e.$Rg=u;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Sg=o;class i{constructor(){this.a=new Map}queue(H,X){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Tg=i;const n=(be,H)=>{let X=!0;const Y=setTimeout(()=>{X=!1,H()},be);return{isTriggered:()=>X,dispose:()=>{clearTimeout(Y),X=!1}}},r=be=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,be())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,X=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,ne)=>{this.d=$e,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=X===y.$Od?r(Y):n(X,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=a;class t{constructor(H){this.a=new a(H),this.b=new u}trigger(H,X){return this.a.trigger(()=>this.b.queue(H),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=t;class s{constructor(){this.a=!1,this.b=new Promise((H,X)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class d extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Xg=d;function c(be,H){return H?new Promise((X,Y)=>{const $e=setTimeout(()=>{ne.dispose(),X()},be),ne=H.onCancellationRequested(()=>{clearTimeout($e),ne.dispose(),Y(new F.$4)})}):A(X=>c(be,X))}e.$Yg=c;function l(be,H=0,X){const Y=setTimeout(()=>{be(),X&&$e.dispose()},H),$e=(0,R.$Pc)(()=>{clearTimeout(Y),X?.deleteAndLeak($e)});return X?.add($e),$e}e.$Zg=l;function h(be){const H=[];let X=0;const Y=be.length;function $e(){return X<Y?be[X++]():null}function ne(de){de!=null&&H.push(de);const ee=$e();return ee?ee.then(ne):Promise.resolve(H)}return Promise.resolve(null).then(ne)}e.$1g=h;function k(be,H=Y=>!!Y,X=null){let Y=0;const $e=be.length,ne=()=>{if(Y>=$e)return Promise.resolve(X);const de=be[Y++];return Promise.resolve(de()).then(he=>H(he)?Promise.resolve(he):ne())};return ne()}e.$2g=k;function C(be,H=Y=>!!Y,X=null){if(be.length===0)return Promise.resolve(X);let Y=be.length;const $e=()=>{Y=-1;for(const ne of be)ne.cancel?.()};return new Promise((ne,de)=>{for(const ee of be)ee.then(he=>{--Y>=0&&H(he)?($e(),ne(he)):Y===0&&ne(X)}).catch(he=>{--Y>=0&&($e(),de(he))})})}e.$3g=C;class m{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new f.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((X,Y)=>{this.f.push({factory:H,c:X,e:Y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const X=H.factory();X.then(H.c,H.e),X.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=m;class p extends m{constructor(){super(1)}}e.$5g=p;class v{constructor(){this.a=new Z,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$6g=v;class E{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new oe;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,X=L.$pg){const Y=X.getComparisonKey(H);let $e=this.a.get(Y);if(!$e){$e=new p;const ne=this.f++,de=f.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(Y),this.h(),this.d?.deleteAndDispose(ne),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(ne,de),this.a.set(Y,$e)}return $e}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=E;class N{constructor(H,X){this.a=-1,typeof H=="function"&&typeof X=="number"&&this.setIfNotSet(H,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},X)}setIfNotSet(H,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},X))}}e.$8g=N;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,X,Y=globalThis){this.cancel();const $e=Y.setInterval(()=>{H()},X);this.d=(0,R.$Pc)(()=>{Y.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$9g=z;class M{constructor(H,X){this.b=-1,this.a=H,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=M;class T{constructor(H,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=H,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=T;class j extends M{constructor(H,X){super(H,X),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$_g=j;class O extends R.$Rc{constructor(H,X){super(),this.g=H,this.h=X,this.a=[],this.b=this.B(new R.$Sc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of H)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(be,H)=>{(0,b.$B)(()=>{if(X)return;const Y=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$ch=(be,H,X)=>{const Y=be.requestIdleCallback(H,typeof X=="number"?{timeout:X}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(Y))}}},e.$bh=be=>(0,e.$ch)(globalThis,be)}();class V{constructor(H,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$ch)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=V;class te extends V{constructor(H){super(globalThis,H)}}e.$eh=te;async function fe(be,H,X){let Y;for(let $e=0;$e<X;$e++)try{return await be()}catch(ne){Y=ne,await c(H)}throw Y}e.$fh=fe;class Z{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,X,Y){return this.a={taskId:H,cancel:()=>Y?.(),promise:X},X.then(()=>this.d(H),()=>this.d(H)),X}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let X,Y;const $e=new Promise((ne,de)=>{X=ne,Y=de});this.b={run:H,promise:$e,promiseResolve:X,promiseReject:Y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=Z;class Q{constructor(H,X=()=>Date.now()){this.d=H,this.f=X,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$hh=Q;var G;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(G||(G={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,X)=>{this.a=H,this.b=X})}complete(H){return new Promise(X=>{this.a(H),this.d={outcome:0,value:H},X()})}error(H){return new Promise(X=>{this.b(H),this.d={outcome:1,value:H},X()})}cancel(){return this.error(new F.$4)}}e.$ih=oe;var x;(function(be){async function H(Y){let $e;const ne=await Promise.all(Y.map(de=>de.then(ee=>ee,ee=>{$e||($e=ee)})));if(typeof $e<"u")throw $e;return ne}be.settled=H;function X(Y){return new Promise(async($e,ne)=>{try{await Y($e,ne)}catch(de){ne(de)}})}be.withAsyncBody=X})(x||(e.Promises=x={}));var Ee;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Ee||(Ee={}));class le{static fromArray(H){return new le(X=>{X.emitMany(H)})}static fromPromise(H){return new le(async X=>{X.emitMany(await H)})}static fromPromises(H){return new le(async X=>{await Promise.all(H.map(async Y=>X.emitOne(await Y)))})}static merge(H){return new le(async X=>{await Promise.all(H.map(async Y=>{for await(const $e of Y)X.emitOne($e)}))})}static{this.EMPTY=le.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new f.$Rd,queueMicrotask(async()=>{const X={emitOne:Y=>this.g(Y),emitMany:Y=>this.h(Y),reject:Y=>this.k(Y)};try{await Promise.resolve(H(X)),this.j()}catch(Y){this.k(Y)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(H,X){return new le(async Y=>{for await(const $e of H)Y.emitOne(X($e))})}map(H){return le.map(this,H)}static filter(H,X){return new le(async Y=>{for await(const $e of H)X($e)&&Y.emitOne($e)})}filter(H){return le.filter(this,H)}static coalesce(H){return le.filter(H,X=>!!X)}coalesce(){return le.coalesce(this)}static async toPromise(H){const X=[];for await(const Y of H)X.push(Y);return X}toPromise(){return le.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$jh=le;class q extends le{constructor(H,X){super(X),this.l=H}cancel(){this.l.cancel()}}e.$kh=q;function U(be){const H=new I.$2d,X=be(H.token);return new q(H,async Y=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),Y.reject(new F.$4)});try{for await(const ne of X){if(H.token.isCancellationRequested)return;Y.emitOne(ne)}$e.dispose(),H.dispose()}catch(ne){$e.dispose(),H.dispose(),Y.reject(ne)}})}e.$lh=U;class ie{constructor(){this.a=new oe,this.b=new le(Y=>{if(H){Y.reject(H);return}return X&&Y.emitMany(X),this.d=$e=>Y.reject($e),this.f=$e=>Y.emitOne($e),this.a.p});let H,X;this.f=Y=>{X||(X=[]),X.push(Y)},this.d=Y=>{H||(H=Y)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$mh=ie}),define(ke[34],Se([1,0,19,11,33,28,16,12,13]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function g(){return Object.create(null)}e.$xj=g,e.$yj="**",e.$zj="/";const A="[/\\\\]",P="[^/\\\\]",$=/\//g;function S(fe,Z){switch(fe){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${Z?`|${A}${P}+`:""})*?`}}function D(fe,Z){if(!fe)return[];const Q=[];let G=!1,oe=!1,x="";for(const Ee of fe){switch(Ee){case Z:if(!G&&!oe){Q.push(x),x="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}x+=Ee}return x&&Q.push(x),Q}e.$Aj=D;function w(fe){if(!fe)return"";let Z="";const Q=D(fe,e.$zj);if(Q.every(G=>G===e.$yj))Z=".*";else{let G=!1;Q.forEach((oe,x)=>{if(oe===e.$yj){if(G)return;Z+=S(2,x===Q.length-1)}else{let Ee=!1,le="",q=!1,U="";for(const ie of oe){if(ie!=="}"&&Ee){le+=ie;continue}if(q&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$zj?be="":be=(0,y.$Je)(ie),U+=be;continue}switch(ie){case"{":Ee=!0;continue;case"[":q=!0;continue;case"}":{const H=`(?:${D(le,",").map(X=>w(X)).join("|")})`;Z+=H,Ee=!1,le="";break}case"]":{Z+="["+U+"]",q=!1,U="";break}case"?":Z+=P;continue;case"*":Z+=S(1);continue;default:Z+=(0,y.$Je)(ie)}}x<Q.length-1&&(Q[x+1]!==e.$yj||x+2<Q.length)&&(Z+=A)}G=oe===e.$yj})}return Z}const u=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Cc(1e4),s=function(){return!1},d=function(){return null};function c(fe,Z){if(!fe)return d;let Q;typeof fe!="string"?Q=fe.pattern:Q=fe,Q=Q.trim();const G=`${Q}_${!!Z.trimForExclusions}`;let oe=t.get(G);if(oe)return l(oe,fe);let x;return u.test(Q)?oe=k(Q.substr(4),Q):(x=o.exec(h(Q,Z)))?oe=C(x[1],Q):(Z.trimForExclusions?n:i).test(Q)?oe=m(Q,Z):(x=r.exec(h(Q,Z)))?oe=p(x[1].substr(1),Q,!0):(x=a.exec(h(Q,Z)))?oe=p(x[1],Q,!1):oe=v(Q),t.set(G,oe),l(oe,fe)}function l(fe,Z){if(typeof Z=="string")return fe;const Q=function(G,oe){return(0,f.$2f)(G,Z.base,!b.$k)?fe((0,y.$Ne)(G.substr(Z.base.length),L.sep),oe):null};return Q.allBasenames=fe.allBasenames,Q.allPaths=fe.allPaths,Q.basenames=fe.basenames,Q.patterns=fe.patterns,Q}function h(fe,Z){return Z.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function k(fe,Z){return function(Q,G){return typeof Q=="string"&&Q.endsWith(fe)?Z:null}}function C(fe,Z){const Q=`/${fe}`,G=`\\${fe}`,oe=function(Ee,le){return typeof Ee!="string"?null:le?le===fe?Z:null:Ee===fe||Ee.endsWith(Q)||Ee.endsWith(G)?Z:null},x=[fe];return oe.basenames=x,oe.patterns=[Z],oe.allBasenames=x,oe}function m(fe,Z){const Q=V(fe.slice(1,-1).split(",").map(le=>c(le,Z)).filter(le=>le!==d),fe),G=Q.length;if(!G)return d;if(G===1)return Q[0];const oe=function(le,q){for(let U=0,ie=Q.length;U<ie;U++)if(Q[U](le,q))return fe;return null},x=Q.find(le=>!!le.allBasenames);x&&(oe.allBasenames=x.allBasenames);const Ee=Q.reduce((le,q)=>q.allPaths?le.concat(q.allPaths):le,[]);return Ee.length&&(oe.allPaths=Ee),oe}function p(fe,Z,Q){const G=L.sep===L.$fc.sep,oe=G?fe:fe.replace($,L.sep),x=L.sep+oe,Ee=L.$fc.sep+fe;let le;return Q?le=function(q,U){return typeof q=="string"&&(q===oe||q.endsWith(x)||!G&&(q===fe||q.endsWith(Ee)))?Z:null}:le=function(q,U){return typeof q=="string"&&(q===oe||!G&&q===fe)?Z:null},le.allPaths=[(Q?"*/":"./")+fe],le}function v(fe){try{const Z=new RegExp(`^${w(fe)}$`);return function(Q){return Z.lastIndex=0,typeof Q=="string"&&Z.test(Q)?fe:null}}catch{return d}}function E(fe,Z,Q){return!fe||typeof Z!="string"?!1:N(fe)(Z,void 0,Q)}e.$Bj=E;function N(fe,Z={}){if(!fe)return s;if(typeof fe=="string"||z(fe)){const Q=c(fe,Z);if(Q===d)return s;const G=function(oe,x){return!!Q(oe,x)};return Q.allBasenames&&(G.allBasenames=Q.allBasenames),Q.allPaths&&(G.allPaths=Q.allPaths),G}return j(fe,Z)}e.$Cj=N;function z(fe){const Z=fe;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Dj=z;function M(fe){return fe.allBasenames||[]}e.$Ej=M;function T(fe){return fe.allPaths||[]}e.$Fj=T;function j(fe,Z){const Q=V(Object.getOwnPropertyNames(fe).map(le=>O(le,fe[le],Z)).filter(le=>le!==d)),G=Q.length;if(!G)return d;if(!Q.some(le=>!!le.requiresSiblings)){if(G===1)return Q[0];const le=function(ie,be){let H;for(let X=0,Y=Q.length;X<Y;X++){const $e=Q[X](ie,be);if(typeof $e=="string")return $e;(0,F.$Kg)($e)&&(H||(H=[]),H.push($e))}return H?(async()=>{for(const X of H){const Y=await X;if(typeof Y=="string")return Y}return null})():null},q=Q.find(ie=>!!ie.allBasenames);q&&(le.allBasenames=q.allBasenames);const U=Q.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(le.allPaths=U),le}const oe=function(le,q,U){let ie,be;for(let H=0,X=Q.length;H<X;H++){const Y=Q[H];Y.requiresSiblings&&U&&(q||(q=(0,L.$mc)(le)),ie||(ie=q.substr(0,q.length-(0,L.$nc)(le).length)));const $e=Y(le,q,ie,U);if(typeof $e=="string")return $e;(0,F.$Kg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const H of be){const X=await H;if(typeof X=="string")return X}return null})():null},x=Q.find(le=>!!le.allBasenames);x&&(oe.allBasenames=x.allBasenames);const Ee=Q.reduce((le,q)=>q.allPaths?le.concat(q.allPaths):le,[]);return Ee.length&&(oe.allPaths=Ee),oe}function O(fe,Z,Q){if(Z===!1)return d;const G=c(fe,Q);if(G===d)return d;if(typeof Z=="boolean")return G;if(Z){const oe=Z.when;if(typeof oe=="string"){const x=(Ee,le,q,U)=>{if(!U||!G(Ee,le))return null;const ie=oe.replace("$(basename)",()=>q),be=U(ie);return(0,F.$Kg)(be)?be.then(H=>H?fe:null):be?fe:null};return x.requiresSiblings=!0,x}}return G}function V(fe,Z){const Q=fe.filter(le=>!!le.basenames);if(Q.length<2)return fe;const G=Q.reduce((le,q)=>{const U=q.basenames;return U?le.concat(U):le},[]);let oe;if(Z){oe=[];for(let le=0,q=G.length;le<q;le++)oe.push(Z)}else oe=Q.reduce((le,q)=>{const U=q.patterns;return U?le.concat(U):le},[]);const x=function(le,q){if(typeof le!="string")return null;if(!q){let ie;for(ie=le.length;ie>0;ie--){const be=le.charCodeAt(ie-1);if(be===47||be===92)break}q=le.substr(ie)}const U=G.indexOf(q);return U!==-1?oe[U]:null};x.basenames=G,x.patterns=oe,x.allBasenames=G;const Ee=fe.filter(le=>!le.basenames);return Ee.push(x),Ee}function te(fe,Z){return(0,I.$tb)(fe,Z,(Q,G)=>typeof Q=="string"&&typeof G=="string"?Q===G:typeof Q!="string"&&typeof G!="string"?Q.base===G.base&&Q.pattern===G.pattern:!1)}e.$Gj=te}),define(ke[80],Se([1,0,8,164,23,13,2]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class y{constructor(o="",i=!1){if(this.value=o,typeof this.value!="string")throw(0,I.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(o,i=0){return this.value+=$(this.supportThemeIcons?(0,F.$3j)(o):o).replace(/([ \t]+)/g,(n,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,i){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(o,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(o),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(o,i){const n=new RegExp((0,R.$Je)(i),"g");return o.replace(n,(r,a)=>o.charAt(a-1)!=="\\"?`\\${r}`:r)}}e.$9j=y;function g(u){return A(u)?!u.value:Array.isArray(u)?u.every(g):!0}e.$0j=g;function A(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||typeof u.isTrusted=="object"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.$$j=A;function P(u,o){return u===o?!0:!u||!o?!1:u.value===o.value&&u.isTrusted===o.isTrusted&&u.supportThemeIcons===o.supportThemeIcons&&u.supportHtml===o.supportHtml&&(u.baseUri===o.baseUri||!!u.baseUri&&!!o.baseUri&&(0,f.$sg)(L.URI.from(u.baseUri),L.URI.from(o.baseUri)))}e.$_j=P;function $(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=$;function S(u){return u.replace(/"/g,"&quot;")}e.$bk=S;function D(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=D;function w(u){const o=[],i=u.split("|").map(r=>r.trim());u=i[0];const n=i[1];if(n){const r=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=r?r[1]:"",s=a?a[1]:"",d=isFinite(parseInt(s)),c=isFinite(parseInt(t));d&&o.push(`width="${s}"`),c&&o.push(`height="${t}"`)}return{href:u,dimensions:o}}e.$dk=w}),define(ke[102],Se([1,0,19,33,16,12,23,13]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function y(c,l){const{os:h,tildify:k,relative:C}=l;if(C){const v=g(c,C,h);if(typeof v=="string")return v}let m=c.fsPath;if(h===1&&!R.$i?m=m.replace(/\//g,"\\"):h!==1&&R.$i&&(m=m.replace(/\\/g,"/")),h!==1&&k?.userHome){const v=k.userHome.fsPath;let E;c.scheme!==k.userHome.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep?E=k.userHome.with({path:c.path}).fsPath:E=m,m=$(E,v,h)}return(h===1?f.$ec:f.$fc).normalize(A(m,h===1))}e.$yv=y;function g(c,l,h){const k=h===1?f.$ec:f.$fc,C=h===3?L.$pg:L.$rg,m=l.getWorkspace(),p=(0,I.$Nb)(m.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep&&(c=p.uri.with({path:c.path}));const v=l.getWorkspaceFolder(c);if(!v)return;let E;if(C.isEqual(v.uri,c)?E="":E=C.relativePath(v.uri,c)??"",E&&(E=k.normalize(E)),m.folders.length>1&&!l.noPrefix){const N=v.name?v.name:C.basenameOrAuthority(v.uri);E=E?`${N} \u2022 ${E}`:N}return E}function A(c,l=R.$i){return(0,F.$6f)(c,l)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$zv=A;let P=Object.create(null);function $(c,l,h=R.OS){if(h===1||!c||!l)return c;let k=P.original===l?P.normalized:void 0;k||(k=l,R.$i&&(k=(0,F.$Vf)(k)),k=`${(0,b.$Oe)(k,f.$fc.sep)}${f.$fc.sep}`,P={original:l,normalized:k});let C=c;return R.$i&&(C=(0,F.$Vf)(C)),(h===3?C.startsWith(k):(0,b.$7e)(C,k))?`~/${C.substr(k.length)}`:c}e.$Av=$;function S(c,l){return c.replace(/^~($|\/|\\)/,`${l}$1`)}e.$Bv=S;const D="\u2026",w="\\\\",u="~";function o(c,l=f.sep){const h=new Array(c.length);let k=!1;for(let C=0;C<c.length;C++){const m=c[C];if(m===""){h[C]=`.${l}`;continue}if(!m){h[C]=m;continue}k=!0;let p="",v=m;v.indexOf(w)===0?(p=v.substr(0,v.indexOf(w)+w.length),v=v.substr(v.indexOf(w)+w.length)):v.indexOf(l)===0?(p=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(u)===0&&(p=v.substr(0,v.indexOf(u)+u.length),v=v.substr(v.indexOf(u)+u.length));const E=v.split(l);for(let N=1;k&&N<=E.length;N++)for(let z=E.length-N;k&&z>=0;z--){k=!1;let M=E.slice(z,z+N).join(l);for(let T=0;!k&&T<c.length;T++)if(T!==C&&c[T]&&c[T].indexOf(M)>-1){const j=z+N===E.length,O=z>0&&c[T].indexOf(l)>-1?l+M:M,V=c[T].endsWith(O);k=!j||V}if(!k){let T="";(E[0].endsWith(":")||p!=="")&&(z===1&&(z=0,N++,M=E[0]+l+M),z>0&&(T=E[0]+l),T=p+T),z>0&&(T=T+D+l),T=T+M,z+N<E.length&&(T=T+l+D),h[C]=T}}k&&(h[C]=m)}return h}e.$Cv=o;var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,l=Object.create(null)){const h=[];let k=!1,C="";for(const m of c)if(m==="$"||k&&m==="{")C&&h.push({value:C,type:i.TEXT}),C="",k=!0;else if(m==="}"&&k){const p=l[C];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const v=h[h.length-1];(!v||v.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}C="",k=!1}else C+=m;return C&&!k&&h.push({value:C,type:i.TEXT}),h.filter((m,p)=>{if(m.type===i.SEPARATOR){const v=h[p-1],E=h[p+1];return[v,E].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(m=>m.value).join("")}e.$Dv=n;function r(c,l){return R.$j||l?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Ev=r;function a(c,l){return R.$j||l?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,h=>h==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$Fv=a;function t(c){return c.replace(/&/g,"&&")}e.$Gv=t;function s(c){if(c.endsWith("]")){const l=c.lastIndexOf(" [",c.length-2);if(l!==-1){const h=d(c.substring(0,l));return{name:h.name,parentPath:h.parentPath+c.substring(l)}}}return d(c)}e.$Hv=s;function d(c){const l=c.indexOf("/")!==-1?f.$fc:f.$ec,h=l.basename(c),k=l.dirname(c);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function f(P){return P.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const S=this.a.transformIncoming($);return S===$?$:f(F.URI.from(S))}transformOutgoing($){const S=this.a.transformOutgoing($);return S===$?$:f(F.URI.from(S))}transformOutgoingURI($){const S=this.a.transformOutgoing($);return S===$?$:F.URI.from(S)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Rm=R,e.$Sm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function L(P,$,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof F.URI)return $.transformOutgoing(P);for(const D in P)if(Object.hasOwnProperty.call(P,D)){const w=L(P[D],$,S+1);w!==null&&(P[D]=w)}}return null}function b(P,$){const S=L(P,$,0);return S===null?P:S}e.$Tm=b;function y(P,$,S,D){if(!P||D>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?F.URI.revive($.transformIncoming(P)):$.transformIncoming(P);if(P instanceof I.$fe)return null;for(const w in P)if(Object.hasOwnProperty.call(P,w)){const u=y(P[w],$,S,D+1);u!==null&&(P[w]=u)}}return null}function g(P,$){const S=y(P,$,!1,0);return S===null?P:S}e.$Um=g;function A(P,$){const S=y(P,$,!0,0);return S===null?P:S}e.$Vm=A}),define(ke[30],Se([1,0,55,63,385,11,33,76,16,12,23,2]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function S(O,V=$.UNLINK,te){if((0,L.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");return V===$.UNLINK?w(O):D(O,te)}async function D(O,V=(0,L.$0f)((0,F.tmpdir)())){try{try{await I.promises.rename(O,V)}catch(te){return te.code==="ENOENT"?void 0:w(O)}w(V).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function w(O){return(0,f.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function u(O){if((0,L.$5f)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function o(O,V){return r(await(V?i(O):(0,f.promisify)(I.readdir)(O)))}async function i(O){try{return await(0,f.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const V=[],te=await o(O);for(const fe of te){let Z=!1,Q=!1,G=!1;try{const oe=await e.Promises.lstat((0,y.$ic)(O,fe));Z=oe.isFile(),Q=oe.isDirectory(),G=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}V.push({name:fe,isFile:()=>Z,isDirectory:()=>Q,isSymbolicLink:()=>G})}return V}function n(O){return r(I.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(V=>typeof V=="string"?g.$j?(0,b.$ul)(V):V:(V.name=g.$j?(0,b.$ul)(V.name):V.name,V))}async function a(O){const V=await o(O),te=[];for(const fe of V)await s.existsDirectory((0,y.$ic)(O,fe))&&te.push(fe);return te}function t(O,V=1e3){return new Promise(te=>{let fe=!1;const Z=setInterval(()=>{fe||(fe=!0,I.access(O,Q=>{fe=!1,Q&&(clearInterval(Z),te(void 0))}))},V)})}e.whenDeleted=t;var s;(function(O){async function V(Z){let Q;try{if(Q=await e.Promises.lstat(Z),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(g.$i&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw G}}O.stat=V;async function te(Z){try{const{stat:Q,symbolicLink:G}=await O.stat(Z);return Q.isFile()&&G?.dangling!==!0}catch{}return!1}O.existsFile=te;async function fe(Z){try{const{stat:Q,symbolicLink:G}=await O.stat(Z);return Q.isDirectory()&&G?.dangling!==!0}catch{}return!1}O.existsDirectory=fe})(s||(e.SymlinkSupport=s={}));const d=new R.$7g;function c(O,V,te){return d.queueFor(P.URI.file(O),A.$qg).queue(()=>{const fe=m(te);return new Promise((Z,Q)=>k(O,V,fe,G=>G?Q(G):Z()))})}let l=!0;function h(O){l=O}e.configureFlushOnWrite=h;function k(O,V,te,fe){if(!l)return I.writeFile(O,V,{mode:te.mode,flag:te.flag},fe);I.open(O,te.flag,te.mode,(Z,Q)=>{if(Z)return fe(Z);I.writeFile(Q,V,G=>{if(G)return I.close(Q,()=>fe(G));I.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),h(!1)),I.close(Q,x=>fe(x))))})})}function C(O,V,te){const fe=m(te);if(!l)return I.writeFileSync(O,V,{mode:fe.mode,flag:fe.flag});const Z=I.openSync(O,fe.flag,fe.mode);try{I.writeFileSync(Z,V);try{I.fdatasyncSync(Z)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{I.closeSync(Z)}}e.writeFileSync=C;function m(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function p(O,V,te=6e4){if(O!==V)try{g.$i&&typeof te=="number"?await v(O,V,Date.now(),te):await(0,f.promisify)(I.rename)(O,V)}catch(fe){if(O.toLowerCase()!==V.toLowerCase()&&fe.code==="EXDEV"||O.endsWith("."))await E(O,V,{preserveSymlinks:!1}),await S(O,$.MOVE);else throw fe}}async function v(O,V,te,fe,Z=0){try{return await(0,f.promisify)(I.rename)(O,V)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-te>=fe)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Q}`),Q;if(Z===0){let G=!1;try{const{stat:oe}=await s.stat(V);oe.isFile()||(G=!0)}catch{}if(G)throw Q}return await(0,R.$Yg)(Math.min(100,Z*10)),v(O,V,te,fe,Z+1)}}async function E(O,V,te){return z(O,V,{root:{source:O,target:V},options:te,handledSourcePaths:new Set})}const N=511;async function z(O,V,te){if(te.handledSourcePaths.has(O))return;te.handledSourcePaths.add(O);const{stat:fe,symbolicLink:Z}=await s.stat(O);if(Z){if(te.options.preserveSymlinks)try{return await j(O,V,te)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(Z.dangling)return}return fe.isDirectory()?M(O,V,fe.mode&N,te):T(O,V,fe.mode&N)}async function M(O,V,te,fe){await e.Promises.mkdir(V,{recursive:!0,mode:te});const Z=await o(O);for(const Q of Z)await z((0,y.$ic)(O,Q),(0,y.$ic)(V,Q),fe)}async function T(O,V,te){await e.Promises.copyFile(O,V),await e.Promises.chmod(V,te)}async function j(O,V,te){let fe=await e.Promises.readlink(O);(0,L.$2f)(fe,te.root.source,!g.$k)&&(fe=(0,y.$ic)(te.root.target,fe.substr(te.root.source.length+1))),await e.Promises.symlink(fe,V)}e.Promises=new class{get access(){return(0,f.promisify)(I.access)}get stat(){return(0,f.promisify)(I.stat)}get lstat(){return(0,f.promisify)(I.lstat)}get utimes(){return(0,f.promisify)(I.utimes)}get read(){return(O,V,te,fe,Z)=>new Promise((Q,G)=>{I.read(O,V,te,fe,Z,(oe,x,Ee)=>oe?G(oe):Q({bytesRead:x,buffer:Ee}))})}get readFile(){return(0,f.promisify)(I.readFile)}get write(){return(O,V,te,fe,Z)=>new Promise((Q,G)=>{I.write(O,V,te,fe,Z,(oe,x,Ee)=>oe?G(oe):Q({bytesWritten:x,buffer:Ee}))})}get appendFile(){return(0,f.promisify)(I.appendFile)}get fdatasync(){return(0,f.promisify)(I.fdatasync)}get truncate(){return(0,f.promisify)(I.truncate)}get copyFile(){return(0,f.promisify)(I.copyFile)}get open(){return(0,f.promisify)(I.open)}get close(){return(0,f.promisify)(I.close)}get symlink(){return(0,f.promisify)(I.symlink)}get readlink(){return(0,f.promisify)(I.readlink)}get chmod(){return(0,f.promisify)(I.chmod)}get mkdir(){return(0,f.promisify)(I.mkdir)}get unlink(){return(0,f.promisify)(I.unlink)}get rmdir(){return(0,f.promisify)(I.rmdir)}get realpath(){return(0,f.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return c}get rm(){return S}get rename(){return p}get copy(){return E}}}),define(ke[103],Se([1,0,55,16,12,13,30]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function b($){if(f.$k)return $;const S=(0,F.$lc)($);if($===S)return $;const D=((0,F.$mc)($)||$).toLowerCase();try{const u=(0,L.readdirSync)(S).filter(o=>o.toLowerCase()===D);if(u.length===1){const o=b(S);if(o)return(0,F.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(D);if(o>=0){const i=b(S);if(i)return(0,F.$ic)(i,u[o])}}}catch{}return null}e.$$p=b;async function y($){if(f.$k)return $;const S=(0,F.$lc)($);if($===S)return $;const D=((0,F.$mc)($)||$).toLowerCase();try{const u=(await L.Promises.readdir(S)).filter(o=>o.toLowerCase()===D);if(u.length===1){const o=await y(S);if(o)return(0,F.$ic)(o,u[0])}else if(u.length>1){const o=u.indexOf(D);if(o>=0){const i=await y(S);if(i)return(0,F.$ic)(i,u[o])}}}catch{}return null}e.$_p=y;async function g($){try{return await L.Promises.realpath($)}catch{const D=P($);return await L.Promises.access(D,I.constants.R_OK),D}}e.$aq=g;function A($){try{return I.realpathSync($)}catch{const D=P($);return I.accessSync(D,I.constants.R_OK),D}}e.$bq=A;function P($){return(0,R.$Oe)((0,F.$gc)($),F.sep)}}),define(ke[104],Se([1,0,16,12,49,101,18,30]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=f.env){return P.comspec||"cmd.exe"}e.$Hl=y;function g(P){let $=[],S=!1;const D=function(w){if(S){$.push(w);return}(!P.send(w,o=>{if(o&&console.error(o),S=!1,$.length>0){const i=$.slice(0);$=[],i.forEach(n=>D(n))}})||F.$i)&&(S=!0)};return{send:D}}e.$Il=g;var A;(function(P){async function $(S,D,w){if(I.$hc(S))return S;if(D===void 0&&(D=f.cwd()),I.$lc(S)!=="."||(w===void 0&&L.$Cf(f.env.PATH)&&(w=f.env.PATH.split(I.$sc)),w===void 0||w.length===0))return I.$ic(D,S);async function o(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(I.$hc(i)?n=I.$ic(i,S):n=I.$ic(D,i,S),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return I.$ic(D,S)}P.findExecutable=$})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,I,F){var f=arguments.length,R=f<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,I,F);else for(var b=me.length-1;b>=0;b--)(L=me[b])&&(R=(f<3?L(R):f>3?L(e,I,R):L(e,I))||R);return f>3&&R&&Object.defineProperty(e,I,R),R};define(ke[81],Se([1,0,19,11,22,21,59,8,4,3,54,13,18]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var S;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(S||(S={}));function D(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(w||(w={}));function u(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(o||(o={}));function i(Z){let Q=0;for(let G=0;;G+=7){const oe=Z.read(1);if(Q|=(oe.buffer[0]&127)<<G,!(oe.buffer[0]&128))return Q}}const n=d(0);function r(Z,Q){if(Q===0){Z.write(n);return}let G=0;for(let x=Q;x!==0;x=x>>>7)G++;const oe=f.$fe.alloc(G);for(let x=0;Q!==0;x++)oe.buffer[x]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[x]|=128);Z.write(oe)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const G=this.b.slice(this.a,this.a+Q);return this.a+=G.byteLength,G}}e.$th=a;class t{constructor(){this.a=[]}get buffer(){return f.$fe.concat(this.a)}write(Q){this.a.push(Q)}}e.$uh=t;var s;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(s||(s={}));function d(Z){const Q=f.$fe.alloc(1);return Q.writeUInt8(Z,0),Q}const c={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},l=typeof Buffer<"u";function h(Z,Q){if(typeof Q>"u")Z.write(c.Undefined);else if(typeof Q=="string"){const G=f.$fe.fromString(Q);Z.write(c.String),r(Z,G.byteLength),Z.write(G)}else if(l&&Buffer.isBuffer(Q)){const G=f.$fe.wrap(Q);Z.write(c.Buffer),r(Z,G.byteLength),Z.write(G)}else if(Q instanceof f.$fe)Z.write(c.VSBuffer),r(Z,Q.byteLength),Z.write(Q);else if(Array.isArray(Q)){Z.write(c.Array),r(Z,Q.length);for(const G of Q)h(Z,G)}else if(typeof Q=="number"&&(Q|0)===Q)Z.write(c.Uint),r(Z,Q);else{const G=f.$fe.fromString(JSON.stringify(Q));Z.write(c.Object),r(Z,G.byteLength),Z.write(G)}}e.$vh=h;function k(Z){switch(Z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return Z.read(i(Z)).toString();case s.Buffer:return Z.read(i(Z)).buffer;case s.VSBuffer:return Z.read(i(Z));case s.Array:{const G=i(Z),oe=[];for(let x=0;x<G;x++)oe.push(k(Z));return oe}case s.Object:return JSON.parse(Z.read(i(Z)).toString());case s.Int:return i(Z)}}e.$wh=k;class C{constructor(Q,G,oe=null,x=1e3){this.h=Q,this.j=G,this.k=oe,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(Q,G){this.b.set(Q,G),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const G=this.o([Q.type]);this.k?.logOutgoing(G,0,1,u(Q.type));return}case 201:case 202:case 204:case 203:{const G=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(G,Q.id,1,u(Q.type),Q.data);return}}}o(Q,G=void 0){const oe=new t;return h(oe,Q),h(oe,G),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const G=new a(Q),oe=k(G),x=k(G),Ee=oe[0];switch(Ee){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(Ee)}: ${oe[2]}.${oe[3]}`,x),this.s({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(Ee)}: ${oe[2]}.${oe[3]}`,x),this.t({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:x});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(Ee)}`),this.u({type:Ee,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${D(Ee)}`),this.u({type:Ee,id:oe[1]})}}s(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const oe=new R.$2d;let x;try{x=G.call(this.j,Q.name,Q.arg,oe.token)}catch(q){x=Promise.reject(q)}const Ee=Q.id;x.then(q=>{this.m({id:Ee,data:q,type:201})},q=>{q instanceof Error?this.m({id:Ee,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Ee,data:q,type:203})}).finally(()=>{le.dispose(),this.d.delete(Q.id)});const le=(0,g.$Pc)(()=>oe.cancel());this.d.set(Q.id,le)}t(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const oe=Q.id,Ee=G.listen(this.j,Q.name,Q.arg)(le=>this.m({id:oe,data:le,type:204}));this.d.set(Q.id,Ee)}u(Q){const G=this.d.get(Q.id);G&&(G.dispose(),this.d.delete(Q.id))}v(Q){let G=this.g.get(Q.channelName);G||(G=[],this.g.set(Q.channelName,G));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:Q,timeoutTimer:oe})}w(Q){const G=this.g.get(Q);if(G){for(const oe of G)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$xh=C;var m;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class p{constructor(Q,G=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=G}getChannel(Q){const G=this;return{call(oe,x,Ee){return G.a?Promise.reject(new b.$4):G.m(Q,oe,x,Ee)},listen(oe,x){return G.a?y.Event.None:G.o(Q,oe,x)}}}m(Q,G,oe,x=R.CancellationToken.None){const Ee=this.g++,q={id:Ee,type:100,channelName:Q,name:G,arg:oe};if(x.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((be,H)=>{if(x.isCancellationRequested)return H(new b.$4);const X=()=>{const de=ee=>{switch(ee.type){case 201:this.f.delete(Ee),be(ee.data);break;case 202:{this.f.delete(Ee);const he=new Error(ee.data.message);he.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,he.name=ee.data.name,H(he);break}case 203:this.f.delete(Ee),H(ee.data);break}};this.f.set(Ee,de),this.p(q)};let Y=null;this.b===o.Idle?X():(Y=(0,F.$Lg)(de=>this.u()),Y.then(()=>{Y=null,X()}));const $e=()=>{Y?(Y.cancel(),Y=null):this.p({id:Ee,type:101}),H(new b.$4)},ne=x.onCancellationRequested($e);U=(0,g.$Oc)((0,g.$Pc)($e),ne),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,G,oe){const x=this.g++,le={id:x,type:102,channelName:Q,name:G,arg:oe};let q=null;const U=new y.$Rd({onWillAddFirstListener:()=>{q=(0,F.$Lg)(be=>this.u()),q.then(()=>{q=null,this.d.add(U),this.p(le)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(U),this.p({id:x,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(x,ie),U.event}p(Q){switch(Q.type){case 100:case 102:{const G=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(G,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const G=this.q([Q.type,Q.id]);this.j?.logOutgoing(G,Q.id,0,D(Q.type));return}}}q(Q,G=void 0){const oe=new t;return h(oe,Q),h(oe,G),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const G=new a(Q),oe=k(G),x=k(G),Ee=oe[0];switch(Ee){case 200:return this.j?.logIncoming(Q.byteLength,0,0,u(Ee)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,u(Ee),x),this.t({type:oe[0],id:oe[1],data:x})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$yh=p,He([L.$nh],p.prototype,"onDidInitializePromise",null);class v{get connections(){const Q=[];return this.f.forEach(G=>Q.push(G)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new y.$Rd,this.onDidAddConnection=this.g.event,this.h=new y.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(Q(({protocol:G,onDidClientDisconnect:oe})=>{const x=y.Event.once(G.onMessage);this.j.add(x(Ee=>{const le=new a(Ee),q=k(le),U=new C(G,q),ie=new p(G);this.a.forEach((H,X)=>U.registerChannel(X,H));const be={channelServer:U,channelClient:ie,ctx:q};this.f.add(be),this.g.fire(be),this.j.add(oe(()=>{U.dispose(),ie.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(Q,G){const oe=this;return{call(x,Ee,le){let q;if((0,$.$Qf)(G)){const ie=(0,I.$3b)(oe.connections.filter(G));q=ie?Promise.resolve(ie):y.Event.toPromise(y.Event.filter(oe.onDidAddConnection,G))}else q=G.routeCall(oe,x,Ee);const U=q.then(ie=>ie.channelClient.getChannel(Q));return N(U).call(x,Ee,le)},listen(x,Ee){if((0,$.$Qf)(G))return oe.k(Q,G,x,Ee);const le=G.routeEvent(oe,x,Ee).then(q=>q.channelClient.getChannel(Q));return N(le).listen(x,Ee)}}}k(Q,G,oe,x){const Ee=this;let le;const q=new y.$Rd({onWillAddFirstListener:()=>{le=new g.$Qc;const U=new y.$Xd,ie=new Map,be=X=>{const $e=X.channelClient.getChannel(Q).listen(oe,x),ne=U.add($e);ie.set(X,ne)},H=X=>{const Y=ie.get(X);Y&&(Y.dispose(),ie.delete(X))};Ee.connections.filter(G).forEach(be),y.Event.filter(Ee.onDidAddConnection,G)(be,void 0,le),Ee.onDidRemoveConnection(H,void 0,le),U.event(q.fire,q,le),le.add(U)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return q.event}registerChannel(Q,G){this.a.set(Q,G);for(const oe of this.f)oe.channelServer.registerChannel(Q,G)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=v;class E{constructor(Q,G,oe=null){const x=new t;h(x,G),Q.send(x.buffer),this.a=new p(Q,oe),this.d=new C(Q,G,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,G){this.d.registerChannel(Q,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=E;function N(Z){return{call(Q,G,oe){return Z.then(x=>x.call(Q,G,oe))},listen(Q,G){const oe=new y.$1d;return Z.then(x=>oe.input=x.listen(Q,G)),oe.event}}}e.$Bh=N;function z(Z){let Q=!1;return{call(G,oe,x){return Q?Z.call(G,oe,x):(0,F.$Yg)(0).then(()=>Q=!0).then(()=>Z.call(G,oe,x))},listen(G,oe){if(Q)return Z.listen(G,oe);const x=new y.$1d;return(0,F.$Yg)(0).then(()=>Q=!0).then(()=>x.input=Z.listen(G,oe)),x.event}}}e.$Ch=z;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const G of Q.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await y.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Dh=M;var T;(function(Z){function Q(Ee,le,q){const U=Ee,ie=q&&q.disableMarshalling,be=new Map;for(const H in U)oe(H)&&be.set(H,y.Event.buffer(U[H],!0,void 0,le));return new class{listen(H,X,Y){const $e=be.get(X);if($e)return $e;if(x(X)){const ne=U[X];if(typeof ne=="function")return ne.call(U,Y)}throw new b.$ab(`Event not found: ${X}`)}call(H,X,Y){const $e=U[X];if(typeof $e=="function"){if(!ie&&Array.isArray(Y))for(let de=0;de<Y.length;de++)Y[de]=(0,A.$sh)(Y[de]);let ne=$e.apply(U,Y);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new b.$ab(`Method not found: ${X}`)}}}Z.fromService=Q;function G(Ee,le){const q=le&&le.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return le?.properties?.has(ie)?le.properties.get(ie):x(ie)?function(be){return Ee.listen(ie,be)}:oe(ie)?Ee.listen(ie):async function(...be){let H;le&&!(0,$.$Lf)(le.context)?H=[le.context,...be]:H=be;const X=await Ee.call(ie,H);return q?X:(0,A.$sh)(X)};throw new b.$ab(`Property not found: ${String(ie)}`)}})}Z.toService=G;function oe(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&P.$5e(Ee.charCodeAt(2))}function x(Ee){return/^onDynamic/.test(Ee)&&P.$5e(Ee.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const Q=Z.toString();if(Q!=="[object Object]")return Q}return Z}function V(Z){return Array.isArray(Z)?Z.map(O):O(Z)}function te(Z,Q,G,oe,x,Ee,le){le=V(le);const q=j[x],U=q[oe%q.length];let ie=[`%c[${Z}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Ee)?(ie=ie.concat(le),ie.push(")")):ie.push(le),console.log.apply(console,ie)}class fe{constructor(Q,G){this.d=Q,this.f=G,this.a=0,this.b=0}logOutgoing(Q,G,oe,x,Ee){this.b+=Q,te(this.d,this.b,Q,G,oe,x,Ee)}logIncoming(Q,G,oe,x,Ee){this.a+=Q,te(this.f,this.a,Q,G,oe,x,Ee)}}e.$Eh=fe}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const l=new WeakMap;let h=0;function k(m,p){if(!l.has(m)){const v=String(++h);l.set(m,v)}return l.get(m)}function C(m,p,v,E){if(!c.enableDiagnostics)return;const N=k(m,p);if(E instanceof I.$fe||E instanceof Uint8Array||E instanceof ArrayBuffer||ArrayBuffer.isView(E)){const z=I.$fe.alloc(E.byteLength);z.set(E),c.records.push({timestamp:Date.now(),id:N,label:p,type:v,buff:z})}else c.records.push({timestamp:Date.now(),id:N,label:p,type:v,data:E})}c.traceSocketEvent=C})(b||(e.SocketDiagnostics=b={}));var y;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let g=null;function A(){return g||(g=I.$fe.alloc(0)),g}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return A();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const p=this.a[0];return h&&(this.a.shift(),this.b-=l),p}if(this.a[0].byteLength>l){const p=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),p}const k=I.$fe.alloc(l);let C=0,m=0;for(;l>0;){const p=this.a[m];if(p.byteLength>l){const v=p.slice(0,l);k.set(v,C),C+=l,h&&(this.a[m]=p.slice(l),this.b-=l),l-=l}else k.set(p,C),C+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):m++,l-=p.byteLength}return k}}e.$Fh=P;var $;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})($||($={}));function S(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class w{constructor(l,h,k,C){this.type=l,this.id=h,this.ack=k,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class u extends f.$Rc{constructor(l){super(),this.f=this.B(new F.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,C=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(k,C,m,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$fe.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const k=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,k}h(){const l=I.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends f.$Rc{constructor(l){super(),this.f=new F.$Rd,this.onMessage=this.f.event,this.g=new F.$Rd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new o(this.a)),this.c=this.B(new u(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new w(1,0,0,l))}}e.$Gh=i;class n extends R.$Ah{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,k=null){super(l,h,k),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Hh=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Ih=r;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,k=this.a;for(;k;)l[h++]=k.data,k=k.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<s.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=s.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+s.a)*1e3;let k=0;for(let C=0;C<s.a;C++)l-this.c[C]<=h&&k++;return 1-k/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??s.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Qc,this.o=l.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new w(5,0,0,A());this.p.write(l),this.p.flush()}sendPause(){const l=new w(7,0,0,A());this.p.write(l)}sendResume(){const l=new w(8,0,0,A());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new f.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new u(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l);const h=this.b.toArray();for(let k=0,C=h.length;k<C;k++)this.p.write(h[k]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let k=0,C=h.length;k<C;k++)this.p.write(h[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const k=new w(1,h,this.h,l);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(l){const h=new w(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,k=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(h>=2e4&&k>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const m=Math.max(2e4-h,2e4-k,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l)}D(){this.h=this.g;const l=new w(9,0,this.h,A());this.p.write(l)}}e.$Jh=d}),define(ke[187],Se([1,0,50,11,22,21,185,8,4,3,24,104,101,81]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class D extends S.$xh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",i=>f.$fe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$8p=D;class w{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new y.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$Ug(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,a){return i.k(o,n,r,a)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const a=this.n(o),t=(0,F.$Lg)(c=>a.call(i,n,c)),s=r.onCancellationRequested(()=>t.cancel()),d=(0,g.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return y.Event.None;this.b.cancel();let r;const a=new y.$Rd({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,$.$Gl)(i.env),this.d=(0,I.fork)(this.i,o,i);const n=new y.$Rd;y.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,L.$4p)(l)){(0,L.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(f.$fe.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,P.$Il)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),s=n.event,d={send:t,onMessage:s};this.f=new S.$yh(d);const c=()=>this.o();process.once("exit",c),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",c),this.c.forEach(k=>(0,g.$Mc)(k)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=w}),define(ke[188],Se([1,0,11,4,3,54,18]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function y($){const S=$;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$7o=y;var g;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(g||(e.StorageState=g={}));class A extends f.$Rc{static{this.a=100}constructor(S,D=Object.create(null)){super(),this.r=S,this.s=D,this.b=this.B(new F.$Ud),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Vg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((D,w)=>this.w(w,D)),S.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(S,D){if(this.c===g.Closed)return;let w=!1;(0,L.$Lf)(D)?w=this.f.delete(S):this.f.get(S)!==D&&(this.f.set(S,D),w=!0),w&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,D){const w=this.f.get(S);return(0,L.$Lf)(w)?D:w}getBoolean(S,D){const w=this.get(S);return(0,L.$Lf)(w)?D:w==="true"}getNumber(S,D){const w=this.get(S);return(0,L.$Lf)(w)?D:parseInt(w,10)}getObject(S,D){const w=this.get(S);return(0,L.$Lf)(w)?D:(0,R.$rh)(w)}async set(S,D,w=!1){if(this.c===g.Closed)return;if((0,L.$Lf)(D))return this.delete(S,w);const u=(0,L.$Ef)(D)||Array.isArray(D)?(0,R.$qh)(D):String(D);if(this.f.get(S)!==u)return this.f.set(S,u),this.j.set(S,u),this.h.delete(S),this.b.fire({key:S,external:w}),this.D()}async delete(S,D=!1){if(!(this.c===g.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:D}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$8o=A;class P{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((D,w)=>this.a.set(w,D)),S.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$9o=P}),define(ke[189],Se([1,0,13,12,22]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function y(){return b||(b=new TextDecoder("UTF-16BE")),b}let g;function A(){return g||(g=F.$D()?L():y()),g}e.$Ss=A;function P(D,w,u){const o=new Uint16Array(D.buffer,w,u);return u>0&&(o[0]===65279||o[0]===65534)?$(D,w,u):L().decode(o)}e.$Ts=P;function $(D,w,u){const o=[];let i=0;for(let n=0;n<u;n++){const r=f.$he(D,w);w+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class S{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const u=this.a-this.d;u<=1&&(u===0||I.$0e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const u=w.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=w;return}for(let o=0;o<u;o++)this.b[this.d++]=w.charCodeAt(o)}}e.$Us=S}),define(ke[190],Se([1,0,22,189]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0;function f(y){return y.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,P,$){this.oldPosition=g,this.oldText=A,this.newPosition=P,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,P){const $=A.length;I.$ke(g,$,P),P+=4;for(let S=0;S<$;S++)I.$ie(g,A.charCodeAt(S),P),P+=2;return P}static d(g,A){const P=I.$je(g,A);return A+=4,(0,F.$Ts)(g,A,P)}writeSize(){return 4+4+R.a(this.oldText)+R.a(this.newText)}write(g,A){return I.$ke(g,this.oldPosition,A),A+=4,I.$ke(g,this.newPosition,A),A+=4,A=R.c(g,this.oldText,A),A=R.c(g,this.newText,A),A}static read(g,A,P){const $=I.$je(g,A);A+=4;const S=I.$je(g,A);A+=4;const D=R.d(g,A);A+=R.a(D);const w=R.d(g,A);return A+=R.a(w),P.push(new R($,D,S,w)),A}}e.$Vs=R;function L(y,g){return y===null||y.length===0?g:new b(y,g).compress()}e.$Ws=L;class b{constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,P=this.n(g),$=this.l(A);for(;g<this.f||A<this.h;){if(P===null){this.k($),$=this.l(++A);continue}if($===null){this.m(P),P=this.n(++g);continue}if($.oldEnd<=P.newPosition){this.k($),$=this.l(++A);continue}if(P.newEnd<=$.oldPosition){this.m(P),P=this.n(++g);continue}if($.oldPosition<P.newPosition){const[o,i]=b.r($,P.newPosition-$.oldPosition);this.k(o),$=i;continue}if(P.newPosition<$.oldPosition){const[o,i]=b.q(P,$.oldPosition-P.newPosition);this.m(o),P=i;continue}let w,u;if($.oldEnd===P.newEnd)w=P,u=$,P=this.n(++g),$=this.l(++A);else if($.oldEnd<P.newEnd){const[o,i]=b.q(P,$.oldLength);w=o,u=$,P=i,$=this.l(++A)}else{const[o,i]=b.r($,P.newLength);w=P,u=o,P=this.n(++g),$=i}this.d[this.e++]=new R(w.oldPosition,w.oldText,u.newPosition,u.newText),this.g+=w.newLength-w.oldLength,this.j+=u.newLength-u.oldLength}const S=b.s(this.d);return b.t(S)}k(g){this.d[this.e++]=b.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=b.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new R(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new R(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const P=g.newText.substr(0,A),$=g.newText.substr(A);return[new R(g.oldPosition,g.oldText,g.newPosition,P),new R(g.oldEnd,"",g.newPosition+A,$)]}static r(g,A){const P=g.oldText.substr(0,A),$=g.oldText.substr(A);return[new R(g.oldPosition,P,g.newPosition,g.newText),new R(g.oldPosition+A,$,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let P=0,$=g[0];for(let S=1;S<g.length;S++){const D=g[S];$.oldEnd===D.oldPosition?$=new R($.oldPosition,$.oldText+D.oldText,$.newPosition,$.newText+D.newText):(A[P++]=$,$=D)}return A[P++]=$,A}static t(g){if(g.length===0)return g;const A=[];let P=0;for(let $=0;$<g.length;$++){const S=g[$];S.oldText!==S.newText&&(A[P++]=S)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function f(R,L,b,y,g,A){if(Array.isArray(R)){let P=0;for(const $ of R){const S=f($,L,b,y,g,A);if(S===10)return S;S>P&&(P=S)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===b?10:0:0;if(R){const{language:P,pattern:$,scheme:S,hasAccessToAllModels:D,notebookType:w}=R;if(!y&&!D)return 0;w&&g&&(L=g);let u=0;if(S)if(S===L.scheme)u=10;else if(S==="*")u=5;else return 0;if(P)if(P===b)u=10;else if(P==="*")u=Math.max(u,5);else return 0;if(w)if(w===A)u=10;else if(w==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,F.$gc)($.base)},o===L.fsPath||(0,I.$Bj)(o,L.fsPath))u=10;else return 0}return u}else return 0}}e.$LE=f}),define(ke[192],Se([1,0,4,13,29,79,128,167,190,3]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class A extends g.$Rc{constructor($,S,D,w,u,o,i){super(),this.m=this.B(new I.$Rd),this.onDidChangeContent=this.m.event,this.f=S,this.j=!o,this.g=w,this.h=u,this.c=new L.$LB($,D,i)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,S){return this.c.getOffsetAt($,S)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,S){const D=$+S,w=this.getPositionAt($),u=this.getPositionAt(D);return new f.$As(w.lineNumber,w.column,u.lineNumber,u.column)}getValueInRange($,S=0){if($.isEmpty())return"";const D=this.n(S);return this.c.getValueInRange($,D)}getValueLengthInRange($,S=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const D=this.getOffsetAt($.startLineNumber,$.startColumn),w=this.getOffsetAt($.endLineNumber,$.endColumn);let u=0;const o=this.n(S),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=$.endLineNumber-$.startLineNumber;u=n*r}return w-D+u}getCharacterCountInRange($,S=0){if(this.j){let D=0;const w=$.startLineNumber,u=$.endLineNumber;for(let o=w;o<=u;o++){const i=this.getLineContent(o),n=o===w?$.startColumn-1:0,r=o===u?$.endColumn-1:i.length;for(let a=n;a<r;a++)F.$0e(i.charCodeAt(a))?(D=D+1,a=a+1):D=D+1}return D+=this.n(S).length*(u-w),D}return this.getValueLengthInRange($,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,S){return this.c.getLineCharCode($,S)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const S=F.$Ue(this.getLineContent($));return S===-1?0:S+1}getLineLastNonWhitespaceColumn($){const S=F.$We(this.getLineContent($));return S===-1?0:S+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,S,D){let w=this.g,u=this.h,o=this.j,i=!0,n=[];for(let l=0;l<$.length;l++){const h=$[l];i&&h._isTracked&&(i=!1);const k=h.range;if(h.text){let E=!0;o||(E=!F.$if(h.text),o=E),!w&&E&&(w=F.$hf(h.text)),!u&&E&&(u=F.$kf(h.text))}let C="",m=0,p=0,v=0;if(h.text){let E;[m,p,v,E]=(0,b.$at)(h.text);const N=this.getEOL();E===0||E===(N===`\r
`?2:1)?C=h.text:C=h.text.replace(/\r\n|\r|\n/g,N)}n[l]={sortIndex:l,identifier:h.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:C,eolCount:m,firstLineLength:p,lastLineLength:v,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let l=0,h=n.length-1;l<h;l++){const k=n[l].range.getEndPosition(),C=n[l+1].range.getStartPosition();if(C.isBeforeOrEqual(k)){if(C.isBefore(k))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=D||S?A._getInverseEditRanges(n):[],t=[];if(S)for(let l=0;l<n.length;l++){const h=n[l],k=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let C=k.startLineNumber;C<=k.endLineNumber;C++){let m="";C===k.startLineNumber&&(m=this.getLineContent(h.range.startLineNumber),F.$Ue(m)!==-1)||t.push({lineNumber:C,oldContent:m})}}let s=null;if(D){let l=0;s=[];for(let h=0;h<n.length;h++){const k=n[h],C=a[h],m=this.getValueInRange(k.range),p=k.rangeOffset+l;l+=k.text.length-m.length,s[h]={sortIndex:k.sortIndex,identifier:k.identifier,range:C,text:m,textChange:new y.$Vs(k.rangeOffset,m,p,k.text)}}r||s.sort((h,k)=>h.sortIndex-k.sortIndex)}this.g=w,this.h=u,this.j=o;const d=this.t(n);let c=null;if(S&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),c=[];for(let l=0,h=t.length;l<h;l++){const k=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===k)continue;const C=t[l].oldContent,m=this.getLineContent(k);m.length===0||m===C||F.$Ue(m)!==-1||c.push(k)}}return this.m.fire(),new R.$Vu(s,d,c)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let S=!1;const D=$[0].range,w=$[$.length-1].range,u=new f.$As(D.startLineNumber,D.startColumn,w.endLineNumber,w.endColumn);let o=D.startLineNumber,i=D.startColumn;const n=[];for(let d=0,c=$.length;d<c;d++){const l=$[d],h=l.range;S=S||l.forceMoveMarkers,n.push(this.getValueInRange(new f.$As(o,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),o=h.endLineNumber,i=h.endColumn}const r=n.join(""),[a,t,s]=(0,b.$at)(r);return{sortIndex:0,identifier:$[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:s,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const S=[];for(let D=0;D<$.length;D++){const w=$[D],u=w.range.startLineNumber,o=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(u===i&&o===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const r=new f.$As(u,o,i,n);S.push({range:r,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return S}findMatchesLineByLine($,S,D,w){return this.c.findMatchesLineByLine($,S,D,w)}getPieceTree(){return this.c}static _getInverseEditRange($,S){const D=$.startLineNumber,w=$.startColumn,[u,o,i]=(0,b.$at)(S);let n;if(S.length>0){const r=u+1;r===1?n=new f.$As(D,w,D,w+o):n=new f.$As(D,w,D+r-1,i+1)}else n=new f.$As(D,w,D,w);return n}static _getInverseEditRanges($){const S=[];let D=0,w=0,u=null;for(let o=0,i=$.length;o<i;o++){const n=$[o];let r,a;u?u.range.endLineNumber===n.range.startLineNumber?(r=D,a=w+(n.range.startColumn-u.range.endColumn)):(r=D+(n.range.startLineNumber-u.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new f.$As(r,a,r,a+n.firstLineLength):t=new f.$As(r,a,r+s-1,n.lastLineLength+1)}else t=new f.$As(r,a,r,a);D=t.endLineNumber,w=t.endColumn,S.push(t),u=n}return S}static u($,S){const D=f.$As.compareRangesUsingEnds($.range,S.range);return D===0?$.sortIndex-S.sortIndex:D}static w($,S){const D=f.$As.compareRangesUsingEnds($.range,S.range);return D===0?S.sortIndex-$.sortIndex:-D}}e.$MB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class R{constructor(y,g,A,P,$,S,D,w,u){this.a=y,this.b=g,this.c=A,this.d=P,this.e=$,this.f=S,this.g=D,this.h=w,this.j=u}k(y){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?y===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(y){const g=this.k(y),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let $=0,S=A.length;$<S;$++){const D=A[$].buffer.replace(/\r\n|\r|\n/g,g),w=(0,F.$HB)(D);A[$]=new F.$KB(D,w)}const P=new f.$MB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(y){return this.a[0].buffer.substr(0,y).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(y){if(y.length===0)return;this.a.length===0&&I.$qf(y)&&(this.b=I.$pf,y=y.substr(1));const g=y.charCodeAt(y.length-1);g===13||g>=55296&&g<=56319?(this.m(y.substr(0,y.length-1),!1),this.c=!0,this.d=g):(this.m(y,!1),this.c=!1,this.d=g)}m(y,g){!g&&y.length===0||(this.c?this.n(String.fromCharCode(this.d)+y):this.n(y))}n(y){const g=(0,F.$IB)(this.e,y);this.a.push(new F.$KB(y,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=I.$hf(y)),this.k||(this.k=I.$kf(y)))}finish(y=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,y)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const y=this.a[this.a.length-1];y.buffer+=String.fromCharCode(this.d);const g=(0,F.$HB)(y.buffer);y.lineStarts=g,this.d===13&&this.f++}}}e.$NB=L}),define(ke[132],Se([1,0,22,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$=e.$D$=void 0;var f;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(f||(f={}));function R(P){for(let $=0,S=P.length;$<S;$+=4){const D=P[$+0],w=P[$+1],u=P[$+2],o=P[$+3];P[$+0]=o,P[$+1]=u,P[$+2]=w,P[$+3]=D}}function L(P){const $=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.$D()||R($),I.$fe.wrap($)}function b(P){const $=P.buffer;if(F.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const S=new Uint8Array($.byteLength);return S.set($),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function y(P){const $=new Uint32Array(g(P));let S=0;if($[S++]=P.id,P.type==="full")$[S++]=1,$[S++]=P.data.length,$.set(P.data,S),S+=P.data.length;else{$[S++]=2,$[S++]=P.deltas.length;for(const D of P.deltas)$[S++]=D.start,$[S++]=D.deleteCount,D.data?($[S++]=D.data.length,$.set(D.data,S),S+=D.data.length):$[S++]=0}return L($)}e.$D$=y;function g(P){let $=0;if($+=1+1,P.type==="full")$+=1+P.data.length;else{$+=1,$+=(1+1+1)*P.deltas.length;for(const S of P.deltas)S.data&&($+=S.data.length)}return $}function A(P){const $=b(P);let S=0;const D=$[S++];if($[S++]===1){const i=$[S++],n=$.subarray(S,S+i);return S+=i,{id:D,type:"full",data:n}}const u=$[S++],o=[];for(let i=0;i<u;i++){const n=$[S++],r=$[S++],a=$[S++];let t;a>0&&(t=$.subarray(S,S+a),S+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:D,type:"delta",deltas:o}}e.$E$=A}),define(ke[194],Se([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,12,170,127,194]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ce,Ie,Ke,Ge){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ce,Ie){return S(ce,Ie)}compute(ce,Ie,Ke){return Ke}}class ${constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=$;function S(ue,ce){if(typeof ue!="object"||typeof ce!="object"||!ue||!ce)return new $(ce,ue!==ce);if(Array.isArray(ue)||Array.isArray(ce)){const Ke=Array.isArray(ue)&&Array.isArray(ce)&&I.$tb(ue,ce);return new $(ce,!Ke)}let Ie=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Ge=S(ue[Ke],ce[Ke]);Ge.didChange&&(ue[Ke]=Ge.newValue,Ie=!0)}return new $(ue,Ie)}class D{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return S(ce,Ie)}validate(ce){return this.defaultValue}}class w{constructor(ce,Ie,Ke,Ge){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ce,Ie){return S(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,Ke){return Ke}}function u(ue,ce){return typeof ue>"u"?ce:ue==="false"?!1:!!ue}e.boolean=u;class o extends w{constructor(ce,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=Ke),super(ce,Ie,Ke,Ge)}validate(ce){return u(ce,this.defaultValue)}}function i(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;let Ge=parseInt(ue,10);return isNaN(Ge)?ce:(Ge=Math.max(Ie,Ge),Ge=Math.min(Ke,Ge),Ge|0)}e.clampedInt=i;class n extends w{static clampedInt(ce,Ie,Ke,Ge){return i(ce,Ie,Ke,Ge)}constructor(ce,Ie,Ke,Ge,_e,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ke,st.minimum=Ge,st.maximum=_e),super(ce,Ie,Ke,st),this.minimum=Ge,this.maximum=_e}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function r(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;const Ge=a.float(ue,ce);return a.clamp(Ge,Ie,Ke)}e.clampedFloat=r;class a extends w{static clamp(ce,Ie,Ke){return ce<Ie?Ie:ce>Ke?Ke:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const Ke=parseFloat(ce);return isNaN(Ke)?Ie:Ke}constructor(ce,Ie,Ke,Ge,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ke),super(ce,Ie,Ke,_e),this.validationFn=Ge}validate(ce){return this.validationFn(a.float(ce,this.defaultValue))}}class t extends w{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=Ke),super(ce,Ie,Ke,Ge)}validate(ce){return t.string(ce,this.defaultValue)}}function s(ue,ce,Ie,Ke){return typeof ue!="string"?ce:Ke&&ue in Ke?Ke[ue]:Ie.indexOf(ue)===-1?ce:ue}e.stringSet=s;class d extends w{constructor(ce,Ie,Ke,Ge,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ge,_e.default=Ke),super(ce,Ie,Ke,_e),this.c=Ge}validate(ce){return s(ce,this.defaultValue,this.c)}}class c extends P{constructor(ce,Ie,Ke,Ge,_e,st,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Ge),super(ce,Ie,Ke,lt),this.c=_e,this.d=st}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function l(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class k extends P{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:u(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function m(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function v(ue){switch(ue){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function E(ue){switch(ue){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class N extends D{constructor(){super(140)}compute(ce,Ie,Ke){const Ge=["monaco-editor"];return Ie.get(39)&&Ge.push(Ie.get(39)),ce.extraEditorClassName&&Ge.push(ce.extraEditorClassName),Ie.get(73)==="default"?Ge.push("mouse-default"):Ie.get(73)==="copy"&&Ge.push("mouse-copy"),Ie.get(110)&&Ge.push("showUnused"),Ie.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ce,Ie,Ke){return Ke&&ce.emptySelectionClipboard}}class M extends P{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:b.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:b.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:u(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":s(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":s(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(Ie.loop,this.defaultValue.loop)}}}class T extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?T.OFF:ce==="true"?T.ON:ce:ce?T.ON:T.OFF}}e.EditorFontLigatures=T;class j extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?j.OFF:ce==="true"?j.TRANSLATE:ce:ce?j.TRANSLATE:j.OFF}compute(ce,Ie,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class O extends D{constructor(){super(50)}compute(ce,Ie,Ke){return ce.fontInfo}}class V extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ce){const Ie=a.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ce,Ie,Ke){return ce.fontInfo.fontSize}}class te extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:te.d,maximum:te.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:te.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,te.d,te.e))}}class fe extends P{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:s(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??s(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??s(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??s(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??s(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??s(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends P{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:b.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:u(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(Ie.above,this.defaultValue.above)}}}var Q;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class G extends D{constructor(){super(143)}compute(ce,Ie,Ke){return G.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Ge=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ie-1));const _e=(Ke+ce.viewLineCount+Ge)/(ce.pixelRatio*ce.height),st=Math.floor(ce.viewLineCount/_e);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ge,desiredRatio:_e,minimapLineCount:st}}static c(ce,Ie){const Ke=ce.outerWidth,Ge=ce.outerHeight,_e=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const st=Ie.stableMinimapLayoutInput,lt=st&&ce.outerHeight===st.outerHeight&&ce.lineHeight===st.lineHeight&&ce.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ce.pixelRatio===st.pixelRatio&&ce.scrollBeyondLastLine===st.scrollBeyondLastLine&&ce.paddingTop===st.paddingTop&&ce.paddingBottom===st.paddingBottom&&ce.minimap.enabled===st.minimap.enabled&&ce.minimap.side===st.minimap.side&&ce.minimap.size===st.minimap.size&&ce.minimap.showSlider===st.minimap.showSlider&&ce.minimap.renderCharacters===st.minimap.renderCharacters&&ce.minimap.maxColumn===st.minimap.maxColumn&&ce.minimap.scale===st.minimap.scale&&ce.verticalScrollbarWidth===st.verticalScrollbarWidth&&ce.isViewportWrapping===st.isViewportWrapping,wt=ce.lineHeight,Ue=ce.typicalHalfwidthCharacterWidth,Kt=ce.scrollBeyondLastLine,Ht=ce.minimap.renderCharacters;let Et=_e>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const Ut=ce.minimap.maxColumn,Ot=ce.minimap.size,Gt=ce.minimap.side,Bt=ce.verticalScrollbarWidth,Dt=ce.viewLineCount,Mt=ce.remainingWidth,Wt=ce.isViewportWrapping,tt=Ht?2:3;let Vt=Math.floor(_e*Ge);const qt=Vt/_e;let ut=!1,mt=!1,Nt=tt*Et,Pt=Et/_e,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Fe,desiredRatio:Ce,minimapLineCount:se}=G.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ge,lineHeight:wt,pixelRatio:_e});if(Dt/se>1)ut=!0,mt=!0,Et=1,Nt=1,Pt=Et/_e;else{let qe=!1,xe=Et+1;if(Ot==="fit"){const Qe=Math.ceil((Me+Dt+Fe)*Nt);Wt&&lt&&Mt<=Ie.stableFitRemainingWidth?(qe=!0,xe=Ie.stableFitMaxMinimapScale):qe=Qe>Vt}if(Ot==="fill"||qe){ut=!0;const Qe=Et;Nt=Math.min(wt*_e,Math.max(1,Math.floor(1/Ce))),Wt&&lt&&Mt<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),Et=Math.min(xe,Math.max(1,Math.floor(Nt/tt))),Et>Qe&&(At=Math.min(2,Et/Qe)),Pt=Et/_e/At,Vt=Math.ceil(Math.max(Jt,Me+Dt+Fe)*Nt),Wt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=Mt,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const gt=Math.floor(Ut*Pt),St=Math.min(gt,Math.max(0,Math.floor((Mt-Bt-2)*Pt/(Ue+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(_e*St);const It=Rt/_e;Rt=Math.floor(Rt*At);const Je=Ht?1:2,jt=Gt==="left"?0:Ke-St-Bt;return{renderMinimap:Je,minimapLeft:jt,minimapWidth:St,minimapHeightIsEditorHeight:ut,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Nt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:It,minimapCanvasOuterHeight:qt}}static computeLayout(ce,Ie){const Ke=Ie.outerWidth|0,Ge=Ie.outerHeight|0,_e=Ie.lineHeight|0,st=Ie.lineNumbersDigitCount|0,lt=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Ue=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ce.get(135),Et=Ht==="inherit"?ce.get(134):Ht,Ut=Et==="inherit"?ce.get(130):Et,Ot=ce.get(133),Gt=Ie.isDominatedByLongLines,Bt=ce.get(57),Dt=ce.get(67).renderType!==0,Mt=ce.get(68),Wt=ce.get(104),tt=ce.get(83),Vt=ce.get(72),qt=ce.get(102),ut=qt.verticalScrollbarSize,mt=qt.verticalHasArrows,Nt=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=ce.get(43),gt=ce.get(109)!=="never";let St=ce.get(65);At&&gt&&(St+=16);let Rt=0;if(Dt){const pt=Math.max(st,Mt);Rt=Math.round(pt*wt)}let It=0;Bt&&(It=_e*Ie.glyphMarginDecorationLaneCount);let Je=0,jt=Je+It,Jt=jt+Rt,Me=Jt+St;const Fe=Ke-It-Rt-St;let Ce=!1,se=!1,Te=-1;Et==="inherit"&&Gt?(Ce=!0,se=!0):Ut==="on"||Ut==="bounded"?se=!0:Ut==="wordWrapColumn"&&(Te=Ot);const qe=G.c({outerWidth:Ke,outerHeight:Ge,lineHeight:_e,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ue,scrollBeyondLastLine:Wt,paddingTop:tt.top,paddingBottom:tt.bottom,minimap:Vt,verticalScrollbarWidth:ut,viewLineCount:Kt,remainingWidth:Fe,isViewportWrapping:se},Ie.memory||new A);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Je+=qe.minimapWidth,jt+=qe.minimapWidth,Jt+=qe.minimapWidth,Me+=qe.minimapWidth);const xe=Fe-qe.minimapWidth,Qe=Math.max(1,Math.floor((xe-ut-2)/lt)),ot=mt?Nt:0;return se&&(Te=Math.max(1,Qe),Ut==="bounded"&&(Te=Math.min(Te,Ot))),{width:Ke,height:Ge,glyphMarginLeft:Je,glyphMarginWidth:It,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:St,contentLeft:Me,contentWidth:xe,minimap:qe,viewportColumn:Qe,isWordWrapMinified:Ce,isViewportWrapping:se,wrappingColumn:Te,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Pt,overviewRuler:{top:ot,width:ut,height:Ge-2*ot,right:0}}}}e.EditorLayoutInfoComputer=G;class oe extends P{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ce){return s(ce,"simple",["simple","advanced"])}compute(ce,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class x extends P{constructor(){const ce={enabled:!0};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:b.localize(50,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:u(ce.enabled,this.defaultValue.enabled)}}}class Ee extends P{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:b.localize(54,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class le extends P{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:b.localize(62,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:s(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:u(Ie.padding,this.defaultValue.padding)}}}class q extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>a.clamp(ce,0,150),{markdownDescription:b.localize(63,null)})}compute(ce,Ie,Ke){return ce.fontInfo.lineHeight}}class ie extends P{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ce.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:b.localize(74,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),autohide:u(Ie.autohide,this.defaultValue.autohide),size:s(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ie.side,this.defaultValue.side,["right","left"]),showSlider:s(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(ue){return ue==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class H extends P{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class X extends P{constructor(){const ce={enabled:!0,cycle:!0};super(85,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:b.localize(78,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),cycle:u(Ie.cycle,this.defaultValue.cycle)}}}class Y extends D{constructor(){super(141)}compute(ce,Ie,Ke){return ce.pixelRatio}}class $e extends P{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ce.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ce.other,description:b.localize(84,null)}},default:ce,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Ue=ce?"on":"off";return{comments:Ue,strings:Ue,other:Ue}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ge}=ce,_e=["on","inline","off"];let st,lt,wt;return typeof Ie=="boolean"?st=Ie?"on":"off":st=s(Ie,this.defaultValue.other,_e),typeof Ke=="boolean"?lt=Ke?"on":"off":lt=s(Ke,this.defaultValue.comments,_e),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=s(Ge,this.defaultValue.strings,_e),{other:st,comments:lt,strings:wt}}}var ne;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class de extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ce){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,Ke=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function ee(ue){const ce=ue.get(97);return ce==="editable"?ue.get(90):ce!=="on"}e.filterValidationDecorations=ee;class he extends P{constructor(){const ce=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ce,description:b.localize(93,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const Ke of ce)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ge=Ke;Ie.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ie.sort((Ke,Ge)=>Ke.column-Ge.column),Ie}return this.defaultValue}}class pe extends P{constructor(){super(91,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Pe(ue,ce){if(typeof ue!="string")return ce;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:u(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ge,0,1e3),scrollByPage:u(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends P{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:b.localize(112,null)}})}applyUpdate(ce,Ie){let Ke=!1;Ie.allowedCharacters&&ce&&(F.$en(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ce&&(F.$en(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},Ke=!0));const Ge=super.applyUpdate(ce,Ie);return Ke?new $(Ge.newValue,!0):Ge}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const Ke={};for(const[Ge,_e]of Object.entries(ce))_e===!0&&(Ke[Ge]=!0);return Ke}}class re extends P{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(114,null),b.localize(115,null)],description:b.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:b.localize(117,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),mode:s(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:u(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends P{constructor(){const ce={enabled:R.$0r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$0r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:b.localize(119,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _ extends P{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],default:ce.bracketPairs,description:b.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ce.bracketPairsHorizontal,description:b.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:b.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:b.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(130,null),b.localize(131,null),b.localize(132,null)],default:ce.highlightActiveIndentation,description:b.localize(133,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ue,ce,Ie){const Ke=Ie.indexOf(ue);return Ke===-1?ce:Ie[Ke]}class ye extends P{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(134,null),b.localize(135,null)],default:ce.insertMode,description:b.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:b.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:b.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:b.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(140,null),b.localize(141,null),b.localize(142,null),b.localize(143,null)],default:ce.selectionMode,markdownDescription:b.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:b.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:b.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:b.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:b.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:b.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:s(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:u(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:u(Ie.preview,this.defaultValue.preview),previewMode:s(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(Ie.showMethods,this.defaultValue.showMethods),showFunctions:u(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:u(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(Ie.showFields,this.defaultValue.showFields),showVariables:u(Ie.showVariables,this.defaultValue.showVariables),showClasses:u(Ie.showClasses,this.defaultValue.showClasses),showStructs:u(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:u(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:u(Ie.showModules,this.defaultValue.showModules),showProperties:u(Ie.showProperties,this.defaultValue.showProperties),showEvents:u(Ie.showEvents,this.defaultValue.showEvents),showOperators:u(Ie.showOperators,this.defaultValue.showOperators),showUnits:u(Ie.showUnits,this.defaultValue.showUnits),showValues:u(Ie.showValues,this.defaultValue.showValues),showConstants:u(Ie.showConstants,this.defaultValue.showConstants),showEnums:u(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:u(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(Ie.showKeywords,this.defaultValue.showKeywords),showWords:u(Ie.showWords,this.defaultValue.showWords),showColors:u(Ie.showColors,this.defaultValue.showColors),showFiles:u(Ie.showFiles,this.defaultValue.showFiles),showReferences:u(Ie.showReferences,this.defaultValue.showReferences),showFolders:u(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:u(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:u(Ie.showUsers,this.defaultValue.showUsers),showIssues:u(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends P{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(183,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class et extends P{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(184,null),b.localize(185,null),b.localize(186,null),b.localize(187,null)],description:b.localize(188,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ze extends D{constructor(){super(144)}compute(ce,Ie,Ke){const Ge=Ie.get(143);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends P{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(191,null),b.localize(192,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showDropSelector:s(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends P{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:b.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:u(Ie.enabled,this.defaultValue.enabled),showPasteSelector:s(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Ne:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Xe;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.occurrencesHighlight=80]="occurrencesHighlight",ue[ue.overviewRulerBorder=81]="overviewRulerBorder",ue[ue.overviewRulerLanes=82]="overviewRulerLanes",ue[ue.padding=83]="padding",ue[ue.pasteAs=84]="pasteAs",ue[ue.parameterHints=85]="parameterHints",ue[ue.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=88]="quickSuggestions",ue[ue.quickSuggestionsDelay=89]="quickSuggestionsDelay",ue[ue.readOnly=90]="readOnly",ue[ue.readOnlyMessage=91]="readOnlyMessage",ue[ue.renameOnType=92]="renameOnType",ue[ue.renderControlCharacters=93]="renderControlCharacters",ue[ue.renderFinalNewline=94]="renderFinalNewline",ue[ue.renderLineHighlight=95]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=97]="renderValidationDecorations",ue[ue.renderWhitespace=98]="renderWhitespace",ue[ue.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ue[ue.roundedSelection=100]="roundedSelection",ue[ue.rulers=101]="rulers",ue[ue.scrollbar=102]="scrollbar",ue[ue.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=104]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=105]="scrollPredominantAxis",ue[ue.selectionClipboard=106]="selectionClipboard",ue[ue.selectionHighlight=107]="selectionHighlight",ue[ue.selectOnLineNumbers=108]="selectOnLineNumbers",ue[ue.showFoldingControls=109]="showFoldingControls",ue[ue.showUnused=110]="showUnused",ue[ue.snippetSuggestions=111]="snippetSuggestions",ue[ue.smartSelect=112]="smartSelect",ue[ue.smoothScrolling=113]="smoothScrolling",ue[ue.stickyScroll=114]="stickyScroll",ue[ue.stickyTabStops=115]="stickyTabStops",ue[ue.stopRenderingLineAfter=116]="stopRenderingLineAfter",ue[ue.suggest=117]="suggest",ue[ue.suggestFontSize=118]="suggestFontSize",ue[ue.suggestLineHeight=119]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ue[ue.suggestSelection=121]="suggestSelection",ue[ue.tabCompletion=122]="tabCompletion",ue[ue.tabIndex=123]="tabIndex",ue[ue.unicodeHighlighting=124]="unicodeHighlighting",ue[ue.unusualLineTerminators=125]="unusualLineTerminators",ue[ue.useShadowDOM=126]="useShadowDOM",ue[ue.useTabStops=127]="useTabStops",ue[ue.wordBreak=128]="wordBreak",ue[ue.wordSeparators=129]="wordSeparators",ue[ue.wordWrap=130]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=133]="wordWrapColumn",ue[ue.wordWrapOverride1=134]="wordWrapOverride1",ue[ue.wordWrapOverride2=135]="wordWrapOverride2",ue[ue.wrappingIndent=136]="wrappingIndent",ue[ue.wrappingStrategy=137]="wrappingStrategy",ue[ue.showDeprecated=138]="showDeprecated",ue[ue.inlayHints=139]="inlayHints",ue[ue.editorClassName=140]="editorClassName",ue[ue.pixelRatio=141]="pixelRatio",ue[ue.tabFocusMode=142]="tabFocusMode",ue[ue.layoutInfo=143]="layoutInfo",ue[ue.wrappingInfo=144]="wrappingInfo",ue[ue.defaultColorDecorators=145]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(197,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(198,null),""],markdownDescription:b.localize(199,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(200,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(201,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(203,null),b.localize(204,null),""],description:b.localize(205,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(206,null),b.localize(207,null),""],description:b.localize(208,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(209,null),""],description:b.localize(210,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(211,null),""],description:b.localize(212,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(213,null),b.localize(214,null),""],description:b.localize(215,null)})),autoIndent:Le(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null)],description:b.localize(221,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(222,null),b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),bracketPairColorization:Le(new ae),bracketPairGuides:Le(new _),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:b.localize(226,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(227,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(228,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(229,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(230,null)})),colorDecoratorActivatedOn:Le(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null)],description:b.localize(234,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(235,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(236,null)})),comments:Le(new k),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(237,null)})),cursorBlinking:Le(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(238,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null)],description:b.localize(242,null)})),cursorStyle:Le(new c(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:b.localize(243,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(244,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(245,null),b.localize(246,null)],markdownDescription:b.localize(247,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(248,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(249,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new rt),stickyScroll:Le(new Ee),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(250,null),b.localize(251,null),b.localize(252,null)],description:b.localize(253,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:b.localize(254,null)})),find:Le(new M),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(255,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(259,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(260,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(261,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(262,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(263,null)})),fontInfo:Le(new O),fontLigatures2:Le(new T),fontSize:Le(new V),fontWeight:Le(new te),fontVariations:Le(new j),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(264,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(265,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(266,null)})),gotoLocation:Le(new fe),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(267,null)})),hover:Le(new Z),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>a.clamp(ue,-5,20),{description:b.localize(268,null)})),lightbulb:Le(new x),lineDecorationsWidth:Le(new q),lineHeight:Le(new U),lineNumbers:Le(new de),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:b.localize(269,null)})),links:Le(new o(70,"links",!0,{description:b.localize(270,null)})),matchBrackets:Le(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(271,null)})),minimap:Le(new ie),mouseStyle:Le(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:b.localize(272,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(273,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(274,null)})),multiCursorModifier:Le(new c(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[b.localize(275,null),b.localize(276,null)],markdownDescription:b.localize(277,null)})),multiCursorPaste:Le(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(278,null),b.localize(279,null)],markdownDescription:b.localize(280,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(281,null)})),occurrencesHighlight:Le(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(282,null),b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:b.localize(286,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new H),pasteAs:Le(new nt),parameterHints:Le(new X),peekWidgetDefaultFocus:Le(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(287,null),b.localize(288,null)],description:b.localize(289,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(290,null)})),quickSuggestions:Le(new $e),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(291,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new pe),renameOnType:Le(new o(92,"renameOnType",!1,{description:b.localize(292,null),markdownDeprecationMessage:b.localize(293,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:b.localize(294,null),restricted:!0})),renderFinalNewline:Le(new d(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(295,null)})),renderLineHighlight:Le(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(296,null)],description:b.localize(297,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(298,null)})),renderValidationDecorations:Le(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(299,null),b.localize(300,null),b.localize(301,null),""],description:b.localize(302,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:b.localize(303,null)})),rulers:Le(new he),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(304,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(305,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:b.localize(306,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:b.localize(307,null),included:f.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:b.localize(308,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(309,null),b.localize(310,null),b.localize(311,null)],description:b.localize(312,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:b.localize(313,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:b.localize(314,null)})),inlayHints:Le(new le),snippetSuggestions:Le(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(315,null),b.localize(316,null),b.localize(317,null),b.localize(318,null)],description:b.localize(319,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:b.localize(320,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new re),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(321,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(324,null)})),suggestSelection:Le(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabCompletion:Le(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new J),unusualLineTerminators:Le(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:b.localize(337,null)})),wordBreak:Le(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null)],description:b.localize(340,null)})),wordSeparators:Le(new t(129,"wordSeparators",L.$$r,{description:b.localize(341,null)})),wordWrap:Le(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(342,null),b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(347,null)})),wordWrapOverride1:Le(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new N),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(348,null)})),pixelRatio:Le(new Y),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(349,null)})),layoutInfo:Le(new G),wrappingInfo:Le(new Ze),wrappingIndent:Le(new et),wrappingStrategy:Le(new oe)}}),define(ke[195],Se([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$rt=e.$qt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$pt=e.$ot=e.SymbolKinds=e.SymbolTag=e.$nt=e.$mt=e.SymbolKind=e.$lt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$kt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$jt=e.$it=e.$ht=void 0;class y{constructor(T,j,O){this.offset=T,this.type=j,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ht=y;class g{constructor(T,j){this.tokens=T,this.endState=j,this._tokenizationResultBrand=void 0}}e.$it=g;class A{constructor(T,j){this.tokens=T,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$jt=A;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var $;(function(M){const T=new Map;T.set(0,I.$1j.symbolMethod),T.set(1,I.$1j.symbolFunction),T.set(2,I.$1j.symbolConstructor),T.set(3,I.$1j.symbolField),T.set(4,I.$1j.symbolVariable),T.set(5,I.$1j.symbolClass),T.set(6,I.$1j.symbolStruct),T.set(7,I.$1j.symbolInterface),T.set(8,I.$1j.symbolModule),T.set(9,I.$1j.symbolProperty),T.set(10,I.$1j.symbolEvent),T.set(11,I.$1j.symbolOperator),T.set(12,I.$1j.symbolUnit),T.set(13,I.$1j.symbolValue),T.set(15,I.$1j.symbolEnum),T.set(14,I.$1j.symbolConstant),T.set(15,I.$1j.symbolEnum),T.set(16,I.$1j.symbolEnumMember),T.set(17,I.$1j.symbolKeyword),T.set(27,I.$1j.symbolSnippet),T.set(18,I.$1j.symbolText),T.set(19,I.$1j.symbolColor),T.set(20,I.$1j.symbolFile),T.set(21,I.$1j.symbolReference),T.set(22,I.$1j.symbolCustomColor),T.set(23,I.$1j.symbolFolder),T.set(24,I.$1j.symbolTypeParameter),T.set(25,I.$1j.account),T.set(26,I.$1j.issues);function j(te){let fe=T.get(te);return fe||(console.info("No codicon found for CompletionItemKind "+te),fe=I.$1j.symbolProperty),fe}M.toIcon=j;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function V(te,fe){let Z=O.get(te);return typeof Z>"u"&&!fe&&(Z=9),Z}M.fromString=V})($||(e.CompletionItemKinds=$={}));var S;(function(M){M[M.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var D;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var u;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(u||(e.InlineCompletionTriggerKind=u={}));class o{constructor(T,j,O,V){this.range=T,this.text=j,this.completionKind=O,this.isSnippetText=V}equals(T){return R.$As.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$kt=o;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(M){return M&&F.URI.isUri(M.uri)&&R.$As.isIRange(M.range)&&(R.$As.isIRange(M.originSelectionRange)||R.$As.isIRange(M.targetSelectionRange))}e.$lt=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$mt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function s(M,T){return(0,b.localize)(26,null,M,e.$mt[T])}e.$nt=s;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var c;(function(M){const T=new Map;T.set(0,I.$1j.symbolFile),T.set(1,I.$1j.symbolModule),T.set(2,I.$1j.symbolNamespace),T.set(3,I.$1j.symbolPackage),T.set(4,I.$1j.symbolClass),T.set(5,I.$1j.symbolMethod),T.set(6,I.$1j.symbolProperty),T.set(7,I.$1j.symbolField),T.set(8,I.$1j.symbolConstructor),T.set(9,I.$1j.symbolEnum),T.set(10,I.$1j.symbolInterface),T.set(11,I.$1j.symbolFunction),T.set(12,I.$1j.symbolVariable),T.set(13,I.$1j.symbolConstant),T.set(14,I.$1j.symbolString),T.set(15,I.$1j.symbolNumber),T.set(16,I.$1j.symbolBoolean),T.set(17,I.$1j.symbolArray),T.set(18,I.$1j.symbolObject),T.set(19,I.$1j.symbolKey),T.set(20,I.$1j.symbolNull),T.set(21,I.$1j.symbolEnumMember),T.set(22,I.$1j.symbolStruct),T.set(23,I.$1j.symbolEvent),T.set(24,I.$1j.symbolOperator),T.set(25,I.$1j.symbolTypeParameter);function j(O){let V=T.get(O);return V||(console.info("No codicon found for SymbolKind "+O),V=I.$1j.symbolProperty),V}M.toIcon=j})(c||(e.SymbolKinds=c={}));class l{static asEditOperation(T){return f.$Bs.replace(R.$As.lift(T.range),T.text)}}e.$ot=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(T){switch(T){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(T)}constructor(T){this.value=T}}e.$pt=h;var k;(function(M){function T(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}M.is=T})(k||(e.Command=k={}));var C;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var m;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(m||(e.CommentThreadState=m={}));var p;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var v;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(v||(e.CommentState=v={}));var E;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(E||(e.InlayHintKind=E={}));class N{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$qt=N,e.$rt=new L.$_s;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[217],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[218],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[219],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[220],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[221],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[222],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[223],Se([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[224],Se([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[225],Se([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[226],Se([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[227],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[228],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[229],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[230],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[231],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[232],Se([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[233],Se([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[234],Se([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[235],Se([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[236],Se([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[237],Se([1,0,8,198]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var f;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const L=(0,F.localize)(3,null),b=(0,F.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,$=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:$};this.g.push({offset:P,lexeme:$,additionalInfo:A}),this.f.push(S)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),$=y.b.get(P);$?this.k($):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const D=this.c.charCodeAt(A);if(P)P=!1;else if(D===47&&!$){A++;break}else D===91?$=!0:D===92?P=!0:D===93&&($=!1);A++}for(;A<this.c.length&&y.a.has(this.c.charCodeAt(A));)A++;this.e=A;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=y}),define(ke[238],Se([1,0,23,39,201,386]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||L.test(o)}e.$Ro=y;function g(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$So=g;function A(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let s=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),s=!1);let d=0;if(o.preRelease){const c=b.exec(o.preRelease);if(c){const[,l,h,k]=c;d=Date.UTC(Number(l),Number(h)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:s,isMinimum:o.hasGreaterEquals,notBefore:d}}e.$To=A;function P(o,i,n){let r;typeof o=="string"?r=A(g(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(g(n)):t=n,!r||!t)return!1;const s=r.majorBase,d=r.minorBase,c=r.patchBase;let l=t.majorBase,h=t.minorBase,k=t.patchBase;const C=t.notBefore;let m=t.majorMustEqual,p=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?s>l?!0:s<l?!1:d>h?!0:d<h||a&&a<C?!1:c>=k:(s===1&&l===0&&(!m||!p||!v)&&(l=1,h=0,k=0,m=!0,p=!1,v=!1),s<l?!1:s>l?!m:d<h?!1:d>h?!p:c<k?!1:c>k?!v:!(a&&a<C))}e.$Uo=P;function $(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([F.default.Error,f.localize(0,null)]),t;if(typeof r.name!="string")return t.push([F.default.Error,f.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([F.default.Error,f.localize(2,null,"version")]),t;if(!r.engines)return t.push([F.default.Error,f.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([F.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!u(r.extensionDependencies))return t.push([F.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!u(r.activationEvents))return t.push([F.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([F.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([F.default.Warning,f.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([F.default.Error,f.localize(9,null,"main")]),t;{const c=(0,I.$zg)(n,r.main);(0,I.$tg)(c,n)||t.push([F.default.Warning,f.localize(10,null,c.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([F.default.Error,f.localize(11,null,"browser")]),t;{const c=(0,I.$zg)(n,r.browser);(0,I.$tg)(c,n)||t.push([F.default.Warning,f.localize(12,null,c.path,n.path)])}}if(!R.valid(r.version))return t.push([F.default.Error,f.localize(13,null)]),t;const s=[];if(!S(o,i,r,a,s))for(const c of s)t.push([F.default.Error,c]);return t}e.$Vo=$;function S(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(o,i,n.engines.vscode,a)}e.$Wo=S;function D(o,i,n){return o==="*"||w(i,n,o)}e.$Xo=D;function w(o,i,n,r=[]){const a=A(g(n));if(!a)return r.push(f.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(f.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push(f.localize(16,null,n)),!1;return P(o,i,a)?!0:(r.push(f.localize(17,null,o,n)),!1)}function u(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class I{constructor(f,R=[],L=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Sh=I}),define(ke[106],Se([1,0,105]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.InstantiationType=void 0;const F=[];var f;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R(b,y,g){y instanceof I.$Sh||(y=new I.$Sh(y,[],!!g)),F.push([b,y])}e.$Dr=R;function L(){return F}e.$Er=L}),define(ke[239],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class I{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$hq=I;class F{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const b=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(L);b.outgoing.set(y.key,y),y.incoming.set(b.key,b)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let b=this.a.get(L);return b||(b=new I(L,R),this.a.set(L,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,b]of this.a)R.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const b=new Set([R]),y=this.c(L,b);if(y)return y}}c(R,L){for(const[b,y]of R.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const g=this.c(y,L);if(g)return g;L.delete(b)}}}e.$iq=F}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var I;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b(y){return y[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(I||(e._util=I={})),e.$Uh=f("instantiationService");function F(L,b,y){b[I.DI_TARGET]===b?b[I.DI_DEPENDENCIES].push({id:L,index:y}):(b[I.DI_DEPENDENCIES]=[{id:L,index:y}],b[I.DI_TARGET]=b)}function f(L){if(I.serviceIds.has(L))return I.serviceIds.get(L);const b=function(y,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(b,y,A)};return b.toString=()=>L,I.serviceIds.set(L,b),b}e.$Vh=f;function R(L){return L}e.$Wh=R}),define(ke[44],Se([1,0,18,2,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,f.$Vh)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof F.URI)}e.$qi=R;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof F.URI)}e.$ri=L;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function y(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=y;function g(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ti=g;function A(o,i){const n=Object.create(null);for(const r in o)P(n,r,o[r],i);return n}e.$ui=A;function P(o,i,n,r){const a=i.split("."),t=a.pop();let s=o;for(let d=0;d<a.length;d++){const c=a[d];let l=s[c];switch(typeof l){case"undefined":l=s[c]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}s=l}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.$vi=P;function $(o,i){const n=i.split(".");S(o,n)}e.$wi=$;function S(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(S(r,i),Object.keys(r).length===0&&delete o[n])}}function D(o,i,n){function r(s,d){let c=s;for(const l of d){if(typeof c!="object"||c===null)return;c=c[l]}return c}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.$xi=D;function w(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?I.$Ef(o[r])&&I.$Ef(i[r])?w(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$yi=w;function u(o){return o.replace(/[\[\]]/g,"")}e.$zi=u}),define(ke[45],Se([1,0,12,13,237,5,197,8]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",I.$j),y.set("isLinux",I.$k),y.set("isWindows",I.$i),y.set("isWeb",I.$o),y.set("isMacNative",I.$j&&!I.$o),y.set("isEdge",I.$H),y.set("isFirefox",I.$F),y.set("isChrome",I.$E),y.set("isSafari",I.$G);function g(q,U){if(y.get(q)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(q,U)}e.$Ri=g;const A=Object.prototype.hasOwnProperty;var P;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const $={regexParsingWithErrorRecovery:!0},S=(0,L.localize)(0,null),D=(0,L.localize)(1,null),w=(0,L.localize)(2,null),u=(0,L.localize)(3,null),o=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),r=(0,L.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new f.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),H=be.type===17?i:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:f.$Qi.getLexeme(be),additionalInfo:H}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,u),ie?.negate()}case 17:return this.z(),E.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,u),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const X=H.lexeme,Y=X.lastIndexOf("/"),$e=Y===X.length-1?void 0:this.w(X.substring(Y+1));let ne;try{ne=new RegExp(X.substring(1,Y),$e)}catch{throw this.B("REGEX",H)}return O.create(ie,ne)}switch(H.type){case 10:case 19:{const X=[H.lexeme];this.z();let Y=this.D(),$e=0;for(let pe=0;pe<H.lexeme.length;pe++)H.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let pe=0;pe<Y.lexeme.length;pe++)Y.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--}if($e<0)break;X.push(f.$Qi.getLexeme(Y)),this.z(),Y=this.D()}const ne=X.join(""),de=ne.lastIndexOf("/"),ee=de===ne.length-1?void 0:this.w(ne.substring(de+1));let he;try{he=new RegExp(ne.substring(1,de),ee)}catch{throw this.B("REGEX",H)}return t.regex(ie,he)}case 18:{const X=H.lexeme;this.z();let Y=null;if(!(0,F.$Fe)(X)){const $e=X.indexOf("/"),ne=X.lastIndexOf("/");if($e!==ne&&$e>=0){const de=X.slice($e+1,ne),ee=X[ne+1]==="i"?"i":"";try{Y=new RegExp(de,ee)}catch{throw this.B("REGEX",H)}}}if(Y===null)throw this.B("REGEX",H);return O.create(ie,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const H=this.u();return t.notIn(ie,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(ie,H);switch(H){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(ie,H);switch(H){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,H)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),j.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),M.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const H=(0,L.localize)(8,null,U,f.$Qi.getLexeme(ie)),X=ie.offset,Y=f.$Qi.getLexeme(ie);return this.h.push({message:H,offset:X,lexeme:Y,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(U){return k.create(U)}static equals(U,ie){return C.create(U,ie)}static notEquals(U,ie){return v.create(U,ie)}static regex(U,ie){return O.create(U,ie)}static in(U,ie){return m.create(U,ie)}static notIn(U,ie){return p.create(U,ie)}static not(U){return E.create(U)}static and(...U){return fe.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,ie){return z.create(U,ie)}static greaterEquals(U,ie){return M.create(U,ie)}static smaller(U,ie){return T.create(U,ie)}static smallerEquals(U,ie){return j.create(U,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ti=t;function s(q){const U=new a({regexParsingWithErrorRecovery:!1});return q.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,L.localize)(9,null,be.additionalInfo):(0,L.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ui=s;function d(q,U){const ie=q?q.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}e.$Vi=d;function c(q,U){return q.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Wi=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Xi=h;class k{static create(U,ie=null){const be=y.get(U);return typeof be=="boolean"?be?h.INSTANCE:l.INSTANCE:new k(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:G(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=y.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=E.create(this.key,this)),this.c}}e.$Yi=k;class C{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?k.create(U,be):E.create(U,be);const H=y.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?h.INSTANCE:l.INSTANCE:new C(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Zi=C;class m{static create(U,ie){return new m(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$1i=m;class p{static create(U,ie){return new p(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=m.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=p;class v{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?E.create(U,be):k.create(U,be);const H=y.get(U);return typeof H=="boolean"?ie===(H?"true":"false")?l.INSTANCE:h.INSTANCE:new v(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$3i=v;class E{static create(U,ie=null){const be=y.get(U);return typeof be=="boolean"?be?l.INSTANCE:h.INSTANCE:new E(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:G(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=y.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$4i=E;function N(q,U){if(typeof q=="string"){const ie=parseFloat(q);isNaN(ie)||(q=ie)}return typeof q=="string"||typeof q=="number"?U(q):l.INSTANCE}class z{static create(U,ie,be=null){return N(ie,H=>new z(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$5i=z;class M{static create(U,ie,be=null){return N(ie,H=>new M(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$6i=M;class T{static create(U,ie,be=null){return N(ie,H=>new T(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$7i=T;class j{static create(U,ie,be=null){return N(ie,H=>new j(U,H,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$8i=j;class O{static create(U,ie){return new O(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$9i=O;class V{static create(U){return new V(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new V(this.c.map(U))}negate(){return this.c}}e.$0i=V;function te(q){let U=null;for(let ie=0,be=q.length;ie<be;ie++){const H=q[ie].substituteConstants();if(q[ie]!==H&&U===null){U=[];for(let X=0;X<ie;X++)U[X]=q[X]}U!==null&&(U[ie]=H)}return U===null?q:U}class fe{static create(U,ie,be){return fe.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=c(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:fe.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const H=[];let X=!1;for(const Y of U)if(Y){if(Y.type===1){X=!0;continue}if(Y.type===0)return l.INSTANCE;if(Y.type===6){H.push(...Y.expr);continue}H.push(Y)}if(H.length===0&&X)return h.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(c);for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];for(;H.length>1;){const Y=H[H.length-1];if(Y.type!==9)break;H.pop();const $e=H.pop(),ne=H.length===0,de=Z.create(Y.expr.map(ee=>fe.create([ee,$e],null,be)),null,ne);de&&(H.push(de),H.sort(c))}if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return l.INSTANCE;if(H.length===1)return H[0]}return new fe(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new fe(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$$i=fe;class Z{static create(U,ie,be){return Z.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const H=c(this.expr[ie],U.expr[ie]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=te(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let H=[],X=!1;if(U){for(let Y=0,$e=U.length;Y<$e;Y++){const ne=U[Y];if(ne){if(ne.type===0){X=!0;continue}if(ne.type===1)return h.INSTANCE;if(ne.type===9){H=H.concat(ne.expr);continue}H.push(ne)}}if(H.length===0&&X)return l.INSTANCE;H.sort(c)}if(H.length!==0){if(H.length===1)return H[0];for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return h.INSTANCE;if(H.length===1)return H[0]}return new Z(H,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Z(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),H=[];for(const X of le(ie))for(const Y of le(be))H.push(fe.create([X,Y],null,!1));U.unshift(Z.create(H,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$_i=Z;class Q extends k{static{this.d=[]}static all(){return Q.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?Q.d.push({...be,key:U}):be!==!0&&Q.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return C.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$aj=Q,e.$bj=(0,R.$Vh)("contextKeyService");function G(q,U){return q<U?-1:q>U?1:0}function oe(q,U,ie,be){return q<ie?-1:q>ie?1:U<be?-1:U>be?1:0}function x(q,U){if(q.type===0||U.type===1)return!0;if(q.type===9)return U.type===9?Ee(q.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(x(q,ie))return!0;return!1}if(q.type===6){if(U.type===6)return Ee(U.expr,q.expr);for(const ie of q.expr)if(x(ie,U))return!0;return!1}return q.equals(U)}e.$cj=x;function Ee(q,U){let ie=0,be=0;for(;ie<q.length&&be<U.length;){const H=q[ie].cmp(U[be]);if(H<0)return!1;H===0&&ie++,be++}return ie===q.length}function le(q){return q.type===9?q.expr:[q]}}),define(ke[240],Se([1,0,23,39,199,5,102,12,24]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.ConfirmResult=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Iv=(0,R.$Vh)("dialogService");var g;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(g||(g={}));class A{a(u){return this.d(u,g.Confirmation)}b(u){return this.d(u,g.Prompt)}c(u){return this.d(u,g.Input)}d(u,o){const i=[];switch(o){case g.Confirmation:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(1,null));break}case g.Prompt:{const n=u;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case g.Input:{const n=u;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(u){if(typeof u=="string")return u;if(typeof u=="number")return u===F.default.Info?"info":u===F.default.Error?"error":u===F.default.Warning?"warning":"none"}f(u,o,i){const n=[...u.buttons??[]];u.cancelButton&&typeof u.cancelButton!="string"&&typeof u.cancelButton!="boolean"&&n.push(u.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$Jv=A,e.$Kv=(0,R.$Vh)("fileDialogService");var P;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const $=10;function S(w){const u=[];return u.push(...w.slice(0,$).map(o=>typeof o=="string"?o:(0,I.$wg)(o))),w.length>$&&(w.length-$===1?u.push((0,f.localize)(7,null)):u.push((0,f.localize)(8,null,w.length-$))),u.push(""),u.join(`
`)}e.$Lv=S;function D(w,u){const o=(0,y.$an)(w);let i=(o.buttons??[]).map(t=>(0,L.$Fv)(t)),n=(w.buttons||[]).map((t,s)=>s),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const s=n[a];n.splice(a,1),n.splice(1,0,s),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const s=n[a];n.splice(a,1),n.push(s),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||u.nameLong,{options:o,buttonIndeces:n}}e.$Mv=D}),define(ke[134],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,I.$Vh)("environmentService"),e.$4h=(0,I.$Wh)(e.$3h)}),define(ke[135],Se([1,0,200,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=f;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=R;function L(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=L;function b(o,i){return i==="web"&&!o.includes("web")}e.$ao=b;function y(o,i,n){return b(i,n)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===n}e.$bo=y;function g(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$co=g;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var S;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$do=(0,F.$Vh)("extensionGalleryService");var D;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));var w;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class u extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$eo=u,e.$fo=(0,F.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,F.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,F.$Vh)("IExtensionTipsService"),e.$ko=(0,I.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ke[241],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BZb=e.$AZb=void 0,e.$AZb=(0,I.$Vh)("externalTerminal"),e.$BZb="Terminal.app"}),define(ke[242],Se([1,0,50,17,16,12,101,30,104,202,241]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=e.$y8b=void 0;const P=g.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends ${static{this.b="cmd.exe"}openTerminal(r,a){return this.spawnTerminal(I,r,y.$Hl(),a)}spawnTerminal(r,a,t,s){const d=a.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const c=f.$mc(d,".exe").toLowerCase();if(c==="cmder")return r.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),c==="wt"&&l.push("-d ."),new Promise((h,k)=>{const C=u(process),m=r.spawn(t,l,{cwd:s,env:C});m.on("error",k),m.on("exit",()=>h())})}runInTerminal(r,a,t,s,d){const c="windowsExec"in d&&d.windowsExec?d.windowsExec:S.getDefaultTerminalWindows();return new Promise((l,h)=>{const k=`"${a} - ${P}"`,C=`""${t.join('" "')}" & pause"`,m=Object.assign({},u(process),s);Object.keys(m).filter(z=>m[z]===null).forEach(z=>delete m[z]);const p={cwd:a,env:m,windowsVerbatimArguments:!0};let v,E;f.$mc(c,".exe")==="wt"?(v=c,E=["-d",".",S.b,"/c",C]):(v=S.b,E=["/c","start",k,"/wait",c,"/c",C]),I.spawn(v,E,p).on("error",z=>{h(o(z))}),l(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$y8b=S;class D extends ${static{this.b="/usr/bin/osascript"}openTerminal(r,a){return this.spawnTerminal(I,r,a)}runInTerminal(r,a,t,s,d){const c=d.osxExec||A.$BZb;return new Promise((l,h)=>{if(c===A.$BZb||c==="iTerm.app"){const k=c===A.$BZb?"TerminalHelper":"iTermHelper",m=[F.$gg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",r||P,"-w",a];for(const E of t)m.push("-a"),m.push(E);if(s){const E=Object.assign({},u(process),s);for(const N in E){const z=E[N];z===null?(m.push("-u"),m.push(N)):(m.push("-e"),m.push(`${N}=${z}`))}}let p="";const v=I.spawn(D.b,m);v.on("error",E=>{h(o(E))}),v.stderr.on("data",E=>{p+=E.toString()}),v.on("exit",E=>{if(E===0)l(void 0);else if(p){const N=p.split(`
`,1);h(new Error(N[0]))}else h(new Error(g.localize(1,null,k,E)))})}else h(new Error(g.localize(2,null,c)))})}spawnTerminal(r,a,t){const s=a.osxExec||A.$BZb;return new Promise((d,c)=>{const l=["-a",s];t&&l.push(t);const h=u(process),k=r.spawn("/usr/bin/open",l,{cwd:t,env:h});k.on("error",c),k.on("exit",()=>d())})}}e.$z8b=D;class w extends ${static{this.b=g.localize(3,null)}openTerminal(r,a){return this.spawnTerminal(I,r,a)}runInTerminal(r,a,t,s,d){const c=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,h)=>{const k=[];c.then(C=>{C.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const m=`${i(t)}; echo; read -p "${w.b}" -n1;`;k.push(`''${m}''`);const p=Object.assign({},u(process),s);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const v={cwd:a,env:p};let E="";const N=I.spawn(C,k,v);N.on("error",z=>{h(o(z))}),N.stderr.on("data",z=>{E+=z.toString()}),N.on("exit",z=>{if(z===0)l(void 0);else if(E){const M=E.split(`
`,1);h(new Error(M[0]))}else h(new Error(g.localize(4,null,C,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!R.$k)w.d=Promise.resolve("xterm");else{const r=await b.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{r?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(r,a,t){const s=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,c)=>{s.then(l=>{const h=u(process),k=r.spawn(l,[],{cwd:t,env:h});k.on("error",c),k.on("exit",()=>d())})})}}e.$A8b=w;function u(n){const r={...n.env};return(0,L.$Fl)(r),r}function o(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(g.localize(5,null,n.path)):n}function i(n){let r="";for(const a of n)a.indexOf(" ")>=0?r+='"'+a+'"':r+=a,r+=" ";return r}}),define(ke[31],Se([1,0,77,16,13,18,2,203,5,12,17,48]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,y.$Vh)("fileService");function $(x){return x.create===!0}e.$fk=$;var S;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var D;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(D||(e.FilePermission=D={}));function w(x){const Ee=x;return!!Ee&&typeof Ee.onDidChange=="function"}e.$gk=w;var u;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function o(x){return!!(x.capabilities&2)}e.$hk=o;function i(x){return!!(x.capabilities&8)}e.$ik=i;function n(x){return!!(x.capabilities&131072)}e.$jk=n;function r(x){return!!(x.capabilities&4)}e.$kk=r;function a(x){return!!(x.capabilities&16)}e.$lk=a;function t(x){return o(x)?!!(x.capabilities&16384):!1}e.$mk=t;function s(x){return o(x)?!!(x.capabilities&32768):!1}e.$nk=s;function d(x){return!!(x.capabilities&65536)}e.$ok=d;function c(x){return!!(x.capabilities&2048)}e.$pk=c;var l;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(Ee,le){const q=new h(Ee.toString(),le);return m(q,le),q}constructor(Ee,le){super(Ee),this.code=le}}e.$qk=h;function k(x,Ee){return h.create(x,Ee)}e.$rk=k;function C(x){return x||k((0,b.localize)(0,null),l.Unknown)}e.$sk=C;function m(x,Ee){return x.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",x}e.$tk=m;function p(x){if(!x)return l.Unknown;if(x instanceof h)return x.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!Ee)return l.Unknown;switch(Ee[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$uk=p;function v(x){if(x instanceof j)return x.fileOperationResult;switch(p(x)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$vk=v;var E;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(E||(e.FileOperation=E={}));class N{constructor(Ee,le,q){this.resource=Ee,this.operation=le,this.target=q}isOperation(Ee){return this.operation===Ee}}e.$wk=N;var z;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class M{static{this.a=null}constructor(Ee,le){this.c=le,this.b=void 0,this.d=new P.$U(()=>{const q=I.$2h.forUris(()=>this.c);return q.fill(this.rawAdded.map(U=>[U,!0])),q}),this.f=new P.$U(()=>{const q=I.$2h.forUris(()=>this.c);return q.fill(this.rawUpdated.map(U=>[U,!0])),q}),this.g=new P.$U(()=>{const q=I.$2h.forUris(()=>this.c);return q.fill(this.rawDeleted.map(U=>[U,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Ee){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==M.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Ee,...le){return this.h(Ee,{includeChildren:!1},...le)}affects(Ee,...le){return this.h(Ee,{includeChildren:!0},...le)}h(Ee,le,...q){if(!Ee)return!1;const U=q.length>0;return!!((!U||q.includes(1))&&(this.d.value.get(Ee)||le.includeChildren&&this.d.value.findSuperstr(Ee))||(!U||q.includes(0))&&(this.f.value.get(Ee)||le.includeChildren&&this.f.value.findSuperstr(Ee))||(!U||q.includes(2))&&(this.g.value.findSubstr(Ee)||le.includeChildren&&this.g.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.b===Ee}hasCorrelation(){return typeof this.b=="number"}}e.$xk=M;function T(x,Ee,le){return!x||!Ee||x===Ee||Ee.length>x.length?!1:(Ee.charAt(Ee.length-1)!==F.sep&&(Ee+=F.sep),le?(0,f.$7e)(x,Ee):x.indexOf(Ee)===0)}e.$yk=T;class j extends Error{constructor(Ee,le,q){super(Ee),this.fileOperationResult=le,this.options=q}}e.$zk=j;class O extends j{constructor(Ee,le,q,U){super(Ee,le,U),this.fileOperationResult=le,this.size=q}}e.$Ak=O;class V extends j{constructor(Ee,le,q){super(Ee,2,q),this.stat=le}}e.$Bk=V;var te;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(te||(e.FileOperationResult=te={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var fe;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Jk="";function Z(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Kk=Z;async function Q(x,Ee){if(!Ee.hasProvider(L.URI.from({scheme:x.scheme})))return new Promise(le=>{const q=Ee.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===x.scheme&&U.added&&(q.dispose(),le())})})}e.$Lk=Q;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(Ee){return(0,R.$Gf)(Ee)||(Ee=0),Ee<G.KB?(0,b.localize)(1,null,Ee.toFixed(0)):Ee<G.MB?(0,b.localize)(2,null,(Ee/G.KB).toFixed(2)):Ee<G.GB?(0,b.localize)(3,null,(Ee/G.MB).toFixed(2)):Ee<G.TB?(0,b.localize)(4,null,(Ee/G.GB).toFixed(2)):(0,b.localize)(5,null,(Ee/G.TB).toFixed(2))}}e.$Mk=G;function oe(x){const Ee=typeof x=="string"||x?.scheme===A.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===A.Schemas.file?1024*G.MB:Ee?10*G.MB:g.$o?50*G.MB:1024*G.MB}e.$Nk=oe}),define(ke[243],Se([1,0,22,8,204,31]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function L(A,P,$,S,D,w){let u;try{await b(A,P,$,S,D,w)}catch(o){u=o}finally{u&&D.errorTransformer&&(u=D.errorTransformer(u)),typeof u<"u"&&$.error(u),$.end()}}e.$Sp=L;async function b(A,P,$,S,D,w){y(w);const u=await A.open(P,{create:!1});try{y(w);let o=0,i=0,n=D&&typeof D.length=="number"?D.length:void 0,r=I.$fe.alloc(Math.min(D.bufferSize,typeof n=="number"?n:D.bufferSize)),a=D&&typeof D.position=="number"?D.position:0,t=0;do i=await A.read(u,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await $.write(S(r)),r=I.$fe.alloc(Math.min(D.bufferSize,typeof n=="number"?n:D.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&y(w)&&g(o,D));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),$.write(S(r.slice(0,s)))}}catch(o){throw(0,R.$sk)(o)}finally{await A.close(u)}}function y(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function g(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,R.$rk)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,12,2,31]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function y(o){return o.recursive===!0}e.$Up=y;class g extends F.$Rc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=g;class A extends g{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$Wp=A;class P extends g{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$Xp=P;function $(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$Yp=$;function S(o){const i=new u;for(const n of o)i.processEvent(n);return i.coalesce()}e.$Zp=S;function D(o,i){return typeof i=="string"&&!i.startsWith(I.$yj)&&!(0,f.$hc)(i)?{base:o,pattern:i}:i}e.$1p=D;function w(o,i){const n=[];for(const r of i)n.push((0,I.$Cj)(D(o,r)));return n}e.$2p=w;class u{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,b.$yk)(r.resource.fsPath,a,!R.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(ke[244],Se([1,0,55,11,21,33,3,76,16,12,23,2,103,30,84]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class w extends L.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new F.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$_g(t=>this.z(t),w.b)),this.g=(0,D.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,D.$2p)(this.m.path,this.m.includes):void 0,this.j=new f.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await S.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await S.Promises.realpath(i.path),i.path===n&&(n=await(0,$.$_p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(g.$j&&(0,R.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Rc.None;const r=new f.$2d(this.j.token),a=new L.$Qc;try{const t=P.URI.file(this.m.path),s=(0,y.$mc)(i),d=(0,I.watch)(i);a.add((0,L.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const c=new Set;if(n)try{for(const h of await S.Promises.readdir(i))c.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,L.$Pc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),d.on("error",(h,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${k})`),this.dispose()}),d.on("change",(h,k)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${k}`);let C="";if(k&&(C=k.toString(),g.$j&&(C=(0,b.$ul)(C))),!(!C||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(C)?.dispose();const m=setTimeout(async()=>{if(l.delete(C),C===s&&!await S.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,y.$ic)(i,C));if(r.token.isCancellationRequested)return;let v;p?c.has(C)?v=0:(v=1,c.add(C)):(c.delete(C),v=2),this.y({resource:(0,A.$zg)(t,C),type:v,cId:this.m.correlationId})},w.a);l.set(C,(0,L.$Pc)(()=>clearTimeout(m)))}else{let m;c.has(C)?m=0:(m=1,c.add(C)),this.y({resource:(0,A.$zg)(t,C),type:m,cId:this.m.correlationId})}else if(h==="rename"||C!==s){const m=setTimeout(async()=>{const p=await S.Promises.exists(i);r.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,L.$Pc)(()=>clearTimeout(m)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Pc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,D.$Zp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(g.$k)return S.Promises.exists(i);try{const n=(0,y.$mc)(i);return(await S.Promises.readdir((0,y.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=w;async function u(o,i,n,r,a=512){const t=await S.Promises.open(o,"r"),s=Buffer.allocUnsafe(a),d=new f.$2d(r);let c,l=!1;const h={path:o,excludes:[],recursive:!1},k=new w(h,C=>{(async()=>{for(const{type:m}of C)if(m===0){if(l)return;l=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await S.Promises.read(t,s,0,a,null);if(!p||d.token.isCancellationRequested)break;i(s.slice(0,p))}}catch(p){c=new Error(p),d.dispose(!0)}finally{l=!1}}})()});return await k.ready,n(),new Promise((C,m)=>{d.token.onCancellationRequested(async()=>{k.dispose();try{await S.Promises.close(t)}catch(p){c=new Error(p)}c?m(c):C()})})}e.$dq=u}),define(ke[245],Se([1,0,4,34,3,12,244]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class b extends f.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const A=this.j(g),P=A.filter(S=>{const D=this.c.get(S.path);return D?!(0,F.$Gj)(D.request.excludes,S.excludes)||!(0,F.$Gj)(D.request.includes,S.includes):!0}),$=Array.from(this.c.values()).filter(({request:S})=>!A.find(D=>D.path===S.path&&(0,F.$Gj)(D.excludes,S.excludes)&&(0,F.$Gj)(D.includes,S.includes))).map(({request:S})=>S.path);P.length&&this.m(`Request to start watching: ${P.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const S of $)this.h(S);for(const S of P)this.g(S)}g(g){const A=new L.$cq(g,$=>this.a.fire($),$=>this.b.fire($),this.f),P={request:g,instance:A};this.c.set(g.path,P)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const A=this.c.get(g);A&&(this.c.delete(g),A.instance.dispose())}j(g){const A=new Map;for(const P of g){const $=R.$k?P.path:P.path.toLowerCase();let S=A.get(P.correlationId);S||(S=new Map,A.set(P.correlationId,S)),S.set($,P)}return Array.from(A.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,A]of this.c)A.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,A){return A?`[File Watcher (node.js)] ${g} (path: ${A.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$eq=b}),define(ke[246],Se([1,0,84,245]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class f extends I.$Wp{constructor(L,b,y){super(L,b,y),this.s()}r(L){return L.add(new F.$eq)}}e.$fq=f}),define(ke[247],Se([1,0,17,81,187,84]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends R.$Xp{constructor(y,g,A){super(y,g,A),this.s()}r(y){const g=y.add(new f.$9p(I.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(g.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),F.ProxyChannel.toService((0,F.$Ch)(g.getChannel("watcher")))}}e.$0p=L}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class I{constructor(...f){this.a=new Map;for(const[R,L]of f)this.set(R,L)}set(f,R){const L=this.a.get(f);return this.a.set(f,R),L}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Th=I}),define(ke[248],Se([1,0,11,8,3,105,239,5,107,75]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const A=!1;class P extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class ${constructor(u=new y.$Th,o=!1,i,n=A){this.f=u,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Uh,this),this._globalGraph=n?i?._globalGraph??new L.$iq(r=>r):void 0}createChild(u){return new $(u,this.g,this,this.i)}invokeFunction(u,...o){const i=D.traceInvocation(this.i,u);let n=!1;try{return u({get:a=>{if(n)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(u,...o){let i,n;return u instanceof R.$Sh?(i=D.traceCreation(this.i,u.ctor),n=this.j(u.ctor,u.staticArguments.concat(o),i)):(i=D.traceCreation(this.i,u),n=this.j(u,o,i)),i.stop(),n}j(u,o=[],i){const n=b._util.getServiceDependencies(u).sort((t,s)=>t.index-s.index),r=[];for(const t of n){const s=this.m(t.id,i);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(s)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${u.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(u,o.concat(r))}k(u,o){if(this.f.get(u)instanceof R.$Sh)this.f.set(u,o);else if(this.h)this.h.k(u,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const o=this.f.get(u);return!o&&this.h?this.h.l(u):o}m(u,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const i=this.l(u);return i instanceof R.$Sh?this.q(u,i,o.branch(u,!0)):(o.branch(u,!1),i)}q(u,o,i){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,o,i)}finally{this.o.delete(u)}}r(u,o,i){const n=new L.$iq(t=>t.id.toString());let r=0;const a=[{id:u,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new P(n);for(const s of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(s.id);if(d||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof R.$Sh){const c={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,c),a.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:s}of t){if(this.l(s.id)instanceof R.$Sh){const c=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,c)}n.removeNode(s)}}return this.l(u)}s(u,o,i=[],n,r){if(this.f.get(u)instanceof R.$Sh)return this.t(u,o,i,n,r);if(this.h)return this.h.s(u,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(u,o,i=[],n,r){if(n){const a=new $(void 0,this.g,this,this.i);a.c=String(u);const t=new Map,s=new I.$eh(()=>{const d=a.j(o,i,r);for(const[c,l]of t){const h=d[c];if(typeof h=="function")for(const k of l)h.apply(d,k)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,c){if(!s.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let k=t.get(c);return k||(k=new g.$2c,t.set(c,k)),(m,p,v)=>{const E=k.push([m,p,v]);return(0,f.$Pc)(E)}}if(c in d)return d[c];const l=s.value;let h=l[c];return typeof h!="function"||(h=h.bind(l),d[c]=h),h},set(d,c,l){return s.value[c]=l,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,i,r)}u(u,o){if(o&&console.warn(u),this.g)throw new Error(u)}}e.$jq=$;var S;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(S||(S={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,o){return u?new D(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(u,o){return u?new D(1,o.name):D.c}static{this.f=0}constructor(u,o){this.type=u,this.name=o,this.g=Date.now(),this.h=[]}branch(u,o){const i=new D(3,u.toString());return this.h.push([u,o,i]),i}stop(){const u=Date.now()-this.g;D.f+=u;let o=!1;function i(r,a){const t=[],s=new Array(r+1).join("	");for(const[d,c,l]of a.h)if(c&&l){o=!0,t.push(`${s}CREATES -> ${d}`);const h=i(r+1,l);h&&t.push(h)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(u>2||o)&&D.all.add(n.join(`
`))}}e.$kq=D}),define(ke[14],Se([1,0,43,4,52,3,28,12,23,18,2,45,5]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,$.$Vh)("logService"),e.$ej=(0,$.$Vh)("loggerService");function S(){return new Date().toISOString()}function D(m){return(0,g.$Gf)(m)}e.$fj=D;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$gj=w.Info;function u(m,p,v){switch(p){case w.Trace:m.trace(v);break;case w.Debug:m.debug(v);break;case w.Info:m.info(v);break;case w.Warning:m.warn(v);break;case w.Error:m.error(v);break;case w.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=u;function o(m,p=!1){let v="";for(let E=0;E<m.length;E++){let N=m[E];if(N instanceof Error&&(N=(0,I.$Gi)(N,p)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(E>0?" ":"")+N}return v}class i extends R.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new F.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==w.Off&&this.b<=p}}e.$ij=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...v){this.f(w.Trace)&&this.g(w.Trace,o([p,...v],!0))}debug(p,...v){this.f(w.Debug)&&this.g(w.Debug,o([p,...v]))}info(p,...v){this.f(w.Info)&&this.g(w.Info,o([p,...v]))}warn(p,...v){this.f(w.Warning)&&this.g(w.Warning,o([p,...v]))}error(p,...v){if(this.f(w.Error))if(p instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=p.stack,this.g(w.Error,o(E))}else this.g(w.Error,o([p,...v]))}flush(){}}e.$jj=n;class r extends i{constructor(p=e.$gj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...v){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,p,...v):console.log(`[main ${S()}]`,p,...v))}debug(p,...v){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,p,...v):console.log(`[main ${S()}]`,p,...v))}info(p,...v){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,p,...v):console.log(`[main ${S()}]`,p,...v))}warn(p,...v){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,p,...v):console.warn(`[main ${S()}]`,p,...v))}error(p,...v){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,p,...v):console.error(`[main ${S()}]`,p,...v))}dispose(){}flush(){}}e.$kj=r;class a extends i{constructor(p=e.$gj,v=!0){super(),this.g=v,this.setLevel(p)}trace(p,...v){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...v):console.log(p,...v))}debug(p,...v){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...v):console.log(p,...v))}info(p,...v){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...v):console.log(p,...v))}warn(p,...v){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...v):console.log(p,...v))}error(p,...v){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...v):console.error(p,...v))}dispose(){}flush(){}}e.$lj=a;class t extends i{constructor(p,v=e.$gj){super(),this.g=p,this.setLevel(v)}trace(p,...v){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(p),...v])}debug(p,...v){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(p),...v])}info(p,...v){this.f(w.Info)&&this.g.log(w.Info,[this.h(p),...v])}warn(p,...v){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(p),...v])}error(p,...v){this.f(w.Error)&&this.g.log(w.Error,[this.h(p),...v])}h(p){return typeof p=="string"?p:(0,I.$Gi)(p,this.f(w.Trace))}dispose(){}flush(){}}e.$mj=t;class s extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const v of this.g)v.setLevel(p);super.setLevel(p)}trace(p,...v){for(const E of this.g)E.trace(p,...v)}debug(p,...v){for(const E of this.g)E.debug(p,...v)}info(p,...v){for(const E of this.g)E.info(p,...v)}warn(p,...v){for(const E of this.g)E.warn(p,...v)}error(p,...v){for(const E of this.g)E.error(p,...v)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$nj=s;class d extends R.$Rc{constructor(p,v,E){if(super(),this.h=p,this.j=v,this.b=new L.$zc,this.c=this.B(new F.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Rd),this.onDidChangeVisibility=this.g.event,E)for(const N of E)this.b.set(N.resource,{logger:void 0,info:N})}m(p){return(0,g.$Cf)(p)?[...this.b.values()].find(v=>v.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,v){const E=this.n(p),N=(0,g.$Cf)(p)?p:v?.id??(0,f.$Ji)(E.toString()).toString(16);let z=this.b.get(E)?.logger;const M=v?.logLevel==="always"?w.Trace:v?.logLevel;z||(z=this.s(E,M??this.getLogLevel(E)??this.h,{...v,id:N}));const T={logger:z,info:{resource:E,id:N,logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(T.info),this.b.set(E,T),z}n(p){return(0,g.$Cf)(p)?(0,y.$zg)(this.j,`${p}.log`):p}setLogLevel(p,v){if(A.URI.isUri(p)){const E=p,N=v,z=this.b.get(E);z&&N!==z.info.logLevel&&(z.info.logLevel=N===this.h?void 0:N,z.logger?.setLevel(N),this.b.set(z.info.resource,z),this.f.fire([E,N]))}else{this.h=p;for(const[E,N]of this.b.entries())this.b.get(E)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,v){const E=this.m(p);E&&v!==!E.info.hidden&&(E.info.hidden=!v,this.b.set(E.info.resource,E),this.g.fire([E.info.resource,v]))}getLogLevel(p){let v;return p&&(v=this.b.get(p)?.info.logLevel),v??this.h}registerLogger(p){const v=this.b.get(p.resource);v?v.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const v=this.b.get(p);v&&(v.logger&&v.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=d;class c{constructor(){this.onDidChangeLogLevel=new F.$Rd().event}setLevel(p){}getLevel(){return w.Info}trace(p,...v){}debug(p,...v){}info(p,...v){}warn(p,...v){}error(p,...v){}critical(p,...v){}dispose(){}flush(){}}e.$pj=c;class l extends c{}e.$qj=l;function h(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const p=C(m.logLevel.toLowerCase());if(p!==void 0)return p}return e.$gj}e.$rj=h;function k(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$sj=k;function C(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$tj=C,e.$uj=new P.$aj("logLevel",k(w.Info))}),define(ke[249],Se([1,0,19,11,8,4,3,16,84,14]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class A extends L.$Rc{constructor($,S){super(),this.a=$,this.b=S,this.c=this.B(new R.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Vg(0)),this.w=[],this.y=this.B(new F.$Vg(0))}watch($,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n($,S):this.z($,S)}n($,S){const D={path:this.H($),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},w=(0,I.$Tb)(this.j,D);return this.r(),(0,L.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,f.$Z)($))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,y.$Yp)(S)),S=>this.G(S),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const S of this.j)(0,y.$Up)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const S of this.j)(0,y.$Up)(S)&&$.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,S){const D={path:this.H($),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},w=(0,I.$Tb)(this.w,D);return this.C(),(0,L.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,f.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,y.$Yp)($)),$=>this.G($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,b.$gc)($.fsPath)}}e.$3p=A}),define(ke[250],Se([1,0,55,387,11,28,22,4,33,3,16,12,23,98,30,205,31,243,249,43,247,246]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.$Gi)(s)}`)}})();class t extends i.$3p{static{this.I=!1}constructor(d,c){super(d,c),this.onDidChangeCapabilities=b.Event.None,this.N=new R.$zc(l=>$.$qg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:c,symbolicLink:l}=await D.SymlinkSupport.stat(this.H(d));return{type:this.M(c,l),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:u.FilePermission.Locked}}catch(c){throw this.fb(c)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const c=await D.Promises.readdir(this.H(d),{withFileTypes:!0}),l=[];return await Promise.all(c.map(async h=>{try{let k;h.isSymbolicLink()?k=(await this.stat((0,$.$zg)(d,h.name))).type:k=this.M(h),l.push([h.name,k])}catch(k){this.a.trace(k)}})),l}catch(c){throw this.fb(c)}}M(d,c){let l;return c?.dangling?l=u.FileType.Unknown:d.isFile()?l=u.FileType.File:d.isDirectory()?l=u.FileType.Directory:l=u.FileType.Unknown,c&&(l|=u.FileType.SymbolicLink),l}async O(d){const c=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let l;for(;l=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await l.wait();const h=new f.$Wg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),h.open()})}async readFile(d,c){let l;try{c?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),l=await this.O(d));const h=this.H(d);return await D.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,c,l){const h=(0,S.$6d)(k=>L.$fe.concat(k.map(C=>L.$fe.wrap(C))).buffer);return(0,o.$Sp)(this,d,h,k=>k.buffer,{...c,bufferSize:256*1024},l),h}async writeFile(d,c,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,$.$zg)((0,$.$yg)(d),`${(0,$.$wg)(d)}${l.atomic.postfix}`),c,l):this.S(d,c,l)}async Q(d){try{const c=this.H(d),{symbolicLink:l}=await D.SymlinkSupport.stat(c);if(l)return!1}catch{}return!0}async R(d,c,l,h){const k=new g.$Qc;try{k.add(await this.O(d)),k.add(await this.O(c)),await this.S(c,l,h,!0);try{await this.rename(c,d,{overwrite:!0})}catch(C){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{k.dispose()}}async S(d,c,l,h){let k;try{const C=this.H(d);if(!l.create||!l.overwrite){if(await D.Promises.exists(C)){if(!l.overwrite)throw(0,u.$rk)((0,w.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,u.$rk)((0,w.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:l.unlock},h),await this.write(k,0,c,0,c.byteLength)}catch(C){throw await this.gb(d,C)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,c,l){const h=this.H(d);let k;(0,u.$fk)(c)&&!l&&(k=await this.O(d));let C;try{if((0,u.$fk)(c)&&c.unlock)try{const{stat:p}=await D.SymlinkSupport.stat(h);p.mode&128||await D.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let m;if((0,u.$fk)(c)){if(P.$i)try{await D.Promises.truncate(h,0),m="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}m||(m="w")}else m="r";C=await D.Promises.open(h,m)}catch(m){throw k?.dispose(),(0,u.$fk)(c)?await this.gb(d,m):this.fb(m)}if(this.U.set(C,0),(0,u.$fk)(c)&&this.X.set(C,d),k){const m=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${h})`),this.W.set(C,k),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${h})`),m.dispose())}return C}async close(d){const c=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await D.Promises.fdatasync(d)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await D.Promises.close(d)}catch(l){throw this.fb(l)}finally{c&&(this.W.get(d)===c&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),c.dispose())}}async read(d,c,l,h,k){const C=this.Z(d,c);let m=null;try{m=(await D.Promises.read(d,l,h,k,C)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,C,m)}return m}Z(d,c){return c===this.U.get(d)?null:c}$(d,c,l){const h=this.U.get(d);typeof h=="number"&&(typeof c=="number"||(typeof l=="number"?this.U.set(d,h+l):this.U.delete(d)))}async write(d,c,l,h,k){return(0,f.$fh)(()=>this.ab(d,c,l,h,k),100,3)}async ab(d,c,l,h,k){const C=this.Z(d,c);let m=null;try{m=(await D.Promises.write(d,l,h,k,C)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,C,m)}return m}async mkdir(d){try{await D.Promises.mkdir(this.H(d))}catch(c){throw this.fb(c)}}async delete(d,c){try{const l=this.H(d);if(c.recursive){let h;c?.atomic!==!1&&c.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(l),`${(0,A.$mc)(l)}${c.atomic.postfix}`)),await D.Promises.rm(l,D.RimRafMode.MOVE,h)}else try{await D.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let k=!1;try{const{stat:C,symbolicLink:m}=await D.SymlinkSupport.stat(l);k=C.isDirectory()&&!m}catch{}if(k)await D.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(d,c,l){const h=this.H(d),k=this.H(c);if(h!==k)try{await this.bb(d,c,"move",l.overwrite),await D.Promises.rename(h,k)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),C.toString()))),this.fb(C)}}async copy(d,c,l){const h=this.H(d),k=this.H(c);if(h!==k)try{await this.bb(d,c,"copy",l.overwrite),await D.Promises.copy(h,k,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),C.toString()))),this.fb(C)}}async bb(d,c,l,h){const k=this.H(d),C=this.H(c);let m=!1;if(!!(this.capabilities&1024)||(m=(0,y.$1f)(k,C,!0)),m){if(l==="copy")throw(0,u.$rk)((0,w.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const v=await this.L(d);if(!v)throw(0,u.$rk)((0,w.localize)(5,null),u.FileSystemProviderErrorCode.FileNotFound);const E=await this.L(c);if(E){if(!h)throw(0,u.$rk)((0,w.localize)(6,null),u.FileSystemProviderErrorCode.FileExists);v.type&u.FileType.File&&E.type&u.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,c){return this.cb(d,c,!1)}async cb(d,c,l){const h=this.H(d),k=this.H(c),C=!!(this.capabilities&1024);if((0,y.$1f)(h,k,!C))return;const m=new g.$Qc;try{m.add(await this.O(d)),m.add(await this.O(c)),l&&await D.Promises.mkdir((0,A.$lc)(k),{recursive:!0}),await D.Promises.copyFile(h,k)}catch(p){if(p.code==="ENOENT"&&!l)return this.cb(d,c,!0);throw this.fb(p)}finally{m.dispose()}}t(d,c,l){return new r.$0p(h=>d(h),h=>c(h),l)}F(d,c,l){return new a.$fq(h=>d(h),h=>c(h),l)}fb(d){if(d instanceof u.$qk)return d;let c=d,l;switch(d.code){case"ENOENT":l=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=u.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=u.FileSystemProviderErrorCode.Unknown;break;default:l=u.FileSystemProviderErrorCode.Unknown}return(0,u.$rk)(c,l)}async gb(d,c){let l=this.fb(c);if(d&&l.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await D.SymlinkSupport.stat(this.H(d));h.mode&128||(l=(0,u.$rk)(c,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$gq=t}),define(ke[251],Se([1,0,3,14]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;class f extends I.$Rc{constructor(L,b=[]){super(),this.a=new F.$nj([L,...b]),this.B(L.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$XN=f}),define(ke[252],Se([1,0,31,14]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0;var f;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(f||(f={}));async function R(g,A,P,$,S){try{const D=await new Promise((u,o)=>{me(["@vscode/spdlog"],u,o)});D.setFlushOn(f.Trace);const w=await D.createAsyncRotatingLogger(g,A,P,$);return S?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(D){console.error(D)}return null}function L(g,A,P){switch(A){case F.LogLevel.Trace:g.trace(P);break;case F.LogLevel.Debug:g.debug(P);break;case F.LogLevel.Info:g.info(P);break;case F.LogLevel.Warning:g.warn(P);break;case F.LogLevel.Error:g.error(P);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(g,A){switch(A){case F.LogLevel.Trace:g.setLevel(f.Trace);break;case F.LogLevel.Debug:g.setLevel(f.Debug);break;case F.LogLevel.Info:g.setLevel(f.Info);break;case F.LogLevel.Warning:g.setLevel(f.Warning);break;case F.LogLevel.Error:g.setLevel(f.Error);break;case F.LogLevel.Off:g.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class y extends F.$jj{constructor(A,P,$,S,D){super(),this.m=[],this.setLevel(D),this.n=this.s(A,P,$,S),this.B(this.onDidChangeLogLevel(w=>{this.r&&b(this.r,w)}))}async s(A,P,$,S){const D=$?6:1,w=30/D*I.$Mk.MB,u=await R(A,P,w,D,S);if(u){this.r=u,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)L(this.r,o,i);this.m=[]}}g(A,P){this.r?L(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$MN=y}),define(ke[136],Se([1,0,39,206,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(y){function g(D,w){return w-D}y.compare=g;const A=Object.create(null);A[y.Error]=(0,F.localize)(0,null),A[y.Warning]=(0,F.localize)(1,null),A[y.Info]=(0,F.localize)(2,null);function P(D){return A[D]||""}y.toString=P;function $(D){switch(D){case I.default.Error:return y.Error;case I.default.Warning:return y.Warning;case I.default.Info:return y.Info;case I.default.Ignore:return y.Hint}}y.fromSeverity=$;function S(D){switch(D){case y.Error:return I.default.Error;case y.Warning:return I.default.Warning;case y.Info:return I.default.Info;case y.Hint:return I.default.Ignore}}y.toSeverity=S}(L||(e.MarkerSeverity=L={}));var b;(function(y){const g="";function A($){return P($,!0)}y.makeKey=A;function P($,S){const D=[g];return $.source?D.push($.source.replace("\xA6","\\\xA6")):D.push(g),$.code?typeof $.code=="string"?D.push($.code.replace("\xA6","\\\xA6")):D.push($.code.value.replace("\xA6","\\\xA6")):D.push(g),$.severity!==void 0&&$.severity!==null?D.push(L.toString($.severity)):D.push(g),$.message&&S?D.push($.message.replace("\xA6","\\\xA6")):D.push(g),$.startLineNumber!==void 0&&$.startLineNumber!==null?D.push($.startLineNumber.toString()):D.push(g),$.startColumn!==void 0&&$.startColumn!==null?D.push($.startColumn.toString()):D.push(g),$.endLineNumber!==void 0&&$.endLineNumber!==null?D.push($.endLineNumber.toString()):D.push(g),$.endColumn!==void 0&&$.endColumn!==null?D.push($.endColumn.toString()):D.push(g),D.push(g),D.join("\xA6")}y.makeKeyOptionalMessage=P})(b||(e.IMarkerData=b={})),e.$gt=(0,f.$Vh)("markerService")}),define(ke[253],Se([1,0,4,39,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$7u=e.Severity=void 0,e.Severity=F.default,e.$7u=(0,f.$Vh)("notificationService");var R;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class y{constructor(){this.progress=new g,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$8u=y;class g{infinite(){}done(){}total(P){}worked(P){}}e.$9u=g}),define(ke[137],Se([1,0,13,2,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=e.$PU=e.$OU=e.$NU=e.$MU=void 0,e.$MU=(0,f.$Vh)("openerService");function R(g,A){return F.URI.isUri(g)?(0,I.$6e)(g.scheme,A):(0,I.$7e)(g,A+":")}e.$NU=R;function L(g,...A){return A.some(P=>R(g,P))}e.$OU=L;function b(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$PU=b;function y(g){let A;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return P&&(A={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$QU=y}),define(ke[254],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const R=f.context.configuration();if(R)F=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:R.version})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(ke[138],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,I.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(ke[85],Se([1,0,11,21,3,5]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.ProgressLocation=e.$0u=void 0,e.$0u=(0,R.$Vh)("progressService");var L;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$$u=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$_u=b;class y{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const S=this.d;this.d=()=>{S?.(),$()}}):Promise.resolve()}}e.$av=y;let g=class extends f.$Rc{constructor($,S){super(),this.a=new I.$ih,S.withProgress($,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,f.$Pc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$bv=g,e.$bv=g=He([Be(1,e.$0u)],g);class A extends f.$Rc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new f.$Qc)}start($){this.stop();const S=++this.a,D=new F.$2d;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,f.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Pc)(()=>D.cancel())),this.b.add((0,f.$Pc)(()=>this.c?this.c.done():void 0)),{id:S,token:D.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$cv=A,e.$dv=(0,R.$Vh)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class f{constructor(){this.a=new Map}add(L,b){I.ok(F.$Cf(L)),I.ok(F.$Ef(b)),I.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$mn=new f}),define(ke[108],Se([1,0,4,37]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function f(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new I.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,g){this.a[f(y)]=g,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;F.$mn.add(e.$nn.JSONContribution,L)}),define(ke[86],Se([1,0,19,4,18,196,44,108,37]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var g;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$rn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const P=y.$mn.as(b.$nn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$Rd,this.onDidSchemaChange=this.i.event,this.j=new F.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),P.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),P.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),P.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:c,source:l}of t)for(const h in c)if(s.add(h),e.$Bn.test(h)){const k=this.a.get(h),C=k?.valuesSources??new Map;if(l)for(const E of Object.keys(c[h]))C.set(E,l);const m={...k?.value||{},...c[h]};this.a.set(h,{source:l,value:m,valuesSources:C});const p=(0,L.$zi)(h),v={type:"object",default:m,description:R.localize(1,null,p),$ref:e.$yn,defaultDefaultValue:m,source:f.$Cf(l)?void 0:l,defaultValueSource:l};d.push(...w(h)),this.d[h]=v,this.b.properties[h]=v}else{this.a.set(h,{value:c[h],source:l});const k=this.d[h];k&&(this.w(h,k),this.r(h,k))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:c}of t)for(const l in d){const h=this.a.get(l),k=f.$Cf(c)?c:c?.id,C=f.$Cf(h?.source)?h?.source:h?.source?.id;if(k===C)if(s.add(l),this.a.delete(l),e.$Bn.test(l))delete this.d[l],delete this.b.properties[l];else{const m=this.d[l];m&&(this.w(l,m),this.r(l,m))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(c=>{this.p(c,s,c.extensionInfo,c.restrictedProperties,void 0,d),this.c.push(c),this.q(c)})}o(t,s){const d=c=>{if(c.properties)for(const l in c.properties){s.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,c.properties[l])}c.allOf?.forEach(l=>d(l))};for(const c of t){d(c);const l=this.c.indexOf(c);l!==-1&&this.c.splice(l,1)}}p(t,s=!0,d,c,l=3,h){l=f.$Lf(t.scope)?l:t.scope;const k=t.properties;if(k)for(const m in k){const p=k[m];if(s&&n(m,p)){delete k[m];continue}if(p.source=d,p.defaultDefaultValue=k[m].default,this.w(m,p),e.$Bn.test(m)?p.scope=void 0:(p.scope=f.$Lf(p.scope)?l:p.scope,p.restricted=f.$Lf(p.restricted)?!!c?.includes(m):p.restricted),k[m].hasOwnProperty("included")&&!k[m].included){this.f[m]=k[m],delete k[m];continue}else this.d[m]=k[m],k[m].policy?.name&&this.e.set(k[m].policy.name,m);!k[m].deprecationMessage&&k[m].markdownDeprecationMessage&&(k[m].deprecationMessage=k[m].markdownDeprecationMessage),h.add(m)}const C=t.allOf;if(C)for(const m of C)this.p(m,s,d,c,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const c=d.properties;if(c)for(const h in c)this.r(h,c[h]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$sn.properties[t]=s,s.scope){case 1:e.$tn.properties[t]=s;break;case 2:e.$un.properties[t]=s;break;case 6:e.$vn.properties[t]=s;break;case 3:e.$wn.properties[t]=s;break;case 4:e.$xn.properties[t]=s;break;case 5:e.$xn.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$sn.properties[t],s.scope){case 1:delete e.$tn.properties[t];break;case 2:delete e.$un.properties[t];break;case 6:delete e.$vn.properties[t];break;case 3:delete e.$wn.properties[t];break;case 4:case 5:delete e.$xn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$yn};this.w(s,d),e.$sn.properties[s]=d,e.$tn.properties[s]=d,e.$un.properties[s]=d,e.$vn.properties[s]=d,e.$wn.properties[s]=d,e.$xn.properties[s]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=t,e.$tn.patternProperties[e.$An]=t,e.$un.patternProperties[e.$An]=t,e.$vn.patternProperties[e.$An]=t,e.$wn.patternProperties[e.$An]=t,e.$xn.patternProperties[e.$An]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let c=d?.value,l=d?.source;f.$Jf(c)&&(c=s.defaultDefaultValue,l=void 0),f.$Jf(c)&&(c=o(s.type)),s.default=c,s.defaultValueSource=l}}const S="\\[([^\\]]+)\\]",D=new RegExp(S,"g");e.$An=`^(${S})+$`,e.$Bn=new RegExp(e.$An);function w(a){const t=[];if(e.$Bn.test(a)){let s=D.exec(a);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=D.exec(a)}}return(0,I.$Lb)(t)}e.$Cn=w;function u(a){return a.reduce((t,s)=>`${t}[${s}]`,"")}e.$Dn=u;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=o;const i=new $;y.$mn.add(e.$rn.Configuration,i);function n(a,t){return a.trim()?e.$Bn.test(a)?R.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$Fn=n;function r(){const a=[],t=i.getConfigurationProperties();for(const s of Object.keys(t))a.push([s,t[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Gn=r}),define(ke[255],Se([1,0,19,4,160,3,28,24,18,2,44,86,37]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function S(s){return Object.isFrozen(s)?s:b.$bn(s)}class D{constructor(d={},c=[],l=[],h){this.b=d,this.c=c,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(c=>{if(c instanceof D)return c;const l=new w("");return l.parseRaw(c),l.configurationModel});this.f=d.reduce((c,l)=>l===c?l:c.merge(l),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$xi)(this.contents,d):this.contents}inspect(d,c){const l=this.rawConfiguration.getValue(d),h=c?this.rawConfiguration.getOverrideValue(d,c):void 0,k=c?this.rawConfiguration.override(c).getValue(d):l;return{value:l,override:h,merged:k}}getOverrideValue(d,c){const l=this.i(c);return l?d?(0,A.$xi)(l,d):l:void 0}getKeysForOverrideIdentifier(d){const c=[];for(const l of this.overrides)l.identifiers.includes(d)&&c.push(...l.keys);return I.$Lb(c)}getAllOverrideIdentifiers(){const d=[];for(const c of this.overrides)d.push(...c.identifiers);return I.$Lb(d)}override(d){let c=this.a.get(d);return c||(c=this.g(d),this.a.set(d,c)),c}merge(...d){const c=b.$an(this.contents),l=b.$an(this.overrides),h=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const C of d)if(k.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(c,C.contents);for(const m of C.overrides){const[p]=l.filter(v=>I.$tb(v.identifiers,m.identifiers));p?(this.h(p.contents,m.contents),p.keys.push(...m.keys),p.keys=I.$Lb(p.keys)):l.push(b.$an(m))}for(const m of C.keys)h.indexOf(m)===-1&&h.push(m)}return new D(c,h,l,k.every(C=>C instanceof D)?void 0:k)}g(d){const c=this.i(d);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const l={};for(const h of I.$Lb([...Object.keys(this.contents),...Object.keys(c)])){let k=this.contents[h];const C=c[h];C&&(typeof k=="object"&&typeof C=="object"?(k=b.$an(k),this.h(k,C)):k=C),l[h]=k}return new D(l,this.keys,this.overrides)}h(d,c){for(const l of Object.keys(c)){if(l in d&&y.$Ef(d[l])&&y.$Ef(c[l])){this.h(d[l],c[l]);continue}d[l]=b.$an(c[l])}}i(d){let c=null,l=null;const h=k=>{k&&(l?this.h(l,k):l=b.$an(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===d?c=k.contents:k.identifiers.includes(d)&&h(k.contents);return h(c),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,c){this.j(d,c,!0)}setValue(d,c){this.j(d,c,!1)}removeValue(d){const c=this.keys.indexOf(d);c!==-1&&(this.keys.splice(c,1),(0,A.$wi)(this.contents,d),P.$Bn.test(d)&&this.overrides.splice(this.overrides.findIndex(l=>I.$tb(l.identifiers,(0,P.$Cn)(d))),1))}j(d,c,l){(0,A.$vi)(this.contents,d,c,h=>console.error(h)),l=l||this.keys.indexOf(d)===-1,l&&this.keys.push(d),P.$Bn.test(d)&&this.overrides.push({identifiers:(0,P.$Cn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ui)(this.contents[d],h=>console.error(h))})}}e.$Hn=D;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,c){if(!y.$Lf(d)){const l=this.g(d);this.parseRaw(l,c)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,c){this.a=d;const{contents:l,keys:h,overrides:k,restricted:C,hasExcludedProperties:m}=this.h(d,c);this.b=new D(l,h,k,m?[d]:void 0),this.c=C||[]}g(d){let c={},l=null,h=[];const k=[],C=[];function m(v){Array.isArray(h)?h.push(v):l!==null&&(h[l]=v)}const p={onObjectBegin:()=>{const v={};m(v),k.push(h),h=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{h=k.pop()},onArrayBegin:()=>{const v=[];m(v),k.push(h),h=v,l=null},onArrayEnd:()=>{h=k.pop()},onLiteralValue:m,onError:(v,E,N)=>{C.push({error:v,offset:E,length:N})}};if(d)try{f.$0m(d,p),c=h[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return c}h(d,c){const l=$.$mn.as(P.$rn.Configuration).getConfigurationProperties(),h=this.i(d,l,!0,c);d=h.raw;const k=(0,A.$ui)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),C=Object.keys(d),m=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:k,keys:C,overrides:m,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,c,l,h){let k=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:k};const C={},m=[];for(const p in d)if(P.$Bn.test(p)&&l){const v=this.i(d[p],c,!1,h);C[p]=v.raw,k=k||v.hasExcludedProperties,m.push(...v.restricted)}else{const v=c[p],E=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&m.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(E===void 0||h.scopes===void 0||h.scopes.includes(E))&&!(h.skipRestricted&&v?.restricted))?C[p]=d[p]:k=!0}return{raw:C,restricted:m,hasExcludedProperties:k}}j(d,c){const l=[];for(const h of Object.keys(d))if(P.$Bn.test(h)){const k={};for(const C in d[h])k[C]=d[h][C];l.push({identifiers:(0,P.$Cn)(h),keys:Object.keys(k),contents:(0,A.$ui)(k,c)})}return l}}e.$In=w;class u extends R.$Rc{constructor(d,c,l,h){super(),this.c=d,this.f=c,this.g=h,this.b=this.B(new F.$Rd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&l.isEqual(k.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=u;class o{constructor(d,c,l,h,k,C,m,p,v,E,N,z,M){this.a=d,this.b=c,this.c=l,this.overrideIdentifiers=h,this.d=k,this.f=C,this.g=m,this.h=p,this.i=v,this.j=E,this.k=N,this.l=z,this.m=M}get value(){return S(this.c)}n(d,c,l){const h=d.inspect(c,l);return{get value(){return S(h.value)},get override(){return S(h.override)},get merged(){return S(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,c,l,h,k=new D,C=new D,m=new L.$zc,p=new D,v=new L.$zc){this.c=d,this.d=c,this.f=l,this.g=h,this.h=k,this.i=C,this.j=m,this.l=p,this.m=v,this.a=null,this.b=new L.$zc,this.n=null}getValue(d,c,l){return this.p(d,c,l).getValue(d)}updateValue(d,c,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new D,this.m.set(l.resource,h))):h=this.l,c===void 0?h.removeValue(d):h.setValue(d,c),l.resource||(this.a=null)}inspect(d,c,l){const h=this.p(d,c,l),k=this.t(c.resource,l),C=c.resource?this.m.get(c.resource)||this.l:this.l,m=new Set;for(const p of h.overrides)for(const v of p.identifiers)h.getOverrideValue(d,v)!==void 0&&m.add(v);return new o(d,c,h.getValue(d),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,k||void 0,C)}keys(d){const c=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,c){this.j.set(d,c),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,c){const l=[];if(!c){const{added:h,updated:k,removed:C}=a(this.c,d);c=[...h,...k,...C]}for(const h of c)for(const k of(0,P.$Cn)(h)){const C=this.c.getKeysForOverrideIdentifier(k),m=d.getKeysForOverrideIdentifier(k),p=[...m.filter(v=>C.indexOf(v)===-1),...C.filter(v=>m.indexOf(v)===-1),...C.filter(v=>!b.$en(this.c.override(k).getValue(v),d.override(k).getValue(v)))];l.push([k,p])}return this.updateDefaultConfiguration(d),{keys:c,overrides:l}}compareAndUpdatePolicyConfiguration(d){const{added:c,updated:l,removed:h}=a(this.d,d),k=[...c,...l,...h];return k.length&&this.updatePolicyConfiguration(d),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:c,updated:l,removed:h,overrides:k}=a(this.applicationConfiguration,d),C=[...c,...l,...h];return C.length&&this.updateApplicationConfiguration(d),{keys:C,overrides:k}}compareAndUpdateLocalUserConfiguration(d){const{added:c,updated:l,removed:h,overrides:k}=a(this.localUserConfiguration,d),C=[...c,...l,...h];return C.length&&this.updateLocalUserConfiguration(d),{keys:C,overrides:k}}compareAndUpdateRemoteUserConfiguration(d){const{added:c,updated:l,removed:h,overrides:k}=a(this.remoteUserConfiguration,d),C=[...c,...l,...h];return C.length&&this.updateRemoteUserConfiguration(d),{keys:C,overrides:k}}compareAndUpdateWorkspaceConfiguration(d){const{added:c,updated:l,removed:h,overrides:k}=a(this.workspaceConfiguration,d),C=[...c,...l,...h];return C.length&&this.updateWorkspaceConfiguration(d),{keys:C,overrides:k}}compareAndUpdateFolderConfiguration(d,c){const l=this.folderConfigurations.get(d),{added:h,updated:k,removed:C,overrides:m}=a(l,c),p=[...h,...k,...C];return(p.length||!l)&&this.updateFolderConfiguration(d,c),{keys:p,overrides:m}}compareAndDeleteFolderConfiguration(d){const c=this.folderConfigurations.get(d);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:l,updated:h,removed:k,overrides:C}=a(c,void 0);return{keys:[...l,...h,...k],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,c,l){let h=this.q(c,l);return c.overrideIdentifier&&(h=h.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},c){let l=this.r();if(c&&d){const h=c.getFolder(d);h&&(l=this.s(h.uri)||l);const k=this.m.get(d);k&&(l=l.merge(k))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let c=this.b.get(d);if(!c){const l=this.r(),h=this.j.get(d);h?(c=l.merge(h),this.b.set(d,c)):c=l}return c}t(d,c){if(c&&d){const l=c.getFolder(d);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,c)=>{const{contents:l,overrides:h,keys:k}=this.j.get(c);return d.push([c,{contents:l,overrides:h,keys:k}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(c=>d.add(c)),this.userConfiguration.keys.forEach(c=>d.add(c)),this.i.keys.forEach(c=>d.add(c)),this.j.forEach(c=>c.keys.forEach(l=>d.add(l))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(l=>d.add(l))),[...d.values()]}v(d){const c=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.i.getKeysForOverrideIdentifier(d).forEach(l=>c.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(d).forEach(h=>c.add(h))),[...c.values()]}static parse(d){const c=this.w(d.defaults),l=this.w(d.policy),h=this.w(d.application),k=this.w(d.user),C=this.w(d.workspace),m=d.folders.reduce((p,v)=>(p.set(g.URI.revive(v[0]),this.w(v[1])),p),new L.$zc);return new i(c,l,h,k,new D,C,m,new D,new L.$zc)}static w(d){return new D(d.contents,d.keys,d.overrides)}}e.$Kn=i;function n(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const d=new Set,c=new Map;for(const h of s)h.keys.forEach(k=>d.add(k)),h.overrides.forEach(([k,C])=>{const m=(0,L.$wc)(c,k,new Set);C.forEach(p=>m.add(p))});const l=[];return c.forEach((h,k)=>l.push([k,[...h.values()]])),{keys:[...d.values()],overrides:l}}e.$Ln=n;class r{constructor(d,c,l,h){this.change=d,this.f=c,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of d.keys)this.affectedKeys.add(k);for(const[,k]of d.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,c){const l=this.a+d,h=this.d.indexOf(l);if(h<0)return!1;const k=h+l.length;if(k>=this.d.length)return!1;const C=this.d.charCodeAt(k);if(C!==this.b&&C!==this.c)return!1;if(c){const m=this.previousConfiguration?this.previousConfiguration.getValue(d,c,this.f?.workspace):void 0,p=this.g.getValue(d,c,this.h);return!b.$en(m,p)}return!0}}e.$Mn=r;function a(s,d){const{added:c,removed:l,updated:h}=t(d?.rawConfiguration,s?.rawConfiguration),k=[],C=s?.getAllOverrideIdentifiers()||[],m=d?.getAllOverrideIdentifiers()||[];if(d){const p=m.filter(v=>!C.includes(v));for(const v of p)k.push([v,d.getKeysForOverrideIdentifier(v)])}if(s){const p=C.filter(v=>!m.includes(v));for(const v of p)k.push([v,s.getKeysForOverrideIdentifier(v)])}if(d&&s){for(const p of C)if(m.includes(p)){const v=t({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});k.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:c,removed:l,updated:h,overrides:k}}function t(s,d){const c=s?d?s.keys.filter(k=>d.keys.indexOf(k)===-1):[...s.keys]:[],l=d?s?d.keys.filter(k=>s.keys.indexOf(k)===-1):[...d.keys]:[],h=[];if(s&&d){for(const k of d.keys)if(s.keys.indexOf(k)!==-1){const C=(0,A.$xi)(d.contents,k),m=(0,A.$xi)(s.contents,k);b.$en(C,m)||h.push(k)}}return{added:c,removed:l,updated:h}}}),define(ke[256],Se([1,0,22,4,3,82]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pb=e.$8pb=e.$7pb=e.$6pb=void 0;const L=(g,A,P)=>{const $=new Uint8Array(16);for(let w=0;w<16;w++)$[w]=Math.round(Math.random()*256);const S=(0,I.$ze)(I.$fe.wrap($));return[`GET ws://localhost${g}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$6pb=L,e.$7pb=I.$fe.fromString(`\r
\r
`);async function b(g,A,P,$,S){g.write(I.$fe.fromString((0,e.$6pb)(A,P,$)));const D=new f.$Qc;try{return await new Promise((w,u)=>{let o;D.add(g.onData(i=>{o?o=I.$fe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$7pb);if(n===-1)return;w(g),g.pauseData();const r=o.slice(n+e.$7pb.byteLength);r.byteLength&&S.onData.fire(r)})),D.add(g.onClose(i=>u(i??new Error("socket closed")))),D.add(g.onEnd(()=>u(new Error("socket ended"))))})}catch(w){throw g.dispose(),w}finally{D.dispose()}}e.$8pb=b;class y extends f.$Rc{constructor(A,P){super(),this.g=A,this.a=this.B(new F.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new F.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event($=>this.a.fire($))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$9pb=y}),define(ke[64],Se([1,0,8,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,F.$Vh)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=R;class L{constructor(P,$){this.host=P,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=L;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class y extends I.$ab{static isNotAvailable(P){return P instanceof y&&P._code===b.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===b.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===b.NoResolverFound}static isInvalidAuthority(P){return P instanceof y&&P._code===b.InvalidAuthority}static isHandled(P){return P instanceof y&&P.isHandled}constructor(P,$=b.Unknown,S){super(P),this._message=P,this._code=$,this._detail=S,this.isHandled=$===b.NotAvailable&&S===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Yk=y;function g(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}e.$Zk=g}),define(ke[65],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function F(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$1k=F;function f(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$2k=f;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$3k=R;function L(g){const{host:A,port:P}=y(g);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:P}}e.$4k=L;function b(g,A){let{host:P,port:$}=y(g);return typeof $>"u"&&($=A),{host:P,port:$}}e.$5k=b;function y(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const P=g.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$0l=R,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class y{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,o){if(typeof u>"u"||u===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof u=="string"||typeof o=="string"){const i=typeof u=="string"?u:u.value,n=typeof o=="string"?o:o.value;return I.$6e(i,n)}return u._lower===o._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$_l=y;class g{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const o of u)this.add(o)}add(u){this.c.add(y.toKey(u))}delete(u){return this.c.delete(y.toKey(u))}has(u){return this.c.has(y.toKey(u))}}e.$am=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(y.toKey(u))}get(u){return this.c.get(y.toKey(u))}has(u){return this.c.has(y.toKey(u))}set(u,o){this.c.set(y.toKey(u),o)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=A;function P(w){return $(w)}e.$cm=P;function $(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$dm=$;function S(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$em=S;function D(w,u){if(u){const o=`onResolveRemoteAuthority:${(0,f.$2k)(u)}`;return!!w.activationEvents?.includes(o)}return!1}e.$fm=D,e.$gm=(0,F.$Vh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,8,26]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const y of L){const g=this.readActivationEvents(y);g.length>0&&(b[F.$_l.toKey(y.identifier)]=g)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let y=0;y<b.length;y++)b[y]==="onUri"&&(b[y]=`onUri:${F.$_l.toKey(L.identifier)}`);if(!L.contributes)return b;for(const y in L.contributes){const g=this.a.get(y);if(!g)continue;const A=L.contributes[y],P=Array.isArray(A)?A:[A];try{g(P,b)}catch($){(0,I.$Z)($)}}return b}}e.$xF=f,e.$yF=new f}),define(ke[257],Se([1,0,11,22,21,8,4,3,56,38,32,82,64,65]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const D=30*1e3;var w;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function u(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const U=new f.$2d;return setTimeout(()=>U.cancel(),q),U.token}function i(q,U){if(q.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const ie=new f.$2d;return q.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((ie,be)=>{this.f=ie,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(q,U){const ie=new n(U);return ie.registerDisposable(q.onControlMessage(be=>{const H=JSON.parse(be.toString()),X=Q(H);X?ie.reject(X):ie.resolve(H)})),ie.promise}function a(q,U,ie,be,H,X,Y,$e){const ne=new n($e),de=g.$Nd.create(!1);return q.info(`Creating a socket (${Y})...`),y.mark(`code/willCreateSocket/${X}`),U.connect(ie,be,H,Y).then(ee=>{ne.didTimeout?(y.mark(`code/didCreateSocketError/${X}`),q.info(`Creating a socket (${Y}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(y.mark(`code/didCreateSocketOK/${X}`),q.info(`Creating a socket (${Y}) was successful after ${de.elapsed()} ms.`),ne.resolve(ee))},ee=>{y.mark(`code/didCreateSocketError/${X}`),q.info(`Creating a socket (${Y}) returned an error after ${de.elapsed()} ms.`),q.error(ee),ne.reject(ee)}),ne.promise}function t(q,U){const ie=new n(U);return q.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function s(q,U,ie,be){const H=Ee(q,U);q.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let X;try{X=await a(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,S.$3k)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,u(U),`renderer-${u(U)}-${q.reconnectionToken}`,be)}catch(ee){throw q.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ee),ee}q.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Y,$e;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(X,null),Y=q.reconnectionProtocol,$e=!1):(Y=new P.$Jh({socket:X}),$e=!0),q.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const ne=await t(q.signService.createNewMessage((0,A.$ig)()),be),de={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ne.data};Y.sendControl(F.$fe.fromString(JSON.stringify(de)));try{const ee=await r(Y,i(be,o(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(q.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(q.signService.validate(ne,ee.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const pe=await t(q.signService.sign(ee.data),be),Pe={type:"connectionType",commit:q.commit,signedData:pe,desiredConnectionType:U};return ie&&(Pe.args=ie),q.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(F.$fe.fromString(JSON.stringify(Pe))),{protocol:Y,ownsProtocol:$e}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(q.logService.error(`${H} the handshake timed out. Error:`),q.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error(ee)),$e&&Z(Y),ee}}async function d(q,U,ie,be){const H=Date.now(),X=Ee(q,U),{protocol:Y,ownsProtocol:$e}=await s(q,U,ie,be),ne=new n(be);return ne.registerDisposable(Y.onControlMessage(de=>{const ee=JSON.parse(de.toString()),he=Q(ee);he?(q.logService.error(`${X} received error control message when negotiating connection. Error:`),q.logService.error(he),$e&&Z(Y),ne.reject(he)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${le(H)}!`),ne.resolve({protocol:Y,firstMessage:ee}))})),ne.promise}async function c(q,U){const{protocol:ie}=await d(q,1,void 0,U);return{protocol:ie}}async function l(q,U,ie){const{protocol:be,firstMessage:H}=await d(q,2,U,ie),X=H&&H.debugPort;return{protocol:be,debugPort:X}}async function h(q,U,ie){const be=Date.now(),H=Ee(q,3),{protocol:X}=await s(q,3,U,ie);return q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${le(be)}!`),X}async function k(q,U,ie){const{connectTo:be,connectionToken:H}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:be,connectionToken:H,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function C(q,U,ie){return p(q,async be=>{const{protocol:H}=await c(be,f.CancellationToken.None);return new te(q,U,ie,be.reconnectionToken,H)})}e.$0k=C;async function m(q,U){return p(q,async ie=>{const{protocol:be,debugPort:H}=await l(ie,U,f.CancellationToken.None);return new fe(q,U,ie.reconnectionToken,be,H)})}e.$$k=m;async function p(q,U){for(let be=1;;be++)try{const H=(0,A.$ig)(),X=await k(q,H,null);return await U(X)}catch(H){if(be<5)q.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(H);else throw q.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(H),V.triggerPermanentFailure(0,0,$.$Yk.isHandled(H)),H}}async function v(q,U,ie){const be=await k(q,(0,A.$ig)(),null);return await h(be,{host:U,port:ie},f.CancellationToken.None)}e.$_k=v;function E(q){return(0,I.$Lg)(U=>new Promise((ie,be)=>{const H=setTimeout(ie,q*1e3);U.onCancellationRequested(()=>{clearTimeout(H),ie()})}))}var N;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class z{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$al=z;class M{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$bl=M;class T{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$cl=T;class j{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$dl=j;class O{constructor(U,ie,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=H,this.type=3}}e.$el=O;class V extends b.$Rc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(H=>H.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||V._permanentFailure}constructor(U,ie,be,H,X){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=H,this.w=X,this.m=this.B(new L.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Y=>{const $e=x(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(H.onSocketTimeout(Y=>{const $e=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),V.j.push(this),this.B((0,b.$Pc)(()=>{const Y=V.j.indexOf(this);Y>=0&&V.j.splice(Y,1)})),this.n&&this.D(V.f,V.g,V.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const H=be<ie.length?ie[be]:ie[ie.length-1];try{if(H>0){const Y=E(H);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Y)),this.u.logService.info(`${U} waiting for ${H} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const X=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${X.connectTo}...`),await this.G(X,o(D)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if($.$Yk.isTemporarilyNotAvailable(X)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,R.$3)(X)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof $.$Yk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,$.$Yk.isHandled(X));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?V.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new O(this.reconnectionToken,U,ie,be)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=V;class te extends V{constructor(U,ie,be,H,X){super(1,U,H,X,!0),this.client=this.B(new P.$Hh(X,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await c(U,ie)}}e.$gl=te;class fe extends V{constructor(U,ie,be,H,X){super(2,U,be,H,!1),this.H=ie,this.debugPort=X}async G(U,ie){await l(U,this.H,ie)}}e.$hl=fe;function Z(q){try{q.acceptDisconnect();const U=q.getSocket();q.dispose(),U.dispose()}catch(U){(0,R.$Z)(U)}}function Q(q){if(q&&q.type==="error"){const U=new Error(`Connection error: ${q.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function G(q,U){for(;q.length<U;)q+=" ";return q}function oe(q,U){return`[remote-connection][${G(u(q),13)}][${U.substr(0,5)}\u2026]`}function x(q,U,ie){return`${oe(q,U)}[${ie?"reconnect":"initial"}]`}function Ee(q,U){return`${x(U,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function le(q){return`${Date.now()-q} ms`}}),define(ke[258],Se([1,0,3,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,F.$Vh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,I.$Pc)(()=>{const y=this.a[L]?.indexOf(b);typeof y=="number"&&y>=0&&this.a[L]?.splice(y,1)})}b(L){return(this.a[L.type]||[]).find(y=>y.supports(L))}connect(L,b,y,g){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,b,y,g)}}e.$7k=f}),define(ke[259],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const R=await this.c();if(R){const L=String(I.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const L=this.b.get(f.id);if(!L)return!1;this.b.delete(f.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$P4b=I}),define(ke[109],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,I.$Vh)(e.$8k)}),define(ke[140],Se([1,0,259]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M9b=void 0;class F extends I.$P4b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>me(["vsda"],R,L))}}e.$M9b=F}),define(ke[260],Se([1,0,12,49,32]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function R(y){if(I.$u===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function L(y,g,A,P,$,S,D,w,u){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=D,o.sessionID=(0,f.$ig)()+Date.now(),o.commitHash=P,o.version=$,o["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,I.$h)(I.$u),o["common.nodePlatform"]=F.$cc,o["common.nodeArch"]=A,o["common.product"]=u||"desktop",w&&(o["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(o["common.snap"]="true");const r=R(g);return r&&(o["common.platformDetail"]=r),o}e.$no=L;function b(y){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return y.some(P=>A===P)}e.$oo=b}),define(ke[261],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,I.$Vh)("telemetryService"),e.$jl=(0,I.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var F;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ke[87],Se([1,0,24,18,4,44,65,260,261]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class g{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$po=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=A,e.$ro=new A;class P{async publicLog(l,h,k){}async publicLogError(l,h,k){}}e.$so=P,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function $(c,l){return f.Event.debounce(l.onDidChangeConfiguration,(k,C)=>{const m=k?new Set([...k.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:m}},1e3,!0)(k=>{k.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.$si)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$wo=$;function S(c,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!c.enableTelemetry)}e.$xo=S;function D(c,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.$yo=D;function w(c){const l=c.getValue(y.$ql),h=c.getValue(y.$rl);if(c.getValue(y.$sl)===!1||h===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=w;function u(c){const l={},h={},k={};n(c,k);for(let C in k){C=C.length>150?C.substr(C.length-149):C;const m=k[C];typeof m=="number"?h[C]=m:typeof m=="boolean"?h[C]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${m.length}`),l[C]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(l[C]=m)}return{properties:l,measurements:h}}e.$Ao=u;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(c){if(!c)return"none";const l=(0,L.$2k)(c);return o.has(l)?l:"other"}e.$Bo=i;function n(c,l,h=0,k){if(c)for(const C of Object.getOwnPropertyNames(c)){const m=c[C],p=k?k+C:C;Array.isArray(m)?l[p]=(0,I.$fn)(m):m instanceof Date?l[p]=m.toISOString():(0,F.$Ef)(m)?h<2?n(m,l,h+1,p+"."):l[p]=(0,I.$fn)(m):l[p]=m}}function r(c,l){const h=c.msftInternalDomains||[],k=l.getValue("telemetry.internalTesting");return(0,b.$oo)(h)||k}e.$Co=r;function a(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.$Do=a;function t(c,l){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let h=c;const k=[];for(const v of l)for(;;){const E=v.exec(c);if(!E)break;k.push([E.index,v.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const v=m.exec(c);if(!v)break;const E=k.some(([N,z])=>v.index<z&&N<m.lastIndex);!C.test(v[0])&&!E&&(h+=c.substring(p,v.index)+"<REDACTED: user-file-path>",p=m.lastIndex)}return p<c.length&&(h+=c.substr(p)),h}function s(c){if(!c)return c;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return c}function d(c,l){return(0,I.$cn)(c,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let k=h.replaceAll("%20"," ");k=t(k,l);for(const C of l)k=k.replace(C,"");return k=s(k),k}})}e.$Eo=d}),define(ke[262],Se([1,0,13,135,26,12,2,8,49,87]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function A(d,c){return d.uuid&&c.uuid?d.uuid===c.uuid:d.id===c.id?!0:(0,I.$1e)(d.id,c.id)===0}e.$Fo=A;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(c){const l=c.manifest?c.manifest.version:c.version,h=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new $(c.identifier,l,h)}static parse(c){const l=P.exec(c);return l&&l[1]&&l[2]?new $({id:l[1]},l[2],l[4]||void 0):null}constructor(c,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof $?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$Go=$;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(d){const c=S.exec(d);return c&&c[1]?[u(c[1]),c[2]]:[u(d),void 0]}e.$Ho=D;function w(d,c){return`${d}.${c}`}e.$Io=w;function u(d){return d.toLowerCase()}e.$Jo=u;function o(d,c){return u(w(d??f.$8l,c))}e.$Ko=o;function i(d,c){const l=[],h=k=>{for(const C of l)if(C.some(m=>A(c(m),c(k))))return C;return null};for(const k of d){const C=h(k);C?C.push(k):l.push([k])}return l}e.$Lo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Mo=n;function r(d){return{id:new g.$po(d.identifier.id),name:new g.$po(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$No=r,e.$Oo=new f.$_l("pprice.better-merge");function a(d,c){const l=[],h=c.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&l.every(C=>!A(C.identifier,{id:k}))){const C=d.filter(m=>A(m.identifier,{id:k}));C.length===1&&(l.push(C[0]),h.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$Po=a;async function t(d,c){if(!R.$k)return!1;let l;try{l=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){c.debug("Error while getting the os-release file.",(0,b.$9)(k))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,c){const l=await t(d,c),h=(0,F.$_n)(l?"alpine":R.$u,y.$dc);return c.debug("ComputeTargetPlatform:",h),h}e.$Qo=s}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=void 0;function I(y){return[...y.entries()]}e.$rr=I;function F(y){return y?[...y.entries()]:[]}e.$sr=F;function f(y){return new Map(y)}e.$tr=f;function R(y){return new Map(y??[])}e.$ur=R;function L(y){return Array.from(y.entries()).map(g=>[g[0],I(g[1].map),F(g[1].descriptionMap)])}e.$vr=L;function b(y){return new Map(y.map(g=>[g[0],{map:f(g[1]),descriptionMap:R(g[2])}]))}e.$wr=b}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqb=void 0;class I{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,L=5){const b=R(y=>{const g=typeof y=="string"?y:y.data;let A=this.a.get(f);if(A){A.data.push(g);return}const P=setTimeout(()=>this.flushBuffer(f),L);A={data:[g],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(f),b.dispose()}},this.a.set(f,A)});return b}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$nqb=I}),define(ke[265],Se([1,0,11,78,61,4,18,2,207,108,37]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var P;(function(r){function a(t,s){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const c=D.getIcon(d.id);if(!c)return;d=c.defaults}return d}r.getDefinition=a})(P||(e.IconContribution=P={}));var $;(function(r){function a(s){return{weight:s.weight,style:s.style,src:s.src.map(d=>({format:d.format,location:d.location.toString()}))}}r.toJSONObject=a;function t(s){const d=c=>(0,L.$Cf)(c)?c:void 0;if(s&&Array.isArray(s.src)&&s.src.every(c=>(0,L.$Cf)(c.format)&&(0,L.$Cf)(c.location)))return{weight:d(s.weight),style:d(s.style),src:s.src.map(c=>({format:c.format,location:b.URI.parse(c.location)}))}}r.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class S{constructor(){this.a=new R.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,s,d){const c=this.b[a];if(c){if(s&&!c.description){c.description=s,this.d.properties[a].markdownDescription=`${s} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=s),this.a.fire()}return c}const l={id:a,description:s,defaults:t,deprecationMessage:d};this.b[a]=l;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),s&&(h.markdownDescription=`${s}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const s=this.f[a];return s||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(c,l)=>c.id.localeCompare(l.id),t=c=>{for(;f.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(c=>this.b[c]);for(const c of d.filter(l=>!!l.description).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|${f.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const c of d.filter(l=>!f.ThemeIcon.isThemeIcon(l.defaults)).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|`);return s.join(`
`)}}const D=new S;A.$mn.add(e.$_v.IconContribution,D);function w(r,a,t,s){return D.registerIcon(r,a,t,s)}e.$aw=w;function u(){return D}e.$bw=u;function o(){const r=(0,F.$Yj)();for(const a in r){const t="\\"+r[a].toString(16);D.registerIcon(a,{fontCharacter:t})}}o(),e.$cw="vscode://schemas/icons";const i=A.$mn.as(g.$nn.JSONContribution);i.registerSchema(e.$cw,D.getIconSchema());const n=new I.$0g(()=>i.notifySchemaChanged(e.$cw),200);D.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$dw=w("widget-close",F.$1j.close,(0,y.localize)(2,null)),e.$ew=w("goto-previous-location",F.$1j.arrowUp,(0,y.localize)(3,null)),e.$fw=w("goto-next-location",F.$1j.arrowDown,(0,y.localize)(4,null)),e.$gw=f.ThemeIcon.modify(F.$1j.sync,"spin"),e.$hw=f.ThemeIcon.modify(F.$1j.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,14]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.ProvidedOnAutoForward=e.$gv=e.TunnelPrivacyId=e.TunnelProtocol=e.$fv=e.$ev=void 0,e.$ev=(0,f.$Vh)("tunnelService"),e.$fv=(0,f.$Vh)("sharedTunnelsService");var L;(function(u){u.Http="http",u.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(b||(e.TunnelPrivacyId=b={}));function y(u){return!!u.forwardPort}e.$gv=y;var g;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(o)return{address:o[1],port:+o[2]}}e.$hv=A,e.$iv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(u){return e.$iv.indexOf(u)>=0}e.$jv=P,e.$kv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(u){return e.$kv.indexOf(u)>=0}e.$lv=$;function S(u,o,i,n){if(i===1)return!1;if(i===2&&$(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return u<1024}e.$mv=S;class D{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new I.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$nv=D;let w=class{constructor(o,i){this.j=o,this.k=i,this.a=new I.$Rd,this.onTunnelOpened=this.a.event,this.b=new I.$Rd,this.onTunnelClosed=this.b.event,this.c=new I.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const a of r){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,r,a){this.p(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){($(o)||P(o))&&(o=e.$iv[0]);const n=this.r(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,a,t=!1,s,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const c=this.f??o;if(!c)return;if(i||(i="localhost"),r||(r=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.s(c,i,n,r,a,t,s,d);return l?l.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&h.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async o(o,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),r}}async closeTunnel(o,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.o(o,i,r)}}p(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async q(o,i){const n=this.e.get(o);if(n){const r=n.get(i),a=r?await r.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}r(o,i){const n=[o];P(o)?(n.push(...e.$iv),n.push(...e.$kv)):$(o)&&n.push(...e.$kv);const r=n.map(a=>this.e.get(a));for(const a of r){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!A(o)}t(o,i,n,r,a,t,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const d=n;this.i.add(d);const c=r===void 0?n:r,l={elevationRequired:a?this.isPortPrivileged(c):!1},h={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==b.Private:void 0,protocol:s},k=o.forwardPort(h,l);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),k}};e.$ov=w,e.$ov=w=He([Be(0,R.$dj),Be(1,F.$pi)],w)}),define(ke[266],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,I.$Vh)("IUriIdentityService")}),define(ke[267],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$pv=void 0,e.$pv=(0,I.$Vh)("editSessionIdentityService");var F;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ke[268],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=void 0;function F(y){return y.scheme!==I.Schemas.file&&y.scheme!==I.Schemas.vscodeRemote}e.$8J=F;function f(y){if(y.folders.length)return y.folders.every(g=>F(g.uri))?y.folders[0].uri:void 0;if(y.configuration&&F(y.configuration))return y.configuration}e.$9J=f;function R(y){return f(y)?.scheme}e.$0J=R;function L(y){return f(y)?.authority}e.$$J=L;function b(y){return f(y)!==void 0}e.$_J=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,b.$Vh)("contextService");function g(c){const l=c;return typeof l?.id=="string"&&L.URI.isUri(l.uri)}e.$6h=g;function A(c){return typeof c?.id=="string"&&!g(c)&&!$(c)}e.$7h=A,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function P(c,l){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,F.$mc)(c)}:l?e.$8h:e.$9h;const h=c;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$0h=P;function $(c){const l=c;return typeof l?.id=="string"&&L.URI.isUri(l.configPath)}e.$$h=$;function S(c){const l=c;if(l?.uri)return{id:l.id,uri:L.URI.revive(l.uri)};const h=c;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(c?.id)return{id:c.id}}e.$_h=S;var D;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function w(c){const l=c;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$ai=w;function u(c){const l=c;return!!(l&&typeof l=="object"&&L.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$bi=u;class o{constructor(l,h,k,C,m){this.h=l,this.j=k,this.k=C,this.l=m,this.c=f.$2h.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=f.$2h.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=o;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,R.$zg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=i;function n(c){return new i({uri:c,index:0,name:(0,R.$vg)(c)},{uri:c.toString()})}e.$ei=n,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,I.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function r(c,l){return R.$qg.isEqualOrParent(c,l.untitledWorkspacesHome)}e.$ji=r;function a(c){let l;return L.URI.isUri(c)?l=c:l=c.configuration,l?.scheme===y.Schemas.tmp}e.$ki=a,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$li}e.$mi=t;function s(c,l){return!r(c,l)&&!a(c)}e.$ni=s;function d(c){return(typeof c=="string"?(0,F.$nc)(c):(0,R.$xg)(c))===e.$gi}e.$oi=d}),define(ke[269],Se([1,0,52,4,3,23,2,208,134,31,5,14,40,28,266,11,32,13,18]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(c){const l=c;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&L.URI.isUri(l.location)&&L.URI.isUri(l.globalStorageHome)&&L.URI.isUri(l.settingsResource)&&L.URI.isUri(l.keybindingsResource)&&L.URI.isUri(l.tasksResource)&&L.URI.isUri(l.snippetsHome)&&L.URI.isUri(l.extensionsResource))}e.$Pk=r,e.$Qk=(0,A.$Vh)("IUserDataProfilesService");function a(c,l){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:L.URI.revive(c.location).with({scheme:l}),globalStorageHome:L.URI.revive(c.globalStorageHome).with({scheme:l}),settingsResource:L.URI.revive(c.settingsResource).with({scheme:l}),keybindingsResource:L.URI.revive(c.keybindingsResource).with({scheme:l}),tasksResource:L.URI.revive(c.tasksResource).with({scheme:l}),snippetsHome:L.URI.revive(c.snippetsHome).with({scheme:l}),extensionsResource:L.URI.revive(c.extensionsResource).with({scheme:l}),cacheHome:L.URI.revive(c.cacheHome).with({scheme:l}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}e.$Rk=a;function t(c,l,h,k,C,m){return{id:c,name:l,location:h,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:m&&C?.useDefaultFlags?.globalState?m.globalStorageHome:(0,R.$zg)(h,"globalStorage"),settingsResource:m&&C?.useDefaultFlags?.settings?m.settingsResource:(0,R.$zg)(h,"settings.json"),keybindingsResource:m&&C?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,R.$zg)(h,"keybindings.json"),tasksResource:m&&C?.useDefaultFlags?.tasks?m.tasksResource:(0,R.$zg)(h,"tasks.json"),snippetsHome:m&&C?.useDefaultFlags?.snippets?m.snippetsHome:(0,R.$zg)(h,"snippets"),extensionsResource:m&&C?.useDefaultFlags?.extensions?m.extensionsResource:(0,R.$zg)(h,"extensions.json"),cacheHome:(0,R.$zg)(k,c),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Sk=t;let s=class extends f.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,k,C){super(),this.t=l,this.u=h,this.w=k,this.y=C,this.f=!0,this.h=this.B(new F.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,i.$Cf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}h.push(t((0,R.$wg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},l))}}catch(m){this.y.error(m)}const k=new S.$zc,C=new Map;if(h.length)try{const m=this.Q();if(m.workspaces)for(const[p,v]of Object.entries(m.workspaces)){const E=L.URI.parse(p),N=h.find(z=>z.id===v);N&&k.set(E,N)}if(m.emptyWindows)for(const[p,v]of Object.entries(m.emptyWindows)){const E=h.find(N=>N.id===v);E&&C.set(p,E)}}catch(m){this.y.error(m)}this.z={profiles:h,workspaces:k,emptyWindows:C}}return this.z}D(){const l=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",k=new RegExp(`${(0,o.$Je)(h)}\\s(\\d+)`);let C=0;for(const p of this.profiles){const v=k.exec(p.name),E=v?parseInt(v[1]):0;C=E>C?E:C}const m=`${h} ${C+1}`;return this.createProfile((0,I.$Ji)((0,u.$ig)()).toString(16),m,{transient:!0},l)}async createNamedProfile(l,h,k){return this.createProfile((0,I.$Ji)((0,u.$ig)()).toString(16),l,h,k)}async createProfile(l,h,k,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(l,h,k);return C&&await this.setProfileForWorkspace(C,m),m}async F(l,h,k){if(!(0,i.$Cf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(h);return C||(C=(async()=>{try{const m=this.profiles.find(E=>E.name===h||E.id===l);if(m)return m;const p=t(l,h,(0,R.$zg)(this.profilesHome,l),this.g,k,this.defaultProfile);await this.u.createFolder(p.location);const v=[];return this.j.fire({profile:p,join(E){v.push(E)}}),await w.Promises.settled(v),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,C)),C}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(C=>C.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);return k=t(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(C=>C.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const k=[];this.m.fire({profile:h,join(C){k.push(C)}});try{await Promise.allSettled(k)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(C){(0,g.$vk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(C=>C.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,k)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return L.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,$.$6h)(l)?l.uri:(0,$.$$h)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,k){const C=[...this.profiles,...l],m=[];this.s.profiles=[];for(let p of C)p.isDefault||h.some(v=>p.id===v.id)||(p=k.find(v=>p.id===v.id)??p,p.isTransient?this.s.profiles.push(p):m.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(m),this.z=void 0,this.J(l,h,k)}J(l,h,k){this.h.fire({added:l,removed:h,updated:k,all:this.profiles})}L(l,h,k){k=h?.isTransient?!0:k,k||this.L(l,void 0,!0);const C=this.G(l),m=k?this.s:this.C;L.URI.isUri(C)?(m.workspaces.delete(C),h&&m.workspaces.set(C,h)):(m.emptyWindows.delete(C),h&&m.emptyWindows.set(C,h)),k||this.M()}M(){const l={};for(const[k,C]of this.C.workspaces.entries())l[k.toString()]=C.id;const h={};for(const[k,C]of this.C.emptyWindows.entries())h[k.toString()]=C.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},k=this.D();if(l.workspaces)for(const[m,p]of Object.entries(l.workspaces)){const v=L.URI.parse(p);h[m]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}const C={};if(l.emptyWindows)for(const[m,p]of Object.entries(l.emptyWindows)){const v=L.URI.parse(p);C[m]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}return{workspaces:h,emptyWindows:C}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Tk=s,e.$Tk=s=He([Be(0,y.$3h),Be(1,g.$ek),Be(2,D.$Ok),Be(3,P.$dj)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Uk=d}),define(ke[270],Se([1,0,11,4,3,56,18,188,5,269]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,y.$Vh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var $;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function S(i){const n=i.get(e.$$o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ap=S;class D extends f.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:D.a}){super(),this.m=n,this.b=this.B(new F.$Ud),this.c=this.B(new F.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,I.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$$o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,s=!1){if((0,L.$Lf)(r)){this.remove(n,a,s);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,s)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const s of Object.keys(t))t[s]===r&&a.push(s);return a}z(n,r,a,t=!1){const s=this.J(r);typeof a=="number"?s[n]!==a&&(s[n]=a,this.P(r)?.set(e.$$o,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(r)?.set(e.$$o,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?S(r):Object.create(null)}isNew(n){return this.getBoolean(e.$0o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await I.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await I.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,g.$Pk)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||w(r)&&w(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),r.get(s)!==d&&this.u(a,{key:s,external:!0});for(const[s]of r.items)t.has(s)||this.u(a,{key:s,external:!0})})}}e.$bp=D;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$cp=w;class u extends D{constructor(){super(),this.U=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dp=u;async function o(i,n,r,a,t,s){const d=E=>{try{return JSON.parse(E)}catch{return E}},c=new Map,l=new Map;i.forEach((E,N)=>{c.set(N,E),l.set(N,d(E))});const h=new Map,k=new Map;n.forEach((E,N)=>{h.set(N,E),k.set(N,d(E))});const C=new Map,m=new Map;r.forEach((E,N)=>{C.set(N,E),m.set(N,d(E))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(c.forEach((E,N)=>{p.push({key:N,value:E})}),console.table(p),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const E=[];h.forEach((N,z)=>{E.push({key:z,value:N})}),console.table(E),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${s})`);const v=[];C.forEach((E,N)=>{v.push({key:N,value:E})}),console.table(v),console.groupEnd(),console.log(m)}e.$ep=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class I{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Adc=I}),define(ke[57],Se([1,0,17,23,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=void 0;class R{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$og(b=>{const y=this.b.get(b.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(b,y){y===null?this.b.delete(b.scheme):this.b.set(b.scheme,y)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Ddc=R,e.$Edc=(0,f.$Vh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$QM=(0,I.$Vh)("IExtHostInitDataService")}),define(ke[271],Se([1,0,214,14,251,27]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let L=class extends f.$XN{constructor(y,g,A){const P=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",$=A.remote.isRemote?(0,I.localize)(0,null):y?(0,I.localize)(1,null):(0,I.localize)(2,null);super(g.createLogger(P,{name:$}))}};e.$Kfc=L,e.$Kfc=L=He([Be(1,F.$ej),Be(2,R.$QM)],L)}),define(ke[272],Se([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=void 0;class F{constructor(L,b,y){this.h=new Map,this.a=L,this.b=b,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new I.$0g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const P of g.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let y=this.f[L];return typeof y>"u"&&(y=b),y}update(L,b){this.f[L]=b;const y=this.h.get(L);if(y!==void 0)return y.p;const g=new I.$ih;return this.h.set(L,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$mec=F;class f extends F{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$nec=f}),define(ke[273],Se([1,0,4,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class f{constructor(L){this.c=L,this.a=new I.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,y,g){const P=this.c.getNotebookDocument(F.URI.revive(L)).acceptModelChanged(b.value,y,g);this.b.fire(P)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(F.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(F.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$afc=f}),define(ke[20],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,I.$Vh)("IExtHostRpcService");class F{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$BM=F}),define(ke[274],Se([1,0,26,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class f{#e;constructor(L,b){this.b=new F.$Rd,this.onDidChange=this.b.event,this.a=I.$_l.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$uec=f}),define(ke[66],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0,e.$Wdc=(0,I.$Vh)("IURITransformerService");class F{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Xdc=F}),define(ke[275],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdb=e.$gdb=void 0;class F{constructor(){this.buffers=[]}add(y){let g=this.buffers.indexOf(y);return g<0&&(g=this.buffers.length,this.buffers.push(y)),g}}function f(b,y){if(y.serializeBuffersForPostMessage){const g=new F,P=JSON.stringify(b,(S,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(D)};if(ArrayBuffer.isView(D)){const w=R(D);if(w)return{$$vscode_array_buffer_reference$$:!0,index:g.add(D.buffer),view:{type:w,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),$=g.buffers.map(S=>{const D=new Uint8Array(S);return I.$fe.wrap(D)});return{message:P,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}e.$gdb=f;function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,y){const g=y.map($=>{const S=new ArrayBuffer($.byteLength);return new Uint8Array(S).set($.buffer),S}),A=y.length?($,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const D=S,{index:w}=D,u=g[w];if(D.view)switch(D.view.type){case 1:return new Int8Array(u,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return S}:void 0;return{message:JSON.parse(b,A),arrayBuffers:g}}e.$hdb=L}),define(ke[276],Se([1,0,277,388,389,62,2,14,390]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;const g=!1;function A(n,r,a,t,s,d){const c=d.environment.useHostProxy,l=typeof c=="boolean"?c:!d.remote.isRemote,h={resolveProxy:m=>n.resolveProxy(m),lookupProxyAuthorization:u.bind(void 0,t,s,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>$(r),getSystemCertificatesV2:()=>S(r),log:(m,p,...v)=>{switch(m){case y.LogLevel.Trace:t.trace(p,...v);break;case y.LogLevel.Debug:t.debug(p,...v);break;case y.LogLevel.Info:t.info(p,...v);break;case y.LogLevel.Warning:t.warn(p,...v);break;case y.LogLevel.Error:t.error(p,...v);break;case y.LogLevel.Critical:t.error(p,...v);break;case y.LogLevel.Off:break;default:E(m,p,v);break}function E(N,z,...M){t.error("Unknown log level",N),t.error(z,...M)}},getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return y.LogLevel.Trace;case b.LogLevel.Debug:return y.LogLevel.Debug;case b.LogLevel.Info:return y.LogLevel.Info;case b.LogLevel.Warning:return y.LogLevel.Warning;case b.LogLevel.Error:return y.LogLevel.Error;case b.LogLevel.Off:return y.LogLevel.Off;default:return p(m)}function p(v){return t.error("Unknown log level",v),y.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,addCertificates:[],env:process.env},k=(0,y.createProxyResolver)(h),C=P(h,k);return w(a,C)}e.$ggc=A;function P(n,r){return{http:Object.assign(I,(0,y.createHttpPatch)(n,I,r)),https:Object.assign(F,(0,y.createHttpPatch)(n,F,r)),net:Object.assign(R,(0,y.createNetPatch)(n,R)),tls:Object.assign(f,(0,y.createTlsPatch)(n,f))}}function $(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}function S(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}const D=new Map;function w(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(c,l,h){if(c==="net")return r.net;if(c==="tls")return r.tls;if(c!=="http"&&c!=="https")return s.apply(this,arguments);const k=a.findSubstr(L.URI.file(l.filename));let C=D.get(k);if(C||D.set(k,C={}),!C[c]){const m=r[c];C[c]={...m}}return C[c]}})}async function u(n,r,a,t,s,d,c,l){const h=t[d];c&&(t[d]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${h}`);const k=c||h,C=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(r,C,s),C.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const m=await new Promise((z,M)=>{me(["kerberos"],z,M)}),p=new URL(d),v=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await m.initializeClient(v)).step("")}catch(m){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[278],Se([1,0,131]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;function F(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function f(R){return new I.$Rm(F(R))}e.$Hr=f}),define(ke[141],Se([1,0,225,18,2,3,5,37,31,17,43,180,39]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var S;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var D;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function w(le){const q=le;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$fE=w;function u(le,q,U){for(const ie of U.visibleEditorPanes)if(ie.group.id===q&&le.matches(ie.input))return ie.getViewState()}e.$gE=u;function o(le){if(k(le))return!1;const q=le;return f.URI.isUri(q?.resource)}e.$hE=o;function i(le){if(k(le))return!1;const q=le;return q?.original!==void 0&&q.modified!==void 0}e.$iE=i;function n(le){if(k(le))return!1;const q=le;return Array.isArray(q?.resources)}e.$jE=n;function r(le){if(k(le)||i(le))return!1;const q=le;return q?.primary!==void 0&&q.secondary!==void 0}e.$kE=r;function a(le){if(k(le))return!1;const q=le;return q?q.resource===void 0||q.resource.scheme===g.Schemas.untitled||q.forceUntitled===!0:!1}e.$lE=a;function t(le){if(k(le))return!1;const q=le;return f.URI.isUri(q?.base?.resource)&&f.URI.isUri(q?.input1?.resource)&&f.URI.isUri(q?.input2?.resource)&&f.URI.isUri(q?.result?.resource)}e.$mE=t;var s;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var d;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class c{constructor(){this.a=new Map}registerSource(q,U){let ie=this.a.get(q);return ie||(ie={source:q,label:U},this.a.set(q,ie)),ie.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$nE=new c;var l;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad",le[le.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class h extends R.$Rc{}e.$oE=h;function k(le){return le instanceof h}e.$pE=k;function C(le){const q=le;return f.URI.isUri(q?.preferredResource)}function m(le){const q=le;return k(q?.primary)&&k(q?.secondary)}e.$qE=m;function p(le){const q=le;return k(q?.modified)&&k(q?.original)}e.$rE=p;function v(le,q,U,ie,be){return Ee(ie,[(0,P.$Fi)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const H={...U,limits:{size:Number.MAX_VALUE}};le.openEditor(q,H)}}),(0,P.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$sE=v;function E(le){return k(le?.editor)}e.$tE=E;function N(le){const q=le;return E(le)&&q?.group!==void 0}e.$uE=N;function z(le){const q=le;return typeof q?.groupId=="number"&&k(q.editor)}e.$vE=z;var M;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var T;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LABEL=2]="GROUP_LABEL",le[le.GROUP_LOCKED=3]="GROUP_LOCKED",le[le.EDITOR_OPEN=4]="EDITOR_OPEN",le[le.EDITOR_CLOSE=5]="EDITOR_CLOSE",le[le.EDITOR_MOVE=6]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=8]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=10]="EDITOR_PIN",le[le.EDITOR_STICKY=11]="EDITOR_STICKY",le[le.EDITOR_DIRTY=12]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var j;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class O{getOriginalUri(q,U){if(!q)return;if(t(q))return e.$xE.getOriginalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getOriginalUri(be,{filterByScheme:U.filterByScheme})??this.getOriginalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===j.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ie=C(q)?q.preferredResource:q.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}a(q){return m(q)||r(q)?{primary:q.primary,secondary:q.secondary}:p(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,U){if(!q)return;if(t(q))return e.$xE.getCanonicalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===j.ANY)return this.getCanonicalUri(be,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===j.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ie=q.resource;return!ie||!U||!U.filterByScheme?ie:this.b(ie,U.filterByScheme)}b(q,U){if(Array.isArray(U)){if(U.some(ie=>q.scheme===ie))return q}else if(U===q.scheme)return q}}var V;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(V||(e.EditorCloseMethod=V={}));function te(le,q,U,ie){if(!le.isSticky(q))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return U===V.MOUSE||U===V.KEYBOARD;case"mouse":return U===V.MOUSE;case"keyboard":return U===V.KEYBOARD}return!1}e.$wE=te,e.$xE=new O;var fe;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(fe||(e.CloseDirection=fe={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(q){const U=this.a=q.get(L.$Uh);for(const[ie,be]of this.c)this.e(ie,be,U);this.c.clear()}e(q,U,ie){const be=ie.createInstance(U);this.d.set(q,be)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,F.$Nf)(this.b)}registerEditorSerializer(q,U){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,U,this.a):this.c.set(q,U),(0,R.$Pc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}b.$mn.add(e.$aE.EditorFactory,new Z);async function Q(le,q,U){return!le||!le.length?[]:await Promise.all(le.map(async ie=>{const be=f.URI.revive(ie.fileUri);if(!be){U.info("Cannot resolve the path because it is not valid.",ie);return}if(!await q.canHandleResource(be)){U.info("Cannot resolve the path because it cannot be handled",ie);return}let X=ie.exists,Y=ie.type;if(typeof X!="boolean"||typeof Y!="number")try{Y=(await q.stat(be)).isDirectory?y.FileType.Directory:y.FileType.Unknown,X=!0}catch(ne){U.error(ne),X=!1}if(!X&&ie.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ie);return}if(Y===y.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ie);return}const $e={...ie.options,pinned:!0};return X?{resource:be,options:$e}:{resource:be,options:$e,forceUntitled:!0}}))}e.$yE=Q;var G;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function oe(le){const q=le;if(!q)return!1;const U=q;if(U.modified)return oe(U.modified);const ie=q;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$zE=oe;function x(le){return(0,A.$Hi)(le)}e.$AE=x;function Ee(le,q,U){const ie=(0,A.$Ii)(le,q);return ie.forceMessage=U?.forceMessage,ie.forceSeverity=U?.forceSeverity,ie.allowDialog=U?.allowDialog,ie}e.$BE=Ee}),define(ke[279],Se([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,F.localize)(0,null),e.$EE=(0,P.$aw)("default-view-icon",A.$1j.window,(0,F.localize)(1,null));var $;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var S;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$FE=[0,1,2];function D(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=D;class w extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new I.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.$Qb)([...this.g.values()])}registerViewContainer(d,c,l){const h=this.get(d.id);if(h)return h;const k=d;return k.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,L.$wc)(this.g,c,[]).push(k),l?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:c}),k}deregisterViewContainer(d){for(const c of this.g.keys()){const l=this.g.get(c),h=l?.indexOf(d);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(c),this.f.fire({viewContainer:d,viewContainerLocation:c});return}}}get(d){return this.all.filter(c=>c.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(l=>l?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(c=>this.getViewContainerLocation(c)===d)}}b.$mn.add($.ViewContainersRegistry,new w);var u;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(u||(e.ViewContentGroups=u={}));function o(s,d){const c=s.group??u.More,l=d.group??u.More;return c!==l?c.localeCompare(l):(s.order??5)-(d.order??5)}class i extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Fc}registerViews(d,c){this.registerViews2([{views:d,viewContainer:c}])}registerViews2(d){d.forEach(({views:c,viewContainer:l})=>this.r(c,l)),this.c.fire(d)}deregisterViews(d,c){const l=this.s(d,c);l.length&&this.f.fire({views:l,viewContainer:c})}moveViews(d,c){for(const l of this.m.keys())if(l!==c){const h=this.s(d,l);h.length&&(this.r(h,c),this.g.fire({views:h,from:l,to:c}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const c of this.j){const l=(this.m.get(c)||[]).filter(h=>h.id===d)[0];if(l)return l}return null}getViewContainer(d){for(const c of this.j)if((this.m.get(c)||[]).filter(h=>h.id===d)[0])return c;return null}registerViewWelcomeContent(d,c){return this.n.add(d,c),this.h.fire(d),(0,R.$Pc)(()=>{this.n.delete(d,c),this.h.fire(d)})}registerViewWelcomeContent2(d,c){const l=new Map;for(const[h,k]of c)this.n.add(d,k),l.set(h,(0,R.$Pc)(()=>{this.n.delete(d,k),this.h.fire(d)}));return this.h.fire(d),l}getViewWelcomeContent(d){const c=[];return this.n.forEach(d,l=>c.push(l)),c.sort(o)}r(d,c){let l=this.m.get(c);l||(l=[],this.m.set(c,l),this.j.push(c));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));l.push(h)}}s(d,c){const l=this.m.get(c);if(!l)return[];const h=[],k=[];for(const C of l)d.includes(C)?h.push(C):k.push(C);return h.length&&(k.length?this.m.set(c,k):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),h}}b.$mn.add($.ViewsRegistry,new i),e.$HE=(0,f.$Vh)("viewsService"),e.$IE=(0,f.$Vh)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(d,c){this.c=!1,this.d=!1,(0,g.$dn)(this,d),this.d=!!c,this.resolve=async l=>{if(c&&!this.c){const h=await c(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$KE=t}),define(ke[280],Se([1,0,2,29,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$_E=e.$$E=void 0;function R(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof I.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(F.$As.isIRange)}e.$$E=R;function L(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(R)}e.$_E=L;var b;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var y;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(y||(e.InteractiveSessionCopyKind=y={})),e.$aF=(0,f.$Vh)("IChatService")}),define(ke[142],Se([1,0,4,11,227]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new I.$Rd,this.n=new I.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,y,g,A){const P={command:b};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const S=this.f.get(P.seq);if(S){this.f.delete(P.seq);const D={type:"response",seq:0,request_seq:P.seq,success:!1,command:b,message:(0,f.localize)(0,null,A,b)};S(D)}},A)}return g&&this.f.set(P.seq,g),P.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,y){return b.type!=="event"||y.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,F.$Yg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const y=b,g=this.f.get(y.request_seq);g&&(this.f.delete(y.request_seq),g(y));break}}}}s(b,y){y.type=b,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((y,g)=>b.set(g,y)),await(0,F.$Yg)(500),b.forEach((y,g)=>{y({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Mdb=R}),define(ke[281],Se([1,0,228,45,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$lH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$kH=e.MemoryRangeType=e.$jH=e.State=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new F.$aj("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$qG=new F.$aj("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$rG=new F.$aj("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$sG="debugUx",e.$tG=new F.$aj(e.$sG,"default",{type:"string",description:I.localize(3,null)}),e.$uG=new F.$aj("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$vG=new F.$aj("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$wG=new F.$aj("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$xG=new F.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$yG=new F.$aj("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$zG=new F.$aj("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$AG=new F.$aj("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$BG=new F.$aj("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$CG=new F.$aj("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$DG=new F.$aj("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$EG=new F.$aj("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$FG=new F.$aj("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$GG=new F.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$HG=new F.$aj("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$IG=new F.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$JG=new F.$aj("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$KG=new F.$aj("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$LG=new F.$aj("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$MG=new F.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.$NG=new F.$aj("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.$OG=new F.$aj("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.$PG=new F.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.$QG=new F.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(26,null)}),e.$RG=new F.$aj("stepBackSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.$SG=new F.$aj("restartFrameSupported",!1,{type:"boolean",description:I.localize(28,null)}),e.$TG=new F.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(29,null)}),e.$UG=new F.$aj("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$VG=new F.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(31,null)}),e.$WG=new F.$aj("breakpointsExist",!1,{type:"boolean",description:I.localize(32,null)}),e.$XG=new F.$aj("debuggersAvailable",!1,{type:"boolean",description:I.localize(33,null)}),e.$YG=new F.$aj("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(34,null)}),e.$ZG=new F.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(35,null)}),e.$1G=new F.$aj("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.$2G=new F.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.$3G=new F.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$4G=new F.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$5G=new F.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$6G=new F.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$7G=new F.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$8G=new F.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(43,null)}),e.$9G=new F.$aj("variableIsReadonly",!1,{type:"boolean",description:I.localize(44,null)}),e.$0G=new F.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(45,null)}),e.$$G=new F.$aj("multiSessionRepl",!1,{type:"boolean",description:I.localize(46,null)}),e.$_G=new F.$aj("multiSessionDebug",!1,{type:"boolean",description:I.localize(47,null)}),e.$aH=new F.$aj("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(48,null)}),e.$bH=new F.$aj("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(49,null)}),e.$cH=new F.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(50,null)}),e.$dH=new F.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(51,null)});const R=$=>I.localize(52,null,$);e.$eH=R,e.$fH="editor.contrib.debug",e.$gH="editor.contrib.breakpoint",e.$hH="debug",e.$iH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(53,null)};var L;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(L||(e.State=L={}));function b($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$jH=b;var y;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$kH="vscode-debug-memory";var g;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$lH=(0,f.$Vh)("debugService");var P;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[282],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const A=/{([^}]+)}/g;function P(C,m,p){return C.replace(A,function(v,E){return m&&E.length>0&&E[0]!=="_"?v:p&&p.hasOwnProperty(E)?p[E]:v})}e.$fF=P;function $(C){const m={};for(const p of Object.keys(C))p.startsWith("!")||(m[p]=C[p]);return m}e.$gF=$;function S(C){return C.configuration.request==="attach"&&!D(C)&&(!C.parentSession||S(C.parentSession))}e.$hF=S;function D(C){let m=C.configuration.type;if(m)return m==="vslsShare"&&(m=C.configuration.adapterProxy.configuration.type),(0,I.$6e)(m,"extensionhost")||(0,I.$6e)(m,"pwa-extensionhost")?C:C.parentSession?D(C.parentSession):void 0}e.$iF=D;function w(C){return C.type&&(C.label||C.program||C.runtime)}e.$jF=w;function u(C,m,p){let v,E=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=N.exec(C);){const M=z.index+1,T=M+z[0].length;if(M<=m&&T>=p){v=z[0],E=M;break}}if(v){const M=/\w+/g;let T=null;for(;(T=M.exec(v))&&!(T.index+1+E+T[0].length>=p););T&&(v=v.substring(0,M.lastIndex))}return v?{start:E,end:E+v.length-1}:{start:0,end:0}}e.$kF=u;async function o(C,m,p,v){if(C.evaluatableExpressionProvider.has(m)){const E=C.evaluatableExpressionProvider.ordered(m),N=(0,g.$Gb)(await Promise.all(E.map(async z=>{try{return await z.provideEvaluatableExpression(m,p,v??y.CancellationToken.None)}catch{return}})));if(N.length>0){let z=N[0].expression;const M=N[0].range;return z||(z=m.getLineContent(p.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:z}}}else{const E=m.getLineContent(p.lineNumber),{start:N,end:z}=u(E,p.column,p.column),M=E.substring(N-1,z);return{matchingExpression:M,range:new b.$As(p.lineNumber,N,p.lineNumber,N+M.length)}}return null}e.$lF=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(C){return!!(C&&C.match(i))}e.$mF=n;function r(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(n(C.path))return F.URI.parse(C.path);if((0,f.$hc)(C.path))return F.URI.file(C.path)}return C.path}function a(C){if(typeof C.path=="object"){const m=F.URI.revive(C.path);if(m)return m.scheme===L.Schemas.file?m.fsPath:m.toString()}return C.path}function t(C,m){const p=m?r:a,v=(0,R.$an)(C);return d(v,(E,N)=>{E&&N&&(N.path=p(N))}),v}e.$nF=t;function s(C,m){const p=m?r:a,v=(0,R.$an)(C);return d(v,(E,N)=>{!E&&N&&(N.path=p(N))}),v}e.$oF=s;function d(C,m){switch(C.type){case"event":{const p=C;switch(p.event){case"output":m(!1,p.body.source);break;case"loadedSource":m(!1,p.body.source);break;case"breakpoint":m(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=C;switch(p.command){case"setBreakpoints":m(!0,p.arguments.source);break;case"breakpointLocations":m(!0,p.arguments.source);break;case"source":m(!0,p.arguments.source);break;case"gotoTargets":m(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(v=>m(!1,v));break;default:break}break}case"response":{const p=C;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(v=>m(!1,v.source));break;case"loadedSources":p.body.sources.forEach(v=>m(!1,v));break;case"scopes":p.body.scopes.forEach(v=>m(!1,v.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(v=>m(!1,v.source));break;case"setBreakpoints":p.body.breakpoints.forEach(v=>m(!1,v.source));break;case"disassemble":p.body?.instructions.forEach(E=>m(!1,E.location));break;default:break}break}}}function c(C){return C.filter(m=>!m.presentation?.hidden).sort((m,p)=>m.presentation?p.presentation?m.presentation.group?p.presentation.group?m.presentation.group!==p.presentation.group?m.presentation.group.localeCompare(p.presentation.group):l(m.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(m.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$pF=c;function l(C,m){return typeof C!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:C-m}async function h(C,m){const p=C.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(p!=="none"&&(await m.saveAll(),p==="allEditorsInActiveGroup")){const v=m.activeEditorPane;v&&v.input.resource?.scheme===L.Schemas.untitled&&await m.save({editor:v.input,groupId:v.group.id})}await C.reloadConfiguration()}e.$qF=h;const k=(C,m)=>!C||!m?C===m:C.name===m.name&&C.path===m.path&&C.sourceReference===m.sourceReference;e.$rF=k}),define(ke[283],Se([1,0,50,62,24,16,12,13,30,229,142]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=void 0;class P extends A.$Mdb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",n=>this.w(n))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(P.b);for(const a of r){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$Qfc=P;class $ extends P{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Rfc=$;class S extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Sfc=S;class D extends ${constructor(o){super(),this.z=o}y(o){return F.createConnection(this.z.path,o)}}e.$Tfc=D;class w extends P{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(R.$hc(o)){if(!await y.Promises.exists(o))throw new Error(g.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=f.$dn(f.$an(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=I.fork(i[0],i.slice(1),t);if(!s.pid)throw new Error(g.localize(2,null,i[0]));this.x=s}else throw new Error(g.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((o,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=R.$ic(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(R.$hc(o.program)?n.program=o.program:n.program=R.$ic(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=w.A(r.win,i)),r.winx86&&(n.winx86=w.A(r.winx86,i)),r.windows&&(n.windows=w.A(r.windows,i)),r.osx&&(n.osx=w.A(r.osx,i)),r.linux&&(n.linux=w.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const c of o)if(c.contributes){const l=c.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&b.$6e(h.type,i)).forEach(h=>{const k=w.A(h,c.extensionLocation.fsPath);n=f.$dn(n,k,c.isBuiltin)})}let r;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:L.$i?r=n.win||n.windows:L.$j?r=n.osx:L.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,s=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Ufc=w}),define(ke[284],Se([1,0,50,33,12]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=void 0;function R(g,A){return new Promise((P,$)=>{let S="";const D=I.spawn(g,A);D.pid&&D.stdout.on("data",w=>{S+=w.toString()}),D.on("error",w=>{$(w)}),D.on("close",w=>{P(S)})})}async function L(g){if(g)if(f.$i){const A=await new Promise((P,$)=>{me(["@vscode/windows-process-tree"],P,$)});return new Promise(P=>{A.getProcessTree(g,$=>{P(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(g)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Vfc=L;var b;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(b||(b={}));function y(g,A,P,$,S){g=g.trim().toLowerCase();let D;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?D=1:g.indexOf("cmd.exe")>=0?D=0:g.indexOf("bash")>=0?D=2:f.$i?D=0:D=2;let w,u=" ";switch(D){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,F.$7f)($);o&&(u+=`${o}:; `),u+=`cd ${w($)}; `}if(S)for(const o in S){const i=S[o];i===null?u+=`Remove-Item env:${o}; `:u+=`\${env:${o}}='${i}'; `}if(A.length>0){const o=A.shift(),i=P?o:w(o);u+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)u+=n==="<"||n===">"||P?n:w(n),u+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),$){const o=(0,F.$7f)($);o&&(u+=`${o}: && `),u+=`cd ${w($)} && `}if(S){u+='cmd /C "';for(const o in S){let i=S[o];i===null?u+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),u+=`set "${o}=${i}" && `)}}for(const o of A)u+=o==="<"||o===">"||P?o:w(o),u+=" ";S&&(u+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if($&&(u+=`cd ${w($)} ; `),S){u+="/usr/bin/env";for(const i in S){const n=S[i];n===null?u+=` -u ${o(i)}`:u+=` ${o(`${i}=${n}`)}`}u+=" "}for(const i of A)u+=i==="<"||i===">"||P?i:w(i),u+=" ";break}}return u}e.$Wfc=y}),define(ke[111],Se([1,0,22,34,51,100,17,16,12,45]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.$DI=e.$CI=e.$BI=e.CellStatusbarAlignment=e.$AI=e.$zI=e.$yI=e.NotebookEditorPriority=e.$xI=e.$wI=e.$vI=e.$uI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$tI=e.$sI=e.$rI=e.$qI=e.CellKind=e.$pI=e.$oI=e.$nI=void 0,e.$nI="workbench.editor.notebook",e.$oI="workbench.editor.notebookTextDiffEditor",e.$pI="workbench.editor.interactive";var A;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(A||(e.CellKind=A={})),e.$qI=["application/json","application/javascript","text/html","image/svg+xml",R.$Wr.latex,R.$Wr.markdown,"image/png","image/jpeg",R.$Wr.text],e.$rI=[R.$Wr.latex,R.$Wr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Wr.text],e.$sI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$tI="_notAvailable";var P;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var $;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var S;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var D;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var w;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var u;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(u||(e.NotebookCellsChangeType=u={}));var o;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(O){O.scheme=L.Schemas.vscodeNotebookCell;const V=["W","X","Y","Z","a","b","c","d","e","f"],te=new RegExp(`^[${V.join("")}]+`),fe=7;function Z(le,q){const U=q.toString(fe),be=`${U.length<V.length?V[U.length-1]:"z"}${U}s${(0,I.$ze)(I.$fe.fromString(le.scheme),!0,!0)}`;return le.with({scheme:O.scheme,fragment:be})}O.generate=Z;function Q(le){if(le.scheme!==O.scheme)return;const q=le.fragment.indexOf("s");if(q<0)return;const U=parseInt(le.fragment.substring(0,q).replace(te,""),fe),ie=(0,I.$ye)(le.fragment.substring(q+1)).toString();if(!isNaN(U))return{handle:U,notebook:le.with({scheme:ie,fragment:null})}}O.parse=Q;function G(le,q){return le.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${le.scheme!==L.Schemas.file?le.scheme:""}`})}O.generateCellOutputUri=G;function oe(le){if(le.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(le.fragment);if(!q)return;const U=q[1]&&q[1]!==""?q[1]:void 0,ie=q[2];return{outputId:U,notebook:le.with({scheme:ie||L.Schemas.file,fragment:null})}}O.parseCellOutputUri=oe;function x(le,q,U){return O.generate(le,q).with({scheme:U})}O.generateCellPropertyUri=x;function Ee(le,q){if(le.scheme===q)return O.parse(le.with({scheme:O.scheme}))}O.parseCellPropertyUri=Ee})(n||(e.CellUri=n={}));const r=O=>y.$i?O.replace(/\//g,"\\"):O;class a{constructor(V=[],te=e.$qI){this.e=te,this.d=[...new Set(V)].map(fe=>({pattern:fe,matches:F.$Cj(r(fe))}))}sort(V){const te=new Map(f.Iterable.map(V,Z=>[Z,r(Z)]));let fe=[];for(const{matches:Z}of this.d)for(const[Q,G]of te)if(Z(G)){fe.push(Q),te.delete(Q);break}return te.size&&(fe=fe.concat([...te.keys()].sort((Z,Q)=>this.e.indexOf(Z)-this.e.indexOf(Q)))),fe}prioritize(V,te){const fe=this.f(V);if(fe===-1){this.d.unshift({pattern:V,matches:F.$Cj(r(V))});return}const Z=new Set(te.map(G=>this.f(G,fe)));Z.delete(-1);const Q=Array.from(Z).sort();this.d.splice(fe+1,0,...Q.map(G=>this.d[G]));for(let G=Q.length-1;G>=0;G--)this.d.splice(Q[G],1)}toArray(){return this.d.map(V=>V.pattern)}f(V,te=this.d.length){const fe=r(V);for(let Z=0;Z<te;Z++)if(this.d[Z].matches(fe))return Z;return-1}}e.$uI=a;function t(O,V,te,fe=(Z,Q)=>Z===Q){const Z=[];function Q(x,Ee,le){if(Ee===0&&le.length===0)return;const q=Z[Z.length-1];q&&q.start+q.deleteCount===x?(q.deleteCount+=Ee,q.toInsert.push(...le)):Z.push({start:x,deleteCount:Ee,toInsert:le})}let G=0,oe=0;for(;;){if(G===O.length){Q(G,0,V.slice(oe));break}if(oe===V.length){Q(G,O.length-G,[]);break}const x=O[G],Ee=V[oe];if(fe(x,Ee)){G+=1,oe+=1;continue}te(Ee)?(Q(G,1,[]),G+=1):(Q(G,0,[Ee]),oe+=1)}return Z}e.$vI=t,e.$wI=new g.$aj("notebookEditorCursorAtBoundary","none"),e.$xI=new g.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(O){const V=O;return!!((typeof V.include=="string"||F.$Dj(V.include))&&(typeof V.exclude=="string"||F.$Dj(V.exclude)))}e.$yI=d;function c(O,V,te){if(Array.isArray(O.viewType)&&O.viewType.indexOf(V)>=0||O.viewType===V)return!0;if(O.filenamePattern){const fe=d(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,Z=d(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(F.$Bj(fe,(0,b.$mc)(te.fsPath).toLowerCase()))return!(Z&&F.$Bj(Z,(0,b.$mc)(te.fsPath).toLowerCase()))}return!1}e.$zI=c,e.$AI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class h{static{this.d="notebook/"}static create(V){return`${h.d}${V}`}static parse(V){if(V.startsWith(h.d))return V.substring(h.d.length)}}e.$BI=h;function k(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$CI=k;const C=new TextDecoder;function m(O){const V=[];let te=!1;for(const G of O)(V.length===0||te)&&(V.push(G),te=!0);let fe=E(V);const Z=I.$fe.concat(V.map(G=>I.$fe.wrap(G))),Q=j(Z);return fe=fe||Q.byteLength!==Z.byteLength,{data:Q,didCompression:fe}}e.$DI=m,e.$EI=`${String.fromCharCode(27)}[A`;const p=e.$EI.split("").map(O=>O.charCodeAt(0)),v=10;function E(O){let V=!1;return O.forEach((te,fe)=>{if(fe===0||te.length<e.$EI.length)return;const Z=O[fe-1],Q=te.subarray(0,e.$EI.length);if(Q[0]===p[0]&&Q[1]===p[1]&&Q[2]===p[2]){const G=Z.lastIndexOf(v);if(G===-1)return;V=!0,O[fe-1]=Z.subarray(0,G),O[fe]=te.subarray(e.$EI.length)}}),V}function N(O){let V=O;do O=V,V=O.replace(/[^\n]\x08/gm,"");while(V.length<O.length);return O}function z(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const V=O.match(/^(.*)\r+/m)[1];let te=O.match(/\r+(.*)$/m)[1];te=te+V.slice(te.length,V.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return O}const M="\b".charCodeAt(0),T="\r".charCodeAt(0);function j(O){return!O.buffer.includes(M)&&!O.buffer.includes(T)?O:I.$fe.fromString(z(N(C.decode(O.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,32,26,31,64,111]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D){"use strict";var w,u,o,i,n,r,a,t,s,d,c,l,h,k,C,m,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$pM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TestRunProfileKind=e.TestResultState=e.$8L=e.$7L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6L=e.$5L=e.$4L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.ColorThemeKind=e.$WL=e.$VL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UL=e.DebugConsoleMode=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OL=e.$NL=e.FileChangeType=e.$ML=e.$LL=e.$KL=e.$JL=e.InlineCompletionTriggerKind=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.ConfigurationTarget=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mL=e.ViewBadge=e.ProgressLocation=e.$lL=e.$kL=e.TaskScope=e.ShellQuoting=e.$jL=e.$iL=e.$hL=e.TaskPanelKind=e.TaskRevealKind=e.$gL=e.TerminalLocation=e.$fL=e.$eL=e.$dL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cL=e.$bL=e.$aL=e.$_K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$K=e.StatusBarAlignment=e.ViewColumn=e.$0K=e.$9K=e.$8K=e.$7K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6K=e.$5K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.LanguageStatusSeverity=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CodeActionTriggerKind=e.$SK=e.$RK=e.SymbolTag=e.SymbolKind=e.$QK=e.DocumentHighlightKind=e.$PK=e.$OK=e.$NK=e.$MK=e.DiagnosticSeverity=e.DiagnosticTag=e.$LK=e.$KK=e.FileEditType=e.$JK=e.$IK=e.$HK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(K){return Object.assign(K,{apply:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(K,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const[Re,...Ye]=ve;return Reflect.construct(K,Ye,Re.constructor)}}})}var N;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var z;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let M=w=class{static from(...W){let ve=W;return new w(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$AK=M,e.$AK=M=w=He([E],M);let T=u=class{static Min(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isBefore(ve)&&(ve=Ye)}return ve}static Max(...W){if(W.length===0)throw new TypeError;let ve=W[0];for(let Re=1;Re<W.length;Re++){const Ye=W[Re];Ye.isAfter(ve)&&(ve=Ye)}return ve}static isPosition(W){if(!W)return!1;if(W instanceof u)return!0;const{line:ve,character:Re}=W;return typeof ve=="number"&&typeof Re=="number"}static of(W){if(W instanceof u)return W;if(this.isPosition(W))return new u(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("line must be non-negative");if(ve<0)throw(0,F.$6)("character must be non-negative");this.c=W,this.e=ve}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,ve=0){if(W===null||ve===null)throw(0,F.$6)();let Re;return typeof W>"u"?Re=0:typeof W=="number"?Re=W:(Re=typeof W.lineDelta=="number"?W.lineDelta:0,ve=typeof W.characterDelta=="number"?W.characterDelta:0),Re===0&&ve===0?this:new u(this.line+Re,this.character+ve)}with(W,ve=this.character){if(W===null||ve===null)throw(0,F.$6)();let Re;return typeof W>"u"?Re=this.line:typeof W=="number"?Re=W:(Re=typeof W.line=="number"?W.line:this.line,ve=typeof W.character=="number"?W.character:this.character),Re===this.line&&ve===this.character?this:new u(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$BK=T,e.$BK=T=u=He([E],T);let j=o=class{static isRange(W){return W instanceof o?!0:W?T.isPosition(W.start)&&T.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,ve,Re,Ye){let it,ct;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"?(it=new T(W,ve),ct=new T(Re,Ye)):T.isPosition(W)&&T.isPosition(ve)&&(it=T.of(W),ct=T.of(ve)),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this.c=it,this.e=ct):(this.c=ct,this.e=it)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):T.isPosition(W)?!(T.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const ve=T.Max(W.start,this.c),Re=T.Min(W.end,this.e);if(!ve.isAfter(Re))return new o(ve,Re)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const ve=T.Min(W.start,this.c),Re=T.Max(W.end,this.end);return new o(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,ve=this.end){if(W===null||ve===null)throw(0,F.$6)();let Re;return W?T.isPosition(W)?Re=W:(Re=W.start||this.start,ve=W.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Re,ve)}toJSON(){return[this.start,this.end]}};e.$CK=j,e.$CK=j=o=He([E],j);let O=i=class extends j{static isSelection(W){return W instanceof i?!0:W?j.isRange(W)&&T.isPosition(W.anchor)&&T.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,ve,Re,Ye){let it,ct;if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"?(it=new T(W,ve),ct=new T(Re,Ye)):T.isPosition(W)&&T.isPosition(ve)&&(it=T.of(W),ct=T.of(ve)),!it||!ct)throw new Error("Invalid arguments");super(it,ct),this.f=it,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$DK=O,e.$DK=O=i=He([E],O);const V=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,F.$6)("connectionToken")};class te{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve,Re){if(typeof W!="string"||W.length===0)throw(0,F.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$6)("port");typeof Re<"u"&&V(Re),this.host=W,this.port=Math.round(ve),this.connectionToken=Re}}e.$EK=te;class fe{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,ve){this.makeConnection=W,this.connectionToken=ve,typeof ve<"u"&&V(ve)}}e.$FK=fe;class Z extends Error{static NotAvailable(W,ve){return new Z(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(W){return new Z(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,ve=S.RemoteAuthorityResolverErrorCode.Unknown,Re){super(W),this._message=W,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,Z.prototype)}}e.$GK=Z;var Q;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var G;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let oe=n=class{static isTextEdit(W){return W instanceof n?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,ve){return new n(W,ve)}static insert(W,ve){return n.replace(new j(W,W),ve)}static delete(W){return n.replace(W,"")}static setEndOfLine(W){const ve=new n(new j(new T(0,0),new T(0,0)),"");return ve.newEol=W,ve}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,F.$6)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$6)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$6)("newEol");this.f=W}constructor(W,ve){this.c=W,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$HK=oe,e.$HK=oe=n=He([E],oe);let x=r=class{static isNotebookCellEdit(W){return W instanceof r?!0:W?_t.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,ve){return new r(W,ve)}static insertCells(W,ve){return new r(new _t(W,W),ve)}static deleteCells(W){return new r(W,[])}static updateCellMetadata(W,ve){const Re=new r(new _t(W,W),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(W){const ve=new r(new _t(0,0),[]);return ve.newNotebookMetadata=W,ve}constructor(W,ve){this.range=W,this.newCells=ve}};e.$IK=x,e.$IK=x=r=He([E],x);class Ee{static isSnippetTextEdit(W){return W instanceof Ee?!0:W?j.isRange(W.range)&&U.isSnippetString(W.snippet):!1}static replace(W,ve){return new Ee(W,ve)}static insert(W,ve){return Ee.replace(new j(W,W),ve)}constructor(W,ve){this.range=W,this.snippet=ve}}e.$JK=Ee;var le;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,ve,Re,Ye){this.c.push({_type:1,from:W,to:ve,options:Re,metadata:Ye})}createFile(W,ve,Re){this.c.push({_type:1,from:void 0,to:W,options:ve,metadata:Re})}deleteFile(W,ve,Re){this.c.push({_type:1,from:W,to:void 0,options:ve,metadata:Re})}e(W,ve,Re){this.c.push({_type:3,metadata:Re,uri:W,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(W,ve,Re,Ye){const it=ve.start,ct=ve.end;(it!==ct||Re.length>0)&&this.c.push({_type:5,uri:W,index:it,count:ct-it,cells:Re,metadata:Ye})}g(W,ve,Re,Ye){this.c.push({_type:3,metadata:Ye,uri:W,edit:{editType:3,index:ve,metadata:Re}})}replace(W,ve,Re,Ye){this.c.push({_type:2,uri:W,edit:new oe(ve,Re),metadata:Ye})}insert(W,ve,Re,Ye){this.replace(W,new j(ve,ve),Re,Ye)}delete(W,ve,Re){this.replace(W,ve,"",Re)}has(W){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===W.toString())}set(W,ve){if(ve)for(const Re of ve){if(!Re)continue;let Ye,it;Array.isArray(Re)?(Ye=Re[0],it=Re[1]):Ye=Re,x.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(W,Ye.range.start,Ye.newCellMetadata,it):Ye.newNotebookMetadata?this.e(W,Ye.newNotebookMetadata,it):this.f(W,Ye.range,Ye.newCells,it):Ee.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:W,range:Ye.range,edit:Ye.snippet,metadata:it}):this.c.push({_type:2,uri:W,edit:Ye,metadata:it})}else{for(let Re=0;Re<this.c.length;Re++){const Ye=this.c[Re];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===W.toString()&&(this.c[Re]=void 0);break}}(0,I.$Hb)(this.c)}}get(W){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===W.toString()&&ve.push(Re.edit);return ve}entries(){const W=new R.$zc;for(const ve of this.c)if(ve._type===2){let Re=W.get(ve.uri);Re||(Re=[ve.uri,[]],W.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$KK=q,e.$KK=q=He([E],q);let U=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,ve=this.e++){if(typeof W=="function"){const Re=new a;Re.e=this.e,W(Re),this.e=Re.e,W=Re.value}else W=a.c(W);return this.value+="${",this.value+=ve,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,ve=this.e++){const Re=W.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(W,ve){if(typeof ve=="function"){const Re=new a;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$LK=U,e.$LK=U=a=He([E],U);var ie;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var be;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let H=t=class{static isLocation(W){return W instanceof t?!0:W?j.isRange(W.range)&&g.URI.isUri(W.uri):!1}constructor(W,ve){if(this.uri=W,ve)if(j.isRange(ve))this.range=j.of(ve);else if(T.isPosition(ve))this.range=new j(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$MK=H,e.$MK=H=t=He([E],H);let X=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&g.URI.isUri(W.location.uri):!1}constructor(W,ve){this.location=W,this.message=ve}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.location.range.isEqual(ve.location.range)&&W.location.uri.toString()===ve.location.uri.toString()}};e.$NK=X,e.$NK=X=He([E],X);let Y=class{constructor(W,ve,Re=be.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=W,this.message=ve,this.severity=Re}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,ve){return W===ve?!0:!W||!ve?!1:W.message===ve.message&&W.severity===ve.severity&&W.code===ve.code&&W.severity===ve.severity&&W.source===ve.source&&W.range.isEqual(ve.range)&&(0,I.$tb)(W.tags,ve.tags)&&(0,I.$tb)(W.relatedInformation,ve.relatedInformation,X.isEqual)}};e.$OK=Y,e.$OK=Y=He([E],Y);let $e=class{constructor(W,ve){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=ve}};e.$PK=$e,e.$PK=$e=He([E],$e);var ne;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let de=class{constructor(W,ve=ne.Text){this.range=W,this.kind=ve}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$QK=de,e.$QK=de=He([E],de);var ee;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var he;(function(K){K[K.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let pe=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,ve,Re,Ye,it){this.name=W,this.kind=ve,this.containerName=it,typeof Re=="string"&&(this.containerName=Re),Ye instanceof H?this.location=Ye:Re instanceof j&&(this.location=new H(Ye,Re)),s.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$RK=pe,e.$RK=pe=s=He([E],pe);let Pe=d=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(d.validate)}constructor(W,ve,Re,Ye,it){this.name=W,this.detail=ve,this.kind=Re,this.range=Ye,this.selectionRange=it,this.children=[],d.validate(this)}};e.$SK=Pe,e.$SK=Pe=d=He([E],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let J=class{constructor(W,ve){this.title=W,this.kind=ve}};e.$TK=J,e.$TK=J=He([E],J);let re=class{static{c=this}static{this.c="."}constructor(W){this.value=W}append(W){return new c(this.value?this.value+c.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+c.c)}};e.$UK=re,e.$UK=re=c=He([E],re),re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorMove=re.Refactor.append("move"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll"),re.Notebook=re.Empty.append("notebook");let ae=class{constructor(W,ve){if(this.range=W,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VK=ae,e.$VK=ae=He([E],ae);class _{constructor(W,ve,Re,Ye,it,ct){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ye,this.range=it,this.selectionRange=ct}}e.$WK=_;class ge{constructor(W,ve){this.fromRanges=ve,this.from=W}}e.$XK=ge;class ye{constructor(W,ve){this.fromRanges=ve,this.to=W}}e.$YK=ye;var je;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(W,ve){this.range=W,this.command=ve}get isResolved(){return!!this.command}};e.$ZK=We,e.$ZK=We=He([E],We);let et=l=class{#e;static isMarkdownString(W){return W instanceof l?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,ve=!1){this.#e=new f.$9j(W,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,ve){return this.#e.appendCodeblock(ve??"",W),this}};e.$1K=et,e.$1K=et=l=He([E],et);let Ze=class{constructor(W,ve){this.label=W,this.documentation=ve}};e.$2K=Ze,e.$2K=Ze=He([E],Ze);let rt=class{constructor(W,ve){this.label=W,this.documentation=ve,this.parameters=[]}};e.$3K=rt,e.$3K=rt=He([E],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4K=nt,e.$4K=nt=He([E],nt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let Ve=class{constructor(W){this.value=W}};e.$5K=Ve,e.$5K=Ve=He([E],Ve);let Le=class{constructor(W,ve,Re){this.position=W,this.label=ve,this.kind=Re}};e.$6K=Le,e.$6K=Le=He([E],Le);var Xe;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var ue;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(ue||(e.CompletionItemKind=ue={}));var ce;(function(K){K[K.Deprecated=1]="Deprecated"})(ce||(e.CompletionItemTag=ce={}));let Ie=class{constructor(W,ve){this.label=W,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7K=Ie,e.$7K=Ie=He([E],Ie);let Ke=class{constructor(W=[],ve=!1){this.items=W,this.isIncomplete=ve}};e.$8K=Ke,e.$8K=Ke=He([E],Ke);let Ge=class{constructor(W,ve,Re){this.insertText=W,this.range=ve,this.command=Re}};e.$9K=Ge,e.$9K=Ge=He([E],Ge);let _e=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$0K=_e,e.$0K=_e=He([E],_e);var st;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var lt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(lt||(e.StatusBarAlignment=lt={}));function wt(K,W){return`${P.$_l.toKey(K)}.${W}`}e.$$K=wt;var Ue;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Ue||(e.TextEditorLineNumbersStyle=Ue={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Et;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ut;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(K){function W(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=W}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function W(ve){switch(ve){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=W}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(W,ve){if(ve&&!g.URI.isUri(ve))throw(0,F.$6)("target");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.target=ve}};e.$_K=Bt,e.$_K=Bt=He([E],Bt);let Dt=class{constructor(W,ve,Re,Ye){this.red=W,this.green=ve,this.blue=Re,this.alpha=Ye}};e.$aL=Dt,e.$aL=Dt=He([E],Dt);let Mt=class{constructor(W,ve){if(ve&&!(ve instanceof Dt))throw(0,F.$6)("color");if(!j.isRange(W)||W.isEmpty)throw(0,F.$6)("range");this.range=W,this.color=ve}};e.$bL=Mt,e.$bL=Mt=He([E],Mt);let Wt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$6)("label");this.label=W}};e.$cL=Wt,e.$cL=Wt=He([E],Wt);var tt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(tt||(e.ColorFormat=tt={}));var Vt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ut{constructor(W,ve,Re){if(this.startIndex=W,this.length=ve,this.tooltip=Re,typeof W!="number"||W<0)throw(0,F.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,F.$6)("tooltip")}}e.$dL=ut;class mt{constructor(W){this.uri=W}}e.$eL=mt;class Nt{constructor(W){this.terminalCommand=W}}e.$fL=Nt;var Pt;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$6)("options")}}e.$gL=At;var gt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(gt||(e.TaskRevealKind=gt={}));var St;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(St||(e.TaskPanelKind=St={}));let Rt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(W){switch(W){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(W,ve){if(this.label=ve,typeof W!="string"||typeof ve!="string")throw(0,F.$6)("name");this.c=W}get id(){return this.c}};e.$hL=Rt,e.$hL=Rt=h=He([E],Rt);function It(K){let W="";for(let ve=0;ve<K.length;ve++)W+=K[ve].replace(/,/g,",,")+",";return W}let Je=class{constructor(W,ve,Re){if(typeof W!="string")throw(0,F.$6)("process");this.e=[],this.c=W,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$6)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)W.push(ve);return It(W)}};e.$iL=Je,e.$iL=Je=He([E],Je);let jt=class{constructor(W,ve,Re){if(this.f=[],Array.isArray(ve)){if(!W)throw(0,F.$6)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W,this.f=ve,this.g=Re}else{if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W,this.g=ve}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$6)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$6)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)W.push(typeof ve=="string"?ve:ve.value);return It(W)}};e.$jL=jt,e.$jL=jt=He([E],jt);var Jt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Fe{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$ig)()}set callback(W){this.c=W}get callback(){return this.c}}e.$kL=Fe;let Ce=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,ve,Re,Ye,it,ct){this.j=!1,this.k=this.definition=W;let ft;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Ye,ft=it,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Ye,this.execution=it,ft=ct):(this.target=ve,this.m=this.name=Re,this.t=this.source=Ye,this.execution=it,ft=ct),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Je?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof jt?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,A.$ig)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=W}get scope(){return this.l}set target(W){this.z(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$6)("name");this.z(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.z(),this.n=W;const ve=this.k.type;(k.g===ve||k.e===ve||k.f===ve||k.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.z(),this.o=W,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.z(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.z(),this.u=W}get detail(){return this.y}set detail(W){W===null&&(W=void 0),this.y=W}get presentationOptions(){return this.w}set presentationOptions(W){W==null&&(W=Object.create(null)),this.z(),this.w=W}get runOptions(){return this.x}set runOptions(W){W==null&&(W=Object.create(null)),this.z(),this.x=W}};e.$lL=Ce,e.$lL=Ce=k=He([E],Ce);var se;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(se||(e.ProgressLocation=se={}));var Te;(function(K){function W(ve){const Re=ve;return(0,y.$Gf)(Re.value)?Re.tooltip&&!(0,y.$Cf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}K.isViewBadge=W})(Te||(e.ViewBadge=Te={}));let qe=C=class{static isTreeItem(W,ve){const Re=W;if(Re.checkboxState!==void 0){const Ye=(0,y.$Gf)(Re.checkboxState)?Re.checkboxState:(0,y.$Ef)(Re.checkboxState)&&(0,y.$Gf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,it=!(0,y.$Gf)(Re.checkboxState)&&(0,y.$Ef)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Qe.Checked&&Ye!==Qe.Unchecked||it!==void 0&&!(0,y.$Cf)(it))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(W instanceof C)return!0;if(Re.label!==void 0&&!(0,y.$Cf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,y.$Cf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,y.$Cf)(Re.iconPath)&&!g.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,y.$Cf)(Re.iconPath.id))){const Ye=Re.iconPath;if(!Ye||!(0,y.$Cf)(Ye.light)&&!g.URI.isUri(Ye.light)&&!(0,y.$Cf)(Ye.dark)&&!g.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,y.$Cf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!g.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,y.$Cf)(Re.tooltip)&&!(Re.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,y.$Cf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(W,ve=xe.None){this.collapsibleState=ve,g.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$mL=qe,e.$mL=qe=C=He([E],qe);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$nL=ot,e.$nL=ot=He([E],ot);class pt extends ot{}e.$oL=pt;class bt extends pt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$pL=bt;class vt{constructor(W,ve,Re,Ye){this.name=W,this.uri=ve,this._itemId=Re,this.c=Ye}data(){return this.c()}}e.$qL=vt;let ht=class{#e=new Map;constructor(W){for(const[ve,Re]of W??[]){const Ye=this.#e.get(this.#t(ve));Ye?Ye.push(Re):this.#e.set(this.#t(ve),[Re])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,ve){this.#e.set(this.#t(W),[ve])}forEach(W,ve){for(const[Re,Ye]of this.#e)for(const it of Ye)W.call(ve,it,Re,this)}*[Symbol.iterator](){for(const[W,ve]of this.#e)for(const Re of ve)yield[W,Re]}#t(W){return W.toLowerCase()}};e.$rL=ht,e.$rL=ht=He([E],ht);let Lt=class{constructor(W){this.insertText=W}};e.$sL=Lt,e.$sL=Lt=He([E],Lt);let Qt=class{constructor(W,ve){this.label=ve,this.insertText=W}};e.$tL=Qt,e.$tL=Qt=He([E],Qt);let Xt=class{constructor(W,ve){this.id=W,this.color=ve}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$uL=Xt,e.$uL=Xt=He([E],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(W){this.id=W}};e.$vL=si,e.$vL=si=He([E],si);var Si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Ct=class{get base(){return this.c}set base(W){this.c=W,this.e=g.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,ve){if(typeof W!="string"&&(!W||!g.URI.isUri(W)&&!g.URI.isUri(W.uri)))throw(0,F.$6)("base");if(typeof ve!="string")throw(0,F.$6)("pattern");typeof W=="string"?this.baseUri=g.URI.file(W):g.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wL=Ct,e.$wL=Ct=He([E],Ct);const Zi=new WeakMap;function ln(K,W){Zi.set(K,W)}e.$xL=ln;let kt=class{constructor(W,ve,Re,Ye){this.enabled=typeof W=="boolean"?W:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this.c||(this.c=Zi.get(this)??(0,A.$ig)()),this.c}};e.$yL=kt,e.$yL=kt=He([E],kt);let gi=class extends kt{constructor(W,ve,Re,Ye,it){if(super(ve,Re,Ye,it),W===null)throw(0,F.$6)("location");this.location=W}};e.$zL=gi,e.$zL=gi=He([E],gi);let mi=class extends kt{constructor(W,ve,Re,Ye,it){super(ve,Re,Ye,it),this.functionName=W}};e.$AL=mi,e.$AL=mi=He([E],mi);let oi=class extends kt{constructor(W,ve,Re,Ye,it,ct,ft){if(super(Ye,it,ct,ft),!ve)throw(0,F.$6)("dataId");this.label=W,this.dataId=ve,this.canPersist=Re}};e.$BL=oi,e.$BL=oi=He([E],oi);let Di=class{constructor(W,ve,Re){this.command=W,this.args=ve||[],this.options=Re}};e.$CL=Di,e.$CL=Di=He([E],Di);let Ci=class{constructor(W,ve){this.port=W,this.host=ve}};e.$DL=Ci,e.$DL=Ci=He([E],Ci);let Ft=class{constructor(W){this.path=W}};e.$EL=Ft,e.$EL=Ft=He([E],Ft);let $i=class{constructor(W){this.implementation=W}};e.$FL=$i,e.$FL=$i=He([E],$i);let Ii=class{constructor(W,ve,Re){this.session=W,this.threadId=ve,this.frameId=Re}};e.$GL=Ii,e.$GL=Ii=He([E],Ii);let ai=class{constructor(W,ve){this.session=W,this.threadId=ve}};e.$HL=ai,e.$HL=ai=He([E],ai);let ci=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$IL=ci,e.$IL=ci=He([E],ci);var dt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(dt||(e.InlineCompletionTriggerKind=dt={}));let Pi=class{constructor(W,ve){this.range=W,this.text=ve}};e.$JL=Pi,e.$JL=Pi=He([E],Pi);let xt=class{constructor(W,ve,Re=!0){this.range=W,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$KL=xt,e.$KL=xt=He([E],xt);let ni=class{constructor(W,ve){this.range=W,this.expression=ve}};e.$LL=ni,e.$LL=ni=He([E],ni);let bi=class{constructor(W,ve){this.frameId=W,this.stoppedLocation=ve}};e.$ML=bi,e.$ML=bi=He([E],bi);var Xi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=m=class extends Error{static FileExists(W){return new m(W,$.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(W){return new m(W,$.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(W){return new m(W,$.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(W){return new m(W,$.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(W){return new m(W,$.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(W){return new m(W,$.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(W,ve=$.FileSystemProviderErrorCode.Unknown,Re){super(g.URI.isUri(W)?W.toString(!0):W),this.code=Re?.name??"Unknown",(0,$.$tk)(this,ve),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$NL=Ai,e.$NL=Ai=m=He([E],Ai);let Ri=class{constructor(W,ve,Re){this.start=W,this.end=ve,this.kind=Re}};e.$OL=Ri,e.$OL=Ri=He([E],Ri);var Li;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Li||(e.FoldingRangeKind=Li={}));var xi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Mi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Mi||(e.CommentMode=Mi={}));var ui;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(W,ve=[]){this.tokenTypes=W,this.tokenModifiers=ve}}e.$PL=Fi;function Ti(K){return typeof K>"u"||(0,y.$Df)(K)}class Ni{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let ve=0,Re=W.tokenTypes.length;ve<Re;ve++)this.j.set(W.tokenTypes[ve],ve);for(let ve=0,Re=W.tokenModifiers.length;ve<Re;ve++)this.k.set(W.tokenModifiers[ve],ve)}}push(W,ve,Re,Ye,it){if(typeof W=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.n(W,ve,Re,Ye,it);if(j.isRange(W)&&typeof ve=="string"&&Ti(Re))return this.m(W,ve,Re);throw(0,F.$6)()}m(W,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ye=W.start.line,it=W.start.character,ct=W.end.character-W.start.character,ft=this.j.get(ve);let zt=0;if(Re)for(const Zt of Re){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);zt|=1<<ei>>>0}this.n(Ye,it,ct,ft,zt)}n(W,ve,Re,Ye,it){if(this.f&&(W<this.c||W===this.c&&ve<this.e)){this.f=!1;const zt=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<zt;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let ct=W,ft=ve;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ft-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ft,this.g[this.h++]=Re,this.g[this.h++]=Ye,this.g[this.h++]=it,this.c=W,this.e=ve}static o(W){const ve=[],Re=W.length/5|0;for(let ft=0;ft<Re;ft++)ve[ft]=ft;ve.sort((ft,zt)=>{const Zt=W[5*ft],ei=W[5*zt];if(Zt===ei){const ii=W[5*ft+1],ri=W[5*zt+1];return ii-ri}return Zt-ei});const Ye=new Uint32Array(W.length);let it=0,ct=0;for(let ft=0;ft<Re;ft++){const zt=5*ve[ft],Zt=W[zt+0],ei=W[zt+1],ii=W[zt+2],ri=W[zt+3],Qi=W[zt+4],Dn=Zt-it,Tn=Dn===0?ei-ct:ei,Yi=5*ft;Ye[Yi+0]=Dn,Ye[Yi+1]=Tn,Ye[Yi+2]=ii,Ye[Yi+3]=ri,Ye[Yi+4]=Qi,it=Zt,ct=ei}return Ye}build(W){return this.f?new Oi(new Uint32Array(this.g),W):new Oi(Ni.o(this.g),W)}}e.$QL=Ni;class Oi{constructor(W,ve){this.resultId=ve,this.data=W}}e.$RL=Oi;class hi{constructor(W,ve,Re){this.start=W,this.deleteCount=ve,this.data=Re}}e.$SL=hi;class hn{constructor(W,ve){this.resultId=ve,this.edits=W}}e.$TL=hn;var en;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let ji=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$UL=ji,e.$UL=ji=He([E],ji);var pi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(pi||(e.QuickPickItemKind=pi={}));var tn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class wi{static validate(W){if(typeof W.badge=="string"){let ve=(0,b.$df)(W.badge,0);if(ve<W.badge.length&&(ve+=(0,b.$df)(W.badge,ve)),W.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Xt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,ve,Re){this.badge=W,this.tooltip=ve,this.color=Re}}e.$VL=wi;let vi=class{constructor(W){this.kind=W}};e.$WL=vi,e.$WL=vi=He([E],vi);var rn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(W){return W instanceof _t?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,ve){if(W<0)throw(0,F.$6)("start must be positive");if(ve<0)throw(0,F.$6)("end must be positive");W<=ve?(this.c=W,this.e=ve):(this.c=ve,this.e=W)}with(W){let ve=this.c,Re=this.e;return W.start!==void 0&&(ve=W.start),W.end!==void 0&&(Re=W.end),ve===this.c&&Re===this.e?this:new _t(ve,Re)}}e.$XL=_t;class di{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(ve=>di.isNotebookCellData(ve))}static isNotebookCellData(W){return!0}constructor(W,ve,Re,Ye,it,ct,ft){this.kind=W,this.value=ve,this.languageId=Re,this.mime=Ye,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,di.validate(this)}}e.$YL=di;class dn{constructor(W){this.cells=W}}e.$ZL=dn;class Yt{static isNotebookCellOutputItem(W){return W instanceof Yt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const ve={name:W.name,message:W.message,stack:W.stack};return Yt.json(ve,"application/vnd.code.notebook.error")}static stdout(W){return Yt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Yt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,ve="application/octet-stream"){return new Yt(W,ve)}static#e=new TextEncoder;static text(W,ve=L.$Wr.text){const Re=Yt.#e.encode(String(W));return new Yt(Re,ve)}static json(W,ve="text/x-json"){const Re=JSON.stringify(W,void 0,"	");return Yt.text(Re,ve)}constructor(W,ve){this.data=W,this.mime=ve;const Re=(0,L.$1r)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$1L=Yt;class yi{static isNotebookCellOutput(W){return W instanceof yi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,ve=!1){const Re=new Set,Ye=new Set;for(let it=0;it<W.length;it++){const ct=W[it],ft=(0,L.$1r)(ct.mime);if(!Re.has(ft)||(0,D.$CI)(ft)){Re.add(ft);continue}Ye.add(it),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ye.size===0?W:W.filter((it,ct)=>!Ye.has(ct))}constructor(W,ve,Re){this.items=yi.ensureUniqueMimeTypes(W,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.$ig)(),this.metadata=ve??Re)}}e.$2L=yi;var sn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var zi;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(zi||(e.NotebookCellStatusBarAlignment=zi={}));var ze;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(ze||(e.NotebookEditorRevealType=ze={}));class ti{constructor(W,ve){this.text=W,this.alignment=ve}}e.$3L=ti;var Ui;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var $t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})($t||(e.NotebookControllerAffinity2=$t={}));class fn{constructor(W,ve=[]){this.uri=W,this.provides=(0,I.$2b)(ve)}}e.$4L=fn;class gn{constructor(W){this.label=W}}e.$5L=gn;let ki=class{constructor(W,ve){this.label=W,this.timestamp=ve}};e.$6L=ki,e.$6L=ki=He([E],ki);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(W,ve){this.ranges=W,this.wordPattern=ve}}e.$7L=mn;class $n{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$8L=$n;var Bi;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(W=void 0,ve=void 0,Re=void 0,Ye=!1){this.include=W,this.exclude=ve,this.profile=Re,this.continuous=Ye}};e.$9L=Wi,e.$9L=Wi=He([E],Wi);let Vi=p=class{static diff(W,ve,Re){const Ye=new p(W);return Ye.expectedOutput=ve,Ye.actualOutput=Re,Ye}constructor(W){this.message=W}};e.$0L=Vi,e.$0L=Vi=p=He([E],Vi);let qi=class{constructor(W){this.id=W}};e.$$L=qi,e.$$L=qi=He([E],qi);let li=class{constructor(W,ve){this.covered=W,this.total=ve}};e.$_L=li,e.$_L=li=He([E],li);let Ki=v=class{static fromDetails(W,ve){const Re=new li(0,0),Ye=new li(0,0),it=new li(0,0);for(const ft of ve)if("branches"in ft){Re.total+=1,Re.covered+=ft.executionCount>0?1:0;for(const zt of ft.branches)Ye.total+=1,Ye.covered+=zt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new v(W,Re,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return ct.detailedCoverage=ve,ct}constructor(W,ve,Re,Ye){this.uri=W,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Ye}};e.$aM=Ki,e.$aM=Ki=v=He([E],Ki);let Hi=class{constructor(W,ve,Re=[]){this.executionCount=W,this.location=ve,this.branches=Re}};e.$bM=Hi,e.$bM=Hi=He([E],Hi);let Gi=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$cM=Gi,e.$cM=Gi=He([E],Gi);let Ji=class{constructor(W,ve){this.executionCount=W,this.location=ve}};e.$dM=Ji,e.$dM=Ji=He([E],Ji);var un;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var we;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(we||(e.WorkspaceTrustState=we={}));var De;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(De||(e.PortAutoForwardAction=De={}));class Oe{constructor(W,ve,Re,Ye,it,ct){this.kind=W,this.name=ve,this.detail=Re,this.uri=Ye,this.range=it,this.selectionRange=ct}}e.$eM=Oe;class at{constructor(W){this.uri=W}}e.$fM=at;class yt{constructor(W,ve){this.original=W,this.modified=ve}}e.$gM=yt;class Tt{constructor(W,ve,Re,Ye){this.base=W,this.input1=ve,this.input2=Re,this.result=Ye}}e.$hM=Tt;class Cn{constructor(W,ve){this.uri=W,this.viewType=ve}}e.$iM=Cn;class In{constructor(W){this.viewType=W}}e.$jM=In;class Pn{constructor(W,ve){this.uri=W,this.notebookType=ve}}e.$kM=Pn;class An{constructor(W,ve,Re){this.original=W,this.modified=ve,this.notebookType=Re}}e.$lM=An;class Rn{constructor(){}}e.$mM=Rn;class Ln{constructor(W,ve){this.uri=W,this.inputBoxUri=ve}}e.$nM=Ln;class Mn{constructor(W){this.providerId=W}}e.$oM=Mn;var bn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var pn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var wn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var yn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(W,ve){this.role=W,this.content=ve}}e.$pM=Fn;var En;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var kn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$DM=e.$CM=void 0;const g=new Map;function A(D,w){w?g.set(D,w):g.delete(D)}e.$CM=A;function P(D){return g.get(D)}class $ extends R.$3u{constructor(w,u,o,i,n,r,a,t){super(u,o,i,n),this.c=w,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,y.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===F.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(u){return u?w.s(u):w.getText()},get eol(){return w.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(u){return w.t(u)},offsetAt(u){return w.u(u)},positionAt(u){return w.v(u)},validateRange(u){return w.w(u)},validatePosition(u){return w.x(u)},getWordRangeAtPosition(u,o){return w.y(u,o)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,I.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,I.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const u=this.w(w);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const o=this.g,i=u.start.line,n=u.end.line,r=[];r.push(this.f[i].substring(u.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,u.end.character)),r.join(o)}t(w){let u;if(w instanceof b.$BK?u=w.line:typeof w=="number"&&(u=w),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new S(u,this.f[u],u===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const u=this.j.getIndexOf(w),o=this.f[u.index].length;return new b.$BK(u.index,Math.min(u.remainder,o))}w(w){if(!(w instanceof b.$CK))throw new Error("Invalid argument");const u=this.x(w.start),o=this.x(w.end);return u===w.start&&o===w.end?w:new b.$CK(u.line,u.character,o.line,o.character)}x(w){if(!(w instanceof b.$BK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:u,character:o}=w,i=!1;if(u<0)u=0,o=0,i=!0;else if(u>=this.f.length)u=this.f.length-1,o=this.f[u].length,i=!0;else{const n=this.f[u].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new b.$BK(u,o):w}y(w,u){const o=this.x(w);if(!u)u=P(this.m);else if((0,f.$Se)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const i=(0,L.$cs)(o.character+1,(0,L.$as)(u),this.f[o.line],0);if(i)return new b.$CK(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$DM=$;class S{constructor(w,u,o){this.a=w,this.b=u,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$CK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$CK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EM=S}),define(ke[285],Se([1,0,7,20,4]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;let R=class{constructor(b){this.a=new I.$WL(I.ColorThemeKind.Dark),this.b=new f.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let y;switch(b){case"light":y=I.ColorThemeKind.Light;break;case"hcDark":y=I.ColorThemeKind.HighContrast;break;case"hcLight":y=I.ColorThemeKind.HighContrastLight;break;default:y=I.ColorThemeKind.Dark}this.a=new I.$WL(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$yfc=R,e.$yfc=R=He([Be(0,F.$AM)],R)}),define(ke[286],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.CellExecutionUpdateType=void 0;var F;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$GI=(0,I.$Vh)("INotebookExecutionService")}),define(ke[287],Se([1,0,3,29,193,99]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MOb=void 0;class L extends I.$Rc{constructor(y,g,A){super(),this._source=y,this.b=g,this.c=A,this.a=void 0}f(y){const g=y.getLineCount();return new F.$As(1,1,g,this.g(y,g))}g(y,g){if(g<1||g>y.getLineCount())throw new Error("Illegal value for lineNumber");return y.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const y=new f.$NB;y.acceptChunk(this._source);const g=y.finish(!0),{textBuffer:A,disposable:P}=g.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(y=>{const g=new f.$NB;g.acceptChunk(y);const A=g.finish(!0),{textBuffer:P,disposable:$}=A.create(1);return this.B($),P})),this.a}findInInputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const $=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if($.length!==0)return{textBuffer:P,matches:$}}).filter(P=>!!P):[]}}e.$MOb=L}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(R){R.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class f{static fromExtHostTestItem(L,b,y=L.parent){if(L._isRoot)return new f([b]);const g=[L.id];for(let A=y;A&&A.id!==b;A=A.parent)g.push(A.id);return g.push(b),new f(g.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new f(L.split("\0"))}static join(L,b){return new f([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:f.isChild(L,b)?2:f.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new f(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new f(this.path,L)}compare(L){if(typeof L=="string")return f.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$rJ=f}),define(ke[89],Se([1,0,2,29,67]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$xJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$wJ=e.$vJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$uJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$tJ=e.$sJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var L;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var b;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$sJ=[2,4,8,16,32,64];const y=C=>"runId"in C;e.$tJ=y;var g;(function(C){C.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),C.deserialize=m=>({range:F.$As.lift(m.range),uri:I.URI.revive(m.uri)})})(g||(e.IRichLocation=g={}));var A;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(A||(e.TestMessageType=A={}));var P;(function(C){C.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.serialize(m.location)}),C.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.deserialize(m.location)})})(P||(e.ITestErrorMessage=P={}));const $=(C,m)=>`${m?"s":"e"}${C}`;e.$uJ=$;var S;(function(C){C.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.serialize(m.location)}),C.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.deserialize(m.location)})})(S||(e.ITestOutputMessage=S={}));var D;(function(C){C.serialize=m=>m.type===0?P.serialize(m):S.serialize(m),C.deserialize=m=>m.type===0?P.deserialize(m):S.deserialize(m)})(D||(e.ITestMessage=D={}));var w;(function(C){C.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),C.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(D.serialize)}),C.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(D.deserialize)})})(w||(e.ITestTaskState=w={}));const u="\0",o=(C,m)=>C+u+m;e.$vJ=o;const i=C=>{const m=C.indexOf(u);return{ctrlId:C.slice(0,m),tagId:C.slice(m+1)}};e.$wJ=i;var n;(function(C){C.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),C.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?I.URI.revive(m.uri):void 0,range:m.range?F.$As.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(n||(e.ITestItem=n={}));var r;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var a;(function(C){C.serialize=m=>({expand:m.expand,item:n.serialize(m.item)}),C.deserialize=m=>({controllerId:f.$rJ.root(m.item.extId),expand:m.expand,item:n.deserialize(m.item)})})(a||(e.InternalTestItem=a={}));var t;(function(C){C.serialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.uri!==void 0&&(p.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(p.range=m.item.range?.toJSON()),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}},C.deserialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.range!==void 0&&(p.range=m.item.range?F.$As.lift(m.item.range):null),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}}})(t||(e.ITestItemUpdate=t={}));const s=(C,m)=>{m.expand!==void 0&&(C.expand=m.expand),m.item!==void 0&&(C.item=C.item?Object.assign(C.item,m.item):m.item)};e.$xJ=s;var d;(function(C){C.serializeWithoutMessages=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serializeWithoutMessages)}),C.serialize=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serialize)}),C.deserialize=m=>({...a.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var c;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(c||(e.DetailType=c={}));var l;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var h;(function(C){C.deserialize=m=>m.op===0?{op:m.op,item:a.deserialize(m.item)}:m.op===1?{op:m.op,item:t.deserialize(m.item)}:m.op===2?{op:m.op,uri:I.URI.revive(m.uri),docv:m.docv}:m,C.serialize=m=>m.op===0?{op:m.op,item:a.serialize(m.item)}:m.op===1?{op:m.op,item:t.serialize(m.item)}:m})(h||(e.TestsDiffOp=h={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(m){const p=this.o();for(const v of m)switch(v.op){case 0:this.j(a.deserialize(v.item),p);break;case 1:this.k(t.deserialize(v.item),p);break;case 3:this.l(v.itemId,p);break;case 5:this.m(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.c.set(v.tag.id,v.tag);break;case 7:this.c.delete(v.id);break}p.complete?.()}j(m,p){const v=f.$rJ.parentId(m.item.extId)?.toString();let E;if(!v)E=this.p(m),this.f.add(E),this.d.set(m.item.extId,E);else if(this.d.has(v)){const N=this.d.get(v);N.children.add(m.item.extId),E=this.p(m,N),this.d.set(m.item.extId,E)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return p.add?.(E),m.expand===2&&this.g++,E}k(m,p){const v=this.d.get(m.extId);if(v)return m.expand!==void 0&&(v.expand===2&&this.g--,m.expand===2&&this.g++),(0,e.$xJ)(v,m),p.update?.(v),v}l(m,p){const v=this.d.get(m);if(!v)return;const E=f.$rJ.parentId(v.item.extId)?.toString();E?this.d.get(E).children.delete(v.item.extId):this.f.delete(v);const N=[[m]];for(;N.length;)for(const z of N.pop()){const M=this.d.get(z);M&&(N.push(M.children),this.d.delete(z),p.remove?.(M,M!==v),M.expand===2&&this.g--)}}m(m){}updatePendingRoots(m){this.h+=m}o(){return{}}}e.$yJ=k}),define(ke[112],Se([1,0,11,4,3,60,89,67]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.TestItemEventOp=void 0;var y;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const g=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:g,label:g,description:g,error:g,sortText:g,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),$=(i,n)=>{let r;for(const[a,t]of P)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class S extends f.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$0g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.I(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,L.$xJ)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,L.$xJ)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,r-1):t.wait().then(()=>this.J(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,r-1)):this.J(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,r){switch(r.op){case 3:this.N(b.$rJ.joinToString(n.fullId,r.id));break;case 0:this.y(r.item,n);break;case 5:for(const a of r.ops)this.u(n,a);break;case 1:this.z(r.new,r.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.w(n.actual.uri);break;default:(0,R.$4c)(r)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,r){const a=b.$rJ.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(a.toString());if(!s){s={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.H(n,s,r);return}if(s.actual===n){this.G(n,s,r);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,r);const d=this.s.getChildren(s.actual),c=s.actual,l=$(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,s.actual=n,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.z(n.tags,c.tags,a.toString()),delete l.tags),this.u(s,{op:4,update:l})),this.H(n,s,r);for(const[h,k]of d)this.s.getChildren(n).get(k.id)||this.N(b.$rJ.joinToString(a,k.id));this.w(s.actual.uri)}z(n,r,a){const t=new Set(r.map(s=>s.id));for(const s of n)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(s=>(0,L.$vJ)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$vJ)(this.s.controllerId,n.id)}}))}D(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$vJ)(this.s.controllerId,n)}))}F(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}G(n,r,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=s=>this.u(r,s),this.I(r)}H(n,r,a){this.G(n,r,a);for(const[t,s]of this.s.getChildren(n))this.y(s,r)}I(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.L(n))}J(n,r){if(r<0)return;const a=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(b.$rJ.joinToString(n.fullId,s.id),r);(0,I.$Kg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new I.$Wg;return s.open(),s}n.expand=2,this.M(n);const r=n.resolveBarrier=new I.$Wg,a=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){a(s)}return(0,I.$Kg)(t)?t.catch(a).then(()=>{r.open(),this.I(n)}):(r.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$rJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$qM=S;class D extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$rM=D;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sM=w;class u extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$tM=u;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,s){for(const d of a.values())t.call(s,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const s=new Map,d=new Set(a.keys()),c={op:5,ops:[]};for(const l of t){if(!(l instanceof r))throw new w(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new u(l.id,h,i.controllerId);if(s.has(l.id))throw new D(l.id);s.set(l.id,l),d.delete(l.id),c.ops.push({op:0,item:l})}for(const l of d.keys())c.ops.push({op:3,id:l});i.listener?.(c),a=s},add(t){if(!(t instanceof r))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$uM=o}),define(ke[144],Se([1,0,112]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;const F=new WeakMap,f=(L,b)=>{const y={controllerId:b};return F.set(L,y),y};e.$vM=f;const R=L=>{const b=F.get(L);if(!b)throw new I.$sM(L?.id||"<unknown>");return b};e.$wM=R}),define(ke[113],Se([1,0,17,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=e.$$tb=e.$0tb=e.$9tb=e.$8tb=void 0,e.$8tb="vscode-cdn.net",e.$9tb=`vscode-resource.${e.$8tb}`,e.$0tb=`'self' https://*.${e.$8tb}`;function f(b,y){return b.scheme===I.Schemas.http||b.scheme===I.Schemas.https?b:(y&&y.authority&&y.isRemote&&b.scheme===I.Schemas.file&&(b=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:y.authority,path:b.path})),F.URI.from({scheme:I.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$9tb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$$tb=f;function R(b){return b.replace(/./g,y=>{const g=y.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?y:"-"+g.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,(y,g)=>String.fromCharCode(parseInt(g,16)))}e.$_tb=L}),define(ke[288],Se([1,0,4,3,113]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class R{constructor(b,y,g){this.d=b,this.e=y,this.f=g,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,y,g,A,P){let $;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){$=n;break}if(!$)throw new Error("not a visible editor");const S=this,D=this.a++,w=new I.$Rd,u=new I.$Rd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,f.$$tb)(n,S.f)}get cspSource(){return f.$0tb}set options(n){this.b=n,S.d.$setOptions(D,n)}get options(){return this.b}set html(n){this.a=n,S.d.$setHtml(D,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return S.d.$postMessage(D,n)}},i=new class{constructor(){this.editor=b,this.line=y,this.height=g,this.webview=o,this.onDidDispose=u.event}dispose(){S.c.has(D)&&(S.c.delete(D),S.d.$disposeEditorInset(D),u.fire(),u.dispose(),w.dispose())}};return this.d.$createEditorInset(D,$.id,$.value.document.uri,y+1,g,A||{},P.identifier,P.extensionLocation),this.c.set(D,{editor:b,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(b){const y=this.c.get(b);y&&y.inset.dispose()}$onDidReceiveMessage(b,y){this.c.get(b)?.onDidReceiveMessage.fire(y)}}e.$Udc=R}),define(ke[289],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.VariableKind=e.$mN=void 0,e.$mN=(0,I.$Vh)("configurationResolverService");var F;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class f extends Error{constructor(L,b){super(b),this.variable=L}}e.$nN=f}),define(ke[290],Se([1,0,16,49,18,24,12,102,232,289,13]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,D,w,u){this.h=new Map,this.a=S,this.b=D,this.g=w,u&&(this.c=u.then(o=>this.i(o)))}i(S){if(L.$i){const D=Object.create(null);return Object.keys(S).forEach(w=>{D[w.toLowerCase()]=S[w]}),D}return S}resolveWithEnvironment(S,D,w){return this.l({env:this.i(S),userHome:void 0},D?D.uri:void 0,w)}async resolveAsync(S,D){const w={env:await this.c,userHome:await this.g};return this.l(w,S?S.uri:void 0,D)}async j(S,D,w,u){const o=R.$an(D);L.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):L.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):L.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,S?S.uri:void 0,o,w,u)}async resolveAnyAsync(S,D,w){return this.j(S,D,w)}async resolveAnyMap(S,D,w){const u=new Map;return{newConfig:await this.j(S,D,w,u),resolvedVariables:u}}resolveWithInteractionReplace(S,D,w,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,D,w,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,D){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,D)}async l(S,D,w,u,o){if(f.$Cf(w))return this.m(S,D,w,u,o);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(S,D,i,u,o)));if(f.$Ef(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async r=>[await this.m(S,D,r,u,o),await this.l(S,D,w[r],u,o)]));for(const[r,a]of n)i[r]=a;return i}return w}m(S,D,w,u,o){return(0,A.$Xe)(w,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let r=await this.o(S,i,n,D,u);return o?.set(n,r),r!==i&&f.$Cf(r)&&r.match(P.VARIABLE_REGEXP)&&(r=await this.m(S,D,r,u,o)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,D,w,u,o){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const r=s=>{const d=this.a.getFilePath();if(d)return(0,b.$zv)(d);throw new g.$nN(s,(0,y.localize)(0,null,D))},a=s=>{const d=r(s);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$zv)(c)}throw new g.$nN(s,(0,y.localize)(1,null,D,I.$mc(d)))},t=s=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new g.$nN(s,(0,y.localize)(2,null,D,i))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new g.$nN(s,(0,y.localize)(3,null,D)):new g.$nN(s,(0,y.localize)(4,null,D))};switch(w){case"env":if(i){if(S.env){const s=S.env[L.$i?i.toLowerCase():i];if(f.$Cf(s))return s}return""}throw new g.$nN(g.VariableKind.Env,(0,y.localize)(5,null,D));case"config":if(i){const s=this.a.getConfigurationValue(u,i);if(f.$Lf(s))throw new g.$nN(g.VariableKind.Config,(0,y.localize)(6,null,D,i));if(f.$Ef(s))throw new g.$nN(g.VariableKind.Config,(0,y.localize)(7,null,D,i));return s}throw new g.$nN(g.VariableKind.Config,(0,y.localize)(8,null,D));case"command":return this.p(g.VariableKind.Command,D,i,o,"command");case"input":return this.p(g.VariableKind.Input,D,i,o,"input");case"extensionInstallFolder":if(i){const s=await this.a.getExtension(i);if(!s)throw new g.$nN(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,D,i));return this.n(s.extensionLocation)}throw new g.$nN(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,D));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,b.$zv)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return u||i?(0,b.$zv)(this.n(t(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$zv)(I.$mc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new g.$nN(g.VariableKind.UserHome,(0,y.localize)(11,null,D))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$nN(g.VariableKind.LineNumber,(0,y.localize)(12,null,D))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$nN(g.VariableKind.SelectedText,(0,y.localize)(13,null,D))}case"file":return r(g.VariableKind.File);case"fileWorkspaceFolder":return a(g.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$mc(a(g.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||i?I.$kc(this.n(t(g.VariableKind.RelativeFile)),r(g.VariableKind.RelativeFile)):r(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=I.$lc(r(g.VariableKind.RelativeFileDirname));if(u||i){const d=I.$kc(this.n(t(g.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return I.$lc(r(g.VariableKind.FileDirname));case"fileExtname":return I.$nc(r(g.VariableKind.FileExtname));case"fileBasename":return I.$mc(r(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=I.$mc(r(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-I.$nc(s).length)}case"fileDirnameBasename":return I.$mc(I.$lc(r(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||D}case"execInstallFolder":{const s=this.a.getAppRoot();return s||D}case"pathSeparator":return I.sep;default:try{const s=i?`${w}:${i}`:w;return this.p(g.VariableKind.Unknown,D,s,o,void 0)}catch{return D}}}}p(S,D,w,u,o){if(w&&u){const i=o===void 0?u[w]:u[o+":"+w];if(typeof i=="string")return i;throw new g.$nN(S,(0,y.localize)(14,null,D))}return D}}e.$BN=P}),define(ke[145],Se([1,0,5,141]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,I.$Vh)("editorGroupsService");var f;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EXPAND=1]="EXPAND",D[D.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var y;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function g(D){const w=D;return(0,F.$pE)(w?.editor)&&(0,F.$pE)(w?.replacement)}e.$HC=g;var A;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function $(D){const w=D;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$IC=$;function S(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=S}),define(ke[291],Se([1,0,5,145]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,I.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function f(R){const L=R;return typeof R=="number"||(0,F.$IC)(L)}e.$NC=f}),define(ke[146],Se([1,0,5,134]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=void 0,e.$VJ=(0,I.$Wh)(F.$3h)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=e.$S5b=e.$R5b=e.$Q5b=e.$P5b=void 0;class L{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$P5b=L;class b{static isHostExtension(o,i,n){if(i.getExtensionDescription(o))return!1;const r=n.getExtensionDescription(o);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(o,i){this.j=o,this.c=new F.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(D),this.f=new I.$bm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=w(this.e,i),this.e=this.e.concat(o);const n=b.l(this.e);return this.e=w(this.e,n.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,n)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,d){this.addNode(s),this.addNode(d),this.c.has(s)?this.c.get(s).push(d):this.c.set(s,[d])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,d){const c=i.getArcs(s);for(let l=0;l<c.length;l++)if(!d.has(c[l]))return!1;return!0}getNodes(){return this.e}},n=new I.$bm;for(const s of o)if(n.set(s.identifier,s),s.extensionDependencies)for(const d of s.extensionDependencies)i.addArc(I.$_l.toKey(s.identifier),I.$_l.toKey(d));const r=new Set;i.getNodes().filter(s=>i.getArcs(s).length===0).forEach(s=>r.add(s));const a=i.getNodes().filter(s=>!r.has(s));let t;do{t=!1;for(let s=0;s<a.length;s++){const d=a[s];i.hasOnlyGoodArcs(d,r)&&(a.splice(s,1),s--,r.add(d),t=!0)}}while(t);return a.map(s=>n.get(s))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Q5b=b;class y{constructor(o,i){this.versionId=o,this.extensions=i}}e.$R5b=y;class g{constructor(o){this.d=new $,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new A(this,i)}deltaExtensions(o,i,n){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$S5b=g;class A extends R.$Rc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$T5b=A;class P{constructor(o){this.name=o,this.promise=new Promise((i,n)=>{this.c=i})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const i=new P(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};o.resolve((0,R.$Pc)(r))}}var S;(function(u){u[u.Builtin=0]="Builtin",u[u.User=1]="User",u[u.Dev=2]="Dev"})(S||(S={}));function D(u,o){const i=u.isBuiltin?0:u.isUnderDevelopment?2:1,n=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==n)return i-n;const r=f.$fc.basename(u.extensionLocation.path),a=f.$fc.basename(o.extensionLocation.path);return r<a?-1:r>a?1:0}function w(u,o){const i=new I.$am(o);return u.filter(n=>!i.has(n.identifier))}}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.ExtHostConnectionType=void 0;var I;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[F.ENV_KEY]=this.pipeName}}e.$Dm=F;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[f.ENV_KEY]="1"}}e.$Em=f;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[R.ENV_KEY]="1"}}e.$Fm=R;function L(A){delete A[F.ENV_KEY],delete A[f.ENV_KEY],delete A[R.ENV_KEY]}function b(A,P){L(P),A.serialize(P)}e.$Gm=b;function y(A){if(A[F.ENV_KEY])return g(A,new F(A[F.ENV_KEY]));if(A[f.ENV_KEY])return g(A,new f);if(A[R.ENV_KEY])return g(A,new R);throw new Error("No connection information defined in environment!")}e.$Hm=y;function g(A,P){return L(A),P}}),define(ke[114],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var f;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(g){const A=I.$fe.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$hm=L;function b(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$im=b;var y;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=void 0;let S=class extends P.$Rc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new F.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:y.$uo,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,f.$fj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new D(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$2k)((0,y.$Bo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$RM=S,e.$RM=S=He([Be(0,R.$QM),Be(1,f.$ej)],S);class D{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,s){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new F.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,y.$Eo)(i,[]),this.c&&(i=(0,g.$dn)(i,this.c)),this.b||(i=(0,g.$dn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,y.$Eo)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$SM=D;function w(u){const o=Date.now()-new Date(u).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$TM=w,e.$UM=(0,I.$Vh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,262,139,26,5]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new L.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,b.$Vh)("extensionService");class y{constructor(a){this.dependency=a}}e.$KF=y;var g;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,s){this.c=a,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$yF.createActivationEventsMap(this.d)}}set(a,t,s){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],c=[],l=[],h=[],k=P(this.d),C=P(t),m=(z,M)=>z.extensionLocation.toString()===M.extensionLocation.toString()||z.isBuiltin===M.isBuiltin||z.isUserBuiltin===M.isUserBuiltin||z.isUnderDevelopment===M.isUnderDevelopment;for(const z of this.d){const M=C.get(z.identifier);if(!M){d.push(z.identifier),k.delete(z.identifier);continue}if(!m(z,M)){d.push(z.identifier),k.delete(z.identifier);continue}}for(const z of t){const M=k.get(z.identifier);if(!M){c.push(z);continue}if(!m(M,z)){d.push(M.identifier),k.delete(M.identifier);continue}}const p=new L.$am(this.e),v=new L.$am(s);for(const z of this.e)v.has(z)||l.push(z);for(const z of s)p.has(z)||h.push(z);const E=R.$yF.createActivationEventsMap(c),N={versionId:a,toRemove:d,toAdd:c,addActivationEvents:E,myToRemove:l,myToAdd:h};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:c}=a,l=new L.$am(t),h=new L.$am(d);for(let k=0;k<this.d.length;k++)l.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of s)this.d.push(k);for(const k of c)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(L.$_l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$yF.readActivationEvents(t);for(const d of s)a.add(d)}return a}}e.$LF=A;function P(r){const a=new L.$bm;for(const t of r)a.set(t.identifier,t);return a}function $(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$MF=$;function S(r,a){if(!$(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$NF=S;class D{constructor(a,t,s,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$OF=D;class w{constructor(a,t){this.description=a,this.value=t}}e.$PF=w;var u;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,f.$Ko)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$QF=o;function i(r,a){return{identifier:new L.$_l((0,f.$Io)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$RF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=n}),define(ke[293],Se([1,0,8,147,26,25,14,11]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=e.$hec=e.$gec=e.$fec=e.$eec=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$eec=y;class g{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$fec=g;class A{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$gec=A;class P extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$hec=P;class $ extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$iec=$;class S extends A{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new f.$bm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new S(a));return this.c.onExtensionActivationError(o.id,a,new R.$KF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const s=this.a.getExtensionDescription(a);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:o.reason}));continue}const d=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),l=this.k(o,i.displayName,[],new S(c));return this.c.onExtensionActivationError(i.identifier,c,new R.$KF(a)),l}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const a=new w(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,a),a}l(o){return F.$Q5b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$jec=D,e.$jec=D=He([Be(3,L.$dj)],D);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,a,t,s){this.c=o,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=s,this.a=new b.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new S(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new S(i),this.b&&I.$3(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};w=He([Be(6,L.$dj)],w)}),define(ke[15],Se([1,0,19,22,165,74,80,28,161,54,100,24,18,2,29,83,136,144,141,111,67,89,291,7,25]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$zM=e.$yM=e.MarkdownString=e.$xM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Fe(se){const{selectionStartLineNumber:Te,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Qe}=se,ot=new s.$BK(Te-1,qe-1),pt=new s.$BK(xe-1,Qe-1);return new s.$DK(ot,pt)}Me.to=Fe;function Ce(se){const{anchor:Te,active:qe}=se;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Ce})(c||(e.Selection=c={}));var l;(function(Me){function Fe(se){if(!se)return;const{start:Te,end:qe}=se;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Fe;function Ce(se){if(!se)return;const{startLineNumber:Te,startColumn:qe,endLineNumber:xe,endColumn:Qe}=se;return new s.$CK(Te-1,qe-1,xe-1,Qe-1)}Me.to=Ce})(l||(e.Range=l={}));var h;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Fe})(h||(e.TokenType=h={}));var k;(function(Me){function Fe(se){return new s.$BK(se.lineNumber-1,se.column-1)}Me.to=Fe;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Me.from=Ce})(k||(e.Position=k={}));var C;(function(Me){function Fe(Te,qe,xe){return(0,I.$Gb)((0,I.$2b)(Te).map(Qe=>Ce(Qe,qe,xe)))}Me.from=Fe;function Ce(Te,qe,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:se(Te.scheme,qe),pattern:ue.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function se(Te,qe){return qe&&typeof Te=="string"?qe.transformOutgoingScheme(Te):Te}})(C||(e.DocumentSelector=C={}));var m;(function(Me){function Fe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(m||(e.DiagnosticTag=m={}));var p;(function(Me){function Fe(se){let Te;return se.code&&((0,$.$Cf)(se.code)||(0,$.$Gf)(se.code)?Te=String(se.code):Te={value:String(se.code.value),target:se.code.target}),{...l.from(se.range),message:se.message,source:se.source,code:Te,severity:E.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(v.from),tags:Array.isArray(se.tags)?(0,I.$Gb)(se.tags.map(m.from)):void 0}}Me.from=Fe;function Ce(se){const Te=new s.$OK(l.to(se),se.message,E.to(se.severity));return Te.source=se.source,Te.code=(0,$.$Cf)(se.code)?se.code:se.code?.value,Te.relatedInformation=se.relatedInformation&&se.relatedInformation.map(v.to),Te.tags=se.tags&&(0,I.$Gb)(se.tags.map(m.to)),Te}Me.to=Ce})(p||(e.Diagnostic=p={}));var v;(function(Me){function Fe(se){return{...l.from(se.location.range),message:se.message,resource:se.location.uri}}Me.from=Fe;function Ce(se){return new s.$NK(new s.$MK(se.resource,l.to(se)),se.message)}Me.to=Ce})(v||(e.DiagnosticRelatedInformation=v={}));var E;(function(Me){function Fe(se){switch(se){case s.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Me.from=Fe;function Ce(se){switch(se){case u.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Ce})(E||(e.DiagnosticSeverity=E={}));var N;(function(Me){function Fe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$MC:t.$LC}Me.from=Fe;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function z(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!z(Me[0])}e.$xM=M;var T;(function(Me){function Fe(Qe){return Qe.map(Me.from)}Me.fromMany=Fe;function Ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function se(Qe){let ot;if(Ce(Qe)){const{language:ht,value:Lt}=Qe;ot={value:"```"+ht+`
`+Lt+"\n```\n"}}else s.$1K.isMarkdownString(Qe)?ot={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ot={value:Qe}:ot={value:""};const pt=Object.create(null);ot.uris=pt;const bt=ht=>{try{let Lt=S.URI.parse(ht,!0);Lt=Lt.with({query:Te(Lt.query,pt)}),pt[ht]=Lt}catch{}return""},vt=new y.marked.Renderer;return vt.link=bt,vt.image=ht=>typeof ht=="string"?bt(L.$dk(ht).href):"",(0,y.marked)(ot.value,{renderer:vt}),ot}Me.from=se;function Te(Qe,ot){if(!Qe)return Qe;let pt;try{pt=(0,g.$rh)(Qe)}catch{}if(!pt)return Qe;let bt=!1;return pt=(0,P.$cn)(pt,vt=>{if(S.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ht]=vt,bt=!0,ht}else return}),bt?JSON.stringify(pt):Qe}function qe(Qe){const ot=new s.$1K(Qe.value,Qe.supportThemeIcons);return ot.isTrusted=Qe.isTrusted,ot.supportHtml=Qe.supportHtml,ot.baseUri=Qe.baseUri?S.URI.from(Qe.baseUri):void 0,ot}Me.to=qe;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(T||(e.MarkdownString=T={}));function j(Me){return M(Me)?Me.map(Fe=>({range:l.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?T.fromMany(Fe.hoverMessage):Fe.hoverMessage?T.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:l.from(Fe)}))}e.$yM=j;function O(Me){return typeof Me>"u"?Me:typeof Me=="string"?S.URI.file(Me):Me}e.$zM=O;var V;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?O(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Fe})(V||(e.ThemableDecorationAttachmentRenderOptions=V={}));var te;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Fe})(te||(e.ThemableDecorationRenderOptions=te={}));var fe;(function(Me){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(fe||(e.DecorationRangeBehavior=fe={}));var Z;(function(Me){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?fe.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?te.from(Ce.light):void 0,dark:Ce.dark?te.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?O(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?V.from(Ce.before):void 0,after:Ce.after?V.from(Ce.after):void 0}}Me.from=Fe})(Z||(e.DecorationRenderOptions=Z={}));var Q;(function(Me){function Fe(se){return{text:se.newText,eol:se.newEol&&Ae.from(se.newEol),range:l.from(se.range)}}Me.from=Fe;function Ce(se){const Te=new s.$HK(l.to(se.range),se.text);return Te.newEol=typeof se.eol>"u"?void 0:Ae.to(se.eol),Te}Me.to=Ce})(Q||(e.TextEdit=Q={}));var G;(function(Me){function Fe(se,Te){const qe={edits:[]};if(se instanceof s.$KK){const xe=new b.$Ac;for(const Qe of se._allEntries())Qe._type===1&&S.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of se._allEntries())if(Qe._type===1){let ot;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ot={type:"base64",value:(0,F.$ze)(F.$fe.wrap(Qe.options.contents))}:ot={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ot},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:Q.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:l.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(wt.from)}})}return qe}Me.from=Fe;function Ce(se){const Te=new s.$KK,qe=new b.$zc;for(const xe of se.edits)if(xe.textEdit){const Qe=xe,ot=S.URI.revive(Qe.resource),pt=l.to(Qe.textEdit.range),bt=Qe.textEdit.text,vt=Qe.textEdit.insertAsSnippet;let ht;vt?ht=s.$JK.replace(pt,new s.$LK(bt)):ht=s.$HK.replace(pt,bt);const Lt=qe.get(ot);Lt?Lt.push(ht):qe.set(ot,[ht])}else Te.renameFile(S.URI.revive(xe.oldResource),S.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of qe)Te.set(xe,Qe);return Te}Me.to=Ce})(G||(e.WorkspaceEdit=G={}));var oe;(function(Me){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Ce;function se(Te){for(const qe in Fe)if(Fe[qe]===Te)return Number(qe);return s.SymbolKind.Property}Me.to=se})(oe||(e.SymbolKind=oe={}));var x;(function(Me){function Fe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Me.to=Ce})(x||(e.SymbolTag=x={}));var Ee;(function(Me){function Fe(se){return{name:se.name,kind:oe.from(se.kind),tags:se.tags&&se.tags.map(x.from),containerName:se.containerName,location:be.from(se.location)}}Me.from=Fe;function Ce(se){const Te=new s.$RK(se.name,oe.to(se.kind),se.containerName,be.to(se.location));return Te.tags=se.tags&&se.tags.map(x.to),Te}Me.to=Ce})(Ee||(e.WorkspaceSymbol=Ee={}));var le;(function(Me){function Fe(se){const Te={name:se.name||"!!MISSING: name!!",detail:se.detail,range:l.from(se.range),selectionRange:l.from(se.selectionRange),kind:oe.from(se.kind),tags:se.tags?.map(x.from)??[]};return se.children&&(Te.children=se.children.map(Fe)),Te}Me.from=Fe;function Ce(se){const Te=new s.$SK(se.name,se.detail,oe.to(se.kind),l.to(se.range),l.to(se.selectionRange));return(0,I.$Kb)(se.tags)&&(Te.tags=se.tags.map(x.to)),se.children&&(Te.children=se.children.map(Ce)),Te}Me.to=Ce})(le||(e.DocumentSymbol=le={}));var q;(function(Me){function Fe(se){const Te=new s.$WK(oe.to(se.kind),se.name,se.detail||"",S.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,name:se.name,detail:se.detail,kind:oe.from(se.kind),uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(x.from)}}Me.from=Ce})(q||(e.CallHierarchyItem=q={}));var U;(function(Me){function Fe(Ce){return new s.$XK(q.to(Ce.from),Ce.fromRanges.map(se=>l.to(se)))}Me.to=Fe})(U||(e.CallHierarchyIncomingCall=U={}));var ie;(function(Me){function Fe(Ce){return new s.$YK(q.to(Ce.to),Ce.fromRanges.map(se=>l.to(se)))}Me.to=Fe})(ie||(e.CallHierarchyOutgoingCall=ie={}));var be;(function(Me){function Fe(se){return{range:se.range&&l.from(se.range),uri:se.uri}}Me.from=Fe;function Ce(se){return new s.$MK(S.URI.revive(se.uri),l.to(se.range))}Me.to=Ce})(be||(e.location=be={}));var H;(function(Me){function Fe(se){const Te=se,qe=se;return{originSelectionRange:Te.originSelectionRange?l.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:qe.uri,range:l.from(Te.targetRange?Te.targetRange:qe.range),targetSelectionRange:Te.targetSelectionRange?l.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Ce(se){return{targetUri:S.URI.revive(se.uri),targetRange:l.to(se.range),targetSelectionRange:se.targetSelectionRange?l.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?l.to(se.originSelectionRange):void 0}}Me.to=Ce})(H||(e.DefinitionLink=H={}));var X;(function(Me){function Fe(se){return{range:l.from(se.range),contents:T.fromMany(se.contents)}}Me.from=Fe;function Ce(se){return new s.$PK(se.contents.map(T.to),l.to(se.range))}Me.to=Ce})(X||(e.Hover=X={}));var Y;(function(Me){function Fe(se){return{range:l.from(se.range),expression:se.expression}}Me.from=Fe;function Ce(se){return new s.$IL(l.to(se.range),se.expression)}Me.to=Ce})(Y||(e.EvaluatableExpression=Y={}));var $e;(function(Me){function Fe(se){if(se instanceof s.$JL)return{type:"text",range:l.from(se.range),text:se.text};if(se instanceof s.$KL)return{type:"variable",range:l.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$LL)return{type:"expression",range:l.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Ce(se){switch(se.type){case"text":return{range:l.to(se.range),text:se.text};case"variable":return{range:l.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:l.to(se.range),expression:se.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var ne;(function(Me){function Fe(se){return{frameId:se.frameId,stoppedLocation:l.from(se.stoppedLocation)}}Me.from=Fe;function Ce(se){return new s.$ML(se.frameId,l.to(se.stoppedLocation))}Me.to=Ce})(ne||(e.InlineValueContext=ne={}));var de;(function(Me){function Fe(se){return{range:l.from(se.range),kind:se.kind}}Me.from=Fe;function Ce(se){return new s.$QK(l.to(se.range),se.kind)}Me.to=Ce})(de||(e.DocumentHighlight=de={}));var ee;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Fe})(ee||(e.CompletionTriggerKind=ee={}));var he;(function(Me){function Fe(Ce){return{triggerKind:ee.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Fe})(he||(e.CompletionContext=he={}));var pe;(function(Me){function Fe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var Pe;(function(Me){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(qe){return Fe.get(qe)??9}Me.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(qe){return se.get(qe)??s.CompletionItemKind.Property}Me.to=Te})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Fe(Ce,se){const Te=new s.$7K(Ce.label);return Te.insertText=Ce.insertText,Te.kind=Pe.to(Ce.kind),Te.tags=Ce.tags?.map(pe.to),Te.detail=Ce.detail,Te.documentation=L.$$j(Ce.documentation)?T.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,D.$As.isIRange(Ce.range)?Te.range=l.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:l.to(Ce.range.insert),replacing:l.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new s.$LK(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof s.$CK?new s.$HK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(qe=>Q.to(qe))),Te.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Te}Me.to=Fe})(B||(e.CompletionItem=B={}));var J;(function(Me){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:T.fromStrict(se.documentation)}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:L.$$j(se.documentation)?T.to(se.documentation):se.documentation}}Me.to=Ce})(J||(e.ParameterInformation=J={}));var re;(function(Me){function Fe(se){return{label:se.label,documentation:T.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(J.from):[],activeParameter:se.activeParameter}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:L.$$j(se.documentation)?T.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(J.to):[],activeParameter:se.activeParameter}}Me.to=Ce})(re||(e.SignatureInformation=re={}));var ae;(function(Me){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.from):[]}}Me.from=Fe;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.to):[]}}Me.to=Ce})(ae||(e.SignatureHelp=ae={}));var _;(function(Me){function Fe(Ce,se){const Te=new s.$6K(k.to(se.position),typeof se.label=="string"?se.label:se.label.map(ge.to.bind(void 0,Ce)),se.kind&&ye.to(se.kind));return Te.textEdits=se.textEdits&&se.textEdits.map(Q.to),Te.tooltip=L.$$j(se.tooltip)?T.to(se.tooltip):se.tooltip,Te.paddingLeft=se.paddingLeft,Te.paddingRight=se.paddingRight,Te}Me.to=Fe})(_||(e.InlayHint=_={}));var ge;(function(Me){function Fe(Ce,se){const Te=new s.$5K(se.label);return Te.tooltip=L.$$j(se.tooltip)?T.to(se.tooltip):se.tooltip,w.Command.is(se.command)&&(Te.command=Ce.fromInternal(se.command)),se.location&&(Te.location=be.to(se.location)),Te}Me.to=Fe})(ge||(e.InlayHintLabelPart=ge={}));var ye;(function(Me){function Fe(se){return se}Me.from=Fe;function Ce(se){return se}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var je;(function(Me){function Fe(se){return{range:l.from(se.range),url:se.target,tooltip:se.tooltip}}Me.from=Fe;function Ce(se){let Te;if(se.url)try{Te=typeof se.url=="string"?S.URI.parse(se.url,!0):S.URI.revive(se.url)}catch{}return new s.$_K(l.to(se.range),Te)}Me.to=Ce})(je||(e.DocumentLink=je={}));var We;(function(Me){function Fe(se){const Te=new s.$cL(se.label);return se.textEdit&&(Te.textEdit=Q.to(se.textEdit)),se.additionalTextEdits&&(Te.additionalTextEdits=se.additionalTextEdits.map(qe=>Q.to(qe))),Te}Me.to=Fe;function Ce(se){return{label:se.label,textEdit:se.textEdit?Q.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Te=>Q.from(Te)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var et;(function(Me){function Fe(se){return new s.$aL(se[0],se[1],se[2],se[3])}Me.to=Fe;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Me.from=Ce})(et||(e.Color=et={}));var Ze;(function(Me){function Fe(se){return{range:l.from(se.range)}}Me.from=Fe;function Ce(se){return new s.$VK(l.to(se.range))}Me.to=Ce})(Ze||(e.SelectionRange=Ze={}));var rt;(function(Me){function Fe(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Me){function Fe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Ce})(nt||(e.TextEditorLineNumbersStyle=nt={}));var Ae;(function(Me){function Fe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Me.from=Fe;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Ne;(function(Me){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Ne||(e.ProgressLocation=Ne={}));var Ve;(function(Me){function Fe(se){const Te={start:se.start+1,end:se.end+1};return se.kind&&(Te.kind=Le.from(se.kind)),Te}Me.from=Fe;function Ce(se){const Te={start:se.start-1,end:se.end-1};return se.kind&&(Te.kind=Le.to(se.kind)),Te}Me.to=Ce})(Ve||(e.FoldingRange=Ve={}));var Le;(function(Me){function Fe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return w.$pt.Comment;case s.FoldingRangeKind.Imports:return w.$pt.Imports;case s.FoldingRangeKind.Region:return w.$pt.Region}}Me.from=Fe;function Ce(se){if(se)switch(se.value){case w.$pt.Comment.value:return s.FoldingRangeKind.Comment;case w.$pt.Imports.value:return s.FoldingRangeKind.Imports;case w.$pt.Region.value:return s.FoldingRangeKind.Region}}Me.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Xe;(function(Me){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?l.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$bE.id:void 0}}Me.from=Fe})(Xe||(e.TextEditorOpenOptions=Xe={}));var ue;(function(Me){function Fe(qe){return qe instanceof s.$wL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||se(qe)?new s.$wL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Fe;function Ce(qe){const xe=qe;return xe?S.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(qe){return typeof qe=="string"?qe:new s.$wL(S.URI.revive(qe.baseUri),qe.pattern)}Me.to=Te})(ue||(e.GlobPattern=ue={}));var ce;(function(Me){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:ue.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Me.from=Fe})(ce||(e.LanguageSelector=ce={}));var Ie;(function(Me){function Fe(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Te=>Array.isArray(Te)&&Te.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&S.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof s.$CK)))}Me.is=Fe;function Ce(se){return{documents:se.documents.map(Te=>Te.map(qe=>({uri:S.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>l.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Fe(se){return{start:se.start,end:se.end}}Me.from=Fe;function Ce(se){return new s.$XL(se.start,se.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ge;(function(Me){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Me.to=Fe;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Me.from=Ce})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var _e;(function(Me){function Fe(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Fe})(_e||(e.NotebookCellExecutionState=_e={}));var st;(function(Me){function Fe(se){switch(se){case s.NotebookCellKind.Markup:return n.CellKind.Markup;case s.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Fe;function Ce(se){switch(se){case n.CellKind.Markup:return s.NotebookCellKind.Markup;case n.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var lt;(function(Me){function Fe(se){const Te={metadata:se.metadata??Object.create(null),cells:[]};for(const qe of se.cells)s.$YL.validate(qe),Te.cells.push(wt.from(qe));return Te}Me.from=Fe;function Ce(se){const Te=new s.$ZL(se.cells.map(wt.to));return(0,$.$Pf)(se.metadata)||(Te.metadata=se.metadata),Te}Me.to=Ce})(lt||(e.NotebookData=lt={}));var wt;(function(Me){function Fe(se){return{cellKind:st.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ge.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Kt.from):[]}}Me.from=Fe;function Ce(se){return new s.$YL(st.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Kt.to):void 0,se.metadata,se.internalMetadata?Ge.to(se.internalMetadata):void 0)}Me.to=Ce})(wt||(e.NotebookCellData=wt={}));var Ue;(function(Me){function Fe(se){return{mime:se.mime,valueBytes:F.$fe.wrap(se.data)}}Me.from=Fe;function Ce(se){return new s.$1L(se.valueBytes.buffer,se.mime)}Me.to=Ce})(Ue||(e.NotebookCellOutputItem=Ue={}));var Kt;(function(Me){function Fe(se){return{outputId:se.id,items:se.items.map(Ue.from),metadata:se.metadata}}Me.from=Fe;function Ce(se){const Te=se.items.map(Ue.to);return new s.$2L(Te,se.outputId,se.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Fe(Te){return se(Te)?{include:ue.from(Te.include)??void 0,exclude:ue.from(Te.exclude)??void 0}:ue.from(Te)??void 0}Me.from=Fe;function Ce(Te){return se(Te)?{include:ue.to(Te.include),exclude:ue.to(Te.exclude)}:ue.to(Te)}Me.to=Ce;function se(Te){const qe=Te;return qe?!(0,$.$Lf)(qe.include)&&!(0,$.$Lf)(qe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var Et;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(qe,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Ut;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(qe,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Me){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Me){function Fe(se){return{uri:se.uri,provides:se.provides}}Me.from=Fe;function Ce(se){return new s.$4L(S.URI.revive(se.uri),se.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Me){function Fe(se){return{message:T.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:l.from(se.location.range),uri:se.location.uri}}}Me.from=Fe;function Ce(se){const Te=new s.$0L(typeof se.message=="string"?se.message:T.to(se.message));return Te.actualOutput=se.actual,Te.expectedOutput=se.expected,Te.contextValue=se.contextValue,Te.location=se.location?be.to(se.location):void 0,Te}Me.to=Ce})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Me){Me.namespace=a.$vJ,Me.denamespace=a.$wJ})(Dt||(e.TestTag=Dt={}));var Mt;(function(Me){function Fe(se){const Te=(0,o.$wM)(se).controllerId;return{extId:r.$rJ.fromExtHostTestItem(se,Te).toString(),label:se.label,uri:S.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(qe=>Dt.namespace(Te,qe.id)),range:D.$As.lift(l.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&T.fromStrict(se.error)||null}}Me.from=Fe;function Ce(se){return{parent:void 0,error:void 0,id:r.$rJ.fromString(se.extId).localId,label:se.label,uri:S.URI.revive(se.uri),tags:(se.tags||[]).map(Te=>{const{tagId:qe}=Dt.denamespace(Te);return new s.$$L(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Me.toPlain=Ce})(Mt||(e.TestItem=Mt={})),function(Me){function Fe(se){return{id:se.id}}Me.from=Fe;function Ce(se){return new s.$$L(se.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Wt;(function(Me){const Fe=(se,Te)=>{const qe=[];for(const[Qe,ot]of Te)r.$rJ.compare(ot.item.extId,Qe)===2&&(Te.delete(Qe),qe.push(ot));const xe={...Mt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ot=>ot.type===0).map(Bt.to)})),children:qe.map(Qe=>Fe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Ce(se){const Te=[],qe=new Map;for(const xe of se.items){qe.set(xe.item.extId,xe);const Qe=r.$rJ.root(xe.item.extId);se.request.targets.some(ot=>ot.controllerId===Qe&&ot.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:se.completedAt,results:Te.map(xe=>Fe(xe,qe))}}Me.to=Ce})(Wt||(e.TestResults=Wt={}));var tt;(function(Me){function Fe(qe){return{covered:qe.covered,total:qe.covered}}function Ce(qe){return"line"in qe?k.from(qe):l.from(qe)}function se(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:qe.executionCount,location:Ce(qe.location)}}Me.fromDetailed=se;function Te(qe){return{uri:qe.uri,statement:Fe(qe.statementCoverage),branch:qe.branchCoverage&&Fe(qe.branchCoverage),function:qe.functionCoverage&&Fe(qe.functionCoverage),details:qe.detailedCoverage?.map(se)}}Me.fromFile=Te})(tt||(e.TestCoverage=tt={}));var Vt;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Fe})(Vt||(e.CodeActionTriggerKind=Vt={}));var qt;(function(Me){function Fe(se){const Te=new s.$eM(oe.to(se.kind),se.name,se.detail||"",S.URI.revive(se.uri),l.to(se.range),l.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,kind:oe.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:l.from(se.range),selectionRange:l.from(se.selectionRange),tags:se.tags?.map(x.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var ut;(function(Me){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Fe})(ut||(e.ViewBadge=ut={}));var mt;(function(Me){function Fe(qe,xe,Qe){const ot=xe.fileData;return ot?new s.$pL(new s.$qL(ot.name,S.URI.revive(ot.uri),ot.id,(0,R.$cb)(()=>Qe(ot.id)))):qe===A.$Wr.uriList&&xe.uriListData?new s.$oL(Te(xe.uriListData)):new s.$oL(xe.asString)}Me.to=Fe;async function Ce(qe,xe){const Qe=await xe.asString();if(qe===A.$Wr.uriList)return{asString:Qe,fileData:void 0,uriListData:se(Qe)};const ot=xe.asFile();return{asString:Qe,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Ce;function se(qe){return f.$0s.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return S.URI.parse(xe)}catch{}return xe})}function Te(qe){return f.$0s.create(qe.map(xe=>typeof xe=="string"?xe:S.URI.revive(xe)))}})(mt||(e.DataTransferItem=mt={}));var Nt;(function(Me){function Fe(se,Te){const qe=se.items.map(([xe,Qe])=>[xe,mt.to(xe,Qe,Te)]);return new s.$rL(qe)}Me.toDataTransfer=Fe;async function Ce(se){const Te={items:[]},qe=[];for(const[xe,Qe]of se)qe.push((async()=>{Te.items.push([xe,await mt.from(xe,Qe)])})());return await Promise.all(qe),Te}Me.from=Ce})(Nt||(e.DataTransfer=Nt={}));var Pt;(function(Me){function Fe(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Fe})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Me){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:Pt.from(Ce)}Me.from=Fe})(At||(e.ChatFollowup=At={}));var gt;(function(Me){function Fe(se){const Te=new s.$pM(St.to(se.role),se.content);return Te.name=se.name,Te}Me.to=Fe;function Ce(se){return{role:St.from(se.role),content:se.content,name:se.name}}Me.from=Ce})(gt||(e.ChatMessage=gt={}));var St;(function(Me){function Fe(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Fe;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Ce})(St||(e.ChatMessageRole=St={}));var Rt;(function(Me){function Fe(Te){const qe={};for(const xe of Object.keys(Te))qe[xe]=Te[xe].map(Me.to);return qe}Me.objectTo=Fe;function Ce(Te){return{level:It.to(Te.level),value:Te.value,description:Te.description}}Me.to=Ce;function se(Te){return{level:It.from(Te.level),value:Te.value,description:Te.description}}Me.from=se})(Rt||(e.ChatVariable=Rt={}));var It;(function(Me){function Fe(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Fe;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(It||(e.ChatVariableLevel=It={}));var Je;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Fe})(Je||(e.InteractiveEditorResponseFeedbackKind=Je={}));var jt;(function(Me){function Fe(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{placeholder:se.placeholder}:"markdownContent"in se?((0,d.$NF)(Ce,"chatAgents2Additions"),{content:T.from(se.markdownContent)}):"content"in se?typeof se.content=="string"?se:((0,d.$NF)(Ce,"chatAgents2Additions"),{content:T.from(se.content)}):"documents"in se?{documents:se.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(qe=>l.from(qe))}))}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:l.from(se.reference.range)}:se.reference}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:l.from(se.inlineReference.range)}:se.inlineReference,title:se.title}:("agentName"in se&&(0,d.$NF)(Ce,"chatAgents2Additions"),se)}Me.from=Fe})(jt||(e.ChatResponseProgress=jt={}));var Jt;(function(Me){function Fe(Ce,se,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Te)}Me.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(ke[294],Se([1,0,2,8,7,15,75]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class b{constructor(g,A,P,$={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=P,this.g=$,this.a=new L.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,P,$)=>{const D={dispose:this.a.push([A,P,g])};return Array.isArray($)&&$.push(D),D}}async $participateInSave(g,A){const P=I.URI.revive(g);let $=!1;const S=setTimeout(()=>$=!0,this.g.timeout),D=[];try{for(const w of[...this.a]){if($)break;const u=this.d.getDocument(P),o=await this.h(w,{document:u,reason:R.TextDocumentSaveReason.to(A)});D.push(o)}}finally{clearTimeout(S)}return D}h([g,A,P],$){const S=this.b.get(g);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(P,g,A,$).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const w=this.b.get(g);this.b.set(g,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,P,$){const S=[],D=Date.now(),{document:w,reason:u}=$,{version:o}=w,i=Object.freeze({document:w,reason:u,waitUntil(n){if(Object.isFrozen(S))throw(0,F.$7)("waitUntil can not be called async");S.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(S),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof f.$HK))for(const{newText:t,newEol:s,range:d}of a)r.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&R.Range.from(d),text:t,eol:s&&R.EndOfLine.from(s)}});if(r.edits.length!==0)return o===w.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Pec=b}),define(ke[295],Se([1,0,17,2,15,7,111]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=void 0;class b{constructor(P,$,S,D){this.start=P,this.deletedCount=$,this.deletedItems=S,this.items=D}asApiEvent(){return{range:new R.$XL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,$,S){this.notebook=P,this.h=$,this.j=S,this.handle=S.handle,this.uri=F.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(f.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return P.g},set mime(D){P.g=D},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(S)}return this.f}setOutputs(P){this.a=P.map(f.NotebookCellOutput.to)}setOutputItems(P,$,S){const D=S.map(f.NotebookCellOutputItem.to),w=this.a.find(u=>u.id===P);if(w&&($||(w.items.length=0),w.items.push(...D),w.items.length>1&&w.items.every(u=>L.$CI(u.mime)))){const u=new Map,o=[];w.items.forEach(i=>{let n;u.has(i.mime)?n=u.get(i.mime):(n=[],u.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),w.items.length=0,o.forEach(i=>{const n=L.$DI(u.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$Uec=y;class g{static{this.a=0}constructor(P,$,S,D,w){this.k=P,this.l=$,this.m=S,this.uri=D,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,$={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(S){return S=P.n(S),P.b[S].apiCell},getCells(S){return(S?P.p(S):P.b).map(w=>w.apiCell)},save(){return P.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,$,S){this.g=P.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:S});const D={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},w=[];for(const o of P.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,D.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,D.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),w.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),w.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const u=new Map;for(let o=0;o<w.length;o++){const i=w[o],n=u.get(i.cell);if(n===void 0){const r=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});u.set(i.cell,r-1)}else D.cellChanges[n]={...D.cellChanges[n],...i}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let $=P.start|0,S=P.end|0;return $<0&&($=0),S>this.b.length&&(S=this.b.length),P.with({start:$,end:S})}p(P){P=this.o(P);const $=[];for(let S=P.start;S<P.end;S++)$.push(this.b[S]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,$,S){if(this.j)return;const D=[],w=[],u=[];if(P.reverse().forEach(o=>{const n=o[2].map(t=>{const s=new y(this,this.l,t);return $||w.push(y.asModelAddData(this.apiNotebook,t)),s}),r=new b(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)u.push(t.uri),r.deletedItems.push(t.apiCell);D.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:u}),S)for(const o of D)S.push(o.asApiEvent())}s(P,$,S,D){const w=this.b.splice(P,$);this.b.splice(S,0,...w);const u=[new b(P,$,w.map(o=>o.apiCell),[]),new b(S,0,[],w)];for(const o of u)D.push(o.asApiEvent())}t(P,$){this.b[P].setOutputs($)}u(P,$,S,D){this.b[P].setOutputItems($,S,D)}v(P,$){const S=this.b[P];S.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(S.uri,$)}w(P,$){const S=this.b[P];S.apiCell.mime=$}x(P,$){this.b[P].setMetadata($)}y(P,$){this.b[P].setInternalMetadata($)}getCellFromApiCell(P){return this.b.find($=>$.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find($=>$.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$Vec=g}),define(ke[296],Se([1,0,4,2,15,7]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class L{constructor(y,g,A,P={timeout:1500,errors:3}){this.b=y,this.c=g,this.d=A,this.f=P,this.a=new I.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(g,A,P)=>{const $=function(D){g.call(A,D)};return $.extension=y,this.a.event($,void 0,P)}}async $participateInSave(y,g,A){const P=F.URI.revive(y),$=this.c.getNotebookDocument(P);if(!$)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:f.TextDocumentSaveReason.to(g)},A,async(w,u)=>{const o=Date.now(),i=await await Promise.resolve(w);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof R.$KK?S.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(S.length===0)return!0;const D={edits:[]};for(const w of S){const{edits:u}=f.WorkspaceEdit.from(w);D.edits=D.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$_ec=L}),define(ke[148],Se([1,0,8,15,7]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,y,g,A,P,$){this.id=b,this.f=y,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(y){this.selections=[y]},get selections(){return b.a},set selections(y){if(!Array.isArray(y)||!y.every(f.$XL.isNotebookRange))throw(0,I.$6)("selections");b.a=y,b.g(y)},get visibleRanges(){return b.b},revealRange(y,g){b.f.$tryRevealRange(b.id,F.NotebookRange.from(y),g??f.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(F.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Wec=R}),define(ke[297],Se([1,0,8,4,14,15]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;let L=class{constructor(y,g){this.c=y,this.d=g,this.a=new F.$Rd({onListenerError:I.$1}),this.b=new F.$Rd({onListenerError:I.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,g);const A=this.d.getEditorById(y);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const g in y)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(y[g]))}};e.$bfc=L,e.$bfc=L=He([Be(0,f.$dj)],L)}),define(ke[298],Se([1,0,15,85,216,21,59,8]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class y{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,S,D){const w=this.b++,{title:u,location:o,cancellable:i}=S,n={label:(0,f.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(w,{location:I.ProgressLocation.from(o),title:u,source:n,cancellable:i},$.isUnderDevelopment?void 0:$.identifier.value).catch(b.$1),this.d(w,D,!!i)}d($,S,D){let w;D&&(w=new R.$2d,this.c.set($,w));const u=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let o;try{o=S(new A(this.a,$),D&&w?w.token:R.CancellationToken.None)}catch(i){throw u($),i}return o.then(i=>u($),i=>u($)),o}$acceptProgressCanceled($){const S=this.c.get($);S&&(S.cancel(),this.c.delete($))}}e.$ifc=y;function g(P,$){return P.message=$.message,typeof $.increment=="number"&&(typeof P.increment=="number"?P.increment+=$.increment:P.increment=$.increment),P}class A extends F.$_u{constructor($,S){super(D=>this.throttledReport(D)),this.c=$,this.d=S}throttledReport($){this.c.$progressReport(this.d,$)}}He([(0,L.$ph)(100,(P,$)=>g(P,$),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,67,112,89,15,2]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=e.$NM=e.$MM=void 0;const g=(n,r,a,t)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!a(s,d)){const c=s;s=d,n.listener?.(t(d,c))}}}},A=(n,r)=>n===r,P={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},$=n=>r=>({op:4,update:n(r)}),S=(n,r)=>({range:(()=>{let a;const t=$(s=>({range:I.$As.lift(b.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return a},set(s){n.listener?.({op:6}),P.range(a,s)||(a=s,n.listener?.(t(s)))}}})(),label:g(n,r,P.label,$(a=>({label:a}))),description:g(n,void 0,P.description,$(a=>({description:a}))),sortText:g(n,void 0,P.sortText,$(a=>({sortText:a}))),canResolveChildren:g(n,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:g(n,!1,P.busy,$(a=>({busy:a}))),error:g(n,void 0,P.error,$(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:g(n,[],P.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),D=n=>{const r=f.$rJ.fromString(n.extId),a=new u(r.controllerId,r.localId,n.label,y.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,L.$wJ)(t).tagId})),a},w=n=>{let r;for(const a of n.tests){const t=D(a.item);(0,F.$wM)(t).parent=r,r=t}return r};e.$MM=w;class u{constructor(r,a,t,s){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$vM)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$uM)(d,F.$wM,u),enumerable:!0,writable:!1},...S(d,t)})}}e.$NM=u;class o extends u{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$OM=o;class i extends R.$qM{constructor(r,a,t){super({controllerId:r,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:F.$wM,getChildren:s=>s.children,root:new o(r,a),toITestItem:b.TestItem.from})}}e.$PM=i}),define(ke[150],Se([1,0,60,8,122,15,7]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=void 0;class b{static{this.c=new f.$FM("TextEditorDecorationType")}constructor($,S,D){const w=b.c.nextId();$.$registerTextEditorDecorationType(S.identifier,w,R.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:w,dispose(){$.$removeTextEditorDecorationType(w)}})}}e.$HM=b;class y{constructor($,S){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,S){this.k();let D=null;if($ instanceof L.$BK)D=new L.$CK($,$);else if($ instanceof L.$CK)D=$;else throw new Error("Unrecognized location");this.l(D,S,!1)}insert($,S){this.k(),this.l(new L.$CK($,$),S,!0)}delete($){this.k();let S=null;if($ instanceof L.$CK)S=$;else throw new Error("Unrecognized location");this.l(S,null,!0)}l($,S,D){const w=this.c.validateRange($);this.g.push({range:w,text:S,forceMoveMarkers:D})}setEndOfLine($){if(this.k(),$!==L.EndOfLine.LF&&$!==L.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=$}}class g{constructor($,S,D,w){this.c=$,this.d=S,this._accept(D),this.e=w;const u=this;this.value={get tabSize(){return u.f},set tabSize(o){u.m(o)},get indentSize(){return u.g},set indentSize(o){u.o(o)},get insertSpaces(){return u.h},set insertSpaces(o){u.q(o)},get cursorStyle(){return u.j},set cursorStyle(o){u.s(o)},get lineNumbers(){return u.k},set lineNumbers(o){u.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}m($){const S=this.l($);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}o($){const S=this.n($);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const S=this.p($);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const S={};let D=!1;if(typeof $.tabSize<"u"){const w=this.l($.tabSize);w==="auto"?(D=!0,S.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,D=!0,S.tabSize=w)}if(typeof $.indentSize<"u"){const w=this.n($.indentSize);w==="tabSize"?(D=!0,S.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,D=!0,S.indentSize=w)}if(typeof $.insertSpaces<"u"){const w=this.p($.insertSpaces);w==="auto"?(D=!0,S.insertSpaces=w):this.h!==w&&(this.h=w,D=!0,S.insertSpaces=w)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,D=!0,S.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,D=!0,S.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u($,S){S.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(D)})}}e.$IM=g;class A{constructor($,S,D,w,u,o,i,n){this.id=$,this.j=S,this.k=D,this.g=!1,this.h=new Set,this.c=u,this.d=new g(this.j,this.id,o,D),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new F.$8("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof L.$DK))throw(0,F.$6)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof L.$DK)))throw(0,F.$6)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new F.$8("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new F.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(w.value,t);return a(s),r.m(s)},insertSnippet(a,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(c=>R.Range.from(c));else if(t instanceof L.$BK){const{lineNumber:c,column:l}=R.Position.from(t);d=[{startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l}]}else if(t instanceof L.$CK)d=[R.Range.from(t)];else{d=[];for(const c of t)if(c instanceof L.$CK)d.push(R.Range.from(c));else{const{lineNumber:l,column:h}=R.Position.from(c);d.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return S.$tryInsertSnippet($,w.value.version,a.value,d,s)},setDecorations(a,t){const s=t.length===0;s&&!r.h.has(a.key)||(s?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(R.$xM(t))return S.$trySetDecorations($,a.key,R.$yM(t));{const d=new Array(4*t.length);for(let c=0,l=t.length;c<l;c++){const h=t[c];d[4*c]=h.start.line+1,d[4*c+1]=h.start.character+1,d[4*c+2]=h.end.line+1,d[4*c+3]=h.end.character+1}return S.$trySetDecorationsFast($,a.key,d)}}))},revealRange(a,t){r.n(()=>S.$tryRevealRange($,R.Range.from(a),t||L.TextEditorRevealType.Default))},show(a){S.$tryShowEditor($,R.ViewColumn.from(a))},hide(){S.$tryHideEditor($)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions($){(0,I.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,I.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,I.ok)(!this.g),this.f=$}_acceptSelections($){(0,I.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const S=$.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const D=S.edits.map(u=>u.range);D.sort((u,o)=>u.end.line===o.end.line?u.end.character===o.end.character?u.start.line===o.start.line?u.start.character-o.start.character:u.start.line-o.start.line:u.end.character-o.end.character:u.end.line-o.end.line);for(let u=0,o=D.length-1;u<o;u++){const i=D[u].end;if(D[u+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=S.edits.map(u=>({range:R.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,w,{setEndOfLine:typeof S.setEndOfLine=="number"?R.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$JM=A}),define(ke[299],Se([1,0,220,23,2,4,3,279,11,7,18,19,15,80,21,177,25]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;function o(r,a){if((0,A.$Cf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends L.$Rc{constructor(a,t,s){super(),this.f=a,this.g=t,this.h=s,this.a=new Map,this.b=new w.$u8;function d(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>d(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(l=>d(l)?this.r(l):l):c})}registerTreeDataProvider(a,t,s){const d=this.createTreeView(a,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(a,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,s),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:c,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(a,C),p={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,u.$NF)(s,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,u.$NF)(s,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(v){(0,S.$$j)(v)&&(0,u.$NF)(s,"treeViewMarkdownMessage"),k.message=v},get title(){return k.title},set title(v){k.title=v},get description(){return k.description},set description(v){k.description=v},get badge(){return k.badge},set badge(v){v!==void 0&&g.ViewBadge.isViewBadge(v)?k.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(k.badge=void 0)},reveal:(v,E)=>k.reveal(v,E),dispose:async()=>{await m,this.a.delete(a),k.dispose()}};return this.B(p),p}$getChildren(a,t){const s=this.a.get(a);return s?s.getChildren(t):Promise.reject(new b.$KE(a))}async $handleDrop(a,t,s,d,c,l,h,k){const C=this.a.get(a);if(!C)return Promise.reject(new b.$KE(a));const m=$.DataTransfer.toDataTransfer(s,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return h===a&&k&&await this.j(m,C,k,c,l),C.onDrop(m,d,c)}async j(a,t,s,d,c){const l=this.b.removeDragOperationTransfer(c);if(l)(await l)?.forEach((h,k)=>{h&&a.set(k,h)});else if(c&&t.handleDrag){const h=t.handleDrag(s,a,d);this.b.addDragOperationTransfer(c,h),await h}return a}async $handleDrag(a,t,s,d){const c=this.a.get(a);if(!c)return Promise.reject(new b.$KE(a));const l=await this.j(new g.$rL,c,t,d,s);if(!(!l||d.isCancellationRequested))return $.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$KE(a);return t.hasResolve}$resolve(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);return d.resolveTreeItem(t,s)}$setExpanded(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setExpanded(t,s)}$setSelectionAndFocus(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setSelectionAndFocus(t,s)}$setVisible(a,t){const s=this.a.get(a);if(!s){if(!t)return;throw new b.$KE(a)}s.setVisible(t)}$changeCheckboxState(a,t){const s=this.a.get(a);if(!s)throw new b.$KE(a);s.setCheckboxState(t)}m(a,t,s){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,s));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Bfc=i;class n extends L.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,s,d,c,l){if(super(),this.I=a,this.J=s,this.L=d,this.M=c,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$2d,l.contributes&&l.contributes.views)for(const m in l.contributes.views)for(const p of l.contributes.views[m])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>this.F.fire({message:!1,element:m})));let h,k;const C=R.Event.debounce(this.F.event,(m,p)=>(m||(m={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(v=>k=v),this.G=this.G.then(()=>h)),Array.isArray(p.element)?m.elements.push(...p.element):m.elements.push(p.element)),p.message&&(m.message=!0),m),200,!0);this.B(C(({message:m,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const v=k;return h=null,this.$(p).then(()=>v())})),m&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let s=this.X(a);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const s=(0,A.$Lf)(t.select)?!0:t.select,d=(0,A.$Lf)(t.focus)?!1:t.focus,c=(0,A.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(k=>k.item)},{select:s,focus:d,expand:c})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:c})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const s=this.getExtensionElement(a);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(a,t){const s=!(0,P.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(a,t,s){const d=[];for(const c of a){const l=this.getExtensionElement(c);l&&d.push(l)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,y.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(a);if(s){const d=this.m.get(s);if(d){const c=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(c),d.item.tooltip=this.eb(c.tooltip),d.item.command=this.fb(d.disposableStore,c.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,y.$Qg)(()=>this.f.getParent(a))}W(a,t){const s=this.m.get(a);return s?Promise.resolve(s):(0,y.$Qg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(d);if(c){const l=this.m.get(c);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const s=this.getExtensionElement(a);t=s?this.m.get(s):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new D.$2d(this.Z.token);try{const s=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,P.$Gb)(d||[]).map(async l=>{const h=await this.f.getTreeItem(l);return h&&!t.token.isCancellationRequested?this.db(l,h,s):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(c)}finally{t.dispose()}}$(a){if(a.some(s=>!s))return this.Z.dispose(!0),this.Z=new D.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(a);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(a){const t=new Set,s=a.map(c=>this.m.get(c));for(const c of s)if(c&&!t.has(c.item.handle)){let l=c;for(;l&&l.parent&&s.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(c.item.handle)}const d=[];return t.forEach(c=>{const l=this.j.get(c);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(c)}}),d}bb(a){const t={};return Promise.all(a.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,y.$Qg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const c=this.ib(t,d,s.parent);return this.pb(t,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}db(a,t,s){const d=this.ib(a,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,s),d}eb(a){return g.$1K.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,s,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,s=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(a){if(!g.$mL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,s){this.hb(t);const d=this.B(new L.$Qc),c=this.kb(a,t,s),l=this.lb(t);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,A.$Lf)(t.collapsibleState)?g.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof g.$uL?a.iconPath:void 0}kb(a,{id:t,label:s,resourceUri:d},c,l){if(t)return`${n.b}/${t}`;const h=o(s,this.N),k=c?c.item.handle:n.a;let C=h?h.label:d?(0,F.$wg)(d):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const m=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(c)||[];let v,E=0;do{if(v=`${k}/${E}:${C}`,l||!this.j.has(v)||m===v)break;E++}while(E<=p.length);return v}lb(a){if(a.iconPath&&!(a.iconPath instanceof g.$uL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof g.$uL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,s,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(a,t);const c=this.X(d)||[],l=c.filter(h=>h.item.handle===s.item.handle)[0];l&&c.splice(c.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[300],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[301],Se([1,0,234,8,39,135,108,37,26,300,138,139]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const $=b.$mn.as(L.$nn.JSONContribution);class S{constructor(a,t,s){this.a=a,this.b=t,this.c=s}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$TF=S;class D{static a(a){const t=new y.$am;for(let s=0,d=a.length;s<d;s++)t.add(a[s].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new D(t,[]);if(!t||!t.length)return new D([],a);const s=this.a(a),d=this.a(t),c=t.filter(h=>!s.has(h.description.identifier)),l=a.filter(h=>!d.has(h.description.identifier));return new D(c,l)}constructor(a,t){this.added=a,this.removed=t}}e.$UF=D;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=D.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$Z)(a)}}}e.$VF=w;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$$l},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionKind:{description:I.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$yF.register(a.extensionPoint,a.activationEventsGenerator),e.$WF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$WF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$mn.add(n.ExtensionsRegistry,new i),e.$YF=b.$mn.as(n.ExtensionsRegistry),$.registerSchema(o,e.$WF),$.registerSchema(A.$wj,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ke[302],Se([1,0,230,18,24,301,45,4]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var g;(function($){function S(D,w,u){if(!D)return;const o=F.$Cf(D.type)?D.type:void 0;if(!o||o.length===0){u.error(I.localize(3,null));return}const i=[];if(Array.isArray(D.required))for(const n of D.required)F.$Cf(n)&&i.push(n);return{extensionId:w.value,taskType:o,required:i,properties:D.properties?f.$an(D.properties):{},when:D.when?L.$Ti.deserialize(D.when):void 0}}$.from=S})(g||(g={}));const A=R.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,S)=>{for(const D of $)D.type&&S.push(`onTaskType:${D.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new b.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,D)=>{A.setHandler((w,u)=>{this.c=void 0;try{for(const o of u.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of u.added){const i=o.value;for(const n of i){const r=g.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const D of this.all()){const w={type:"object",additionalProperties:!1};D.required.length>0&&(w.required=D.required.slice(0)),D.properties!==void 0?w.properties=f.$an(D.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[D.taskType]},S.push(w)}this.c={oneOf:S}}return this.c}}e.$8F=new P}),define(ke[303],Se([1,0,231,18,23,24,45,302]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new L.$aj("taskRunning",!1,I.localize(0,null)),e.$$F={value:I.localize(1,null),original:"Tasks"};var y;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.$_F="$customized",function(j){function O(V){if(!V)return j.Strong;switch(V.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=O}(y||(e.ShellQuoting=y={}));var g;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(A||(e.RevealKind=A={})),function(j){function O(V){switch(V.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=O}(A||(e.RevealKind=A={}));var P;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(j){function O(V){switch(V.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=O}(P||(e.RevealProblemKind=P={}));var $;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})($||(e.PanelKind=$={})),function(j){function O(V){switch(V.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=O}($||(e.PanelKind=$={}));var S;(function(j){j.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var D;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(j){function O(te){switch(te.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=O;function V(te){switch(te){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=V}(D||(e.RuntimeType=D={}));var w;(function(j){function O(V){return F.$Cf(V)?V:V.value}j.value=O})(w||(e.CommandString=w={}));var u;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function O(te){return te===j.Clean._id||te===j.Build._id||te===j.Rebuild._id||te===j.Test._id}j.is=O;function V(te){if(te!==void 0)return F.$Cf(te)?O(te)?{_id:te,isDefault:!1}:void 0:te}j.from=V})(u||(e.TaskGroup=u={}));var o;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function O(V){switch(V){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(j){j.parallel="parallel",j.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,V,te,fe,Z,Q){this._label="",this._id=O,V&&(this._label=V),te&&(this.type=te),this.runOptions=fe,this.configurationProperties=Z,this._source=Q}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,V=!1){if(O===void 0)return!1;if(F.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||V&&O===this._id;const te=this.getDefinition(!0);return te!==void 0&&te._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$aG=t;class s extends t{constructor(O,V,te,fe,Z,Q,G,oe){super(O,te,void 0,G,oe,V),this.command={},this._source=V,this.hasDefinedMatchers=Q,Z&&(this.command=Z)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case D.Shell:V="shell";break;case D.Process:V="process";break;case D.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const te={type:e.$_F,folder:O,id:V};return JSON.stringify(te)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$bG=s;class d extends t{constructor(O,V,te,fe,Z,Q,G){super(O,te,fe,Q,G,V),this._source=V,this.configures=Z}static is(O){return O instanceof d}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const te={type:e.$_F,folder:O,id:V};return JSON.stringify(te)}}e.$cG=d;class c extends t{constructor(O,V,te,fe,Z,Q,G,oe,x){super(O,te,fe,oe,x,V),this.defines=Z,this.hasDefinedMatchers=G,this.command=Q,this.icon=x.icon,this.hide=x.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof c}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new c(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$dG=c;class l extends t{constructor(O,V,te,fe,Z,Q){super(O,te,fe,Z,Q,V),this._source=V}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new l(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$eG=l;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var k;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class C{constructor(O){this.c=new Map;for(let V=0;V<O.length;V++)this.c.set(O[V].uri.toString(),V)}compare(O,V){const te=O.getWorkspaceFolder(),fe=V.getWorkspaceFolder();if(te&&fe){let Z=this.c.get(te.uri.toString());Z=Z===void 0?0:Z+1;let Q=this.c.get(fe.uri.toString());return Q=Q===void 0?0:Q+1,Z===Q?O._label.localeCompare(V._label):Z-Q}else return!te&&fe?-1:te&&!fe?1:0}}e.$fG=C;var m;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(m||(e.TaskEventKind=m={}));var p;(function(j){j.SingleRun="singleRun",j.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var E;(function(j){function O(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function V(oe,x,Ee){return{...O(oe),kind:"start",terminalId:x,resolvedVariables:Ee}}j.start=V;function te(oe,x,Ee){return{...O(oe),kind:"processStarted",terminalId:x,processId:Ee}}j.processStarted=te;function fe(oe,x,Ee){return{...O(oe),kind:"processEnded",terminalId:x,exitCode:Ee}}j.processEnded=fe;function Z(oe,x,Ee){return{...O(oe),kind:"terminated",exitReason:Ee,terminalId:x}}j.terminated=Z;function Q(oe,x,Ee){return{...O(x),kind:oe,terminalId:Ee}}j.general=Q;function G(){return{kind:"changed"}}j.changed=G})(E||(e.TaskEvent=E={}));var N;(function(j){function O(te){const fe=Object.keys(te).sort();let Z="";for(const Q of fe){let G=te[Q];G instanceof Object?G=O(G):typeof G=="string"&&(G=G.replace(/,/g,",,")),Z+=Q+","+G+","}return Z}function V(te){const Z={_key:O(te),type:te.taskType};return Object.assign(Z,te),Z}j.create=V})(N||(e.KeyedTaskIdentifier=N={}));var z;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var M;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var T;(function(j){function O(V,te){const fe=b.$8F.get(V.type);if(fe===void 0){const oe=R.$an(V);return delete oe._key,N.create(oe)}const Z=Object.create(null);Z.type=fe.taskType;const Q=new Set;fe.required.forEach(oe=>Q.add(oe));const G=fe.properties;for(const oe of Object.keys(G)){const x=V[oe];if(x!=null)Z[oe]=x;else if(Q.has(oe)){const Ee=G[oe];if(Ee.default!==void 0)Z[oe]=R.$an(Ee.default);else switch(Ee.type){case"boolean":Z[oe]=!1;break;case"number":case"integer":Z[oe]=0;break;case"string":Z[oe]="";break;default:te.error(I.localize(2,null,JSON.stringify(V,void 0,0),oe));return}}}return N.create(Z)}j.createTaskIdentifier=O})(T||(e.TaskDefinition=T={}))}),define(ke[304],Se([1,0,8]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.$U5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,I.$Z)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$U5b=F;class f extends F{constructor(){super(),this.h=!0,this.i=new I.$4}}e.$V5b=f}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=e.$uv=void 0;class I{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++I.count}}e.$uv=I;const F=[];function f(b){const y=new I(b);return F[y.nid]=y,y}e.$vv=f;function R(b){return F[b].sid}e.$wv=R;class L{constructor(y){this.value=y}}e.$xv=L}),define(ke[6],Se([1,0,68]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$xK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var g;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(u){return u._id=P.a++,u}}e.$xK=P;var $;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var S;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var D;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$yK={MainThreadAuthentication:(0,I.$vv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$vv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$vv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.$vv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$vv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$vv)("MainThreadClipboard"),MainThreadCommands:(0,I.$vv)("MainThreadCommands"),MainThreadComments:(0,I.$vv)("MainThreadComments"),MainThreadConfiguration:(0,I.$vv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$vv)("MainThreadConsole"),MainThreadDebugService:(0,I.$vv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$vv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$vv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$vv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$vv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$vv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$vv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$vv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$vv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$vv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$vv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$vv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$vv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$vv)("MainThreadLanguages"),MainThreadLogger:(0,I.$vv)("MainThreadLogger"),MainThreadMessageService:(0,I.$vv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$vv)("MainThreadOutputService"),MainThreadProgress:(0,I.$vv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$vv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$vv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$vv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$vv)("MainThreadSecretState"),MainThreadStorage:(0,I.$vv)("MainThreadStorage"),MainThreadSpeech:(0,I.$vv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$vv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$vv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$vv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$vv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$vv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$vv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$vv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$vv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$vv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$vv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$vv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$vv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$vv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$vv)("MainThreadSCM"),MainThreadSearch:(0,I.$vv)("MainThreadSearch"),MainThreadShare:(0,I.$vv)("MainThreadShare"),MainThreadTask:(0,I.$vv)("MainThreadTask"),MainThreadWindow:(0,I.$vv)("MainThreadWindow"),MainThreadLabelService:(0,I.$vv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$vv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$vv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$vv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$vv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$vv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$vv)("MainThreadInteractive"),MainThreadChat:(0,I.$vv)("MainThreadChat"),MainThreadInlineChat:(0,I.$vv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$vv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$vv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$vv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$vv)("MainThreadTimeline"),MainThreadTesting:(0,I.$vv)("MainThreadTesting"),MainThreadLocalization:(0,I.$vv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$vv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$vv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$vv)("MainThreadIssueReporter")},e.$zK={ExtHostCommands:(0,I.$vv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$vv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$vv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$vv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$vv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$vv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$vv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$vv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$vv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$vv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$vv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$vv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$vv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$vv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$vv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$vv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$vv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$vv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$vv)("ExtHostStatusBar"),ExtHostShare:(0,I.$vv)("ExtHostShare"),ExtHostExtensionService:(0,I.$vv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$vv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$vv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$vv)("ExtHostSCM"),ExtHostSearch:(0,I.$vv)("ExtHostSearch"),ExtHostTask:(0,I.$vv)("ExtHostTask"),ExtHostWorkspace:(0,I.$vv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$vv)("ExtHostWindow"),ExtHostWebviews:(0,I.$vv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$vv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$vv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$vv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$vv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$vv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$vv)("ExtHostProgress"),ExtHostComments:(0,I.$vv)("ExtHostComments"),ExtHostSecretState:(0,I.$vv)("ExtHostSecretState"),ExtHostStorage:(0,I.$vv)("ExtHostStorage"),ExtHostUrls:(0,I.$vv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$vv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$vv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$vv)("ExtHostOutputService"),ExtHosLabelService:(0,I.$vv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$vv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$vv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$vv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$vv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$vv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$vv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$vv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$vv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$vv)("ExtHostChat"),ExtHostChatAgents2:(0,I.$vv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$vv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$vv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$vv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$vv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$vv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$vv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$vv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$vv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$vv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$vv)("ExtHostTimeline"),ExtHostTesting:(0,I.$vv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$vv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$vv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$vv)("ExtHostIssueReporter")}}),define(ke[305],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(I.$yK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,y){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(L);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(b,y)??[]}getRelatedInformation(L,b,y){return this.c.$getAiRelatedInformation(b,y)}registerRelatedInformationProvider(L,b,y){const g=this.b;return this.b++,this.a.set(g,y),this.c.$registerAiRelatedInformationProvider(g,b),new F.$AK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Bdc=f}),define(ke[91],Se([1,0,5,14,6,20]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,I.$Vh)("IExtHostApiDeprecationService");let L=class{constructor(y,g){this.c=g,this.a=new Set,this.b=y.getProxy(f.$yK.MainThreadTelemetry)}report(y,g,A){const P=this.d(y,g);this.a.has(P)||(this.a.add(P),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:y}))}d(y,g){return`${y}-${g.identifier.value}`}};e.$Idc=L,e.$Idc=L=He([Be(0,R.$AM),Be(1,F.$dj)],L),e.$Jdc=Object.freeze(new class{report(b,y,g){}})}),define(ke[306],Se([1,0,4,6,7,26]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class L{constructor(g){this.b=new Map,this.c=[],this.d=new I.$Rd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=g.getProxy(F.$yK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,P,$={}){const S=R.$_l.toKey(g.identifier),D=[...P].sort().join(" ");return await this.f.getOrCreate(`${S} ${A} ${D}`,async()=>{await this.a.$ensureProvider(A);const w=g.displayName||g.name;return this.a.$getSession(A,P,S,w,$)})}async getSessions(g,A,P){const $=R.$_l.toKey(g.identifier),S=[...P].sort().join(" ");return await this.g.getOrCreate(`${$} ${S}`,async()=>{await this.a.$ensureProvider(A);const D=g.displayName||g.name;return this.a.$getSessions(A,P,$,D)})}async removeSession(g,A){const P=this.b.get(g);return P?P.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,P,$){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:P,options:$??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===g)||this.c.push({id:g,label:A});const S=P.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(g,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,$?.supportsMultipleAccounts??!1),new f.$AK(()=>{S.dispose(),this.b.delete(g);const D=this.c.findIndex(w=>w.id===g);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,P){const $=this.b.get(g);if($)return Promise.resolve($.provider.createSession(A,P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Mdc=L;class b{constructor(){this.a=new Map}getOrCreate(g,A){const P=this.a.get(g);if(P)return P;const $=A().finally(()=>this.a.delete(g));return this.a.set(g,$),$}}}),define(ke[307],Se([1,0,6,20,15]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let R=class{constructor(b,y){this.a=b.getProxy(I.$yK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>y.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,y,g){const A=f.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Ndc=R,e.$Ndc=R=He([Be(0,F.$AM)],R)}),define(ke[308],Se([1,0,4,51,3,6,15]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class b{static{this.a=0}constructor(A,P){this.extension=A,this.provider=P,this.handle=b.a++}}class y{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new I.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(R.$yK.MainThreadChat)}registerChatProvider(A,P,$){const S=new b(A,$);return this.b.set(S.handle,S),this.e.$registerChatProvider(S.handle,P),(0,f.$Pc)(()=>{this.e.$unregisterChatProvider(S.handle),this.b.delete(S.handle)})}transferChatSession(A,P){const $=F.Iterable.find(this.c.keys(),S=>this.c.get(S)===A)??0;typeof $=="number"&&this.e.$transferChatSession($,P)}sendInteractiveRequestToProvider(A,P){this.e.$sendRequestToProvider(A,P)}async $prepareChat(A,P){const $=this.b.get(A);if(!$)return;const S=await $.provider.prepareSession(P);if(!S)return;const D=y.a++;return this.c.set(D,S),{id:D,requesterUsername:S.requester?.name,requesterAvatarIconUri:S.requester?.icon,responderUsername:S.responder?.name,responderAvatarIconUri:S.responder?.icon,inputPlaceholder:S.inputPlaceholder}}async $provideWelcomeMessage(A,P){const $=this.b.get(A);if(!$||!$.provider.provideWelcomeMessage)return;const S=await $.provider.provideWelcomeMessage(P);if(S)return S.map(D=>typeof D=="string"?D:Array.isArray(D)?D.map(w=>L.ChatReplyFollowup.from(w)):L.MarkdownString.from(D))}async $provideSampleQuestions(A,P){const $=this.b.get(A);if(!$||!$.provider.provideSampleQuestions)return;const S=await $.provider.provideSampleQuestions(P);if(S)return S?.map(D=>L.ChatReplyFollowup.from(D))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$Odc=y}),define(ke[309],Se([1,0,11,21,43,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class u{static{this.a=0}constructor(n,r,a){this.i=r,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(P.$yK.MainThreadChatAgents2)}createChatAgent(n,r,a){const t=u.a++,s=new o(n,r,this.d,t,a);return this.b.set(t,s),this.d.$registerAgent(t,r,{}),s.apiAgent}async $invokeAgent(n,r,a,t,s,d){this.g.delete(r);const c=this.b.get(n);if(!c)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let l=!1;function h(){if(l)throw new Error("Only valid while executing the command")}const k=new I.$ih;d.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(c.extension.identifier,k.p);const C=t.command?await c.validateSlashCommand(t.command):void 0,m=L.$Nd.create(!1);let p;try{const v=c.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:C},{history:s.history.map($.ChatMessage.to)},new A.$_u(E=>{h(),typeof p>"u"&&"content"in E&&(p=m.elapsed());const N=$.ChatResponseProgress.from(c.extension,E);if("placeholder"in E&&"resolvedContent"in E){const z=Promise.all([this.d.$handleProgressChunk(a,N),E.resolvedContent]);(0,I.$Mg)(z,d).then(M=>{if(!M)return;const[T,j]=M;this.d.$handleProgressChunk(a,j,T??void 0)})}else this.d.$handleProgressChunk(a,N)}),d);return await(0,I.$Mg)(Promise.resolve(v).then(E=>{if(E){this.g.set(r,E);let N=this.h.get(r);N||(N=new Map,this.h.set(r,N)),N.set(a,E);const z={firstProgress:p,totalElapsed:m.elapsed()};return{errorDetails:E.errorDetails,timings:z}}else this.g.delete(r)}),d)}catch(v){return this.j.error(v,c.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,f.$Gi)(v)),responseIsIncomplete:!0}}}finally{l=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,r){const a=this.b.get(n);return a?a.provideSlashCommand(r):[]}$provideFollowups(n,r,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const s=this.g.get(r);return s?t.provideFollowups(s,a):Promise.resolve([])}$acceptFeedback(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);if(!d)return;let c;switch(t){case D.InteractiveSessionVoteDirection.Down:c=S.ChatAgentResultFeedbackKind.Unhelpful;break;case D.InteractiveSessionVoteDirection.Up:c=S.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:d,kind:c}))}$acceptAction(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);d&&t.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$Qdc=u;class o{constructor(n,r,a,t,s){this.extension=n,this.r=r,this.s=a,this.t=t,this.u=s,this.o=new R.$Rd,this.q=new R.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,b.$Mf)(this.b));const r=this.b.find(a=>a.name===n);if(!r)throw new Error(`Unknown slashCommand: ${n}`);return r}async provideSlashCommand(n){if(!this.a)return[];const r=await this.a.provideSlashCommands(n);return r?(this.b=r,r.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,r){if(!this.d)return[];const a=await this.d.provideFollowups(n,r);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,r=!1;const a=()=>{n||r||(r=!0,queueMicrotask(()=>{this.s.$updateAgent(this.t,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof y.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof S.$uL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m}),r=!1}))},t=this;return{get name(){return t.r},get description(){return t.g??""},set description(s){t.g=s,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(s){t.h=s,a()},get iconPath(){return t.i},set iconPath(s){t.i=s,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(s){t.a=s,a()},get followupProvider(){return t.d},set followupProvider(s){t.d=s,a()},get isDefault(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.j},set isDefault(s){(0,w.$NF)(t.extension,"defaultChatAgent"),t.j=s,a()},get helpTextPrefix(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(s){if((0,w.$NF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=s,a()},get helpTextPostfix(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(s){if((0,w.$NF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=s,a()},get isSecondary(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(s){(0,w.$NF)(t.extension,"defaultChatAgent"),t.n=s,a()},get sampleRequest(){return t.m},set sampleRequest(s){t.m=s,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,w.$MF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.s.$unregisterAgent(t.t)}}}invoke(n,r,a,t){return this.u(n,r,a,t)}}}),define(ke[310],Se([1,0,21,3,6,15,85,26,11,4]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class A{constructor(D,w){this.stream=new y.$mh,this.stream=w??new y.$mh;const u=this;this.apiObj={option:D,response:u.stream.asyncIterable}}}class P{constructor(D,w){this.a=new g.$Rd,this.b=new Map,this.c=new y.$mh,this.d=!1;const u=this;this.apiObject={result:D,response:u.c.asyncIterable,onDidStartResponseStream:u.a.event,cancel(){w.cancel()}},D.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(D){if(this.d)return;let w=this.b.get(D.index);w||(this.b.size===0?w=new A(D.index,this.c):w=new A(D.index),this.b.set(D.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(D.part)}}class ${static{this.a=1}constructor(D,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new b.$bm,this.b=D.getProxy(f.$yK.MainThreadChatProvider)}registerProvider(D,w,u,o){const i=$.a++;return this.c.set(i,{extension:D,provider:u}),this.b.$registerProvider(i,w,{extension:D,displayName:o.name??D.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(D,w,u,o,i){const n=this.c.get(D);if(!n)return;const r=new L.$_u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(u.map(R.ChatMessage.to),o,r,i)}allowListExtensionWhile(D,w){this.f.set(D,w),w.finally(()=>this.f.delete(D))}async requestChatResponseProvider(D,w){if(!this.f.has(D))throw new Error("Extension is NOT allowed to make chat requests");const u=this;return{get isRevoked(){return!u.f.has(D)},makeRequest(o,i,n){if(!u.f.has(D))throw new Error("Access to chat has been revoked");const r=new I.$2d(n),a=Math.random()*1e6|0,t=u.b.$fetchResponse(D,w,a,o.map(R.ChatMessage.from),i??{},r.token),s=new P(t,r);return u.e.set(a,{res:s}),t.finally(()=>{u.e.delete(a)}),s.apiObject}}}async $handleResponseFragment(D,w){const u=this.e.get(D);u&&u.res.handleFragment(w)}}e.$Pdc=$}),define(ke[311],Se([1,0,3,6,8,15]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class L{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(F.$yK.MainThreadChatVariables)}async $resolveVariable(y,g,A){const P=this.b.get(y);if(P)try{const $=await P.resolver.resolve(P.data.name,{message:g},A);if($)return $.map(R.ChatVariable.from)}catch($){(0,f.$1)($)}}registerVariableResolver(y,g,A,P){const $=L.a++;return this.b.set($,{extension:y.identifier,data:{name:g,description:A},resolver:P}),this.c.$registerVariable($,{name:g,description:A}),(0,I.$Pc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$Rdc=L}),define(ke[312],Se([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class F{constructor(R){const L=R.getProxy(I.$yK.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$Sdc=F}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,53,2,3,5,20,149,22,68,43,38,87,90]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=void 0;let s=class{#e;#t;#i;constructor(C,m,p){this.b=new Map,this.c=new Map,this.#e=C.getProxy(L.$yK.MainThreadCommands),this.d=m,this.#i=p,this.#t=C.getProxy(L.$yK.MainThreadTelemetry),this.converter=new d(this,v=>{const E=this.c.get(v);return E?.result===l.Void?E:void 0},m),this.f=[{processArgument(v){return(0,g.$sh)(v)}},{processArgument(v){return(0,R.$cn)(v,function(E){if(A.$As.isIRange(E))return f.Range.to(E);if(P.$zs.isIPosition(E))return f.Position.to(E);if(A.$As.isIRange(E.range)&&$.URI.isUri(E.uri))return f.location.to(E);if(E instanceof o.$fe)return E.buffer.buffer;if(!Array.isArray(E))return E})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const m=this.registerCommand(!1,C.id,async(...p)=>{const v=C.args.map((N,z)=>{if(!N.validate(p[z]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof p[z]=="object"?JSON.stringify(p[z],null,"	"):p[z]} `);return N.convert(p[z])}),E=await this.executeCommand(C.internalId,...v);return C.result.convert(E,p,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new F.$AK(()=>{m.dispose(),this.c.delete(C.id)})}registerCommand(C,m,p,v,E,N){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:p,thisArg:v,metadata:E,extension:N}),C&&this.#e.$registerCommand(m),new F.$AK(()=>{this.b.delete(m)&&C&&this.#e.$unregisterCommand(m)})}executeCommand(C,...m){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,m,!0)}async g(C,m,p){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,m,!1);{let v=!1;const E=(0,R.$cn)(m,function(N){if(N instanceof F.$BK)return f.Position.from(N);if(N instanceof F.$CK)return f.Range.from(N);if(N instanceof F.$MK)return f.location.from(N);if(F.$XL.isNotebookRange(N))return f.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,o.$fe.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,o.$fe.wrap(N);if(N instanceof o.$fe)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,v?new i.$xv(E):E,p);return(0,g.$sh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,m,!1);throw N}}}async h(C,m,p){const v=this.b.get(C);if(!v)throw new Error("Unknown command");const{callback:E,thisArg:N,metadata:z}=v;if(z?.args)for(let T=0;T<z.args.length;T++)try{(0,I.$Tf)(m[T],z.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${z.args[T].name}' - ${z.args[T].description}`)}const M=r.$Nd.create();try{return await E.apply(N,m)}catch(T){if(C===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...m);j&&(C=j.command)}if(this.d.error(T,C,v.extension?.identifier),!p)throw T;if(v.extension?.identifier){const j=this.#i.onExtensionError(v.extension.identifier,T);this.d.trace("forwarded error to extension?",j,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Gi)(T)),this.id=C,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,C,M.elapsed())}}j(C,m,p){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new a.$po(m),duration:p})}$executeContributedCommand(C,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const p=this.b.get(C);return p?(m=m.map(v=>this.f.reduce((E,N)=>N.processArgument(E,p.extension?.identifier),v)),this.h(C,m,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(m=>(C&&(m=m.filter(p=>p[0]!=="_")),m))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[m,p]of this.b){const{metadata:v}=p;v&&(C[m]=v)}return Promise.resolve(C)}};e.$VM=s,e.$VM=s=He([Be(0,w.$AM),Be(1,y.$dj),Be(2,t.$UM)],s),e.$WM=(0,D.$Vh)("IExtHostCommands");class d{constructor(C,m,p){this.d=C,this.f=m,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,m){if(!C)return;const p={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return p;const v=this.f(C.command);if(v)p.id=v.internalId,p.arguments=v.args.map((E,N)=>E.convert(C.arguments&&C.arguments[N]));else if((0,b.$Kb)(C.arguments)){const E=`${C.command} /${++this.c}`;this.b.set(E,C),m.add((0,S.$Pc)(()=>{this.b.delete(E),this.g.trace("CommandsConverter#DISPOSE",E)})),p.$ident=E,p.id=this.delegatingCommandId,p.arguments=[E],this.g.trace("CommandsConverter#CREATE",C.command,E)}return p}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const m=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$XM=d;class c{static{this.Uri=new c("uri","Uri of a text document",C=>$.URI.isUri(C),C=>C)}static{this.Position=new c("position","A position in a text document",C=>F.$BK.isPosition(C),f.Position.from)}static{this.Range=new c("range","A range in a text document",C=>F.$CK.isRange(C),f.Range.from)}static{this.Selection=new c("selection","A selection in a text document",C=>F.$DK.isSelection(C),f.Selection.from)}static{this.Number=new c("number","",C=>typeof C=="number",C=>C)}static{this.String=new c("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=c.Arr(c.String)}static Arr(C){return new c(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,m=>Array.isArray(m)&&m.every(p=>C.validate(p)),m=>m.map(p=>C.convert(p)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",C=>C instanceof F.$WK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",C=>C instanceof F.$eM,f.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",C=>C instanceof u.$NM,f.TestItem.from)}constructor(C,m,p,v){this.name=C,this.description=m,this.validate=p,this.convert=v}optional(){return new c(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,m){return new c(C??this.name,m??this.description,this.validate,this.convert)}}e.$YM=c;class l{static{this.Void=new l("no result",C=>C)}constructor(C,m){this.description=C,this.convert=m}}e.$ZM=l;class h{constructor(C,m,p,v,E){this.id=C,this.internalId=m,this.description=p,this.args=v,this.result=E}}e.$1M=h}),define(ke[313],Se([1,0,19,17,2,83,132,45,137,35,15,7]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;const $=[new g.$1M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of DocumentHighlight-instances.",D(A.DocumentHighlight.to))),new g.$1M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$YM.Uri],new g.$ZM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,o)=>{if((0,I.$Jb)(u))return;class i extends P.$RK{static to(r){const a=new i(r.name,A.SymbolKind.to(r.kind),r.containerName||"",new P.$MK(o[0],A.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=A.Range.to(r.selectionRange),a.children=r.children?r.children.map(i.to):[],a}}return u.map(i.to)})),new g.$1M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$YM.Uri,new g.$YM("options","Formatting options",u=>!0,u=>u)],new g.$ZM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new g.$1M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$YM.Uri,g.$YM.Range,new g.$YM("options","Formatting options",u=>!0,u=>u)],new g.$ZM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new g.$1M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$YM.Uri,g.$YM.Position,new g.$YM("ch","Trigger character",u=>typeof u=="string",u=>u),new g.$YM("options","Formatting options",u=>!0,u=>u)],new g.$ZM("A promise that resolves to an array of TextEdits.",D(A.TextEdit.to))),new g.$1M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$1M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$1M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$1M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$1M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Location-instances.",D(A.location.to))),new g.$1M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of Hover-instances.",D(A.Hover.to))),new g.$1M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$YM.Uri,new g.$YM("position","A position in a text document",u=>Array.isArray(u)&&u.every(o=>P.$BK.isPosition(o)),u=>u.map(A.Position.from))],new g.$ZM("A promise that resolves to an array of ranges.",u=>u.map(o=>{let i;for(const n of o.reverse())i=new P.$VK(A.Range.to(n),i);return i}))),new g.$1M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$YM.String.with("query","Search string")],new g.$ZM("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(A.WorkspaceSymbol.to))),new g.$1M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(A.CallHierarchyItem.to))),new g.$1M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$YM.CallHierarchyItem],new g.$ZM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(A.CallHierarchyIncomingCall.to))),new g.$1M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$YM.CallHierarchyItem],new g.$ZM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(A.CallHierarchyOutgoingCall.to))),new g.$1M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:A.Range.to(u.range),placeholder:u.text}})),new g.$1M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$YM.Uri,g.$YM.Position,g.$YM.String.with("newName","The new symbol name")],new g.$ZM("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return A.WorkspaceEdit.to(u)}})),new g.$1M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$YM.Uri,g.$YM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$ZM("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(A.DocumentLink.to))),new g.$1M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$YM.Uri],new g.$ZM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new P.$PL(u.tokenTypes,u.tokenModifiers)})),new g.$1M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$YM.Uri],new g.$ZM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,L.$E$)(u);if(o.type==="full")return new P.$RL(o.data,void 0)})),new g.$1M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$YM.Uri,g.$YM.Range.optional()],new g.$ZM("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new P.$PL(u.tokenTypes,u.tokenModifiers)})),new g.$1M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$YM.Uri,g.$YM.Range],new g.$ZM("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const o=(0,L.$E$)(u);if(o.type==="full")return new P.$RL(o.data,void 0)})),new g.$1M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$YM.Uri,g.$YM.Position,g.$YM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$YM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$ZM("A promise that resolves to a CompletionList-instance.",(u,o,i)=>{if(!u)return new P.$8K([]);const n=u.suggestions.map(r=>A.CompletionItem.to(r,i));return new P.$8K(n,u.incomplete)})),new g.$1M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$YM.Uri,g.$YM.Position,g.$YM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$ZM("A promise that resolves to SignatureHelp.",u=>{if(u)return A.SignatureHelp.to(u)})),new g.$1M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$YM.Uri,g.$YM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$ZM("A promise that resolves to an array of CodeLens-instances.",(u,o,i)=>D(n=>new P.$ZK(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(u))),new g.$1M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$YM.Uri,new g.$YM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>P.$CK.isRange(u),u=>P.$DK.isSelection(u)?A.Selection.from(u):A.Range.from(u)),g.$YM.String.with("kind","Code action kind to return code actions for").optional(),g.$YM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$ZM("A promise that resolves to an array of Command-instances.",(u,o,i)=>D(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const r=new P.$TK(n.title,n.kind?new P.$UK(n.kind):void 0);return n.edit&&(r.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(r.command=i.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(u))),new g.$1M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$YM.Uri],new g.$ZM("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(o=>new P.$bL(A.Range.to(o.range),A.Color.to(o.color))):[])),new g.$1M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$YM("color","The color to show and insert",u=>u instanceof P.$aL,A.Color.from),new g.$YM("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:A.Range.from(u.range)}))],new g.$ZM("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(A.ColorPresentation.to):[])),new g.$1M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$YM.Uri,g.$YM.Range],new g.$ZM("A promise that resolves to an array of Inlay objects",(u,o,i)=>u.map(A.InlayHint.to.bind(void 0,i)))),new g.$1M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$YM.Uri],new g.$ZM("A promise that resolves to an array of FoldingRange objects",(u,o)=>{if(u)return u.map(A.FoldingRange.to)})),new g.$1M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$ZM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(o=>A.NotebookExclusiveDocumentPattern.to(o))})))),new g.$1M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$YM.Uri,g.$YM.Range,new g.$YM("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof P.$CK,u=>A.InlineValueContext.from(u))],new g.$ZM("A promise that resolves to an array of InlineValue objects",u=>u.map(A.InlineValue.to))),new g.$1M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$YM("uriOrString","Uri-instance or string (only http/https)",u=>f.URI.isUri(u)||typeof u=="string"&&(0,y.$OU)(u,F.Schemas.http,F.Schemas.https),u=>u),new g.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional(),g.$YM.String.with("label","").optional()],g.$ZM.Void),new g.$1M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$YM.Uri.with("resource","Resource to open"),g.$YM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[A.ViewColumn.from(u),void 0]:[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)])).optional()],g.$ZM.Void),new g.$1M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$YM.Uri.with("left","Left-hand side resource of the diff editor"),g.$YM.Uri.with("right","Right-hand side resource of the diff editor"),g.$YM.String.with("title","Human readable title for the diff editor").optional(),new g.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[A.ViewColumn.from(u.viewColumn),A.TextEditorOpenOptions.from(u)]).optional()],g.$ZM.Void),new g.$1M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$YM.String.with("title","Human readable title for the changes editor"),new g.$YM("resourceList","List of resources to compare",u=>{for(const o of u){if(o.length!==3)return!1;const[i,n,r]=o;if(!f.URI.isUri(i)||!f.URI.isUri(n)&&n!==void 0&&n!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},u=>u)],g.$ZM.Void),new g.$1M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$YM.Uri,g.$YM.Position],new g.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$1M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$YM.TypeHierarchyItem],new g.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$1M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$YM.TypeHierarchyItem],new g.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(A.TypeHierarchyItem.to))),new g.$1M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$YM.TestItem],g.$ZM.Void),new g.$1M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$YM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$ZM.Void),new g.$1M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$YM.String.with("name","The context key name"),new g.$YM("value","The context key value",()=>!0,u=>u)],g.$ZM.Void),new g.$1M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$YM.Uri,g.$YM.StringArray,new g.$YM("MappedEditsContext","Mapped Edits Context",u=>A.MappedEditsContext.is(u),u=>A.MappedEditsContext.from(u))],new g.$ZM("A promise that resolves to a workspace edit or null",u=>u?A.WorkspaceEdit.to(u):null))];class S{static register(o){$.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",b.$Ui)}}e.$Ldc=S;function D(u){return o=>{if(Array.isArray(o))return o.map(u)}}function w(u){if(!Array.isArray(u))return;const o=[];for(const i of u)R.$lt(i)?o.push(A.DefinitionLink.to(i)):o.push(A.location.to(i));return o}}),define(ke[314],Se([1,0,11,59,4,3,2,83,26,15,7,6,25]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;function S(D,w,u){const o=D.getProxy(P.$yK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new y.$bm,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const k=this.b.get(h.handle);return k?k.value:h}else if(h&&h.$mid===7){const k=this.b.get(h.commentControlHandle);if(!k)return h;const C=k.getCommentThread(h.commentThreadHandle);return C?C.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const C=k.getCommentThread(h.thread.commentThreadHandle);return C?h.$mid===8?C.value:{thread:C.value,text:h.text}:h}else if(h&&h.$mid===10){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const C=k.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const m=h.commentUniqueId,p=C.getCommentByUniqueId(m);return p||h}else if(h&&h.$mid===11){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const C=k.getCommentThread(h.thread.commentThreadHandle);if(!C)return h;const m=h.text,p=h.commentUniqueId,v=C.getCommentByUniqueId(p);return v?(typeof v.body=="string"?v.body=m:v.body=new A.$1K(m),v):h}return h}})}createCommentController(h,k,C){const m=i.a++,p=new r(h,m,k,C);this.b.set(p.handle,p);const v=this.c.get(h.identifier)||[];return v.push(p),this.c.set(h.identifier,v),p.value}async $createCommentThreadTemplate(h,k,C){const m=this.b.get(h);m&&m.$createCommentThreadTemplate(k,C)}async $updateCommentThreadTemplate(h,k,C){const m=this.b.get(h);m&&m.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(h,k){this.b.get(h)?.$deleteCommentThread(k)}$provideCommentingRanges(h,k,C){const m=this.b.get(h);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const p=u.getDocument(L.URI.revive(k));return(0,I.$Qg)(async()=>{const v=await m.commentingRangeProvider.provideCommentingRanges(p,C);let E;return Array.isArray(v)?E={ranges:v,fileComments:!1}:v?E={ranges:v.ranges||[],fileComments:v.fileComments||!1}:E=v??void 0,E}).then(v=>{let E;return v&&(E={ranges:v.ranges.map(N=>g.Range.from(N)),fileComments:v.fileComments}),E})}$toggleReaction(h,k,C,m,p){const v=this.b.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,I.$Qg)(()=>{const E=v.getCommentThread(k);if(E){const N=E.getCommentByUniqueId(m.uniqueIdInThread);if(v!==void 0&&N&&v.reactionHandler)return v.reactionHandler(N,s(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,k,C,m,p,v,E,N){this.m=k,this.n=C,this.o=m,this.p=p,this.q=v,this.extensionDescription=E,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Sc,this.l.value=new R.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(k,this.handle,this.n,this.o,g.Range.from(this.p),E.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{o.$deleteCommentThread(k,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(M){z.range=M},get comments(){return z.comments},set comments(M){z.comments=M},get collapsibleState(){return z.collapsibleState},set collapsibleState(M){z.collapsibleState=M},get canReply(){return z.canReply},set canReply(M){z.canReply=M},get contextValue(){return z.contextValue},set contextValue(M){z.contextValue=M},get label(){return z.label},set label(M){z.label=M},get state(){return z.state},set state(M){z.state=M},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Qc);const h=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};h("range")&&(k.range=g.Range.from(this.p)),h("label")&&(k.label=this.label),h("contextValue")&&(k.contextValue=this.contextValue??null),h("comments")&&(k.comments=this.q.map(C=>a(this,C,this.k,this.extensionDescription))),h("collapsibleState")&&(k.collapseState=d(this.g)),h("canReply")&&(k.canReply=this.canReply),h("state")&&(k.state=c(this.h)),h("isTemplate")&&(k.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(h){for(const k of this.k){const C=k[0],m=k[1];if(h===m)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$oh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,k,C,m){this.f=h,this.g=k,this.h=C,this.i=m,this.a=new Map,o.$registerCommentController(this.handle,C,m,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(v){p.options=v},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(v){p.commentingRangeProvider=v},get reactionHandler(){return p.reactionHandler},set reactionHandler(v){p.reactionHandler=v},createCommentThread(v,E,N){return p.createCommentThread(v,E,N).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,k,C){k===void 0&&(0,$.$NF)(this.f,"fileComments");const m=new n(this.id,this.handle,void 0,h,k,C,this.f,!1);return this.a.set(m.handle,m),m}$createCommentThreadTemplate(h,k){const C=new n(this.id,this.handle,void 0,L.URI.revive(h),g.Range.to(k),[],this.f,!0);return C.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(h,k){const C=this.a.get(h);C&&(C.range=g.Range.to(k))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(l,h,k,C){let m=k.get(h);return m||(m=++l.commentHandle,k.set(h,m)),h.state!==void 0&&(0,$.$NF)(C,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:m,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?g.$zM(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function s(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?L.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(l){if(l!==void 0)switch(l){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$Vdc=S}),define(ke[315],Se([1,0,24,6,27,20]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let L=class{constructor(A,P){this.a=A.getProxy(F.$yK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,P){const $=this,S=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,P,S,arguments)}})}e(A,P,$,S){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(S,this.b)}),this.c&&this.f(A,$,S)}};e.$Jfc=L,e.$Jfc=L=He([Be(0,R.$AM),Be(1,f.$QM)],L);const b=1e5;function y(g,A){const P=[];if(g.length)for(let $=0;$<g.length;$++){let S=g[$];if(typeof S>"u")S="undefined";else if(S instanceof Error){const D=S;D.stack?S=D.stack:S=D.toString()}P.push(S)}if(A){const $=new Error().stack;$&&P.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,I.$fn)(P);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=void 0;let S=class{static{$=this}static{this.c=0}static{this.d=250}constructor(w,u){this.h=u,this.f=new Map,this.g=w.getProxy(F.$yK.MainThreadDecorations)}registerFileDecorationProvider(w,u){const o=$.c++;this.f.set(o,{provider:w,extensionDescription:u}),this.g.$registerDecorationProvider(o,u.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,y.$2b)(n);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,r.length);const a=r.map(d=>({uri:d,rank:(0,g.$Ke)(d.path,"/")})),t=(0,y.$yb)(a,(d,c)=>d.rank-c.rank||(0,g.$Ye)(d.uri.path,c.uri.path)),s=[];e:for(const d of t){let c;for(const l of d){const h=(0,A.$lc)(l.uri.path);if(c!==h&&(c=h,s.push(l.uri)>=$.d))break e}}this.g.$onDidChange(o,s)});return new f.$AK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(w,u,o){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(w);return await Promise.all(u.map(async a=>{try{const{uri:t,id:s}=a,d=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),o));if(!d)return;try{f.$VL.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$NF)(r,"codiconDecoration"),i[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(c){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),i}};e.$Lec=S,e.$Lec=S=$=He([Be(0,L.$AM),Be(1,b.$dj)],S),e.$Mec=(0,R.$Vh)("IExtHostDecorations")}),define(ke[316],Se([1,0,211,136,2,6,7,15,4,14,28,57]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;class S{#e;#t;#i;constructor(u,o,i,n,r,a,t,s){this.d=u,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,o){if(!u){this.clear();return}this.j();let i=[];if(f.URI.isUri(u)){if(!o){this.delete(u);return}this.#i.set(u,o.slice()),i=[u]}else if(Array.isArray(u)){i=[];let a;u=[...u].sort(S.k);for(const t of u){const[s,d]=t;if((!a||s.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=s,i.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const c=this.#i.get(s);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const s=this.#i.get(a);if(s)if(s.length>this.g){t=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const l of s)if(l.severity===d[c]&&t.push({...b.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,o){this.j();for(const[i,n]of this)u.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const o=this.#i.get(u);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,o){return u[0].toString()<o[0].toString()?-1:u[0].toString()>o[0].toString()?1:0}}e.$Fdc=S;let D=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(u){const o=new A.$zc;for(const i of u)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(u,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new y.$Vd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.h.event,$._mapper),this.f=u.getProxy(R.$yK.MainThreadDiagnostics)}createDiagnosticCollection(u,o){const{g:i,f:n,h:r,j:a,k:t,l:s}=this,d=new class{$changeMany(h,k){n.$changeMany(h,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,h,k.length===0?"CLEARING":k)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,h)}dispose(){n.dispose()}};let c;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,c=o;else if(!i.has(o))c=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do c=o+$.c++;while(i.has(c))}return new class extends S{constructor(){super(o,c,$.e,$.d,h=>s.getDocument(h)?.version,t.extUri,d,r),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(u){if(u)return this.m(u);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(u){let o=[];for(const i of this.g.values())i.has(u)&&(o=o.concat(i.get(u)));return o}$acceptMarkersChange(u){if(!this.n){const o="_generated_mirror",i=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of u)this.n.set(f.URI.revive(o),i.map(b.Diagnostic.to))}};e.$Gdc=D,e.$Gdc=D=$=He([Be(1,g.$dj),Be(2,P.$Edc)],D)}),define(ke[317],Se([1,0,2,6,25]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class R{constructor(b){this.a=b.getProxy(F.$yK.MainThreadDialogs)}showOpenDialog(b,y){return y?.allowUIResources&&(0,f.$NF)(b,"showLocal"),this.a.$showOpenDialog(y).then(g=>g?g.map(A=>I.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(y=>y?I.URI.revive(y):void 0)}}e.$Nec=R}),define(ke[318],Se([1,0,8,2,7,6,17,21,13]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class g{static{this.a=0}constructor(P,$,S){this.d=$,this.e=S,this.b=new Map,this.c=P.getProxy(R.$yK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,$){if(Object.keys(L.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const S=g.a++;this.b.set(S,$),this.c.$registerTextContentProvider(S,P);let D;return typeof $.onDidChange=="function"&&(D=$.onDidChange(w=>{if(w.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(S,w).then(u=>{if(!u&&typeof u!="string")return;const o=this.d.getDocument(w);if(!o)return;const i=(0,y.$Te)(u);if(!o.equalLines(i))return this.c.$onVirtualDocumentChange(w,u)},I.$Z)})),new f.$AK(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(P,$){const S=this.b.get(P);return S?Promise.resolve(S.provideTextDocumentContent(F.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$Oec=g}),define(ke[319],Se([1,0,4,3,2,6,143,15,18,24,7,8]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class ${constructor(D,w){this.a=new I.$Rd({onListenerError:P.$1}),this.b=new I.$Rd({onListenerError:P.$1}),this.c=new I.$Rd({onListenerError:P.$1}),this.d=new I.$Rd({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=D.getProxy(R.$yK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(u=>{for(const o of u)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const o of u)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const w=this.g.getDocument(D);if(w)return w}getDocument(D){const w=this.getDocumentData(D);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return w.document}ensureDocumentData(D){const w=this.g.getDocument(D);if(w)return Promise.resolve(w);let u=this.h.get(D.toString());return u||(u=this.f.$tryOpenDocument(D).then(o=>{this.h.delete(D.toString());const i=f.URI.revive(o);return(0,y.$Nf)(this.g.getDocument(i))},o=>(this.h.delete(D.toString()),Promise.reject(o))),this.h.set(D.toString(),u)),u}createDocumentData(D){return this.f.$tryCreateDocument(D).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(D,w){const u=f.URI.revive(D),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(D){const w=f.URI.revive(D),u=this.g.getDocument(w);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(D,w){const u=f.URI.revive(D),o=this.g.getDocument(u);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,w,u){const o=f.URI.revive(D),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(u),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$bn)({document:i.document,contentChanges:w.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(D,w){(0,L.$CM)(D,w)}}e.$Cdc=$}),define(ke[69],Se([1,0,60,4,3,2,5,6,143,20,150,15,14,28,17,51,48]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new S.$zc,this.d=new F.$Rd,this.e=new F.$Rd,this.f=new F.$Rd,this.g=new F.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],s=[];if(r.removedDocuments)for(const d of r.removedDocuments){const c=R.URI.revive(d),l=this.c.get(c);l?.unref()&&(this.c.delete(c),a.push(l.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const c=R.URI.revive(d.uri);let l=this.c.get(c);if(l&&c.scheme!==D.Schemas.vscodeNotebookCell&&c.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);l||(l=new o(new y.$DM(this.h.getProxy(b.$yK.MainThreadDocuments),c,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(c,l),t.push(l.value)),l.ref()}if(r.removedEditors)for(const d of r.removedEditors){const c=this.b.get(d);this.b.delete(d),c&&s.push(c)}if(r.addedEditors)for(const d of r.addedEditors){const c=R.URI.revive(d.documentUri);I.ok(this.c.has(c),`document '${c}' does not exist`),I.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const l=this.c.get(c).value,h=new A.$JM(d.id,this.h.getProxy(b.$yK.MainThreadTextEditors),this.i,new u.$U(()=>l.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(k=>P.Range.to(k)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(I.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,f.$Mc)(a),(0,f.$Mc)(s),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return w.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$KM=i,e.$KM=i=He([Be(0,g.$AM),Be(1,$.$dj)],i),e.$LM=(0,L.$Vh)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0,e.$cec=(0,L.$Vh)("IExtHostEditorTabs");class P{constructor(u,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$fM(R.URI.revive(this.b.input.uri));case 2:return new A.$gM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$hM(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$iM(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$jM(this.b.input.viewType);case 4:return new A.$kM(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$lM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$mM;case 9:return new A.$nM(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$oM(this.b.input.providerId);default:return}}}class ${constructor(u,o){this.c=[],this.d="",this.b=u,this.e=o;for(const i of u.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,o={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return g.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(i=>i.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const i=new P(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,i),u.tabDto.isActive&&(this.d=i.tabId),i}else if(u.kind===1){const i=this.c.splice(u.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(u.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,i),i}const o=this.c.find(i=>i.tabId===u.tabDto.id);if(!o)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(u.tabDto),o}activeTabId(){return this.d}}let S=class{constructor(u){this.b=new F.$Rd,this.c=new F.$Rd,this.e=[],this.a=u.getProxy(b.$yK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,o={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(i=>i.apiObject))},get activeTabGroup(){const i=u.d;return(0,f.$Nf)(u.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?D(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(u){const o=new Set(this.e.map(d=>d.groupId)),i=new Set(u.map(d=>d.groupId)),n=(0,I.$K)(o,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=u.map(d=>{const c=new $(d,()=>this.d);return n.added.includes(c.groupId)?a.push(c.apiObject):t.push(c.apiObject),c});const s=(0,f.$Nf)(u.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(u){const o=this.e.find(i=>i.groupId===u.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const o=this.e.find(n=>n.groupId===u.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(u){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===u)return i}h(u){return this.e.find(o=>o.apiObject===u)}async i(u,o){const i=[];for(const n of u){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(u,o){const i=[];for(const n of u){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$dec=S,e.$dec=S=He([Be(0,y.$AM)],S);function D(w){return w.tabs!==void 0}}),define(ke[320],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(I.$yK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,y){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(L);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector(b,y);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,b,y){const g=this.b;return this.b++,this.a.set(g,y),this.c.$registerAiEmbeddingVectorProvider(b,g),new F.$AK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Qec=f}),define(ke[321],Se([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class ${constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const u=this.a.indexOf(w);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),u=[];let o,i,n=14,r=14;for(const a of w){let t=o?(0,y.$8e)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,u.push([i,a.toUpperCase().charCodeAt(t),r]),u.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}u.push([9,58,10]),u.push([10,47,12]),this.b=new b.$FZ(u)}}provideDocumentLinks(w){this.c();const u=[],o=b.$GZ.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of o){const n=L.DocumentLink.to(i);n.target&&u.push(n)}return u}}class S{constructor(w,u){this.i=u,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(F.$yK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,u,o,i={}){if(S.j(o),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(u),this.d.add(u),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$NF)(w,"fsChunks"),r+=4);let a;i.isReadonly&&(0,P.$$j)(i.isReadonly)&&((0,A.$NF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,u,r,a).catch(s=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${u}`),console.error(s)});const t=o.onDidChangeFile(s=>{const d=[];for(const c of s){const{uri:l,type:h}=c;if(l.scheme!==u)continue;let k;switch(h){case R.FileChangeType.Changed:k=0;break;case R.FileChangeType.Created:k=1;break;case R.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:l,type:k})}this.a.$onFileSystemChange(n,d)});return(0,f.$Pc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:u,ctime:o,mtime:i,size:n,permissions:r}=w;return{type:u,ctime:o,mtime:i,size:n,permissions:r}}$stat(w,u){return Promise.resolve(this.l(w).stat(I.URI.revive(u))).then(o=>S.k(o))}$readdir(w,u){return Promise.resolve(this.l(w).readDirectory(I.URI.revive(u)))}$readFile(w,u){return Promise.resolve(this.l(w).readFile(I.URI.revive(u))).then(o=>g.$fe.wrap(o))}$writeFile(w,u,o,i){return Promise.resolve(this.l(w).writeFile(I.URI.revive(u),o.buffer,i))}$delete(w,u,o){return Promise.resolve(this.l(w).delete(I.URI.revive(u),o))}$rename(w,u,o,i){return Promise.resolve(this.l(w).rename(I.URI.revive(u),I.URI.revive(o),i))}$copy(w,u,o,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(u),I.URI.revive(o),i))}$mkdir(w,u){return Promise.resolve(this.l(w).createDirectory(I.URI.revive(u)))}$watch(w,u,o,i){const n=this.l(w).watch(I.URI.revive(o),i);this.f.set(u,n)}$unwatch(w,u){const o=this.f.get(u);o&&(o.dispose(),this.f.delete(u))}$open(w,u,o){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(u),o))}$close(w,u){const o=this.l(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(u))}$read(w,u,o,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=g.$fe.alloc(i);return Promise.resolve(n.read(u,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(w,u,o,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(u,o,i.buffer,0,i.byteLength))}l(w){const u=this.c.get(w);if(!u){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return u}}e.$Rec=S}),define(ke[71],Se([1,0,6,31,7,22,5,20,57,3,11,23,17]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;let D=S=class{constructor(u,o){this.b=new Map,this.c=new A.$7g,this.a=u.getProxy(I.$yK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===F.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return S.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return S.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return S.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,R.$fe.wrap(r))}catch(a){return S.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return S.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return S.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return S.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(u,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await u.stat(i)).type&F.FileType.Directory))throw f.$NL.FileExists(`Unable to create folder '${i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(F.$uk(r)!==F.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await u.createDirectory(i)}catch(a){if(F.$uk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(u){if(u instanceof f.$NL)throw u;if(u instanceof F.$qk)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw f.$NL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$NL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$NL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$NL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$NL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$NL.Unavailable(u.message);default:throw new f.$NL(u.message,u.name)}if(!(u instanceof Error))throw new f.$NL(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw f.$NL.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw f.$NL.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw f.$NL.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw f.$NL.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw f.$NL.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw f.$NL.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw f.$NL.Unavailable(u.message);default:throw new f.$NL(u.message,u.name)}}addFileSystemProvider(u,o,i){return this.b.set(u,{impl:o,extUri:i?.isCaseSensitive?P.$pg:P.$rg,isReadonly:!!i?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??P.$pg}};e.$4dc=D,e.$4dc=D=S=He([Be(0,b.$AM),Be(1,y.$Edc)],D),e.$5dc=(0,L.$Vh)("IExtHostConsumerFileSystem")}),define(ke[322],Se([1,0,4,34,2,6,15,7,48]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,D,w,u,o,i){this.a=Math.random(),this.b=new I.$Rd,this.c=new I.$Rd,this.d=new I.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Cj)(o),r=typeof o=="string",a=i?.correlate,t=u(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(a&&typeof s.session>"u")){if(!i?.ignoreCreateEvents)for(const d of s.created){const c=f.URI.revive(d);n(c.fsPath)&&(!r||D.getWorkspaceFolder(c))&&this.b.fire(c)}if(!i?.ignoreChangeEvents)for(const d of s.changed){const c=f.URI.revive(d);n(c.fsPath)&&(!r||D.getWorkspaceFolder(c))&&this.c.fire(c)}if(!i?.ignoreDeleteEvents)for(const d of s.deleted){const c=f.URI.revive(d);n(c.fsPath)&&(!r||D.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$AK.from(this.i(S,w,o,i,i?.correlate),this.b,this.c,this.d,t)}i(S,D,w,u,o){const i=b.$AK.from();if(typeof w=="string")return i;const n=S.getProxy(R.$yK.MainThreadFileSystemEventService);let r=!1;return(w.pattern.includes(F.$yj)||w.pattern.includes(F.$zj))&&(r=!0),n.$watch(D.identifier.value,this.a,w.baseUri,{recursive:r,excludes:u?.excludes??[]},!!o),b.$AK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(S){this.a=S,this.session=this.a.session,this.b=new y.$U(()=>this.a.created.map(f.URI.revive)),this.c=new y.$U(()=>this.a.changed.map(f.URI.revive)),this.d=new y.$U(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(S,D,w){this.j=S,this.k=D,this.l=w,this.a=new I.$Rd,this.b=new I.$Rd,this.c=new I.$Rd,this.d=new I.$Rd,this.g=new I.$Td,this.h=new I.$Td,this.i=new I.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,D,w,u){return new g(this.j,S,D,this.a.event,L.GlobPattern.from(w),u)}$onFileEvent(S){this.a.fire(new A(S))}$onDidRunFileOperation(S,D){switch(S){case 2:this.b.fire(Object.freeze({files:D.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,D){return(w,u,o)=>{const i=function(r){w.call(u,r)};return i.extension=S,D.event(i,void 0,o)}}async $onWillRunFileOperation(S,D,w,u){switch(S){case 2:return await this.n(this.g,{files:D.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},w,u);case 1:return await this.n(this.i,{files:D.map(o=>f.URI.revive(o.target))},w,u);case 0:case 3:return await this.n(this.h,{files:D.map(o=>f.URI.revive(o.target))},w,u)}}async n(S,D,w,u){const o=new Set,i=[];if(await S.fireAsync(D,u,async(r,a)=>{const t=Date.now(),s=await Promise.resolve(r);s instanceof b.$KK&&(i.push([a.extension,s]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),u.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=L.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$Sec=P}),define(ke[323],Se([1,0,3,2,6,15,7,35,11]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class g{static{this.a=0}constructor(S,D){this.extension=S,this.provider=D,this.handle=g.a++}}class A{constructor(S){this.session=S,this.responses=[]}}class P{static{this.a=0}constructor(S,D,w,u){this.f=w,this.g=u,this.b=new Map,this.d=new Map,this.e=S.getProxy(f.$yK.MainThreadInlineChat),D.registerApiCommand(new b.$1M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$YM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?R.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?R.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?R.Position.from(o.position):void 0}})],b.$ZM.Void))}registerProvider(S,D,w){const u=new g(S,D);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,w.label,S.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,I.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(S,D,w,u){const o=this.b.get(S);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(D)),n=R.Selection.to(w),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},u);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new A(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(r.wholeRange),message:r.message}}async $provideResponse(S,D,w,u){const o=this.b.get(S);if(!o)return;const i=this.d.get(D.id);if(!i)return;const n={prompt:w.prompt,selection:R.Selection.to(w.selection),wholeRange:R.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let r=!1;const a={report:async l=>{if(!w.live&&l.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||u.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:l.message,edits:l.edits?.map(R.TextEdit.from),editsShouldBeInstant:l.editsShouldBeInstant,slashCommand:l.slashCommand?.command,markdownFragment:L.$1K.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,u));let s;try{s=await(0,y.$Mg)(t,u)}finally{r=!0}if(!s)return;const d=i.responses.push(s)-1,c={wholeRange:R.Range.from(s.wholeRange),placeholder:s.placeholder};if(P.h(s)){const{edits:l,contents:h}=s,k=h!==void 0?R.MarkdownString.from(h):void 0;return l instanceof L.$KK?{...c,id:d,type:"bulkEdit",edits:R.WorkspaceEdit.from(l),message:k}:{...c,id:d,type:"editorEdit",edits:l.map(R.TextEdit.from),message:k}}return{...c,id:d,type:"message",message:R.MarkdownString.from(s.contents)}}$handleFeedback(S,D,w,u){const o=this.b.get(S),i=this.d.get(D),n=i?.responses[w];if(o&&n){const r=R.InteractiveEditorResponseFeedbackKind.to(u);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(S,D){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$Tec=P}),define(ke[324],Se([1,0,2,35]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class f{constructor(L,b,y,g,A){this.a=b,this.b=y,this.c=g;const P=new F.$1M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$YM("showOptions","Show Options",$=>!0,$=>$),new F.$YM("resource","Interactive resource Uri",$=>!0,$=>$),new F.$YM("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$YM("title","Interactive editor title",$=>!0,$=>$)],new F.$ZM("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const S=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:I.URI.revive($.notebookUri),inputUri:I.URI.revive($.inputUri),notebookEditor:S.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:I.URI.revive($.notebookUri),inputUri:I.URI.revive($.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(L,b,y,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:y,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$7ec=f}),define(ke[325],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class f{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(I.$yK.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const y=this.a.get(L);if(!y)throw new Error("Issue request handler not found");const g=await y.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const g=await y.provideIssueData(b);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const g=await y.provideIssueTemplate(b);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(L,b){const y=L.identifier.value;return this.a.set(y,b),this.c.$registerIssueUriRequestHandler(y),new F.$AK(()=>{this.c.$unregisterIssueUriRequestHandler(y),this.a.delete(y)})}registerIssueDataProvider(L,b){const y=L.identifier.value;return this.b.set(y,b),this.c.$registerIssueDataProvider(y),new F.$AK(()=>{this.c.$unregisterIssueDataProvider(y),this.b.delete(y)})}}e.$8ec=f}),define(ke[326],Se([1,0,3,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class f{constructor(L){this.b=0,this.a=L.getProxy(F.$yK.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,I.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$9ec=f}),define(ke[327],Se([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,132,122,110,38,8,11,25,213]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class d{constructor(B,J){this.d=B,this.e=J}async provideDocumentSymbols(B,J){const re=this.d.getDocument(B),ae=await this.e.provideDocumentSymbols(re,J);if(!(0,A.$Jb)(ae))return ae[0]instanceof R.$SK?ae.map(f.DocumentSymbol.from):d.f(ae)}static f(B){B=B.slice(0).sort((ae,_)=>{let ge=ae.location.range.start.compareTo(_.location.range.start);return ge===0&&(ge=_.location.range.end.compareTo(ae.location.range.end)),ge});const J=[],re=[];for(const ae of B){const _={name:ae.name||"!!MISSING: name!!",kind:f.SymbolKind.from(ae.kind),tags:ae.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:f.Range.from(ae.location.range),selectionRange:f.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(_),J.push(_);break}const ge=re[re.length-1];if(g.$As.containsRange(ge.range,_.range)&&!g.$As.equalsRange(ge.range,_.range)){ge.children?.push(_),re.push(_);break}re.pop()}}return J}}class c{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,J,re){this.g=B,this.h=J,this.j=re,this.e=new i.$Adc("CodeLens"),this.f=new Map}async provideCodeLenses(B,J){const re=this.g.getDocument(B),ae=await this.j.provideCodeLenses(re,J);if(!ae||J.isCancellationRequested)return;const _=this.e.add(ae),ge=new w.$Qc;this.f.set(_,ge);const ye={cacheId:_,lenses:[]};for(let je=0;je<ae.length;je++)ye.lenses.push({cacheId:[_,je],range:f.Range.from(ae[je].range),command:this.h.toInternal(ae[je].command,ge)});return ye}async resolveCodeLens(B,J){const re=B.cacheId&&this.e.get(...B.cacheId);if(!re)return;let ae;if(typeof this.j.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this.j.resolveCodeLens(re,J),ae||(ae=re),J.isCancellationRequested)return;const _=B.cacheId&&this.f.get(B.cacheId[0]);if(_)return B.command=this.h.toInternal(ae.command??c.d,_),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function l(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,J){this.d=B,this.e=J}async provideDefinition(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideDefinition(ae,_,re);return l(ge)}}class k{constructor(B,J){this.d=B,this.e=J}async provideDeclaration(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideDeclaration(ae,_,re);return l(ge)}}class C{constructor(B,J){this.d=B,this.e=J}async provideImplementation(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideImplementation(ae,_,re);return l(ge)}}class m{constructor(B,J){this.d=B,this.e=J}async provideTypeDefinition(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideTypeDefinition(ae,_,re);return l(ge)}}class p{constructor(B,J){this.d=B,this.e=J}async provideHover(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideHover(ae,_,re);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=ae.getWordRangeAtPosition(_)),ge.range||(ge.range=new R.$CK(_,_)),f.Hover.from(ge)}}class v{constructor(B,J){this.d=B,this.e=J}async provideEvaluatableExpression(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideEvaluatableExpression(ae,_,re);if(ge)return f.EvaluatableExpression.from(ge)}}class E{constructor(B,J){this.d=B,this.e=J}async provideInlineValues(B,J,re,ae){const _=this.d.getDocument(B),ge=await this.e.provideInlineValues(_,f.Range.to(J),f.InlineValueContext.to(re),ae);if(Array.isArray(ge))return ge.map(ye=>f.InlineValue.from(ye))}}class N{constructor(B,J){this.d=B,this.e=J}async provideDocumentHighlights(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideDocumentHighlights(ae,_,re);if(Array.isArray(ge))return ge.map(f.DocumentHighlight.from)}}class z{constructor(B,J){this.d=B,this.e=J}async provideLinkedEditingRanges(B,J,re){const ae=this.d.getDocument(B),_=f.Position.to(J),ge=await this.e.provideLinkedEditingRanges(ae,_,re);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(f.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,J){this.d=B,this.e=J}async provideReferences(B,J,re,ae){const _=this.d.getDocument(B),ge=f.Position.to(J),ye=await this.e.provideReferences(_,ge,re,ae);if(Array.isArray(ye))return ye.map(f.location.from)}}class T{static{this.d=1e3}constructor(B,J,re,ae,_,ge,ye){this.g=B,this.h=J,this.j=re,this.k=ae,this.l=_,this.m=ge,this.n=ye,this.e=new i.$Adc("CodeAction"),this.f=new Map}async provideCodeActions(B,J,re,ae){const _=this.g.getDocument(B),ge=$.$Cs.isISelection(J)?f.Selection.to(J):f.Range.to(J),ye=[];for(const nt of this.j.getDiagnostics(B))if(ge.intersection(nt.range)&&ye.push(nt)>T.d)break;const je={diagnostics:ye,only:re.only?new R.$UK(re.only):void 0,triggerKind:f.CodeActionTriggerKind.to(re.trigger)},We=await this.k.provideCodeActions(_,ge,je,ae);if(!(0,A.$Kb)(We)||ae.isCancellationRequested)return;const et=this.e.add(We),Ze=new w.$Qc;this.f.set(et,Ze);const rt=[];for(let nt=0;nt<We.length;nt++){const Ae=We[nt];Ae&&(T.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ze)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[et,nt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ze),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$MF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:et,actions:rt}}async resolveCodeAction(B,J){const[re,ae]=B,_=this.e.get(re,ae);if(!_||T.o(_))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(_,J)??_;let ye;ge.edit&&(ye=f.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(re);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,re,ae,_){this.d=B,this.e=J,this.f=re,this.g=ae,this.h=_}async prepareDocumentPaste(B,J,re,ae){if(!this.f.prepareDocumentPaste)return;const _=this.e.getDocument(B),ge=J.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(re,()=>{throw new r.$0});if(await this.f.prepareDocumentPaste(_,ge,ye,ae),ae.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof R.$oL));return f.DataTransfer.from(je)}async providePasteEdits(B,J,re,ae,_){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(J),ye=re.map(et=>f.Range.to(et)),je=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolvePasteFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,_);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:j.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class O{constructor(B,J){this.d=B,this.e=J}async provideDocumentFormattingEdits(B,J,re){const ae=this.d.getDocument(B),_=await this.e.provideDocumentFormattingEdits(ae,J,re);if(Array.isArray(_))return _.map(f.TextEdit.from)}}class V{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeFormattingEdits(B,J,re,ae){const _=this.d.getDocument(B),ge=f.Range.to(J),ye=await this.e.provideDocumentRangeFormattingEdits(_,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,J,re,ae){(0,P.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(B),ge=J.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(_,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class te{constructor(B,J){this.d=B,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,J,re,ae,_){const ge=this.d.getDocument(B),ye=f.Position.to(J),je=await this.e.provideOnTypeFormattingEdits(ge,ye,re,ae,_);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class fe{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Adc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,J){const re=await this.e.provideWorkspaceSymbols(B,J);if(!(0,A.$Kb)(re))return{symbols:[]};const ae=this.d.add(re),_={cacheId:ae,symbols:[]};for(let ge=0;ge<re.length;ge++){const ye=re[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}_.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[ae,ge]})}return _}async resolveWorkspaceSymbol(B,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const re=this.d.get(...B.cacheId);if(re){const ae=await this.e.resolveWorkspaceSymbol(re,J);return ae&&(0,F.$dn)(B,f.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Z{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,J,re){this.d=B,this.e=J,this.f=re}async provideRenameEdits(B,J,re,ae){const _=this.d.getDocument(B),ge=f.Position.to(J);try{const ye=await this.e.provideRenameEdits(_,ge,re,ae);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const je=Z.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,J,re){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ae=this.d.getDocument(B),_=f.Position.to(J);try{const ge=await this.e.prepareRename(ae,_,re);let ye,je;if(R.$CK.isRange(ge)?(ye=ge,je=ae.getText(ge)):(0,P.$Ef)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>_.line||ye.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:je}}catch(ge){const ye=Z.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,J){this.resultId=B,this.tokens=J}}class G{constructor(B,J){this.f=B,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,J,re){const ae=this.f.getDocument(B),_=J!==0?this.d.get(J):null;let ge=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ae,_.resultId,re):await this.g.provideDocumentSemanticTokens(ae,re);return _&&this.d.delete(J),ge?(ge=G.h(ge),this.o(G.n(_,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return G.j(B)?G.k(B)?B:new R.$RL(new Uint32Array(B.data),B.resultId):G.l(B)?G.m(B)?B:new R.$TL(B.edits.map(J=>new R.$SL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const J of B.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(B,J){if(!G.j(J)||!B||!B.tokens)return J;const re=B.tokens,ae=re.length,_=J.data,ge=_.length;let ye=0;const je=Math.min(ae,ge);for(;ye<je&&re[ye]===_[ye];)ye++;if(ye===ae&&ye===ge)return new R.$TL([],J.resultId);let We=0;const et=je-ye;for(;We<et&&re[ae-We-1]===_[ge-We-1];)We++;return new R.$TL([{start:ye,deleteCount:ae-ye-We,data:_.subarray(ye,ge-We)}],J.resultId)}o(B,J){if(G.j(B)){const re=this.e++;return this.d.set(re,new Q(B.resultId,B.data)),(0,u.$D$)({id:re,type:"full",data:B.data})}if(G.l(B)){const re=this.e++;return G.j(J)?this.d.set(re,new Q(J.resultId,J.data)):this.d.set(re,new Q(B.resultId)),(0,u.$D$)({id:re,type:"delta",deltas:(B.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}class oe{constructor(B,J){this.d=B,this.e=J}async provideDocumentRangeSemanticTokens(B,J,re){const ae=this.d.getDocument(B),_=await this.e.provideDocumentRangeSemanticTokens(ae,f.Range.to(J),re);return _?this.f(_):null}f(B){return(0,u.$D$)({id:0,type:"full",data:B.data})}}class x{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,J,re,ae,_){this.f=B,this.g=J,this.h=re,this.j=ae,this.k=_,this.d=new i.$Adc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,J,re,ae){const _=this.f.getDocument(B),ge=f.Position.to(J),ye=_.getWordRangeAtPosition(ge)||new R.$CK(ge,ge),je=ye.with({end:ge}),We=new n.$Nd,et=await this.h.provideCompletionItems(_,ge,ae,f.CompletionContext.to(re));if(!et||ae.isCancellationRequested)return;const Ze=Array.isArray(et)?new R.$8K(et):et,rt=x.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),nt=new w.$Qc;this.e.set(rt,nt);const Ae=[],Ne={x:rt,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(je)},c:Ze.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ze.items.length;Ve++){const Le=Ze.items[Ve],Xe=this.l(Le,[rt,Ve],je,ye);Ae.push(Xe)}return Ne}async resolveCompletionItem(B,J){if(typeof this.h.resolveCompletionItem!="function")return;const re=this.d.get(...B);if(!re)return;const ae=this.l(re,B),_=await this.h.resolveCompletionItem(re,J);if(!_)return;const ge=this.l(_,B);return(ae.h!==ge.h||ae.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ae.n!==ge.n||ae.o!==ge.o||!(0,F.$en)(ae.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ae,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J,re,ae){const _=this.e.get(J[0]);if(!_)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,_),ye={x:J,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof R.$LK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),R.$CK.isRange(je)?ye.j=f.Range.from(je):je&&(!re?.isEqual(je.inserting)||!ae?.isEqual(je.replacing))&&(ye.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),ye}}class Ee{async provideInlineCompletions(B,J,re,ae){}disposeCompletions(B){}handleDidShowCompletionItem(B,J,re){}handlePartialAccept(B,J,re){}}class le extends Ee{constructor(B,J,re,ae){super(),this.f=B,this.g=J,this.h=re,this.j=ae,this.d=new q,this.e=(0,t.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,J,re,ae){const _=this.g.getDocument(B),ge=f.Position.to(J),ye=await this.h.provideInlineCompletionItems(_,ge,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:f.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[re.triggerKind]},ae);if(!ye||ae.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],et=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:je}),items:je.map((nt,Ae)=>{let Ne;nt.command&&(Ze||(Ze=new w.$Qc),Ne=this.j.toInternal(nt.command,Ze));const Ve=nt.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:nt.filterText,range:nt.range?f.Range.from(nt.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ze||(Ze=new w.$Qc),this.j.toInternal(nt,Ze))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,J,re){const ae=this.d.get(B)?.items[J];ae&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ae,re)}handlePartialAccept(B,J,re){const ae=this.d.get(B)?.items[J];ae&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ae,re)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const J=this.e++;return this.d.set(J,B),J}disposeReferenceId(B){const J=this.d.get(B);return this.d.delete(B),J}get(B){return this.d.get(B)}}class U{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Adc("SignatureHelp")}async provideSignatureHelp(B,J,re,ae){const _=this.e.getDocument(B),ge=f.Position.to(J),ye=this.g(re),je=await this.f.provideSignatureHelp(_,ge,ae,ye);if(je){const We=this.d.add([je]);return{...f.SignatureHelp.from(je),id:We}}}g(B){let J;if(B.activeSignatureHelp){const re=f.SignatureHelp.to(B.activeSignatureHelp),ae=this.d.get(B.activeSignatureHelp.id,0);ae?(J=ae,J.activeSignature=re.activeSignature,J.activeParameter=re.activeParameter):J=re}return{...B,activeSignatureHelp:J}}releaseSignatureHelp(B){this.d.delete(B)}}class ie{constructor(B,J,re,ae,_){this.f=B,this.g=J,this.h=re,this.j=ae,this.k=_,this.d=new i.$Adc("InlayHints"),this.e=new Map}async provideInlayHints(B,J,re){const ae=this.f.getDocument(B),_=f.Range.to(J),ge=await this.h.provideInlayHints(ae,_,re);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(re.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new w.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],_)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),je}async resolveInlayHint(B,J){if(typeof this.h.resolveInlayHint!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.h.resolveInlayHint(re,J);if(ae&&this.l(ae))return this.m(ae,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,J){return B.label.length===0||Array.isArray(B.label)&&B.label.every(re=>re.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(J&&!J.contains(B.position))}m(B,J){const re=this.e.get(J[0]);if(!re)throw Error("DisposableStore is missing...");const ae={label:"",cacheId:J,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?ae.label=B.label:ae.label=B.label.map(_=>{const ge={label:_.value};return ge.tooltip=f.MarkdownString.fromStrict(_.tooltip),R.$MK.isLocation(_.location)&&(ge.location=f.location.from(_.location)),_.command&&(ge.command=this.g.toInternal(_.command,re)),ge}),ae}}class be{constructor(B,J){this.e=B,this.f=J,this.d=new i.$Adc("DocumentLink")}async provideLinks(B,J){const re=this.e.getDocument(B),ae=await this.f.provideDocumentLinks(re,J);if(!(!Array.isArray(ae)||ae.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ae.filter(be.g).map(f.DocumentLink.from)};{const _=this.d.add(ae),ge={links:[],cacheId:_};for(let ye=0;ye<ae.length;ye++){if(!be.g(ae[ye]))continue;const je=f.DocumentLink.from(ae[ye]);je.cacheId=[_,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,J){if(typeof this.f.resolveDocumentLink!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.f.resolveDocumentLink(re,J);if(!(!ae||!be.g(ae)))return f.DocumentLink.from(ae)}releaseLinks(B){this.d.delete(B)}}class H{constructor(B,J){this.d=B,this.e=J}async provideColors(B,J){const re=this.d.getDocument(B),ae=await this.e.provideDocumentColors(re,J);return Array.isArray(ae)?ae.map(ge=>({color:f.Color.from(ge.color),range:f.Range.from(ge.range)})):[]}async provideColorPresentations(B,J,re){const ae=this.d.getDocument(B),_=f.Range.to(J.range),ge=f.Color.to(J.color),ye=await this.e.provideColorPresentations(ge,{document:ae,range:_},re);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class X{constructor(B,J){this.d=B,this.e=J}async provideFoldingRanges(B,J,re){const ae=this.d.getDocument(B),_=await this.e.provideFoldingRanges(ae,J,re);if(Array.isArray(_))return _.map(f.FoldingRange.from)}}class Y{constructor(B,J,re){this.d=B,this.e=J,this.f=re}async provideSelectionRanges(B,J,re){const ae=this.d.getDocument(B),_=J.map(f.Position.to),ge=await this.e.provideSelectionRanges(ae,_,re);if(!(0,A.$Kb)(ge))return[];if(ge.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<_.length;je++){const We=[];ye.push(We);let et=_[je],Ze=ge[je];for(;;){if(!Ze.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ze)),!Ze.parent)break;et=Ze.range,Ze=Ze.parent}}return ye}}class $e{constructor(B,J){this.f=B,this.g=J,this.d=new o.$FM(""),this.e=new Map}async prepareSession(B,J,re){const ae=this.f.getDocument(B),_=f.Position.to(J),ge=await this.g.prepareCallHierarchy(ae,_,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,J,re){const ae=this.j(B,J);if(!ae)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(ae,re);if(_)return _.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,J,re){const ae=this.j(B,J);if(!ae)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(ae,re);if(_)return _.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,J){const re=this.e.get(B),ae=f.CallHierarchyItem.from(J,B,re.size.toString(36));return re.set(ae._itemId,J),ae}j(B,J){return this.e.get(B)?.get(J)}}class ne{constructor(B,J){this.f=B,this.g=J,this.d=new o.$FM(""),this.e=new Map}async prepareSession(B,J,re){const ae=this.f.getDocument(B),_=f.Position.to(J),ge=await this.g.prepareTypeHierarchy(ae,_,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,J,re){const ae=this.j(B,J);if(!ae)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(ae,re);if(_)return _.map(ge=>this.h(B,ge))}async provideSubtypes(B,J,re){const ae=this.j(B,J);if(!ae)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(ae,re);if(_)return _.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,J){const re=this.e.get(B),ae=f.TypeHierarchyItem.from(J,B,re.size.toString(36));return re.set(ae._itemId,J),ae}j(B,J){return this.e.get(B)?.get(J)}}class de{static toInternalProviderId(B,J){return B+"."+J}constructor(B,J,re,ae,_){this.d=B,this.e=J,this.f=re,this.g=ae,this.h=_}async provideDocumentOnDropEdits(B,J,re,ae,_){const ge=this.e.getDocument(J),ye=f.Position.to(re),je=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,_);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:de.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ee{constructor(B,J){this.d=B,this.e=J}async provideMappedEdits(B,J,re,ae){const _=I.URI.revive(B),ge=this.d.getDocument(_),ye=re.documents.map(et=>et.map(Ze=>({uri:I.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(rt=>f.Range.to(rt))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,J,je,ae);return We?f.WorkspaceEdit.from(We):null}}class he{constructor(B,J){this.adapter=B,this.extension=J}}class pe{static{this.d=0}constructor(B,J,re,ae,_,ge,ye,je){this.g=J,this.h=re,this.j=ae,this.k=_,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(b.$yK.MainThreadLanguageFeatures)}o(B,J){return f.DocumentSelector.from(B,this.g,J)}p(B){return new R.$AK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,J,re,ae,_,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof J))return ae;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${re.toString().replace(/[\r\n]/g,"")}'`);const We=re(ye.adapter,ye.extension);return Promise.resolve(We).catch(et=>{(0,r.$3)(et)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(ye.extension.identifier,et))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),S.CancellationToken.isCancellationToken(_)?(0,a.$Ng)(We,_):We}t(B,J){const re=this.q();return this.f.set(re,new he(B,J)),re}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,J,re,ae){const _=this.t(new d(this.h,re),B),ge=ae&&ae.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(_,this.o(J,B),ge),this.p(_)}$provideDocumentSymbols(B,J,re){return this.s(B,d,ae=>ae.provideDocumentSymbols(I.URI.revive(J),re),void 0,re)}registerCodeLensProvider(B,J,re){const ae=this.q(),_=typeof re.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ae,new he(new c(this.h,this.j.converter,re),B)),this.e.$registerCodeLensSupport(ae,this.o(J,B),_);let ge=this.p(ae);if(_!==void 0){const ye=re.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(_));ge=R.$AK.from(ge,ye)}return ge}$provideCodeLenses(B,J,re){return this.s(B,c,ae=>ae.provideCodeLenses(I.URI.revive(J),re),void 0,re)}$resolveCodeLens(B,J,re){return this.s(B,c,ae=>ae.resolveCodeLens(J,re),void 0,void 0)}$releaseCodeLenses(B,J){this.s(B,c,re=>Promise.resolve(re.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(B,J,re){const ae=this.t(new h(this.h,re),B);return this.e.$registerDefinitionSupport(ae,this.o(J,B)),this.p(ae)}$provideDefinition(B,J,re,ae){return this.s(B,h,_=>_.provideDefinition(I.URI.revive(J),re,ae),[],ae)}registerDeclarationProvider(B,J,re){const ae=this.t(new k(this.h,re),B);return this.e.$registerDeclarationSupport(ae,this.o(J,B)),this.p(ae)}$provideDeclaration(B,J,re,ae){return this.s(B,k,_=>_.provideDeclaration(I.URI.revive(J),re,ae),[],ae)}registerImplementationProvider(B,J,re){const ae=this.t(new C(this.h,re),B);return this.e.$registerImplementationSupport(ae,this.o(J,B)),this.p(ae)}$provideImplementation(B,J,re,ae){return this.s(B,C,_=>_.provideImplementation(I.URI.revive(J),re,ae),[],ae)}registerTypeDefinitionProvider(B,J,re){const ae=this.t(new m(this.h,re),B);return this.e.$registerTypeDefinitionSupport(ae,this.o(J,B)),this.p(ae)}$provideTypeDefinition(B,J,re,ae){return this.s(B,m,_=>_.provideTypeDefinition(I.URI.revive(J),re,ae),[],ae)}registerHoverProvider(B,J,re,ae){const _=this.t(new p(this.h,re),B);return this.e.$registerHoverProvider(_,this.o(J,B)),this.p(_)}$provideHover(B,J,re,ae){return this.s(B,p,_=>_.provideHover(I.URI.revive(J),re,ae),void 0,ae)}registerEvaluatableExpressionProvider(B,J,re,ae){const _=this.t(new v(this.h,re),B);return this.e.$registerEvaluatableExpressionProvider(_,this.o(J,B)),this.p(_)}$provideEvaluatableExpression(B,J,re,ae){return this.s(B,v,_=>_.provideEvaluatableExpression(I.URI.revive(J),re,ae),void 0,ae)}registerInlineValuesProvider(B,J,re,ae){const _=typeof re.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new E(this.h,re),B);this.e.$registerInlineValuesProvider(ge,this.o(J,B),_);let ye=this.p(ge);if(_!==void 0){const je=re.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(_));ye=R.$AK.from(ye,je)}return ye}$provideInlineValues(B,J,re,ae,_){return this.s(B,E,ge=>ge.provideInlineValues(I.URI.revive(J),re,ae,_),void 0,_)}registerDocumentHighlightProvider(B,J,re){const ae=this.t(new N(this.h,re),B);return this.e.$registerDocumentHighlightProvider(ae,this.o(J,B)),this.p(ae)}$provideDocumentHighlights(B,J,re,ae){return this.s(B,N,_=>_.provideDocumentHighlights(I.URI.revive(J),re,ae),void 0,ae)}registerLinkedEditingRangeProvider(B,J,re){const ae=this.t(new z(this.h,re),B);return this.e.$registerLinkedEditingRangeProvider(ae,this.o(J,B)),this.p(ae)}$provideLinkedEditingRanges(B,J,re,ae){return this.s(B,z,async _=>{const ge=await _.provideLinkedEditingRanges(I.URI.revive(J),re,ae);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?pe.w(ge.wordPattern):void 0}},void 0,ae)}registerReferenceProvider(B,J,re){const ae=this.t(new M(this.h,re),B);return this.e.$registerReferenceSupport(ae,this.o(J,B)),this.p(ae)}$provideReferences(B,J,re,ae,_){return this.s(B,M,ge=>ge.provideReferences(I.URI.revive(J),re,ae,_),void 0,_)}registerCodeActionProvider(B,J,re,ae){const _=new w.$Qc,ge=this.t(new T(this.h,this.j.converter,this.k,re,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(J,B),{providedKinds:ae?.providedCodeActionKinds?.map(ye=>ye.value),documentation:ae?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,_)}))},pe.u(B),!!re.resolveCodeAction),_.add(this.p(ge)),_}$provideCodeActions(B,J,re,ae,_){return this.s(B,T,ge=>ge.provideCodeActions(I.URI.revive(J),re,ae,_),void 0,_)}$resolveCodeAction(B,J,re){return this.s(B,T,ae=>ae.resolveCodeAction(J,re),{},void 0)}$releaseCodeActions(B,J){this.s(B,T,re=>Promise.resolve(re.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(B,J,re){const ae=this.t(new O(this.h,re),B);return this.e.$registerDocumentFormattingSupport(ae,this.o(J,B),B.identifier,B.displayName||B.name),this.p(ae)}$provideDocumentFormattingEdits(B,J,re,ae){return this.s(B,O,_=>_.provideDocumentFormattingEdits(I.URI.revive(J),re,ae),void 0,ae)}registerDocumentRangeFormattingEditProvider(B,J,re){const ae=typeof re.provideDocumentRangesFormattingEdits=="function",_=this.t(new V(this.h,re),B);return this.e.$registerRangeFormattingSupport(_,this.o(J,B),B.identifier,B.displayName||B.name,ae),this.p(_)}$provideDocumentRangeFormattingEdits(B,J,re,ae,_){return this.s(B,V,ge=>ge.provideDocumentRangeFormattingEdits(I.URI.revive(J),re,ae,_),void 0,_)}$provideDocumentRangesFormattingEdits(B,J,re,ae,_){return this.s(B,V,ge=>ge.provideDocumentRangesFormattingEdits(I.URI.revive(J),re,ae,_),void 0,_)}registerOnTypeFormattingEditProvider(B,J,re,ae){const _=this.t(new te(this.h,re),B);return this.e.$registerOnTypeFormattingSupport(_,this.o(J,B),ae,B.identifier),this.p(_)}$provideOnTypeFormattingEdits(B,J,re,ae,_,ge){return this.s(B,te,ye=>ye.provideOnTypeFormattingEdits(I.URI.revive(J),re,ae,_,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,J){const re=this.t(new fe(J,this.l),B);return this.e.$registerNavigateTypeSupport(re,typeof J.resolveWorkspaceSymbol=="function"),this.p(re)}$provideWorkspaceSymbols(B,J,re){return this.s(B,fe,ae=>ae.provideWorkspaceSymbols(J,re),{symbols:[]},re)}$resolveWorkspaceSymbol(B,J,re){return this.s(B,fe,ae=>ae.resolveWorkspaceSymbol(J,re),void 0,void 0)}$releaseWorkspaceSymbols(B,J){this.s(B,fe,re=>re.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(B,J,re){const ae=this.t(new Z(this.h,re,this.l),B);return this.e.$registerRenameSupport(ae,this.o(J,B),Z.supportsResolving(re)),this.p(ae)}$provideRenameEdits(B,J,re,ae,_){return this.s(B,Z,ge=>ge.provideRenameEdits(I.URI.revive(J),re,ae,_),void 0,_)}$resolveRenameLocation(B,J,re,ae){return this.s(B,Z,_=>_.resolveRenameLocation(I.URI.revive(J),re,ae),void 0,ae)}registerDocumentSemanticTokensProvider(B,J,re,ae){const _=this.t(new G(this.h,re),B),ge=typeof re.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(J,B),ae,ge);let ye=this.p(_);if(ge){const je=re.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=R.$AK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,J,re,ae){return this.s(B,G,_=>_.provideDocumentSemanticTokens(I.URI.revive(J),re,ae),null,ae)}$releaseDocumentSemanticTokens(B,J){this.s(B,G,re=>re.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,J,re,ae){const _=this.t(new oe(this.h,re),B);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(J,B),ae),this.p(_)}$provideDocumentRangeSemanticTokens(B,J,re,ae){return this.s(B,oe,_=>_.provideDocumentRangeSemanticTokens(I.URI.revive(J),re,ae),null,ae)}registerCompletionItemProvider(B,J,re,ae){const _=this.t(new x(this.h,this.j.converter,re,this.m,B),B);return this.e.$registerCompletionsProvider(_,this.o(J,B),ae,x.supportsResolving(re),B.identifier),this.p(_)}$provideCompletionItems(B,J,re,ae,_){return this.s(B,x,ge=>ge.provideCompletionItems(I.URI.revive(J),re,ae,_),void 0,_)}$resolveCompletionItem(B,J,re){return this.s(B,x,ae=>ae.resolveCompletionItem(J,re),void 0,re)}$releaseCompletionItems(B,J){this.s(B,x,re=>re.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(B,J,re,ae){const _=new le(B,this.h,re,this.j.converter),ge=this.t(_,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(J,B),_.supportsHandleEvents,D.$_l.toKey(B.identifier.value),ae?.yieldTo?.map(ye=>D.$_l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,J,re,ae,_){return this.s(B,Ee,ge=>ge.provideInlineCompletions(I.URI.revive(J),re,ae,_),void 0,_)}$handleInlineCompletionDidShow(B,J,re,ae){this.s(B,Ee,async _=>{_.handleDidShowCompletionItem(J,re,ae)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,J,re,ae){this.s(B,Ee,async _=>{_.handlePartialAccept(J,re,ae)},void 0,void 0)}$freeInlineCompletionsList(B,J){this.s(B,Ee,async re=>{re.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(B,J,re,ae){const _=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ge=this.t(new U(this.h,re),B);return this.e.$registerSignatureHelpProvider(ge,this.o(J,B),_),this.p(ge)}$provideSignatureHelp(B,J,re,ae,_){return this.s(B,U,ge=>ge.provideSignatureHelp(I.URI.revive(J),re,ae,_),void 0,_)}$releaseSignatureHelp(B,J){this.s(B,U,re=>re.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(B,J,re){const ae=typeof re.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new ie(this.h,this.j.converter,re,this.l,B),B);this.e.$registerInlayHintsProvider(_,this.o(J,B),typeof re.resolveInlayHint=="function",ae,pe.u(B));let ge=this.p(_);if(ae!==void 0){const ye=re.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(ae));ge=R.$AK.from(ge,ye)}return ge}$provideInlayHints(B,J,re,ae){return this.s(B,ie,_=>_.provideInlayHints(I.URI.revive(J),re,ae),void 0,ae)}$resolveInlayHint(B,J,re){return this.s(B,ie,ae=>ae.resolveInlayHint(J,re),void 0,re)}$releaseInlayHints(B,J){this.s(B,ie,re=>re.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(B,J,re){const ae=this.t(new be(this.h,re),B);return this.e.$registerDocumentLinkProvider(ae,this.o(J,B),typeof re.resolveDocumentLink=="function"),this.p(ae)}$provideDocumentLinks(B,J,re){return this.s(B,be,ae=>ae.provideLinks(I.URI.revive(J),re),void 0,re,J.scheme==="output")}$resolveDocumentLink(B,J,re){return this.s(B,be,ae=>ae.resolveLink(J,re),void 0,void 0,!0)}$releaseDocumentLinks(B,J){this.s(B,be,re=>re.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(B,J,re){const ae=this.t(new H(this.h,re),B);return this.e.$registerDocumentColorProvider(ae,this.o(J,B)),this.p(ae)}$provideDocumentColors(B,J,re){return this.s(B,H,ae=>ae.provideColors(I.URI.revive(J),re),[],re)}$provideColorPresentations(B,J,re,ae){return this.s(B,H,_=>_.provideColorPresentations(I.URI.revive(J),re,ae),void 0,ae)}registerFoldingRangeProvider(B,J,re){const ae=this.q(),_=typeof re.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ae,new he(new X(this.h,re),B)),this.e.$registerFoldingRangeProvider(ae,this.o(J,B),B.identifier,_);let ge=this.p(ae);if(_!==void 0){const ye=re.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));ge=R.$AK.from(ge,ye)}return ge}$provideFoldingRanges(B,J,re,ae){return this.s(B,X,_=>_.provideFoldingRanges(I.URI.revive(J),re,ae),void 0,ae)}registerSelectionRangeProvider(B,J,re){const ae=this.t(new Y(this.h,re,this.l),B);return this.e.$registerSelectionRangeProvider(ae,this.o(J,B)),this.p(ae)}$provideSelectionRanges(B,J,re,ae){return this.s(B,Y,_=>_.provideSelectionRanges(I.URI.revive(J),re,ae),[],ae)}registerCallHierarchyProvider(B,J,re){const ae=this.t(new $e(this.h,re),B);return this.e.$registerCallHierarchyProvider(ae,this.o(J,B)),this.p(ae)}$prepareCallHierarchy(B,J,re,ae){return this.s(B,$e,_=>Promise.resolve(_.prepareSession(I.URI.revive(J),re,ae)),void 0,ae)}$provideCallHierarchyIncomingCalls(B,J,re,ae){return this.s(B,$e,_=>_.provideCallsTo(J,re,ae),void 0,ae)}$provideCallHierarchyOutgoingCalls(B,J,re,ae){return this.s(B,$e,_=>_.provideCallsFrom(J,re,ae),void 0,ae)}$releaseCallHierarchy(B,J){this.s(B,$e,re=>Promise.resolve(re.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(B,J,re){const ae=this.t(new ne(this.h,re),B);return this.e.$registerTypeHierarchyProvider(ae,this.o(J,B)),this.p(ae)}$prepareTypeHierarchy(B,J,re,ae){return this.s(B,ne,_=>Promise.resolve(_.prepareSession(I.URI.revive(J),re,ae)),void 0,ae)}$provideTypeHierarchySupertypes(B,J,re,ae){return this.s(B,ne,_=>_.provideSupertypes(J,re,ae),void 0,ae)}$provideTypeHierarchySubtypes(B,J,re,ae){return this.s(B,ne,_=>_.provideSubtypes(J,re,ae),void 0,ae)}$releaseTypeHierarchy(B,J){this.s(B,ne,re=>Promise.resolve(re.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(B,J,re,ae){const _=this.q();this.f.set(_,new he(new de(this.e,this.h,re,_,B),B));const ge=(0,t.$MF)(B,"dropMetadata")&&ae?de.toInternalProviderId(B.identifier.value,ae.id):void 0;return this.e.$registerDocumentOnDropEditProvider(_,this.o(J,B),ge,(0,t.$MF)(B,"dropMetadata")?ae:void 0),this.p(_)}$provideDocumentOnDropEdits(B,J,re,ae,_,ge){return this.s(B,de,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(J,I.URI.revive(re),ae,_,ge)),void 0,void 0)}registerMappedEditsProvider(B,J,re){const ae=this.t(new ee(this.h,re),B);return this.e.$registerMappedEditsProvider(ae,this.o(J,B)),this.p(ae)}$provideMappedEdits(B,J,re,ae,_){return this.s(B,ee,ge=>Promise.resolve(ge.provideMappedEdits(J,re,ae,_)),null,_)}registerDocumentPasteEditProvider(B,J,re,ae){const _=this.q();this.f.set(_,new he(new j(this.e,this.h,re,_,B),B));const ge=j.toInternalProviderId(B.identifier.value,ae.id);return this.e.$registerPasteEditProvider(_,this.o(J,B),ge,{supportsCopy:!!re.prepareDocumentPaste,supportsPaste:!!re.provideDocumentPasteEdits,copyMimeTypes:ae.copyMimeTypes,pasteMimeTypes:ae.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(B,J,re,ae,_){return this.s(B,j,ge=>ge.prepareDocumentPaste(I.URI.revive(J),re,ae,_),void 0,_)}$providePasteEdits(B,J,re,ae,_,ge){return this.s(B,j,ye=>ye.providePasteEdits(J,I.URI.revive(re),ae,_,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(J=>R.SyntaxTokenType.toString(J)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,J,re){const{wordPattern:ae}=re;if(ae&&(0,y.$Se)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this.h.setWordDefinitionFor(J,ae):this.h.setWordDefinitionFor(J,void 0),re.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),re.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const _=this.q(),ge={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?pe.w(re.wordPattern):void 0,indentationRules:re.indentationRules?pe.y(re.indentationRules):void 0,onEnterRules:re.onEnterRules?pe.B(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport,autoClosingPairs:re.autoClosingPairs?pe.D(re.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,J,ge),this.p(_)}$setWordDefinitions(B){for(const J of B)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$Kdc=pe}),define(ke[328],Se([1,0,6,15,7,39,11,3,25]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class g{constructor(P,$,S,D){this.c=$,this.d=S,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(I.$yK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,$){await this.a.$changeLanguage(P,$);const S=this.c.getDocumentData(P);if(!S)throw new Error(`document '${P.toString()}' NOT found`);return S.document}async tokenAtPosition(P,$){const S=P.version,D=F.Position.from($),w=await this.a.$tokensAtPosition(P.uri,D),u={type:f.StandardTokenType.Other,range:P.getWordRangeAtPosition($)??new f.$CK($.line,$.character,$.line,$.character)};if(!w)return u;const o={range:F.Range.to(w.range),type:F.TokenType.to(w.type)};return!o.range.contains($)||S!==P.version?u:o}createLanguageStatusItem(P,$,S){const D=this.f++,w=this.a,u=this.g,o=`${P.identifier.value}/${$}`;if(u.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);u.add(o);const i={selector:S,id:$,name:P.displayName??P.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new b.$Qc,a=()=>{if(n?.dispose(),!u.has(o)){console.warn(`LanguageStatusItem (${$}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Zg)(()=>{r.clear(),this.a.$setLanguageStatus(D,{id:o,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?R.default.Error:i.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),w.$removeLanguageStatus(D),u.delete(o)},get id(){return i.id},get name(){return i.name},set name(s){i.name=s,a()},get selector(){return i.selector},set selector(s){i.selector=s,a()},get text(){return i.text},set text(s){i.text=s,a()},set text2(s){(0,y.$NF)(P,"languageStatusText"),i.text=s,a()},get text2(){return(0,y.$NF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(s){i.detail=s,a()},get severity(){return i.severity},set severity(s){i.severity=s,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(s){i.accessibilityInformation=s,a()},get command(){return i.command},set command(s){i.command=s,a()},get busy(){return i.busy},set busy(s){i.busy=s,a()}};return a(),t}}e.$0ec=g}),define(ke[115],Se([1,0,12,13,2,5,14,6,27,20]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;let A=class{constructor($,S,D){this.f=D,this.d=new Map,this.a=S.getProxy(b.$yK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===I.$g}getMessage($,S){const{message:D,args:w,comment:u}=S;if(this.c)return(0,F.$He)(D,w??{});let o=D;u&&u.length>0&&(o+=`/${Array.isArray(u)?u.join(""):u}`);const i=this.d.get($)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,F.$He)(i??D,w??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let S;const D=await this.g($);if(!D){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(D),u=JSON.parse(w);S=$.isBuiltin?u.contents?.bundle:u}catch(w){this.f.error(`Failed to load translations for ${$.identifier.value} from ${D}: ${w.message}`);return}S&&this.d.set($.identifier.value,{contents:S,uri:D})}async g($){if($.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return f.URI.revive(S)}return $.l10n?f.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vec=A,e.$vec=A=He([Be(0,y.$QM),Be(1,g.$AM),Be(2,L.$dj)],A),e.$wec=(0,R.$Vh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,14,6,27,20,2,54]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let y=class extends I.$oj{constructor(P,$){super($.logLevel,$.logsLocation,$.loggers.map(S=>(0,b.$sh)(S))),this.r=P.getProxy(F.$yK.MainThreadLogger)}$setLogLevel(P,$){$?this.setLogLevel(L.URI.revive($),P):this.setLogLevel(P)}setVisibility(P,$){super.setVisibility(P,$),this.r.$setVisibility(P,$)}s(P,$,S){return new g(this.r,P,$,S)}};e.$Ifc=y,e.$Ifc=y=He([Be(0,R.$AM),Be(1,f.$QM)],y);class g extends I.$jj{constructor(P,$,S,D){super(D?.logLevel==="always"),this.r=P,this.s=$,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger($,D).then(()=>{this.u(this.n),this.m=!0})}g(P,$){const S=[[P,$]];this.m?this.u(S):this.n.push(...S)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=void 0,e.$xec=(0,F.$Vh)("IExtHostManagedSockets");let b=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(I.$yK.MainThreadManagedSockets)}setFactory(P,$){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new y(P,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const $=++this.b,S=await this.c.makeConnection(),D=new f.$Qc;return this.d.set($,new g($,S,D)),D.add((0,f.$Pc)(()=>this.d.delete($))),D.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),D.dispose()})),D.add(S.onDidClose(w=>{this.a.$onDidManagedSocketClose($,w?.stack??w?.message),D.dispose()})),D.add(S.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData($,L.$fe.wrap(w)))),$}$remoteSocketWrite(P,$){this.d.get(P)?.actual.send($.buffer)}$remoteSocketEnd(P){const $=this.d.get(P);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$yec=b,e.$yec=b=He([Be(0,R.$AM)],b);class y{constructor(P,$){this.socketFactoryId=P,this.makeConnection=$}}class g extends f.$Rc{constructor(P,$,S){super(),this.socketId=P,this.actual=$,this.B(S)}}}),define(ke[329],Se([1,0,6,14,25]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;function R(b){return b&&b.title}let L=class{constructor(y,g){this.b=g,this.a=y.getProxy(I.$yK.MainThreadMessageService)}showMessage(y,g,A,P,$){const S={source:{identifier:y.identifier,label:y.displayName||y.name}};let D;typeof P=="string"||R(P)?D=[P,...$]:(S.modal=P?.modal,S.useCustom=P?.useCustom,S.detail=P?.detail,D=$),S.useCustom&&(0,f.$NF)(y,"resolvers");const w=[];for(let u=0;u<D.length;u++){const o=D[u];if(typeof o=="string")w.push({title:o,handle:u,isCloseAffordance:!1});else if(typeof o=="object"){const{title:i,isCloseAffordance:n}=o;w.push({title:i,isCloseAffordance:!!n,handle:u})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(g,A,S,w).then(u=>{if(typeof u=="number")return D[u]})}};e.$$ec=L,e.$$ec=L=He([Be(1,F.$dj)],L)}),define(ke[330],Se([1,0,19,11,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;let n=class{constructor(h,k,C,m,p){this.l=k,this.m=C,this.n=m,this.o=p,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new R.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(P.$yK.MainThreadNotebookKernels);const v=new $.$1M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$YM("options","Select kernel options",E=>!0,E=>{if(E&&"notebookEditor"in E&&"id"in E){const N=this.m.getIdByEditor(E.notebookEditor);return{id:E.id,extension:E.extension,notebookEditorId:N}}else if(E&&"notebookEditor"in E){const N=this.m.getIdByEditor(E.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${E.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return E})],$.$ZM.Void);this.n.registerApiCommand(v)}createNotebookController(h,k,C,m,p,v){for(const oe of this.i.values())if(oe.controller.id===k&&g.$_l.equals(h.identifier,oe.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const E=this.j++,N=this;this.o.trace(`NotebookController[${E}], CREATED by ${h.identifier.value}, ${k}`);const z=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${h.identifier}'`);let M=!1;const T=new R.$Rd,j=new R.$Rd,O={id:c(h.identifier,k),notebookType:C,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:m||h.identifier.value,preloads:v?v.map(S.NotebookRendererScript.from):[]};let V=p??z,te;this.a.$addKernel(E,O).catch(oe=>{console.log(oe),M=!0});let fe=0;const Z=()=>{if(M)return;const oe=++fe;Promise.resolve().then(()=>{oe===fe&&this.a.$updateKernel(E,O)})},Q=new b.$zc,G={get id(){return k},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return O.label},set label(oe){O.label=oe??h.displayName??h.name,Z()},get detail(){return O.detail??""},set detail(oe){O.detail=oe,Z()},get description(){return O.description??""},set description(oe){O.description=oe,Z()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(oe){O.supportedLanguages=oe,Z()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){O.supportsExecutionOrder=oe,Z()},get rendererScripts(){return O.preloads?O.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(oe){V=oe??z},get interruptHandler(){return te},set interruptHandler(oe){te=oe,O.supportsInterrupt=!!oe,Z()},createNotebookCellExecution(oe){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.notebook.uri))throw N.o.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,c(h.identifier,this.id))},createNotebookExecution(oe){if((0,o.$NF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.uri))throw N.o.trace(`NotebookController[${E}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,c(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${E}], DISPOSED`),M=!0,this.i.delete(E),T.dispose(),j.dispose(),this.a.$removeKernel(E))},updateNotebookAffinity(oe,x){x===D.NotebookControllerAffinity2.Hidden&&(0,o.$NF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(E,oe.uri,x)},onDidReceiveMessage:j.event,postMessage(oe,x){return(0,o.$NF)(h,"notebookMessaging"),N.a.$postMessage(E,x&&N.m.getIdByEditor(x),oe)},asWebviewUri(oe){return(0,o.$NF)(h,"notebookMessaging"),(0,w.$$tb)(oe,N.l.remote)}};return this.i.set(E,{extensionId:h.identifier,controller:G,onDidReceiveMessage:j,onDidChangeSelection:T,associatedNotebooks:Q}),G}getIdByController(h){for(const[k,C]of this.i)if(C.controller===h)return c(C.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,k){const C=this.f++,m=this;this.o.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(C,k);const p={dispose:()=>{this.e.delete(C),m.a.$removeKernelDetectionTask(C)}};return this.e.set(C,p),p}registerKernelSourceActionProvider(h,k,C){const m=this.h++,p=typeof C.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,v=this;this.g.set(m,C),this.o.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,k);let E;return p!==void 0&&(E=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.g.delete(m),v.a.$removeKernelSourceActionProvider(m,m),E?.dispose()}}}async $provideKernelSourceActions(h,k){const C=this.g.get(h);if(C){const m=new L.$Qc;return(await C.provideNotebookKernelSourceActions(k)??[]).map(v=>S.NotebookKernelSourceAction.from(v,this.n.converter,m))}return[]}$acceptNotebookAssociation(h,k,C){const m=this.i.get(h);if(m){const p=this.m.getNotebookDocument(y.URI.revive(k));C?m.associatedNotebooks.set(p.uri,!0):m.associatedNotebooks.delete(p.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),C),m.onDidChangeSelection.fire({selected:C,notebook:p.apiNotebook})}}async $executeCells(h,k,C){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(y.URI.revive(k)),v=[];for(const E of C){const N=p.getCell(E);N&&v.push(N.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),v.length),await m.controller.executeHandler.call(m.controller,v,p.apiNotebook,m.controller)}catch(E){this.o.error(`NotebookController[${h}] execute cells FAILED`,E),console.error(E)}}async $cancelCells(h,k,C){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(y.URI.revive(k));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,p.apiNotebook);else for(const v of C){const E=p.getCell(v);E&&this.b.get(E.uri)?.cancel()}if(m.controller.interruptHandler){const v=this.c.get(p.uri);C.length&&Array.isArray(v)&&v.length&&v.forEach(E=>E.dispose())}}$acceptKernelMessageFromRenderer(h,k,C){const m=this.i.get(h);if(!m)return;const p=this.m.getEditorById(k);m.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:C}))}$cellExecutionChanged(h,k,C){const p=this.m.getNotebookDocument(y.URI.revive(h)).getCell(k);if(p){const v=C?S.NotebookCellExecutionState.to(C):D.NotebookCellExecutionState.Idle;v!==void 0&&this.k.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(h,k){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const p=new a(k,m,this.a);this.b.set(m.uri,p);const v=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),v.dispose(),this.b.delete(m.uri))});return p.asApiObject()}_createNotebookExecution(h,k){const C=this.m.getNotebookDocument(h.uri),m=h.getCells().find(E=>{const N=C.getCellFromApiCell(E);return N&&this.b.has(N.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const p=new s(k,C,this.a),v=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),v.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[p,v]),p.asApiObject()}};e.$cfc=n,e.$cfc=n=He([Be(4,A.$dj)],n);var r;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(r||(r={}));class a extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,C){super(),this.m=k,this.n=C,this.b=a.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new f.$2d),this.h=new d(10,m=>this.s(m)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const k=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$xv(k))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let k=this.m;if(h&&(k=this.m.notebook.getCellFromApiCell(h)),!k)throw new Error("INVALID cell");return k.handle}y(h){return h.map(k=>{const C=D.$2L.ensureUniqueMimeTypes(k.items,!0);return C===k.items?S.NotebookCellOutput.from(k):S.NotebookCellOutput.from({items:C,id:k.id,metadata:k.metadata})})}async z(h,k,C){const m=this.w(k),p=this.y((0,I.$2b)(h));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:m,append:C,outputs:p})}async C(h,k,C){return h=D.$2L.ensureUniqueMimeTypes((0,I.$2b)(h),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:h.map(S.NotebookCellOutputItem.from),outputId:k.id,append:C})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(C){h.j=C,h.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(C){if(h.f===r.Resolved||h.f===r.Started)throw new Error("Cannot call start again");h.f=r.Started,h.c.fire(),h.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,m){if(h.f===r.Resolved)throw new Error("Cannot call resolve twice");h.f=r.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$xv({runEndTime:m,lastRunSuccess:C}))},clearOutput(C){return h.t(),h.z([],C,!1)},appendOutput(C,m){return h.t(),h.z(C,m,!0)},replaceOutput(C,m){return h.t(),h.z(C,m,!1)},appendOutputItems(C,m){return h.t(),h.C(C,m,!0)},replaceOutputItems(C,m){return h.t(),h.C(C,m,!1)}})}}var t;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(t||(t={}));class s extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,C){super(),this.h=k,this.j=C,this.b=s.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$2d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,k){this.e=h,this.f=k,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$ih,this.b=Date.now(),(0,F.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>h.complete())}}function c(l,h){return`${l.value}/${h}`}e.$dfc=c}),define(ke[331],Se([1,0,4,6,148]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class R{constructor(b,y){this.c=y,this.a=new Map,this.b=b.getProxy(F.$yK.MainThreadNotebookRenderers)}$postRendererMessage(b,y,g){const A=this.c.getEditorById(b);this.a.get(y)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging(b,y){if(!b.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,P,$)=>this.d(y).event(A,P,$),postMessage:(A,P)=>{f.$Wec.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const $=P&&f.$Wec.apiEditorsToExtHost.get(P);return this.b.$postMessage($?.id,y,A)}}}d(b){let y=this.a.get(b);return y||(y=new I.$Rd({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(b)}}),this.a.set(b,y),y)}}e.$efc=R}),define(ke[332],Se([1,0,3,18,2,25,6]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class b{constructor(g){this.b=new Map,this.a=g.getProxy(L.$yK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,P){if((0,R.$NF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,g.identifier.value),(0,I.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,P,$){const S=this.b.get(g);if(!S)throw new Error(`Unknown handler with id: ${g}`);return S.saveProfile(A,P,$)}async $readProfile(g,A,P){const $=this.b.get(g);if(!$)throw new Error(`Unknown handler with id: ${g}`);return $.readProfile((0,F.$Cf)(A)?A:f.URI.revive(A),P)}}e.$hfc=b}),define(ke[333],Se([1,0,2,6,11,15]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class L{static{this.a=0}constructor(y,g){this.d=g,this.c=new Map,this.b=y.getProxy(F.$yK.MainThreadQuickDiff)}$provideOriginalResource(y,g,A){const P=I.URI.revive(g),$=this.c.get(y);return $?(0,f.$Qg)(()=>$.provideOriginalResource(P,A)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(y,g,A,P){const $=L.a++;return this.c.set($,g),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(y,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$jfc=L}),define(ke[334],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;function D(w,u,o){const i=w.getProxy(R.$yK.MainThreadQuickOpen);class n{constructor(k,C){this.e=new Map,this.f=0,this.a=k,this.b=C}showQuickPick(k,C,m,p=I.CancellationToken.None){this.c=void 0;const v=Promise.resolve(C),E=++this.f,N=i.$show(E,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},p),z={},M=N.then(()=>z);return Promise.race([M,v]).then(T=>{if(T===z)return;const j=(0,$.$MF)(k,"quickPickItemTooltip");return v.then(O=>{const V=[];for(let te=0;te<O.length;te++){const fe=O[te];if(typeof fe=="string")V.push({label:fe,handle:te});else if(fe.kind===b.QuickPickItemKind.Separator)V.push({type:"separator",label:fe.label});else{fe.tooltip&&!j&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=fe.iconPath?d(fe.iconPath):void 0;V.push({label:fe.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:fe.description,detail:fe.detail,picked:fe.picked,alwaysShow:fe.alwaysShow,tooltip:j?S.MarkdownString.fromStrict(fe.tooltip):void 0,handle:te})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=te=>{m.onDidSelectItem(O[te])}),i.$setItems(E,V),N.then(te=>{if(typeof te=="number")return O[te];if(Array.isArray(te))return te.map(fe=>O[fe])})})}).then(void 0,T=>{if(!(0,y.$3)(T))return i.$setError(E,T),Promise.reject(T)})}$onItemSelected(k){this.c?.(k)}showInput(k,C=I.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",C).then(void 0,m=>{if(!(0,y.$3)(m))return Promise.reject(m)})}async $validateInput(k){if(!this.d)return;const C=await this.d(k);if(!C||typeof C=="string")return C;let m;switch(C.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=C.message?A.default.Error:A.default.Ignore;break}return{content:C.message,severity:m}}async showWorkspaceFolderPick(k,C=I.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!m)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(v=>v.uri.toString()===m.uri.toString())}createQuickPick(k){const C=new c(k,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(k){const C=new l(k,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(k,C){this.e.get(k)?._fireDidChangeValue(C)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,C){const m=this.e.get(k);m instanceof c&&m._fireDidChangeActive(C)}$onDidChangeSelection(k,C){const m=this.e.get(k);m instanceof c&&m._fireDidChangeSelection(C)}$onDidTriggerButton(k,C){this.e.get(k)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(k,C,m){const p=this.e.get(k);p instanceof c&&p._fireDidTriggerItemButton(C,m)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class r{static{this.a=1}constructor(k,C){this.x=k,this.y=C,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Rd,this.q=new F.$Rd,this.r=new F.$Rd,this.s=new F.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((C,m)=>{const p=C===b.$UL.Back?-1:m;this.o.set(p,C)}),this.z({buttons:k.map((C,m)=>({...d(C.iconPath),tooltip:C.tooltip,handle:C===b.$UL.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const C=this.o.get(k);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const C of Object.keys(k)){const m=k[C];this.u[C]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof b.$uL)return{id:h.id};const k=s(h),C=t(h);return{dark:typeof k=="string"?L.URI.file(k):k,light:typeof C=="string"?L.URI.file(C):C}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function s(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const k=a(h);let C,m;return"id"in k?m=P.ThemeIcon.asClassName(k):C=k,{iconPath:C,iconClass:m}}class c extends r{constructor(k,C){super(k.identifier,C),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Rd,this.L=[],this.M=new F.$Rd,this.N=new F.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((p,v)=>{this.C.set(v,p),this.D.set(p,v)});const C=(0,$.$MF)(this.O,"quickPickItemTooltip"),m=[];for(let p=0;p<k.length;p++){const v=k[p];if(v.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:v.label});else{v.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const E=v.iconPath?d(v.iconPath):void 0;m.push({handle:p,label:v.label,iconPath:E?.iconPath,iconClass:E?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:C?S.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,z)=>({...d(N.iconPath),tooltip:N.tooltip,handle:z}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(k){const C=(0,g.$Gb)(k.map(m=>this.C.get(m)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(k){const C=(0,g.$Gb)(k.map(m=>this.C.get(m)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(k,C){const m=this.C.get(k);if(!m||!m.buttons||!m.buttons.length)return;const p=m.buttons[C];p&&this.N.fire({button:p,item:m})}}class l extends r{constructor(k,C){super(k.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(u,o)}e.$kfc=D}),define(ke[335],Se([1,0,2,4,59,3,11,6,19,129,14,26,61,15,25,17]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=void 0;function o(v){if(v)return typeof v.iconPath=="string"?I.URI.file(v.iconPath):I.URI.isUri(v.iconPath)||$.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function i(v){if(v?.icon){if(I.URI.isUri(v.icon))return v.icon;if($.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const E=v.icon;return{light:E.light,dark:E.dark}}}else return}function n(v){if(v.icon){if(I.URI.isUri(v.icon))return v.icon;if($.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const E=v.icon;return{light:E.light,dark:E.dark}}}else return}function r(v,E){if(!v.iconPath&&!E.iconPath)return 0;if(v.iconPath){if(!E.iconPath)return 1}else return-1;const N=typeof v.iconPath=="string"?v.iconPath:I.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,z=typeof E.iconPath=="string"?E.iconPath:I.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id;return(0,g.$xq)(N,z)}function a(v,E){let N=0;if(v.strikeThrough!==E.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==E.faded)return v.faded?1:-1;if(v.tooltip!==E.tooltip)return(v.tooltip||"").localeCompare(E.tooltip||"");if(N=r(v,E),N!==0)return N;if(v.light&&E.light)N=r(v.light,E.light);else{if(v.light)return 1;if(E.light)return-1}if(N!==0)return N;if(v.dark&&E.dark)N=r(v.dark,E.dark);else{if(v.dark)return 1;if(E.dark)return-1}return N}function t(v,E){if(v.command!==E.command)return v.command<E.command?-1:1;if(v.title!==E.title)return v.title<E.title?-1:1;if(v.tooltip!==E.tooltip){if(v.tooltip!==void 0&&E.tooltip!==void 0)return v.tooltip<E.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(E.tooltip!==void 0)return-1}if(v.arguments===E.arguments)return 0;if(v.arguments)if(E.arguments){if(v.arguments.length!==E.arguments.length)return v.arguments.length-E.arguments.length}else return 1;else return-1;for(let N=0;N<v.arguments.length;N++){const z=v.arguments[N],M=E.arguments[N];if(z!==M)return z<M?-1:1}return 0}function s(v,E){let N=(0,g.$xq)(v.resourceUri.fsPath,E.resourceUri.fsPath,!0);if(N!==0)return N;if(v.command&&E.command)N=t(v.command,E.command);else{if(v.command)return 1;if(E.command)return-1}if(N!==0)return N;if(v.decorations&&E.decorations)N=a(v.decorations,E.decorations);else{if(v.decorations)return 1;if(E.decorations)return-1}return N}function d(v,E){for(let N=0;N<v.length;N++)if(v[N]!==E[N])return!1;return!0}function c(v,E){return v.command===E.command&&v.title===E.title&&v.tooltip===E.tooltip&&(v.arguments&&E.arguments?d(v.arguments,E.arguments):v.arguments===E.arguments)}function l(v,E){return(0,y.$tb)(v,E,c)}function h(v,E){return v===E?!0:!v||!E?!1:v.id===E.id&&v.label===E.label&&v.upstream?.id===E.upstream?.id&&v.upstream?.label===E.upstream?.label}class k{#e;#t;get value(){return this.d}set value(E){E=E??"",this.#e.$setInputBoxValue(this.o,E),this.q(E)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(E){this.#e.$setInputBoxPlaceholder(this.o,E),this.f=E}get validateInput(){return(0,D.$NF)(this.m,"scmValidation"),this.g}set validateInput(E){if((0,D.$NF)(this.m,"scmValidation"),E&&typeof E!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=E,this.#e.$setValidationProviderIsEnabled(this.o,!!E)}get enabled(){return this.h}set enabled(E){E=!!E,this.h!==E&&(this.h=E,this.#e.$setInputBoxEnablement(this.o,E))}get visible(){return this.j}set visible(E){E=!!E,this.j!==E&&(this.j=E,this.#e.$setInputBoxVisibility(this.o,E))}get actionButton(){return(0,D.$NF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(E){(0,D.$NF)(this.m,"scmInputBoxActionButton"),this.l.value=new R.$Qc,this.k=E;const N=E!==void 0?{command:this.n.converter.toInternal(E.command,this.l.value),icon:i(E),enabled:E.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,D.$NF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(E,N,z,M,T,j){this.m=E,this.n=N,this.o=T,this.p=j,this.d="",this.e=new F.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new R.$Sc,this.#t=z,this.#e=M}showValidationMessage(E,N){(0,D.$NF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,E,N)}$onInputBoxValueChange(E){this.q(E)}q(E){this.d=E,this.e.fire(E)}}e.$lfc=k;class C{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(E){this.v=E,this.q.$updateGroupLabel(this.t,this.handle,E)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(E){this.p=E,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(E){this.f=[...E],this.k.fire()}constructor(E,N,z,M,T){this.q=E,this.s=N,this.t=z,this.u=M,this.v=T,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=C.d++}getResourceState(E){return this.g.get(E)}$executeResourceCommand(E,N){const z=this.h.get(E);return z?(0,L.$Qg)(()=>this.s.executeCommand(z.command,...z.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const E=[...this.f].sort(s),z=(0,y.$Cb)(this.o,E,s).map(j=>{const O=j.toInsert.map(V=>{const te=this.e++;this.g.set(te,V);const fe=V.resourceUri;let Z;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"||V.command.command==="vscode.changes"){const be=new R.$Qc;Z=this.s.converter.toInternal(V.command,be),this.j.set(te,be)}else this.h.set(te,V.command);const Q=o(V.decorations),G=V.decorations&&o(V.decorations.light)||Q,oe=V.decorations&&o(V.decorations.dark)||Q,x=[G,oe],Ee=V.decorations&&V.decorations.tooltip||"",le=V.decorations&&!!V.decorations.strikeThrough,q=V.decorations&&!!V.decorations.faded,U=V.contextValue||"";return{rawResource:[te,fe,x,Ee,le,q,U,Z],handle:te}});return{start:j.start,deleteCount:j.deleteCount,toInsert:O}}),M=z.map(({start:j,deleteCount:O,toInsert:V})=>[j,O,V.map(te=>te.rawResource)]),T=z.reverse();for(const{start:j,deleteCount:O,toInsert:V}of T){const te=V.map(Z=>Z.handle),fe=this.n.splice(j,O,...te);for(const Z of fe)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=E,M}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(E){this.g!==E&&(this.g=E,this.#e.$updateSourceControl(this.x,{count:E}))}get quickDiffProvider(){return this.h}set quickDiffProvider(E){this.h=E;let N;(0,D.$MF)(this.y,"quickDiffProvider")&&(N=E?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!E,quickDiffLabel:N})}get historyProvider(){return(0,D.$NF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(E){(0,D.$NF)(this.y,"scmHistoryProvider"),this.j=E,this.k.value=new R.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!E}),E&&(this.k.value.add(E.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,E?.currentHistoryItemGroup)||(this.l=E?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(E.onDidChangeActionButton(()=>{(0,D.$NF)(this.y,"scmActionButton"),this.m.value=new R.$Qc;const N=E.actionButton!==void 0?{command:this.z.converter.toInternal(E.actionButton.command,this.m.value),description:E.actionButton.description,enabled:E.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(E){E!==this.n&&(this.n=E,this.#e.$updateSourceControl(this.x,{commitTemplate:E}))}get acceptInputCommand(){return this.p}set acceptInputCommand(E){this.o.value=new R.$Qc,this.p=E;const N=this.z.converter.toInternal(E,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,D.$NF)(this.y,"scmActionButton"),this.s}set actionButton(E){(0,D.$NF)(this.y,"scmActionButton"),this.q.value=new R.$Qc,this.s=E;const N=E!==void 0?{command:this.z.converter.toInternal(E.command,this.q.value),secondaryCommands:E.secondaryCommands?.map(z=>z.map(M=>this.z.converter.toInternal(M,this.q.value))),description:E.description,enabled:E.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(E){if(this.u&&E&&l(this.u,E))return;this.t.value=new R.$Qc,this.u=E;const N=(E||[]).map(z=>this.z.converter.toInternal(z,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(E,N,z,M,T,j,O){this.y=E,this.z=M,this.A=T,this.B=j,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Sc,this.m=new R.$Sc,this.n=void 0,this.o=new R.$Sc,this.p=void 0,this.q=new R.$Sc,this.t=new R.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Rd,this.onDidChangeSelection=this.w.event,this.x=m.d++,this.D=new Map,this.E=new Set,this.#e=z;const V=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${T}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new k(E,M,N,this.#e,this.x,V),this.#e.$registerSourceControl(this.x,T,j,O,V)}createResourceGroup(E,N){const z=new C(this.#e,this.z,this.x,E,N),M=F.Event.once(z.onDidDispose)(()=>this.D.delete(z));return this.D.set(z,M),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const E=[],N=[];for(const[z,M]of this.D){M.dispose();const T=z.onDidUpdateResourceStates(()=>{this.E.add(z),this.eventuallyUpdateResourceStates()});F.Event.once(z.onDidDispose)(()=>{this.E.delete(z),T.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.x,z.handle)}),E.push([z.handle,z.id,z.label,z.features]);const j=z._takeResourceStateSnapshot();j.length>0&&N.push([z.handle,j]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.x,E,N),this.D.clear()}eventuallyUpdateResourceStates(){const E=[];this.E.forEach(N=>{const z=N._takeResourceStateSnapshot();z.length!==0&&E.push([N.handle,z])}),E.length>0&&this.#e.$spliceResourceStates(this.x,E),this.E.clear()}getResourceGroup(E){return this.e.get(E)}setSelectionState(E){this.v=E,this.w.fire(E)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(E=>E.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$oh)(100)],m.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$oh)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let p=class{static{u=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(E,N,z,M){this.l=N,this.m=z,this.n=M,this.g=new Map,this.h=new P.$bm,this.j=new F.$Rd,this.e=E.getProxy(b.$yK.MainThreadSCM),this.f=E.getProxy(b.$yK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===3){const j=this.g.get(T.sourceControlHandle);if(!j)return T;const O=j.getResourceGroup(T.groupHandle);return O?O.getResourceState(T.handle):T}else if(T&&T.$mid===4){const j=this.g.get(T.sourceControlHandle);return j?j.getResourceGroup(T.groupHandle):T}else if(T&&T.$mid===5){const j=this.g.get(T.handle);return j||T}return T}})}createSourceControl(E,N,z,M){this.n.trace("ExtHostSCM#createSourceControl",E.identifier.value,N,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:E.identifier.value});const T=u.d++,j=new m(E,this.m,this.e,this.l,N,z,M);this.g.set(T,j);const O=this.h.get(E.identifier)||[];return O.push(j),this.h.set(E.identifier,O),j}getLastInputBox(E){this.n.trace("ExtHostSCM#getLastInputBox",E.identifier.value);const N=this.h.get(E.identifier),z=N&&N[N.length-1];return z&&z.inputBox}$provideOriginalResource(E,N,z){const M=I.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",E,M.toString());const T=this.g.get(E);return!T||!T.quickDiffProvider||!T.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Qg)(()=>T.quickDiffProvider.provideOriginalResource(M,z)).then(j=>j||null)}$onInputBoxValueChange(E,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",E);const z=this.g.get(E);return z&&z.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(E,N,z,M){this.n.trace("ExtHostSCM#$executeResourceCommand",E,N,z);const T=this.g.get(E);if(!T)return Promise.resolve(void 0);const j=T.getResourceGroup(N);return j?j.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(E,N,z){this.n.trace("ExtHostSCM#$validateInput",E);const M=this.g.get(E);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Qg)(()=>M.inputBox.validateInput(N,z)).then(T=>{if(!T)return Promise.resolve(void 0);const j=S.MarkdownString.fromStrict(T.message);return j?Promise.resolve([j,T.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(E){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",E),E!==void 0&&this.g.get(E)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=E,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(E,N,z){return await this.g.get(E)?.historyProvider?.resolveHistoryItemGroupBase(N,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(E,N,z,M){return await this.g.get(E)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,z,M)??void 0}async $provideHistoryItems(E,N,z,M){return(await this.g.get(E)?.historyProvider?.provideHistoryItems(N,z,M))?.map(O=>({...O,icon:n(O)}))??void 0}async $provideHistoryItemChanges(E,N,z){return await this.g.get(E)?.historyProvider?.provideHistoryItemChanges(N,z)??void 0}};e.$mfc=p,e.$mfc=p=u=He([Be(3,A.$dj)],p)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0;class R{constructor(b){this.b=new F.$Rd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(I.$yK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,y){return this.a.$getPassword(b,y)}store(b,y,g){return this.a.$setPassword(b,y,g)}delete(b,y){return this.a.$deletePassword(b,y)}}e.$sec=R,e.$tec=(0,f.$Vh)("IExtHostSecretState")}),define(ke[336],Se([1,0,6,15,2]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class R{static{this.a=0}constructor(b,y){this.d=y,this.c=new Map,this.b=b.getProxy(I.$yK.MainThreadShare)}async $provideShare(b,y,g){return await this.c.get(b)?.provideShare({selection:F.Range.to(y.selection),resourceUri:f.URI.revive(y.resourceUri)},g)??void 0}registerShareProvider(b,y){const g=R.a++;return this.c.set(g,y),this.b.$registerShareProvider(g,F.DocumentSelector.from(b,this.d),y.id,y.label,y.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$nfc=R}),define(ke[337],Se([1,0,21,3,6]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(f.$yK.MainThreadSpeech)}async $createSpeechToTextSession(b,y){const g=this.c.get(b);if(!g)return;const A=new F.$Qc,P=new I.$2d;this.d.set(y,P);const $=A.add(g.provideSpeechToTextSession(P.token));A.add($.onDidChange(S=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(y,S)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,y,g){const A=R.a++;return this.c.set(A,g),this.b.$registerProvider(A,y,{extension:b,displayName:b.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$ofc=R}),define(ke[338],Se([1,0,7,6,217,3,15,18]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0;class y{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$vL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$vL("statusBarItem.warningForeground")]])}#e;#t;constructor($,S,D,w,u,o=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new R.$Qc,this.#e=$,this.#t=S,u&&w){this.c=(0,I.$$K)(w.identifier,u);const n=D.get(this.c);n&&(o=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(y.a++);this.e=w,this.f=u,this.g=o,this.h=this.u(i)}u($){if((0,b.$Gf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!y.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Qc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let S;this.m?S=this.m:S=(0,f.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=y.b.get(this.o.id));const w=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,S,this.k,w,this.r?.internal,D,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$pfc=y;class g{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const S={message:$};return this.b.unshift(S),this.c(),new I.$AK(()=>{const D=this.b.indexOf(S);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,S){this.e=new Map,this.a=$.getProxy(F.$yK.MainThreadStatusBar),this.b=S,this.c=new g(this)}$acceptStaticEntries($){for(const S of $)this.e.set(S.entryId,S)}createStatusBarEntry($,S,D,w){return new y(this.a,this.b,this.e,$,S,D,w)}setStatusBarMessage($,S){const D=this.c.setMessage($);let w;return typeof S=="number"?w=setTimeout(()=>D.dispose(),S):typeof S<"u"&&S.then(()=>D.dispose(),()=>D.dispose()),new I.$AK(()=>{D.dispose(),clearTimeout(w)})}}e.$qfc=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;class R{constructor(b,y){this.c=y,this.b=new F.$Rd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(I.$yK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,y){this.a.$registerExtensionStorageKeysToSync(b,y)}async initializeExtensionStorage(b,y,g){const A=await this.a.$initializeExtensionStorage(b,y);let P;return A&&(P=this.d(b,y,A)),P||g}setValue(b,y,g){return this.a.$setValue(b,y,g)}$acceptValue(b,y,g){const A=this.d(b,y,g);A&&this.b.fire({shared:b,key:y,value:A})}d(b,y,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${b}): ${A}`)}}}e.$kec=R,e.$lec=(0,f.$Vh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0,e.$6dc=(0,I.$Vh)("IExtensionStoragePaths");let b=class{constructor(g,A,P){this.d=A,this.f=P,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then($=>this.c=$)}async g(g){return L.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(g){if(this.c)return L.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return L.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7dc=b,e.$7dc=b=He([Be(0,F.$QM),Be(1,f.$dj),Be(2,R.$5dc)],b)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,219,8,263,21,32,264,61,11,15,35]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=e.$pec=e.$oec=void 0,e.$oec=(0,f.$Vh)("IExtHostTerminalService");class n{constructor(m,p,v,E){this.l=m,this._id=p,this.m=v,this.n=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(z,M=!0){N.q(),N.l.$sendText(N._id,z,M)},show(z){N.q(),N.l.$show(N._id,z)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(m,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??p?.cwd??void 0,env:m.env??void 0,icon:l(m.iconPath)??void 0,color:w.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(m.location,p?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,p,v,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:v,color:w.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.o(m,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(m,p){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in m?{viewColumn:o.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.n=m}setExitStatus(m,p){this.h=Object.freeze({code:m,reason:p})}setDimensions(m,p){return m===this.d&&p===this.g||m===0||p===0?!1:(this.d=m,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(m){this.k=m}_setProcessId(m){this.f?(this.f(m),this.f=void 0):this.b.then(p=>{p!==m&&(this.b=Promise.resolve(m))})}}e.$pec=n;class r{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new I.$Rd,this.onProcessData=this.a.event,this.b=new I.$Rd,this.d=new I.$Rd,this.onDidChangeProperty=this.d.event,this.f=new I.$Rd,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,p){this.g.setDimensions?.({columns:m,rows:p})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,p,v){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new I.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new I.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Rd,this.onDidChangeShell=this.N.event,this.O=new I.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$yK.MainThreadTerminalService),this.y=new D.$nqb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:E=>{const N=z=>{const M=z;return this.W(M.instanceId)?.value};switch(E?.$mid){case 15:return N(E);default:{if(Array.isArray(E))for(let z=0;z<E.length&&E[z].$mid===15;z++)E[z]=N(E[z]);return E}}}}),this.B({dispose:()=>{for(const[E,N]of this.g)N.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,p){const v=new n(this.a,(0,S.$ig)(),m,m.name),E=new r(m.pty);return v.createExtensionTerminal(m.location,this.R(m,p).resolvedExtHostIdentifier,l(m.iconPath),h(m.color)).then(N=>{const z=this.S(N,E);this.h[N]=z}),this.f.push(v),v.value}R(m,p){if(p=p||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const v=m.location.parentTerminal;if(v){const E=this.f.find(N=>N.value===v);E&&(p.resolvedExtHostIdentifier=E._id)}}else m.location&&typeof m.location!="object"?p.location=m.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(m,p){if(!this.W(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const E=new r(p),N=this.S(m,E);this.h[m]=N}async $acceptActiveTerminalChanged(m){const p=this.b;if(m===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const v=this.W(m);v&&(this.b=v,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,p){const v=this.W(m);v&&this.O.fire({terminal:v.value,data:p})}async $acceptTerminalDimensions(m,p,v){const E=this.W(m);E&&E.setDimensions(p,v)&&this.L.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptDidExecuteCommand(m,p){const v=this.W(m);v&&this.P.fire({terminal:v.value,...p})}async $acceptTerminalMaximumDimensions(m,p,v){this.g.get(m)?.resize(p,v)}async $acceptTerminalTitleChange(m,p){const v=this.W(m);v&&(v.name=p)}async $acceptTerminalClosed(m,p,v){const E=this.Y(this.f,m);if(E!==null){const N=this.f.splice(E,1)[0];N.setExitStatus(p,v),this.H.fire(N.value)}}$acceptTerminalOpened(m,p,v,E){if(p){const M=this.Y(this.f,p);if(M!==null){this.f[M]._id=m,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},z=new n(this.a,m,N,v);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(m,p){this.W(m)?._setProcessId(p)}async $startExtensionTerminal(m,p){const v=this.W(m);if(!v)return{message:(0,g.localize)(0,null,m)};v.isOpen||await new Promise(N=>{const z=this.onDidOpenTerminal(async M=>{M===v.value&&(z.dispose(),N())})});const E=this.g.get(m);E?E.startSendingEvents(p):this.j[m]={initialDimensions:p}}S(m,p){const v=new b.$Qc;v.add(p.onProcessReady(N=>this.a.$sendProcessReady(m,N.pid,N.cwd,N.windowsPty))),v.add(p.onDidChangeProperty(N=>this.a.$sendProcessProperty(m,N))),this.y.startBuffering(m,p.onProcessData),v.add(p.onProcessExit(N=>this.U(m,N))),this.g.set(m,p);const E=this.j[m];return E&&p instanceof r&&(p.startSendingEvents(E.initialDimensions),delete this.j[m]),v}$acceptProcessAckDataEvent(m,p){this.g.get(m)?.acknowledgeDataEvent(p)}$acceptProcessInput(m,p){this.g.get(m)?.input(p)}$acceptTerminalInteraction(m){const p=this.W(m);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(m,p){this.W(m)?.setSelection(p)}$acceptProcessResize(m,p,v){try{this.g.get(m)?.resize(p,v)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(m,p){this.g.get(m)?.shutdown(p)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(p=>this.a.$sendProcessProperty(m,{type:"cwd",value:p}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new y.$AK(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,p,v){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,v),this.a.$registerProfileProvider(p,m.identifier.value),new y.$AK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(m,p,v){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,v),this.a.$registerQuickFixProvider(m,p),new y.$AK(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,p){const v=new $.$2d().token;if(v.isCancellationRequested)return;const E=this.D.get(m);if(!E)return;const N=await E.provideTerminalQuickFixes(p,v);if(N===null||Array.isArray(N)&&N.length===0)return;const z=new b.$Qc;if(this.w.value=z,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,z):void 0;const M=[];for(const T of N){const j=o.TerminalQuickFix.from(T,this.Q.converter,z);j&&M.push(j)}return M}async $createContributedProfileTerminal(m,p){const v=new $.$2d().token;let E=await this.C.get(m)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,p);return}this.createTerminalFromOptions(E.options,p)}}async $provideLinks(m,p){const v=this.W(m);if(!v)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const N=new $.$2d;this.G.set(m,N);const z=[],M={terminal:v.value,line:p},T=[];for(const V of this.z)T.push(u.Promises.withAsyncBody(async te=>{N.token.onCancellationRequested(()=>te({provider:V,links:[]}));const fe=await V.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||te({provider:V,links:fe})}));const j=await Promise.all(T);if(N.token.isCancellationRequested)return[];const O=new Map;for(const V of j)V&&V.links.length>0&&z.push(...V.links.map(te=>{const fe={id:a++,startIndex:te.startIndex,length:te.length,label:te.tooltip};return O.set(fe.id,{provider:V.provider,link:te}),fe}));return this.F.set(m,O),z}$activateLink(m,p){const v=this.F.get(m)?.get(p);v&&v.provider.handleTerminalLink(v.link)}U(m,p){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const v=this.h[m];v&&(v.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,p)}W(m){return this.X(this.f,m)}X(m,p){const v=this.Y(m,p);return v!==null?m[v]:null}Y(m,p){const v=m.findIndex(E=>E._id===p);return v===-1?null:v}getEnvironmentVariableCollection(m){let p=this.n.get(m.identifier.value);return p||(p=new s,this.$(m.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(m,p){const v=(0,P.$rr)(p.map),E=(0,P.$sr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(m,p.persistent,v.length===0?void 0:v,E)}$initEnvironmentVariableCollections(m){m.forEach(p=>{const v=p[0],E=new s(p[1]);this.$(v,E)})}$acceptDefaultProfile(m,p){const v=this.s;this.s=m,this.u=p,v?.path!==m.path&&this.N.fire(m.path)}$(m,p){this.n.set(m,p),p.onDidChangeCollection(()=>{this.Z(m,p)})}};e.$qec=t,e.$qec=t=He([Be(1,i.$WM),Be(2,L.$AM)],t);class s{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Rd,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const p=this.h(m);let v=this.a.get(p);return v||(v=new d(this,m),this.a.set(p,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace(m,p,v,E){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:E})}append(m,p,v,E){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:E})}prepend(m,p,v,E){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:E})}f(m,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g(m,p.scope),E=this.map.get(v),N=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!E||E.value!==p.value||E.type!==p.type||E.options?.applyAtProcessCreation!==N.applyAtProcessCreation||E.options?.applyAtShellIntegration!==N.applyAtShellIntegration||E.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const z=this.g(m,p.scope),M={variable:m,...p,options:N};this.map.set(z,M),this.d.fire()}}get(m,p){const v=this.g(m,p),E=this.map.get(v);return E?k(E):void 0}g(m,p){const v=this.h(p);return v.length?`${m}:::${v}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const p=new Map;for(const[v,E]of this.map)this.h(E.scope)===this.h(m)&&p.set(E.variable,k(E));return p}delete(m,p){const v=this.g(m,p);this.map.delete(v),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[p,v]of this.map)v.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(p);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,p){const v=this.h(p),E=this.descriptionMap.get(v);if(!E||E.description!==m){let N;typeof m=="string"?N=m:N=m?.value.split(`

`)[0];const z={description:N,scope:p};this.descriptionMap.set(v,z),this.d.fire()}}getDescription(m){const p=this.h(m);return this.descriptionMap.get(p)?.description}k(m){const p=this.h(m);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,p){this.b=m,this.d=p,this.a=new I.$Rd}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,p,v){this.b.replace(m,p,v,this.d)}append(m,p,v){this.b.append(m,p,v,this.d)}prepend(m,p,v){this.b.prepend(m,p,v,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,p){this.b.getVariableMap(this.d).forEach((v,E)=>m.call(p,E,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(m,p){super(!1,m,p)}createTerminal(m,p,v){throw new A.$$}createTerminalFromOptions(m,p){throw new A.$$}};e.$rec=c,e.$rec=c=He([Be(0,i.$WM),Be(1,L.$AM)],c);function l(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function h(C){return w.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const m={...C};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[339],Se([1,0,121,11,22,21,4,74,52,3,24,18,32,6,20,149,15,7,67,112,89,25]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=e.$vfc=e.$ufc=void 0;let t=class extends g.$Rc{constructor(M,T,j){super(),this.u=j,this.f=this.B(new L.$Rd),this.g=new Map,this.s=this.B(new L.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(S.$yK.MainThreadTesting),this.m=new v(this.h),this.j=new l(this.h),T.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const V=O,te=V.tests[V.tests.length-1].item.extId;return this.g.get(i.$rJ.root(te))?.collection.tree.get(te)?.actual??(0,w.$MM)(O)}case 18:{const{extId:V,message:te}=O;return{test:this.g.get(i.$rJ.root(V))?.collection.tree.get(V)?.actual,message:u.TestMessage.to(te)}}default:return O}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await T.executeCommand("_testing.getExplorerSelection"),V=te=>{const fe=this.g.get(i.$rJ.root(te));if(fe)return i.$rJ.isRoot(te)?fe.controller:fe.collection.tree.get(te)?.actual};return{include:O?.include.map(V).filter(P.$Kf)||[],exclude:O?.exclude.map(V).filter(P.$Kf)||[]}})}createTestController(M,T,j,O){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const V=new g.$Qc,te=V.add(new w.$PM(T,j,this.u));te.root.label=j;const fe=new Map,Z=new Set,Q=this.h,G={items:te.root.children,get label(){return j},set label(x){j=x,te.root.label=x,Q.$updateController(T,{label:j})},get refreshHandler(){return O},set refreshHandler(x){O=x,Q.$updateController(T,{canRefresh:!!x})},get id(){return T},createRunProfile:(x,Ee,le,q,U,ie)=>{let be=(0,y.$Ji)(x);for(;fe.has(be);)be++;return new E(this.h,fe,M,Z,this.s.event,T,be,x,Ee,le,q,U,ie)},createTestItem(x,Ee,le){return new w.$NM(T,x,Ee,le)},createTestRun:(x,Ee,le=!0)=>this.j.createTestRun(M,T,te,x,Ee,le),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const Ee=x instanceof Array?x:[x];this.h.$markTestRetired(Ee.map(le=>i.$rJ.fromExtHostTestItem(le,T).toString()))}},set resolveHandler(x){te.resolveHandler=x},get resolveHandler(){return te.resolveHandler},dispose:()=>{V.dispose()}};Q.$registerTestController(T,j,!!O),V.add((0,g.$Pc)(()=>Q.$unregisterTestController(T)));const oe={controller:G,collection:te,profiles:fe,extension:M,activeProfiles:Z};return this.g.set(T,oe),V.add((0,g.$Pc)(()=>this.g.delete(T))),V.add(te.onDidGenerateDiff(x=>Q.$publishDiff(T,x.map(r.TestsDiffOp.serialize)))),G}createTestObserver(){return this.m.checkout()}async runTests(M,T=R.CancellationToken.None){const j=h(M);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(j.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(V=>i.$rJ.fromExtHostTestItem(V,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:N[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:M.exclude?.map(V=>V.id)},T)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,T,j){return(0,I.$qb)(this.j.trackers,V=>V.id===M?V.getCoverage(T):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(M,T,j,O){return(0,I.$qb)(this.j.trackers,te=>te.id===M?te.getCoverage(T):void 0)?.resolveFileCoverage(j,O)??Promise.resolve([])}$configureRunProfile(M,T){this.g.get(M)?.profiles.get(T)?.configureHandler?.()}$setActiveRunProfiles(M){const T=new Map;for(const[j,O]of Object.entries(M)){const V=this.g.get(j);if(!V)continue;const te=new Map,fe=O.filter(Q=>!V.activeProfiles.has(Q)),Z=[...V.activeProfiles].filter(Q=>!O.includes(Q));for(const Q of fe)te.set(Q,!0),V.activeProfiles.add(Q);for(const Q of Z)te.set(Q,!1),V.activeProfiles.delete(Q);te.size&&T.set(j,te)}this.s.fire(T)}async $refreshTests(M,T){await this.g.get(M)?.controller.refreshHandler?.(T)}$publishTestResults(M){this.results=Object.freeze(M.map(T=>(0,A.$bn)(u.TestResults.to(T))).concat(this.results).sort((T,j)=>j.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,T){const j=this.g.get(i.$rJ.fromString(M).controllerId)?.collection;j&&(await j.expand(M,T<0?1/0:T),j.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(r.TestsDiffOp.deserialize))}async $runControllerTests(M,T){return Promise.all(M.map(j=>this.w(j,!1,T)))}async $startContinuousRun(M,T){const j=new R.$2d(T),O=await Promise.all(M.map(V=>this.w(V,!0,j.token)));return!T.isCancellationRequested&&!O.some(V=>V.error)&&await new Promise(V=>T.onCancellationRequested(V)),j.dispose(!0),O}async w(M,T,j){const O=this.g.get(M.controllerId);if(!O)return{};const{collection:V,profiles:te,extension:fe}=O,Z=te.get(M.profileId);if(!Z)return{};const Q=M.testIds.map(Ee=>V.tree.get(Ee)).filter(P.$Kf),G=M.excludeExtIds.map(Ee=>O.collection.tree.get(Ee)).filter(P.$Kf).filter(Ee=>Q.some(le=>le.fullId.compare(Ee.fullId)===2));if(!Q.length)return{};const oe=new o.$9L(Q.some(Ee=>Ee.actual instanceof w.$OM)?void 0:Q.map(Ee=>Ee.actual),G.map(Ee=>Ee.actual),Z,T),x=(0,r.$tJ)(M)&&this.j.prepareForMainThreadTestRun(oe,k.fromInternal(M,O.collection),fe,j);try{return await Z.runHandler(oe,j),{}}catch(Ee){return{error:String(Ee)}}finally{x&&(x.hasRunningTasks&&!j.isCancellationRequested&&await L.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$ufc=t,e.$ufc=t=He([Be(0,D.$AM)],t);const s=1e4;var d;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(d||(d={}));class c extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,T,j){super(),this.m=M,this.s=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Rd),this.onEnd=this.j.event,this.h=this.B(new R.$2d(j));const O=this.B(new F.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const T=this.m.id,j=this.m.controllerId,O=(0,$.$ig)(),V=new C(this.s,T,O),te=G=>(oe,...x)=>{if(Z){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(oe)&&(this.y(oe),G(oe,...x))},fe=(G,oe)=>{const x=oe instanceof Array?oe.map(u.TestMessage.from):[u.TestMessage.from(oe)];if(G.uri&&G.range){const Ee={range:u.Range.from(G.range),uri:G.uri};for(const le of x)le.location=le.location||Ee}this.s.$appendTestMessagesInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),x)};let Z=!1;const Q={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return V.coverageProvider},set coverageProvider(G){V.coverageProvider=G},enqueued:te(G=>{this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),1)}),skipped:te(G=>{this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),5)}),started:te(G=>{this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),2)}),errored:te((G,oe,x)=>{fe(G,oe),this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),6,x)}),failed:te((G,oe,x)=>{fe(G,oe),this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,j).toString(),4,x)}),passed:te((G,oe)=>{this.s.$updateTestStateInRun(T,O,i.$rJ.fromExtHostTestItem(G,this.m.controllerId).toString(),3,oe)}),appendOutput:(G,oe,x)=>{Z||(x&&(this.m.isIncluded(x)?this.y(x):x=void 0),this.s.$appendOutputToRun(T,O,f.$fe.fromString(G),oe&&u.location.from(oe),x&&i.$rJ.fromExtHostTestItem(x,j).toString()))},end:()=>{Z||(Z=!0,this.s.$finishedTestRunTask(T,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:Q,coverage:V}),this.s.$startedTestRunTask(T,{id:O,name:M,running:!0}),Q}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof w.$NM))throw new n.$sM(M.id);if(this.g.has(i.$rJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const T=[],j=this.m.colllection.root;for(;;){const O=u.TestItem.from(M);if(T.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),M===j))break;M=M.parent||j}this.s.$addTestsToRun(this.m.controllerId,this.m.id,T)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,T,j,O){return this.f(M,T,j,O)}cancelRunById(M){for(const T of this.c.values())if(T.id===M){T.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,T,j,O,V,te){const fe=this.c.get(O);if(fe)return fe.createRun(V);const Z=k.fromPublic(T,j,O,te),Q=h(O);this.d.$startedExtensionTestRun({controllerId:T,continuous:!!O.continuous,profile:Q&&{group:N[Q.kind],id:Q.profileId},exclude:O.exclude?.map(oe=>i.$rJ.fromExtHostTestItem(oe,j.root.id).toString())??[],id:Z.id,include:O.include?.map(oe=>i.$rJ.fromExtHostTestItem(oe,j.root.id).toString())??[j.root.id],persist:te});const G=this.f(O,Z,M);return L.Event.once(G.onEnd)(()=>{this.d.$finishedExtensionTestRun(Z.id),G.dispose()}),G.createRun(V)}f(M,T,j,O){const V=new c(T,this.d,O);return this.c.set(M,V),L.Event.once(V.onEnd)(()=>this.c.delete(M)),V}}e.$vfc=l;const h=z=>{if(z.profile){if(!(z.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class k{static fromPublic(M,T,j,O){return new k(M,(0,$.$ig)(),j.include?.map(V=>i.$rJ.fromExtHostTestItem(V,M).toString())??[M],j.exclude?.map(V=>i.$rJ.fromExtHostTestItem(V,M).toString())??[],O,T)}static fromInternal(M,T){return new k(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,T)}constructor(M,T,j,O,V,te){this.controllerId=M,this.id=T,this.isPersisted=V,this.colllection=te,this.c=j.map(fe=>fe+"\0"),this.d=O.map(fe=>fe+"\0")}isIncluded(M){const T=i.$rJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const j of this.d)if(T===j||T.startsWith(j))return!1;for(const j of this.c)if(T===j||T.startsWith(j))return!0;return!1}}e.$wfc=k;class C{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,T,j){this.f=M,this.g=T,this.h=j}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(u.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(M,T){const j=await this.d;let O=j?.[M];return!this.c||!j||!O?[]:(O.detailedCoverage||(O=j[M]=await this.c.resolveFileCoverage?.(O,T)??O),O.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,u.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const T=i.$rJ.parentId(M.item.extId);if(T&&this.g.has(T.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:T,f:j}=this;return{get added(){return[...M].map(O=>O.revived)},get updated(){return[...T].map(O=>O.revived)},get removed(){return[...j].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends r.$yJ{constructor(){super(...arguments),this.q=new L.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,T){return{...M,revived:u.TestItem.toPlain(M.item),depth:T?T.depth+1:0,children:new Set}}o(){return new m(this.q)}}class v{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(T=>T.revived)},dispose:(0,b.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class E{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?u.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$NF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$NF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,M=>M.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(P.$Kf))}constructor(M,T,j,O,V,te,fe,Z,Q,G,oe=!1,x=void 0,Ee=!1){this.controllerId=te,this.profileId=fe,this.d=Z,this.kind=Q,this.runHandler=G,this.f=oe,this._tag=x,this.g=Ee,this.#e=M,this.#r=T,this.#t=j,this.#i=O,this.#o=V,T.set(fe,this);const le=N[Q];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:fe,controllerId:te,tag:x?u.TestTag.namespace(this.controllerId,x.id):null,label:Z,group:le,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:Ee})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$xfc=E;const N={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[340],Se([1,0,19,8,4,6,150,15,7]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class g{constructor(P,$){this.i=$,this.a=new f.$Rd({onListenerError:F.$1}),this.b=new f.$Rd({onListenerError:F.$1}),this.c=new f.$Rd({onListenerError:F.$1}),this.d=new f.$Rd({onListenerError:F.$1}),this.f=new f.$Rd({onListenerError:F.$1}),this.g=new f.$Rd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(R.$yK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const $=this.i.allEditors();return P?$:$.map(S=>S.value)}async showTextDocument(P,$,S){let D;typeof $=="number"?D={position:b.ViewColumn.from($),preserveFocus:S}:typeof $=="object"?D={position:b.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?b.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:D={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(P.uri,D),u=w&&this.i.getEditor(w);if(u)return u.value;throw w?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,$){return new L.$HM(this.h,P,$).value}$acceptEditorPropertiesChanged(P,$){const S=this.i.getEditor(P);if(!S)throw new Error("unknown text editor");if($.options&&S._acceptOptions($.options),$.selections){const D=$.selections.selections.map(b.Selection.to);S._acceptSelections(D)}if($.visibleRanges){const D=I.$Gb($.visibleRanges.map(b.Range.to));S._acceptVisibleRanges(D)}if($.options&&this.b.fire({textEditor:S.value,options:{...$.options,lineNumbers:b.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const D=y.TextEditorSelectionChangeKind.fromValue($.selections.source),w=$.selections.selections.map(b.Selection.to);this.a.fire({textEditor:S.value,selections:w,kind:D})}if($.visibleRanges){const D=I.$Gb($.visibleRanges.map(b.Range.to));this.c.fire({textEditor:S.value,visibleRanges:D})}}$acceptEditorPositionData(P){for(const $ in P){const S=this.i.getEditor($);if(!S)throw new Error("Unknown text editor");const D=b.ViewColumn.to(P[$]);S.value.viewColumn!==D&&(S._acceptViewColumn(D),this.d.fire({textEditor:S.value,viewColumn:D}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$Tdc=g}),define(ke[341],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,F.$Vh)("IExtHostTimeline");class A{constructor(S,D){this.b=new Map,this.c=new Map,this.a=S.getProxy(f.$yK.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(w,u)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&y.$_l.equals(u,this.b.get(w.source)?.extension)){const o=w.uri===void 0?void 0:I.URI.revive(w.uri);return this.c.get(w.source)?.get(P(o))?.get(w.handle)}else return;return w}})}async $getTimeline(S,D,w,u){return this.b.get(S)?.provider.provideTimeline(I.URI.revive(D),w,u)}registerTimelineProvider(S,D,w,u){const o=new R.$Qc,i=this.d(D.id,u,o).bind(this);let n;D.onDidChange&&(n=D.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:D.id}),this));const r=this.c;return this.f({...D,scheme:S,onDidChange:void 0,async provideTimeline(a,t,s){t?.resetCache&&(o.clear(),r.get(D.id)?.clear());const d=await D.provideTimeline(a,t,s);if(d==null)return;const c=i(a,t);return{...d,source:D.id,items:d.items.map(c)}},dispose(){for(const a of r.values())a.get(D.id)?.clear();n?.dispose(),o.dispose()}},w)}d(S,D,w){return(u,o)=>{let i;if(o?.cacheResults){let n=this.c.get(S);n===void 0&&(n=new Map,this.c.set(S,n));const r=P(u);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${S}|${n.id??n.timestamp}`;i?.set(t,n);let s,d,c;n.iconPath&&(r instanceof L.$uL?c={id:r.id,color:r.color}:I.URI.isUri(r)?(s=r,d=r):{light:s,dark:d}=r);let l;return L.$1K.isMarkdownString(a.tooltip)?l=b.MarkdownString.from(a.tooltip):(0,g.$Cf)(a.tooltip)?l=a.tooltip:L.$1K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=b.MarkdownString.from(a.detail)):(0,g.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:n.command?D.toInternal(n.command,w):void 0,icon:s,iconDark:d,themeIcon:c,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(S,D){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:D}),(0,R.$Pc)(()=>{for(const u of this.c.values())u.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$Afc=A;function P($){return $?.toString()}}),define(ke[72],Se([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Swb=e.$Rwb=e.TunnelDtoConverter=void 0;class S extends y.$nv{}var D;(function(u){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==y.TunnelPrivacyId.ConstantPrivate&&n.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=i})(D||(e.TunnelDtoConverter=D={})),e.$Rwb=(0,L.$Vh)("IExtHostTunnelService");let w=class extends f.$Rc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(g.$yK.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new S(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new $.$AK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const d of o){const c=this.r.get(d);if(!c)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await c.provider.providePortAttributes({port:l,pid:n,commandLine:r},a)}catch{h=await c.provider.providePortAttributes(l,n,r,a)}return{providedAttributes:h,port:l}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await o.provideTunnel(r,a,new I.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,f.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Pc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),D.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$Swb=w,e.$Swb=w=He([Be(0,P.$AM),Be(1,A.$QM),Be(2,b.$dj)],w)}),define(ke[342],Se([1,0,3,17,2,6]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class L{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(y){this.c=new Map,this.b=y.getProxy(R.$yK.MainThreadUriOpeners)}registerExternalUriOpener(y,g,A,P){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const $=P.schemes.find(S=>!L.a.has(S));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,P.schemes,y,P.label),(0,I.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(y,g,A){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const $=f.URI.revive(g);return P.canOpenExternalUri($,A)}async $openUri(y,g,A){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(f.URI.revive(g.resolvedUri),{sourceUri:f.URI.revive(g.sourceUri)},A)}}e.$Cfc=L}),define(ke[343],Se([1,0,6,2,3,8,26]),function(me,e,I,F,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class b{static{this.a=0}constructor(g){this.c=new L.$am,this.d=new Map,this.b=g.getProxy(I.$yK.MainThreadUrls)}registerUriHandler(g,A){const P=g.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const $=b.a++;return this.c.add(P),this.d.set($,A),this.b.$registerUriHandler($,P,g.displayName||g.name),(0,f.$Pc)(()=>{this.c.delete(P),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(g,A){const P=this.d.get(g);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(A))}catch($){(0,R.$Z)($)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$Dfc=b}),define(ke[93],Se([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=e.$0dc=e.$9dc=e.$8dc=void 0;class P{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(r,a,t,s,d,c,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Rd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#s=t,this.#o=s,this.#r=d,this.#n=c,this.#l=$(c),this.#d=S(c),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,g.$$tb)(r,this.#o)}get cspSource(){const r=this.#n.extensionLocation;if(r.scheme===f.Schemas.https||r.scheme===f.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+g.$0tb}return g.$0tb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#s}set options(r){this.a(),R.$en(this.#s,r)||this.#t.$setOptions(this.#e,u(this.#n,this.#r,r)),this.#s=r}async postMessage(r){if(this.#c)return!1;const a=(0,y.$gdb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,l,h,k)=>{const C=L.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),m=(0,g.$$tb)(C,{isRemote:a,authority:t}).toString();return`${d}${m}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,l,h,k)=>{const C=L.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),m=(0,g.$$tb)(C,{isRemote:a,authority:t}).toString();return`${d}${m}${k}`})}}e.$8dc=P;function $(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$9dc=$;function S(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class D extends F.$Rc{constructor(r,a,t,s,d){super(),this.c=a,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=r.getProxy(A.$yK.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const s=this.j(r);if(s){const{message:d}=(0,y.$hdb)(a,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const s=new P(r,this.a,o(a),this.c,this.f,t,this.h);this.b.set(r,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return s}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$0dc=D;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$$dc=w;function u(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$_dc=u;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>L.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[344],Se([1,0,21,52,3,17,23,2,15,93,110,6,7]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class S{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new A.$Adc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=a(this.document.uri)+this.a++;return(0,L.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class D{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,c){const l=this.b(s,d.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const h=new S(d,c);return this.a.set(l,h),h}delete(s,d){const c=this.b(s,d.uri);this.a.delete(c)}b(s,d){return`${s}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class u{constructor(){this.a=new Map}addTextProvider(s,d,c){return this.b(0,s,d,c)}addCustomProvider(s,d,c){return this.b(1,s,d,c)}get(s){return this.a.get(s)}b(s,d,c,l){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:s,extension:c,provider:l}),new $.$AK(()=>this.a.delete(d))}}class o{constructor(s,d,c,l,h){this.d=d,this.f=c,this.g=l,this.h=h,this.b=new u,this.c=new D,this.a=s.getProxy(P.$yK.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,c,l){const h=new f.$Qc;return n(c)?(h.add(this.b.addTextProvider(d,s,c)),this.a.$registerTextEditorProvider((0,g.$$dc)(s),d,l.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,g.$9dc)(s))):(h.add(this.b.addCustomProvider(d,s,c)),i(c)&&h.add(c.onDidChangeCustomDocument(k=>{const C=this.i(d,k.document.uri);if(r(k)){const m=C.addEdit(k);this.a.$onDidEdit(k.document.uri,d,m,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,g.$$dc)(s),d,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,g.$9dc)(s))),$.$AK.from(h,new $.$AK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,c,l,h){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${d}'`);const C=b.URI.revive(s),m=await k.provider.openCustomDocument(C,{backupId:c,untitledDocumentData:l?.buffer},h);let p;return i(k.provider)&&this.f&&(p=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,m,p),{editable:i(k.provider)}}async $disposeCustomDocument(s,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${d}'`);const l=b.URI.revive(s),{document:h}=this.i(d,l);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(s,d,c,l,h,k){const C=this.b.get(c);if(!C)throw new Error(`No provider found for '${c}'`);const m=y.ViewColumn.to(h),p=this.g.createNewWebview(d,l.contentOptions,C.extension),v=this.h.createNewWebviewPanel(d,c,l.title,m,l.options,p,l.active),E=b.URI.revive(s);switch(C.type){case 1:{const{document:N}=this.i(c,E);return C.provider.resolveCustomEditor(N,v,k)}case 0:{const N=this.d.getDocument(E);return C.provider.resolveCustomTextEditor(N,v,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,c){this.i(d,s).disposeEdits(c)}async $onMoveCustomEditor(s,d,c){const l=this.b.get(c);if(!l)throw new Error(`No provider found for '${c}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this.h.getWebviewPanel(s);if(!h)throw new Error("No webview found");const k=b.URI.revive(d),C=this.d.getDocument(k);await l.provider.moveCustomTextEditor(C,h,I.CancellationToken.None)}async $undo(s,d,c,l){return this.i(d,s).undo(c,l)}async $redo(s,d,c,l){return this.i(d,s).redo(c,l)}async $revert(s,d,c){const l=this.i(d,s);await this.j(d).revertCustomDocument(l.document,c),l.disposeBackup()}async $onSave(s,d,c){const l=this.i(d,s);await this.j(d).saveCustomDocument(l.document,c),l.disposeBackup()}async $onSaveAs(s,d,c,l){const h=this.i(d,s);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(c),l)}async $backup(s,d,c){const l=this.i(d,s),k=await this.j(d).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},c);return l.updateBackup(k),k.id}i(s,d){const c=this.c.get(s,b.URI.revive(d));if(!c)throw new Error("No custom document found");return c}j(s){const c=this.b.get(s)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.$bec=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Ji)(s)+""}}),define(ke[345],Se([1,0,4,3,2,32,15,93,6,7]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class A extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(D,w,u,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=w,this.#o=u,this.#i=o.viewType,this.#r=o.panelOptions,this.#s=o.viewColumn,this.#n=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#a}set iconPath(D){this.c(),this.#a!==D&&(this.#a=D,this.#t.$setIconPath(this.#e,f.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(D){this.#l||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#u=D.active,this.#c=D.visible,this.#s=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:L.ViewColumn.from(D),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends F.$Rc{static c(){return(0,R.$ig)()}constructor(D,w,u){super(),this.j=w,this.m=u,this.g=new Map,this.h=new Map,this.f=D.getProxy(y.$yK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(D=>D.dispose()),this.g.clear()}createWebviewPanel(D,w,u,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,b.$9dc)(D),t=P.c();this.f.$createWebviewPanel((0,b.$$dc)(D),t,w,{title:u,panelOptions:$(i),webviewOptions:(0,b.$_dc)(D,this.m,i),serializeBuffersForPostMessage:a},r);const s=this.j.createNewWebview(t,i,D);return this.createNewWebviewPanel(t,w,u,n,i,s,!0)}$onDidChangeWebviewPanelViewStates(D){const w=Object.keys(D);w.sort((u,o)=>{const i=D[u],n=D[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const u of w){const o=this.getWebviewPanel(u);if(!o)continue;const i=D[u];o._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.g.delete(D),this.j.deleteWebview(D)}registerWebviewPanelSerializer(D,w,u){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:u,extension:D}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,b.$9dc)(D)}),new g.$AK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(D,w,u,o){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(D,u.webviewOptions,r),t=this.createNewWebviewPanel(D,w,u.title,o,u.panelOptions,a,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(D,w,u,o,i,n,r){const a=new A(D,this.f,n,{viewType:w,title:u,viewColumn:o,panelOptions:i,active:r});return this.g.set(D,a),a}getWebviewPanel(D){return this.g.get(D)}}e.$aec=P;function $(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(ke[346],Se([1,0,4,3,93,15,6,7]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class y extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(P,$,S,D,w,u){super(),this.#r=!1,this.#u=this.B(new I.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$Rd),this.onDidDispose=this.#l.event,this.#i=S,this.#a=D,this.#e=P,this.#t=$,this.#o=w,this.#n=u}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#s}set description(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#r||(this.#n=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(P,$){this.d=$,this.b=new Map,this.c=new Map,this.a=P.getProxy(L.$yK.MainThreadWebviewViews)}registerWebviewViewProvider(P,$,S,D){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:S,extension:P}),this.a.$registerWebviewViewProvider((0,f.$$dc)(P),$,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$9dc)(P)}),new b.$AK(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(P,$,S,D,w){const u=this.b.get($);if(!u)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:i}=u,n=this.d.createNewWebview(P,{},i),r=new y(P,this.a,$,S,n,!0);this.c.set(P,r),await o.resolveWebviewView(r,{state:D},w)}async $onDidChangeWebviewViewVisibility(P,$){this.e(P)._setVisible($)}async $disposeWebviewView(P){const $=this.e(P);this.c.delete(P),$.dispose(),this.d.deleteWebview(P)}e(P){const $=this.c.get(P);if(!$)throw new Error("No webview found");return $}}e.$Efc=g}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,I,F,f,R,L,b,y,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(S){const D=this.d;return{get focused(){return D.focused},get active(){return(0,g.$NF)(S,"windowActivity"),D.active}}}constructor(S){this.c=new I.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=S.getProxy(F.$yK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:w})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,D){D!==this.d[S]&&(this.d={...this.d,[S]:D},this.c.fire(this.d))}openUri(S,D){let w;if(typeof S=="string"){w=S;try{S=f.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,L.$Fe)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,w,D)}async asExternalUri(S,D){if((0,L.$Fe)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(S,D);return f.URI.from(w)}};e.$Ffc=P,e.$Ffc=P=A=He([Be(0,y.$AM)],P),e.$Gfc=(0,b.$Vh)("IExtHostWindow")}),define(ke[347],Se([1,0,315,27,20]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;const R=1024*1024;let L=class extends I.$Jfc{constructor(y,g){super(y,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,g,A){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),g.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,g){const A=process[y],P=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(S,D,w)=>{if(!this.g){$+=S.toString(D);const u=$.length>R?$.length:$.lastIndexOf(`
`);u!==-1&&(console[g]($.slice(0,u)),$=$.slice(u+1))}P.call(A,S,D,w)}})}};e.$igc=L,e.$igc=L=He([Be(0,f.$AM),Be(1,F.$QM)],L)}),define(ke[348],Se([1,0,71,17,14,250,31,12]),function(me,e,I,F,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;let y=class{constructor(P,$){P.addFileSystemProvider(F.Schemas.file,new g($),{isCaseSensitive:b.$k})}};e.$jgc=y,e.$jgc=y=He([Be(0,I.$5dc),Be(1,f.$dj)],y);class g{constructor(P){this.b=P,this.a=new R.$gq(this.b)}async stat(P){const $=await this.a.stat(P);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,$,S){return this.a.writeFile(P,$,{...S,unlock:!1,atomic:!1})}delete(P,$){return this.a.delete(P,{...$,useTrash:!1,atomic:!1})}rename(P,$,S){return this.a.rename(P,$,S)}copy(P,$,S){return this.a.copy(P,$,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,$){throw new Error("Method not implemented.")}}}),define(ke[349],Se([1,0,16,63,32,35,3,6,2,20]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;let A=class extends L.$Rc{constructor($,S){super();const D=$.getProxy(b.$yK.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async w=>{const u=y.URI.file((0,I.$ic)((0,F.tmpdir)(),(0,f.$ig)()));return await D.$download(w,u),u})}};e.$hgc=A,e.$hgc=A=He([Be(0,g.$AM),Be(1,R.$WM)],A)}),define(ke[350],Se([1,0,152,17,252,32]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;class L extends I.$Ifc{s(y,g,A){return y.scheme===F.Schemas.file?new f.$MN(A?.name||(0,R.$ig)(),y.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,g):super.s(y,g,A)}registerLogger(y){super.registerLogger(y),this.r.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.r.$deregisterLogger(y)}}e.$ugc=L}),define(ke[351],Se([1,0,55,16,2,92,3,17,11,30]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;class A extends R.$7dc{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==b.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let c=0;do{let l;c===0?l=d:l=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${c}`:`${d}-${c}`,await P(l);const h=F.$ic(l,"vscode.lock"),k=await w(this.d,h,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),f.URI.file(l);c++}while(c<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$tgc=A;async function P(a){try{await g.Promises.stat(a);return}catch{}try{await g.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,S=10*60*1e3;class D extends L.$Rc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new y.$9g),this.a.cancelAndSet(async()=>{const d=await u(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(s,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${s}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function w(a,t,s){try{const c={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){a.error(c)}const d=await u(a,t);return!d||d.pid!==process.pid?s?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new D(a,t))}async function u(a,t){let s;try{s=await g.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(s))}catch(d){return a.error(d),null}}async function o(a,t){let s;try{s=await g.Promises.stat(t)}catch(d){return a.error(d),0}return s.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const s=await u(a,t);if(!s)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(s.willReleaseAt){let k=s.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,y.$Yg)(Math.min(100,k)),await o(a,t)===0)return r(a,t);k=s.willReleaseAt-Date.now()}return r(a,t)}}if(!i(s.pid))return a.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),r(a,t);const d=await o(a,t),c=Date.now()-d;if(c<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.$Yg)(2e3);const l=await o(a,t),h=Date.now()-l;return h<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[352],Se([1,0,32,20,46,35]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;let L=class extends f.$qec{constructor(y,g){super(!0,y,g)}createTerminal(y,g,A){return this.createTerminalFromOptions({name:y,shellPath:g,shellArgs:A})}createTerminalFromOptions(y,g){const A=new f.$pec(this.a,(0,I.$ig)(),y,y.name);return this.f.push(A),A.create(y,this.R(y,g)),A.value}};e.$Ofc=L,e.$Ofc=L=He([Be(0,R.$WM),Be(1,F.$AM)],L)}),define(ke[353],Se([1,0,11,22,21,8,4,3,131,304,68]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.ResponsiveState=e.RequestInitiator=e.$X5b=e.$W5b=void 0;function $(v,E){try{return JSON.stringify(v,E)}catch{return"null"}}const S="$$ref$$",D={[S]:-1};class w{constructor(E,N){this.jsonString=E,this.referencedBuffers=N}}function u(v,E=null,N=!1){const z=[];return{jsonString:(N?$:JSON.stringify)(v,(T,j)=>{if(typeof j>"u")return D;if(typeof j=="object"){if(j instanceof F.$fe){const O=z.push(j)-1;return{[S]:O}}if(E)return E(T,j)}return j}),referencedBuffers:z}}e.$W5b=u;function o(v,E,N){return JSON.parse(v,(z,M)=>{if(M){const T=M[S];if(typeof T=="number")return E[T];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$X5b=o;function i(v,E){return JSON.stringify(v,E)}function n(v){return v?(E,N)=>N&&N.$mid===1?v.transformOutgoing(N):N:null}var r;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},s=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class c extends b.$Rc{static{P=s}static{this.a=3*1e3}constructor(E,N=null,z=null){super(),this[P]=!0,this.b=this.B(new L.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=E,this.f=N,this.g=z,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,T=A.$uv.count;M<T;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$0g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(E=>{const N=this.w[E];delete this.w[E],N.resolveErr(R.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(E){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(E){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(E){this.y!==E&&(this.y=E,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(E){return this.g?(0,y.$Um)(E,this.g):E}getProxy(E){const{nid:N,sid:z}=E;return this.s[N]||(this.s[N]=this.J(N,z)),this.s[N]}J(E,N){const z={get:(M,T)=>(typeof T=="string"&&!M[T]&&T.charCodeAt(0)===36&&(M[T]=(...j)=>this.U(E,T,j)),T===d?N:M[T])};return new Proxy(Object.create(null),z)}set(E,N){return this.m[E.nid]=N,N}assertRegistered(E){for(let N=0,z=E.length;N<z;N++){const M=E[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(E){if(this.j)return;const N=E.byteLength,z=h.read(E,0),M=z.readUInt8(),T=z.readUInt32();switch(M){case 1:case 2:{let{rpcId:j,method:O,args:V}=C.deserializeRequestJSONArgs(z);this.g&&(V=(0,y.$Um)(V,this.g)),this.M(N,T,j,O,V,M===2);break}case 3:case 4:{let{rpcId:j,method:O,args:V}=C.deserializeRequestMixedArgs(z);this.g&&(V=(0,y.$Um)(V,this.g)),this.M(N,T,j,O,V,M===4);break}case 5:{this.f?.logIncoming(N,T,0,"ack"),this.G(T);break}case 6:{this.N(N,T);break}case 7:{this.O(N,T,void 0);break}case 9:{let j=C.deserializeReplyOKJSON(z);this.g&&(j=(0,y.$Um)(j,this.g)),this.O(N,T,j);break}case 10:{const j=C.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(N,T,j);break}case 8:{const j=C.deserializeReplyOKVSBuffer(z);this.O(N,T,j);break}case 11:{let j=C.deserializeReplyErrError(z);this.g&&(j=(0,y.$Um)(j,this.g)),this.P(N,T,j);break}case 12:{this.P(N,T,void 0);break}default:console.error("received unexpected message"),console.error(E)}}M(E,N,z,M,T,j){this.f?.logIncoming(E,N,1,`receiveRequest ${(0,A.$wv)(z)}.${M}(`,T);const O=String(N);let V,te;if(j){const Z=new f.$2d;T.push(Z.token),V=this.Q(z,M,T),te=()=>Z.cancel()}else V=this.Q(z,M,T),te=t;this.u[O]=te;const fe=C.serializeAcknowledged(N);this.f?.logOutgoing(fe.byteLength,N,1,"ack"),this.c.send(fe),V.then(Z=>{delete this.u[O];const Q=C.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(Q.byteLength,N,1,"reply:",Z),this.c.send(Q)},Z=>{delete this.u[O];const Q=C.serializeReplyErr(N,Z);this.f?.logOutgoing(Q.byteLength,N,1,"replyErr:",Z),this.c.send(Q)})}N(E,N){this.f?.logIncoming(E,N,1,"receiveCancel");const z=String(N);this.u[z]?.()}O(E,N,z){this.f?.logIncoming(E,N,0,"receiveReply:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const T=this.w[M];delete this.w[M],T.resolveOk(z)}P(E,N,z){this.f?.logIncoming(E,N,0,"receiveReplyErr:",z);const M=String(N);if(!this.w.hasOwnProperty(M))return;const T=this.w[M];delete this.w[M];let j;z&&(z.$isError?(j=new Error,j.name=z.name,j.message=z.message,j.stack=z.stack):j=z),T.resolveErr(j)}Q(E,N,z){try{return Promise.resolve(this.S(E,N,z))}catch(M){return Promise.reject(M)}}S(E,N,z){const M=this.m[E];if(!M)throw new Error("Unknown actor "+(0,A.$wv)(E));const T=M[N];if(typeof T!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$wv)(E));return T.apply(M,z)}U(E,N,z){if(this.j)return new g.$V5b;let M=null;if(z.length>0&&f.CancellationToken.isCancellationToken(z[z.length-1])&&(M=z.pop()),M&&M.isCancellationRequested)return Promise.reject(R.$5());const T=C.serializeRequestArguments(z,this.h),j=++this.t,O=String(j),V=new g.$U5b,te=new b.$Qc;M&&te.add(M.onCancellationRequested(()=>{const Z=C.serializeCancel(j);this.f?.logOutgoing(Z.byteLength,j,0,"cancel"),this.c.send(C.serializeCancel(j))})),this.w[O]=new l(V,te),this.F(j);const fe=C.serializeRequest(j,E,N,T,!!M);return this.f?.logOutgoing(fe.byteLength,j,0,`request: ${(0,A.$wv)(E)}.${N}(`,z),this.c.send(fe),V}}e.$Y5b=c;class l{constructor(E,N){this.a=E,this.b=N}resolveOk(E){this.a.resolveOk(E),this.b.dispose()}resolveErr(E){this.a.resolveErr(E),this.b.dispose()}}class h{static alloc(E,N,z){const M=new h(F.$fe.alloc(z+1+4),0);return M.writeUInt8(E),M.writeUInt32(N),M}static read(E,N){return new h(E,N)}get buffer(){return this.a}constructor(E,N){this.a=E,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(E){this.a.writeUInt8(E,this.b),this.b+=1}readUInt8(){const E=this.a.readUInt8(this.b);return this.b+=1,E}writeUInt32(E){this.a.writeUInt32BE(E,this.b),this.b+=4}readUInt32(){const E=this.a.readUInt32BE(this.b);return this.b+=4,E}static sizeShortString(E){return 1+E.byteLength}writeShortString(E){this.a.writeUInt8(E.byteLength,this.b),this.b+=1,this.a.set(E,this.b),this.b+=E.byteLength}readShortString(){const E=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+E).toString();return this.b+=E,z}static sizeLongString(E){return 4+E.byteLength}writeLongString(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readLongString(){const E=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+E).toString();return this.b+=E,z}writeBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}static sizeVSBuffer(E){return 4+E.byteLength}writeVSBuffer(E){this.a.writeUInt32BE(E.byteLength,this.b),this.b+=4,this.a.set(E,this.b),this.b+=E.byteLength}readVSBuffer(){const E=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+E);return this.b+=E,N}static sizeMixedArray(E){let N=0;N+=1;for(let z=0,M=E.length;z<M;z++){const T=E[z];switch(N+=1,T.type){case 1:N+=this.sizeLongString(T.value);break;case 2:N+=this.sizeVSBuffer(T.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(T.value);for(let j=0;j<T.buffers.length;++j)N+=this.sizeVSBuffer(T.buffers[j]);break;case 4:break}}return N}writeMixedArray(E){this.a.writeUInt8(E.length,this.b),this.b+=1;for(let N=0,z=E.length;N<z;N++){const M=E[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let T=0;T<M.buffers.length;++T)this.writeBuffer(M.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const E=this.a.readUInt8(this.b);this.b+=1;const N=new Array(E);for(let z=0;z<E;z++)switch(this.readUInt8()){case 1:N[z]=this.readLongString();break;case 2:N[z]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),j=this.readLongString(),O=[];for(let V=0;V<T;++V)O.push(this.readVSBuffer());N[z]=new A.$xv(o(j,O,null));break}case 4:N[z]=void 0;break}return N}}var k;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(k||(k={}));class C{static a(E){for(let N=0,z=E.length;N<z;N++)if(E[N]instanceof F.$fe||E[N]instanceof A.$xv||typeof E[N]>"u")return!0;return!1}static serializeRequestArguments(E,N){if(this.a(E)){const z=[];for(let M=0,T=E.length;M<T;M++){const j=E[M];if(j instanceof F.$fe)z[M]={type:2,value:j};else if(typeof j>"u")z[M]={type:4};else if(j instanceof A.$xv){const{jsonString:O,referencedBuffers:V}=u(j.value,N);z[M]={type:3,value:F.$fe.fromString(O),buffers:V}}else z[M]={type:1,value:F.$fe.fromString(i(j,N))}}return{type:1,args:z}}return{type:0,args:i(E,N)}}static serializeRequest(E,N,z,M,T){switch(M.type){case 0:return this.b(E,N,z,M.args,T);case 1:return this.c(E,N,z,M.args,T)}}static b(E,N,z,M,T){const j=F.$fe.fromString(z),O=F.$fe.fromString(M);let V=0;V+=h.sizeUInt8(),V+=h.sizeShortString(j),V+=h.sizeLongString(O);const te=h.alloc(T?2:1,E,V);return te.writeUInt8(N),te.writeShortString(j),te.writeLongString(O),te.buffer}static deserializeRequestJSONArgs(E){const N=E.readUInt8(),z=E.readShortString(),M=E.readLongString();return{rpcId:N,method:z,args:JSON.parse(M)}}static c(E,N,z,M,T){const j=F.$fe.fromString(z);let O=0;O+=h.sizeUInt8(),O+=h.sizeShortString(j),O+=h.sizeMixedArray(M);const V=h.alloc(T?4:3,E,O);return V.writeUInt8(N),V.writeShortString(j),V.writeMixedArray(M),V.buffer}static deserializeRequestMixedArgs(E){const N=E.readUInt8(),z=E.readShortString(),M=E.readMixedArray(),T=new Array(M.length);for(let j=0,O=M.length;j<O;j++){const V=M[j];typeof V=="string"?T[j]=JSON.parse(V):T[j]=V}return{rpcId:N,method:z,args:T}}static serializeAcknowledged(E){return h.alloc(5,E,0).buffer}static serializeCancel(E){return h.alloc(6,E,0).buffer}static serializeReplyOK(E,N,z){if(typeof N>"u")return this.d(E);if(N instanceof F.$fe)return this.e(E,N);if(N instanceof A.$xv){const{jsonString:M,referencedBuffers:T}=u(N.value,z,!0);return this.g(E,M,T)}else return this.f(E,$(N,z))}static d(E){return h.alloc(7,E,0).buffer}static e(E,N){let z=0;z+=h.sizeVSBuffer(N);const M=h.alloc(8,E,z);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(E){return E.readVSBuffer()}static f(E,N){const z=F.$fe.fromString(N);let M=0;M+=h.sizeLongString(z);const T=h.alloc(9,E,M);return T.writeLongString(z),T.buffer}static g(E,N,z){const M=F.$fe.fromString(N);let T=0;T+=h.sizeUInt32,T+=h.sizeLongString(M);for(const O of z)T+=h.sizeVSBuffer(O);const j=h.alloc(10,E,T);j.writeUInt32(z.length),j.writeLongString(M);for(const O of z)j.writeBuffer(O);return j.buffer}static deserializeReplyOKJSON(E){const N=E.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(E,N){const z=E.readUInt32(),M=E.readLongString(),T=[];for(let j=0;j<z;++j)T.push(E.readVSBuffer());return new A.$xv(o(M,T,N))}static serializeReplyErr(E,N){const z=N?$(R.$2(N),null):void 0;if(typeof z!="string")return this.h(E);const M=F.$fe.fromString(z);let T=0;T+=h.sizeLongString(M);const j=h.alloc(11,E,T);return j.writeLongString(M),j.buffer}static deserializeReplyErrError(E){const N=E.readLongString();return JSON.parse(N)}static h(E){return h.alloc(12,E,0).buffer}}var m;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var p;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(p||(p={}))}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.OutputChannelUpdateMode=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0,e.$JJ="text/x-code-output",e.$KJ="output",e.$LJ="Log",e.$MJ="text/x-code-log-output",e.$NJ="log",e.$OJ="workbench.panel.output",e.$PJ=new f.$aj("inOutput",!1),e.$QJ=new f.$aj("activeLogOutput",!1),e.$RJ=new f.$aj("outputView.scrollLock",!1),e.$SJ=(0,R.$Vh)("outputService");var L;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$TJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new I.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new I.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$mn.add(e.$TJ.OutputChannels,new b),e.$UJ=new f.$aj("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,14,354,71,27,57,182,22,18,31,4,3]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class o extends L.$jj{get disposed(){return this.n}constructor(a,t,s,d,c){super(),this.id=a,this.name=t,this.r=s,this.s=d,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$fe.fromString(t).byteLength,(0,L.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,s,d,c,l){this.i=t,this.j=s,this.k=d,this.l=c,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$yK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(a,t,s){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,c=(0,S.$Cf)(t)?t:void 0;if((0,S.$Cf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([C])=>R.$_l.equals(s.identifier,C))?.[1];h&&(l=(0,L.$tj)(h));const k=d?this.o(a,l,s):this.n(a,c,s);return k.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),d?this.r(a,l??this.m.getLevel(),k):this.q(a,k)}async n(a,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,c=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,c,t,s.identifier.value);return new o(h,a,l,this.a,s)}async o(a,t,s){const d=await this.p(s),c=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(d,`${c}.log`),h=`${s.identifier.value}.${c}`,k=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:s.identifier.value});return new i(h,a,k,this.a,s)}p(a){let t=this.d.get(a.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,D.$uk)(d)!==D.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(a,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return a},append(c){d(),t.then(l=>l.append(c))},appendLine(c){d(),t.then(l=>l.appendLine(c))},clear(){d(),t.then(c=>c.clear())},replace(c){d(),t.then(l=>l.replace(c))},show(c,l){d(),t.then(h=>h.show(c,l))},hide(){d(),t.then(c=>c.hide())},dispose(){s=!0,t.then(c=>c.dispose())}}}r(a,t,s){const d=new u.$Qc,c=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},l=d.add(new w.$Rd);function h(k){t=k,l.fire(k)}return s.then(k=>{d.add(k),k.logLevel!==t&&h(k.logLevel),d.add(k.onDidChangeLogLevel(C=>h(C)))}),{...this.q(a,s),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(k,...C){c(),s.then(m=>m.trace(k,...C))},debug(k,...C){c(),s.then(m=>m.debug(k,...C))},info(k,...C){c(),s.then(m=>m.info(k,...C))},warn(k,...C){c(),s.then(m=>m.warn(k,...C))},error(k,...C){c(),s.then(m=>m.error(k,...C))},dispose(){d.dispose()}}}};e.$ffc=n,e.$ffc=n=He([Be(0,f.$AM),Be(1,g.$QM),Be(2,y.$5dc),Be(3,A.$Edc),Be(4,L.$ej),Be(5,L.$dj)],n),e.$gfc=(0,F.$Vh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,11]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,I.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const y=await f.getRoundTripTime();if(y===void 0)return;R=Math.min(R,y/2),await(0,F.$Yg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((b,y)=>b+y,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((b,y)=>b+y,0)/this.average.length,high:(()=>typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,224,86,37,40,44,3,4,155,12,24]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$pH=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$qH=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$rH=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$sH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new y.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const S=new $;f.$mn.add(e.$sH.ConfigurationMigration,S);let D=class extends b.$Rc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,S.migrations)})),this.c(S.migrations),this.B(S.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(n=>this.g(n,o?.uri))])}async g(o,i){const n=this.a.inspect(o.key,{resource:i}),r=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of r){const s=[];for(const c of n.overrideIdentifiers??[]){const l=await this.h(o,{resource:i,overrideIdentifier:c},a);for(const h of l??[]){let k=s.find(([[C,m]])=>C===h[0]&&(0,P.$en)(m.value,h[1].value));k||s.push(k=[h,[]]),k[1].push(c)}}const d=await this.h(o,{resource:i},a,n);for(const c of d??[])s.push([c,[]]);s.length&&await Promise.allSettled(s.map(async([[c,l],h])=>this.a.updateValue(c,l.value,{resource:i,overrideIdentifiers:h},t)))}}async h(o,i,n,r){const a=(r??this.a.inspect(o.key,i))[n];if(a===void 0)return;const t=d=>this.a.inspect(d,i)[n],s=await o.migrateFn(a,t);return Array.isArray(s)?s:[[o.key,s]]}};e.$tH=D,e.$tH=D=He([Be(0,L.$pi),Be(1,R.$5h)],D);let w=class extends b.$Rc{constructor(o){super(),(async()=>{if(!A.$i&&(await o.getEnvironment())?.os!==1)return;f.$mn.as(F.$rn.Configuration).registerConfiguration({...e.$rH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(3,null)},default:[],markdownDescription:(0,I.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(5,null),scope:2}}})})()}};e.$uH=w,e.$uH=w=He([Be(0,g.$zm)],w)}),define(ke[356],Se([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcb=e.$Acb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$zcb=e.$ycb=void 0,e.$ycb=(0,g.$Vh)("editorResolverService"),e.$zcb="workbench.editorAssociations";const P=A.$mn.as(y.$rn.Configuration),$={...b.$qH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration($);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var D;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(D||(e.ResolvedStatus=D={}));function w(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}e.$Acb=w;function u(o,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$wg)(i);return I.$Bj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$Bcb=u}),define(ke[357],Se([1,0,33,17,16,12,23,2,5,268,40,146,155]),function(me,e,I,F,f,R,L,b,y,g,A,P,$){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0,e.$aK=(0,y.$Vh)("pathService");let D=S=class{constructor(u,o,i,n){this.d=u,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??u})()}hasValidBasename(u,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(u,n,o)):this.h(u,o,i)}h(u,o,i){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,I.$Zf)(i??(0,L.$wg)(u),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,o){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,g.$0J)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?f.$ec:f.$fc)}async fileURI(u){let o="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(o=u.substring(2),u="/"):(o=u.substring(2,n),u=u.substring(n)||"/")}return b.URI.from({scheme:F.Schemas.file,authority:o,path:u,query:"",fragment:""})}};e.$bK=D,e.$bK=D=S=He([Be(1,$.$zm),Be(2,P.$VJ),Be(3,A.$5h)],D)}),define(ke[358],Se([1,0,235,19,59,4,52,3,2,44,240,14,64,270,88,40,146,25,21,18,24,45]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7J=e.$6J=e.$5J=e.OnPortForward=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.TunnelSource=e.TunnelCloseReason=e.$YJ=e.$XJ=e.$WJ=void 0;const t=10*1e3,s="remote.tunnels.toRestore";e.$WJ="onTunnel",e.$XJ=new a.$aj("forwardedPortsViewEnabled",!1,I.localize(0,null));function d(N){const z=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$YJ=d;var c;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(c||(e.TunnelCloseReason=c={}));var l;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$ZJ={source:l.User,description:I.localize(1,null)},e.$1J={source:l.Auto,description:I.localize(2,null)};function h(N,z,M){const T=N.get(C(z,M));if(T)return T;if((0,D.$jv)(z))for(const j of D.$iv){const O=C(j,M);if(N.has(O))return N.get(O)}else if((0,D.$lv)(z))for(const j of D.$kv){const O=C(j,M);if(N.has(O))return N.get(O)}}e.$2J=h;function k(N,z,M){const T=h(N,z,M);if(T)return T;const j=(0,D.$lv)(z)?"localhost":(0,D.$jv)(z)?"0.0.0.0":void 0;if(j)return h(N,j,M)}e.$3J=k;function C(N,z){return N+":"+z}e.$4J=C;var m;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})(m||(e.OnPortForward=m={}));function p(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$5J=p;class v extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new R.$Rd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,M,T){let j=this.w(z,M,T,this.j,0);const O={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const V=this.j[j];V.key===z?(O.onAutoForward=V.onAutoForward??O.onAutoForward,O.elevateIfNeeded=V.elevateIfNeeded!==void 0?V.elevateIfNeeded:O.elevateIfNeeded,O.label=V.label??O.label,O.requireLocalPort=V.requireLocalPort,O.protocol=V.protocol):(O.onAutoForward=O.onAutoForward??V.onAutoForward,O.elevateIfNeeded=O.elevateIfNeeded!==void 0?O.elevateIfNeeded:V.elevateIfNeeded,O.label=O.label??V.label,O.requireLocalPort=O.requireLocalPort!==void 0?O.requireLocalPort:void 0,O.protocol=O.protocol??V.protocol),j=this.w(z,M,T,this.j,j+1)}return O.onAutoForward!==void 0||O.elevateIfNeeded!==void 0||O.label!==void 0||O.requireLocalPort!==void 0||O.protocol!==void 0?O:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,n.$Cf)(z.host)&&(0,n.$Gf)(z.port)}w(z,M,T,j,O){if(O>=j.length)return-1;const V=!(0,D.$jv)(M)&&!(0,D.$lv)(M),fe=j.slice(O).findIndex(Z=>(0,n.$Gf)(Z.key)?V?!1:Z.key===z:this.t(Z.key)?V?!1:z>=Z.key.start&&z<=Z.key.end:this.u(Z.key)?z===Z.key.port&&M===Z.key.host:T?Z.key.test(T):!1);return fe>=0?fe+O:-1}y(){const z=this.r.getValue(v.c);if(!z||!(0,n.$Ef)(z))return[];const M=[];for(const j in z){if(j===void 0)continue;const O=z[j];let V;if(Number(j))V=Number(j);else if((0,n.$Cf)(j))if(v.g.test(j)){const te=j.match(v.g);V={start:Number(te[1]),end:Number(te[2])}}else if(v.h.test(j)){const te=j.match(v.h);V={host:te[1],port:Number(te[2])}}else{let te;try{te=RegExp(j)}catch{}te&&(V=te)}V&&M.push({key:V,elevateIfNeeded:O.elevateIfNeeded,onAutoForward:O.onAutoForward,label:O.label,requireLocalPort:O.requireLocalPort,protocol:O.protocol})}const T=this.r.getValue(v.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(M)}z(z){function M(T,j){return(0,n.$Gf)(T.key)?T.key:j.t(T.key)?T.key.start:j.u(T.key)?T.key.port:Number.MAX_VALUE}return z.sort((T,j)=>M(T,this)-M(j,this))}C(){return this.m}static providedActionToAction(z){switch(z){case D.ProvidedOnAutoForward.Notify:return m.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return m.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return m.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return m.OpenPreview;case D.ProvidedOnAutoForward.Silent:return m.Silent;case D.ProvidedOnAutoForward.Ignore:return m.Ignore;default:return}}async addAttributes(z,M,T){const O=this.r.inspect(v.c).userRemoteValue;let V;!O||!(0,n.$Ef)(O)?V={}:V=(0,r.$an)(O),V[`${z}`]||(V[`${z}`]={});for(const te in M)V[`${z}`][te]=M[te];return this.r.updateValue(v.c,V,T)}}e.$6J=v;let E=class extends b.$Rc{constructor(z,M,T,j,O,V,te,fe,Z,Q){super(),this.H=z,this.I=M,this.J=T,this.L=j,this.M=O,this.N=V,this.O=te,this.P=fe,this.Q=Z,this.R=Q,this.c=new Map,this.g=new R.$Rd,this.onForwardPort=this.g.event,this.h=new R.$Rd,this.onClosePort=this.h.event,this.j=new R.$Rd,this.onPortName=this.j.event,this.n=new R.$Rd,this.onCandidatesChanged=this.n.event,this.t=new R.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new v(T),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async G=>{const oe=await this.getAttributes(G.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of G)if(x.localAddress){const Ee=C(x.tunnelRemoteHost,x.tunnelRemotePort),le=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(Ee,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:oe?.get(x.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(x.localAddress,oe?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:le?.detail,hasRunningProcess:!!le,pid:le?.pid,privacy:x.privacy,source:e.$ZJ}),this.f.set(Ee,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async G=>{const oe=C(G.tunnelRemoteHost,G.tunnelRemotePort);if(!k(this.forwarded,G.tunnelRemoteHost,G.tunnelRemotePort)&&!k(this.detected,G.tunnelRemoteHost,G.tunnelRemotePort)&&!k(this.c,G.tunnelRemoteHost,G.tunnelRemotePort)&&G.localAddress){const x=k(this.m??new Map,G.tunnelRemoteHost,G.tunnelRemotePort),Ee=(await this.getAttributes([{port:G.tunnelRemotePort,host:G.tunnelRemoteHost}]))?.get(G.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localAddress:G.localAddress,protocol:Ee?.protocol??D.TunnelProtocol.Http,localUri:await this.X(G.localAddress,Ee),localPort:G.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:G.privacy,source:e.$ZJ})}await this.$(),this.f.set(oe,G),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(G=>this.W(G,c.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$WJ))?(this.R.createKey(e.$XJ.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,M){const T=C(z.host,z.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.$(),this.h.fire(z))}X(z,M){if(z.startsWith("http"))return y.URI.parse(z);const T=M?.protocol??"http";return y.URI.parse(`${T}://${z}`)}async Y(){const z=this.N.getWorkspace(),M=z.configuration?(0,L.$Ji)(z.configuration.path):z.folders.length>0?(0,L.$Ji)(z.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${s}.${this.L.remoteAuthority}.${M}`}async Z(){const z=this.I.get(s,1);if(z)return this.I.remove(s,1),await this.$(),z;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const M=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(T=>T.remotePort).join(", ")}`);for(const T of M){const j=k(this.detected,T.remoteHost,T.remotePort);T.source.source!==l.Extension&&!j||T.source.source===l.Extension&&j?await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,privacy:T.privacy,elevateIfNeeded:!0,source:T.source}):T.source.source===l.Extension&&!j&&this.D.set(C(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(z,M,T){if(!z.tunnelLocalPort||!T?.requireLocalPort||z.tunnelLocalPort===M)return;const j=new Date;if(this.ab.getTime()+t>j.getTime())return;this.ab=j;const O=I.localize(3,null,M,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(O)}async forward(z,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(z,M)}async cb(z,M){await this.Q.activateByEvent(e.$WJ);const T=k(this.forwarded,z.remote.host,z.remote.port);M=M??(M!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const j=z.local!==void 0?z.local:z.remote.port;let O;if(T)return this.eb(T,z,M);{const V=this.L.remoteAuthority,te=V?{getAddress:async()=>(await this.M.resolveAuthority(V)).authority}:void 0,fe=C(z.remote.host,z.remote.port);this.c.set(fe,!0),z=this.db(fe,z);const Z=await this.H.openTunnel(te,z.remote.host,z.remote.port,void 0,j,z.elevateIfNeeded?z.elevateIfNeeded:M?.elevateIfNeeded,z.privacy,M?.protocol);if(typeof Z=="string")O=Z;else if(Z&&Z.localAddress){const Q=k(this.m??new Map,z.remote.host,z.remote.port),G=Z.protocol?Z.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:M?.protocol??D.TunnelProtocol.Http,oe={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:M?.label??z.name,closeable:!0,localAddress:Z.localAddress,protocol:G,localUri:await this.X(Z.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:z.source??e.$ZJ,privacy:Z.privacy};return this.forwarded.set(fe,oe),this.f.set(fe,Z),this.c.delete(fe),await this.$(),await this.bb(Z,j,M),this.g.fire(oe),Z}this.c.delete(fe)}return O}db(z,M){const T=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(T){const j=T.get(z);T.delete(z),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=j.privacy??M.privacy)}return M}async eb(z,M,T){const j=T?.label??M.name;let O;(function(te){te[te.None=0]="None",te[te.Fire=1]="Fire",te[te.Reopen=2]="Reopen"})(O||(O={}));let V=O.None;switch(j!==z.name&&(z.name=j,V=O.Fire),(T?.protocol||z.protocol!==D.TunnelProtocol.Http)&&T?.protocol!==z.protocol&&(M.source=z.source,V=O.Reopen),M.privacy&&z.privacy!==M.privacy&&(V=O.Reopen),V){case O.Fire:{this.g.fire();break}case O.Reopen:await this.close(z.remoteHost,z.remotePort,c.User),await this.cb(M,T)}return k(this.f,M.remote.host,M.remote.port)}async name(z,M,T){const j=k(this.forwarded,z,M),O=C(z,M);if(j){j.name=T,await this.$(),this.j.fire({host:z,port:M});return}else this.detected.has(O)&&(this.detected.get(O).name=T,this.j.fire({host:z,port:M}))}async close(z,M,T){const j=C(z,M),O=this.forwarded.get(j);return T===c.AutoForwardEnd&&O&&O.source.source===l.Auto&&this.F.set(j,{local:O.localPort,name:O.name,privacy:O.privacy}),await this.H.closeTunnel(z,M),this.W({host:z,port:M},T)}address(z,M){const T=C(z,M);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const M of z){const T=k(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:C(M.localAddress.host,M.localAddress.port);this.detected.set(C(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:D.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let M=z;this.r&&(M=await this.r(z));const T=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(j=>j.port).join(", ")}`),this.n.fire(T)}fb(z){const M=this.m??new Map,T=new Map;return this.m=T,z.forEach(j=>{const O=C(j.host,j.port);T.set(O,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(O)&&M.delete(O);const V=k(this.forwarded,j.host,j.port);V&&(V.runningProcess=j.detail,V.hasRunningProcess=!0,V.pid=j.pid)}),M.forEach((j,O)=>{const V=d(O);if(!V)return;const te=k(this.forwarded,V.host,V.port);te&&(te.runningProcess=void 0,te.hasRunningProcess=!1,te.pid=void 0);const fe=k(this.detected,V.host,V.port);fe&&(fe.runningProcess=void 0,fe.hasRunningProcess=!1,fe.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),M=await this.getAttributes(z.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(M)for(const T of z){const j=M.get(T.remotePort);(j?.protocol||T.protocol!==D.TunnelProtocol.Http)&&j?.protocol!==T.protocol&&await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},j),j&&j.label&&j.label!==T.name&&await this.name(T.remoteHost,T.remotePort,j.label)}}async getAttributes(z,M=!0){const T=new Map,j=new Map;z.forEach(Z=>{const Q=k(this.m??new Map,D.$iv[0],Z.port)??Z;if(Q){T.set(Z.port,Q);const G=p(Q)?Q.pid:void 0;j.has(G)||j.set(G,[]),j.get(G)?.push(Z.port)}});const O=new Map;if(z.forEach(Z=>{const Q=this.configPortsAttributes.getAttributes(Z.port,Z.host,T.get(Z.port)?.detail);Q&&O.set(Z.port,Q)}),this.G.length===0||!M)return O.size>0?O:void 0;const V=await Promise.all((0,F.$Qb)(this.G.map(Z=>Array.from(j.entries()).map(Q=>{const G=Q[1],oe=T.get(G[0]);return Z.providePortAttributes(G,oe?.pid,oe?.detail,new i.$2d().token)})))),te=new Map;if(V.forEach(Z=>Z.forEach(Q=>{Q&&te.set(Q.port,Q)})),!O&&!te)return;const fe=new Map;return z.forEach(Z=>{const Q=O.get(Z.port),G=te.get(Z.port);fe.set(Z.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(G?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),fe}addAttributesProvider(z){this.G.push(z)}};e.$7J=E,He([(0,f.$oh)(1e3)],E.prototype,"$",null),e.$7J=E=He([Be(0,D.$ev),Be(1,S.$_o),Be(2,g.$pi),Be(3,u.$VJ),Be(4,$.$Vk),Be(5,w.$5h),Be(6,P.$dj),Be(7,A.$Iv),Be(8,o.$JF),Be(9,a.$bj)],E)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$QI=e.$PI=void 0;class I{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new I(0,0)}with(L){return new I(0,0)}}e.$PI=I;class F{constructor(L,b,y,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(L,b),this.end=new I(y,g)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new F(0,0,0,0)}with(L){return new F(0,0,0,0)}}e.$QI=F;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,11]),function(me,e,I,F,f,R,L,b,y,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchErrorCode=e.$6I=e.$5I=e.SearchSortOrder=e.ViewMode=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchCompletionExitCode=e.$ZI=e.$YI=e.$XI=e.QueryType=e.SearchProviderType=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$RI="workbench.view.search",e.$SI="workbench.panel.search",e.$TI="workbench.view.search",e.$UI="search-result",e.$VI="search.exclude";const $="\u27EA ",S=" characters skipped \u27EB",D=($.length+S.length+5)*2;e.$WI=(0,b.$Vh)("searchService");var w;(function(G){G[G.file=0]="file",G[G.text=1]="text"})(w||(e.SearchProviderType=w={}));var u;(function(G){G[G.File=1]="File",G[G.Text=2]="Text"})(u||(e.QueryType=u={}));function o(G){return!!G.preview}e.$XI=o;function i(G){return!!G.resource}e.$YI=i;function n(G){return!!G.message}e.$ZI=n;var r;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(oe){this.resource=oe,this.results=[]}}e.$1I=a;class t{constructor(oe,x,Ee,le){this.ranges=x,this.webviewIndex=le;const q=Array.isArray(x)?x:[x];if(Ee&&Ee.matchLines===1&&s(q)){oe=(0,L.$vf)(oe,Ee.matchLines);let U="",ie=0,be=0;const H=Math.floor(Ee.charsPerLine/5),X=[];for(const Y of q){const $e=Math.max(Y.startColumn-H,0),ne=Y.startColumn+Ee.charsPerLine;if($e>be+H+D){const de=$+($e-be)+S;U+=de+oe.slice($e,ne),ie+=$e-(be+de.length)}else U+=oe.slice(be,ne);X.push(new c(0,Y.startColumn-ie,Y.endColumn-ie)),be=ne}this.preview={text:U,matches:Array.isArray(this.ranges)?X:X[0]}}else{const U=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:oe,matches:(0,I.$1b)(x,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$2I=t;function s(G){const oe=G[0].startLineNumber;for(const x of G)if(x.startLineNumber!==oe||x.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,x,Ee,le){this.startLineNumber=oe,this.startColumn=x,this.endLineNumber=Ee,this.endColumn=le}}e.$3I=d;class c extends d{constructor(oe,x,Ee){super(oe,x,oe,Ee)}}e.$4I=c;var l;(function(G){G.List="list",G.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function k(G,oe=!0){const x=G&&G.files&&G.files.exclude,Ee=oe&&G&&G.search&&G.search.exclude;if(!x&&!Ee)return;if(!x||!Ee)return x||Ee;let le=Object.create(null);return le=f.$dn(le,f.$an(x)),le=f.$dn(le,f.$an(Ee),!0),le}e.$5I=k;function C(G,oe){return G.excludePattern&&F.$Bj(G.excludePattern,oe)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&F.$Bj(G.includePattern,oe)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(x=>{const Ee=x.folder.fsPath;if(R.$2f(oe,Ee)){const le=y.$kc(Ee,oe);return!x.includePattern||!!F.$Bj(x.includePattern,le)}else return!1}):!1:!0}e.$6I=C;var m;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class p extends Error{constructor(oe,x){super(oe),this.code=x}}e.$7I=p;function v(G){const oe=G.message;if((0,g.$3)(G))return new p(oe,m.canceled);try{const x=JSON.parse(oe);return new p(x.message,x.code)}catch{return new p(oe,m.other)}}e.$8I=v;function E(G){const oe={message:G.message,code:G.code};return new Error(JSON.stringify(oe))}e.$9I=E;function N(G){return G.type==="error"?!0:G.type==="success"}e.$0I=N;function z(G){return G.type==="success"}e.$$I=z;function M(G){return!!G.path}e.$_I=M;function T(G,oe){const x=G.searchPath?G.searchPath:G.relativePath;return(0,L.$sf)(x,oe)}e.$aJ=T;class j{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$bJ=j;function O(G,oe){const x={...G||{},...oe||{}};return Object.keys(x).filter(Ee=>{const le=x[Ee];return typeof le=="boolean"&&le})}e.$cJ=O;class V{constructor(oe,x){this.c=null,this.a={...oe.excludePattern||{},...x.excludePattern||{}},this.b=F.$Cj(this.a);let Ee=oe.includePattern;x.includePattern&&(Ee?Ee={...Ee,...x.includePattern}:Ee=x.includePattern),Ee&&(this.c=F.$Cj(Ee))}matchesExcludesSync(oe,x,Ee){return!!(this.b&&this.b(oe,x,Ee))}includedInQuerySync(oe,x,Ee){return!(this.b&&this.b(oe,x,Ee)||this.c&&!this.c(oe,x,Ee))}includedInQuery(oe,x,Ee){const le=this.b(oe,x,Ee),q=()=>this.c?!!this.c(oe,x,Ee):!0;return(0,P.$Kg)(le)?le.then(U=>U?!1:q()):q()}hasSiblingExcludeClauses(){return te(this.a)}}e.$dJ=V;function te(G){for(const oe in G)if(typeof G[oe]!="boolean")return!0;return!1}function fe(G){if(!G)return;let oe;return x=>(oe||(oe=(G()||Promise.resolve([])).then(Ee=>Ee?Q(Ee):{})),oe.then(Ee=>!!Ee[x]))}e.$eJ=fe;function Z(G){if(!G)return;let oe;return x=>{if(!oe){const Ee=G();oe=Ee?Q(Ee):{}}return!!oe[x]}}e.$fJ=Z;function Q(G){const oe={};for(const x of G)oe[x]=!0;return oe}}),define(ke[41],Se([1,0,19,11,21,4,3,77,17,123,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=void 0;function h(z,M,T){return new A.$og(j=>p(j,T)).isEqual(z,M)}function k(z,M,T){return h(z.uri,M.uri,T)?0:(0,P.$Ye)(z.uri.toString(),M.uri.toString())}function C(z,M,T){return z.index!==M.index?z.index<M.index?-1:1:h(z.uri,M.uri,T)?(0,P.$Ye)(z.name,M.name):(0,P.$Ye)(z.uri.toString(),M.uri.toString())}function m(z,M,T,j){const O=z.slice(0).sort((te,fe)=>T(te,fe,j)),V=M.slice(0).sort((te,fe)=>T(te,fe,j));return(0,I.$Db)(O,V,(te,fe)=>T(te,fe,j))}function p(z,M){const T=M.getCapabilities(z.scheme);return!(T&&T&1024)}class v extends o.$ci{static toExtHostWorkspace(M,T,j,O){if(!M)return{workspace:null,added:[],removed:[]};const{id:V,name:te,folders:fe,configuration:Z,transient:Q,isUntitled:G}=M,oe=[],x=T;T?fe.forEach((U,ie)=>{const be=$.URI.revive(U.uri),H=v.o(j||T,be,O);H?(H.name=U.name,H.index=U.index,oe.push(H)):oe.push({uri:be,name:U.name,index:ie})}):oe.push(...fe.map(({uri:U,name:ie,index:be})=>({uri:$.URI.revive(U),name:ie,index:be}))),oe.sort((U,ie)=>U.index<ie.index?-1:1);const Ee=new v(V,te,oe,!!Q,Z?$.URI.revive(Z):null,!!G,U=>p(U,O)),{added:le,removed:q}=m(x?x.workspaceFolders:[],Ee.workspaceFolders,k,O);return{workspace:Ee,added:le,removed:q}}static o(M,T,j){for(let O=0;O<M.folders.length;O++){const V=M.workspaceFolders[O];if(h(V.uri,T,j))return V}}constructor(M,T,j,O,V,te,fe){super(M,j.map(Z=>new o.$di(Z)),O,V,fe),this.t=T,this.u=te,this.q=[],this.s=b.$2h.forUris(fe),j.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,T){return T&&this.s.get(M)&&(M=(0,A.$yg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let E=class{constructor(M,T,j,O,V){this.c=new R.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Td,this.B=new Map,this.h=O,this.s=j,this.t=V,this.j=new g.$Wl,this.k=new F.$Wg,this.o=M.getProxy(c.$yK.MainThreadWorkspace),this.q=M.getProxy(c.$yK.MainThreadMessageService);const te=T.workspace;this.l=te?new v(te.id,te.name,[],!!te.transient,te.configuration?$.URI.revive(te.configuration):null,!!te.isUntitled,fe=>p(fe,j)):void 0}$initializeWorkspace(M,T){this.v=T,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:y.Schemas.untitled,path:(0,A.$wg)((0,A.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,T,j,...O){const V=[];if(Array.isArray(O)&&O.forEach(G=>{$.URI.isUri(G.uri)&&!V.some(oe=>h(oe.uri,G.uri,this.s))&&V.push({uri:G.uri,name:G.name||(0,A.$vg)(G.uri)})}),this.n||[T,j].some(G=>typeof G!="number"||G<0)||j===0&&V.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(T+j>te.length)return!1;const fe=te.slice(0);fe.splice(T,j,...V.map(G=>({uri:G.uri,name:G.name||(0,A.$vg)(G.uri),index:void 0})));for(let G=0;G<fe.length;G++){const oe=fe[G];if(fe.some((x,Ee)=>Ee!==G&&h(oe.uri,x.uri,this.s)))return!1}fe.forEach((G,oe)=>G.index=oe);const{added:Z,removed:Q}=m(te,fe,C,this.s);if(Z.length===0&&Q.length===0)return!1;if(this.o){const G=M.displayName||M.name;this.o.$updateWorkspaceFolders(G,T,j,V).then(void 0,oe=>{this.n=void 0;const x={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(u.Severity.Error,(0,S.localize)(0,null,G,oe.toString()),x,[])})}return this.y(fe),!0}getWorkspaceFolder(M,T){if(this.x)return this.x.getWorkspaceFolder(M,T)}async getWorkspaceFolder2(M,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,T)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,T){let j,O="";if(typeof M=="string"?(j=$.URI.file(M),O=M):typeof M<"u"&&(j=M,O=M.fsPath),!j)return O;const V=this.getWorkspaceFolder(j,!0);if(!V)return O;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let te=(0,A.$Bg)(V.uri,j);return T&&V.name&&(te=`${V.name}/${te}`),te}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:T,added:j,removed:O}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:O}))}findFiles(M,T,j,O,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(T===null?te=!1:T&&(typeof T=="string"?te=T:te=T.pattern),V&&V.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:Z}=N(a.GlobPattern.from(M));return this.o.$startFileSearch(fe??null,Z??null,te??null,j??null,V).then(Q=>Array.isArray(Q)?Q.map(G=>$.URI.revive(G)):[])}async findTextInFiles(M,T,j,O,V=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),fe=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:Z,folder:Q}=N(a.GlobPattern.from(T.include)),G=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,oe={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:fe,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:Z,excludePattern:G},x=!1;if(this.u[te]=Ee=>{if(x)return;const le=$.URI.revive(Ee.resource);Ee.results.forEach(q=>{const U=(0,l.$sh)(q);(0,d.$XI)(U)?j({uri:le,preview:{text:U.preview.text,matches:(0,I.$1b)(U.preview.matches,ie=>new t.$CK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,I.$1b)(U.ranges,ie=>new t.$CK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):j({uri:le,text:U.text,lineNumber:U.lineNumber})})},V.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(M,Q??null,oe,te,V);return delete this.u[te],Ee||{}}catch(Ee){throw delete this.u[te],Ee}}$handleTextSearchResult(M,T){this.u[T]?.(M)}async save(M){const T=await this.o.$save(M,{saveAs:!1});return $.URI.revive(T)}async saveAs(M){const T=await this.o.$save(M,{saveAs:!0});return $.URI.revive(T)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,T){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,T);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,j),(0,L.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(M,T){this.h.info("Getting edit session identifier for workspaceFolder",M);const j=await this.resolveWorkspaceFolder($.URI.revive(M));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const O=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!O),!O)return;const V=await O.provideEditSessionIdentity(j,T);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(M,T,j,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const V=await this.resolveWorkspaceFolder($.URI.revive(M));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const te=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!te),!te)return;const fe=await te.provideEditSessionIdentityMatch?.(T,j,O);if(this.h.info("Provider returned edit session identifier match result: ",fe),!!fe)return fe}getOnWillCreateEditSessionIdentityEvent(M){return(T,j,O)=>{const V=function(fe){T.call(j,fe)};return V.extension=M,this.A.event(V,void 0,O)}}async $onWillCreateEditSessionIdentity(M,T,j){const O=await this.resolveWorkspaceFolder($.URI.revive(M));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},T,async(V,te)=>{const fe=Date.now();await Promise.resolve(V),Date.now()-fe>j&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(M,T){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,T);const j=this.t.transformOutgoingScheme(M),O=this.z++;return this.o.$registerCanonicalUriProvider(O,j),(0,L.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(M,T,j){const O=this.B.get(M.scheme);if(!O)return;const V=await O.provideCanonicalUri?.($.URI.revive(M),T,j);if(V)return V}async $provideCanonicalUri(M,T,j){return this.provideCanonicalUri($.URI.revive(M),{targetScheme:T},j)}};e.$Ydc=E,e.$Ydc=E=He([Be(0,r.$AM),Be(1,n.$QM),Be(2,i.$Edc),Be(3,w.$dj),Be(4,s.$Wdc)],E),e.$Zdc=(0,D.$Vh)("IExtHostWorkspace");function N(z){let M,T;return z&&(typeof z=="string"?M=z:(M=z.pattern,T=$.URI.revive(z.baseUri))),{includePattern:M,folder:T}}}),define(ke[42],Se([1,0,24,4,41,6,7,255,86,18,11,5,20,14,2]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=void 0;function w(s,d){if(d){const c=d.split(".");let l=s;for(let h=0;l&&h<c.length;h++)l=l[c[h]];return l}}function u(s){return s instanceof D.URI}function o(s){return s&&s.uri instanceof D.URI&&s.languageId&&typeof s.languageId=="string"}function i(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&s.uri instanceof D.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function r(s){if(u(s))return{resource:s};if(o(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(i(s))return{overrideIdentifier:s.languageId};if(n(s))return{resource:s.uri};if(s===null)return{resource:null}}let a=class{constructor(d,c,l){this.a=d.getProxy(R.$yK.MainThreadConfiguration),this.c=c,this.b=l,this.d=new A.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,c){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,c))}};e.$1dc=a,e.$1dc=a=He([Be(0,$.$AM),Be(1,f.$Zdc),Be(2,S.$dj)],a);class t{constructor(d,c,l,h){this.a=new F.$Rd,this.b=d,this.f=h,this.c=c,this.e=b.$Kn.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,c){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Kn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(c,l))}getConfiguration(d,c,l){const h=r(c)||{},k=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,l?.identifier);function C(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(p){return typeof w(k,p)<"u"},get:(p,v)=>{this.h(d?`${d}.${p}`:p,h,l?.identifier);let E=w(k,p);if(typeof E>"u")E=v;else{let N;const z=(M,T)=>{if((0,g.$Ef)(M)){let j;const O=()=>{N=N||(0,I.$an)(k),j=j||w(N,T)};return new Proxy(M,{get:(V,te)=>{if(typeof te=="string"&&te.toLowerCase()==="tojson")return O(),()=>j;if(N)return j=j||w(N,T),j[te];const fe=V[te];return typeof te=="string"?z(fe,`${T}.${te}`):fe},set:(V,te,fe)=>(O(),j&&(j[te]=fe),!0),deleteProperty:(V,te)=>(O(),j&&delete j[te],!0),defineProperty:(V,te,fe)=>(O(),j&&Object.defineProperty(j,te,fe),!0)})}return Array.isArray(M)?(0,I.$an)(M):M};E=z(E,p)}return E},update:(p,v,E,N)=>{p=d?`${d}.${p}`:p;const z=C(E);return v!==void 0?this.b.$updateConfigurationOption(z,p,v,h,N):this.b.$removeConfigurationOption(z,p,h,N)},inspect:p=>{p=d?`${d}.${p}`:p;const v=this.e.inspect(p,h,this.c.workspace);if(v)return{key:p,defaultValue:(0,I.$an)(v.policy?.value??v.default?.value),globalValue:(0,I.$an)(v.user?.value??v.application?.value),workspaceValue:(0,I.$an)(v.workspace?.value),workspaceFolderValue:(0,I.$an)(v.workspaceFolder?.value),defaultLanguageValue:(0,I.$an)(v.default?.override),globalLanguageValue:(0,I.$an)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,I.$an)(v.workspace?.override),workspaceFolderLanguageValue:(0,I.$an)(v.workspaceFolder?.override),languageIds:(0,I.$an)(v.overrideIdentifiers)}}};return typeof k=="object"&&(0,I.$dn)(m,k,!1),Object.freeze(m)}g(d){const c=l=>(0,g.$Ef)(l)?new Proxy(l,{get:(h,k)=>c(h[k]),set:(h,k,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(h,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(h,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return c(d)}h(d,c,l){const h=y.$Bn.test(d)?4:this.d.get(d),k=l?`[${l.value}] `:"";if(h===4){typeof c?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){c?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,c){const l=new b.$Mn(d,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,k)=>l.affectsConfiguration(h,r(k))})}k(d){return d.reduce((c,l)=>(c.set(l[0],l[1]),c),new Map)}}e.$2dc=t,e.$3dc=(0,P.$Vh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,11,4,6,7,41,69,42,21,46,20,27,5,17,12,14,91,303,8]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=e.$rfc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(a||(a={}));var t;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(t||(t={}));var s;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(s||(s={}));var d;(function(z){function M(O){if(O){const V=O;return V&&!!V.process}else return!1}z.is=M;function T(O){if(O==null)return;const V={process:O.process,args:O.args};return O.options&&(V.options=s.from(O.options)),V}z.from=T;function j(O){if(O!=null)return new L.$iL(O.process,O.args,O.options)}z.to=j})(d||(d={}));var c;(function(z){function M(j){if(j!=null)return j}z.from=M;function T(j){if(j!=null)return j}z.to=T})(c||(c={}));var l;(function(z){function M(O){if(O){const V=O;return V&&(!!V.commandLine||!!V.command)}else return!1}z.is=M;function T(O){if(O==null)return;const V={};return O.commandLine!==void 0?V.commandLine=O.commandLine:(V.command=O.command,V.args=O.args),O.options&&(V.options=c.from(O.options)),V}z.from=T;function j(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new L.$jL(O.commandLine,O.options):new L.$jL(O.command,O.args?O.args:[],O.options)}z.to=j})(l||(l={}));var h;(function(z){function M(O){if(O){const V=O;return V&&V.customExecution==="customExecution"}else return!1}z.is=M;function T(O){return{customExecution:"customExecution"}}z.from=T;function j(O,V){return V.get(O)}z.to=j})(h||(e.CustomExecutionDTO=h={}));var k;(function(z){function M(T,j){let O;return T.scope!==void 0&&typeof T.scope!="number"?O=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===L.TaskScope.Workspace&&j&&j.workspaceFile?O=j.workspaceFile:O=n.$9F),{id:T._id,workspaceFolder:O}}z.from=M})(k||(e.TaskHandleDTO=k={}));var C;(function(z){function M(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}z.from=M})(C||(C={}));var m;(function(z){function M(O,V){if(O==null)return[];const te=[];for(const fe of O){const Z=T(fe,V);Z&&te.push(Z)}return te}z.fromMany=M;function T(O,V){if(O==null)return;let te;O.execution instanceof L.$iL?te=d.from(O.execution):O.execution instanceof L.$jL?te=l.from(O.execution):O.execution&&O.execution instanceof L.$kL&&(te=h.from(O.execution));const fe=a.from(O.definition);let Z;return O.scope?typeof O.scope=="number"?Z=O.scope:Z=O.scope.uri:Z=L.TaskScope.Workspace,!fe||!Z?void 0:{_id:O._id,definition:fe,name:O.name,source:{extensionId:V.identifier.value,label:O.source,scope:Z},execution:te,isBackground:O.isBackground,group:C.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}z.from=T;async function j(O,V,te){if(O==null)return;let fe;d.is(O.execution)?fe=d.to(O.execution):l.is(O.execution)?fe=l.to(O.execution):h.is(O.execution)&&(fe=h.to(O._id,te));const Z=a.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await V.resolveWorkspaceFolder(I.URI.revive(O.source.scope)):Q=L.TaskScope.Workspace),!Z||!Q)return;const G=new L.$lL(Z,Q,O.name,O.source.label,fe,O.problemMatchers);return O.isBackground!==void 0&&(G.isBackground=O.isBackground),O.group!==void 0&&(G.group=L.$hL.from(O.group._id),G.group&&O.group.isDefault&&(G.group=new L.$hL(G.group.id,G.group.label),O.group.isDefault===!0&&(G.group.isDefault=O.group.isDefault))),O.presentationOptions&&(G.presentationOptions=t.to(O.presentationOptions)),O._id&&(G._id=O._id),O.detail&&(G.detail=O.detail),G}z.to=j})(m||(e.TaskDTO=m={}));var p;(function(z){function M(j){return j}z.from=M;function T(j){if(j)return Object.assign(Object.create(null),j)}z.to=T})(p||(p={}));class v{#e;constructor(M,T,j){this._id=T,this.a=j,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let E=class{constructor(M,T,j,O,V,te,fe,Z){this.q=new f.$Rd,this.r=new f.$Rd,this.s=new f.$Rd,this.t=new f.$Rd,this.a=M.getProxy(R.$yK.MainThreadTask),this.b=j,this.c=O,this.d=V,this.e=te,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=fe,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,T,j){if(!j)return new L.$AK(()=>{});const O=this.w();return this.j.set(O,{type:T,provider:j,extension:M}),this.a.$registerTaskProvider(O,T),new L.$AK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(M,T){this.a.$registerTaskSystem(M,T)}fetchTasks(M){return this.a.$fetchTasks(p.from(M)).then(async T=>{const j=[];for(const O of T){const V=await m.to(O,this.b,this.m);V&&j.push(V)}return j})}get taskExecutions(){const M=[];return this.k.forEach(T=>M.push(T)),M}terminateTask(M){if(!(M instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,T,j){const O=this.m.get(M.id);O&&(this.o.set(M.id,O),this.e.attachPtyToTerminal(T,await O.callback(j))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const T=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const T=await this.y(M.id);this.s.fire({execution:T,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const T=await this.y(M.id);this.t.fire({execution:T,exitCode:M.exitCode})}$provideTasks(M,T){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));const O=[],V=(0,F.$Qg)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(te=>this.u(T,O,j,te));return new Promise(te=>{V.then(fe=>{Promise.all(O).then(()=>{te(fe)})})})}async $resolveTask(M,T){const j=this.j.get(M);if(!j)return Promise.reject(new Error("no handler found"));if(T.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${j.type}].`);const O=await m.to(T,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const V=await j.provider.resolveTask(O,A.CancellationToken.None);if(!V)return;this.z(V,j);const te=m.from(V,j.extension);if(!te)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(te.execution)&&await this.x(te,V,!0),await this.v(te)}w(){return this.h++}async x(M,T,j){const O=await this.a.$createTaskId(M);!j&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,T.execution)),this.m.set(O,T.execution)}async y(M,T){if(typeof M=="string"){const V=this.l.get(M);if(!V)throw new r.$ab("Unexpected: The specified task is missing an execution");return V}const j=this.l.get(M.id);if(j)return j;const O=new Promise((V,te)=>{function fe(Z,Q,G){G?V(new v(Z,Q.id,G)):te("Unexpected: Task does not exist.")}T?fe(this,M,T):m.to(M.task,this.b,this.m).then(Z=>fe(this,M,Z))});return this.l.set(M.id,O),O.then(V=>(this.k.set(M.id,V),V),V=>Promise.reject(V))}z(M,T){M._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const j=this.n.values();let O=j.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=j.next()}};e.$rfc=E,e.$rfc=E=He([Be(0,$.$AM),Be(1,S.$QM),Be(2,b.$Zdc),Be(3,y.$LM),Be(4,g.$3dc),Be(5,P.$oec),Be(6,o.$dj),Be(7,i.$Hdc)],E);let N=class extends E{constructor(M,T,j,O,V,te,fe,Z){super(M,T,j,O,V,te,fe,Z),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:u.$h(0)})}async executeTask(M,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const j=m.from(T,M);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.x(j,T,!1);else throw new r.$$;const O=await this.y(await this.a.$getTaskExecution(j),T);return this.a.$executeTask(j).catch(V=>{throw new Error(V)}),O}u(M,T,j,O){const V=[];if(O)for(const te of O){if(this.z(te,j),!te.definition||!M[te.definition.type]){const Z=te.source?te.source:"No task source";this.f.warn(`The task [${Z}, ${te.name}] uses an undefined task type. The task will be ignored in the future.`)}const fe=m.from(te,j.extension);fe&&h.is(fe.execution)?(V.push(fe),T.push(this.x(fe,te,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:j.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,T,j){}};e.$sfc=N,e.$sfc=N=He([Be(0,$.$AM),Be(1,S.$QM),Be(2,b.$Zdc),Be(3,y.$LM),Be(4,g.$3dc),Be(5,P.$oec),Be(6,o.$dj),Be(7,i.$Hdc)],N),e.$tfc=(0,D.$Vh)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=void 0;function f(L){return"cellResults"in L}e.$lJ=f,e.$mJ="rawCell#";function R(L,b){let y=-1;const g=[];let A=[];return L.forEach($=>{$.range.startLineNumber!==y&&A.length>0&&(g.push([...A]),A=[]),A.push($),y=$.range.endLineNumber}),A.length>0&&g.push([...A]),g.map($=>{const S=[],D=$[0].range.startLineNumber,w=$[$.length-1].range.endLineNumber;for(let u=D;u<=w;u++)S.push(b.getLineContent(u));return new I.$2I(S.join(`
`)+`
`,$.map(u=>new F.$As(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$nJ=R}),define(ke[360],Se([1,0,215,22,4,3,28,13,18,2,31,110,6,35,15,7,68,295,148,8,24,17,287,359,356]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,k,C,m,p,v){this.q=C,this.r=m,this.s=p,this.t=v,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new f.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Adc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy($.$yK.MainThreadNotebook),this.c=h.getProxy($.$yK.MainThreadNotebookDocuments),this.d=h.getProxy($.$yK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const N=E.notebookEditor?.notebookUri,z=E.cell.handle,T=this.g.get(N)?.getCell(z);if(T)return T.apiCell}if(E&&E.$mid===14){const N=E.uri,z=this.g.get(N);if(z)return z.apiNotebook}return E}}),c.B(k)}getEditorById(h){const k=this.h.get(h);if(!k)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(h){for(const[k,C]of this.h)if(C.apiEditor===h)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,k){const C=this.g.get(h);if(!C&&!k)throw new Error(`NO notebook document for '${h}'`);return C}static u(h,k){if(!k)return;const C=k.filenamePattern.map(m=>D.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(k.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:k.displayName,filenamePattern:C,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,k,C){const m=c.a++,p=typeof C.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(m,C),this.b.$registerNotebookCellStatusBarItemProvider(m,p,k);let v;return p!==void 0&&(v=C.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(p))),new w.$AK(()=>{this.f.delete(m),this.b.$unregisterNotebookCellStatusBarItemProvider(m,p),v?.dispose()})}async createNotebookDocument(h){const k=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&D.NotebookData.from(h.content)});return g.URI.revive(k)}async openNotebookDocument(h){const k=this.g.get(h);if(k)return k.apiNotebook;const C=await this.c.$tryOpenNotebook(h),m=this.g.get(g.URI.revive(C));return(0,y.$Nf)(m?.apiNotebook)}async showNotebookDocument(h,k){g.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let C;typeof k=="object"?C={position:D.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(D.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:C={preserveFocus:!1};const m=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,C),p=m&&this.h.get(m)?.apiEditor;if(p)return p;throw m?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,k,C,m){const p=this.f.get(h),v=g.URI.revive(k),E=this.g.get(v);if(!E||!p)return;const N=E.getCellFromIndex(C);if(!N)return;const z=await p.provideCellStatusBarItems(N.apiCell,m);if(!z)return;const M=new R.$Qc,T=this.p.add([M]),O=(Array.isArray(z)?z:[z]).map(V=>D.NotebookStatusBarItem.from(V,this.i,M));return{cacheId:T,items:O}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,k,C,m,p){if((0,b.$Fe)(k))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:k,serializer:C,options:m}),this.b.$registerNotebookSerializer(v,{id:h.identifier,location:h.extensionLocation},k,D.NotebookDocumentContentOptions.from(m),c.u(h,p)),(0,R.$Pc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(h,k,C){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.deserializeNotebook(k.buffer,C);return new u.$xv(D.NotebookData.from(p))}async $notebookToData(h,k,C){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.serializeNotebook(D.NotebookData.to(k.value),C);return F.$fe.wrap(p)}async $saveNotebook(h,k,C,m,p){const v=g.URI.revive(k),E=this.x.get(h);if(!E)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$zk((0,I.localize)(0,null,this.z(v)),6);await this.y(v,m);const z={metadata:(0,r.$in)(N.apiNotebook.metadata,V=>!(E.options?.transientDocumentMetadata??{})[V]),cells:[]};for(const V of N.apiNotebook.getCells()){const te=new w.$YL(V.kind,V.document.getText(),V.document.languageId,V.mime,E.options?.transientOutputs?[]:[...V.outputs],V.metadata,V.executionSummary);te.metadata=(0,r.$in)(V.metadata,fe=>!(E.options?.transientCellMetadata??{})[fe]),z.cells.push(te)}const M=await E.serializer.serializeNotebook(z,p);await this.s.value.writeFile(v,M);const T=this.s.getFileSystemProviderExtUri(v.scheme),j=await this.s.value.stat(v);return{name:T.basename(v),isFile:(j.type&A.FileType.File)!==0,isDirectory:(j.type&A.FileType.Directory)!==0,isSymbolicLink:(j.type&A.FileType.SymbolicLink)!==0,mtime:j.mtime,ctime:j.ctime,size:j.size,readonly:!!((j.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((j.permissions??0)&A.FilePermission.Locked),etag:A.$Kk({mtime:j.mtime,size:j.size}),children:void 0}}async $searchInNotebooks(h,k,C,m,p){const v=this.x.get(h)?.serializer;if(!v)return{limitHit:!1,results:[]};const E=new L.$Ac;await(async(j,O,V)=>{await Promise.all(j.map(async te=>await Promise.all(te.filenamePatterns.map(fe=>{const Z={...V,type:1,filePattern:fe};return this.t.doInternalFileSearchWithCustomCallback(Z,O,Q=>{Q.forEach(G=>{E.has(G)||m.some(x=>te.isFromSettings&&!x.isFromSettings?!1:x.filenamePatterns.some(Ee=>(0,d.$Bcb)(Ee,G)))||E.add(G)})})}))))})(C,p,k);const z=new L.$zc;let M=!1;const T=Array.from(E).map(async j=>{const O=[];try{if(p.isCancellationRequested)return;if(k.maxResults&&[...z.values()].reduce((Z,Q)=>Z+Q.cellResults.length,0)>k.maxResults){M=!0;return}const V=[],te=this.g.get(j);if(te)te.apiNotebook.getCells().forEach(Q=>V.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(G=>G.items.map(oe=>oe.data.toString()))}));else{const Z=await this.s.value.readFile(j),Q=F.$fe.fromString(Z.toString()),G=await v.deserializeNotebook(Q.buffer,p);if(p.isCancellationRequested)return;D.NotebookData.from(G).cells.forEach(x=>V.push({input:x.source,outputs:x.outputs.flatMap(Ee=>Ee.items.map(le=>le.valueBytes.toString()))}))}if(p.isCancellationRequested)return;V.forEach((Z,Q)=>{const G=k.contentPattern.pattern,oe=new t.$MOb(Z.input,void 0,Z.outputs),x=oe.findInInputs(G),Ee=oe.findInOutputs(G),le=Ee.flatMap(q=>(0,s.$nJ)(q.matches,q.textBuffer)).map((q,U)=>(q.webviewIndex=U,q));if(x.length>0||Ee.length>0){const q={index:Q,contentResults:(0,s.$nJ)(x,oe.inputTextBuffer),webviewResults:le};O.push(q)}});const fe={resource:j,cellResults:O};z.set(j,fe);return}catch{return}});return await Promise.all(T),{limitHit:M,results:[...z.values()]}}async y(h,k){const C=await this.s.value.stat(h);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==A.$Jk&&typeof C.mtime=="number"&&typeof C.size=="number"&&k.mtime<C.mtime&&k.etag!==A.$Kk({mtime:k.mtime,size:C.size}))throw new A.$zk((0,I.localize)(1,null),3,k)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,k,C){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const m=new i.$Wec(k,this.d,h,C.visibleRanges.map(D.NotebookRange.to),C.selections.map(D.NotebookRange.to),typeof C.viewColumn=="number"?D.ViewColumn.to(C.viewColumn):void 0);this.h.set(k,m)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const C of h.value.removedDocuments){const m=g.URI.revive(C),p=this.g.get(m);p&&(p.dispose(),this.g.delete(m),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===m.toString()&&this.h.delete(v.id)}if(h.value.addedDocuments){const C=[];for(const m of h.value.addedDocuments){const p=g.URI.revive(m.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new o.$Vec(this.c,this.q,this.r,p,m);C.push(...m.cells.map(E=>o.$Uec.asModelAddData(v.apiNotebook,E))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(v.apiNotebook)}}if(h.value.addedEditors)for(const C of h.value.addedEditors){if(this.h.has(C.id))return;const m=g.URI.revive(C.documentUri),p=this.g.get(m);p&&this.A(p,C.id,C)}const k=[];if(h.value.removedEditors)for(const C of h.value.removedEditors){const m=this.h.get(C);m&&(this.h.delete(C),this.k?.id===m.id&&(this.k=void 0),k.push(m))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(m=>this.h.get(m)).filter(m=>!!m);const C=new Set;this.l.forEach(m=>C.add(m.id));for(const m of this.h.values()){const p=C.has(m.id);m._acceptVisibility(p)}this.l=[...this.h.values()].map(m=>m).filter(m=>m.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const k=S.$YM.String.with("notebookType","A notebook type"),C=new S.$1M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new S.$YM("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>F.$fe.wrap(p))],new S.$ZM("Notebook Data",p=>D.NotebookData.to(p.value))),m=new S.$1M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new S.$YM("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new u.$xv(D.NotebookData.from(p)))],new S.$ZM("Bytes",p=>p.buffer));h.registerApiCommand(C),h.registerApiCommand(m)}}e.$6ec=c}),define(ke[361],Se([1,0,16,21,43,34,23,38,36]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class g{constructor($,S,D){this.k=$,this.l=S,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$Cj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$Cj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const S=this.k.folderQueries||[];return new Promise((D,w)=>{const u=o=>{this.f++,$(o)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=I.$mc(i);this.j&&this.j(i,n)||this.v(u,{base:o,basename:n})}),Promise.all(S.map(o=>this.p(o,u))).then(o=>{D({limitHit:this.e,stats:o[0]||void 0})},o=>{w(new Error((0,f.$Gi)(o)))})})}async p($,S){const D=new F.$2d,w=this.q($),u=this.r(),o=new y.$dJ(this.k,$),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(D),n=b.$Nd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,D.token),a=n.elapsed(),t=b.$Nd.create();return this.g&&!this.e||(r&&r.forEach(s=>{const d=I.$fc.relative($.folder.path,s.path);if(i){const c=I.$mc(s.path);this.v(S,{base:$.folder,relativePath:d,basename:c});return}this.s(u,$.folder,d,S)}),this.g&&!this.e)?null:(this.u(u,o,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q($){const S=(0,y.$cJ)(this.k.includePattern,$.includePattern),D=(0,y.$cJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:D,includes:S,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},S,D,w){if(D===this.a){const o=I.$mc(this.a);this.v(w,{base:S,relativePath:this.a,basename:o})}function u(o){const i=I.$mc(o),n=I.$lc(o);let r=$[n];r||(r=$[n]=[],u(n)),r.push({base:S,relativePath:o,basename:i})}u(D)}u({rootEntries:$,pathToEntries:S},D,w){const u=this,o=this.a;function i(n){const r=(0,y.$fJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const s=n[a],{relativePath:d,basename:c}=s;if(D.matchesExcludesSync(d,c,o!==c?r:void 0))continue;const l=S[d];if(l)i(l);else{if(d===o)continue;u.v(w,s)}if(u.e)break}}i($)}v($,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(S))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,S,D,w){const u=this.c($.cacheKey),o=new g($,S,u&&u.token);let i=0;const n=r=>{i+=r.length,D(r.map(a=>this.d(a)))};return this.e(o,A.a,n,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$2d),this.b.get($)}d($){return $.relativePath?{resource:L.$zg($.base,$.relativePath)}:{resource:$.base}}e($,S,D,w){const u=w.onCancellationRequested(()=>{$.cancel()}),o=n=>{n&&(i.push(n),S>0&&i.length>=S&&(D(i),i=[]))};let i=[];return $.search(o).then(n=>(i.length&&D(i),u.dispose(),n),n=>(i.length&&D(i),u.dispose(),Promise.reject(n)))}}e.$Xec=A}),define(ke[362],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,44,14,40,145,357,36]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=void 0;let a=class{constructor(p,v,E,N,z){this.a=p,this.b=v,this.c=E,this.d=N,this.e=z}text(p,v,E={}){p=this.f(p,E);const N=this.a.getValue(),z=v&&v.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(v?.map(o.$ei),E),type:2,contentPattern:p,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:N.search.usePCRE2||z||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}f(p,v){const E=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const N={...p,wordSeparators:E.editor.wordSeparators};return this.j(p,v)&&(N.isCaseSensitive=!0),this.k(p)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(p,v={}){return{...this.h(p,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(p,v){return p?(p=Array.isArray(p)?p.map(l):l(p),v?this.parseSearchPaths(p):{pattern:s(...Array.isArray(p)?p:[p])}):{}}h(p=[],v={}){const E=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),z=p.length>1,M=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(O=>this.q(O,v,N)):p.map(O=>this.r(O,v,N,z))).filter(O=>!!O),T={_reason:v._reason,folderQueries:M,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:E.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const O=I.$Gb(I.$Qb(this.c.groups.map(fe=>fe.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const V=O.filter(fe=>(0,r.$6I)(T,fe.fsPath)),te=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(te)),{...T,...te}}const j=v.extraFileResources&&v.extraFileResources.filter(O=>(0,r.$6I)(T,O.fsPath));return T.extraFileResources=j&&j.length?j:void 0,T}i(p){const v=[],E=new L.$zc,N={};let z=!1;return p.forEach(M=>{if(M.scheme===b.Schemas.walkThrough)return;if((0,g.$Dg)(M)){const j=this.b.getWorkspaceFolder(M)?.uri??M.with({path:y.$lc(M.fsPath)});let O=E.get(j);O||(z=!0,O={folder:j,includePattern:{}},v.push(O),E.set(j,O));const V=y.$kc(j.fsPath,M.fsPath);(0,P.$Nf)(O.includePattern)[V.replace(/\\/g,"/")]=!0}else M.fsPath&&(z=!0,N[M.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(p,v){if(v.isSmartCase){if(p.isRegExp){if(A.$tf(p.pattern,!0))return!0}else if(A.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,S.$CB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const v=te=>y.$hc(te)||/^\.\.?([\/\\]|$)/.test(te),N=(Array.isArray(p)?p:d(p)).map(te=>{const fe=this.e.resolvedUserHome;return fe?(0,R.$Bv)(te,fe.scheme===b.Schemas.file?fe.fsPath:fe.path):te}),z=F.$J(N,te=>v(te)?"searchPaths":"exprSegments"),M=(z.exprSegments||[]).map(te=>A.$Oe(te,"/")).map(te=>A.$Oe(te,"\\")).map(te=>(te[0]==="."&&(te="*"+te),c(te))),T={},j=this.m(z.searchPaths||[]);j&&j.length&&(T.searchPaths=j);const O=I.$Qb(M),V=s(...O);return V&&(T.pattern=V),T}l(p,v){return v.disregardExcludeSettings?void 0:(0,r.$5I)(p,!v.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const v=p.flatMap(N=>{let{pathPortion:z,globPortion:M}=t(N);return M&&(M=h(M)),this.n(z).flatMap(j=>this.o(j,M))}),E=new Map;return v.forEach(N=>{const z=N.searchPath.toString(),M=E.get(z);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):E.set(z,{searchPath:N.searchPath,pattern:N.pattern?s(N.pattern):void 0})}),Array.from(E.values())}n(p){if(y.$hc(p)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==b.Schemas.file?[{searchPath:v[0].uri.with({path:p})}]:[{searchPath:$.URI.file(y.$gc(p))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(p=l(p),p.startsWith("../")||p===".."){const N=y.$fc.resolve(v.path,p);return[{searchPath:v.with({path:N})}]}const E=h(p);return[{searchPath:v,pattern:E}]}else{if(p==="./"||p===".\\")return[];{const v=p.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(z=>{const M=v.match(new RegExp(`^${A.$Je(z.name)}(?:/(.*)|$)`));return M?{match:M,folder:z}:null}).filter(P.$Kf);if(N.length)return N.map(z=>{const M=z.match[1];return{searchPath:z.folder.uri,pattern:M&&h(M)}});{const z=p.match(/\.[\/\\](.+)[\/\\]?/),M=z?z[1]:p,T=D.localize(0,null,M);throw new Error(T)}}}}o(p,v){const E=p.pattern&&v?`${p.pattern}/${v}`:p.pattern||v,N=[{searchPath:p.searchPath,pattern:E}];return E&&!E.endsWith("**")&&N.push({searchPath:p.searchPath,pattern:E+"/**"}),N}q(p,v,E){const N=this.r((0,o.$ei)(p.searchPath),v,E,!1);return N?{...N,includePattern:p.pattern}:null}r(p,v,E,N){let z;const M=$.URI.isUri(p)?p:p.uri;if(E.searchPaths){const te=E.searchPaths.filter(fe=>(0,g.$sg)(fe.searchPath,M))[0];if(te&&!te.pattern)return null;te&&(z=te.pattern)}const T=this.a.getValue({resource:M}),O={...this.l(T,v)||{},...z||{}},V=$.URI.isUri(p)?(0,g.$wg)(p):p.name;return{folder:M,folderName:N?V:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!T.search.followSymlinks}}};e.$cK=a,e.$cK=a=He([Be(0,w.$pi),Be(1,o.$5h),Be(2,i.$GC),Be(3,u.$dj),Be(4,n.$aK)],a);function t(m){const p=m.match(/[\*\{\}\(\)\[\]\?]/);if(p){const v=p.index,E=m.substr(0,v).match(/[/|\\][^/\\]*$/);if(E){let N=m.substr(0,E.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:m.substr((E.index||0)+1)}}}return{pathPortion:m}}function s(...m){return m.length?m.reduce((p,v)=>(p[v]=!0,p),Object.create(null)):void 0}function d(m){return f.$Aj(m,",").map(p=>p.trim()).filter(p=>!!p.length)}function c(m){return[`**/${m}/**`,`**/${m}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function l(m){return m.replace(/\\/g,"/")}function h(m){return l(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(m){return m.replace(/([?*[\]])/g,"[$1]")}function C(m,p){m=I.$Lb(m,N=>N.toString());const v=[],E=p.getWorkspace();return m&&m.forEach(N=>{let z;if(p.getWorkbenchState()===2)z=(0,g.$Bg)(E.folders[0].uri,N),z&&z!=="."&&(z="./"+z);else{const M=p.getWorkspaceFolder(N);if(M){const T=M.name;if(E.folders.filter(O=>O.name===T).length===1){const O=(0,g.$Bg)(M.uri,N);O===""?z=`./${M.name}`:z=`./${M.name}/${O}`}else z=N.fsPath}}z&&v.push(k(z))}),v}e.$dK=C}),define(ke[363],Se([1,0,23,2,21,8,5,362,36,40]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qb=e.$6qb=void 0;const A=7e3;function P(w,u){const o=u.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],n=[];for(const c of o)if(/^workspaceContains:/.test(c)){const l=c.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?n.push(l):i.push(l)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let r;const a=new Promise((c,l)=>{r=c}),t=c=>r({activationEvent:c}),s=Promise.all(i.map(c=>$(w,c,t))).then(()=>{}),d=S(w,u.identifier,n,t);return Promise.all([s,d]).then(()=>{r(void 0)}),a}e.$6qb=P;async function $(w,u,o){for(const i of w.folders)if(await w.exists(I.$zg(F.URI.revive(i),u))){o(`workspaceContains:${u}`);return}}async function S(w,u,o,i){if(o.length===0)return Promise.resolve(void 0);const n=new f.$2d,r=w.checkExists(w.folders,o,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await r}catch(s){R.$3(s)||R.$Z(s)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function D(w,u,o,i){const n=w.get(L.$Uh),r=w.get(y.$WI),t=n.createInstance(b.$cK).file(u.map(s=>(0,g.$ei)(F.URI.revive(s))),{_reason:"checkExists",includePattern:o,exists:!0});return r.fileSearch(t,i).then(s=>!!s.limitHit,s=>R.$3(s)?!1:Promise.reject(s))}e.$7qb=D}),define(ke[47],Se([1,0,212,16,56,23,11,3,77,2,14,6,42,293,118,41,25,147,8,26,22,272,7,64,5,27,92,20,107,72,46,4,363,117,274,17,115,38,12,116]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d,c,l,h,k,C,m,p,v,E,N,z,M,T,j,O){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0,e.$zec=(0,d.$Vh)("IHostUtils");let te=V=class extends b.$Rc{constructor(q,U,ie,be,H,X,Y,$e,ne,de,ee,he){super(),this.X=he,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ie,this.f=Y,this.j=be,this.m=H,this.s=X,this.t=ne,this.u=de,this.w=ee,this.y=this.g.getProxy(P.$yK.MainThreadWorkspace),this.z=this.g.getProxy(P.$yK.MainThreadTelemetry),this.C=this.g.getProxy(P.$yK.MainThreadExtensionService),this.D=new L.$Wg,this.F=new L.$Wg,this.G=new L.$Wg,this.H=new L.$Wg,this.I=new Ee(this.f.extensions.activationEvents),this.L=new o.$Q5b(this.I,this.f.extensions.allExtensions);const pe=new n.$am(this.f.extensions.myExtensions);this.J=new o.$Q5b(this.I,oe(this.L,pe)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new D.$kec(this.g,this.s),this.N=new E.$sec(this.g),this.O=$e,this.h=q.createChild(new k.$Th([D.$lec,this.M],[E.$tec,this.N])),this.P=this.B(new S.$jec(this.J,this.L,{onExtensionActivationError:(Pe,B,J)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),J)},actualActivateExtension:async(Pe,B)=>{if(o.$Q5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new S.$iec;const J=this.J.getExtensionDescription(Pe);return this.db(J,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(q){i.$Z(q)}}async Y(){this.O.onWillDeactivateAll();let q=[];try{q=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.cb(H))}catch{}await Promise.all(q)}terminate(q,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ie=this.Y();Promise.race([(0,L.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(q){return this.G.isOpen()?this.P.isActivated(q):!1}async getExtension(q){const U=await this.C.$getExtension(q);return U&&{...U,identifier:new n.$_l(U.identifier.value),extensionLocation:g.URI.revive(U.extensionLocation)}}Z(q,U){return this.P.activateByEvent(q,U)}$(q,U){return this.P.activateById(q,U)}activateByIdWithErrors(q,U){return this.$(q,U).then(()=>{const ie=this.P.getActivatedExtension(q);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(q=>this.J)}getExtensionExports(q){if(this.G.isOpen())return this.P.getActivatedExtension(q).exports;try{return this.P.getActivatedExtension(q).exports}catch{return null}}async ab(q){if(q.scheme===z.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(q.fsPath);return g.URI.file(U)}return q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(q=>new x(q))),this.Q}async bb(q){const U=y.$2h.forUris(ie=>R.$qg.ignorePathCasing(ie));return await Promise.all(q.map(async ie=>{if(this.ub(ie)){const be=await this.ab(ie.extensionLocation);U.set(be,ie)}})),U}cb(q){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(q))return U;const ie=this.P.getActivatedExtension(q);if(!ie)return U;try{typeof ie.module.deactivate=="function"&&(U=Promise.resolve(ie.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${q.value}':`),this.s.error(be)}try{(0,b.$Mc)(ie.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.s.error(be)}return U}async db(q,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(q.identifier):await this.C.$onWillActivateExtension(q.identifier),this.fb(q,U).then(ie=>{const be=ie.activationTimes;return this.C.$onDidActivateExtension(q.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(q,U,"success",be),ie},ie=>{throw this.eb(q,U,"failure"),ie})}eb(q,U,ie,be){const H=Z(q,U);this.z.$publicLog2("extensionActivationTimes",{...H,...be||{},outcome:ie})}fb(q,U){const ie=Z(q,U);this.z.$publicLog2("activatePlugin",ie);const be=this.ub(q);if(!be)return Promise.resolve(new S.$hec(S.$eec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${q.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const H=new S.$fec(U.startup);return Promise.all([this.vb(q,(0,R.$zg)(q.extensionLocation,be),H),this.gb(q)]).then(X=>(f.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),V.hb(this.s,q.identifier,X[0],X[1],H))).then(X=>(f.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),X))}gb(q){const U=new a.$nec(q,this.M),ie=new a.$mec(q.identifier.value,!1,this.M),be=new N.$uec(q,this.N),H=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,X=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([U.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const Y=this;let $e,ne;const de=(0,u.$MF)(q,"ipc")?this.f.messagePorts?.get(n.$_l.toKey(q.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ie,secrets:be,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(ee){return F.$ic(q.extensionLocation.fsPath,ee)},get storagePath(){return Y.O.workspaceValue(q)?.fsPath},get globalStoragePath(){return Y.O.globalValue(q).fsPath},get logPath(){return F.$ic(Y.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return g.URI.joinPath(Y.f.logsLocation,q.identifier.value)},get storageUri(){return Y.O.workspaceValue(q)},get globalStorageUri(){return Y.O.globalValue(q)},get extensionMode(){return H},get extension(){return $e===void 0&&($e=new G(Y,q.identifier,q,X,!1)),$e},get extensionRuntime(){return(0,u.$NF)(q,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ne){if(!de)return;const ee=p.Event.buffer(p.Event.fromDOMEventEmitter(de,"message",he=>he.data));de.start(),ne={onDidReceiveMessage:ee,postMessage:de.postMessage.bind(de)}}return ne}})})}static hb(q,U,ie,be,H){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(q,U,ie,be,H).then(X=>new S.$gec(!1,null,H.build(),ie,X,be.subscriptions))}static ib(q,U,ie,be,H){if(typeof ie.activate=="function")try{H.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${U.value}`);const X=typeof global=="object"?global:self,Y=ie.activate.apply(X,[be]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(Y).then($e=>(H.activateResolveStop(),$e))}catch(X){return Promise.reject(X)}else return Promise.resolve(ie)}jb(q,U){this.$(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:U}).then(void 0,ie=>{this.s.error(ie)})}kb(q,U=0){const be=Date.now();(0,j.$B)(()=>{for(let H=U;H<q.length;H+=1){const X=q[H];for(const Y of X.activationEvents??[])if(Y==="onStartupFinished")if(Date.now()-be>50){this.kb(q,H);break}else this.jb(X,Y)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(q=>{const U=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(U)this.kb(ie);else for(const be of ie)if(be.activationEvents)for(const H of be.activationEvents)H==="onStartupFinished"&&this.jb(be,H)})}mb(){const q=this.Z("*",!0).then(void 0,X=>{this.s.error(X)});this.B(this.j.onDidChangeWorkspace(X=>this.nb(X.added)));const U=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(U),be=this.pb(),H=Promise.all([be,q,ie]).then(()=>{});return Promise.race([H,(0,L.$Yg)(1e4)]).then(()=>{this.lb()}),H}nb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(q,U))).then(()=>{})}async ob(q,U){if(this.isActivated(U.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:q.map(X=>X.uri),forceUsingSearch:ie||!this.c.fsExists,exists:X=>this.c.fsExists(X.fsPath),checkExists:(X,Y,$e)=>this.y.$checkExists(X,Y,$e)},H=await(0,v.$6qb)(be,U);if(H)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:H.activationEvent}).then(void 0,X=>this.s.error(X))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(q){throw console.error(q),q}}async qb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:U}=this.f.environment;if(!q||!U)throw new Error(I.localize(0,null));const ie=await this.vb(null,U,new S.$fec(!1));if(!ie||typeof ie.run!="function")throw new Error(I.localize(1,null,U.toString()));return new Promise((be,H)=>{const X=(ne,de)=>{ne?(j.$t&&this.s.error("Test runner called back with error",ne),H(ne)):(j.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof de=="number"&&de>0?1:0))},Y=(0,R.$ng)(U),$e=ie.run(Y,X);$e&&$e.then&&$e.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(ne=>{j.$t&&this.s.error("Test runner finished with error",ne),H(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,U){return this.R[q]=U,(0,b.$Pc)(()=>{delete this.R[q]})}async getRemoteExecServer(q){const{resolver:U}=await this.sb(q);return U?.resolveExecServer?.(q,{resolveAttempt:0})}async sb(q){const U=q.indexOf("+");if(U===-1)throw new t.$GK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=q.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(q,U){const ie=T.$Nd.create(!1),be=()=>`[resolveAuthority(${(0,s.$Zk)(q)},${U})][${ie.elapsed()}ms] `,H=ae=>this.s.info(`${be()}${ae}`),X=ae=>this.s.warn(`${be()}${ae}`),Y=(ae,_=void 0)=>this.s.error(`${be()}${ae}`,_),$e=ae=>{if(ae instanceof t.$GK)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae},ne=async ae=>{H(`activating resolver for ${ae}...`);const{resolver:_,authorityPrefix:ge}=await this.sb(ae);if(!_)throw Y(`no resolver for ${ge}`),new t.$GK(`No remote extension installed to resolve ${ge}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_,authorityPrefix:ge,remoteAuthority:ae}},de=q.split(/@|%40/g).reverse();H(`activating remote resolvers ${de.join(" -> ")}`);let ee;try{ee=await Promise.all(de.map(ne)).catch(async ae=>{if(!(ae instanceof t.$GK)||ae._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ae;return X(`resolving nested authorities failed: ${ae.message}`),[await ne(q)]})}catch(ae){return $e(ae)}const he=new L.$9g;he.cancelAndSet(()=>H("waiting..."),1e3);let pe,Pe;for(const[ae,{authorityPrefix:_,resolver:ge,remoteAuthority:ye}]of ee.entries())try{if(ae===ee.length-1)H("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${_}`),pe=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${_}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$FK.isManagedResolvedAuthority(pe)?pe:void 0));else{if(H(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${_}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$GK(`Exec server was not available for ${ye}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${_}`)}}catch(je){return f.mark(`code/extHost/didResolveAuthorityError/${_}`),Y("returned an error",je),he.dispose(),$e(je)}he.dispose();const B={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},J={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${t.$FK.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let re;if(t.$FK.isManagedResolvedAuthority(pe)){const ae=U;this.X.setFactory(ae,pe.makeConnection),re={authority:q,connectTo:new s.$Wk(ae),connectionToken:pe.connectionToken}}else re={authority:q,connectTo:new s.$Xk(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:re,options:J,tunnelInformation:B}}}async $getCanonicalURI(q,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(q)})`);const{resolver:ie}=await this.sb(q);if(!ie)return null;const be=g.URI.revive(U);if(typeof ie.getCanonicalURI>"u")return be;const H=await(0,L.$Qg)(()=>ie.getCanonicalURI(be));return H||be}$startExtensionHost(q){q.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ie}=fe(this.I,this.L,this.J,q);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(q,U){return U===1?this.D.wait().then(ie=>this.Z(q,!1)):this.G.wait().then(ie=>this.Z(q,!1))}async $activate(q,U){return await this.G.wait(),this.J.getExtensionDescription(q)?(await this.$(q,U),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(X=>X.extensionLocation=g.URI.revive(X.extensionLocation));const{globalRegistry:U,myExtensions:ie}=fe(this.I,this.L,this.J,q),be=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ie),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const U=r.$fe.alloc(q),ie=Math.random()%256;for(let be=0;be<q;be++)U.writeUInt8(ie,be);return U}async $updateRemoteConnectionData(q){this.W=q,this.a.fire()}};e.$Aec=te,e.$Aec=te=V=He([Be(0,d.$Uh),Be(1,e.$zec),Be(2,h.$AM),Be(3,w.$Zdc),Be(4,$.$3dc),Be(5,A.$dj),Be(6,c.$QM),Be(7,l.$6dc),Be(8,C.$Rwb),Be(9,m.$oec),Be(10,M.$wec),Be(11,O.$xec)],te);function fe(le,q,U,ie){le.addActivationEvents(ie.addActivationEvents);const be=new o.$Q5b(le,q.getAllExtensionDescriptions());be.deltaExtensions(ie.toAdd,ie.toRemove);const H=new n.$am(U.getAllExtensionDescriptions().map(Y=>Y.identifier));for(const Y of ie.myToRemove)H.delete(Y);for(const Y of ie.myToAdd)H.add(Y);const X=oe(be,H);return{globalRegistry:be,myExtensions:X}}function Z(le,q){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}function Q(le){return le.getAllExtensionDescriptions().map(q=>q.identifier.value).join(",")}e.$Bec=(0,d.$Vh)("IExtHostExtensionService");class G{#e;#t;#i;constructor(q,U,ie,be,H){this.#e=q,this.#t=U,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.$gc((0,R.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=be,this.isFromDifferentExtensionHost=H}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Cec=G;function oe(le,q){return le.getAllExtensionDescriptions().filter(U=>q.has(U.identifier))}class x{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.$Dec=x;class Ee{constructor(q){this.a=new n.$bm,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)??[]}addActivationEvents(q){for(const U of Object.keys(q))this.a.set(U,q[U])}}}),define(ke[364],Se([1,0,56,2,6,42,25,26,20,27,5,47,14,13]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;let w=class{constructor(r,a,t,s,d,c,l){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.h=c,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$Lfc=w,e.$Lfc=w=He([Be(2,A.$Uh),Be(3,R.$3dc),Be(4,P.$Bec),Be(5,g.$QM),Be(6,$.$dj)],w);let u=class{static{D=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&D.a.size){const a=(0,S.$Je)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,s,d]=a,c=D.a.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),t+c+d}c(r){return r.replace(/\\/g,"/")}};u=D=He([Be(0,g.$QM)],u);class o{constructor(r,a,t,s,d){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new b.$bm}load(r,a){const t=this.d.findSubstr(a);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,c)=>s+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this.b=this.c(L.$HF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$yK.MainThreadTelemetry);const s=t.getProxy(f.$yK.MainThreadWindow);this.c=(d,c)=>{const l=F.URI.parse(d);return c?this.g(d,c):l.scheme==="http"||l.scheme==="https"?s.$openUri(l,d,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?s.$openUri(l,d,{}):this.g(d,c)}}load(r,a,t){const s=this.e.findSubstr(a);return s&&(this.a=s.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,y.$AM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,69,70,47,7,41,290,42]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=void 0,e.$Eec=(0,L.$Vh)("IExtHostVariableResolverProvider");class D extends $.$BN{constructor(o,i,n,r,a,t,s){function d(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const l=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof A.$gM||l.input instanceof A.$lM)return l.input.modified;if(l.input instanceof A.$fM||l.input instanceof A.$kM||l.input instanceof A.$iM)return l.input.uri}}}super({getFolderUri:c=>{const l=t.folders.filter(h=>h.name===c);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,l)=>a.getConfiguration(void 0,c).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=d();if(c)return f.$gc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=d();if(c){const l=i.getWorkspaceFolder(c);if(l)return f.$gc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>o.getExtension(c)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let w=class extends F.$Rc{constructor(o,i,n,r,a){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new I.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Fec=w,e.$Fec=w=He([Be(0,g.$Bec),Be(1,P.$Zdc),Be(2,b.$LM),Be(3,S.$3dc),Be(4,y.$cec)],w)}),define(ke[96],Se([1,0,11,4,2,5,6,70,47,20,7,41,142,282,42,58]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0,e.$Gec=(0,R.$Vh)("IExtHostDebugService");let u=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,d,c,l,h,k){this.E=d,this.F=c,this.G=l,this.H=h,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Rd,this.n=new F.$Rd,this.o=new F.$Rd,this.u=new F.$Rd,this.k=s.getProxy(L.$yK.MainThreadDebugService),this.y=new F.$Rd,this.A=new F.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange(m=>{this.J(C)}),this.J(C)})}asDebugSourceUri(s,d){const c=s;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let l=`debug:${encodeURIComponent(c.path||"")}`,h="?";return d&&(l+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),l+=`${h}ref=${c.sourceReference}`,f.URI.parse(l)}else{if(c.path)return f.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const d=[];for(const c of s.getAllExtensionDescriptions())if(c.contributes){const l=c.contributes.debuggers;if(l&&l.length>0)for(const h of l)(0,S.$jF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(d=>s.push(d)),s}addBreakpoints(s){const d=s.filter(h=>{const k=h.id;return this.w.has(k)?!1:(this.w.set(k,h),!0)});this.U(d,[],[]);const c=[],l=new Map;for(const h of d)if(h instanceof A.$zL){let k=l.get(h.location.uri.toString());k||(k={type:"sourceMulti",uri:h.location.uri,lines:[]},l.set(h.location.uri.toString(),k),c.push(k)),k.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$AL&&c.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(s){const d=s.filter(k=>this.w.delete(k.id));this.U([],d,[]);const c=d.filter(k=>k instanceof A.$zL).map(k=>k.id),l=d.filter(k=>k instanceof A.$AL).map(k=>k.id),h=d.filter(k=>k instanceof A.$BL).map(k=>k.id);return this.k.$unregisterBreakpoints(c,l,h)}startDebugging(s,d,c){return this.k.$startDebugging(s?s.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,c){if(!d)return new A.$AK(()=>{});const l=this.d++;return this.f.push({type:s,handle:l,provider:d}),this.k.$registerDebugConfigurationProvider(s,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new A.$AK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(s,d,c){if(!c)return new A.$AK(()=>{});if(!this.Q(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:d,handle:l,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,l),new A.$AK(()=>{this.h=this.h.filter(h=>h.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new A.$AK(()=>{});const c=this.i++;return this.j.push({type:s,handle:c,factory:d}),new A.$AK(()=>{this.j=this.j.filter(l=>l.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){let c;const l=await this.W(s);return l&&(c={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,d)}K(s,d){if(s.type==="implementation")return new r(s.implementation)}L(){}async $startDASession(s,d){const c=this,l=await this.V(d);return this.S(this.N(l.type),l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const k=this.M(h),C=this.K(k,l);if(!C)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const m=C;return this.B.set(s,m),this.R(l).then(p=>(p&&this.C.set(s,p),m.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const E=v,N={type:"response",seq:0,command:E.command,request_seq:E.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const z=await this.D.sign(E.arguments.value);N.body={signature:z},m.sendResponse(N)}else throw new Error("no signer")}catch(z){N.success=!1,N.message=z.message,m.sendResponse(N)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(v),v=(0,S.$oF)(v,!0),c.k.$acceptDAMessage(s,v)}),m.onError(v=>{p&&p.onError&&p.onError(v),this.k.$acceptDAError(s,v.name,v.message,v.stack)}),m.onExit(v=>{p&&p.onExit&&p.onExit(v??void 0,void 0),this.k.$acceptDAExit(s,v??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),m.startSession()))})}$sendDAMessage(s,d){d=(0,S.$nF)(d,!1);const c=this.C.get(s);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.B.get(s)?.sendMessage(d)}$stopDASession(s){const d=this.C.get(s);this.C.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.B.get(s);return this.B.delete(s),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],c=[],l=[];if(s.added)for(const h of s.added){const k=h.id;if(k&&!this.w.has(k)){let C;if(h.type==="function")C=new A.$AL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")C=new A.$BL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const m=f.URI.revive(h.uri);C=new A.$zL(new A.$MK(m,new A.$BK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$xL)(C,k),this.w.set(k,C),d.push(C)}}if(s.removed)for(const h of s.removed){const k=this.w.get(h);k&&(this.w.delete(h),c.push(k))}if(s.changed){for(const h of s.changed)if(h.id){const k=this.w.get(h.id);if(k){if(k instanceof A.$AL&&h.type==="function"){const C=k;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.functionName=h.functionName}else if(k instanceof A.$zL&&h.type==="source"){const C=k;C.enabled=h.enabled,C.condition=h.condition,C.hitCondition=h.hitCondition,C.logMessage=h.logMessage,C.location=new A.$MK(f.URI.revive(h.uri),new A.$BK(h.line,h.character))}l.push(k)}}}this.U(d,c,l)}async $acceptStackFrameFocus(s){let d;const c=s.sessionId?await this.V(s.sessionId):void 0;if(!c)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?d=new A.$HL(c,s.threadId):d=new A.$GL(c,s.threadId,s.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(s,d,c){return(0,I.$Qg)(async()=>{const l=this.P(s);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return l.provideDebugConfigurations(h,c)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(s,d,c,l){return(0,I.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(d);return h.resolveDebugConfiguration(k,c,l)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,c,l){return(0,I.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(k,c,l)})}async $provideDebugAdapter(s,d){const c=this.O(s);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(d);return this.S(c,l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(s){const d=await this.V(s);this.m.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.V(s);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,d){(await this.V(s))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const l={session:await this.V(s),event:d.event,body:d.body};this.u.fire(l)}M(s){if(s instanceof A.$CL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$DL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$EL)return{type:"pipeServer",path:s.path};if(s instanceof A.$FL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const d=this.h.filter(c=>c.type===s);if(d.length>0)return d[0].factory}O(s){const d=this.h.filter(c=>c.handle===s);if(d.length>0)return d[0].factory}P(s){const d=this.f.filter(c=>c.handle===s);if(d.length>0)return d[0].provider}Q(s,d){if(s.contributes){const c=s.contributes.debuggers;if(c&&c.length>0){for(const l of c)if(l.label&&l.type&&l.type===d)return!0}}return!1}R(s){const c=s.configuration.type,l=this.j.filter(h=>h.type===c||h.type==="*").map(h=>(0,I.$Qg)(()=>h.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(l).then(h=>{const k=h.filter(C=>!!C);if(k.length>0)return new n(k)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(s,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new A.$DL(c));if(s){const h=await this.F.getExtensionRegistry();return(0,I.$Qg)(()=>s.createDebugAdapterDescriptor(d,this.T(d,h))).then(k=>{if(k)return k})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,l))}T(s,d){}U(s,d,c){(s.length>0||d.length>0||c.length>0)&&this.y.fire(Object.freeze({added:s,removed:d,changed:c}))}async V(s){if(s)if(typeof s=="string"){const d=this.l.get(s);if(d)return d}else{let d=this.l.get(s.id);if(!d){const c=await this.W(s.folderUri),l=s.parent?this.l.get(s.parent):void 0;d=new o(this.k,s.id,s.type,s.name,c,s.configuration,l),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(s){if(s){const d=f.URI.revive(s);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$Hec=u,e.$Hec=u=He([Be(0,g.$AM),Be(1,P.$Zdc),Be(2,y.$Bec),Be(3,D.$3dc),Be(4,b.$cec),Be(5,w.$Eec)],u);class o{constructor(s,d,c,l,h,k,C){this.d=s,this.f=d,this.g=c,this.h=l,this.i=h,this.j=k,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,d){return this.d.$customDebugAdapterRequest(this.f,s,d)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Iec=o;class i{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$Jec=i;class n{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.d.forEach(c=>c.onExit?c.onExit(s,d):void 0)}}class r extends $.$Mdb{constructor(s){super(),this.h=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends u{constructor(s,d,c,l,h,k){super(s,d,c,l,h,k)}};e.$Kec=a,e.$Kec=a=He([Be(0,g.$AM),Be(1,P.$Zdc),Be(2,y.$Bec),Be(3,D.$3dc),Be(4,b.$cec),Be(5,w.$Eec)],a)}),define(ke[365],Se([1,0,8,56,2,6,353,14,106,107,27,248,20,66,47,90]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(b.$dj),t=n.get($.$AM).getProxy(R.$yK.MainThreadErrors);I.setUnexpectedErrorHandler(s=>{r.error(s);const d=I.$2(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(b.$dj),a=n.get($.$AM),t=n.get(D.$Bec),s=n.get(w.$UM),d=a.getProxy(R.$yK.MainThreadExtensionService),c=a.getProxy(R.$yK.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function k(p,v){if(h.has(p))return h.get(p).stack;let E="",N,z;for(const T of v)E+=`
	at ${T.toString()}`,z=T.getFileName(),!N&&z&&(N=l.findSubstr(f.URI.file(z)));const M=`${p.name||"Error"}: ${p.message||""}${E}`;return h.set(p,{extensionIdentifier:N?.identifier,stack:M}),M}const C=Symbol("prepareStackTrace wrapped");let m=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(p){if(p===k||!p||p[C]){m=p||k;return}m=function(v,E){return k(v,E),p.call(Error,v,E)},Object.assign(m,{[C]:!0})}}),I.setUnexpectedErrorHandler(p=>{r.error(p);const v=I.$2(p),E=h.get(p);if(!E?.extensionIdentifier){c.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(E.extensionIdentifier,v);const N=s.onExtensionError(E.extensionIdentifier,p);r.trace("forwarded error to extension?",N,E)})}}e.$Mfc=u;class o{constructor(n,r,a,t,s){this.a=a,this.b=new L.$Y5b(n,null,t),r=o.e(r,this.b);const d=new g.$Th(...(0,y.$Er)());d.set(A.$QM,{_serviceBrand:void 0,...r,messagePorts:s}),d.set($.$AM,new $.$BM(this.b)),d.set(S.$Wdc,new S.$Xdc(t)),d.set(D.$zec,a);const c=new P.$jq(d,!0);c.invokeFunction(u.installEarlyHandler),this.d=c.invokeFunction(l=>l.get(b.$dj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=c.invokeFunction(l=>l.get(D.$Bec)),this.c.initialize(),c.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(R.$yK.MainThreadExtensionService);return f.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=f.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=f.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=f.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$Nfc=o}),define(ke[366],Se([1,0,11,12,223,242,140,96,70,47,20,46,7,58,41,283,284,42]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=void 0;let i=class extends b.$Hec{constructor(s,d,c,l,h,k,C){super(s,d,c,l,k,C),this.Z=h,this.X=new a}K(s,d){switch(s.type){case"server":return new w.$Sfc(s);case"pipeServer":return new w.$Tfc(s);case"executable":return new w.$Ufc(s,d.type)}return super.K(s,d)}T(s,d){const c=w.$Ufc.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(c)return new $.$CL(c.command,c.args,c.options)}L(){return new L.$M9b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const c=await this.G.getConfigProvider(),l=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),k=s.title||f.localize(0,null),C=JSON.stringify({shell:l,shellArgs:h});let m=await this.X.checkout(C,k),p,v=!1;if(m)p=s.cwd;else{const M={shellPath:l,shellArgs:h,cwd:s.cwd,name:k,iconPath:new $.$uL("debug")};v=!0,m=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(m,C)}m.show(!0);const E=await m.processId;v?await new Promise(M=>setTimeout(M,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):F.$i?m.sendText("cls"):m.sendText("clear"));const N=(0,u.$Wfc)(l,s.args,!!s.argsCanBeInterpretedByShell,p,s.env);m.sendText(N);const z=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free(m),z.dispose())});return E}else if(s.kind==="external")return r(s,await this.G.getConfigProvider());return super.$runInTerminal(s,d)}};e.$Xfc=i,e.$Xfc=i=He([Be(0,A.$AM),Be(1,D.$Zdc),Be(2,g.$Bec),Be(3,o.$3dc),Be(4,P.$oec),Be(5,y.$cec),Be(6,S.$Eec)],i);let n;function r(t,s){if(!n)if(F.$i)n=new R.$y8b;else if(F.$j)n=new R.$z8b;else if(F.$k)n=new R.$A8b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const l=[...this.b.entries()].map(([h,k])=>(0,I.$Lg)(async C=>{if(h.name!==d||k.lastUsedAt!==-1&&await(0,u.$Vfc)(await h.processId))return null;const m=Date.now();return k.lastUsedAt+a.a>m||C.isCancellationRequested||k.config!==s?null:(k.lastUsedAt=m,h)}));return await(0,I.$3g)(l,h=>!!h)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[367],Se([1,0,16,2,104,41,69,42,40,46,20,27,95,17,14,91,23,63,58]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let n=class extends $.$rfc{constructor(a,t,s,d,c,l,h,k,C){super(a,t,s,d,c,l,h,k),this.B=s,this.C=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=$.TaskHandleDTO.from(s,this.B),c=await this.a.$getTaskExecution(d);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(c,t);return this.a.$executeTask(d).catch(()=>{}),l}else{const d=$.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const c=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),c}}u(a,t,s,d){const c=[];if(d)for(const l of d){this.z(l,s),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(l,s.extension);h&&(c.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,l,!0)))}return{tasks:c,extension:s.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const s=F.URI.file((0,o.homedir)());t=new y.$di({uri:s,name:u.$wg(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const s=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(s),l=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),k=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const C of t.variables)d.variables[C]=await h.resolveAsync(k,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(I.$sc);for(let m=0;m<C.length;m++)C[m]=await h.resolveAsync(k,C[m])}d.process=await f.win32.findExecutable(await h.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(k,t.process.cwd):void 0,C)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,s){return f.win32.findExecutable(a,t,s)}};e.$Pfc=n,e.$Pfc=n=He([Be(0,A.$AM),Be(1,P.$QM),Be(2,R.$Zdc),Be(3,L.$LM),Be(4,b.$3dc),Be(5,g.$oec),Be(6,D.$dj),Be(7,w.$Hdc),Be(8,i.$Eec)],n)}),define(ke[368],Se([1,0,63,58]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class f extends F.$Fec{m(){return(0,I.homedir)()}}e.$vgc=f}),define(ke[156],Se([1,0,19,11,21,43,17,16,23,2,36]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class P{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new f.$2d(n);return new Promise((t,s)=>{this.a=new S(i);let d=!1;const c=(l,h)=>{if(!d&&!this.b){const k=this.h(l);w(l)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const C=this.h(l);this.c+=C,(C>0||!w(l))&&this.a.add(l,h)}};Promise.all(r.map((l,h)=>this.k(l,k=>c(k,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||h,messages:(0,I.$Qb)(l.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,R.$Gi)(l);s(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new A.$dJ(this.d,i),t=[],s={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===L.Schemas.file?(0,A.$eJ)(()=>this.f.readdir(y.$yg(l.uri))):void 0,k=y.$Bg(i.folder,l.uri);if(k){const C=a.includedInQuery(k,b.$mc(k),h);(0,F.$Kg)(C)?t.push(C.then(m=>{m&&n(l)})):C&&n(l)}}},d=this.n(i),c=await this.e.provideTextSearchResults($(this.d.contentPattern),d,s,r);return t.length&&await Promise.all(t),c}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$cJ)(this.d.includePattern,i.includePattern),r=(0,A.$cJ)(this.d.excludePattern,i.excludePattern),a={folder:g.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$Yec=P;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!y.$sg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(D(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Zec=S;function D(o){return w(o)?{preview:{matches:(0,I.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,I.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.$1ec=w;class u{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2ec=u}),define(ke[97],Se([1,0,3,6,5,361,20,66,14,2,156]),function(me,e,I,F,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,f.$Vh)("IExtHostSearch");let P=class{constructor(w,u,o){this.k=w,this.l=u,this.n=o,this.c=this.k.getProxy(F.$yK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Xec}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,u){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const o=this.d++;return this.e.set(o,u),this.c.$registerTextSearchProvider(o,this.o(w)),(0,I.$Pc)(()=>{this.g.delete(w),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(w,u){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const o=this.d++;return this.h.set(o,u),this.c.$registerFileSearchProvider(o,this.o(w)),(0,I.$Pc)(()=>{this.i.delete(w),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(w,u,o,i){const n=$(o),r=this.h.get(w);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(w,u,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,u,o){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,u,o,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=$(o);return this.q(r,n).search(t=>this.c.$handleTextMatch(w,u,t),i)}$enableExtensionHostSearch(){}q(w,u){return new A.$Yec(w,u,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$4ec=P,e.$4ec=P=He([Be(0,L.$AM),Be(1,b.$Wdc),Be(2,y.$dj)],P);function $(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(S),extraFileResources:D.extraFileResources&&D.extraFileResources.map(w=>g.URI.revive(w))}}e.$5ec=$;function S(D){return{...D,folder:g.URI.revive(D.folder)}}}),define(ke[369],Se([1,0,21,8,4,3,17,39,2,133,191,172,79,26,31,14,137,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,151,316,317,318,294,319,69,70,320,47,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,154,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,46,339,340,285,341,299,72,15,7,342,66,343,93,345,346,153,41,281,114,25,94]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d,c,l,h,k,C,m,p,v,E,N,z,M,T,j,O,V,te,fe,Z,Q,G,oe,x,Ee,le,q,U,ie,be,H,X,Y,$e,ne,de,ee,he,pe,Pe,B,J,re,ae,_,ge,ye,je,We,et,Ze,rt,nt,Ae,Ne,Ve,Le,Xe,ue,ce,Ie,Ke,Ge,_e,st,lt,wt,Ue,Kt,Ht,Et,Ut,Ot,Gt,Bt,Dt,Mt,Wt,tt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;function qt(ut){const mt=ut.get(U.$QM),Nt=ut.get(q.$Edc),Pt=ut.get(Ee.$5dc),At=ut.get(oe.$Bec),gt=ut.get(Dt.$Zdc),St=ut.get(ue.$UM),Rt=ut.get(N.$3dc),It=ut.get(Ht.$Wdc),Je=ut.get(We.$AM),jt=ut.get(Ve.$lec),Jt=ut.get(Le.$6dc),Me=ut.get(w.$ej),Fe=ut.get(w.$dj),Ce=ut.get(lt.$Rwb),se=ut.get(s.$Hdc),Te=ut.get(Bt.$Gfc),qe=ut.get(rt.$tec),xe=ut.get(Q.$cec),Qe=ut.get(de.$xec);Je.set(r.$zK.ExtHostFileSystemInfo,Nt),Je.set(r.$zK.ExtHostLogLevelServiceShape,Me),Je.set(r.$zK.ExtHostWorkspace,gt),Je.set(r.$zK.ExtHostConfiguration,Rt),Je.set(r.$zK.ExtHostExtensionService,At),Je.set(r.$zK.ExtHostStorage,jt),Je.set(r.$zK.ExtHostTunnelService,Ce),Je.set(r.$zK.ExtHostWindow,Te),Je.set(r.$zK.ExtHostSecretState,qe),Je.set(r.$zK.ExtHostTelemetry,St),Je.set(r.$zK.ExtHostEditorTabs,xe),Je.set(r.$zK.ExtHostManagedSockets,Qe);const ot=Je.set(r.$zK.ExtHostDecorations,ut.get(T.$Mec)),pt=Je.set(r.$zK.ExtHostDocumentsAndEditors,ut.get(Z.$LM)),bt=Je.set(r.$zK.ExtHostCommands,ut.get(v.$WM)),vt=Je.set(r.$zK.ExtHostTerminalService,ut.get(ce.$oec)),ht=Je.set(r.$zK.ExtHostDebugService,ut.get(M.$Gec)),Lt=Je.set(r.$zK.ExtHostSearch,ut.get(Ze.$3ec)),Qt=Je.set(r.$zK.ExtHostTask,ut.get(Xe.$tfc)),Xt=Je.set(r.$zK.ExtHostOutputService,ut.get(ae.$gfc)),si=Je.set(r.$zK.ExtHostLocalization,ut.get(ne.$wec)),Si=Je.set(r.$zK.ExtHostUrls,new Et.$Dfc(Je)),Ct=Je.set(r.$zK.ExtHostDocuments,new fe.$Cdc(Je,pt)),Zi=Je.set(r.$zK.ExtHostDocumentContentProviders,new V.$Oec(Je,pt,Fe)),ln=Je.set(r.$zK.ExtHostDocumentSaveParticipant,new te.$Pec(Fe,Ct,Je.getProxy(r.$yK.MainThreadBulkEdits))),kt=Je.set(r.$zK.ExtHostNotebook,new he.$6ec(Je,bt,pt,Ct,Pt,Lt)),gi=Je.set(r.$zK.ExtHostNotebookDocuments,new Pe.$afc(kt)),mi=Je.set(r.$zK.ExtHostNotebookEditors,new B.$bfc(Fe,kt)),oi=Je.set(r.$zK.ExtHostNotebookKernels,new J.$cfc(Je,mt,kt,bt,Fe)),Di=Je.set(r.$zK.ExtHostNotebookRenderers,new re.$efc(Je,kt)),Ci=Je.set(r.$zK.ExtHostNotebookDocumentSaveParticipant,new pe.$_ec(Fe,kt,Je.getProxy(r.$yK.MainThreadBulkEdits))),Ft=Je.set(r.$zK.ExtHostEditors,new Ke.$Tdc(Je,pt)),$i=Je.set(r.$zK.ExtHostTreeViews,new st.$Bfc(Je.getProxy(r.$yK.MainThreadTreeViews),bt,Fe)),Ii=Je.set(r.$zK.ExtHostEditorInsets,new p.$Udc(Je.getProxy(r.$yK.MainThreadEditorInsets),Ft,mt.remote)),ai=Je.set(r.$zK.ExtHostDiagnostics,new j.$Gdc(Je,Fe,Nt,pt)),ci=Je.set(r.$zK.ExtHostLanguages,new $e.$0ec(Je,Ct,bt.converter,It)),dt=Je.set(r.$zK.ExtHostLanguageFeatures,new Y.$Kdc(Je,It,Ct,bt,ai,Fe,se,St)),Pi=Je.set(r.$zK.ExtHostFileSystem,new x.$Rec(Je,dt)),xt=Je.set(r.$zK.ExtHostFileSystemEventService,new le.$Sec(Je,Fe,pt)),ni=Je.set(r.$zK.ExtHostQuickOpen,(0,je.$kfc)(Je,gt,bt)),bi=Je.set(r.$zK.ExtHostSCM,new et.$mfc(Je,bt,Ct,Fe)),Xi=Je.set(r.$zK.ExtHostQuickDiff,new ye.$jfc(Je,It)),Ai=Je.set(r.$zK.ExtHostShare,new nt.$nfc(Je,It)),Ri=Je.set(r.$zK.ExtHostComments,(0,E.$Vdc)(Je,bt,Ct)),Li=Je.set(r.$zK.ExtHostProgress,new ge.$ifc(Je.getProxy(r.$yK.MainThreadProgress))),xi=Je.set(r.$zK.ExtHosLabelService,new X.$9ec(Je)),Mi=Je.set(r.$zK.ExtHostTheming,new Ge.$yfc(Je)),ui=Je.set(r.$zK.ExtHostAuthentication,new d.$Mdc(Je)),_i=Je.set(r.$zK.ExtHostTimeline,new _e.$Afc(Je,bt)),Fi=Je.set(r.$zK.ExtHostWebviews,new Ut.$0dc(Je,mt.remote,gt,Fe,se)),Ti=Je.set(r.$zK.ExtHostWebviewPanels,new Ot.$aec(Je,Fi,gt)),Ni=Je.set(r.$zK.ExtHostCustomEditors,new z.$bec(Je,Ct,Jt,Fi,Ti)),Oi=Je.set(r.$zK.ExtHostWebviewViews,new Gt.$Efc(Je,Fi)),hi=Je.set(r.$zK.ExtHostTesting,new Ie.$ufc(Je,bt,pt)),hn=Je.set(r.$zK.ExtHostUriOpeners,new Kt.$Cfc(Je)),en=Je.set(r.$zK.ExtHostProfileContentHandlers,new _.$hfc(Je));Je.set(r.$zK.ExtHostInteractive,new be.$7ec(Je,kt,pt,bt,Fe));const ji=Je.set(r.$zK.ExtHostInlineChat,new ie.$Tec(Je,bt,Ct,Fe)),pi=Je.set(r.$zK.ExtHostChatProvider,new k.$Pdc(Je,Fe)),tn=Je.set(r.$zK.ExtHostChatAgents2,new h.$Qdc(Je,pi,Fe)),nn=Je.set(r.$zK.ExtHostChatVariables,new C.$Rdc(Je)),wi=Je.set(r.$zK.ExtHostChat,new l.$Odc(Je)),vi=Je.set(r.$zK.ExtHostAiRelatedInformation,new a.$Bdc(Je)),rn=Je.set(r.$zK.ExtHostAiEmbeddingVector,new G.$Qec(Je)),_t=Je.set(r.$zK.ExtHostIssueReporter,new H.$8ec(Je)),di=Je.set(r.$zK.ExtHostStatusBar,new Ne.$qfc(Je,bt.converter)),dn=Je.set(r.$zK.ExtHostSpeech,new Ae.$ofc(Je)),Yt=Object.values(r.$zK);Je.assertRegistered(Yt);const yi=new c.$Ndc(Je,pt),sn=new m.$Sdc(Je),Ei=new ee.$$ec(Je,Fe),zi=new O.$Nec(Je);return t.$Ldc.register(bt),function(ze,ti,Ui){const $t=function(){let we=!ze.isUnderDevelopment;function De(){we||(Fe.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(at){if(Array.isArray(at))at.forEach(Oe);else if(typeof at=="string")De();else{const yt=at;typeof yt.scheme>"u"&&De(),typeof yt.exclusive=="boolean"&&(0,tt.$NF)(ze,"documentFiltersExclusive")}return at}}(),fn={getSession(we,De,Oe){return ui.getSession(ze,we,De,Oe)},getSessions(we,De){return(0,tt.$NF)(ze,"authGetSessions"),ui.getSessions(ze,we,De)},async hasSession(we,De){return(0,tt.$NF)(ze,"authSession"),!!await ui.getSession(ze,we,De,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,De,Oe,at){return ui.registerAuthenticationProvider(we,De,Oe,at)}},gn={registerCommand(we,De,Oe){return bt.registerCommand(!0,we,De,Oe,void 0,ze)},registerTextEditorCommand(we,De,Oe){return bt.registerCommand(!0,we,(...at)=>{const yt=Ft.getActiveTextEditor();if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}return yt.edit(Tt=>{De.apply(Oe,[yt,Tt,...at])}).then(Tt=>{Tt||Fe.warn("Edits from command "+we+" were not applied.")},Tt=>{Fe.warn("An error occurred while running command "+we,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,De,Oe)=>((0,tt.$NF)(ze,"diffCommand"),bt.registerCommand(!0,we,async(...at)=>{const yt=pt.activeEditor(!0);if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(yt.id);De.apply(Oe,[Tt,...at])},void 0,void 0,ze)),executeCommand(we,...De){return bt.executeCommand(we,...De)},getCommands(we=!1){return bt.getCommands(we)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$NF)(ze,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$NF)(ze,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ue.$TM)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return ue.$SM.validateSender(we),St.instantiateLogger(ze,we,De)},openExternal(we,De){return Te.openUri(we,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===mt.environment.appUriScheme)return Si.createAppUri(we);try{return await Te.asExternalUri(we,{allowTunneling:!!mt.remote.authority})}catch(De){if((0,u.$NU)(we,L.Schemas.http)||(0,u.$NU)(we,L.Schemas.https))return we;throw De}},get remoteName(){return(0,o.$2k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$NF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,tt.$NF)(ze,"handleIssueUri"),_t.registerIssueUriRequestHandler(ze,we)},registerIssueDataProvider(we){return(0,tt.$NF)(ze,"handleIssueUri"),_t.registerIssueDataProvider(ze,we)},get appQuality(){return(0,tt.$NF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,tt.$NF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const on={createTestController(we,De,Oe){return hi.createTestController(ze,we,De,Oe)},createTestObserver(){return(0,tt.$NF)(ze,"testObserver"),hi.createTestObserver()},runTests(we){return(0,tt.$NF)(ze,"testObserver"),hi.runTests(we)},get onDidChangeTestResults(){return(0,tt.$NF)(ze,"testObserver"),hi.onResultsChanged},get testResults(){return(0,tt.$NF)(ze,"testObserver"),hi.results}},fi=mt.remote.isRemote?Ue.ExtensionKind.Workspace:Ue.ExtensionKind.UI,an={getExtension(we,De){(0,tt.$MF)(ze,"extensionsAny")||(De=!1);const Oe=ti.mine.getExtensionDescription(we);if(Oe)return new oe.$Cec(At,ze.identifier,Oe,fi,!1);if(De){const at=ti.all.getExtensionDescription(we);if(at)return new oe.$Cec(At,ze.identifier,at,fi,!0)}},get all(){const we=[];for(const De of ti.mine.getAllExtensionDescriptions())we.push(new oe.$Cec(At,ze.identifier,De,fi,!1));return we},get allAcrossExtensionHosts(){(0,tt.$NF)(ze,"extensionsAny");const we=new S.$am(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),De=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const at=!we.has(Oe.identifier);De.push(new oe.$Cec(At,ze.identifier,Oe,fi,at))}return De},get onDidChange(){return(0,tt.$MF)(ze,"extensionsAny")?f.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,De){return ci.changeLanguage(we.uri,De)},match(we,De){const Oe=Ct.getDocumentData(De.uri)?.notebook;return(0,A.$LE)(wt.LanguageSelector.from(we),De.uri,De.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,De,Oe){return dt.registerCodeActionProvider(ze,$t(we),De,Oe)},registerDocumentPasteEditProvider(we,De,Oe){return(0,tt.$NF)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,$t(we),De,Oe)},registerCodeLensProvider(we,De){return dt.registerCodeLensProvider(ze,$t(we),De)},registerDefinitionProvider(we,De){return dt.registerDefinitionProvider(ze,$t(we),De)},registerDeclarationProvider(we,De){return dt.registerDeclarationProvider(ze,$t(we),De)},registerImplementationProvider(we,De){return dt.registerImplementationProvider(ze,$t(we),De)},registerTypeDefinitionProvider(we,De){return dt.registerTypeDefinitionProvider(ze,$t(we),De)},registerHoverProvider(we,De){return dt.registerHoverProvider(ze,$t(we),De,ze.identifier)},registerEvaluatableExpressionProvider(we,De){return dt.registerEvaluatableExpressionProvider(ze,$t(we),De,ze.identifier)},registerInlineValuesProvider(we,De){return dt.registerInlineValuesProvider(ze,$t(we),De,ze.identifier)},registerDocumentHighlightProvider(we,De){return dt.registerDocumentHighlightProvider(ze,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return dt.registerLinkedEditingRangeProvider(ze,$t(we),De)},registerReferenceProvider(we,De){return dt.registerReferenceProvider(ze,$t(we),De)},registerRenameProvider(we,De){return dt.registerRenameProvider(ze,$t(we),De)},registerDocumentSymbolProvider(we,De,Oe){return dt.registerDocumentSymbolProvider(ze,$t(we),De,Oe)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,De){return dt.registerDocumentFormattingEditProvider(ze,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return dt.registerDocumentRangeFormattingEditProvider(ze,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,Oe,...at){return dt.registerOnTypeFormattingEditProvider(ze,$t(we),De,[Oe].concat(at))},registerDocumentSemanticTokensProvider(we,De,Oe){return dt.registerDocumentSemanticTokensProvider(ze,$t(we),De,Oe)},registerDocumentRangeSemanticTokensProvider(we,De,Oe){return dt.registerDocumentRangeSemanticTokensProvider(ze,$t(we),De,Oe)},registerSignatureHelpProvider(we,De,Oe,...at){return typeof Oe=="object"?dt.registerSignatureHelpProvider(ze,$t(we),De,Oe):dt.registerSignatureHelpProvider(ze,$t(we),De,typeof Oe>"u"?[]:[Oe,...at])},registerCompletionItemProvider(we,De,...Oe){return dt.registerCompletionItemProvider(ze,$t(we),De,Oe)},registerInlineCompletionItemProvider(we,De,Oe){return De.handleDidShowCompletionItem&&(0,tt.$NF)(ze,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,tt.$NF)(ze,"inlineCompletionsAdditions"),Oe&&(0,tt.$NF)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,$t(we),De,Oe)},registerDocumentLinkProvider(we,De){return dt.registerDocumentLinkProvider(ze,$t(we),De)},registerColorProvider(we,De){return dt.registerColorProvider(ze,$t(we),De)},registerFoldingRangeProvider(we,De){return dt.registerFoldingRangeProvider(ze,$t(we),De)},registerSelectionRangeProvider(we,De){return dt.registerSelectionRangeProvider(ze,we,De)},registerCallHierarchyProvider(we,De){return dt.registerCallHierarchyProvider(ze,we,De)},registerTypeHierarchyProvider(we,De){return dt.registerTypeHierarchyProvider(ze,we,De)},setLanguageConfiguration:(we,De)=>dt.setLanguageConfiguration(ze,we,De),getTokenInformationAtPosition(we,De){return(0,tt.$NF)(ze,"tokenInformation"),ci.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return dt.registerInlayHintsProvider(ze,we,De)},createLanguageStatusItem(we,De){return ci.createLanguageStatusItem(ze,we,De)},registerDocumentDropEditProvider(we,De,Oe){return dt.registerDocumentOnDropEditProvider(ze,we,De,(0,tt.$MF)(ze,"dropMetadata")?Oe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(we,De,Oe){const at=await(y.URI.isUri(we)?Promise.resolve(Bi.openTextDocument(we)):Promise.resolve(we));return Ft.showTextDocument(at,De,Oe)},createTextEditorDecorationType(we){return Ft.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,De,Oe){return Ft.onDidChangeActiveTextEditor(we,De,Oe)},onDidChangeVisibleTextEditors(we,De,Oe){return Ft.onDidChangeVisibleTextEditors(we,De,Oe)},onDidChangeTextEditorSelection(we,De,Oe){return Ft.onDidChangeTextEditorSelection(we,De,Oe)},onDidChangeTextEditorOptions(we,De,Oe){return Ft.onDidChangeTextEditorOptions(we,De,Oe)},onDidChangeTextEditorVisibleRanges(we,De,Oe){return Ft.onDidChangeTextEditorVisibleRanges(we,De,Oe)},onDidChangeTextEditorViewColumn(we,De,Oe){return Ft.onDidChangeTextEditorViewColumn(we,De,Oe)},onDidCloseTerminal(we,De,Oe){return vt.onDidCloseTerminal(we,De,Oe)},onDidOpenTerminal(we,De,Oe){return vt.onDidOpenTerminal(we,De,Oe)},onDidChangeActiveTerminal(we,De,Oe){return vt.onDidChangeActiveTerminal(we,De,Oe)},onDidChangeTerminalDimensions(we,De,Oe){return(0,tt.$NF)(ze,"terminalDimensions"),vt.onDidChangeTerminalDimensions(we,De,Oe)},onDidChangeTerminalState(we,De,Oe){return vt.onDidChangeTerminalState(we,De,Oe)},onDidWriteTerminalData(we,De,Oe){return(0,tt.$NF)(ze,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(we,De,Oe)},onDidExecuteTerminalCommand(we,De,Oe){return(0,tt.$NF)(ze,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(we,De,Oe)},get state(){return Te.getState(ze)},onDidChangeWindowState(we,De,Oe){return Te.onDidChangeWindowState(we,De,Oe)},showInformationMessage(we,...De){return Ei.showMessage(ze,b.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(ze,b.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(ze,b.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,Oe){return ni.showQuickPick(ze,we,De,Oe)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,De){return ni.showInput(we,De)},showOpenDialog(we){return zi.showOpenDialog(ze,we)},showSaveDialog(we){return zi.showSaveDialog(we)},createStatusBarItem(we,De,Oe){let at,yt,Tt;return typeof we=="string"?(at=we,yt=De,Tt=Oe):(yt=we,Tt=De),di.createStatusBarEntry(ze,at,yt,Tt)},setStatusBarMessage(we,De){return di.setStatusBarMessage(we,De)},withScmProgress(we){return se.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Li.withProgress(ze,{location:Ue.ProgressLocation.SourceControl},(De,Oe)=>we({report(at){}}))},withProgress(we,De){return Li.withProgress(ze,we,De)},createOutputChannel(we,De){return Xt.createOutputChannel(we,De,ze)},createWebviewPanel(we,De,Oe,at){return Ti.createWebviewPanel(ze,we,De,Oe,at)},createWebviewTextEditorInset(we,De,Oe,at){return(0,tt.$NF)(ze,"editorInsets"),Ii.createWebviewEditorInset(we,De,Oe,at,ze)},createTerminal(we,De,Oe){return typeof we=="object"?"pty"in we?vt.createExtensionTerminal(we):vt.createTerminalFromOptions(we):vt.createTerminal(we,De,Oe)},registerTerminalLinkProvider(we){return vt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return vt.registerProfileProvider(ze,we,De)},registerTerminalQuickFixProvider(we,De){return(0,tt.$NF)(ze,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(we,ze.identifier.value,De)},registerTreeDataProvider(we,De){return $i.registerTreeDataProvider(we,De,ze)},createTreeView(we,De){return $i.createTreeView(we,De,ze)},registerWebviewPanelSerializer:(we,De)=>Ti.registerWebviewPanelSerializer(ze,we,De),registerCustomEditorProvider:(we,De,Oe={})=>Ni.registerCustomEditorProvider(ze,we,De,Oe),registerFileDecorationProvider(we){return ot.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return Si.registerUriHandler(ze,we)},createQuickPick(){return ni.createQuickPick(ze)},createInputBox(){return ni.createInputBox(ze)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(we,De,Oe){return Mi.onDidChangeActiveColorTheme(we,De,Oe)},registerWebviewViewProvider(we,De,Oe){return Oi.registerWebviewViewProvider(ze,we,De,Oe?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,Oe){return kt.onDidChangeActiveNotebookEditor(we,De,Oe)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,Oe){return mi.onDidChangeNotebookEditorSelection(we,De,Oe)},onDidChangeNotebookEditorVisibleRanges(we,De,Oe){return mi.onDidChangeNotebookEditorVisibleRanges(we,De,Oe)},showNotebookDocument(we,De){return kt.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,Oe){return(0,tt.$NF)(ze,"externalUriOpener"),hn.registerExternalUriOpener(ze.identifier,we,De,Oe)},registerProfileContentHandler(we,De){return(0,tt.$NF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,we,De)},registerQuickDiffProvider(we,De,Oe,at){return(0,tt.$NF)(ze,"quickDiffProvider"),Xi.registerQuickDiffProvider($t(we),De,Oe,at)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,De){return(0,tt.$NF)(ze,"shareProvider"),Ai.registerShareProvider($t(we),De)}},Bi={get rootPath(){return se.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(we){throw new F.$8("rootPath")},getWorkspaceFolder(we){return gt.getWorkspaceFolder(we)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(we){throw new F.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(we){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...Oe)=>gt.updateWorkspaceFolders(ze,we,De||0,...Oe),onDidChangeWorkspaceFolders:function(we,De,Oe){return gt.onDidChangeWorkspace(we,De,Oe)},asRelativePath:(we,De)=>gt.getRelativePath(we,De),findFiles:(we,De,Oe,at)=>gt.findFiles(we,De,Oe,ze.identifier,at),findTextInFiles:(we,De,Oe,at)=>{(0,tt.$NF)(ze,"findTextInFiles");let yt,Tt;return typeof De=="object"?(yt=De,Tt=Oe):(yt={},Tt=De,at=Oe),gt.findTextInFiles(we,yt||{},Tt,ze.identifier,at)},save:we=>((0,tt.$NF)(ze,"saveEditor"),gt.save(we)),saveAs:we=>((0,tt.$NF)(ze,"saveEditor"),gt.saveAs(we)),saveAll:we=>gt.saveAll(we),applyEdit(we,De){return yi.applyWorkspaceEdit(we,ze,De)},createFileSystemWatcher:(we,De,Oe,at)=>{let yt;return typeof De=="boolean"?yt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!at,correlate:!1}:De&&((0,tt.$NF)(ze,"createFileSystemWatcher"),yt={...De,correlate:!0}),xt.createFileSystemWatcher(gt,ze,we,yt)},get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new F.$8("textDocuments")},openTextDocument(we){let De;const Oe=we;if(typeof we=="string")De=Promise.resolve(y.URI.file(we));else if(y.URI.isUri(we))De=Promise.resolve(we);else if(!Oe||typeof Oe=="object")De=Ct.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(at=>Ct.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(we,De,Oe)=>Ct.onDidAddDocument(we,De,Oe),onDidCloseTextDocument:(we,De,Oe)=>Ct.onDidRemoveDocument(we,De,Oe),onDidChangeTextDocument:(we,De,Oe)=>Ct.onDidChangeDocument(we,De,Oe),onDidSaveTextDocument:(we,De,Oe)=>Ct.onDidSaveDocument(we,De,Oe),onWillSaveTextDocument:(we,De,Oe)=>ln.getOnWillSaveTextDocumentEvent(ze)(we,De,Oe),get notebookDocuments(){return kt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let Oe;if(y.URI.isUri(we))Oe=we,await kt.openNotebookDocument(we);else if(typeof we=="string")Oe=y.URI.revive(await kt.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,De,Oe){return gi.onDidSaveNotebookDocument(we,De,Oe)},onDidChangeNotebookDocument(we,De,Oe){return gi.onDidChangeNotebookDocument(we,De,Oe)},onWillSaveNotebookDocument(we,De,Oe){return Ci.getOnWillSaveNotebookDocumentEvent(ze)(we,De,Oe)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,Oe,at){return kt.registerNotebookSerializer(ze,we,De,Oe,(0,tt.$MF)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,De,Oe)=>Ui.onDidChangeConfiguration(we,De,Oe),getConfiguration(we,De){return De=arguments.length===1?void 0:De,Ui.getConfiguration(we,De,ze)},registerTextDocumentContentProvider(we,De){return Zi.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(se.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(ze,we,De)),registerFileSystemProvider(we,De,Oe){return(0,R.$Oc)(Pi.registerFileSystemProvider(ze,we,De,Oe),Pt.addFileSystemProvider(we,De,Oe))},get fs(){return Pt.value},registerFileSearchProvider:(we,De)=>((0,tt.$NF)(ze,"fileSearchProvider"),Lt.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,tt.$NF)(ze,"textSearchProvider"),Lt.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,tt.$NF)(ze,"resolvers"),At.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,tt.$NF)(ze,"resolvers"),xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,tt.$NF)(ze,"resolvers"),At.getRemoteExecServer(we)),onDidCreateFiles:(we,De,Oe)=>xt.onDidCreateFile(we,De,Oe),onDidDeleteFiles:(we,De,Oe)=>xt.onDidDeleteFile(we,De,Oe),onDidRenameFiles:(we,De,Oe)=>xt.onDidRenameFile(we,De,Oe),onWillCreateFiles:(we,De,Oe)=>xt.getOnWillCreateFileEvent(ze)(we,De,Oe),onWillDeleteFiles:(we,De,Oe)=>xt.getOnWillDeleteFileEvent(ze)(we,De,Oe),onWillRenameFiles:(we,De,Oe)=>xt.getOnWillRenameFileEvent(ze)(we,De,Oe),openTunnel:we=>((0,tt.$NF)(ze,"tunnels"),Ce.openTunnel(ze,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,tt.$NF)(ze,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(we,De,Oe)=>((0,tt.$NF)(ze,"tunnels"),Ce.onDidChangeTunnels(we,De,Oe)),registerPortAttributesProvider:(we,De)=>((0,tt.$NF)(ze,"portsAttributes"),Ce.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,tt.$NF)(ze,"tunnelFactory"),Ce.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,tt.$NF)(ze,"timeline"),_i.registerTimelineProvider(we,De,ze.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:we=>((0,tt.$NF)(ze,"workspaceTrust"),gt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,Oe)=>gt.onDidGrantWorkspaceTrust(we,De,Oe),registerEditSessionIdentityProvider:(we,De)=>((0,tt.$NF)(ze,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,Oe)=>((0,tt.$NF)(ze,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(ze)(we,De,Oe)),registerCanonicalUriProvider:(we,De)=>((0,tt.$NF)(ze,"canonicalUriProvider"),gt.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,Oe)=>((0,tt.$NF)(ze,"canonicalUriProvider"),gt.provideCanonicalUri(we,De,Oe))},cn={get inputBox(){return se.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(ze)},createSourceControl(we,De,Oe){return bi.createSourceControl(ze,we,De,Oe)}},Wi={createCommentController(we,De){return Ri.createCommentController(ze,we,De)}},Vi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(we,De,Oe){return ht.onDidStartDebugSession(we,De,Oe)},onDidTerminateDebugSession(we,De,Oe){return ht.onDidTerminateDebugSession(we,De,Oe)},onDidChangeActiveDebugSession(we,De,Oe){return ht.onDidChangeActiveDebugSession(we,De,Oe)},onDidReceiveDebugSessionCustomEvent(we,De,Oe){return ht.onDidReceiveDebugSessionCustomEvent(we,De,Oe)},onDidChangeBreakpoints(we,De,Oe){return ht.onDidChangeBreakpoints(we,De,Oe)},onDidChangeStackFrameFocus(we,De,Oe){return(0,tt.$NF)(ze,"debugFocus"),ht.onDidChangeStackFrameFocus(we,De,Oe)},registerDebugConfigurationProvider(we,De,Oe){return ht.registerDebugConfigurationProvider(we,De,Oe||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return ht.registerDebugAdapterDescriptorFactory(ze,we,De)},registerDebugAdapterTrackerFactory(we,De){return ht.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ht.startDebugging(we,De,{parentSession:Oe}):ht.startDebugging(we,De,Oe||{})},stopDebugging(we){return ht.stopDebugging(we)},addBreakpoints(we){return ht.addBreakpoints(we)},removeBreakpoints(we){return ht.removeBreakpoints(we)},asDebugSourceUri(we,De){return ht.asDebugSourceUri(we,De)}},qi={registerTaskProvider:(we,De)=>Qt.registerTaskProvider(ze,we,De),fetchTasks:we=>Qt.fetchTasks(we),executeTask:we=>Qt.executeTask(ze,we),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(we,De,Oe)=>Qt.onDidStartTask(we,De,Oe),onDidEndTask:(we,De,Oe)=>Qt.onDidEndTask(we,De,Oe),onDidStartTaskProcess:(we,De,Oe)=>Qt.onDidStartTaskProcess(we,De,Oe),onDidEndTaskProcess:(we,De,Oe)=>Qt.onDidEndTaskProcess(we,De,Oe)},li={createNotebookController(we,De,Oe,at,yt){return oi.createNotebookController(ze,we,De,Oe,at,(0,tt.$MF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>kt.registerNotebookCellStatusBarItemProvider(ze,we,De),createRendererMessaging(we){return Di.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,tt.$NF)(ze,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,De){return(0,tt.$NF)(ze,"notebookKernelSource"),oi.registerKernelSourceActionProvider(ze,we,De)},onDidChangeNotebookCellExecutionState(we,De,Oe){return(0,tt.$NF)(ze,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,De,Oe)}},Ki={t(...we){if(typeof we[0]=="string"){const De=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return si.getMessage(ze.identifier.value,{message:De,args:Oe})}return si.getMessage(ze.identifier.value,we[0])},get bundle(){return si.getBundle(ze.identifier.value)},get uri(){return si.getBundleUri(ze.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,tt.$NF)(ze,"interactive"),ji.registerProvider(ze,we,De={label:De?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(we,De){return(0,tt.$NF)(ze,"interactive"),wi.registerChatProvider(ze,we,De)},sendInteractiveRequestToProvider(we,De){return(0,tt.$NF)(ze,"interactive"),wi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,tt.$NF)(ze,"interactiveUserActions"),wi.onDidPerformUserAction},transferChatSession(we,De){return(0,tt.$NF)(ze,"interactive"),wi.transferChatSession(we,De)}},Gi={getRelatedInformation(we,De){return(0,tt.$NF)(ze,"aiRelatedInformation"),vi.getRelatedInformation(ze,we,De)},registerRelatedInformationProvider(we,De){return(0,tt.$NF)(ze,"aiRelatedInformation"),vi.registerRelatedInformationProvider(ze,we,De)},registerEmbeddingVectorProvider(we,De){return(0,tt.$NF)(ze,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(ze,we,De)}},Ji={registerChatResponseProvider(we,De,Oe){return(0,tt.$NF)(ze,"chatProvider"),pi.registerProvider(ze.identifier,we,De,Oe)},requestChatAccess(we){return(0,tt.$NF)(ze,"chatRequestAccess"),pi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,De,Oe){return(0,tt.$NF)(ze,"chatVariables"),nn.registerVariableResolver(ze,we,De,Oe)},registerMappedEditsProvider(we,De){return(0,tt.$NF)(ze,"mappedEditsProvider"),dt.registerMappedEditsProvider(ze,we,De)},createChatAgent(we,De){return(0,tt.$NF)(ze,"chatAgents2"),tn.createChatAgent(ze,we,De)}},un={registerSpeechProvider(we,De){return(0,tt.$NF)(ze,"speech"),dn.registerProvider(ze.identifier,we,De)}};return{version:mt.version,ai:Gi,authentication:fn,commands:gn,comments:Wi,chat:Ji,debug:Vi,env:ki,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Ue.$yL,TerminalOutputAnchor:Ue.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ue.ChatAgentResultFeedbackKind,ChatMessage:Ue.$pM,ChatMessageRole:Ue.ChatMessageRole,ChatVariableLevel:Ue.ChatVariableLevel,CallHierarchyIncomingCall:Ue.$XK,CallHierarchyItem:Ue.$WK,CallHierarchyOutgoingCall:Ue.$YK,CancellationError:F.$4,CancellationTokenSource:I.$2d,CandidatePortSource:r.CandidatePortSource,CodeAction:Ue.$TK,CodeActionKind:Ue.$UK,CodeActionTriggerKind:Ue.CodeActionTriggerKind,CodeLens:Ue.$ZK,Color:Ue.$aL,ColorInformation:Ue.$bL,ColorPresentation:Ue.$cL,ColorThemeKind:Ue.ColorThemeKind,CommentMode:Ue.CommentMode,CommentState:Ue.CommentState,CommentThreadCollapsibleState:Ue.CommentThreadCollapsibleState,CommentThreadState:Ue.CommentThreadState,CompletionItem:Ue.$7K,CompletionItemKind:Ue.CompletionItemKind,CompletionItemTag:Ue.CompletionItemTag,CompletionList:Ue.$8K,CompletionTriggerKind:Ue.CompletionTriggerKind,ConfigurationTarget:Ue.ConfigurationTarget,CustomExecution:Ue.$kL,DebugAdapterExecutable:Ue.$CL,DebugAdapterInlineImplementation:Ue.$FL,DebugAdapterNamedPipeServer:Ue.$EL,DebugAdapterServer:Ue.$DL,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ue.DebugConsoleMode,DecorationRangeBehavior:Ue.DecorationRangeBehavior,Diagnostic:Ue.$OK,DiagnosticRelatedInformation:Ue.$NK,DiagnosticSeverity:Ue.DiagnosticSeverity,DiagnosticTag:Ue.DiagnosticTag,Disposable:Ue.$AK,DocumentHighlight:Ue.$QK,DocumentHighlightKind:Ue.DocumentHighlightKind,DocumentLink:Ue.$_K,DocumentSymbol:Ue.$SK,EndOfLine:Ue.EndOfLine,EnvironmentVariableMutatorType:Ue.EnvironmentVariableMutatorType,EvaluatableExpression:Ue.$IL,InlineValueText:Ue.$JL,InlineValueVariableLookup:Ue.$KL,InlineValueEvaluatableExpression:Ue.$LL,InlineCompletionTriggerKind:Ue.InlineCompletionTriggerKind,EventEmitter:f.$Rd,ExtensionKind:Ue.ExtensionKind,ExtensionMode:Ue.ExtensionMode,ExternalUriOpenerPriority:Ue.ExternalUriOpenerPriority,FileChangeType:Ue.FileChangeType,FileDecoration:Ue.$VL,FileDecoration2:Ue.$VL,FileSystemError:Ue.$NL,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Ue.$OL,FoldingRangeKind:Ue.FoldingRangeKind,FunctionBreakpoint:Ue.$AL,InlineCompletionItem:Ue.$9K,InlineCompletionList:Ue.$0K,Hover:Ue.$PK,IndentAction:P.IndentAction,Location:Ue.$MK,MarkdownString:Ue.$1K,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Ue.$2K,PortAutoForwardAction:Ue.PortAutoForwardAction,Position:Ue.$BK,ProcessExecution:Ue.$iL,ProgressLocation:Ue.ProgressLocation,QuickInputButtons:Ue.$UL,Range:Ue.$CK,RelativePattern:Ue.$wL,Selection:Ue.$DK,SelectionRange:Ue.$VK,SemanticTokens:Ue.$RL,SemanticTokensBuilder:Ue.$QL,SemanticTokensEdit:Ue.$SL,SemanticTokensEdits:Ue.$TL,SemanticTokensLegend:Ue.$PL,ShellExecution:Ue.$jL,ShellQuoting:Ue.ShellQuoting,SignatureHelp:Ue.$4K,SignatureHelpTriggerKind:Ue.SignatureHelpTriggerKind,SignatureInformation:Ue.$3K,SnippetString:Ue.$LK,SourceBreakpoint:Ue.$zL,StandardTokenType:Ue.StandardTokenType,StatusBarAlignment:Ue.StatusBarAlignment,SymbolInformation:Ue.$RK,SymbolKind:Ue.SymbolKind,SymbolTag:Ue.SymbolTag,Task:Ue.$lL,TaskGroup:Ue.$hL,TaskPanelKind:Ue.TaskPanelKind,TaskRevealKind:Ue.TaskRevealKind,TaskScope:Ue.TaskScope,TerminalLink:Ue.$dL,TerminalQuickFixExecuteTerminalCommand:Ue.$fL,TerminalQuickFixOpener:Ue.$eL,TerminalLocation:Ue.TerminalLocation,TerminalProfile:Ue.$gL,TerminalExitReason:Ue.TerminalExitReason,TextDocumentSaveReason:Ue.TextDocumentSaveReason,TextEdit:Ue.$HK,SnippetTextEdit:Ue.$JK,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ue.TextEditorLineNumbersStyle,TextEditorRevealType:Ue.TextEditorRevealType,TextEditorSelectionChangeKind:Ue.TextEditorSelectionChangeKind,SyntaxTokenType:Ue.SyntaxTokenType,TextDocumentChangeReason:Ue.TextDocumentChangeReason,ThemeColor:Ue.$vL,ThemeIcon:Ue.$uL,TreeItem:Ue.$mL,TreeItemCheckboxState:Ue.TreeItemCheckboxState,TreeItemCollapsibleState:Ue.TreeItemCollapsibleState,TypeHierarchyItem:Ue.$eM,UIKind:Wt.UIKind,Uri:y.URI,ViewColumn:Ue.ViewColumn,WorkspaceEdit:Ue.$KK,DocumentDropEdit:Ue.$sL,DocumentPasteEdit:Ue.$tL,InlayHint:Ue.$6K,InlayHintLabelPart:Ue.$5K,InlayHintKind:Ue.InlayHintKind,RemoteAuthorityResolverError:Ue.$GK,ResolvedAuthority:Ue.$EK,ManagedResolvedAuthority:Ue.$FK,SourceControlInputBoxValidationType:Ue.SourceControlInputBoxValidationType,ExtensionRuntime:Ue.ExtensionRuntime,TimelineItem:Ue.$6L,NotebookRange:Ue.$XL,NotebookCellKind:Ue.NotebookCellKind,NotebookCellExecutionState:Ue.NotebookCellExecutionState,NotebookCellData:Ue.$YL,NotebookData:Ue.$ZL,NotebookRendererScript:Ue.$4L,NotebookCellStatusBarAlignment:Ue.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ue.NotebookEditorRevealType,NotebookCellOutput:Ue.$2L,NotebookCellOutputItem:Ue.$1L,NotebookCellStatusBarItem:Ue.$3L,NotebookControllerAffinity:Ue.NotebookControllerAffinity,NotebookControllerAffinity2:Ue.NotebookControllerAffinity2,NotebookEdit:Ue.$IK,NotebookKernelSourceAction:Ue.$5L,PortAttributes:Ue.$8L,LinkedEditingRanges:Ue.$7L,TestResultState:Ue.TestResultState,TestRunRequest:Ue.$9L,TestMessage:Ue.$0L,TestMessage2:Ue.$0L,TestTag:Ue.$$L,TestRunProfileKind:Ue.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Ue.$rL,DataTransferItem:Ue.$nL,CoveredCount:Ue.$_L,FileCoverage:Ue.$aM,StatementCoverage:Ue.$bM,BranchCoverage:Ue.$cM,FunctionCoverage:Ue.$dM,WorkspaceTrustState:Ue.WorkspaceTrustState,LanguageStatusSeverity:Ue.LanguageStatusSeverity,QuickPickItemKind:Ue.QuickPickItemKind,InputBoxValidationSeverity:Ue.InputBoxValidationSeverity,TabInputText:Ue.$fM,TabInputTextDiff:Ue.$gM,TabInputTextMerge:Ue.$hM,TabInputCustom:Ue.$iM,TabInputNotebook:Ue.$kM,TabInputNotebookDiff:Ue.$lM,TabInputWebview:Ue.$jM,TabInputTerminal:Ue.$mM,TabInputInteractiveWindow:Ue.$nM,TabInputChat:Ue.$oM,TelemetryTrustedValue:i.$po,LogLevel:w.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ue.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ue.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ue.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ue.$GL,ThreadFocus:Ue.$HL,RelatedInformationType:Ue.RelatedInformationType,SpeechToTextStatus:Ue.SpeechToTextStatus}}}e.$Hfc=qt}),define(ke[370],Se([1,0,106,154,41,151,42,35,69,46,95,96,97,118,72,91,153,71,57,117,90,70,152,14,58,115,116]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Dr)(c.$wec,c.$vec,1),(0,I.$Dr)(s.$ej,t.$Ifc,1),(0,I.$Dr)(w.$Hdc,w.$Idc,1),(0,I.$Dr)(b.$WM,b.$VM,0),(0,I.$Dr)(L.$3dc,L.$1dc,0),(0,I.$Dr)(o.$5dc,o.$4dc,0),(0,I.$Dr)(P.$Gec,P.$Kec,0),(0,I.$Dr)(R.$Mec,R.$Lec,0),(0,I.$Dr)(y.$LM,y.$KM,0),(0,I.$Dr)(l.$xec,l.$yec,0),(0,I.$Dr)(i.$Edc,i.$Ddc,0),(0,I.$Dr)(F.$gfc,F.$ffc,1),(0,I.$Dr)($.$3ec,$.$4ec,0),(0,I.$Dr)(S.$lec,S.$kec,0),(0,I.$Dr)(A.$tfc,A.$sfc,0),(0,I.$Dr)(g.$oec,g.$rec,0),(0,I.$Dr)(D.$Rwb,D.$Swb,0),(0,I.$Dr)(u.$Gfc,u.$Ffc,0),(0,I.$Dr)(f.$Zdc,f.$Ydc,0),(0,I.$Dr)(n.$tec,n.$sec,0),(0,I.$Dr)(r.$UM,r.$RM,0),(0,I.$Dr)(a.$cec,a.$dec,0),(0,I.$Dr)(d.$Eec,d.$Fec,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=void 0;function L(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$Yfc=L;function b(P,$,S,D){const w=(0,I.$1b)(S,y),u=new f.$2I($,w,D),o=u.preview.matches;return{ranges:(0,I.$1b)(w,g),uri:P,preview:{text:u.preview.text,matches:(0,I.$1b)(o,g)}}}e.$Zfc=b;function y(P){return new f.$3I(P.start.line,P.start.character,P.end.line,P.end.character)}function g(P){return new R.$QI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor($,S){this.a=$,this.b=S}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$1fc=A,e.$1fc=A=He([Be(1,F.$dj)],A)}),define(ke[371],Se([1,0,50,16,76,33,12,13,119,372]),function(me,e,I,F,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=e.$2fc=void 0;const A=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,r,a,t){const s=$(n,r,a,t),d=r.folder.fsPath;return{cmd:I.spawn(A,s.args,{cwd:d}),rgDiskPath:A,siblingClauses:s.siblingClauses,rgArgs:s,cwd:d}}e.$2fc=P;function $(n,r,a,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];D([r],a,!1).forEach(c=>{const l=(0,y.$Yfc)(c);if(s.push("-g",l),L.$j){const h=(0,f.$vl)(l);h!==l&&s.push("-g",h)}});const d=S([r],t,void 0,!1);return d.globArgs.forEach(c=>{const l=`!${(0,y.$Yfc)(c)}`;if(s.push("-g",l),L.$j){const h=(0,f.$vl)(l);h!==l&&s.push("-g",h)}}),r.disregardIgnoreFiles!==!1?s.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),r.ignoreSymlinks||s.push("--follow"),n.exists&&s.push("--quiet"),s.push("--no-config"),r.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:d.siblingClauses}}function S(n,r,a,t=!0){const s=[];let d={};return n.forEach(c=>{const l=Object.assign({},c.excludePattern||{},r||{}),h=w(l,t?c.folder.fsPath:void 0,a);s.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:s,siblingClauses:d}}function D(n,r,a=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},r||{},s.includePattern||{}),c=w(d,a?s.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function w(n,r,a){const t=[],s={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const c=n[d];d=o(r?u(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof c=="boolean"&&c?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):c&&c.when&&(s[d]=c)}),{globArgs:t,siblingClauses:s}}function u(n,r){return F.$hc(r)?r:F.$ic(n,r)}e.$3fc=u;function o(n){return n=b.$Oe(n,"\\"),b.$Oe(n,"/")}function i(n){return R.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$4fc=i}),define(ke[373],Se([1,0,50,55,16,374,19,43,34,76,33,12,38,13,18,30,36,371,130]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=e.$5fc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&y.$Cj(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Eq)(this.b).normalizedLowercase),this.u=c.excludePattern&&y.$Cj(c.excludePattern),this.t=new Map,c.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),k=l.folder.fsPath;c.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==k).forEach(C=>{(0,A.$2f)(C,k)&&(h[f.$kc(k,C)]=!0)}),this.t.set(k,new t(h,k))})}cancel(){this.l=!0,n.forEach(c=>c())}walk(c,l,h,k,C){if(this.m=$.$Nd.create(!1),this.l)return C(null,this.j);l.forEach(m=>{const p=f.$mc(m.fsPath);this.u&&this.u(m.fsPath,p)||this.J(h,{relativePath:m.fsPath,searchPath:void 0})}),this.r=$.$Nd.create(!1),this.w(c,(m,p)=>{this.x(this.y,this,m,h,k,v=>{if(v){const E=(0,b.$Gi)(v);console.error(E),this.q.push(E),p(v,void 0)}else p(null,void 0)})},(m,p)=>{this.m.stop();const v=m?L.$Gb(m)[0]:null;C(v,this.j)})}w(c,l,h){const k=new Array(c.length),C=new Array(c.length);let m=!1,p=0;if(c.length===0)return h(null,[]);c.forEach((v,E)=>{l(v,(N,z)=>{if(N?(m=!0,k[E]=null,C[E]=N):(k[E]=z,C[E]=null),++p===c.length)return h(m?C:null,k)})})}x(c,l,...h){try{c.apply(l,h)}catch(k){h[h.length-1](k)}}y(c,l,h,k){const C=c.folder.fsPath,m=P.$j,p=()=>M&&M.kill();n.add(p);let v=V=>{n.delete(p),v=()=>{},k(V)},E="";const N=this.D(),z=(0,o.$2fc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),M=z.cmd,T=!Object.keys(z.siblingClauses).length,j=z.rgArgs.args.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");let O=`${z.rgDiskPath} ${j}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),h({message:O}),this.s=0,this.z(M,"utf8",h,(V,te,fe)=>{if(V){v(V);return}if(this.j){v();return}const Q=(E+(m?g.$ul(te||""):te)).split(`
`);if(fe){const G=Q.length;Q[G-1]=Q[G-1].trim(),Q[G-1]||Q.pop()}else E=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,T){for(const G of Q)if(this.J(l,{base:C,relativePath:G,searchPath:this.N(c,G)}),this.j){p();break}(fe||this.j)&&v();return}this.G(c,N,C,Q,l),fe&&(this.H(N,C,l),v())})}spawnFindCmd(c){const l=this.t.get(c.folder.fsPath),h=l.getBasenameTerms(),k=l.getPathTerms(),C=["-L","."];if(h.length||k.length){C.push("-not","(","(");for(const m of h)C.push("-name",m),C.push("-o");for(const m of k)C.push("-path",m),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),I.spawn("find",C,{cwd:c.folder.fsPath})}readStdout(c,l,h){let k="";this.z(c,l,()=>{},(C,m,p)=>{if(C){h(C);return}k+=m,p&&h(null,k)})}z(c,l,h,k){let C=(v,E,N)=>{(v||N)&&(C=()=>{},this.r?.stop()),k(v,E,N)},m=!1;c.stdout?(this.A(c.stdout,l,C),c.stdout.once("data",()=>m=!0)):h({message:"stdout is null"});let p;c.stderr?p=this.B(c.stderr):h({message:"stderr is null"}),c.on("error",v=>{C(v)}),c.on("close",v=>{let E;!m&&(E=this.C(p,l))&&s(E)?C(new Error(`command failed with error code ${v}: ${this.C(p,l)}`)):(this.g&&v===0&&(this.j=!0),C(null,"",!0))})}A(c,l,h){const k=new R.StringDecoder(l);return c.on("data",C=>{h(null,k.write(C))}),k}B(c){const l=[];return c.on("data",h=>{l.push(h)}),l}C(c,l){const h=new R.StringDecoder(l);return c.map(k=>h.write(k)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:l},h,k,C){k.indexOf(this.b)!==-1&&this.J(C,{base:h,relativePath:this.b,searchPath:this.N(c,this.b)});const m=p=>{const v=f.$mc(p),E=f.$lc(p);let N=l[E];N||(N=l[E]=[],m(E)),N.push({base:h,relativePath:p,basename:v,searchPath:this.N(c,p)})};k.forEach(m)}H({rootEntries:c,pathToEntries:l},h,k){const C=this,m=this.t.get(h),p=this.b;function v(E){C.o++;const N=(0,u.$fJ)(()=>E.map(z=>z.basename));for(let z=0,M=E.length;z<M;z++){const T=E[z],{relativePath:j,basename:O}=T;if(m.test(j,O,p!==O?N:void 0))continue;const V=l[j];if(V)v(V);else{if(C.p++,j===p)continue;C.J(k,T)}if(C.j)break}}v(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,l,h,k,C){const m=c.folder,p=(0,u.$fJ)(()=>h);this.w(h,(v,E)=>{if(this.l||this.j)return E(null);const N=l?[l,v].join(f.sep):v;if(this.t.get(c.folder.fsPath).test(N,v,this.a.filePattern!==v?p:void 0))return E(null);const z=[m.fsPath,N].join(f.sep);F.lstat(z,(M,T)=>{if(M||this.l||this.j)return E(null);this.L(z,T,(j,O)=>j||this.l||this.j?E(null):O.isDirectory()?(this.o++,this.M(z,T,(V,te)=>V||this.l||this.j||(te=te||"",this.v[te])?E(null):(this.v[te]=!0,w.Promises.readdir(z).then(fe=>{if(this.l||this.j)return E(null);this.I(c,N,fe,k,Z=>E(Z||null))},fe=>{E(null)})))):(this.p++,N===this.b||this.h&&D.$Gf(O.size)&&O.size>this.h||this.J(k,{base:m.fsPath,relativePath:N,searchPath:this.N(c,N)}),E(null,void 0)))})},v=>{const E=v&&L.$Gb(v);return C(E&&E.length>0?E[0]:void 0)})}J(c,l){this.K(l)&&(!this.d||this.d(l.relativePath,f.$mc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(l))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.$aJ)(c,this.c)}return!0}L(c,l,h){return l.isSymbolicLink()?F.stat(c,h):h(null,l)}M(c,l,h){return l.isSymbolicLink()?F.realpath(c,(k,C)=>k?h(k):h(null,C)):h(null,c)}N(c,l){return c.folderName?f.$ic(c.folderName,l):l}}e.$5fc=r;class a{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new r(c)}search(c,l,h){this.c.walk(this.a,this.b,c,l,(k,C)=>{h(k,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$6fc=a;class t{constructor(c,l){this.expression=c,this.c=l,this.d(c)}d(c){let l,h;Object.keys(c).filter(k=>c[k]).forEach(k=>{f.$hc(k)?(l=l||y.$xj(),l[k]=c[k]):(h=h||y.$xj(),h[k]=c[k])}),this.a=l&&y.$Cj(l,{trimForExclusions:!0}),this.b=h&&y.$Cj(h,{trimForExclusions:!0})}test(c,l,h){return this.b&&this.b(c,l,h)||this.a&&this.a(f.$ic(this.c,c),l,h)}getBasenameTerms(){const c=[];return this.a&&c.push(...y.$Ej(this.a)),this.b&&c.push(...y.$Ej(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...y.$Fj(this.a)),this.b&&c.push(...y.$Fj(this.b)),c}}function s(d){const c=d.trim().split(`
`),l=c[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return S.$uf(c[c.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[375],Se([1,0,98,22,186,21]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.DecodeStreamErrorKind=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC="utf8",e.$QC="utf8bom",e.$RC="utf16be",e.$SC="utf16le";function L(l){return[e.$PC,e.$QC,e.$RC,e.$SC].some(h=>h===l)}e.$TC=L,e.$UC=[254,255],e.$VC=[255,254],e.$WC=[239,187,191];const b=512,y=512,g=512*8,A=512*128;var P;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class $ extends Error{constructor(h,k){super(h),this.decodeStreamErrorKind=k}}e.$XC=$;class S{static async create(h){let k;if(h!==e.$PC)k=(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const C=new TextDecoder;k={write(m){return C.decode(m,{stream:!0})},end(){return C.decode()}}}return new S(k)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function D(l,h){const k=h.minBytesRequiredForDetection??h.guessEncoding?g:y;return new Promise((C,m)=>{const p=(0,I.$6d)(T=>T.join("")),v=[];let E=0,N;const z=new R.$2d,M=async()=>{try{const T=await c({buffer:F.$fe.concat(v),bytesRead:E},h.guessEncoding);if(T.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);T.encoding=await h.overwriteEncoding(T.encoding),N=await S.create(T.encoding);const j=N.write(F.$fe.concat(v).buffer);p.write(j),v.length=0,E=0,C({stream:p,detected:T})}catch(T){z.cancel(),p.destroy(),m(T)}};(0,I.$0d)(l,{onData:async T=>{N?p.write(N.write(T.buffer)):(v.push(T),E+=T.byteLength,E>=k&&(l.pause(),await M(),setTimeout(()=>l.resume())))},onError:T=>p.error(T),onEnd:async()=>{N||await M(),p.end(N?.end())}},z.token)})}e.$YC=D;async function w(l,h,k){const m=(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),k);let p=!1,v=!1;return{read(){if(v)return null;const E=l.read();if(typeof E!="string"){if(v=!0,!p&&k?.addBOM)switch(h){case e.$PC:case e.$QC:return F.$fe.wrap(Uint8Array.from(e.$WC));case e.$RC:return F.$fe.wrap(Uint8Array.from(e.$UC));case e.$SC:return F.$fe.wrap(Uint8Array.from(e.$VC))}const N=m.end();return N&&N.length>0?(p=!0,F.$fe.wrap(N)):null}return p=!0,F.$fe.wrap(m.write(E))}}}e.$ZC=w;async function u(l){return(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.$1C=u;function o(l){return l===e.$QC||l===null?e.$PC:l}e.$2C=o;function i(l,h){if(!l||h<e.$UC.length)return null;const k=l.readUInt8(0),C=l.readUInt8(1);if(k===e.$UC[0]&&C===e.$UC[1])return e.$RC;if(k===e.$VC[0]&&C===e.$VC[1])return e.$SC;if(h<e.$WC.length)return null;const m=l.readUInt8(2);return k===e.$WC[0]&&C===e.$WC[1]&&m===e.$WC[2]?e.$QC:null}e.$3C=i;const n=["ascii","utf-16","utf-32"];async function r(l){const h=await(0,f.$OC)("jschardet","dist/jschardet.min.js"),k=l.slice(0,A),C=s(k.buffer),m=h.detect(C);if(!m||!m.encoding)return null;const p=m.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(m.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function s(l){let h="";for(let k=0;k<l.length;k++)h+=String.fromCharCode(l[k]);return h}function d(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$4C=d;function c({buffer:l,bytesRead:h},k){let C=i(l,h),m=!1;if(C!==e.$RC&&C!==e.$SC&&l){let p=!0,v=!0,E=!1;for(let N=0;N<h&&N<b;N++){const z=N%2===1,M=l.readUInt8(N)===0;if(M&&(E=!0),p&&(z&&!M||!z&&M)&&(p=!1),v&&(z&&M||!z&&!M)&&(v=!1),M&&!p&&!v)break}E&&(p?C=e.$SC:v?C=e.$RC:m=!0)}return k&&!m&&!C&&l?r(l.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:m,encoding:C}}e.$5C=c,e.$6C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,375,30,156]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class R extends f.$Yec{constructor(b,y,g=F,A="searchProcess"){super(b,y,{readdir:P=>g.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.$4C)(P)},A)}}e.$bgc=R}),define(ke[158],Se([1,0,50,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=e.$$fc=e.$0fc=e.$9fc=e.$8fc=e.$7fc=void 0;const u=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(v){this.a=v}provideTextSearchResults(v,E,N,z){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...E,folder:E.folder.toString()})}`),new Promise((M,T)=>{z.onCancellationRequested(()=>G());const j=s(v,E),O=E.folder.fsPath,V=j.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${u} ${V}
 - cwd: ${O}`);let te=I.spawn(u,j,{cwd:O});te.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),T((0,P.$9I)(new P.$7I(q&&q.message,P.SearchErrorCode.rgProcessError)))});let fe=!1;const Z=new r(E.maxResults,O,E.previewOptions);Z.on("result",q=>{fe=!0,x="",N.report(q)});let Q=!1;const G=()=>{Q=!0,te?.kill(),Z?.cancel()};let oe=!1;Z.on("hitLimit",()=>{oe=!0,G()});let x="";te.stdout.on("data",q=>{Z.handleData(q),fe||(x+=q)});let Ee=!1;te.stdout.once("data",()=>Ee=!0);let le="";te.stderr.on("data",q=>{const U=q.toString();this.a.appendLine(U),le.length+U.length<1e6&&(le+=U)}),te.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(fe?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),Q)M({limitHit:oe});else{Z.flush(),te=null;let q;le&&!Ee&&(q=i(le))?T((0,P.$9I)(new P.$7I(q.message,q.code))):M({limitHit:oe})}})})}}e.$7fc=o;function i(p){const v=p.split(`
`),E=v[0].trim();if(v.some(z=>z.startsWith("regex parse error")))return new P.$7I(n(v),P.SearchErrorCode.regexParseError);const N=E.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$7I(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(E.startsWith("error parsing glob"))return new P.$7I(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.globParseError);if(E.startsWith("the literal"))return new P.$7I(E.charAt(0).toUpperCase()+E.substr(1),P.SearchErrorCode.invalidLiteral);if(E.startsWith("PCRE2: error compiling pattern"))return new P.$7I(E,P.SearchErrorCode.regexParseError)}function n(p){const v=["Regex parse error"],E=p.filter(N=>N.startsWith("PCRE2:"));if(E.length>=1){const N=E[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const z=N.split(":")[1];v.push(":"+z)}}return v.join("")}class r extends F.EventEmitter{constructor(v,E,N){super(),this.g=v,this.h=E,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,E){return super.on(v,E),this}handleData(v){if(this.b)return;const E=typeof v=="string"?v:this.d.write(v);this.k(E)}k(v){let E=v.indexOf(`
`);const N=this.a+v;if(E>=0)E+=this.a.length;else{this.a=N;return}let z=0;for(;E>=0;)this.m(N.substring(z,E).trim()),z=E+1,E=N.indexOf(`
`,z);this.a=N.substring(z)}m(v){if(this.b||!v)return;let E;try{E=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(E.type==="match"){const N=a(E.data.path),z=A.URI.file(y.$ic(this.h,N)),M=this.n(E.data,z);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(E.type==="context"){const N=a(E.data.path),z=A.URI.file(y.$ic(this.h,N));this.o(E.data,z).forEach(T=>this.p(T))}}n(v,E){const N=v.line_number-1,z=a(v.lines),M=Buffer.from(z);let T=0,j=0,O=N;v.submatches.length===0&&v.submatches.push(z.length?{start:0,end:1,match:{text:z[0]}}:{start:0,end:0,match:{text:""}});const V=(0,R.$Gb)(v.submatches.map((te,fe)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=a(te.match),Q=M.slice(T,te.start).toString(),G=t(Q),oe=G.numLines>0?G.lastLineLength:G.lastLineLength+j,x=t(Z),Ee=G.numLines+O,le=x.numLines+Ee,q=x.numLines>0?x.lastLineLength:x.lastLineLength+oe;return T=te.end,j=q,O=le,new $.$QI(Ee,oe,le,q)}));return(0,w.$Zfc)(E,z,V,this.j)}o(v,E){const N=a(v.lines),z=v.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,T)=>({text:M,uri:E,lineNumber:z+T}))}p(v){this.emit("result",v)}}e.$8fc=r;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const v=/\n/g;let E=0,N=-1,z;for(;z=v.exec(p);)E++,N=z.index;const M=N>=0?p.length-N-1:p.length;return{numLines:E,lastLineLength:M}}function s(p,v){const E=["--hidden","--no-require-git"];E.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:z}=(0,L.$J)(v.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(z&&z.length){const T=new Set;z.forEach(j=>{T.add(j)}),E.push("-g","!*"),T.forEach(j=>{d(j).map(w.$Yfc).forEach(O=>{E.push("-g",O)})})}N&&N.length&&N.forEach(T=>{E.push("-g",T)}),v.excludes.map(w.$Yfc).forEach(T=>E.push("-g",`!${T}`)),v.maxFileSize&&E.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||E.push("--no-ignore-parent"):E.push("--no-ignore"),v.followSymlinks&&E.push("--follow"),v.encoding&&v.encoding!=="utf8"&&E.push("--encoding",v.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,g.$Je)(p.pattern),p.isRegExp=!0),v.usePCRE2&&E.push("--pcre2"),E.push("--crlf"),p.isRegExp&&(p.pattern=c(p.pattern),E.push("--engine","auto"));let M;if(p.isWordMatch){const j=(0,g.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");E.push("--regexp",j)}else if(p.isRegExp){let T=h(p.pattern);T=k(T),E.push("--regexp",T)}else M=p.pattern,E.push("--fixed-strings");return E.push("--no-config"),v.useGlobalIgnoreFiles||E.push("--no-ignore-global"),E.push("--json"),p.isMultiline&&E.push("--multiline"),v.beforeContext&&E.push("--before-context",v.beforeContext+""),v.afterContext&&E.push("--after-context",v.afterContext+""),E.push("--"),M&&E.push(M),E.push("."),E}e.$9fc=s;function d(p){return m(p).flatMap(E=>{const N=(0,b.$Aj)(E,"/");return N.map((z,M)=>N.slice(0,M+1).join("/"))})}function c(p){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(v);)p=p.replace(v,"$1\\x{$2}");const E=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");return p}e.$0fc=c;const l=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let v;try{v=new S.RegExpParser().parsePattern(p)}catch{return p}let E="",N=0;const z=(j,O,V)=>{E+=p.slice(N,j)+V,N=O},M=[];return new S.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const O=M[0];if(!O)z(j.start,j.end,"\\r?\\n");else if(!M.some(l))if(O.type==="CharacterClass")if(O.negate){const V=p.slice(O.start+2,j.start)+p.slice(j.end,O.end-1);O.parent?.type==="Quantifier"?z(O.start,O.end,V?`[^${V}]`:"."):z(O.start,O.end,"(?!\\r?\\n"+(V?`|[${V}]`:"")+")")}else{const V=p.slice(O.start+1,j.start)+p.slice(j.end,O.end-1);z(O.start,O.end,V===""?"\\r?\\n":`(?:[${V}]|\\r?\\n)`)}else O.type==="Quantifier"&&z(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){M.unshift(j)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(j){M.unshift(j)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(j){M.unshift(j)},onCharacterClassLeave(){M.shift()},onAssertionEnter(j){l(j)&&M.push(j)},onAssertionLeave(j){M[0]===j&&M.shift()}}).visit(v),E+=p.slice(N),E}e.$$fc=h;function k(p){return p.replace(/\n/g,"\\r?\\n")}e.$_fc=k;function C(p){let v=!1,E=!1,N="",z="";for(let M=0;M<p.length;M++){const T=p[M];switch(T){case"\\":E?(v?z+="\\"+T:N+="\\"+T,E=!1):E=!0;break;case"{":if(E)v?z+=T:N+=T,E=!1;else{if(v)return{strInBraces:N+"{"+z+"{"+p.substring(M+1)};v=!0}break;case"}":if(E)v?z+=T:N+=T,E=!1;else{if(v)return{fixedStart:N,strInBraces:z,fixedEnd:p.substring(M+1)};N+=T}break;default:v?z+=(E?"\\":"")+T:N+=(E?"\\":"")+T,E=!1;break}}return{strInBraces:N+(v?"{"+z:"")}}function m(p){const{fixedStart:v,strInBraces:E,fixedEnd:N}=C(p);if(v===void 0||N===void 0)return[E];let z=(0,b.$Aj)(E,",");z.length||(z=[""]);const M=m(N);return z.flatMap(T=>{const j=v+T;return M.map(O=>j+O)})}e.$agc=m}),define(ke[376],Se([1,0,21,158,85,17]),function(me,e,I,F,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class L{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,A,P,$){const S=new F.$7fc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const D={...A,folder:A.folder.with({scheme:R.Schemas.file})},w=new f.$_u(u=>P.report({...u,uri:u.uri.with({scheme:A.folder.scheme})}));return this.c($,u=>S.provideTextSearchResults(g,D,w,u))}else return this.c($,D=>S.provideTextSearchResults(g,A,P,D))}async c(g,A){const P=b(g);this.a.add(P);const $=await A(P.token);return this.a.delete(P),$}d(){this.a.forEach(g=>g.cancel())}}e.$egc=L;function b(y){const g=new I.$2d;return y.onCancellationRequested(()=>g.cancel()),g}}),define(ke[377],Se([1,0,30,158,157]),function(me,e,I,F,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class R{constructor(y){this.a=y}search(y,g,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(S){A({message:S})}},$=new f.$bgc(this.a,new F.$7fc(P),I);return new Promise((S,D)=>$.search(w=>{g(w.map(L))},y).then(w=>S({limitHit:w.limitHit,type:"success",stats:w.stats}),D))}}e.$cgc=R;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((y,g)=>{if(g.ranges){const A=g;return y+(Array.isArray(A.ranges)?A.ranges.length:1)}else return y+1},0)}}}),define(ke[378],Se([1,0,19,11,8,4,130,16,38,2,31,36,373,377]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class D{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,F.$Lg)(d=>this.doFileSearchWithEngine($.$6fc,t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}textSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,F.$Lg)(d=>this.f(t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new S.$cgc(r).search(t,a,a)}g(){return{maxFileSize:16*A.$Mk.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine($.$6fc,r,a,t)}doFileSearchWithEngine(r,a,t,s,d=D.a){let c=0;const l=k=>{Array.isArray(k)?(c+=k.length,t(k.map(C=>this.h(C)))):k.relativePath?(c++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,l,s);if(!k){const C=a.maxResults?Object.assign({},a,{maxResults:null}):a,m=new r(C);k=this.j(m,a,t,l,s)}return new Promise((C,m)=>{k.then(([p,v])=>{const E=v.map(N=>this.h(N));this.o(E,t,d),C(p)},m)})}const h=new r(a);return this.r(h,l,d,s).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$ic)(r.base,r.relativePath):r.relativePath}}j(r,a,t,s,d){const c=new R.$Rd;let l=(0,F.$Lg)(k=>{let C=[];const m=p=>{Array.isArray(p)?C=p:(s(p),c.fire(p))};return this.r(r,m,-1,k).then(p=>[p,C])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const k={promise:l,event:c.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=k,l.then(()=>{k.resolved=!0},C=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([k,C])=>{const m=h?h.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&y.$Nd.create(!1);return this.n(a,C,m,d).then(v=>{const E=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:E,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:v.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&C.length>a.maxResults},v]})})}k(r){const a=this.b[r];return a||(this.b[r]=new w)}l(r,a,t){const s=r.cacheKey&&this.b[r.cacheKey];if(!s)return;const d=this.q(s,r.filePattern||"",a,t);if(d)return d.then(([c,l,h])=>{const k=y.$Nd.create(!1);return this.n(r,l,s.scorerCache,t).then(C=>{const m=k.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:m};return[{type:"success",limitHit:c.limitHit||typeof r.maxResults=="number"&&l.length>r.maxResults,stats:p},C]})})}n(r,a,t,s){const d=(0,L.$Eq)(r.filePattern||""),c=(h,k)=>(0,L.$Dq)(h,k,d,!0,u,t),l=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return I.$Fb(a,c,l,1e4,s)}o(r,a,t){if(t&&t>0)for(let s=0;s<r.length;s+=t)a(r.slice(s,s+t));else a(r)}q(r,a,t,s){const d=y.$Nd.create(!1),c=a.indexOf(b.sep)>=0;let l;for(const m in r.resultsToSearchCache)if(a.startsWith(m)){if(c&&m.indexOf(b.sep)<0&&m!=="")continue;const p=r.resultsToSearchCache[m];l={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!l)return null;const h=d.elapsed(),k=y.$Nd.create(!1),C=l.event(t);return s&&s.onCancellationRequested(()=>{C.dispose()}),l.promise.then(([m,p])=>{if(s&&s.isCancellationRequested)throw(0,f.$5)();const v=[],E=(0,L.$Eq)(a).normalizedLowercase;for(const N of p)(0,P.$aJ)(N,E)&&v.push(N);return[m,v,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:k.elapsed(),cacheEntryCount:p.length}]})}r(r,a,t,s){return new Promise((d,c)=>{let l=[];s?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,k)=>{l.length&&a(l),h?c(h):d(k)})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$dgc=D;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(n){return(0,b.$mc)(n.relativePath)}getItemDescription(n){return(0,b.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>g.URI.revive(r))}}function i(n){return{...n,folder:g.URI.revive(n.folder)}}}),define(ke[379],Se([1,0,3,17,2,30,14,27,20,97,66,36,378,376,119,157]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;let u=class extends g.$4ec{constructor(i,n,r,a){super(i,r,a),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Qc;const t=new D.$1fc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new S.$egc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new D.$1fc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new S.$egc(i))),this.x.add(this.z(F.Schemas.file,new $.$dgc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,I.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,g.$5ec)(r);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,P.$_I)(t)&&(t=[t]),Array.isArray(t)){r(t.map(s=>f.URI.file(s.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$bgc(i,n,void 0,"textSearchProvider")}};e.$fgc=u,e.$fgc=u=He([Be(0,y.$AM),Be(1,b.$QM),Be(2,A.$Wdc),Be(3,L.$dj)],u)}),define(ke[120],Se([1,0,393,62,63,394,22,8,4,3,16,12,32,81,82]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class w{traceSocketEvent(p,v){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=E=>{if(this.traceSocketEvent("error",{code:E?.code,message:E?.message}),E){if(E.code==="EPIPE")return;(0,b.$Z)(E)}},this.socket.on("error",this.a),this.b=E=>{this.traceSocketEvent("close",{hadError:E}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=E=>{this.traceSocketEvent("read",E),p(L.$fe.wrap(E))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=E=>{p({type:0,hadError:E,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,b.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,b.$Z)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const E=()=>{this.socket.off("close",E),this.socket.off("end",E),this.socket.off("error",E),this.socket.off("timeout",E),this.socket.off("drain",E),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",E),this.socket.on("end",E),this.socket.on("error",E),this.socket.on("timeout",E),this.socket.on("drain",E)})}}e.$Kh=w;var u;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(u||(u={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class i extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,E,N){super(),this.f=this.B(new y.$Rd),this.g=this.B(new y.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:E?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,v,E,N,this.f,(z,M)=>this.m(z,M))),this.B(this.a.onError(z=>{console.error(z),(0,b.$Z)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new D.$Fh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+262144,p.byteLength)),{compressed:!0,opcode:2}),v+=262144}m(p,{compressed:v,opcode:E}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let N=2;p.byteLength<126?N+=0:p.byteLength<2**16?N+=2:N+=8;const z=L.$fe.alloc(N),M=v?64:0,T=E&15;if(z.writeUInt8(128|M|T,0),p.byteLength<126)z.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){z.writeUInt8(126,1);let j=1;z.writeUInt8(p.byteLength>>>8&255,++j),z.writeUInt8(p.byteLength>>>0&255,++j)}else{z.writeUInt8(127,1);let j=1;z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(0,++j),z.writeUInt8(p.byteLength>>>24&255,++j),z.writeUInt8(p.byteLength>>>16&255,++j),z.writeUInt8(p.byteLength>>>8&255,++j),z.writeUInt8(p.byteLength>>>0&255,++j)}this.socket.write(L.$fe.concat([z,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),E=v.readUInt8(0),N=(E&128)>>>7,z=(E&64)>>>6,M=E&15,T=v.readUInt8(1),j=(T&128)>>>7,O=T&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),E=v.readUInt8(1),N=(E&128)>>>7;let z=E&127,M=1;z===126?z=v.readUInt8(++M)*2**8+v.readUInt8(++M):z===127&&(z=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let T=0;N&&(T=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=3,this.j.readLen=z,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=i;class n extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$fe.alloc(0)}constructor(p,v,E,N,z,M){super(),this.n=p,this.r=z,this.s=M,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new r(this.n,N,E,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const E=await this.w(this.f,p);this.s(E,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((E,N)=>{p.write(v),p.flush(z=>E(z))})}acceptFrame(p,v,E){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:E}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,E){return new Promise((N,z)=>{p.write(v),E&&p.write(L.$fe.fromByteArray([0,0,255,255])),p.flush(M=>N(M))})}}class r extends g.$Rc{get recordedInflateBytes(){return this.j?L.$fe.concat(this.f):L.$fe.alloc(0)}constructor(p,v,E,N){super(),this.h=p,this.j=v,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(N),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(L.$fe.wrap(z))}),E&&(this.h.traceSocketEvent("zlibInflateInitialWrite",E.buffer),this.b.write(E.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=L.$fe.concat(this.g);this.g.length=0,p(v)})}}class a extends g.$Rc{constructor(p,v){super(),this.g=p,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",E=>{this.g.traceSocketEvent("zlibDeflateError",{message:E?.message,code:E?.code}),this.a.fire(E)}),this.b.on("data",E=>{this.g.traceSocketEvent("zlibDeflateData",E),this.f.push(L.$fe.wrap(E))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=L.$fe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function t(m,p){if(p===0)return;const v=m.byteLength>>>2;for(let j=0;j<v;j++){const O=m.readUInt32BE(j*4);m.writeUInt32BE(O^p,j*4)}const E=v*4,N=m.byteLength-E,z=p>>>24&255,M=p>>>16&255,T=p>>>8&255;N>=1&&m.writeUInt8(m.readUInt8(E)^z,E),N>=2&&m.writeUInt8(m.readUInt8(E+1)^M,E+1),N>=3&&m.writeUInt8(m.readUInt8(E+2)^T,E+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function d(){const m=(0,$.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const p=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,f.tmpdir)(),v=(0,A.$ic)(p,`vscode-ipc-${m}.sock`);return l(v),v}e.$Nh=d;function c(m,p,v){const E=(0,I.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${E}-${v}-${p}-sock`;const N=v.substr(0,4),z=p.substr(0,6),M=E.substr(0,8);let T;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?T=(0,A.$ic)(e.$Mh,`vscode-${M}-${N}-${z}.sock`):T=(0,A.$ic)(m,`${N}-${z}.sock`),l(T),T}e.$Oh=c;function l(m){const p=s[P.$u];typeof p=="number"&&m.length>=p&&console.warn(`WARNING: IPC handle "${m}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends S.$zh{static b(p){const v=y.Event.fromNodeEventEmitter(p,"connection");return y.Event.map(v,E=>({protocol:new D.$Gh(new w(E,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(E,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=h;function k(m){return new Promise((p,v)=>{const E=(0,F.createServer)();E.on("error",v),E.listen(m,()=>{E.removeListener("error",v),p(new h(E))})})}e.$Qh=k;function C(m,p){return new Promise((v,E)=>{const N=(0,F.createConnection)(m,()=>{N.removeListener("error",E),v(D.$Hh.fromSocket(new w(N,`ipc-client${p}`),p))});N.once("error",E)})}e.$Rh=C}),define(ke[380],Se([1,0,62,63,166,120,11,3,12,44,14,138,257,258,109,88,22]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=e.$J9b=e.$I9b=e.$H9b=void 0;async function o(t,s,d,c,l){let h;for(let k=3;k&&(h?.dispose(),h=await new i(t,s,d,c,l).waitForReady(),!(l&&f.$lg[l]||!f.$lg[h.tunnelLocalPort]));k--);return h}class i extends b.$Rc{constructor(s,d,c,l,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=I.createServer(),this.c=new L.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,w.$lv)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,f.$mg)(s,2,1e3,d),l=null;return this.b.listen(c,this.m),await this.c.wait(),l=this.b.address(),l||(c=0,this.b.listen(c,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(s){s.pause();const d=(0,w.$jv)(this.tunnelRemoteHost)||(0,w.$lv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,$.$_k)(this.a,d,this.tunnelRemotePort),l=c.getSocket(),h=c.readEntireBuffer();c.dispose(),h.byteLength>0&&s.write(h.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),l.end()}),s.on("close",()=>l.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),l instanceof R.$Kh?l.socket.destroy():l.end()}),l instanceof R.$Kh?this.t(s,l):this.s(s,l),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),l.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(c=>s.write(c.buffer)),s.on("data",c=>d.write(u.$fe.wrap(c))),s.resume()}t(s,d){const c=d.socket;c.on("end",()=>s.end()),c.on("close",()=>s.end()),c.on("error",()=>{s.destroy()}),c.pipe(s),s.pipe(c)}}e.$H9b=i;let n=class extends w.$ov{constructor(s,d,c,l,h){super(d,h),this.u=s,this.v=c,this.w=l}isPortPrivileged(s){return(0,w.$mv)(s,this.l,y.OS,F.release())}s(s,d,c,l,h,k,C,m){const p=this.r(d,c);if(p)return++p.refcount,p.value;if((0,w.$gv)(s))return this.t(s,d,c,h,k,C,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${h}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:s,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},E=o(v,l,d,c,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,c,E),E}}};e.$I9b=n,e.$I9b=n=He([Be(0,S.$6k),Be(1,A.$dj),Be(2,D.$9k),Be(3,P.$vj),Be(4,g.$pi)],n);let r=class extends n{constructor(s,d,c,l,h){super(s,d,c,l,h)}};e.$J9b=r,e.$J9b=r=He([Be(0,S.$6k),Be(1,A.$dj),Be(2,D.$9k),Be(3,P.$vj),Be(4,g.$pi)],r);let a=class extends b.$Rc{constructor(s,d,c,l,h){super(),this.b=s,this.c=d,this.f=c,this.g=l,this.h=h,this.a=new Map}async openTunnel(s,d,c,l,h,k,C,m,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${l} on local port ${k}.`),!this.a.has(s)){const v=new r(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(s,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,c,l,h,k,C,m,p)}};e.$K9b=a,e.$K9b=a=He([Be(0,S.$6k),Be(1,A.$dj),Be(2,P.$vj),Be(3,D.$9k),Be(4,g.$pi)],a)}),define(ke[381],Se([1,0,120,277,55,35,2,14,40]),function(me,e,I,F,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3M=e.$2M=void 0;class g{constructor($,S,D){this.b=$,this.c=S,this.f=D,this.a=F.createServer((w,u)=>this.h(w,u)),this.g().catch(w=>(S.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,S){const D=(u,o)=>{S.writeHead(u,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},w=[];$.setEncoding("utf8"),$.on("data",u=>w.push(u)),$.on("end",async()=>{try{const u=JSON.parse(w.join(""));let o;switch(u.type){case"open":o=await this.i(u);break;case"openExternal":o=await this.j(u);break;case"status":o=await this.l(u);break;case"extensionManagement":o=await this.k(u);break;default:D(404,`Unknown message type: ${u.type}`);break}D(200,o)}catch(u){const o=u instanceof Error?u.message:JSON.stringify(u);D(500,o),this.c.error("Error while processing pipe request",u)}})}async i($){const{fileURIs:S,folderURIs:D,forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=$,s=[];if(Array.isArray(D))for(const h of D)try{s.push({folderUri:L.URI.parse(h)})}catch{}if(Array.isArray(S))for(const h of S)try{(0,y.$oi)(h)?s.push({workspaceUri:L.URI.parse(h)}):s.push({fileUri:L.URI.parse(h)})}catch{}const d=a?L.URI.file(a):void 0,l={forceNewWindow:w,diffMode:u,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,l)}async j($){for(const S of $.uris){const D=L.URI.parse(S),w=D.scheme==="file"?D:S;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k($){const S=w=>w?.map(u=>/\.vsix$/i.test(u)?L.URI.parse(u):u),D={list:$.list,install:S($.install),uninstall:S($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$2M=g;let A=class extends g{constructor($,S){super($,S,(0,I.$Nh)())}};e.$3M=A,e.$3M=A=He([Be(0,R.$WM),Be(1,b.$dj)],A)}),define(ke[382],Se([1,0,56,369,364,276,47,349,2,17,7,381,103,347,348]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class w extends f.$Lfc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(d,c,l){return d=t(d),i.a.has(d)?i.a.get(d).load(d,y.URI.file((0,$.$bq)(c.filename)),h=>r.apply(this,[h,c,l])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>a.call(this,t(s),d);const t=s=>{for(const d of i.b){const c=d(s);if(c){s=c;break}}return s}}}class u extends L.$Aec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(S.$igc);const i=this.h.invokeFunction(F.$Hfc);if(this.h.createInstance(b.$hgc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$3M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(D.$jgc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$ggc)(this.j,r,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$kgc=u}),define(ke[383],Se([1,0,50,22,4,3,123,12,23,2,30,14,256,64,109,88,380,27,20,72,358]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=e.$qgc=e.$pgc=e.$ogc=e.$ngc=e.$mgc=e.$lgc=void 0;function a(p){const v=p.trim().split(`
`),E=[];return v.forEach(z=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);M&&M.length>=3&&E.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),E.reduce((z,M)=>(z[M.socket]=M,z),{})}e.$lgc=a;function t(...p){const v=[].concat(...p.map(d));return[...new Map(v.filter(E=>E.st==="0A").map(E=>{const N=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:s(N[0]),port:parseInt(N[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.$mgc=t;function s(p){let v="";if(p.length===8)for(let E=p.length-2;E>=0;E-=2)v+=parseInt(p.substr(E,2),16),E!==0&&(v+=".");else for(let E=0;E<p.length;E+=8){const N=p.substring(E,E+8);let z="";for(let M=8;M>=2;M-=2)z+=N.substring(M-2,M),(M===6||M===2)&&(z=parseInt(z,16).toString(16),v+=`${z}`,z="",E+M!==p.length-6&&(v+=":"))}return v}e.$ngc=s;function d(p){const v=p.trim().split(`
`),E=v.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return v.map(z=>z.trim().split(/\s+/).reduce((M,T,j)=>(M[E[j]||j]=T,M),{}))}e.$ogc=d;function c(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function l(p){const v=p.trim().split(`
`),E=[];return v.forEach(N=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);z&&z.length>=4&&E.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),E}e.$pgc=l;async function h(p,v,E){const N=E.reduce((M,T)=>(M[T.pid]=T,M),{}),z=[];return p.forEach(({socket:M,ip:T,port:j})=>{const O=v[M]?v[M].pid:void 0,V=O?N[O]?.cmd:void 0;O&&V&&!c(V)&&z.push({host:T,port:j,detail:V,pid:O})}),z}e.$qgc=h;function k(p,v,E){const N=new Map,z=l(v);for(const M of p){const T=E.get(M.port);if(T){N.set(M.port,T);continue}const j=z.find(O=>O.cmd.includes(`${M.port}`));if(j){let O=j,V;do V=z.find(te=>te.ppid===O.pid),V&&(O=V);while(V);N.set(M.port,{host:M.ip,port:M.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$rgc=k;let C=class extends n.$Swb{constructor(v,E,N,z){super(v,E,N),this.D=E,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&E.remote.isRemote&&E.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let E;this.y&&(E=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new L.$Xl;let z=0;for(;this.C;){const M=new Date().getTime(),T=(await this.I()).filter(V=>(0,w.$jv)(V.host)||(0,w.$lv)(V.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),z++>3&&N.update(j),(!E||JSON.stringify(E)!==JSON.stringify(T))&&(E=T,await this.a.$onFoundNewCandidates(E));const O=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(V=>setTimeout(()=>V(),O))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",E="";try{v=await A.Promises.readFile("/proc/net/tcp","utf8"),E=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(v,E),z=await new Promise(Z=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,G,oe)=>{Z(G)})}),M=a(z),T=await A.Promises.readdir("/proc"),j=[];for(const Z of T)try{const Q=Number(Z),G=y.$zg(g.URI.file("/proc"),Z);if((await A.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(Q)){const x=await A.Promises.readlink(y.$zg(G,"cwd").fsPath),Ee=await A.Promises.readFile(y.$zg(G,"cmdline").fsPath,"utf8");j.push({pid:Q,cwd:x,cmd:Ee})}}catch{}const O=[],V=N.filter(Z=>{const Q=M[Z.socket];return Q||O.push(Z),Q}),te=h(V,M,j);let fe;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const Z=await new Promise(Q=>{(0,I.exec)("ps -F -A -l | grep root",(G,oe,x)=>{Q(oe)})});this.z=k(O,Z,this.z),fe=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${fe.map(Q=>Q.port).join(", ")}`)}return te.then(Z=>fe?Z.concat(fe):Z)}w(v){return async E=>{const N=new u.$H9b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,T,j,O){const V=await v.makeConnection();return m.connect(V,T,j,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Wk(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",E.remoteAddress.host||"localhost",E.remoteAddress.port,E.localAddressPort);await N.waitForReady();const z=new f.$Rd;return{localAddress:(0,r.$YJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{N.dispose(),z.fire(),z.dispose()}}}}};e.$sgc=C,e.$sgc=C=He([Be(0,i.$AM),Be(1,o.$QM),Be(2,P.$dj),Be(3,D.$9k)],C);class m extends $.$9pb{static connect(v,E,N,z){const M=new R.$Qc,T={onClose:M.add(new f.$Rd),onData:M.add(new f.$Rd),onEnd:M.add(new f.$Rd)};M.add(v.onDidReceiveMessage(O=>T.onData.fire(F.$fe.wrap(O)))),M.add(v.onDidEnd(()=>T.onEnd.fire())),M.add(v.onDidClose(O=>T.onClose.fire({type:0,error:O,hadError:!!O})));const j=new m(v,z,T);return j.B(M),(0,$.$8pb)(j,E,N,z,T)}constructor(v,E,N){super(E,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,106,352,367,366,379,382,383,96,47,97,95,46,72,92,351,350,14,368,58,271,105,109,140]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Dr)(A.$Bec,b.$kgc,0),(0,I.$Dr)(i.$ej,o.$ugc,1),(0,I.$Dr)(i.$dj,new t.$Sh(a.$Kfc,[!1],!0)),(0,I.$Dr)(s.$9k,d.$M9b,1),(0,I.$Dr)(w.$6dc,u.$tgc,0),(0,I.$Dr)(g.$Gec,R.$Xfc,0),(0,I.$Dr)(P.$3ec,L.$fgc,0),(0,I.$Dr)($.$tfc,f.$Pfc,0),(0,I.$Dr)(S.$oec,F.$Ofc,0),(0,I.$Dr)(D.$Rwb,y.$sgc,0),(0,I.$Dr)(r.$Eec,n.$vgc,0)}),define(ke[395],Se([1,0,62,396,56,8,82,120,254,114,365,22,30,103,11,133,278,292,370,384]),function(me,e,I,F,f,R,L,b,y,g,A,P,$,S,D,w,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,h=l._load;l._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function r(l){process.exit=function(h){if(l)n(h);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(l){n()};function t(){const l=(0,o.$Hm)(process.env);if(l.type===3)return new Promise((h,k)=>{const C=m=>{const p=m[0],v=new L.$Ih;p.on("message",E=>v.fire(P.$fe.wrap(E.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),h({onMessage:v.event,send:E=>p.postMessage(E.buffer)})};process.parentPort.on("message",m=>C(m.ports))});if(l.type===2)return new Promise((h,k)=>{let C=null;const m=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,v=3e5,E=new D.$$g(()=>a("renderer disconnected for too long (1)"),p),N=new D.$$g(()=>a("renderer disconnected for too long (2)"),v);process.on("message",(M,T)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){T.setNoDelay(!0);const j=P.$fe.wrap(Buffer.from(M.initialDataChunk,"base64"));let O;if(M.skipWebSocketFrames)O=new b.$Kh(T,"extHost-socket");else{const V=P.$fe.wrap(Buffer.from(M.inflateBytes,"base64"));O=new b.$Lh(new b.$Kh(T,"extHost-socket"),M.permessageDeflate,V,!1)}C?(E.cancel(),N.cancel(),C.beginAcceptReconnection(O,j),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(m),C=new L.$Jh({socket:O,initialChunk:j}),C.sendResume(),C.onDidDispose(()=>a("renderer disconnected")),h(C),C.onSocketClose(()=>{E.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;E.isScheduled()&&N.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const h=l.pipeName;return new Promise((k,C)=>{const m=I.createConnection(h,()=>{m.removeListener("error",C);const p=new L.$Jh({socket:new b.$Kh(m,"extHost-renderer")});p.sendResume(),k(p)});m.once("error",C),m.on("close",()=>{a("renderer closed the socket")})})}}async function s(){const l=await t();return new class{constructor(){this.a=new L.$Ih,this.onMessage=this.a.event,this.b=!1,l.onMessage(h=>{(0,g.$im)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||l.send(h)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(h=>{const k=l.onMessage(C=>{k.dispose();const m=JSON.parse(C.toString()),p=m.commit,v=y.default.commit;if(p&&v&&p!==v&&n(55),m.parentPid){let E=0;setInterval(function(){try{process.kill(m.parentPid,0),E=0}catch(z){z&&z.code==="EPERM"?(E++,E>=3&&a(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):a(`parent process ${m.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start(m.parentPid)}catch(z){(0,R.$Z)(z)}}l.send((0,g.$hm)(0)),h({protocol:l,initData:m})});l.send((0,g.$hm)(1))})}async function c(){const l=[];process.on("unhandledRejection",(E,N)=>{l.push(N),setTimeout(()=>{const z=l.indexOf(N);z>=0&&N.catch(M=>{l.splice(z,1),(0,R.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),E&&(0,R.$Z)(E))})},1e3)}),process.on("rejectionHandled",E=>{const N=l.indexOf(E);N>=0&&l.splice(N,1)}),process.on("uncaughtException",function(E){(0,R.$Y)(E)||(0,R.$Z)(E)}),f.mark("code/extHost/willConnectToRenderer");const h=await s();f.mark("code/extHost/didConnectToRenderer");const k=await d(h);f.mark("code/extHost/didWaitForInitData");const{initData:C}=k;r(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return $.Promises.exists(N)}fsRealpath(N){return(0,S.$aq)(N)}};let p=null;C.remote.authority&&i.transformURIs&&(p=(0,u.$Hr)(C.remote.authority));const v=new A.$Nfc(k.protocol,C,m,p);a=E=>v.terminate(E)}c().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/345c8d0927402d41f42402411d856eeec4013e5e/core/vs/workbench/api/node/extensionHostProcess.js.map
