/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Ae=function(be){for(var e=[],E=0,L=be.length;E<L;E++)e[E]=Pe[be[E]];return e};define(Pe[66],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function E(R){return($,D,f)=>{let P=null,k=null;if(typeof f.value=="function"?(P="value",k=f.value):typeof f.get=="function"&&(P="get",k=f.get),!k)throw new Error("not supported");f[P]=R(k,D)}}function L(R,$,D){let f=null,P=null;if(typeof D.value=="function"?(f="value",P=D.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(f="get",P=D.get),!P)throw new Error("not supported");const k=`$memoize$${$}`;D[f]=function(...u){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[k]}}e.$nh=L;function A(R,$,D){return E((f,P)=>{const k=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...b){this[u]||(this[u]=D?D():void 0),clearTimeout(this[k]),$&&(this[u]=$(this[u],...b),b=[this[u]]),this[k]=setTimeout(()=>{f.apply(this,b),this[u]=D?D():void 0},R)}})}e.$oh=A;function M(R,$,D){return E((f,P)=>{const k=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...g){if(this[u]||(this[u]=D?D():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[u]=$(this[u],...g)),this[p])return;const t=this[b]+R;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=D?D():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=D?D():void 0},t-Date.now()))}})}e.$ph=M}),define(Pe[89],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=void 0;class E{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$FM=E,e.$GM=new E("id#")}),define(Pe[119],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var A;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(n,s=!1){let a=0;const d=n.length;let v="",m=0,I=16,S=0;function h(z){let F=0,O=0;for(;F<z;){const X=n.charCodeAt(a);if(X>=48&&X<=57)O=O*16+X-48;else if(X>=65&&X<=70)O=O*16+X-65+10;else if(X>=97&&X<=102)O=O*16+X-97+10;else break;a++,F++}return F<z&&(O=-1),O}function w(z){a=z,v="",m=0,I=16,S=0}function y(){const z=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&f(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&f(n.charCodeAt(a)))for(a++;a<n.length&&f(n.charCodeAt(a));)a++;else return S=3,n.substring(z,a);let F=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&f(n.charCodeAt(a))){for(a++;a<n.length&&f(n.charCodeAt(a));)a++;F=a}else S=3;return n.substring(z,F)}function C(){let z="",F=a;for(;;){if(a>=d){z+=n.substring(F,a),S=2;break}const O=n.charCodeAt(a);if(O===34){z+=n.substring(F,a),a++;break}if(O===92){if(z+=n.substring(F,a),a++,a>=d){S=2;break}switch(n.charCodeAt(a++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const $e=h(4);$e>=0?z+=String.fromCharCode($e):S=4;break}default:S=5}F=a;continue}if(O>=0&&O<=31)if(D(O)){z+=n.substring(F,a),S=2;break}else S=6;a++}return z}function W(){if(v="",S=0,m=a,a>=d)return m=d,I=17;let z=n.charCodeAt(a);if($(z)){do a++,v+=String.fromCharCode(z),z=n.charCodeAt(a);while($(z));return I=15}if(D(z))return a++,v+=String.fromCharCode(z),z===13&&n.charCodeAt(a)===10&&(a++,v+=`
`),I=14;switch(z){case 123:return a++,I=1;case 125:return a++,I=2;case 91:return a++,I=3;case 93:return a++,I=4;case 58:return a++,I=6;case 44:return a++,I=5;case 34:return a++,v=C(),I=10;case 47:{const F=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<d&&!D(n.charCodeAt(a));)a++;return v=n.substring(F,a),I=12}if(n.charCodeAt(a+1)===42){a+=2;const O=d-1;let X=!1;for(;a<O;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,X=!0;break}a++}return X||(a++,S=1),v=n.substring(F,a),I=13}return v+=String.fromCharCode(z),a++,I=16}case 45:if(v+=String.fromCharCode(z),a++,a===d||!f(n.charCodeAt(a)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=y(),I=11;default:for(;a<d&&K(z);)a++,z=n.charCodeAt(a);if(m!==a){switch(v=n.substring(m,a),v){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return v+=String.fromCharCode(z),a++,I=16}}function K(z){if($(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=W();while(z>=12&&z<=15);return z}return{setPosition:w,getPosition:()=>a,scan:s?U:W,getToken:()=>I,getTokenValue:()=>v,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>S}}e.$1m=R;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function D(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function k(n,s){const a=[],d=new Object;let v;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(h,w,y,C){m.value=h,m.offset=w,m.length=y,m.type=C,m.colonOffset=void 0,v=m}try{c(n,{onObjectBegin:(h,w)=>{if(s<=h)throw d;v=void 0,I=s>h,a.push("")},onObjectProperty:(h,w,y)=>{if(s<w||(S(h,w,y,"property"),a[a.length-1]=h,s<=w+y))throw d},onObjectEnd:(h,w)=>{if(s<=h)throw d;v=void 0,a.pop()},onArrayBegin:(h,w)=>{if(s<=h)throw d;v=void 0,a.push(0)},onArrayEnd:(h,w)=>{if(s<=h)throw d;v=void 0,a.pop()},onLiteralValue:(h,w,y)=>{if(s<w||(S(h,w,y,l(h)),s<=w+y))throw d},onSeparator:(h,w,y)=>{if(s<=w)throw d;if(h===":"&&v&&v.type==="property")v.colonOffset=w,I=!1,v=void 0;else if(h===","){const C=a[a.length-1];typeof C=="number"?a[a.length-1]=C+1:(I=!0,a[a.length-1]=""),v=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:v,isAtPropertyKey:I,matches:h=>{let w=0;for(let y=0;w<h.length&&y<a.length;y++)if(h[w]===a[y]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$2m=k;function u(n,s=[],a=M.DEFAULT){let d=null,v=[];const m=[];function I(h){Array.isArray(v)?v.push(h):d!==null&&(v[d]=h)}return c(n,{onObjectBegin:()=>{const h={};I(h),m.push(v),v=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{v=m.pop()},onArrayBegin:()=>{const h=[];I(h),m.push(v),v=h,d=null},onArrayEnd:()=>{v=m.pop()},onLiteralValue:I,onError:(h,w,y)=>{s.push({error:h,offset:w,length:y})}},a),v[0]}e.$3m=u;function b(n,s=[],a=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function m(h){return d.children.push(h),h}c(n,{onObjectBegin:h=>{d=m({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,w,y)=>{d=m({type:"property",offset:w,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:w,length:y,parent:d})},onObjectEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,v(h+w)},onArrayBegin:(h,w)=>{d=m({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,v(h+w)},onLiteralValue:(h,w,y)=>{m({type:l(h),offset:w,length:y,parent:d,value:h}),v(w+y)},onSeparator:(h,w,y)=>{d.type==="property"&&(h===":"?d.colonOffset=w:h===","&&v(w))},onError:(h,w,y)=>{s.push({error:h,offset:w,length:y})}},a);const S=d.children[0];return S&&delete S.parent,S}e.$4m=b;function p(n,s){if(!n)return;let a=n;for(const d of s)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let v=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===d){a=m.children[1],v=!0;break}if(!v)return}else{const v=d;if(a.type!=="array"||v<0||!Array.isArray(a.children)||v>=a.children.length)return;a=a.children[v]}return a}e.$5m=p;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.$6m=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const a of n.children){const d=a.children[1];d&&(s[a.children[0].value]=t(d))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$7m=t;function i(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.$8m=i;function r(n,s,a=!1){if(i(n,s,a)){const d=n.children;if(Array.isArray(d))for(let v=0;v<d.length&&d[v].offset<=s;v++){const m=r(d[v],s,a);if(m)return m}return n}}e.$9m=r;function c(n,s,a=M.DEFAULT){const d=R(n,!1);function v(re){return re?()=>re(d.getTokenOffset(),d.getTokenLength()):()=>!0}function m(re){return re?Re=>re(Re,d.getTokenOffset(),d.getTokenLength()):()=>!0}const I=v(s.onObjectBegin),S=m(s.onObjectProperty),h=v(s.onObjectEnd),w=v(s.onArrayBegin),y=v(s.onArrayEnd),C=m(s.onLiteralValue),W=m(s.onSeparator),K=v(s.onComment),U=m(s.onError),z=a&&a.disallowComments,F=a&&a.allowTrailingComma;function O(){for(;;){const re=d.scan();switch(d.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:z||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(re){case 12:case 13:z?X(10):K();break;case 16:X(1);break;case 15:case 14:break;default:return re}}}function X(re,Re=[],se=[]){if(U(re),Re.length+se.length>0){let Y=d.getToken();for(;Y!==17;){if(Re.indexOf(Y)!==-1){O();break}else if(se.indexOf(Y)!==-1)break;Y=O()}}}function $e(re){const Re=d.getTokenValue();return re?C(Re):S(Re),O(),!0}function Ee(){switch(d.getToken()){case 11:{let re=0;try{re=JSON.parse(d.getTokenValue()),typeof re!="number"&&(X(2),re=0)}catch{X(2)}C(re);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return O(),!0}function De(){return d.getToken()!==10?(X(3,[],[2,5]),!1):($e(!1),d.getToken()===6?(W(":"),O(),pe()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function Ce(){I(),O();let re=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(re||X(4,[],[]),W(","),O(),d.getToken()===2&&F)break}else re&&X(6,[],[]);De()||X(4,[],[2,5]),re=!0}return h(),d.getToken()!==2?X(7,[2],[]):O(),!0}function de(){w(),O();let re=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(re||X(4,[],[]),W(","),O(),d.getToken()===4&&F)break}else re&&X(6,[],[]);pe()||X(4,[],[4,5]),re=!0}return y(),d.getToken()!==4?X(8,[4],[]):O(),!0}function pe(){switch(d.getToken()){case 3:return de();case 1:return Ce();case 10:return $e(!0);default:return Ee()}}return O(),d.getToken()===17?a.allowEmptyContent?!0:(X(4,[],[]),!1):pe()?(d.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$0m=c;function o(n,s){const a=R(n),d=[];let v,m=0,I;do switch(I=a.getPosition(),v=a.scan(),v){case 12:case 13:case 17:m!==I&&d.push(n.substring(m,I)),s!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(v!==17);return d.join("")}e.$$m=o;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=l}),function(be,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(le,ce){for(var we=0;we<ce.length;we++){var _=ce[we];_.enumerable=_.enumerable||!1,_.configurable=!0,"value"in _&&(_.writable=!0),Object.defineProperty(le,_.key,_)}}function E(le,ce,we){return ce&&e(le.prototype,ce),we&&e(le,we),Object.defineProperty(le,"prototype",{writable:!1}),le}function L(le,ce){if(le){if(typeof le=="string")return A(le,ce);var we=Object.prototype.toString.call(le).slice(8,-1);if(we==="Object"&&le.constructor&&(we=le.constructor.name),we==="Map"||we==="Set")return Array.from(le);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return A(le,ce)}}function A(le,ce){(ce==null||ce>le.length)&&(ce=le.length);for(var we=0,_=new Array(ce);we<ce;we++)_[we]=le[we];return _}function M(le,ce){var we=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(we)return(we=we.call(le)).next.bind(we);if(Array.isArray(le)||(we=L(le))||ce&&le&&typeof le.length=="number"){we&&(le=we);var _=0;return function(){return _>=le.length?{done:!0}:{done:!1,value:le[_++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=R();function $(le){be.defaults=le}var D=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ce){return u[ce]};function p(le,ce){if(ce){if(D.test(le))return le.replace(f,b)}else if(P.test(le))return le.replace(k,b);return le}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(le){return le.replace(g,function(ce,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(le,ce){le=typeof le=="string"?le:le.source,ce=ce||"";var we={replace:function(he,te){return te=te.source||te,te=te.replace(i,"$1"),le=le.replace(he,te),we},getRegex:function(){return new RegExp(le,ce)}};return we}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(le,ce,we){if(le){var _;try{_=decodeURIComponent(t(we)).replace(c,"").toLowerCase()}catch{return null}if(_.indexOf("javascript:")===0||_.indexOf("vbscript:")===0||_.indexOf("data:")===0)return null}ce&&!o.test(we)&&(we=v(ce,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(le,ce){n[" "+le]||(s.test(le)?n[" "+le]=le+"/":n[" "+le]=h(le,"/",!0)),le=n[" "+le];var we=le.indexOf(":")===-1;return ce.substring(0,2)==="//"?we?ce:le.replace(a,"$1")+ce:ce.charAt(0)==="/"?we?ce:le.replace(d,"$1")+ce:le+ce}var m={exec:function(){}};function I(le){for(var ce=1,we,_;ce<arguments.length;ce++){we=arguments[ce];for(_ in we)Object.prototype.hasOwnProperty.call(we,_)&&(le[_]=we[_])}return le}function S(le,ce){var we=le.replace(/\|/g,function(te,ae,ge){for(var Se=!1,T=ae;--T>=0&&ge[T]==="\\";)Se=!Se;return Se?"|":" |"}),_=we.split(/ \|/),he=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),_.length>ce)_.splice(ce);else for(;_.length<ce;)_.push("");for(;he<_.length;he++)_[he]=_[he].trim().replace(/\\\|/g,"|");return _}function h(le,ce,we){var _=le.length;if(_===0)return"";for(var he=0;he<_;){var te=le.charAt(_-he-1);if(te===ce&&!we)he++;else if(te!==ce&&we)he++;else break}return le.slice(0,_-he)}function w(le,ce){if(le.indexOf(ce[1])===-1)return-1;for(var we=le.length,_=0,he=0;he<we;he++)if(le[he]==="\\")he++;else if(le[he]===ce[0])_++;else if(le[he]===ce[1]&&(_--,_<0))return he;return-1}function y(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(le,ce){if(ce<1)return"";for(var we="";ce>1;)ce&1&&(we+=le),ce>>=1,le+=le;return we+le}function W(le,ce,we,_){var he=ce.href,te=ce.title?p(ce.title):null,ae=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){_.state.inLink=!0;var ge={type:"link",raw:we,href:he,title:te,text:ae,tokens:_.inlineTokens(ae)};return _.state.inLink=!1,ge}return{type:"image",raw:we,href:he,title:te,text:p(ae)}}function K(le,ce){var we=le.match(/^(\s+)(?:```)/);if(we===null)return ce;var _=we[1];return ce.split(`
`).map(function(he){var te=he.match(/^\s+/);if(te===null)return he;var ae=te[0];return ae.length>=_.length?he.slice(_.length):he}).join(`
`)}var U=function(){function le(we){this.options=we||be.defaults}var ce=le.prototype;return ce.space=function(_){var he=this.rules.block.newline.exec(_);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},ce.code=function(_){var he=this.rules.block.code.exec(_);if(he){var te=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?te:h(te,`
`)}}},ce.fences=function(_){var he=this.rules.block.fences.exec(_);if(he){var te=he[0],ae=K(te,he[3]||"");return{type:"code",raw:te,lang:he[2]?he[2].trim():he[2],text:ae}}},ce.heading=function(_){var he=this.rules.block.heading.exec(_);if(he){var te=he[2].trim();if(/#$/.test(te)){var ae=h(te,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(te=ae.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:te,tokens:this.lexer.inline(te)}}},ce.hr=function(_){var he=this.rules.block.hr.exec(_);if(he)return{type:"hr",raw:he[0]}},ce.blockquote=function(_){var he=this.rules.block.blockquote.exec(_);if(he){var te=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ce.list=function(_){var he=this.rules.block.list.exec(_);if(he){var te,ae,ge,Se,T,V,G,J,q,x,ue,Ne,Ue=he[1].trim(),Ze=Ue.length>1,Je={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");_&&(Ne=!1,!(!(he=tt.exec(_))||this.rules.block.hr.test(_)));){if(te=he[0],_=_.substring(te.length),J=he[2].split(`
`,1)[0],q=_.split(`
`,1)[0],this.options.pedantic?(Se=2,ue=J.trimLeft()):(Se=he[2].search(/[^ ]/),Se=Se>4?1:Se,ue=J.slice(Se),Se+=he[1].length),V=!1,!J&&/^ *$/.test(q)&&(te+=q+`
`,_=_.substring(q.length+1),Ne=!0),!Ne)for(var _e=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}#");_&&(x=_.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(J)||nt.test(J)||_e.test(J)||et.test(_)));){if(J.search(/[^ ]/)>=Se||!J.trim())ue+=`
`+J.slice(Se);else if(!V)ue+=`
`+J;else break;!V&&!J.trim()&&(V=!0),te+=x+`
`,_=_.substring(x.length+1)}Je.loose||(G?Je.loose=!0:/\n *\n *$/.test(te)&&(G=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&(ge=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:te,task:!!ae,checked:ge,loose:!1,text:ue}),Je.raw+=te}Je.items[Je.items.length-1].raw=te.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Je.items[T].tokens=this.lexer.blockTokens(Je.items[T].text,[]);var dt=Je.items[T].tokens.filter(function(Q){return Q.type==="space"}),Z=dt.every(function(Q){for(var ye=Q.raw.split(""),Be=0,He=M(ye),Xe;!(Xe=He()).done;){var st=Xe.value;if(st===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&dt.length&&Z&&(Je.loose=!0,Je.items[T].loose=!0)}return Je}},ce.html=function(_){var he=this.rules.block.html.exec(_);if(he){var te={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]);te.type="paragraph",te.text=ae,te.tokens=this.lexer.inline(ae)}return te}},ce.def=function(_){var he=this.rules.block.def.exec(_);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var te=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:he[0],href:he[2],title:he[3]}}},ce.table=function(_){var he=this.rules.block.table.exec(_);if(he){var te={type:"table",header:S(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=he[0];var ae=te.align.length,ge,Se,T,V;for(ge=0;ge<ae;ge++)/^ *-+: *$/.test(te.align[ge])?te.align[ge]="right":/^ *:-+: *$/.test(te.align[ge])?te.align[ge]="center":/^ *:-+ *$/.test(te.align[ge])?te.align[ge]="left":te.align[ge]=null;for(ae=te.rows.length,ge=0;ge<ae;ge++)te.rows[ge]=S(te.rows[ge],te.header.length).map(function(G){return{text:G}});for(ae=te.header.length,Se=0;Se<ae;Se++)te.header[Se].tokens=this.lexer.inline(te.header[Se].text);for(ae=te.rows.length,Se=0;Se<ae;Se++)for(V=te.rows[Se],T=0;T<V.length;T++)V[T].tokens=this.lexer.inline(V[T].text);return te}}},ce.lheading=function(_){var he=this.rules.block.lheading.exec(_);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},ce.paragraph=function(_){var he=this.rules.block.paragraph.exec(_);if(he){var te=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:te,tokens:this.lexer.inline(te)}}},ce.text=function(_){var he=this.rules.block.text.exec(_);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},ce.escape=function(_){var he=this.rules.inline.escape.exec(_);if(he)return{type:"escape",raw:he[0],text:p(he[1])}},ce.tag=function(_){var he=this.rules.inline.tag.exec(_);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]):he[0]}},ce.link=function(_){var he=this.rules.inline.link.exec(_);if(he){var te=he[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ae=h(te.slice(0,-1),"\\");if((te.length-ae.length)%2===0)return}else{var ge=w(he[2],"()");if(ge>-1){var Se=he[0].indexOf("!")===0?5:4,T=Se+he[1].length+ge;he[2]=he[2].substring(0,ge),he[0]=he[0].substring(0,T).trim(),he[3]=""}}var V=he[2],G="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);J&&(V=J[1],G=J[3])}else G=he[3]?he[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(te)?V=V.slice(1):V=V.slice(1,-1)),W(he,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},ce.reflink=function(_,he){var te;if((te=this.rules.inline.reflink.exec(_))||(te=this.rules.inline.nolink.exec(_))){var ae=(te[2]||te[1]).replace(/\s+/g," ");if(ae=he[ae.toLowerCase()],!ae||!ae.href){var ge=te[0].charAt(0);return{type:"text",raw:ge,text:ge}}return W(te,ae,te[0],this.lexer)}},ce.emStrong=function(_,he,te){te===void 0&&(te="");var ae=this.rules.inline.emStrong.lDelim.exec(_);if(ae&&!(ae[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=ae[1]||ae[2]||"";if(!ge||ge&&(te===""||this.rules.inline.punctuation.exec(te))){var Se=ae[0].length-1,T,V,G=Se,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,he=he.slice(-1*_.length+Se);(ae=q.exec(he))!=null;)if(T=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!T){if(V=T.length,ae[3]||ae[4]){G+=V;continue}else if((ae[5]||ae[6])&&Se%3&&!((Se+V)%3)){J+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+J),Math.min(Se,V)%2){var x=_.slice(1,Se+ae.index+V);return{type:"em",raw:_.slice(0,Se+ae.index+V+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=_.slice(2,Se+ae.index+V-1);return{type:"strong",raw:_.slice(0,Se+ae.index+V+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(_){var he=this.rules.inline.code.exec(_);if(he){var te=he[2].replace(/\n/g," "),ae=/[^ ]/.test(te),ge=/^ /.test(te)&&/ $/.test(te);return ae&&ge&&(te=te.substring(1,te.length-1)),te=p(te,!0),{type:"codespan",raw:he[0],text:te}}},ce.br=function(_){var he=this.rules.inline.br.exec(_);if(he)return{type:"br",raw:he[0]}},ce.del=function(_){var he=this.rules.inline.del.exec(_);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},ce.autolink=function(_,he){var te=this.rules.inline.autolink.exec(_);if(te){var ae,ge;return te[2]==="@"?(ae=p(this.options.mangle?he(te[1]):te[1]),ge="mailto:"+ae):(ae=p(te[1]),ge=ae),{type:"link",raw:te[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(_,he){var te;if(te=this.rules.inline.url.exec(_)){var ae,ge;if(te[2]==="@")ae=p(this.options.mangle?he(te[0]):te[0]),ge="mailto:"+ae;else{var Se;do Se=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Se!==te[0]);ae=p(te[0]),te[1]==="www."?ge="http://"+ae:ge=ae}return{type:"link",raw:te[0],text:ae,href:ge,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(_,he){var te=this.rules.inline.text.exec(_);if(te){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):p(te[0]):te[0]:ae=p(this.options.smartypants?he(te[0]):te[0]),{type:"text",raw:te[0],text:ae}}},le}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=r(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=r(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=r(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=r(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=r(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=r(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=r(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=r(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=r(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=r(z._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=r(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=r(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=r(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=r(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=r(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=r(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=r(F.reflink).replace("label",F._label).replace("ref",z._label).getRegex(),F.nolink=r(F.nolink).replace("ref",z._label).getRegex(),F.reflinkSearch=r(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:r(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=r(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:r(F.br).replace("{2,}","*").getRegex(),text:r(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(le){var ce="",we,_,he=le.length;for(we=0;we<he;we++)_=le.charCodeAt(we),Math.random()>.5&&(_="x"+_.toString(16)),ce+="&#"+_+";";return ce}var $e=function(){function le(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var _={block:z.normal,inline:F.normal};this.options.pedantic?(_.block=z.pedantic,_.inline=F.pedantic):this.options.gfm&&(_.block=z.gfm,this.options.breaks?_.inline=F.breaks:_.inline=F.gfm),this.tokenizer.rules=_}le.lex=function(_,he){var te=new le(he);return te.lex(_)},le.lexInline=function(_,he){var te=new le(he);return te.inlineTokens(_)};var ce=le.prototype;return ce.lex=function(_){_=_.replace(/\r\n|\r/g,`
`),this.blockTokens(_,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},ce.blockTokens=function(_,he){var te=this;he===void 0&&(he=[]),this.options.pedantic?_=_.replace(/\t/g,"    ").replace(/^ +$/gm,""):_=_.replace(/^( *)(\t+)/gm,function(G,J,q){return J+"    ".repeat(q.length)});for(var ae,ge,Se,T;_;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ae=G.call({lexer:te},_,he))?(_=_.substring(ae.raw.length),he.push(ae),!0):!1}))){if(ae=this.tokenizer.space(_)){_=_.substring(ae.raw.length),ae.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(ae);continue}if(ae=this.tokenizer.code(_)){_=_.substring(ae.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae);continue}if(ae=this.tokenizer.fences(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.heading(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.hr(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.blockquote(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.list(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.html(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.def(_)){_=_.substring(ae.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.lheading(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(Se=_,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,J=_.slice(1),q=void 0;te.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Se=_.substring(0,G+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Se))){ge=he[he.length-1],T&&ge.type==="paragraph"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae),T=Se.length!==_.length,_=_.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(_)){_=_.substring(ae.raw.length),ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+ae.raw,ge.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ae);continue}if(_){var V="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,he},ce.inline=function(_,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:_,tokens:he}),he},ce.inlineTokens=function(_,he){var te=this;he===void 0&&(he=[]);var ae,ge,Se,T=_,V,G,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,V.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;_;)if(G||(J=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:te},_,he))?(_=_.substring(ae.raw.length),he.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.tag(_)){_=_.substring(ae.raw.length),ge=he[he.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(ae=this.tokenizer.link(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.reflink(_,this.tokens.links)){_=_.substring(ae.raw.length),ge=he[he.length-1],ge&&ae.type==="text"&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(ae=this.tokenizer.emStrong(_,T,J)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.codespan(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.br(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.del(_)){_=_.substring(ae.raw.length),he.push(ae);continue}if(ae=this.tokenizer.autolink(_,X)){_=_.substring(ae.raw.length),he.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(_,X))){_=_.substring(ae.raw.length),he.push(ae);continue}if(Se=_,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ne=_.slice(1),Ue=void 0;te.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},Ne),typeof Ue=="number"&&Ue>=0&&(ue=Math.min(ue,Ue))}),ue<1/0&&ue>=0&&(Se=_.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Se,O)){_=_.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),G=!0,ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=ae.raw,ge.text+=ae.text):he.push(ae);continue}if(_){var x="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},E(le,null,[{key:"rules",get:function(){return{block:z,inline:F}}}]),le}(),Ee=function(){function le(we){this.options=we||be.defaults}var ce=le.prototype;return ce.code=function(_,he,te){var ae=(he||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(_,ae);ge!=null&&ge!==_&&(te=!0,_=ge)}return _=_.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+p(ae,!0)+'">'+(te?_:p(_,!0))+`</code></pre>
`:"<pre><code>"+(te?_:p(_,!0))+`</code></pre>
`},ce.blockquote=function(_){return`<blockquote>
`+_+`</blockquote>
`},ce.html=function(_){return _},ce.heading=function(_,he,te,ae){if(this.options.headerIds){var ge=this.options.headerPrefix+ae.slug(te);return"<h"+he+' id="'+ge+'">'+_+"</h"+he+`>
`}return"<h"+he+">"+_+"</h"+he+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(_,he,te){var ae=he?"ol":"ul",ge=he&&te!==1?' start="'+te+'"':"";return"<"+ae+ge+`>
`+_+"</"+ae+`>
`},ce.listitem=function(_){return"<li>"+_+`</li>
`},ce.checkbox=function(_){return"<input "+(_?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(_){return"<p>"+_+`</p>
`},ce.table=function(_,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+_+`</thead>
`+he+`</table>
`},ce.tablerow=function(_){return`<tr>
`+_+`</tr>
`},ce.tablecell=function(_,he){var te=he.header?"th":"td",ae=he.align?"<"+te+' align="'+he.align+'">':"<"+te+">";return ae+_+("</"+te+`>
`)},ce.strong=function(_){return"<strong>"+_+"</strong>"},ce.em=function(_){return"<em>"+_+"</em>"},ce.codespan=function(_){return"<code>"+_+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(_){return"<del>"+_+"</del>"},ce.link=function(_,he,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<a href="'+p(_)+'"';return he&&(ae+=' title="'+he+'"'),ae+=">"+te+"</a>",ae},ce.image=function(_,he,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<img src="'+_+'" alt="'+te+'"';return he&&(ae+=' title="'+he+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(_){return _},le}(),De=function(){function le(){}var ce=le.prototype;return ce.strong=function(_){return _},ce.em=function(_){return _},ce.codespan=function(_){return _},ce.del=function(_){return _},ce.html=function(_){return _},ce.text=function(_){return _},ce.link=function(_,he,te){return""+te},ce.image=function(_,he,te){return""+te},ce.br=function(){return""},le}(),Ce=function(){function le(){this.seen={}}var ce=le.prototype;return ce.serialize=function(_){return _.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(_,he){var te=_,ae=0;if(this.seen.hasOwnProperty(te)){ae=this.seen[_];do ae++,te=_+"-"+ae;while(this.seen.hasOwnProperty(te))}return he||(this.seen[_]=ae,this.seen[te]=0),te},ce.slug=function(_,he){he===void 0&&(he={});var te=this.serialize(_);return this.getNextSafeSlug(te,he.dryrun)},le}(),de=function(){function le(we){this.options=we||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Ce}le.parse=function(_,he){var te=new le(he);return te.parse(_)},le.parseInline=function(_,he){var te=new le(he);return te.parseInline(_)};var ce=le.prototype;return ce.parse=function(_,he){he===void 0&&(he=!0);var te="",ae,ge,Se,T,V,G,J,q,x,ue,Ne,Ue,Ze,Je,tt,_e,et,rt,nt,ze=_.length;for(ae=0;ae<ze;ae++){if(ue=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){te+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",J="",T=ue.header.length,ge=0;ge<T;ge++)J+=this.renderer.tablecell(this.parseInline(ue.header[ge].tokens),{header:!0,align:ue.align[ge]});for(q+=this.renderer.tablerow(J),x="",T=ue.rows.length,ge=0;ge<T;ge++){for(G=ue.rows[ge],J="",V=G.length,Se=0;Se<V;Se++)J+=this.renderer.tablecell(this.parseInline(G[Se].tokens),{header:!1,align:ue.align[Se]});x+=this.renderer.tablerow(J)}te+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),te+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ue.ordered,Ue=ue.start,Ze=ue.loose,T=ue.items.length,x="",ge=0;ge<T;ge++)tt=ue.items[ge],_e=tt.checked,et=tt.task,Je="",tt.task&&(rt=this.renderer.checkbox(_e),Ze?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(tt.tokens,Ze),x+=this.renderer.listitem(Je,et,_e);te+=this.renderer.list(x,Ne,Ue);continue}case"html":{te+=this.renderer.html(ue.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<ze&&_[ae+1].type==="text";)ue=_[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);te+=he?this.renderer.paragraph(x):x;continue}default:{var dt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return te},ce.parseInline=function(_,he){he=he||this.renderer;var te="",ae,ge,Se,T=_.length;for(ae=0;ae<T;ae++){if(ge=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(Se=this.options.extensions.renderers[ge.type].call({parser:this},ge),Se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){te+=Se||"";continue}switch(ge.type){case"escape":{te+=he.text(ge.text);break}case"html":{te+=he.html(ge.text);break}case"link":{te+=he.link(ge.href,ge.title,this.parseInline(ge.tokens,he));break}case"image":{te+=he.image(ge.href,ge.title,ge.text);break}case"strong":{te+=he.strong(this.parseInline(ge.tokens,he));break}case"em":{te+=he.em(this.parseInline(ge.tokens,he));break}case"codespan":{te+=he.codespan(ge.text);break}case"br":{te+=he.br();break}case"del":{te+=he.del(this.parseInline(ge.tokens,he));break}case"text":{te+=he.text(ge.text);break}default:{var V='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return te},le}();function pe(le,ce,we){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ce=="function"&&(we=ce,ce=null),ce=I({},pe.defaults,ce||{}),y(ce),we){var _=ce.highlight,he;try{he=$e.lex(le,ce)}catch(T){return we(T)}var te=function(V){var G;if(!V)try{ce.walkTokens&&pe.walkTokens(he,ce.walkTokens),G=de.parse(he,ce)}catch(J){V=J}return ce.highlight=_,V?we(V):we(null,G)};if(!_||_.length<3||(delete ce.highlight,!he.length))return te();var ae=0;pe.walkTokens(he,function(T){T.type==="code"&&(ae++,setTimeout(function(){_(T.text,T.lang,function(V,G){if(V)return te(V);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),ae--,ae===0&&te()})},0))}),ae===0&&te();return}function ge(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Se=$e.lex(le,ce);if(ce.walkTokens){if(ce.async)return Promise.all(pe.walkTokens(Se,ce.walkTokens)).then(function(){return de.parse(Se,ce)}).catch(ge);pe.walkTokens(Se,ce.walkTokens)}return de.parse(Se,ce)}catch(T){ge(T)}}pe.options=pe.setOptions=function(le){return I(pe.defaults,le),$(pe.defaults),pe},pe.getDefaults=R,pe.defaults=be.defaults,pe.use=function(){for(var le=arguments.length,ce=new Array(le),we=0;we<le;we++)ce[we]=arguments[we];var _=I.apply(void 0,[{}].concat(ce)),he=pe.defaults.extensions||{renderers:{},childTokens:{}},te;ce.forEach(function(ae){if(ae.extensions&&(te=!0,ae.extensions.forEach(function(Se){if(!Se.name)throw new Error("extension name required");if(Se.renderer){var T=he.renderers?he.renderers[Se.name]:null;T?he.renderers[Se.name]=function(){for(var V=arguments.length,G=new Array(V),J=0;J<V;J++)G[J]=arguments[J];var q=Se.renderer.apply(this,G);return q===!1&&(q=T.apply(this,G)),q}:he.renderers[Se.name]=Se.renderer}if(Se.tokenizer){if(!Se.level||Se.level!=="block"&&Se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Se.level]?he[Se.level].unshift(Se.tokenizer):he[Se.level]=[Se.tokenizer],Se.start&&(Se.level==="block"?he.startBlock?he.startBlock.push(Se.start):he.startBlock=[Se.start]:Se.level==="inline"&&(he.startInline?he.startInline.push(Se.start):he.startInline=[Se.start]))}Se.childTokens&&(he.childTokens[Se.name]=Se.childTokens)})),ae.renderer&&function(){var Se=pe.defaults.renderer||new Ee,T=function(J){var q=Se[J];Se[J]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Ue=ae.renderer[J].apply(Se,ue);return Ue===!1&&(Ue=q.apply(Se,ue)),Ue}};for(var V in ae.renderer)T(V);_.renderer=Se}(),ae.tokenizer&&function(){var Se=pe.defaults.tokenizer||new U,T=function(J){var q=Se[J];Se[J]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Ue=ae.tokenizer[J].apply(Se,ue);return Ue===!1&&(Ue=q.apply(Se,ue)),Ue}};for(var V in ae.tokenizer)T(V);_.tokenizer=Se}(),ae.walkTokens){var ge=pe.defaults.walkTokens;_.walkTokens=function(Se){var T=[];return T.push(ae.walkTokens.call(this,Se)),ge&&(T=T.concat(ge.call(this,Se))),T}}te&&(_.extensions=he),pe.setOptions(_)})},pe.walkTokens=function(le,ce){for(var we=[],_=function(){var ge=te.value;switch(we=we.concat(ce.call(pe,ge)),ge.type){case"table":{for(var Se=M(ge.header),T;!(T=Se()).done;){var V=T.value;we=we.concat(pe.walkTokens(V.tokens,ce))}for(var G=M(ge.rows),J;!(J=G()).done;)for(var q=J.value,x=M(q),ue;!(ue=x()).done;){var Ne=ue.value;we=we.concat(pe.walkTokens(Ne.tokens,ce))}break}case"list":{we=we.concat(pe.walkTokens(ge.items,ce));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[ge.type]?pe.defaults.extensions.childTokens[ge.type].forEach(function(Ue){we=we.concat(pe.walkTokens(ge[Ue],ce))}):ge.tokens&&(we=we.concat(pe.walkTokens(ge.tokens,ce)))}},he=M(le),te;!(te=he()).done;)_();return we},pe.parseInline=function(le,ce){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ce=I({},pe.defaults,ce||{}),y(ce);try{var we=$e.lexInline(le,ce);return ce.walkTokens&&pe.walkTokens(we,ce.walkTokens),de.parseInline(we,ce)}catch(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+p(_.message+"",!0)+"</pre>";throw _}},pe.Parser=de,pe.parser=de.parse,pe.Renderer=Ee,pe.TextRenderer=De,pe.Lexer=$e,pe.lexer=$e.lex,pe.Tokenizer=U,pe.Slugger=Ce,pe.parse=pe;var re=pe.options,Re=pe.setOptions,se=pe.use,Y=pe.walkTokens,B=pe.parseInline,ie=pe,me=de.parse,ne=$e.lex;be.Lexer=$e,be.Parser=de,be.Renderer=Ee,be.Slugger=Ce,be.TextRenderer=De,be.Tokenizer=U,be.getDefaults=R,be.lexer=ne,be.marked=pe,be.options=re,be.parse=ie,be.parseInline=B,be.parser=me,be.setOptions=Re,be.use=se,be.walkTokens=Y,Object.defineProperty(be,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function E($,D,f){return Math.min(Math.max($,D),f)}e.$Ul=E;function L($,D){return(D+$%D)%D}e.rot=L;class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=A;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const f=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=R}),function(){function be(A){const M=[];typeof A=="number"&&M.push("code/timeOrigin",A);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let f=0;f<M.length;f+=2)D.push({name:M[f],startTime:M[f+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(A+R.startTime)});return M}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function E(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:be)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function E(L){if(e[L])return e[L].exports;var A=e[L]={i:L,l:!1,exports:{}};return be[L].call(A.exports,A,A.exports,E),A.l=!0,A.exports}return E.m=be,E.c=e,E.d=function(L,A,M){E.o(L,A)||Object.defineProperty(L,A,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,A){if(1&A&&(L=E(L)),8&A||4&A&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&A&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var A=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(A,"a",A),A},E.o=function(L,A){return Object.prototype.hasOwnProperty.call(L,A)},E.p="",E(E.s=0)}([function(be,e,E){(function(L){var A;e=be.exports=se,A=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],f=0,P=f++;D[P]="0|[1-9]\\d*";var k=f++;D[k]="[0-9]+";var u=f++;D[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;D[b]="("+D[P]+")\\.("+D[P]+")\\.("+D[P]+")";var p=f++;D[p]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var g=f++;D[g]="(?:"+D[P]+"|"+D[u]+")";var t=f++;D[t]="(?:"+D[k]+"|"+D[u]+")";var i=f++;D[i]="(?:-("+D[g]+"(?:\\."+D[g]+")*))";var r=f++;D[r]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var c=f++;D[c]="[0-9A-Za-z-]+";var o=f++;D[o]="(?:\\+("+D[c]+"(?:\\."+D[c]+")*))";var l=f++,n="v?"+D[b]+D[i]+"?"+D[o]+"?";D[l]="^"+n+"$";var s="[v=\\s]*"+D[p]+D[r]+"?"+D[o]+"?",a=f++;D[a]="^"+s+"$";var d=f++;D[d]="((?:<|>)?=?)";var v=f++;D[v]=D[k]+"|x|X|\\*";var m=f++;D[m]=D[P]+"|x|X|\\*";var I=f++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[o]+"?)?)?";var S=f++;D[S]="[v=\\s]*("+D[v]+")(?:\\.("+D[v]+")(?:\\.("+D[v]+")(?:"+D[r]+")?"+D[o]+"?)?)?";var h=f++;D[h]="^"+D[d]+"\\s*"+D[I]+"$";var w=f++;D[w]="^"+D[d]+"\\s*"+D[S]+"$";var y=f++;D[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=f++;D[C]="(?:~>?)";var W=f++;D[W]="(\\s*)"+D[C]+"\\s+",$[W]=new RegExp(D[W],"g");var K=f++;D[K]="^"+D[C]+D[I]+"$";var U=f++;D[U]="^"+D[C]+D[S]+"$";var z=f++;D[z]="(?:\\^)";var F=f++;D[F]="(\\s*)"+D[z]+"\\s+",$[F]=new RegExp(D[F],"g");var O=f++;D[O]="^"+D[z]+D[I]+"$";var X=f++;D[X]="^"+D[z]+D[S]+"$";var $e=f++;D[$e]="^"+D[d]+"\\s*("+s+")$|^$";var Ee=f++;D[Ee]="^"+D[d]+"\\s*("+n+")$|^$";var De=f++;D[De]="(\\s*)"+D[d]+"\\s*("+s+"|"+D[I]+")",$[De]=new RegExp(D[De],"g");var Ce=f++;D[Ce]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var de=f++;D[de]="^\\s*("+D[S]+")\\s+-\\s+("+D[S]+")\\s*$";var pe=f++;D[pe]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)A(re,D[re]),$[re]||($[re]=new RegExp(D[re]));function Re(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[a]:$[l]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);A("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[a]:$[l]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Ue=+Ne;if(Ue>=0&&Ue<R)return Ue}return Ne}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Re,e.valid=function(q,x){var ue=Re(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Re(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Ne=q.prerelease[x];if(A("prerelease compare",x,ue,Ne),ue===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ne)return B(ue,Ne)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Ne){typeof ue=="string"&&(Ne=ue,ue=void 0);try{return new se(q,ue).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(le(q,x))return null;var ue=Re(q),Ne=Re(x);if(ue.prerelease.length||Ne.prerelease.length){for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Ne[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Ne[Ue])return Ue},e.compareIdentifiers=B;var Y=/^[0-9]+$/;function B(q,x){var ue=Y.test(q),Ne=Y.test(x);return ue&&Ne&&(q=+q,x=+x),ue&&!Ne?-1:Ne&&!ue?1:q<x?-1:q>x?1:0}function ie(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function me(q,x,ue){return ie(q,x,ue)>0}function ne(q,x,ue){return ie(q,x,ue)<0}function le(q,x,ue){return ie(q,x,ue)===0}function ce(q,x,ue){return ie(q,x,ue)!==0}function we(q,x,ue){return ie(q,x,ue)>=0}function _(q,x,ue){return ie(q,x,ue)<=0}function he(q,x,ue,Ne){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q!==ue;break;case"":case"=":case"==":Ue=le(q,ue,Ne);break;case"!=":Ue=ce(q,ue,Ne);break;case">":Ue=me(q,ue,Ne);break;case">=":Ue=we(q,ue,Ne);break;case"<":Ue=ne(q,ue,Ne);break;case"<=":Ue=_(q,ue,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function te(q,x){if(q instanceof te){if(q.loose===x)return q;q=q.value}if(!(this instanceof te))return new te(q,x);A("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ie,e.compareLoose=function(q,x){return ie(q,x,!0)},e.rcompare=function(q,x,ue){return ie(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Ne){return e.compare(ue,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ue,Ne){return e.rcompare(ue,Ne,x)})},e.gt=me,e.lt=ne,e.eq=le,e.neq=ce,e.gte=we,e.lte=_,e.cmp=he,e.Comparator=te;var ae={};function ge(q,x){if(q instanceof ge)return q.loose===x?q:new ge(q.raw,x);if(q instanceof te)return new ge(q.value,x);if(!(this instanceof ge))return new ge(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Se(q){return!q||q.toLowerCase()==="x"||q==="*"}function T(q,x,ue,Ne,Ue,Ze,Je,tt,_e,et,rt,nt,ze){return((x=Se(ue)?"":Se(Ne)?">="+ue+".0.0":Se(Ue)?">="+ue+"."+Ne+".0":">="+x)+" "+(tt=Se(_e)?"":Se(et)?"<"+(+_e+1)+".0.0":Se(rt)?"<"+_e+"."+(+et+1)+".0":nt?"<="+_e+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function V(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(A(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Ne=q[ue].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function G(q,x,ue){try{x=new ge(x,ue)}catch{return!1}return x.test(q)}function J(q,x,ue,Ne){var Ue,Ze,Je,tt,_e;switch(q=new se(q,Ne),x=new ge(x,Ne),ue){case">":Ue=me,Ze=_,Je=ne,tt=">",_e=">=";break;case"<":Ue=ne,Ze=we,Je=me,tt="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,x,Ne))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,ze=null;if(rt.forEach(function(dt){dt.semver===ae&&(dt=new te(">=0.0.0")),nt=nt||dt,ze=ze||dt,Ue(dt.semver,nt.semver,Ne)?nt=dt:Je(dt.semver,ze.semver,Ne)&&(ze=dt)}),nt.operator===tt||nt.operator===_e||(!ze.operator||ze.operator===tt)&&Ze(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}te.prototype.parse=function(q){var x=this.loose?$[$e]:$[Ee],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},te.prototype.toString=function(){return this.value},te.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),he(q,this.operator,this.semver,this.loose))},te.prototype.intersects=function(q,x){if(!(q instanceof te))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new ge(q.value,x),G(this.value,ue,x);if(q.operator==="")return ue=new ge(this.value,x),G(q.semver,ue,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ze=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),tt=he(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=he(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Ue||Ze&&Je||tt||_e},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),A("range",q,x);var ue=x?$[de]:$[Ce];q=q.replace(ue,T),A("hyphen replace",q),q=q.replace($[De],"$1$2$3"),A("comparator trim",q,$[De]),q=(q=(q=q.replace($[W],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Ne=x?$[$e]:$[Ee],Ue=q.split(" ").map(function(Ze){return function(Je,tt){return A("comp",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){A("caret",nt,ze);var dt=ze?$[X]:$[O];return nt.replace(dt,function(Z,Q,ye,Be,He){var Xe;return A("caret",nt,Z,Q,ye,Be,He),Se(Q)?Xe="":Se(ye)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Se(Be)?Xe=Q==="0"?">="+Q+"."+ye+".0 <"+Q+"."+(+ye+1)+".0":">="+Q+"."+ye+".0 <"+(+Q+1)+".0.0":He?(A("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=Q==="0"?ye==="0"?">="+Q+"."+ye+"."+Be+He+" <"+Q+"."+ye+"."+(+Be+1):">="+Q+"."+ye+"."+Be+He+" <"+Q+"."+(+ye+1)+".0":">="+Q+"."+ye+"."+Be+He+" <"+(+Q+1)+".0.0"):(A("no pr"),Xe=Q==="0"?ye==="0"?">="+Q+"."+ye+"."+Be+" <"+Q+"."+ye+"."+(+Be+1):">="+Q+"."+ye+"."+Be+" <"+Q+"."+(+ye+1)+".0":">="+Q+"."+ye+"."+Be+" <"+(+Q+1)+".0.0"),A("caret return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),A("caret",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var dt=ze?$[U]:$[K];return nt.replace(dt,function(Z,Q,ye,Be,He){var Xe;return A("tilde",nt,Z,Q,ye,Be,He),Se(Q)?Xe="":Se(ye)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Se(Be)?Xe=">="+Q+"."+ye+".0 <"+Q+"."+(+ye+1)+".0":He?(A("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=">="+Q+"."+ye+"."+Be+He+" <"+Q+"."+(+ye+1)+".0"):Xe=">="+Q+"."+ye+"."+Be+" <"+Q+"."+(+ye+1)+".0",A("tilde return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),A("tildes",Je),Je=function(_e,et){return A("replaceXRanges",_e,et),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var dt=ze?$[w]:$[h];return nt.replace(dt,function(Z,Q,ye,Be,He,Xe){A("xRange",nt,Z,Q,ye,Be,He,Xe);var st=Se(ye),vt=st||Se(Be),Dt=vt||Se(He);return Q==="="&&Dt&&(Q=""),st?Z=Q===">"||Q==="<"?"<0.0.0":"*":Q&&Dt?(vt&&(Be=0),Dt&&(He=0),Q===">"?(Q=">=",vt?(ye=+ye+1,Be=0,He=0):Dt&&(Be=+Be+1,He=0)):Q==="<="&&(Q="<",vt?ye=+ye+1:Be=+Be+1),Z=Q+ye+"."+Be+"."+He):vt?Z=">="+ye+".0.0 <"+(+ye+1)+".0.0":Dt&&(Z=">="+ye+"."+Be+".0 <"+ye+"."+(+Be+1)+".0"),A("xRange return",Z),Z})}(rt,et)}).join(" ")}(Je,tt),A("xrange",Je),Je=function(_e,et){return A("replaceStars",_e,et),_e.trim().replace($[pe],"")}(Je,tt),A("stars",Je),Je}(Ze,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(Ne)})),Ue=Ue.map(function(Ze){return new te(Ze,x)})},ge.prototype.intersects=function(q,x){if(!(q instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ne){return q.set.some(function(Ue){return Ue.every(function(Ze){return Ne.intersects(Ze,x)})})})})},e.toComparators=function(q,x){return new ge(q,x).set.map(function(ue){return ue.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(V(this.set[x],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,x,ue){var Ne=null,Ue=null;try{var Ze=new ge(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Ne&&Ue.compare(Je)!==-1||(Ue=new se(Ne=Je,ue)))}),Ne},e.minSatisfying=function(q,x,ue){var Ne=null,Ue=null;try{var Ze=new ge(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Ne&&Ue.compare(Je)!==1||(Ue=new se(Ne=Je,ue)))}),Ne},e.validRange=function(q,x){try{return new ge(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return J(q,x,"<",ue)},e.gtr=function(q,x,ue){return J(q,x,">",ue)},e.outside=J,e.prerelease=function(q,x){var ue=Re(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new ge(q,ue),x=new ge(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[y]);return x==null?null:Re((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,E(1))},function(be,e){var E,L,A=be.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,f=[],P=!1,k=-1;function u(){P&&D&&(P=!1,D.length?f=D.concat(f):k=-1,f.length&&b())}function b(){if(!P){var t=$(u);P=!0;for(var i=f.length;i;){for(D=f,f=[];++k<i;)D&&D[k].run();k=-1,i=f.length}D=null,P=!1,function(r){if(L===clearTimeout)return clearTimeout(r);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(r);try{L(r)}catch{try{return L.call(null,r)}catch{return L.call(this,r)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function g(){}A.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];f.push(new p(t,i)),f.length!==1||P||$(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=g,A.addListener=g,A.once=g,A.off=g,A.removeListener=g,A.removeAllListeners=g,A.emit=g,A.prependListener=g,A.prependOnceListener=g,A.listeners=function(t){return[]},A.binding=function(t){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(t){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Pe[122],Ae([1,0,11,6]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function A(o){const l=o;return l?typeof l.read=="function":!1}e.$3d=A;function M(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.$4d=M;function R(o){const l=o;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$5d=R;function $(o,l){return new D(o,l)}e.$6d=$;class D{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(o,l){const n=[];let s;for(;(s=o.read())!==null;)n.push(s);return l(n)}e.$7d=f;function P(o,l,n){const s=[];let a;for(;(a=o.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return o.read()}}}e.$8d=P;function k(o,l){return new Promise((n,s)=>{const a=[];u(o,{onData:d=>{l&&a.push(d)},onError:d=>{l?s(d):n(void 0)},onEnd:()=>{n(l?l(a):void 0)}})})}e.$9d=k;function u(o,l,n){o.on("error",s=>{n?.isCancellationRequested||l.onError(s)}),o.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),o.on("data",s=>{n?.isCancellationRequested||l.onData(s)})}e.$0d=u;function b(o,l){return new Promise((n,s)=>{const a=new L.$Qc,d=[],v=S=>{if(d.push(S),d.length>l)return a.dispose(),o.pause(),n({stream:o,buffer:d,ended:!1})},m=S=>(a.dispose(),s(S)),I=()=>(a.dispose(),n({stream:o,buffer:d,ended:!0}));a.add((0,L.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),a.add((0,L.$Pc)(()=>o.removeListener("end",I))),o.on("end",I),a.add((0,L.$Pc)(()=>o.removeListener("data",v))),o.on("data",v)})}e.$$d=b;function p(o,l){const n=$(l);return n.end(o),n}e.$_d=p;function g(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=g;function t(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$be=t;function i(o,l,n){const s=$(n);return u(o,{onData:a=>s.write(l.data(a)),onError:a=>s.error(l.error?l.error(a):a),onEnd:()=>s.end()}),s}e.$ce=i;function r(o,l,n){let s=!1;return{read:()=>{const a=l.read();return s?a:(s=!0,a!==null?n([o,a]):o)}}}e.$de=r;function c(o,l,n){let s=!1;const a=$(n);return u(l,{onData:d=>s?a.write(d):(s=!0,a.write(n([o,d]))),onError:d=>a.error(d),onEnd:()=>{s||(s=!0,a.write(o)),a.end()}}),a}e.$ee=c}),define(Pe[24],Ae([1,0,44,122]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const A=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(y){return A?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return A&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(y)):(R||(R=new TextEncoder),new D(R.encode(y)))}static fromByteArray(y){const C=D.alloc(y.length);for(let W=0,K=y.length;W<K;W++)C.buffer[W]=y[W];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let U=0,z=y.length;U<z;U++)C+=y[U].byteLength}const W=D.alloc(C);let K=0;for(let U=0,z=y.length;U<z;U++){const F=y[U];W.set(F,K),K+=F.byteLength}return W}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return A?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(y,C){return new D(this.buffer.subarray(y,C))}set(y,C){if(y instanceof D)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,C){b(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){g(this.buffer,y,C)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,C){i(this.buffer,y,C)}indexOf(y,C=0){return f(this.buffer,y instanceof D?y.buffer:y,C)}}e.$fe=D;function f(w,y,C=0){const W=y.byteLength,K=w.byteLength;if(W===0)return 0;if(W===1)return w.indexOf(y[0]);if(W>K-C)return-1;const U=M.value;U.fill(y.length);for(let X=0;X<y.length;X++)U[y[X]]=y.length-X-1;let z=C+y.length-1,F=z,O=-1;for(;z<K;)if(w[z]===y[F]){if(F===0){O=z;break}z--,F--}else z+=Math.max(y.length-F,U[w[z]]),F=y.length-1;return O}e.$ge=f;function P(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0}e.$he=P;function k(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255}e.$ie=k;function u(w,y){return w[y]*2**24+w[y+1]*2**16+w[y+2]*2**8+w[y+3]}e.$je=u;function b(w,y,C){w[C+3]=y,y=y>>>8,w[C+2]=y,y=y>>>8,w[C+1]=y,y=y>>>8,w[C]=y}e.$ke=b;function p(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0|w[y+2]<<16>>>0|w[y+3]<<24>>>0}e.$le=p;function g(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255,y=y>>>8,w[C+2]=y&255,y=y>>>8,w[C+3]=y&255}e.$me=g;function t(w,y){return w[y]}e.$ne=t;function i(w,y,C){w[C]=y}e.$oe=i;function r(w){return L.$7d(w,y=>D.concat(y))}e.$pe=r;function c(w){return L.$be(w)}e.$qe=c;function o(w){return L.$9d(w,y=>D.concat(y))}e.$re=o;async function l(w){return w.ended?D.concat(w.buffer):D.concat([...w.buffer,await o(w.stream)])}e.$se=l;function n(w){return L.$_d(w,y=>D.concat(y))}e.$te=n;function s(w){return L.$ce(w,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.$ue=s;function a(w){return L.$6d(y=>D.concat(y),w)}e.$ve=a;function d(w,y){return L.$de(w,y,C=>D.concat(C))}e.$we=d;function v(w,y){return L.$ee(w,y,C=>D.concat(C))}e.$xe=v;function m(w){let y=0,C=0,W=0;const K=new Uint8Array(Math.floor(w.length/4*3)),U=F=>{switch(C){case 3:K[W++]=y|F,C=0;break;case 2:K[W++]=y|F>>>2,y=F<<6,C=3;break;case 1:K[W++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<w.length;F++){const O=w.charCodeAt(F);if(O>=65&&O<=90)U(O-65);else if(O>=97&&O<=122)U(O-97+26);else if(O>=48&&O<=57)U(O-48+52);else if(O===43||O===45)U(62);else if(O===47||O===95)U(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[F]}`)}}const z=W;for(;C>0;)U(0);return D.wrap(K).slice(0,z)}e.$ye=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},y=!0,C=!1){const W=C?S:I;let K="";const U=w.byteLength%3;let z=0;for(;z<w.byteLength-U;z+=3){const F=w[z+0],O=w[z+1],X=w[z+2];K+=W[F>>>2],K+=W[(F<<4|O>>>4)&63],K+=W[(O<<2|X>>>6)&63],K+=W[X&63]}if(U===1){const F=w[z+0];K+=W[F>>>2],K+=W[F<<4&63],y&&(K+="==")}else if(U===2){const F=w[z+0],O=w[z+1];K+=W[F>>>2],K+=W[(F<<4|O>>>4)&63],K+=W[O<<2&63],y&&(K+="=")}return K}e.$ze=h}),define(Pe[123],Ae([1,0,28,12]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function A(...te){return function(ae,ge){for(let Se=0,T=te.length;Se<T;Se++){const V=te[Se](ae,ge);if(V)return V}return null}}e.or=A,e.$Ij=M.bind(void 0,!1),e.$Jj=M.bind(void 0,!0);function M(te,ae,ge){if(!ge||ge.length<ae.length)return null;let Se;return te?Se=L.$7e(ge,ae):Se=ge.indexOf(ae)===0,Se?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(te,ae){const ge=ae.toLowerCase().indexOf(te.toLowerCase());return ge===-1?null:[{start:ge,end:ge+te.length}]}e.$Kj=R;function $(te,ae){return D(te.toLowerCase(),ae.toLowerCase(),0,0)}e.$Lj=$;function D(te,ae,ge,Se){if(ge===te.length)return[];if(Se===ae.length)return null;if(te[ge]===ae[Se]){let T=null;return(T=D(te,ae,ge+1,Se+1))?i({start:Se,end:Se+1},T):null}return D(te,ae,ge,Se+1)}function f(te){return 97<=te&&te<=122}function P(te){return 65<=te&&te<=90}e.$Mj=P;function k(te){return 48<=te&&te<=57}function u(te){return te===32||te===9||te===10||te===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>b.add(te.charCodeAt(0)));function p(te){return u(te)||b.has(te)}function g(te,ae){return te===ae||p(te)&&p(ae)}function t(te){return f(te)||P(te)||k(te)}function i(te,ae){return ae.length===0?ae=[te]:te.end===ae[0].start?ae[0].start=te.start:ae.unshift(te),ae}function r(te,ae){for(let ge=ae;ge<te.length;ge++){const Se=te.charCodeAt(ge);if(P(Se)||k(Se)||ge>0&&!t(te.charCodeAt(ge-1)))return ge}return te.length}function c(te,ae,ge,Se){if(ge===te.length)return[];if(Se===ae.length)return null;if(te[ge]!==ae[Se].toLowerCase())return null;{let T=null,V=Se+1;for(T=c(te,ae,ge+1,Se+1);!T&&(V=r(ae,V))<ae.length;)T=c(te,ae,ge+1,V),V++;return T===null?null:i({start:Se,end:Se+1},T)}}function o(te){let ae=0,ge=0,Se=0,T=0,V=0;for(let ue=0;ue<te.length;ue++)V=te.charCodeAt(ue),P(V)&&ae++,f(V)&&ge++,t(V)&&Se++,k(V)&&T++;const G=ae/te.length,J=ge/te.length,q=Se/te.length,x=T/te.length;return{upperPercent:G,lowerPercent:J,alphaPercent:q,numericPercent:x}}function l(te){const{upperPercent:ae,lowerPercent:ge}=te;return ge===0&&ae>.6}function n(te){const{upperPercent:ae,lowerPercent:ge,alphaPercent:Se,numericPercent:T}=te;return ge>.2&&ae<.8&&Se>.6&&T<.2}function s(te){let ae=0,ge=0,Se=0,T=0;for(let V=0;V<te.length;V++)Se=te.charCodeAt(V),P(Se)&&ae++,f(Se)&&ge++,u(Se)&&T++;return(ae===0||ge===0)&&T===0?te.length<=30:ae<=5}function a(te,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(te)||ae.length>60)return null;const ge=o(ae);if(!n(ge)){if(!l(ge))return null;ae=ae.toLowerCase()}let Se=null,T=0;for(te=te.toLowerCase();T<ae.length&&(Se=c(te,ae,0,T))===null;)T=r(ae,T+1);return Se}e.$Nj=a;function d(te,ae,ge=!1){if(!ae||ae.length===0)return null;let Se=null,T=0;for(te=te.toLowerCase(),ae=ae.toLowerCase();T<ae.length&&(Se=v(te,ae,0,T,ge))===null;)T=m(ae,T+1);return Se}e.$Oj=d;function v(te,ae,ge,Se,T){if(ge===te.length)return[];if(Se===ae.length)return null;if(g(te.charCodeAt(ge),ae.charCodeAt(Se))){let V=null,G=Se+1;if(V=v(te,ae,ge+1,Se+1,T),!T)for(;!V&&(G=m(ae,G))<ae.length;)V=v(te,ae,ge+1,G,T),G++;return V?te.charCodeAt(ge)!==ae.charCodeAt(Se)?V:i({start:Se,end:Se+1},V):null}else return null}function m(te,ae){for(let ge=ae;ge<te.length;ge++)if(p(te.charCodeAt(ge))||ge>0&&p(te.charCodeAt(ge-1)))return ge;return te.length}const I=A(e.$Jj,a,R),S=A(e.$Jj,a,$),h=new E.$Cc(1e4);function w(te,ae,ge=!1){if(typeof te!="string"||typeof ae!="string")return null;let Se=h.get(te);Se||(Se=new RegExp(L.$Pe(te),"i"),h.set(te,Se));const T=Se.exec(ae);return T?[{start:T.index,end:T.index+T[0].length}]:ge?S(te,ae):I(te,ae)}e.$Pj=w;function y(te,ae){const ge=me(te,te.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ge?W(ge):null}e.$Qj=y;function C(te,ae,ge,Se,T,V){const G=Math.min(13,te.length);for(;ge<G;ge++){const J=me(te,ae,ge,Se,T,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}e.$Rj=C;function W(te){if(typeof te>"u")return[];const ae=[],ge=te[1];for(let Se=te.length-1;Se>1;Se--){const T=te[Se]+ge,V=ae[ae.length-1];V&&V.end===T?V.end=T+1:ae.push({start:T,end:T+1})}return ae}e.$Sj=W;const K=128;function U(){const te=[],ae=[];for(let ge=0;ge<=K;ge++)ae[ge]=0;for(let ge=0;ge<=K;ge++)te.push(ae.slice(0));return te}function z(te){const ae=[];for(let ge=0;ge<=te;ge++)ae[ge]=0;return ae}const F=z(2*K),O=z(2*K),X=U(),$e=U(),Ee=U(),De=!1;function Ce(te,ae,ge,Se,T){function V(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let G=` |   |${Se.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=ge;J++)J===0?G+=" |":G+=`${ae[J-1]}|`,G+=te[J].slice(0,T+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function de(te,ae,ge,Se){te=te.substr(ae),ge=ge.substr(Se),console.log(Ce($e,te,te.length,ge,ge.length)),console.log(Ce(Ee,te,te.length,ge,ge.length)),console.log(Ce(X,te,te.length,ge,ge.length))}function pe(te,ae){if(ae<0||ae>=te.length)return!1;const ge=te.codePointAt(ae);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$mf(ge)}}function re(te,ae){if(ae<0||ae>=te.length)return!1;switch(te.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Re(te,ae,ge){return ae[te]!==ge[te]}function se(te,ae,ge,Se,T,V,G=!1){for(;ae<ge&&T<V;)te[ae]===Se[T]&&(G&&(F[ae]=T),ae+=1),T+=1;return ae===ge}e.$Tj=se;var Y;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(Y||(Y={}));var B;(function(te){te.Default=[-100,0];function ae(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}te.isDefault=ae})(B||(e.FuzzyScore=B={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,ge){this.firstMatchCanBeWeak=ae,this.boostFullMatch=ge}}e.$Uj=ie;function me(te,ae,ge,Se,T,V,G=ie.default){const J=te.length>K?K:te.length,q=Se.length>K?K:Se.length;if(ge>=J||V>=q||J-ge>q-V||!se(ae,ge,J,T,V,q,!0))return;ne(J,q,ge,V,ae,T);let x=1,ue=1,Ne=ge,Ue=V;const Ze=[!1];for(x=1,Ne=ge;Ne<J;x++,Ne++){const rt=F[Ne],nt=O[Ne],ze=Ne+1<J?O[Ne+1]:q;for(ue=rt-V+1,Ue=rt;Ue<ze;ue++,Ue++){let dt=Number.MIN_SAFE_INTEGER,Z=!1;Ue<=nt&&(dt=le(te,ae,Ne,ge,Se,T,Ue,q,V,X[x-1][ue-1]===0,Ze));let Q=0;dt!==Number.MAX_SAFE_INTEGER&&(Z=!0,Q=dt+$e[x-1][ue-1]);const ye=Ue>rt,Be=ye?$e[x][ue-1]+(X[x][ue-1]>0?-5:0):0,He=Ue>rt+1&&X[x][ue-1]>0,Xe=He?$e[x][ue-2]+(X[x][ue-2]>0?-5:0):0;if(He&&(!ye||Xe>=Be)&&(!Z||Xe>=Q))$e[x][ue]=Xe,Ee[x][ue]=3,X[x][ue]=0;else if(ye&&(!Z||Be>=Q))$e[x][ue]=Be,Ee[x][ue]=2,X[x][ue]=0;else if(Z)$e[x][ue]=Q,Ee[x][ue]=1,X[x][ue]=X[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&de(te,ge,Se,V),!Ze[0]&&!G.firstMatchCanBeWeak)return;x--,ue--;const Je=[$e[x][ue],V];let tt=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=Ee[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ae[ge+x-1]===T[V+ue-1]&&!Re(rt+V-1,Se,T)&&tt+1>X[x][rt]&&(rt=ue),rt===ue?tt++:tt=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===J&&G.boostFullMatch&&(Je[0]+=2);const et=_e-J;return Je[0]-=et,Je}e.$Vj=me;function ne(te,ae,ge,Se,T,V){let G=te-1,J=ae-1;for(;G>=ge&&J>=Se;)T[G]===V[J]&&(O[G]=J,G--),J--}function le(te,ae,ge,Se,T,V,G,J,q,x,ue){if(ae[ge]!==V[G])return Number.MIN_SAFE_INTEGER;let Ne=1,Ue=!1;return G===ge-Se?Ne=te[ge]===T[G]?7:5:Re(G,T,V)&&(G===0||!Re(G-1,T,V))?(Ne=te[ge]===T[G]?7:5,Ue=!0):pe(V,G)&&(G===0||!pe(V,G-1))?Ne=5:(pe(V,G-1)||re(V,G-1))&&(Ne=5,Ue=!0),Ne>1&&ge===Se&&(ue[0]=!0),Ue||(Ue=Re(G,T,V)||pe(V,G-1)||re(V,G-1)),ge===Se?G>q&&(Ne-=Ue?3:5):x?Ne+=Ue?2:0:Ne+=Ue?0:1,G+1===J&&(Ne-=Ue?3:5),Ne}function ce(te,ae,ge,Se,T,V,G){return _(te,ae,ge,Se,T,V,!0,G)}e.$Wj=ce;function we(te,ae,ge,Se,T,V,G){return _(te,ae,ge,Se,T,V,!1,G)}e.$Xj=we;function _(te,ae,ge,Se,T,V,G,J){let q=me(te,ae,ge,Se,T,V,J);if(q&&!G)return q;if(te.length>=3){const x=Math.min(7,te.length-1);for(let ue=ge+1;ue<x;ue++){const Ne=he(te,ue);if(Ne){const Ue=me(Ne,Ne.toLowerCase(),ge,Se,T,V,J);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function he(te,ae){if(ae+1>=te.length)return;const ge=te[ae],Se=te[ae+1];if(ge!==Se)return te.slice(0,ae)+Se+ge+te.slice(ae+2)}}),define(Pe[31],Ae([1,0,12]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(L||(L={})),function(A){const M="error",R="warning",$="warn",D="info",f="ignore";function P(u){return u?E.$6e(M,u)?A.Error:E.$6e(R,u)||E.$6e($,u)?A.Warning:E.$6e(D,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function k(u){switch(u){case A.Error:return M;case A.Warning:return R;case A.Info:return D;default:return f}}A.toString=k}(L||(L={})),e.default=L}),define(Pe[124],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class A{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return p-g}value(){return this.b[this.c]}}e.$Xh=A;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,L.$Ze)(b,this.b,0,b.length,this.c,this.d):(0,L.$2e)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class R{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const g=this.b.charCodeAt(p);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,L.$Ze)(b,this.b,0,b.length,this.d,this.e):(0,L.$2e)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=R;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class D{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,L.$1e)(b,this.c.scheme);if(this.d[this.e]===2)return(0,L.$1e)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,L.$Ye)(b,this.c.query);if(this.d[this.e]===5)return(0,L.$Ye)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=D;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class k{static forUris(b=()=>!1,p=()=>!1){return new k(new D(b,p))}static forPaths(b=!1){return new k(new R(void 0,!b))}static forStrings(){return new k(new A)}static forConfigKeys(){return new k(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const g=p.slice(0);(0,E.$Wb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,E.$Wb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,p){const g=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=g.value());const i=[];for(t=this.c;;){const c=g.cmp(t.segment);if(c>0)t.left||(t.left=new f,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(c<0)t.right||(t.right=new f,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=p,t.key=b;for(let c=i.length-1;c>=0;c--){const o=i[c][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=i[c][0],s=i[c+1][0];if(n===1&&s===1)i[c][1]=o.rotateLeft();else if(n===-1&&s===-1)i[c][1]=o.rotateRight();else if(n===1&&s===-1)o.right=i[c+1][1]=i[c+1][1].rotateRight(),i[c][1]=o.rotateLeft();else if(n===-1&&s===1)o.left=i[c+1][1]=i[c+1][1].rotateLeft(),i[c][1]=o.rotateRight();else throw new Error;if(c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let g=this.c;for(;g;){const t=p.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else break}return g}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=g.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:c,value:o,segment:l}=r;this.e(r.key,!1),i.key=c,i.value=o,i.segment=l}}else{const r=i.left??i.right;if(t.length>0){const[c,o]=t[t.length-1];switch(c){case-1:o.left=r;break;case 0:o.mid=r;break;case 1:o.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const c=t[r][1];c.updateHeight();const o=c.balanceFactor();if(o>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),t[r][1]=c.rotateLeft()):o<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),t[r][1]=c.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let g=this.c,t;for(;g;){const i=p.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(p.hasNext())p.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,g]of this)b(g,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const g=p.balanceFactor();return g<-1||g>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$2h=k}),define(Pe[45],Ae([1,0,90]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function A(R){return{id:R}}e.$2j=A;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(r){const c=$.exec(r.id);if(!c)return D(E.$1j.error);const[,o,l]=c,n=["codicon","codicon-"+o];return l&&n.push("codicon-modifier-"+l.substring(1)),n}R.asClassNameArray=D;function f(r){return D(r).join(" ")}R.asClassName=f;function P(r){return"."+D(r).join(".")}R.asCSSSelector=P;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||L.isThemeColor(r.color))}R.isThemeIcon=k;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(r){const c=u.exec(r);if(!c)return;const[,o]=c;return{id:o}}R.fromString=b;function p(r){return{id:r}}R.fromId=p;function g(r,c){let o=r.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),c&&(o=`${o}~${c}`),{id:o}}R.modify=g;function t(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}R.getModifier=t;function i(r,c){return r.id===c.id&&r.color?.id===c.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Ae([1,0,123,12,45]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const M="$(",R=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(r,c)=>c?r:`\\${r}`)}e.$3j=D;const f=new RegExp(`\\\\${R.source}`,"g");function P(i){return i.replace(f,r=>`\\${r}`)}e.$4j=P;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(i){return i.indexOf(M)===-1?i:i.replace(k,(r,c,o,l)=>o?r:c||l||"")}e.$5j=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$6j=b;const p=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){p.lastIndex=0;let r="";const c=[];let o=0;for(;;){const l=p.lastIndex,n=p.exec(i),s=i.substring(l,n?.index);if(s.length>0){r+=s;for(let a=0;a<s.length;a++)c.push(o)}if(!n)break;o+=n[0].length}return{text:r,iconOffsets:c}}e.$7j=g;function t(i,r,c=!1){const{text:o,iconOffsets:l}=r;if(!l||l.length===0)return(0,E.$Pj)(i,o,c);const n=(0,L.$Ne)(o," "),s=o.length-n.length,a=(0,E.$Pj)(i,n,c);if(a)for(const d of a){const v=l[d.start+s]+s;d.start+=v,d.end+=v}return a}e.$8j=t}),define(Pe[38],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(A){return E.test(A)}e.$hg=L,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){A(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,f="";return f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f+="-",f+=R[M[D++]],f+=R[M[D++]],f+="-",f+=R[M[D++]],f+=R[M[D++]],f+="-",f+=R[M[D++]],f+=R[M[D++]],f+="-",f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f+=R[M[D++]],f}}()}),define(Pe[126],Ae([1,0,18,67,38]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.$9s=e.$8s=e.$7s=e.$6s=void 0;function M(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$6s=M;function R(k,u,b){const p={id:(0,A.$ig)(),name:k,uri:u,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$7s=R;class ${constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return L.Iterable.some(this,([p,g])=>g.asFile())&&b.push("files"),P(D(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const p=this.a.get(u);p?p.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const p of b)yield[u,p]}b(u){return D(u)}}e.$8s=$;function D(k){return k.toLowerCase()}function f(k,u){return P(D(k),u.map(D))}e.$9s=f;function P(k,u){if(k==="*/*")return u.length>0;if(u.includes(k))return!0;const b=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,g,t]=b;return t==="*"?u.some(i=>i.startsWith(g+"/")):!1}e.$0s=Object.freeze({create:k=>(0,E.$Lb)(k.map(u=>u.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$0s.split(k).filter(u=>!u.startsWith("#"))})}),define(Pe[127],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.StringEOL=void 0;var E;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(A){let M=0,R=0,$=0,D=0;for(let f=0,P=A.length;f<P;f++){const k=A.charCodeAt(f);k===13?(M===0&&(R=f),M++,f+1<P&&A.charCodeAt(f+1)===10?(D|=2,f++):D|=3,$=f+1):k===10&&(D|=1,M===0&&(R=f),M++,$=f+1)}return M===0&&(R=A.length),[M,R,A.length-$,D]}e.$at=L}),define(Pe[128],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0,e.$0r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,f=$.notIn.length;D<f;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const f=$.findTokenIndexAtOffset(D-2),P=$.getStandardTokenType(f);return this.isOK(P)}g($,D){for(let f=$;f<=D;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$wt=L;class A{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$xt=A;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Pe[130],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return A(this.right);let t=this;for(;t.parent!==e.$sB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}prev(){if(this.left!==e.$sB)return M(this.left);let t=this;for(;t.parent!==e.$sB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=E;var L;(function(g){g[g.Black=0]="Black",g[g.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$sB=new E(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function A(g){for(;g.left!==e.$sB;)g=g.left;return g}e.$tB=A;function M(g){for(;g.right!==e.$sB;)g=g.right;return g}e.$uB=M;function R(g){return g===e.$sB?0:g.size_left+g.piece.length+R(g.right)}function $(g){return g===e.$sB?0:g.lf_left+g.piece.lineFeedCnt+$(g.right)}function D(){e.$sB.parent=e.$sB}function f(g,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$sB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$sB?g.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$vB=f;function P(g,t){const i=t.left;t.left=i.right,i.right!==e.$sB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$sB?g.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$wB=P;function k(g,t){let i,r;if(t.left===e.$sB?(r=t,i=r.right):t.right===e.$sB?(r=t,i=r.left):(r=A(t.right),i=r.right),r===g.root){g.root=i,i.color=0,t.detach(),D(),g.root.parent=e.$sB;return}const c=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,p(g,i)):(r.parent===t?i.parent=r:i.parent=r.parent,p(g,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===g.root?g.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$sB&&(r.left.parent=r),r.right!==e.$sB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,p(g,r)),t.detach(),i.parent.left===i){const l=R(i),n=$(i);if(l!==i.parent.size_left||n!==i.parent.lf_left){const s=l-i.parent.size_left,a=n-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=n,b(g,i.parent,s,a)}}if(p(g,i.parent),c){D();return}let o;for(;i!==g.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,f(g,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,P(g,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,f(g,i.parent),i=g.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,P(g,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,f(g,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,P(g,i.parent),i=g.root));i.color=0,D()}e.$xB=k;function u(g,t){for(p(g,t);t!==g.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,f(g,t)),t.parent.color=0,t.parent.parent.color=1,P(g,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,P(g,t)),t.parent.color=0,t.parent.parent.color=1,f(g,t.parent.parent))}g.root.color=0}e.$yB=u;function b(g,t,i,r){for(;t!==g.root&&t!==e.$sB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$zB=b;function p(g,t){let i=0,r=0;if(t!==g.root){for(;t!==g.root&&t===t.parent.right;)t=t.parent;if(t!==g.root)for(t=t.parent,i=R(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==g.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$AB=p}),define(Pe[91],Ae([1,0,131,29,92,130,93]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const $=65535;function D(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class f{constructor(r,c,o,l,n){this.lineStarts=r,this.cr=c,this.lf=o,this.crlf=l,this.isBasicASCII=n}}function P(i,r=!0){const c=[0];let o=1;for(let l=0,n=i.length;l<n;l++){const s=i.charCodeAt(l);s===13?l+1<n&&i.charCodeAt(l+1)===10?(c[o++]=l+2,l++):c[o++]=l+1:s===10&&(c[o++]=l+1)}return r?D(c):c}e.$HB=P;function k(i,r){i.length=0,i[0]=0;let c=1,o=0,l=0,n=0,s=!0;for(let d=0,v=r.length;d<v;d++){const m=r.charCodeAt(d);m===13?d+1<v&&r.charCodeAt(d+1)===10?(n++,i[c++]=d+2,d++):(o++,i[c++]=d+1):m===10?(l++,i[c++]=d+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const a=new f(D(i),o,l,n,s);return i.length=0,a}e.$IB=k;class u{constructor(r,c,o,l,n){this.bufferIndex=r,this.start=c,this.end=o,this.lineFeedCnt=l,this.length=n}}e.$JB=u;class b{constructor(r,c){this.buffer=r,this.lineStarts=c}}e.$KB=b;class p{constructor(r,c){this.a=[],this.c=r,this.d=c,this.b=0,r.root!==M.$sB&&r.iterate(r.root,o=>(o!==M.$sB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(r){this.a=r,this.b=[]}get(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartOffset<=r&&o.nodeStartOffset+o.node.piece.length>=r)return o}return null}get2(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<r&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=r)return o}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let c=!1;const o=this.b;for(let l=0;l<o.length;l++){const n=o[l];if(n.node.parent===null||n.nodeStartOffset>=r){o[l]=null,c=!0;continue}}if(c){const l=[];for(const n of o)n!==null&&l.push(n);this.b=l}}}class t{constructor(r,c,o){this.create(r,c,o)}create(r,c,o){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$sB,this.b=1,this.c=0,this.d=c,this.e=c.length,this.f=o;let l=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=P(r[n].buffer));const a=new u(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),l=this.S(l,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const c=$,o=c-Math.floor(c/3),l=o*2;let n="",s=0;const a=[];if(this.iterate(this.root,d=>{const v=this.R(d),m=v.length;if(s<=o||s+m<l)return n+=v,s+=m,!0;const I=n.replace(/\r\n|\r|\n/g,r);return a.push(new b(I,P(I))),n=v,s=m,!0}),s>0){const d=n.replace(/\r\n|\r|\n/g,r);a.push(new b(d,P(d)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new p(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let c=0;return this.iterate(this.root,l=>{if(l===M.$sB)return!0;const n=this.R(l),s=n.length,a=r.G(c),d=r.G(c+s),v=r.getValueInRange2(a,d);return c+=s,n===v})}getOffsetAt(r,c){let o=0,l=this.root;for(;l!==M.$sB;)if(l.left!==M.$sB&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){o+=l.size_left;const n=this.B(l,r-l.lf_left-2);return o+=n+c-1}else r-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let c=this.root,o=0;const l=r;for(;c!==M.$sB;)if(c.size_left!==0&&c.size_left>=r)c=c.left;else if(c.size_left+c.piece.length>=r){const n=this.A(c,r-c.size_left);if(o+=c.lf_left+n.index,n.index===0){const s=this.getOffsetAt(o+1,1),a=l-s;return new E.$zs(o+1,a+1)}return new E.$zs(o+1,n.remainder+1)}else if(r-=c.size_left+c.piece.length,o+=c.lf_left+c.piece.lineFeedCnt,c.right===M.$sB){const n=this.getOffsetAt(o+1,1),s=l-r-n;return new E.$zs(o+1,s+1)}else c=c.right;return new E.$zs(1,1)}getValueInRange(r,c){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const o=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(o,l);return c?c!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,c):c===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,c):n}getValueInRange2(r,c){if(r.node===c.node){const a=r.node,d=this.a[a.piece.bufferIndex].buffer,v=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(v+r.remainder,v+c.remainder)}let o=r.node;const l=this.a[o.piece.bufferIndex].buffer,n=this.u(o.piece.bufferIndex,o.piece.start);let s=l.substring(n+r.remainder,n+o.piece.length);for(o=o.next();o!==M.$sB;){const a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(o===c.node){s+=a.substring(d,d+c.remainder);break}else s+=a.substr(d,o.piece.length);o=o.next()}return s}getLinesContent(){const r=[];let c=0,o="",l=!1;return this.iterate(this.root,n=>{if(n===M.$sB)return!0;const s=n.piece;let a=s.length;if(a===0)return!0;const d=this.a[s.bufferIndex].buffer,v=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let S=v[m]+s.start.column;if(l&&(d.charCodeAt(S)===10&&(S++,a--),r[c++]=o,o="",l=!1,a===0))return!0;if(m===I)return!this.f&&d.charCodeAt(S+a-1)===13?(l=!0,o+=d.substr(S,a-1)):o+=d.substr(S,a),!0;o+=this.f?d.substring(S,Math.max(S,v[m+1]-this.e)):d.substring(S,v[m+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;for(let h=m+1;h<I;h++)o=this.f?d.substring(v[h],v[h+1]-this.e):d.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;return!this.f&&d.charCodeAt(v[I]+s.end.column-1)===13?(l=!0,s.end.column===0?c--:o=d.substr(v[I],s.end.column-1)):o=d.substr(v[I],s.end.column),!0}),l&&(r[c++]=o,o=""),r[c++]=o,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const c=r.node.next();if(!c)return 0;const o=this.a[c.piece.bufferIndex],l=this.u(c.piece.bufferIndex,c.piece.start);return o.buffer.charCodeAt(l)}else{const c=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return c.buffer.charCodeAt(l)}}getLineCharCode(r,c){const o=this.H(r,c+1);return this.l(o)}getLineLength(r){if(r===this.getLineCount()){const c=this.getOffsetAt(r,1);return this.getLength()-c}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const c=this.G(r);return this.l(c)}findMatchesInNode(r,c,o,l,n,s,a,d,v,m,I){const S=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start),w=this.u(r.piece.bufferIndex,n),y=this.u(r.piece.bufferIndex,s);let C;const W={line:0,column:0};let K,U;c._wordSeparators?(K=S.buffer.substring(w,y),U=z=>z+w,c.reset(0)):(K=S.buffer,U=z=>z,c.reset(w));do if(C=c.next(K),C){if(U(C.index)>=y)return m;this.s(r,U(C.index)-h,W);const z=this.t(r.piece.bufferIndex,n,W),F=W.line===n.line?W.column-n.column+l:W.column+1,O=F+C[0].length;if(I[m++]=(0,R.$DB)(new L.$As(o+z,F,o+z,O),C,d),U(C.index)+C[0].length>=y||m>=v)return m}while(C);return m}findMatchesLineByLine(r,c,o,l){const n=[];let s=0;const a=new R.$GB(c.wordSeparators,c.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const v=this.H(r.endLineNumber,r.endColumn);if(v===null)return[];let m=this.s(d.node,d.remainder);const I=this.s(v.node,v.remainder);if(d.node===v.node)return this.findMatchesInNode(d.node,a,r.startLineNumber,r.startColumn,m,I,c,o,l,s,n),n;let S=r.startLineNumber,h=d.node;for(;h!==v.node;){const y=this.t(h.piece.bufferIndex,m,h.piece.end);if(y>=1){const W=this.a[h.piece.bufferIndex].lineStarts,K=this.u(h.piece.bufferIndex,h.piece.start),U=W[m.line+y],z=S===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(h,a,S,z,m,this.s(h,U-K),c,o,l,s,n),s>=l)return n;S+=y}const C=S===r.startLineNumber?r.startColumn-1:0;if(S===r.endLineNumber){const W=this.getLineContent(S).substring(C,r.endColumn-1);return s=this.n(c,a,W,r.endLineNumber,C,s,n,o,l),n}if(s=this.n(c,a,this.getLineContent(S).substr(C),S,C,s,n,o,l),s>=l)return n;S++,d=this.H(S,1),h=d.node,m=this.s(d.node,d.remainder)}if(S===r.endLineNumber){const y=S===r.startLineNumber?r.startColumn-1:0,C=this.getLineContent(S).substring(y,r.endColumn-1);return s=this.n(c,a,C,r.endLineNumber,y,s,n,o,l),n}const w=S===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(v.node,a,S,w,m,I,c,o,l,s,n),n}n(r,c,o,l,n,s,a,d,v){const m=r.wordSeparators;if(!d&&r.simpleSearch){const S=r.simpleSearch,h=S.length,w=o.length;let y=-h;for(;(y=o.indexOf(S,y+h))!==-1;)if((!m||(0,R.$FB)(m,o,w,y,h))&&(a[s++]=new A.$Ru(new L.$As(l,y+1+n,l,y+1+h+n),null),s>=v))return s;return s}let I;c.reset(0);do if(I=c.next(o),I&&(a[s++]=(0,R.$DB)(new L.$As(l,I.index+1+n,l,I.index+1+I[0].length+n),I,d),s>=v))return s;while(I);return s}insert(r,c,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$sB){const{node:l,remainder:n,nodeStartOffset:s}=this.G(r),a=l.piece,d=a.bufferIndex,v=this.s(l,n);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&s+a.length===r&&c.length<$){this.F(l,c),this.y();return}if(s===r)this.o(c,l),this.h.validate(r);else if(s+l.piece.length>r){const m=[];let I=new u(a.bufferIndex,v,a.end,this.t(a.bufferIndex,v,a.end),this.u(d,a.end)-this.u(d,v));if(this.K()&&this.M(c)&&this.I(l,n)===10){const y={line:I.start.line+1,column:0};I=new u(I.bufferIndex,y,I.end,this.t(I.bufferIndex,y,I.end),I.length-1),c+=`
`}if(this.K()&&this.L(c))if(this.I(l,n-1)===13){const y=this.s(l,n-1);this.C(l,y),c="\r"+c,l.piece.length===0&&m.push(l)}else this.C(l,v);else this.C(l,v);const S=this.w(c);I.length>0&&this.S(l,I);let h=l;for(let w=0;w<S.length;w++)h=this.S(h,S[w]);this.v(m)}else this.q(c,l)}else{const l=this.w(c);let n=this.T(null,l[0]);for(let s=1;s<l.length;s++)n=this.S(n,l[s])}this.y()}delete(r,c){if(this.j.lineNumber=0,this.j.value="",c<=0||this.root===M.$sB)return;const o=this.G(r),l=this.G(r+c),n=o.node,s=l.node;if(n===s){const S=this.s(n,o.remainder),h=this.s(n,l.remainder);if(o.nodeStartOffset===r){if(c===n.piece.length){const w=n.next();(0,M.$xB)(this,n),this.N(w),this.y();return}this.D(n,h),this.h.validate(r),this.N(n),this.y();return}if(o.nodeStartOffset+n.piece.length===r+c){this.C(n,S),this.O(n),this.y();return}this.E(n,S,h),this.y();return}const a=[],d=this.s(n,o.remainder);this.C(n,d),this.h.validate(r),n.piece.length===0&&a.push(n);const v=this.s(s,l.remainder);this.D(s,v),s.piece.length===0&&a.push(s);const m=n.next();for(let S=m;S!==M.$sB&&S!==s;S=S.next())a.push(S);const I=n.piece.length===0?n.prev():n;this.v(a),this.O(I),this.y()}o(r,c){const o=[];if(this.K()&&this.M(r)&&this.L(c)){const s=c.piece,a={line:s.start.line+1,column:0},d=new u(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),s.length-1);c.piece=d,r+=`
`,(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c)}const l=this.w(r);let n=this.T(c,l[l.length-1]);for(let s=l.length-2;s>=0;s--)n=this.T(n,l[s]);this.N(n),this.v(o)}q(r,c){this.Q(r,c)&&(r+=`
`);const o=this.w(r),l=this.S(c,o[0]);let n=l;for(let s=1;s<o.length;s++)n=this.S(n,o[s]);this.N(l)}s(r,c,o){const l=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,d=s[l.start.line]+l.start.column+c;let v=l.start.line,m=l.end.line,I=0,S=0,h=0;for(;v<=m&&(I=v+(m-v)/2|0,h=s[I],I!==m);)if(S=s[I+1],d<h)m=I-1;else if(d>=S)v=I+1;else break;return o?(o.line=I,o.column=d-h,null):{line:I,column:d-h}}t(r,c,o){if(o.column===0)return o.line-c.line;const l=this.a[r].lineStarts;if(o.line===l.length-1)return o.line-c.line;const n=l[o.line+1],s=l[o.line]+o.column;if(n>s+1)return o.line-c.line;const a=s-1;return this.a[r].buffer.charCodeAt(a)===13?o.line-c.line+1:o.line-c.line}u(r,c){return this.a[r].lineStarts[c.line]+c.column}v(r){for(let c=0;c<r.length;c++)(0,M.$xB)(this,r[c])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const S=r.charCodeAt($-1);let h;S===13||S>=55296&&S<=56319?(h=r.substring(0,$-1),r=r.substring($-1)):(h=r.substring(0,$),r=r.substring($));const w=P(h);m.push(new u(this.a.length,{line:0,column:0},{line:w.length-1,column:h.length-w[w.length-1]},w.length-1,h.length)),this.a.push(new b(h,w))}const I=P(r);return m.push(new u(this.a.length,{line:0,column:0},{line:I.length-1,column:r.length-I[I.length-1]},I.length-1,r.length)),this.a.push(new b(r,I)),m}let c=this.a[0].buffer.length;const o=P(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===c&&c!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<o.length;m++)o[m]+=c+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+r,c+=1}else{if(c!==0)for(let m=0;m<o.length;m++)o[m]+=c;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,a=n-this.a[0].lineStarts[s],d={line:s,column:a},v=new u(0,l,d,this.t(0,l,d),n-c);return this.g=d,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,c=0){let o=this.root,l="";const n=this.h.get2(r);if(n){o=n.node;const s=this.B(o,r-n.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(n.nodeStartLineNumber+o.piece.lineFeedCnt===r)l=a.substring(d+s,d+o.piece.length);else{const v=this.B(o,r-n.nodeStartLineNumber);return a.substring(d+s,d+v-c)}}else{let s=0;const a=r;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const d=this.B(o,r-o.lf_left-2),v=this.B(o,r-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,I=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:a-(r-1-o.lf_left)}),m.substring(I+d,I+v-c)}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const d=this.B(o,r-o.lf_left-2),v=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);l=v.substring(m+d,m+o.piece.length);break}else r-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$sB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),d=this.u(o.piece.bufferIndex,o.piece.start);return l+=s.substring(d,d+a-c),l}else{const a=this.u(o.piece.bufferIndex,o.piece.start);l+=s.substr(a,o.piece.length)}o=o.next()}return l}y(){let r=this.root,c=1,o=0;for(;r!==M.$sB;)c+=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;this.b=c,this.c=o,this.h.validate(this.c)}A(r,c){const o=r.piece,l=this.s(r,c),n=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===c){const s=this.t(r.piece.bufferIndex,o.start,l);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:l.column}}B(r,c){if(c<0)return 0;const o=r.piece,l=this.a[o.bufferIndex].lineStarts,n=o.start.line+c+1;return n>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[n]-l[o.start.line]-o.start.column}C(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.end),s=c,a=this.u(o.bufferIndex,s),d=this.t(o.bufferIndex,o.start,s),v=d-l,m=a-n,I=o.length+m;r.piece=new u(o.bufferIndex,o.start,s,d,I),(0,M.$zB)(this,r,m,v)}D(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.start),s=c,a=this.t(o.bufferIndex,s,o.end),d=this.u(o.bufferIndex,s),v=a-l,m=n-d,I=o.length+m;r.piece=new u(o.bufferIndex,s,o.end,a,I),(0,M.$zB)(this,r,m,v)}E(r,c,o){const l=r.piece,n=l.start,s=l.end,a=l.length,d=l.lineFeedCnt,v=c,m=this.t(l.bufferIndex,l.start,v),I=this.u(l.bufferIndex,c)-this.u(l.bufferIndex,n);r.piece=new u(l.bufferIndex,l.start,v,m,I),(0,M.$zB)(this,r,I-a,m-d);const S=new u(l.bufferIndex,o,s,this.t(l.bufferIndex,o,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,o)),h=this.S(r,S);this.N(h)}F(r,c){this.Q(c,r)&&(c+=`
`);const o=this.K()&&this.L(c)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=c;const n=P(c,!1);for(let h=0;h<n.length;h++)n[h]+=l;if(o){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:a},v=r.piece.length+c.length,m=r.piece.lineFeedCnt,I=this.t(0,r.piece.start,d),S=I-m;r.piece=new u(r.piece.bufferIndex,r.piece.start,d,I,v),this.g=d,(0,M.$zB)(this,r,c.length,S)}G(r){let c=this.root;const o=this.h.get(r);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:r-o.nodeStartOffset};let l=0;for(;c!==M.$sB;)if(c.size_left>r)c=c.left;else if(c.size_left+c.piece.length>=r){l+=c.size_left;const n={node:c,remainder:r-c.size_left,nodeStartOffset:l};return this.h.set(n),n}else r-=c.size_left+c.piece.length,l+=c.size_left+c.piece.length,c=c.right;return null}H(r,c){let o=this.root,l=0;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const n=this.B(o,r-o.lf_left-2),s=this.B(o,r-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(n+c-1,s),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const n=this.B(o,r-o.lf_left-2);if(n+c-1<=o.piece.length)return{node:o,remainder:n+c-1,nodeStartOffset:l};c-=o.piece.length-n;break}else r-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$sB;){if(o.piece.lineFeedCnt>0){const n=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(c-1,n),nodeStartOffset:s}}else if(o.piece.length>=c-1){const n=this.J(o);return{node:o,remainder:c-1,nodeStartOffset:n}}else c-=o.piece.length;o=o.next()}return null}I(r,c){if(r.piece.lineFeedCnt<1)return-1;const o=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+c;return o.buffer.charCodeAt(l)}J(r){if(!r)return 0;let c=r.size_left;for(;r!==this.root;)r.parent.right===r&&(c+=r.parent.size_left+r.parent.piece.length),r=r.parent;return c}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$sB||r.piece.lineFeedCnt===0)return!1;const c=r.piece,o=this.a[c.bufferIndex].lineStarts,l=c.start.line,n=o[l]+c.start.column;return l===o.length-1||o[l+1]>n+1?!1:this.a[c.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$sB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const c=r.prev();this.M(c)&&this.P(c,r)}}O(r){if(this.K()&&this.M(r)){const c=r.next();this.L(c)&&this.P(r,c)}}P(r,c){const o=[],l=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,n,a,s),(0,M.$zB)(this,r,-1,-1),r.piece.length===0&&o.push(r);const d={line:c.piece.start.line+1,column:0},v=c.piece.length-1,m=this.t(c.piece.bufferIndex,d,c.piece.end);c.piece=new u(c.piece.bufferIndex,d,c.piece.end,m,v),(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c);const I=this.w(`\r
`);this.S(r,I[0]);for(let S=0;S<o.length;S++)(0,M.$xB)(this,o[S])}Q(r,c){if(this.K()&&this.M(r)){const o=c.next();if(this.L(o)){if(r+=`
`,o.piece.length===1)(0,M.$xB)(this,o);else{const l=o.piece,n={line:l.start.line+1,column:0},s=l.length-1,a=this.t(l.bufferIndex,n,l.end);o.piece=new u(l.bufferIndex,n,l.end,a,s),(0,M.$zB)(this,o,-1,-1)}return!0}}return!1}iterate(r,c){if(r===M.$sB)return c(M.$sB);const o=this.iterate(r.left,c);return o&&c(r)&&this.iterate(r.right,c)}R(r){if(r===M.$sB)return"";const c=this.a[r.piece.bufferIndex],o=r.piece,l=this.u(o.bufferIndex,o.start),n=this.u(o.bufferIndex,o.end);return c.buffer.substring(l,n)}getPieceContent(r){const c=this.a[r.bufferIndex],o=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return c.buffer.substring(o,l)}S(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.right===M.$sB)r.right=o,o.parent=r;else{const n=(0,M.$tB)(r.right);n.left=o,o.parent=n}return(0,M.$yB)(this,o),o}T(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.left===M.$sB)r.left=o,o.parent=r;else{const l=(0,M.$uB)(r.left);l.right=o,o.parent=l}return(0,M.$yB)(this,o),o}U(r){let c="";return this.iterate(r,o=>(c+=this.R(o),!0)),c}}e.$LB=t}),define(Pe[132],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8=e.$u8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$u8=E;class L{constructor(M){this.identifier=M}}e.$v8=L}),define(Pe[133],Ae([9,10]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M extends L.$Rc{constructor(u,b="",p="",g=!0,t){super(),this.h=this.B(new E.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=p,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Ai=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Rd),this.onWillRun=this.f.event,this.m=this.B(new E.$Rd),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,b)}catch(g){p=g}this.m.fire({action:u,error:p})}async u(u,b){await u.run(b)}}e.$Bi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const p of u)p.length&&(b.length?b=[...b,new $,...p]:b=p);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=$;class D{get actions(){return this.a}constructor(u,b,p,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=g,this.a=p}async run(){}}e.$Di=D;class f extends M{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,A.localize(0,null),void 0,!1)}}e.$Ei=f;function P(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...u)=>k.run(...u),tooltip:k.label}}e.$Fi=P}),define(Pe[135],Ae([9,10]),function(be,e){return be.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const L=60,A=L*60,M=A*24,R=M*7,$=M*30,D=M*365;function f(k,u,b,p){typeof k!="number"&&(k=k.getTime());const g=Math.round((new Date().getTime()-k)/1e3);if(g<-30)return(0,E.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,E.localize)(1,null);let t;return g<L?(t=g,u?t===1?b?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):b?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?b?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):b?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):g<A?(t=Math.floor(g/L),u?t===1?b?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):b?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?b?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):b?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):g<M?(t=Math.floor(g/A),u?t===1?b?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):b?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?b?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):b?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):g<R?(t=Math.floor(g/M),u?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):g<$?(t=Math.floor(g/R),u?t===1?b?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):b?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?b?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):b?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):g<D?(t=Math.floor(g/$),u?t===1?b?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):b?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?b?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):b?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(g/D),u?t===1?b?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):b?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?b?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):b?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$jm=f;function P(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=P}),define(Pe[137],Ae([9,10]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Pe[39],Ae([1,0,18,16,137]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(k,u){return u&&(k.stack||k.stacktrace)?A.localize(0,null,$(k),R(k.stack)||R(k.stacktrace)):$(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function $(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?A.localize(1,null,k.message):k.message||A.localize(2,null)}function D(k=null,u=!1){if(!k)return A.localize(3,null);if(Array.isArray(k)){const b=E.$Gb(k),p=D(b[0],u);return b.length>1?A.localize(4,null,p,b.length):p}if(L.$Cf(k))return k;if(k.detail){const b=k.detail;if(b.error)return M(b.error,u);if(b.exception)return M(b.exception,u)}return k.stack?M(k,u):k.message?k.message:A.localize(5,null)}e.$Gi=D;function f(k){const u=k;return u instanceof Error&&Array.isArray(u.actions)}e.$Hi=f;function P(k,u){let b;return typeof k=="string"?b=new Error(k):b=k,b.actions=u,b}e.$Ii=P}),define(Pe[138],Ae([1,0,44,19]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const A=new E.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(S,h,w=!1){const y=S||"",C=h||"",W=A.value.collator.compare(y,C);return A.value.collatorIsNumeric&&W===0&&y!==C?y<C?-1:1:W}e.$nq=$;function D(S,h){const w=M.value.collator;return S=S||"",h=h||"",o(w,S,h)}e.$oq=D;function f(S,h){const w=M.value.collator;return S=S||"",h=h||"",a(S,h)||o(w,S,h)}e.$pq=f;function P(S,h){const w=M.value.collator;return S=S||"",h=h||"",s(S,h)||o(w,S,h)}e.$qq=P;function k(S,h){return S=S||"",h=h||"",S===h?0:S<h?-1:1}e.$rq=k;function u(S,h){const[w,y]=r(S),[C,W]=r(h);let K=A.value.collator.compare(y,W);if(K===0){if(A.value.collatorIsNumeric&&y!==W)return y<W?-1:1;if(K=A.value.collator.compare(w,C),A.value.collatorIsNumeric&&K===0&&w!==C)return w<C?-1:1}return K}e.$sq=u;function b(S,h){S=S||"",h=h||"";const w=c(S),y=c(h),C=M.value.collator,W=R.value.collator;return o(W,w,y)||o(C,S,h)}e.$tq=b;function p(S,h){S=S||"",h=h||"";const w=c(S),y=c(h),C=M.value.collator,W=R.value.collator;return o(W,w,y)||a(S,h)||o(C,S,h)}e.$uq=p;function g(S,h){S=S||"",h=h||"";const w=c(S),y=c(h),C=M.value.collator,W=R.value.collator;return o(W,w,y)||s(S,h)||o(C,S,h)}e.$vq=g;function t(S,h){S=S||"",h=h||"";const w=c(S).toLowerCase(),y=c(h).toLowerCase();return w!==y?w<y?-1:1:S!==h?S<h?-1:1:0}e.$wq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(S,h=!1){const w=S?i.exec(S):[];let y=[w&&w[1]||"",w&&w[3]||""];return h&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function c(S){const h=S?i.exec(S):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function o(S,h,w){const y=S.compare(h,w);return y!==0?y:h.length!==w.length?h.length<w.length?-1:1:0}function l(S){const h=S.charAt(0);return h.toLocaleUpperCase()!==h}function n(S){const h=S.charAt(0);return h.toLocaleLowerCase()!==h}function s(S,h){return l(S)&&n(h)?-1:n(S)&&l(h)?1:0}function a(S,h){return n(S)&&l(h)?-1:l(S)&&n(h)?1:0}function d(S,h,w=!1){return w||(S=S&&S.toLowerCase(),h=h&&h.toLowerCase()),S===h?0:S<h?-1:1}function v(S,h,w=!1){const y=S.split(L.sep),C=h.split(L.sep),W=y.length-1,K=C.length-1;let U,z;for(let F=0;;F++){if(U=W===F,z=K===F,U&&z)return $(y[F],C[F],w);if(U)return-1;if(z)return 1;const O=d(y[F],C[F],w);if(O!==0)return O}}e.$xq=v;function m(S,h,w){const y=S.toLowerCase(),C=h.toLowerCase(),W=I(S,h,w);if(W)return W;const K=y.endsWith(w),U=C.endsWith(w);if(K!==U)return K?-1:1;const z=$(y,C);return z!==0?z:y.localeCompare(C)}e.$yq=m;function I(S,h,w){const y=S.toLowerCase(),C=h.toLowerCase(),W=y.startsWith(w),K=C.startsWith(w);if(W!==K)return W?-1:1;if(W&&K){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}e.$zq=I}),define(Pe[46],Ae([1,0,19,21,12,16]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function R(m){return m===47||m===92}e.$Uf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Vf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Wf=D;function f(m,I=E.$fc.sep){if(!m)return"";const S=m.length,h=m.charCodeAt(0);if(R(h)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let y=3;const C=y;for(;y<S&&!R(m.charCodeAt(y));y++);if(C!==y&&!R(m.charCodeAt(y+1))){for(y+=1;y<S;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(i(h)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<S;w++)if(R(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Xf=f;function P(m){if(!L.$i||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let S=2;const h=S;for(;S<m.length&&(I=m.charCodeAt(S),I!==92);S++);return!(h===S||(I=m.charCodeAt(S+1),isNaN(I)||I===92))}e.$Yf=P;const k=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=L.$i){const S=I?k:u;return!(!m||m.length===0||/^\s+$/.test(m)||(S.lastIndex=0,S.test(m))||I&&b.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Zf=p;function g(m,I,S){const h=m===I;return!S||h?h:!m||!I?!1:(0,A.$6e)(m,I)}e.$1f=g;function t(m,I,S,h=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(S){if(!(0,A.$7e)(m,I))return!1;if(I.length===m.length)return!0;let y=I.length;return I.charAt(I.length-1)===h&&y--,m.charAt(y)===h}return I.charAt(I.length-1)!==h&&(I+=h),m.indexOf(I)===0}e.$2f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$3f=i;function r(m,I){return L.$i&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$i?(m=(0,A.$Oe)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,A.$Oe)(m,E.sep),m||(m=E.sep)),m}e.$4f=r;function c(m){const I=(0,E.$gc)(m);return L.$i?m.length>3?!1:o(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$5f=c;function o(m,I=L.$i){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$6f=o;function l(m,I=L.$i){return o(m,I)?m[0]:void 0}e.$7f=l;function n(m,I,S){return I.length>m.length?-1:m===I?0:(S&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$8f=n;function s(m){const I=m.split(":");let S,h,w;for(const y of I){const C=Number(y);(0,M.$Gf)(C)?h===void 0?h=C:w===void 0&&(w=C):S=S?[S,y].join(":"):y}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$9f=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(m,I,S=8){let h="";for(let y=0;y<S;y++){let C;y===0&&L.$i&&!I&&(S===3||S===4)?C=d:C=a,h+=C.charAt(Math.floor(Math.random()*C.length))}let w;return I?w=`${I}-${h}`:w=h,m?(0,E.$ic)(m,w):w}e.$0f=v}),define(Pe[68],Ae([1,0,19]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=e.$Wr=void 0,e.$Wr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(P){const k=(0,E.$nc)(P),u=L[k.toLowerCase()];return u!==void 0?u:R(P)}e.$Xr=M;function R(P){const k=(0,E.$nc)(P);return A[k.toLowerCase()]}e.$Yr=R;function $(P){for(const k in A)if(A[k]===P)return k}e.$Zr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function f(P,k){const u=D.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:k?void 0:P}e.$1r=f}),define(Pe[51],Ae([1,0,24,2]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function A(D){return JSON.stringify(D,R)}e.$qh=A;function M(D){let f=JSON.parse(D);return f=$(f),f}e.$rh=M;function R(D,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function $(D,f=0){if(!D||f>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$fe||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=$(D[P],f+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=$(D[P],f+1))}return D}e.$sh=$}),define(Pe[13],Ae([1,0,11,21,2]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${M.vscodeRemoteResource}`}set(P,k,u){this.a[P]=k,this.b[P]=u}setConnectionToken(P,k){this.c[P]=k}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return E.$Z(t),P}const k=P.authority;let u=this.a[k];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[k],p=this.c[k];let g=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(g+=`&${e.$_f}=${encodeURIComponent(p)}`),A.URI.from({scheme:L.$o?this.d:M.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:g})}}e.$ag=new R,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class ${static{this.a=e.$fg}asBrowserUri(P){const k=this.b(P,be);return this.uriToBrowserUri(k)}uriToBrowserUri(P){return P.scheme===M.vscodeRemote?e.$ag.rewrite(P):P.scheme===M.file&&(L.$m||L.$q===`${M.vscodeFileResource}://${$.a}`)?P.with({scheme:M.vscodeFileResource,authority:P.authority||$.a,query:null,fragment:null}):P}asFileUri(P){const k=this.b(P,be);return this.uriToFileUri(k)}uriToFileUri(P){return P.scheme===M.vscodeFileResource?P.with({scheme:M.file,authority:P.authority!==$.a?P.authority:null,query:null,fragment:null}):P}b(P,k){return A.URI.isUri(P)?P:A.URI.parse(k.toUrl(P))}}e.$gg=new $;var D;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const k="vscode-coi";function u(p){let g;typeof p=="string"?g=new URL(p).searchParams:p instanceof URL?g=p.searchParams:A.URI.isUri(p)&&(g=new URL(p.toString(!0)).searchParams);const t=g?.get(k);if(t)return P.get(t)}f.getHeadersFromQuery=u;function b(p,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(k,i):p[k]=i}f.addSearchParam=b})(D||(e.COI=D={}))}),define(Pe[25],Ae([1,0,46,13,19,21,12,2]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function D(b){return(0,$.$vc)(b,!0)}e.$ng=D;class f{constructor(p){this.a=p}compare(p,g,t=!1){return p===g?0:(0,R.$Ye)(this.getComparisonKey(p,t),this.getComparisonKey(g,t))}isEqual(p,g,t=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,t)===this.getComparisonKey(g,t)}getComparisonKey(p,g=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,g,t=!1){if(p.scheme===g.scheme){if(p.scheme===L.Schemas.file)return E.$2f(D(p),D(g),this.a(p))&&p.query===g.query&&(t||p.fragment===g.fragment);if((0,e.$Eg)(p.authority,g.authority))return E.$2f(p.path,g.path,this.a(p),"/")&&p.query===g.query&&(t||p.fragment===g.fragment)}return!1}joinPath(p,...g){return $.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.$wg)(p)||p.authority}basename(p){return A.$fc.basename(p.path)}extname(p){return A.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===L.Schemas.file?g=$.URI.file(A.$lc(D(p))).path:(g=A.$fc.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===L.Schemas.file?g=$.URI.file(A.$gc(D(p))).path:g=A.$fc.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.$Eg)(p.authority,g.authority))return;if(p.scheme===L.Schemas.file){const r=A.$kc(D(p),D(g));return M.$i?E.$Vf(r):r}let t=p.path||"/";const i=g.path||"/";if(this.a(p)){let r=0;for(const c=Math.min(t.length,i.length);r<c&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return A.$fc.relative(t,i)}resolvePath(p,g){if(p.scheme===L.Schemas.file){const t=$.URI.file(A.$jc(D(p),g));return p.with({authority:t.authority,path:t.path})}return g=E.$Wf(g),p.with({path:A.$fc.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,R.$6e)(p,g)}hasTrailingPathSeparator(p,g=A.sep){if(p.scheme===L.Schemas.file){const t=D(p);return t.length>E.$Xf(t).length&&t[t.length-1]===g}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=A.sep){return(0,e.$Fg)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=A.sep){let t=!1;if(p.scheme===L.Schemas.file){const i=D(p);t=i!==void 0&&i.length===E.$Xf(i).length&&i[i.length-1]===g}else{g="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Fg)(p,g)?p.with({path:p.path+"/"}):p}}e.$og=f,e.$pg=new f(()=>!1),e.$qg=new f(b=>b.scheme===L.Schemas.file?!M.$k:!0),e.$rg=new f(b=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function P(b,p){const g=[];for(let t=0;t<b.length;t++){const i=p(b[t]);b.some((r,c)=>c===t?!1:(0,e.$tg)(i,p(r)))||g.push(b[t])}return g}e.$Ig=P;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,l]=c.split(":");o&&l&&t.set(o,l)});const r=g.path.substring(0,g.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=p})(k||(e.DataUri=k={}));function u(b,p,g){if(p){let t=b.path;return t&&t[0]!==A.$fc.sep&&(t=A.$fc.sep+t),b.with({scheme:g,authority:p,path:t})}return b.with({scheme:g})}e.$Jg=u}),define(Pe[14],Ae([1,0,20,11,5,6,25,21,124]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function f(me){return!!me&&typeof me.then=="function"}e.$Kg=f;function P(me){const ne=new E.$2d,le=me(ne.token),ce=new Promise((we,_)=>{const he=ne.token.onCancellationRequested(()=>{he.dispose(),ne.dispose(),_(new L.$4)});Promise.resolve(le).then(te=>{he.dispose(),ne.dispose(),we(te)},te=>{he.dispose(),ne.dispose(),_(te)})});return new class{cancel(){ne.cancel()}then(we,_){return ce.then(we,_)}catch(we){return this.then(void 0,we)}finally(we){return ce.finally(we)}}}e.$Lg=P;function k(me,ne,le){return new Promise((ce,we)=>{const _=ne.onCancellationRequested(()=>{_.dispose(),ce(le)});me.then(ce,we).finally(()=>_.dispose())})}e.$Mg=k;function u(me,ne){return new Promise((le,ce)=>{const we=ne.onCancellationRequested(()=>{we.dispose(),ce(new L.$4)});me.then(le,ce).finally(()=>we.dispose())})}e.$Ng=u;async function b(me){let ne=-1;const le=me.map((ce,we)=>ce.then(_=>(ne=we,_)));try{return await Promise.race(le)}finally{me.forEach((ce,we)=>{we!==ne&&ce.cancel()})}}e.$Og=b;function p(me,ne,le){let ce;const we=setTimeout(()=>{ce?.(void 0),le?.()},ne);return Promise.race([me.finally(()=>clearTimeout(we)),new Promise(_=>ce=_)])}e.$Pg=p;function g(me){return new Promise((ne,le)=>{const ce=me();f(ce)?ce.then(ne,le):ne(ce)})}e.$Qg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ne){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ne,!this.b){const le=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(le,le).then(ce)})}return new Promise((le,ce)=>{this.b.then(le,ce)})}return this.a=ne(),new Promise((le,ce)=>{this.a.then(we=>{this.a=null,le(we)},we=>{this.a=null,ce(we)})})}dispose(){this.f=!0}}e.$Rg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ne){return this.a=this.a.then(()=>ne(),()=>ne())}}e.$Sg=i;class r{constructor(){this.a=new Map}queue(ne,le){const we=(this.a.get(ne)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(ne)===we&&this.a.delete(ne)});return this.a.set(ne,we),we}}e.$Tg=r;const c=(me,ne)=>{let le=!0;const ce=setTimeout(()=>{le=!1,ne()},me);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ce),le=!1}}},o=me=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,me())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class l{constructor(ne){this.defaultDelay=ne,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ne,le=this.defaultDelay){this.g=ne,this.h(),this.b||(this.b=new Promise((we,_)=>{this.d=we,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=le===D.$Od?o(ce):c(le,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=l;class n{constructor(ne){this.a=new l(ne),this.b=new t}trigger(ne,le){return this.a.trigger(()=>this.b.queue(ne),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=n;class s{constructor(){this.a=!1,this.b=new Promise((ne,le)=>{this.d=ne})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class a extends s{constructor(ne){super(),this.f=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this.f),super.open()}}e.$Xg=a;function d(me,ne){return ne?new Promise((le,ce)=>{const we=setTimeout(()=>{_.dispose(),le()},me),_=ne.onCancellationRequested(()=>{clearTimeout(we),_.dispose(),ce(new L.$4)})}):P(le=>d(me,le))}e.$Yg=d;function v(me,ne=0,le){const ce=setTimeout(()=>{me(),le&&we.dispose()},ne),we=(0,M.$Pc)(()=>{clearTimeout(ce),le?.deleteAndLeak(we)});return le?.add(we),we}e.$Zg=v;function m(me){const ne=[];let le=0;const ce=me.length;function we(){return le<ce?me[le++]():null}function _(he){he!=null&&ne.push(he);const te=we();return te?te.then(_):Promise.resolve(ne)}return Promise.resolve(null).then(_)}e.$1g=m;function I(me,ne=ce=>!!ce,le=null){let ce=0;const we=me.length,_=()=>{if(ce>=we)return Promise.resolve(le);const he=me[ce++];return Promise.resolve(he()).then(ae=>ne(ae)?Promise.resolve(ae):_())};return _()}e.$2g=I;function S(me,ne=ce=>!!ce,le=null){if(me.length===0)return Promise.resolve(le);let ce=me.length;const we=()=>{ce=-1;for(const _ of me)_.cancel?.()};return new Promise((_,he)=>{for(const te of me)te.then(ae=>{--ce>=0&&ne(ae)?(we(),_(ae)):ce===0&&_(le)}).catch(ae=>{--ce>=0&&(we(),he(ae))})})}e.$3g=S;class h{constructor(ne){this.a=0,this.d=ne,this.f=[],this.b=0,this.g=new A.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ne){return this.a++,new Promise((le,ce)=>{this.f.push({factory:ne,c:le,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ne=this.f.shift();this.b++;const le=ne.factory();le.then(ne.c,ne.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=h;class w extends h{constructor(){super(1)}}e.$5g=w;class y{constructor(){this.a=new De,this.b=0}queue(ne){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ne())):this.a.run(this.b++,ne())}}e.$6g=y;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ne=new pe;return this.b.add(ne),ne.p}g(){for(const[,ne]of this.a)if(ne.size>0)return!1;return!0}queueFor(ne,le=R.$pg){const ce=le.getComparisonKey(ne);let we=this.a.get(ce);if(!we){we=new w;const _=this.f++,he=A.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(_,he),this.a.set(ce,we)}return we}h(){this.g()&&this.j()}j(){for(const ne of this.b)ne.complete();this.b.clear()}dispose(){for(const[,ne]of this.a)ne.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=C;class W{constructor(ne,le){this.a=-1,typeof ne=="function"&&typeof le=="number"&&this.setIfNotSet(ne,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ne,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ne()},le)}setIfNotSet(ne,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ne()},le))}}e.$8g=W;class K{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ne,le,ce=globalThis){this.cancel();const we=ce.setInterval(()=>{ne()},le);this.d=(0,M.$Pc)(()=>{ce.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$9g=K;class U{constructor(ne,le){this.b=-1,this.a=ne,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ne=this.d){this.cancel(),this.b=setTimeout(this.f,ne)}get delay(){return this.d}set delay(ne){this.d=ne}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=U;class z{constructor(ne,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=ne,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ne=this.b){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ne/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=z;class F extends U{constructor(ne,le){super(ne,le),this.j=[]}work(ne){this.j.push(ne),this.isScheduled()||this.schedule()}h(){const ne=this.j;this.j=[],this.a?.(ne)}dispose(){this.j=[],super.dispose()}}e.$_g=F;class O extends M.$Rc{constructor(ne,le){super(),this.g=ne,this.h=le,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ne){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ne.length>this.g.maxBufferedWork)return!1}else if(this.pending+ne.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of ne)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(me,ne)=>{(0,$.$B)(()=>{if(le)return;const ce=Date.now()+15;ne(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.$ch=(me,ne,le)=>{const ce=me.requestIdleCallback(ne,typeof le=="number"?{timeout:le}:void 0);let we=!1;return{dispose(){we||(we=!0,me.cancelIdleCallback(ce))}}},e.$bh=me=>(0,e.$ch)(globalThis,me)}();class X{constructor(ne,le){this.g=!1,this.d=()=>{try{this.j=le()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ch)(ne,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=X;class $e extends X{constructor(ne){super(globalThis,ne)}}e.$eh=$e;async function Ee(me,ne,le){let ce;for(let we=0;we<le;we++)try{return await me()}catch(_){ce=_,await d(ne)}throw ce}e.$fh=Ee;class De{isRunning(ne){return typeof ne=="number"?this.a?.taskId===ne:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ne,le,ce){return this.a={taskId:ne,cancel:()=>ce?.(),promise:le},le.then(()=>this.d(ne),()=>this.d(ne)),le}d(ne){this.a&&ne===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ne=this.b;this.b=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}queue(ne){if(this.b)this.b.run=ne;else{let le,ce;const we=new Promise((_,he)=>{le=_,ce=he});this.b={run:ne,promise:we,promiseResolve:le,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=De;class Ce{constructor(ne,le=()=>Date.now()){this.d=ne,this.f=le,this.a=0,this.b=0}increment(){const ne=this.f();return ne-this.a>this.d&&(this.a=ne,this.b=0),this.b++,this.b}}e.$hh=Ce;var de;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(de||(de={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ne,le)=>{this.a=ne,this.b=le})}complete(ne){return new Promise(le=>{this.a(ne),this.d={outcome:0,value:ne},le()})}error(ne){return new Promise(le=>{this.b(ne),this.d={outcome:1,value:ne},le()})}cancel(){return this.error(new L.$4)}}e.$ih=pe;var re;(function(me){async function ne(ce){let we;const _=await Promise.all(ce.map(he=>he.then(te=>te,te=>{we||(we=te)})));if(typeof we<"u")throw we;return _}me.settled=ne;function le(ce){return new Promise(async(we,_)=>{try{await ce(we,_)}catch(he){_(he)}})}me.withAsyncBody=le})(re||(e.Promises=re={}));var Re;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(Re||(Re={}));class se{static fromArray(ne){return new se(le=>{le.emitMany(ne)})}static fromPromise(ne){return new se(async le=>{le.emitMany(await ne)})}static fromPromises(ne){return new se(async le=>{await Promise.all(ne.map(async ce=>le.emitOne(await ce)))})}static merge(ne){return new se(async le=>{await Promise.all(ne.map(async ce=>{for await(const we of ce)le.emitOne(we)}))})}static{this.EMPTY=se.fromArray([])}constructor(ne){this.a=0,this.b=[],this.d=null,this.f=new A.$Rd,queueMicrotask(async()=>{const le={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(ne(le)),this.j()}catch(ce){this.k(ce)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ne<this.b.length)return{done:!1,value:this.b[ne++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(ne,le){return new se(async ce=>{for await(const we of ne)ce.emitOne(le(we))})}map(ne){return se.map(this,ne)}static filter(ne,le){return new se(async ce=>{for await(const we of ne)le(we)&&ce.emitOne(we)})}filter(ne){return se.filter(this,ne)}static coalesce(ne){return se.filter(ne,le=>!!le)}coalesce(){return se.coalesce(this)}static async toPromise(ne){const le=[];for await(const ce of ne)le.push(ce);return le}toPromise(){return se.toPromise(this)}g(ne){this.a===0&&(this.b.push(ne),this.f.fire())}h(ne){this.a===0&&(this.b=this.b.concat(ne),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ne){this.a===0&&(this.a=2,this.d=ne,this.f.fire())}}e.$jh=se;class Y extends se{constructor(ne,le){super(le),this.l=ne}cancel(){this.l.cancel()}}e.$kh=Y;function B(me){const ne=new E.$2d,le=me(ne.token);return new Y(ne,async ce=>{const we=ne.token.onCancellationRequested(()=>{we.dispose(),ne.dispose(),ce.reject(new L.$4)});try{for await(const _ of le){if(ne.token.isCancellationRequested)return;ce.emitOne(_)}we.dispose(),ne.dispose()}catch(_){we.dispose(),ne.dispose(),ce.reject(_)}})}e.$lh=B;class ie{constructor(){this.a=new pe,this.b=new se(ce=>{if(ne){ce.reject(ne);return}return le&&ce.emitMany(le),this.d=we=>ce.reject(we),this.f=we=>ce.emitOne(we),this.a.p});let ne,le;this.f=ce=>{le||(le=[]),le.push(ce)},this.d=ce=>{ne||(ne=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ne){this.d(ne),this.a.complete()}emitOne(ne){this.f(ne)}}e.$mh=ie}),define(Pe[33],Ae([1,0,18,14,46,28,19,21,12]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function f(){return Object.create(null)}e.$xj=f,e.$yj="**",e.$zj="/";const P="[/\\\\]",k="[^/\\\\]",u=/\//g;function b(Ee,De){switch(Ee){case 0:return"";case 1:return`${k}*?`;default:return`(?:${P}|${k}+${P}${De?`|${P}${k}+`:""})*?`}}function p(Ee,De){if(!Ee)return[];const Ce=[];let de=!1,pe=!1,re="";for(const Re of Ee){switch(Re){case De:if(!de&&!pe){Ce.push(re),re="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}re+=Re}return re&&Ce.push(re),Ce}e.$Aj=p;function g(Ee){if(!Ee)return"";let De="";const Ce=p(Ee,e.$zj);if(Ce.every(de=>de===e.$yj))De=".*";else{let de=!1;Ce.forEach((pe,re)=>{if(pe===e.$yj){if(de)return;De+=b(2,re===Ce.length-1)}else{let Re=!1,se="",Y=!1,B="";for(const ie of pe){if(ie!=="}"&&Re){se+=ie;continue}if(Y&&(ie!=="]"||!B)){let me;ie==="-"?me=ie:(ie==="^"||ie==="!")&&!B?me="^":ie===e.$zj?me="":me=(0,D.$Je)(ie),B+=me;continue}switch(ie){case"{":Re=!0;continue;case"[":Y=!0;continue;case"}":{const ne=`(?:${p(se,",").map(le=>g(le)).join("|")})`;De+=ne,Re=!1,se="";break}case"]":{De+="["+B+"]",Y=!1,B="";break}case"?":De+=k;continue;case"*":De+=b(1);continue;default:De+=(0,D.$Je)(ie)}}re<Ce.length-1&&(Ce[re+1]!==e.$yj||re+2<Ce.length)&&(De+=P)}de=pe===e.$yj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},a=function(){return null};function d(Ee,De){if(!Ee)return a;let Ce;typeof Ee!="string"?Ce=Ee.pattern:Ce=Ee,Ce=Ce.trim();const de=`${Ce}_${!!De.trimForExclusions}`;let pe=n.get(de);if(pe)return v(pe,Ee);let re;return t.test(Ce)?pe=I(Ce.substr(4),Ce):(re=i.exec(m(Ce,De)))?pe=S(re[1],Ce):(De.trimForExclusions?c:r).test(Ce)?pe=h(Ce,De):(re=o.exec(m(Ce,De)))?pe=w(re[1].substr(1),Ce,!0):(re=l.exec(m(Ce,De)))?pe=w(re[1],Ce,!1):pe=y(Ce),n.set(de,pe),v(pe,Ee)}function v(Ee,De){if(typeof De=="string")return Ee;const Ce=function(de,pe){return(0,A.$2f)(de,De.base,!$.$k)?Ee((0,D.$Ne)(de.substr(De.base.length),R.sep),pe):null};return Ce.allBasenames=Ee.allBasenames,Ce.allPaths=Ee.allPaths,Ce.basenames=Ee.basenames,Ce.patterns=Ee.patterns,Ce}function m(Ee,De){return De.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,De){return function(Ce,de){return typeof Ce=="string"&&Ce.endsWith(Ee)?De:null}}function S(Ee,De){const Ce=`/${Ee}`,de=`\\${Ee}`,pe=function(Re,se){return typeof Re!="string"?null:se?se===Ee?De:null:Re===Ee||Re.endsWith(Ce)||Re.endsWith(de)?De:null},re=[Ee];return pe.basenames=re,pe.patterns=[De],pe.allBasenames=re,pe}function h(Ee,De){const Ce=X(Ee.slice(1,-1).split(",").map(se=>d(se,De)).filter(se=>se!==a),Ee),de=Ce.length;if(!de)return a;if(de===1)return Ce[0];const pe=function(se,Y){for(let B=0,ie=Ce.length;B<ie;B++)if(Ce[B](se,Y))return Ee;return null},re=Ce.find(se=>!!se.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Re=Ce.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return Re.length&&(pe.allPaths=Re),pe}function w(Ee,De,Ce){const de=R.sep===R.$fc.sep,pe=de?Ee:Ee.replace(u,R.sep),re=R.sep+pe,Re=R.$fc.sep+Ee;let se;return Ce?se=function(Y,B){return typeof Y=="string"&&(Y===pe||Y.endsWith(re)||!de&&(Y===Ee||Y.endsWith(Re)))?De:null}:se=function(Y,B){return typeof Y=="string"&&(Y===pe||!de&&Y===Ee)?De:null},se.allPaths=[(Ce?"*/":"./")+Ee],se}function y(Ee){try{const De=new RegExp(`^${g(Ee)}$`);return function(Ce){return De.lastIndex=0,typeof Ce=="string"&&De.test(Ce)?Ee:null}}catch{return a}}function C(Ee,De,Ce){return!Ee||typeof De!="string"?!1:W(Ee)(De,void 0,Ce)}e.$Bj=C;function W(Ee,De={}){if(!Ee)return s;if(typeof Ee=="string"||K(Ee)){const Ce=d(Ee,De);if(Ce===a)return s;const de=function(pe,re){return!!Ce(pe,re)};return Ce.allBasenames&&(de.allBasenames=Ce.allBasenames),Ce.allPaths&&(de.allPaths=Ce.allPaths),de}return F(Ee,De)}e.$Cj=W;function K(Ee){const De=Ee;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Dj=K;function U(Ee){return Ee.allBasenames||[]}e.$Ej=U;function z(Ee){return Ee.allPaths||[]}e.$Fj=z;function F(Ee,De){const Ce=X(Object.getOwnPropertyNames(Ee).map(se=>O(se,Ee[se],De)).filter(se=>se!==a)),de=Ce.length;if(!de)return a;if(!Ce.some(se=>!!se.requiresSiblings)){if(de===1)return Ce[0];const se=function(ie,me){let ne;for(let le=0,ce=Ce.length;le<ce;le++){const we=Ce[le](ie,me);if(typeof we=="string")return we;(0,L.$Kg)(we)&&(ne||(ne=[]),ne.push(we))}return ne?(async()=>{for(const le of ne){const ce=await le;if(typeof ce=="string")return ce}return null})():null},Y=Ce.find(ie=>!!ie.allBasenames);Y&&(se.allBasenames=Y.allBasenames);const B=Ce.reduce((ie,me)=>me.allPaths?ie.concat(me.allPaths):ie,[]);return B.length&&(se.allPaths=B),se}const pe=function(se,Y,B){let ie,me;for(let ne=0,le=Ce.length;ne<le;ne++){const ce=Ce[ne];ce.requiresSiblings&&B&&(Y||(Y=(0,R.$mc)(se)),ie||(ie=Y.substr(0,Y.length-(0,R.$nc)(se).length)));const we=ce(se,Y,ie,B);if(typeof we=="string")return we;(0,L.$Kg)(we)&&(me||(me=[]),me.push(we))}return me?(async()=>{for(const ne of me){const le=await ne;if(typeof le=="string")return le}return null})():null},re=Ce.find(se=>!!se.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Re=Ce.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return Re.length&&(pe.allPaths=Re),pe}function O(Ee,De,Ce){if(De===!1)return a;const de=d(Ee,Ce);if(de===a)return a;if(typeof De=="boolean")return de;if(De){const pe=De.when;if(typeof pe=="string"){const re=(Re,se,Y,B)=>{if(!B||!de(Re,se))return null;const ie=pe.replace("$(basename)",()=>Y),me=B(ie);return(0,L.$Kg)(me)?me.then(ne=>ne?Ee:null):me?Ee:null};return re.requiresSiblings=!0,re}}return de}function X(Ee,De){const Ce=Ee.filter(se=>!!se.basenames);if(Ce.length<2)return Ee;const de=Ce.reduce((se,Y)=>{const B=Y.basenames;return B?se.concat(B):se},[]);let pe;if(De){pe=[];for(let se=0,Y=de.length;se<Y;se++)pe.push(De)}else pe=Ce.reduce((se,Y)=>{const B=Y.patterns;return B?se.concat(B):se},[]);const re=function(se,Y){if(typeof se!="string")return null;if(!Y){let ie;for(ie=se.length;ie>0;ie--){const me=se.charCodeAt(ie-1);if(me===47||me===92)break}Y=se.substr(ie)}const B=de.indexOf(Y);return B!==-1?pe[B]:null};re.basenames=de,re.patterns=pe,re.allBasenames=de;const Re=Ee.filter(se=>!se.basenames);return Re.push(re),Re}function $e(Ee,De){return(0,E.$tb)(Ee,De,(Ce,de)=>typeof Ce=="string"&&typeof de=="string"?Ce===de:typeof Ce!="string"&&typeof de!="string"?Ce.base===de.base&&Ce.pattern===de.pattern:!1)}e.$Gj=$e}),define(Pe[52],Ae([1,0,11,125,25,12,2]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=u(this.supportThemeIcons?(0,L.$3j)(i):i).replace(/([ \t]+)/g,(c,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,r){const c=new RegExp((0,M.$Je)(r),"g");return i.replace(c,(o,l)=>i.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9j=D;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$0j=f;function P(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$$j=P;function k(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,A.$sg)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$_j=k;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=u;function b(t){return t.replace(/"/g,"&quot;")}e.$bk=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=p;function g(t){const i=[],r=t.split("|").map(o=>o.trim());t=r[0];const c=r[1];if(c){const o=/height=(\d+)/.exec(c),l=/width=(\d+)/.exec(c),n=o?o[1]:"",s=l?l[1]:"",a=isFinite(parseInt(s)),d=isFinite(parseInt(n));a&&i.push(`width="${s}"`),d&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$dk=g}),define(Pe[94],Ae([1,0,18,46,19,21,25,12]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function D(d,v){const{os:m,tildify:I,relative:S}=v;if(S){const y=f(d,S,m);if(typeof y=="string")return y}let h=d.fsPath;if(m===1&&!M.$i?h=h.replace(/\//g,"\\"):m!==1&&M.$i&&(h=h.replace(/\\/g,"/")),m!==1&&I?.userHome){const y=I.userHome.fsPath;let C;d.scheme!==I.userHome.scheme&&d.path[0]===A.$fc.sep&&d.path[1]!==A.$fc.sep?C=I.userHome.with({path:d.path}).fsPath:C=h,h=u(C,y,m)}return(m===1?A.$ec:A.$fc).normalize(P(h,m===1))}e.$yv=D;function f(d,v,m){const I=m===1?A.$ec:A.$fc,S=m===3?R.$pg:R.$rg,h=v.getWorkspace(),w=(0,E.$Nb)(h.folders);if(!w)return;d.scheme!==w.uri.scheme&&d.path[0]===A.$fc.sep&&d.path[1]!==A.$fc.sep&&(d=w.uri.with({path:d.path}));const y=v.getWorkspaceFolder(d);if(!y)return;let C;if(S.isEqual(y.uri,d)?C="":C=S.relativePath(y.uri,d)??"",C&&(C=I.normalize(C)),h.folders.length>1&&!v.noPrefix){const W=y.name?y.name:S.basenameOrAuthority(y.uri);C=C?`${W} \u2022 ${C}`:W}return C}function P(d,v=M.$i){return(0,L.$6f)(d,v)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$zv=P;let k=Object.create(null);function u(d,v,m=M.OS){if(m===1||!d||!v)return d;let I=k.original===v?k.normalized:void 0;I||(I=v,M.$i&&(I=(0,L.$Vf)(I)),I=`${(0,$.$Oe)(I,A.$fc.sep)}${A.$fc.sep}`,k={original:v,normalized:I});let S=d;return M.$i&&(S=(0,L.$Vf)(S)),(m===3?S.startsWith(I):(0,$.$7e)(S,I))?`~/${S.substr(I.length)}`:d}e.$Av=u;function b(d,v){return d.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Bv=b;const p="\u2026",g="\\\\",t="~";function i(d,v=A.sep){const m=new Array(d.length);let I=!1;for(let S=0;S<d.length;S++){const h=d[S];if(h===""){m[S]=`.${v}`;continue}if(!h){m[S]=h;continue}I=!0;let w="",y=h;y.indexOf(g)===0?(w=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length)):y.indexOf(v)===0?(w=y.substr(0,y.indexOf(v)+v.length),y=y.substr(y.indexOf(v)+v.length)):y.indexOf(t)===0&&(w=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(v);for(let W=1;I&&W<=C.length;W++)for(let K=C.length-W;I&&K>=0;K--){I=!1;let U=C.slice(K,K+W).join(v);for(let z=0;!I&&z<d.length;z++)if(z!==S&&d[z]&&d[z].indexOf(U)>-1){const F=K+W===C.length,O=K>0&&d[z].indexOf(v)>-1?v+U:U,X=d[z].endsWith(O);I=!F||X}if(!I){let z="";(C[0].endsWith(":")||w!=="")&&(K===1&&(K=0,W++,U=C[0]+v+U),K>0&&(z=C[0]+v),z=w+z),K>0&&(z=z+p+v),z=z+U,K+W<C.length&&(z=z+v+p),m[S]=z}}I&&(m[S]=h)}return m}e.$Cv=i;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(d,v=Object.create(null)){const m=[];let I=!1,S="";for(const h of d)if(h==="$"||I&&h==="{")S&&m.push({value:S,type:r.TEXT}),S="",I=!0;else if(h==="}"&&I){const w=v[S];if(typeof w=="string")w.length&&m.push({value:w,type:r.VARIABLE});else if(w){const y=m[m.length-1];(!y||y.type!==r.SEPARATOR)&&m.push({value:w.label,type:r.SEPARATOR})}S="",I=!1}else S+=h;return S&&!I&&m.push({value:S,type:r.TEXT}),m.filter((h,w)=>{if(h.type===r.SEPARATOR){const y=m[w-1],C=m[w+1];return[y,C].every(W=>W&&(W.type===r.VARIABLE||W.type===r.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Dv=c;function o(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Ev=o;function l(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,m=>m==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Fv=l;function n(d){return d.replace(/&/g,"&&")}e.$Gv=n;function s(d){if(d.endsWith("]")){const v=d.lastIndexOf(" [",d.length-2);if(v!==-1){const m=a(d.substring(0,v));return{name:m.name,parentPath:m.parentPath+d.substring(v)}}}return a(d)}e.$Hv=s;function a(d){const v=d.indexOf("/")!==-1?A.$fc:A.$ec,m=v.basename(d),I=v.dirname(d);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function A(k){return k.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:A(L.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:A(L.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:L.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Rm=M,e.$Sm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,u,b){if(!k||b>200)return null;if(typeof k=="object"){if(k instanceof L.URI)return u.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const g=R(k[p],u,b+1);g!==null&&(k[p]=g)}}return null}function $(k,u){const b=R(k,u,0);return b===null?k:b}e.$Tm=$;function D(k,u,b,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return b?L.URI.revive(u.transformIncoming(k)):u.transformIncoming(k);if(k instanceof E.$fe)return null;for(const g in k)if(Object.hasOwnProperty.call(k,g)){const t=D(k[g],u,b,p+1);t!==null&&(k[g]=t)}}return null}function f(k,u){const b=D(k,u,!1,0);return b===null?k:b}e.$Um=f;function P(k,u){const b=D(k,u,!0,0);return b===null?k:b}e.$Vm=P}),define(Pe[140],Ae([1,0,12,21,24]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let f;function P(){return f||(f=L.$D()?R():D()),f}e.$Ss=P;function k(p,g,t){const i=new Uint16Array(p.buffer,g,t);return t>0&&(i[0]===65279||i[0]===65534)?u(p,g,t):R().decode(i)}e.$Ts=k;function u(p,g,t){const i=[];let r=0;for(let c=0;c<t;c++){const o=A.$he(p,g);g+=2,i[r++]=String.fromCharCode(o)}return i.join("")}class b{constructor(g){this.a=g|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const g=new Uint16Array(this.b.buffer,0,this.d);return P().decode(g)}f(){const g=this.e();this.d=0,this.c===null?this.c=[g]:this.c[this.c.length]=g}appendCharCode(g){const t=this.a-this.d;t<=1&&(t===0||E.$0e(g))&&this.f(),this.b[this.d++]=g}appendASCIICharCode(g){this.d===this.a&&this.f(),this.b[this.d++]=g}appendString(g){const t=g.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=g;return}for(let i=0;i<t;i++)this.b[this.d++]=g.charCodeAt(i)}}e.$Us=b}),define(Pe[141],Ae([1,0,24,140]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0;function A(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(f,P,k,u){this.oldPosition=f,this.oldText=P,this.newPosition=k,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(f){return 4+2*f.length}static c(f,P,k){const u=P.length;E.$ke(f,u,k),k+=4;for(let b=0;b<u;b++)E.$ie(f,P.charCodeAt(b),k),k+=2;return k}static d(f,P){const k=E.$je(f,P);return P+=4,(0,L.$Ts)(f,P,k)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(f,P){return E.$ke(f,this.oldPosition,P),P+=4,E.$ke(f,this.newPosition,P),P+=4,P=M.c(f,this.oldText,P),P=M.c(f,this.newText,P),P}static read(f,P,k){const u=E.$je(f,P);P+=4;const b=E.$je(f,P);P+=4;const p=M.d(f,P);P+=M.a(p);const g=M.d(f,P);return P+=M.a(g),k.push(new M(u,p,b,g)),P}}e.$Vs=M;function R(D,f){return D===null||D.length===0?f:new $(D,f).compress()}e.$Ws=R;class ${constructor(f,P){this.a=f,this.c=P,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let f=0,P=0,k=this.n(f),u=this.l(P);for(;f<this.f||P<this.h;){if(k===null){this.k(u),u=this.l(++P);continue}if(u===null){this.m(k),k=this.n(++f);continue}if(u.oldEnd<=k.newPosition){this.k(u),u=this.l(++P);continue}if(k.newEnd<=u.oldPosition){this.m(k),k=this.n(++f);continue}if(u.oldPosition<k.newPosition){const[i,r]=$.r(u,k.newPosition-u.oldPosition);this.k(i),u=r;continue}if(k.newPosition<u.oldPosition){const[i,r]=$.q(k,u.oldPosition-k.newPosition);this.m(i),k=r;continue}let g,t;if(u.oldEnd===k.newEnd)g=k,t=u,k=this.n(++f),u=this.l(++P);else if(u.oldEnd<k.newEnd){const[i,r]=$.q(k,u.oldLength);g=i,t=u,k=r,u=this.l(++P)}else{const[i,r]=$.r(u,k.newLength);g=k,t=i,k=this.n(++f),u=r}this.d[this.e++]=new M(g.oldPosition,g.oldText,t.newPosition,t.newText),this.g+=g.newLength-g.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(f){this.d[this.e++]=$.o(this.g,f),this.j+=f.newLength-f.oldLength}l(f){return f<this.h?this.c[f]:null}m(f){this.d[this.e++]=$.p(this.j,f),this.g+=f.newLength-f.oldLength}n(f){return f<this.f?this.a[f]:null}static o(f,P){return new M(P.oldPosition-f,P.oldText,P.newPosition,P.newText)}static p(f,P){return new M(P.oldPosition,P.oldText,P.newPosition+f,P.newText)}static q(f,P){const k=f.newText.substr(0,P),u=f.newText.substr(P);return[new M(f.oldPosition,f.oldText,f.newPosition,k),new M(f.oldEnd,"",f.newPosition+P,u)]}static r(f,P){const k=f.oldText.substr(0,P),u=f.oldText.substr(P);return[new M(f.oldPosition,k,f.newPosition,f.newText),new M(f.oldPosition+P,u,f.newEnd,"")]}static s(f){if(f.length===0)return f;const P=[];let k=0,u=f[0];for(let b=1;b<f.length;b++){const p=f[b];u.oldEnd===p.oldPosition?u=new M(u.oldPosition,u.oldText+p.oldText,u.newPosition,u.newText+p.newText):(P[k++]=u,u=p)}return P[k++]=u,P}static t(f){if(f.length===0)return f;const P=[];let k=0;for(let u=0;u<f.length;u++){const b=f[u];b.oldText!==b.newText&&(P[k++]=b)}return P}}}),define(Pe[142],Ae([1,0,33,19]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function A(M,R,$,D,f,P){if(Array.isArray(M)){let k=0;for(const u of M){const b=A(u,R,$,D,f,P);if(b===10)return b;b>k&&(k=b)}return k}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:k,pattern:u,scheme:b,hasAccessToAllModels:p,notebookType:g}=M;if(!D&&!p)return 0;g&&f&&(R=f);let t=0;if(b)if(b===R.scheme)t=10;else if(b==="*")t=5;else return 0;if(k)if(k===$)t=10;else if(k==="*")t=Math.max(t,5);else return 0;if(g)if(g===P)t=10;else if(g==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,L.$gc)(u.base)},i===R.fsPath||(0,E.$Bj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$LE=A}),define(Pe[143],Ae([1,0,5,12,29,92,91,127,141,6]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class P extends f.$Rc{constructor(u,b,p,g,t,i,r){super(),this.m=this.B(new E.$Rd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=g,this.h=t,this.c=new R.$LB(u,p,r)}equals(u){return!(u instanceof P)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const p=u+b,g=this.getPositionAt(u),t=this.getPositionAt(p);return new A.$As(g.lineNumber,g.column,t.lineNumber,t.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const p=this.n(b);return this.c.getValueInRange(u,p)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const p=this.getOffsetAt(u.startLineNumber,u.startColumn),g=this.getOffsetAt(u.endLineNumber,u.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const c=i.length-r.length,o=u.endLineNumber-u.startLineNumber;t=c*o}return g-p+t}getCharacterCountInRange(u,b=0){if(this.j){let p=0;const g=u.startLineNumber,t=u.endLineNumber;for(let i=g;i<=t;i++){const r=this.getLineContent(i),c=i===g?u.startColumn-1:0,o=i===t?u.endColumn-1:r.length;for(let l=c;l<o;l++)L.$0e(r.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(b).length*(t-g),p}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=L.$Ue(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=L.$We(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,p){let g=this.g,t=this.h,i=this.j,r=!0,c=[];for(let v=0;v<u.length;v++){const m=u[v];r&&m._isTracked&&(r=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$if(m.text),i=C),!g&&C&&(g=L.$hf(m.text)),!t&&C&&(t=L.$kf(m.text))}let S="",h=0,w=0,y=0;if(m.text){let C;[h,w,y,C]=(0,$.$at)(m.text);const W=this.getEOL();C===0||C===(W===`\r
`?2:1)?S=m.text:S=m.text.replace(/\r\n|\r|\n/g,W)}c[v]={sortIndex:v,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:S,eolCount:h,firstLineLength:w,lastLineLength:y,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}c.sort(P.u);let o=!1;for(let v=0,m=c.length-1;v<m;v++){const I=c[v].range.getEndPosition(),S=c[v+1].range.getStartPosition();if(S.isBeforeOrEqual(I)){if(S.isBefore(I))throw new Error("Overlapping ranges are not allowed!");o=!0}}r&&(c=this.s(c));const l=p||b?P._getInverseEditRanges(c):[],n=[];if(b)for(let v=0;v<c.length;v++){const m=c[v],I=l[v];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let S=I.startLineNumber;S<=I.endLineNumber;S++){let h="";S===I.startLineNumber&&(h=this.getLineContent(m.range.startLineNumber),L.$Ue(h)!==-1)||n.push({lineNumber:S,oldContent:h})}}let s=null;if(p){let v=0;s=[];for(let m=0;m<c.length;m++){const I=c[m],S=l[m],h=this.getValueInRange(I.range),w=I.rangeOffset+v;v+=I.text.length-h.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:S,text:h,textChange:new D.$Vs(I.rangeOffset,h,w,I.text)}}o||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=g,this.h=t,this.j=i;const a=this.t(c);let d=null;if(b&&n.length>0){n.sort((v,m)=>m.lineNumber-v.lineNumber),d=[];for(let v=0,m=n.length;v<m;v++){const I=n[v].lineNumber;if(v>0&&n[v-1].lineNumber===I)continue;const S=n[v].oldContent,h=this.getLineContent(I);h.length===0||h===S||L.$Ue(h)!==-1||d.push(I)}}return this.m.fire(),new M.$Vu(s,a,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const p=u[0].range,g=u[u.length-1].range,t=new A.$As(p.startLineNumber,p.startColumn,g.endLineNumber,g.endColumn);let i=p.startLineNumber,r=p.startColumn;const c=[];for(let a=0,d=u.length;a<d;a++){const v=u[a],m=v.range;b=b||v.forceMoveMarkers,c.push(this.getValueInRange(new A.$As(i,r,m.startLineNumber,m.startColumn))),v.text.length>0&&c.push(v.text),i=m.endLineNumber,r=m.endColumn}const o=c.join(""),[l,n,s]=(0,$.$at)(o);return{sortIndex:0,identifier:u[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:l,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(P.w);const b=[];for(let p=0;p<u.length;p++){const g=u[p],t=g.range.startLineNumber,i=g.range.startColumn,r=g.range.endLineNumber,c=g.range.endColumn;if(t===r&&i===c&&g.text.length===0)continue;g.text?(this.c.delete(g.rangeOffset,g.rangeLength),this.c.insert(g.rangeOffset,g.text,!0)):this.c.delete(g.rangeOffset,g.rangeLength);const o=new A.$As(t,i,r,c);b.push({range:o,rangeLength:g.rangeLength,text:g.text,rangeOffset:g.rangeOffset,forceMoveMarkers:g.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,p,g){return this.c.findMatchesLineByLine(u,b,p,g)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const p=u.startLineNumber,g=u.startColumn,[t,i,r]=(0,$.$at)(b);let c;if(b.length>0){const o=t+1;o===1?c=new A.$As(p,g,p,g+i):c=new A.$As(p,g,p+o-1,r+1)}else c=new A.$As(p,g,p,g);return c}static _getInverseEditRanges(u){const b=[];let p=0,g=0,t=null;for(let i=0,r=u.length;i<r;i++){const c=u[i];let o,l;t?t.range.endLineNumber===c.range.startLineNumber?(o=p,l=g+(c.range.startColumn-t.range.endColumn)):(o=p+(c.range.startLineNumber-t.range.endLineNumber),l=c.range.startColumn):(o=c.range.startLineNumber,l=c.range.startColumn);let n;if(c.text.length>0){const s=c.eolCount+1;s===1?n=new A.$As(o,l,o,l+c.firstLineLength):n=new A.$As(o,l,o+s-1,c.lastLineLength+1)}else n=new A.$As(o,l,o,l);p=n.endLineNumber,g=n.endColumn,b.push(n),t=c}return b}static u(u,b){const p=A.$As.compareRangesUsingEnds(u.range,b.range);return p===0?u.sortIndex-b.sortIndex:p}static w(u,b){const p=A.$As.compareRangesUsingEnds(u.range,b.range);return p===0?b.sortIndex-u.sortIndex:-p}}e.$MB=P}),define(Pe[144],Ae([1,0,12,91,143]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class M{constructor(D,f,P,k,u,b,p,g,t){this.a=D,this.b=f,this.c=P,this.d=k,this.e=u,this.f=b,this.g=p,this.h=g,this.j=t}k(D){const f=this.c+this.d+this.e,P=this.c+this.e;return f===0?D===1?`
`:`\r
`:P>f/2?`\r
`:`
`}create(D){const f=this.k(D),P=this.a;if(this.j&&(f===`\r
`&&(this.c>0||this.d>0)||f===`
`&&(this.c>0||this.e>0)))for(let u=0,b=P.length;u<b;u++){const p=P[u].buffer.replace(/\r\n|\r|\n/g,f),g=(0,L.$HB)(p);P[u]=new L.$KB(p,g)}const k=new A.$MB(P,this.b,f,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$qf(D)&&(this.b=E.$pf,D=D.substr(1));const f=D.charCodeAt(D.length-1);f===13||f>=55296&&f<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=f):(this.m(D,!1),this.c=!1,this.d=f)}m(D,f){!f&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const f=(0,L.$IB)(this.e,D);this.a.push(new L.$KB(D,f.lineStarts)),this.f+=f.cr,this.g+=f.lf,this.h+=f.crlf,f.isBasicASCII||(this.l=!1,this.j||(this.j=E.$hf(D)),this.k||(this.k=E.$kf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const f=(0,L.$HB)(D.buffer);D.lineStarts=f,this.d===13&&this.f++}}}e.$NB=R}),define(Pe[95],Ae([1,0,24,21]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$=e.$D$=void 0;var A;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(A||(A={}));function M(k){for(let u=0,b=k.length;u<b;u+=4){const p=k[u+0],g=k[u+1],t=k[u+2],i=k[u+3];k[u+0]=i,k[u+1]=t,k[u+2]=g,k[u+3]=p}}function R(k){const u=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return L.$D()||M(u),E.$fe.wrap(u)}function $(k){const u=k.buffer;if(L.$D()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function D(k){const u=new Uint32Array(f(k));let b=0;if(u[b++]=k.id,k.type==="full")u[b++]=1,u[b++]=k.data.length,u.set(k.data,b),b+=k.data.length;else{u[b++]=2,u[b++]=k.deltas.length;for(const p of k.deltas)u[b++]=p.start,u[b++]=p.deleteCount,p.data?(u[b++]=p.data.length,u.set(p.data,b),b+=p.data.length):u[b++]=0}return R(u)}e.$D$=D;function f(k){let u=0;if(u+=1+1,k.type==="full")u+=1+k.data.length;else{u+=1,u+=(1+1+1)*k.deltas.length;for(const b of k.deltas)b.data&&(u+=b.data.length)}return u}function P(k){const u=$(k);let b=0;const p=u[b++];if(u[b++]===1){const r=u[b++],c=u.subarray(b,b+r);return b+=r,{id:p,type:"full",data:c}}const t=u[b++],i=[];for(let r=0;r<t;r++){const c=u[b++],o=u[b++],l=u[b++];let n;l>0&&(n=u.subarray(b,b+l),b+=l),i[r]={start:c,deleteCount:o,data:n}}return{id:p,type:"delta",deltas:i}}e.$E$=P}),define(Pe[145],Ae([9,10]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,128,147,145]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class k{constructor(Q,ye,Be,He){this.id=Q,this.name=ye,this.defaultValue=Be,this.schema=He}applyUpdate(Q,ye){return b(Q,ye)}compute(Q,ye,Be){return Be}}class u{constructor(Q,ye){this.newValue=Q,this.didChange=ye}}e.ApplyUpdateResult=u;function b(Z,Q){if(typeof Z!="object"||typeof Q!="object"||!Z||!Q)return new u(Q,Z!==Q);if(Array.isArray(Z)||Array.isArray(Q)){const Be=Array.isArray(Z)&&Array.isArray(Q)&&E.$tb(Z,Q);return new u(Q,!Be)}let ye=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const He=b(Z[Be],Q[Be]);He.didChange&&(Z[Be]=He.newValue,ye=!0)}return new u(Z,ye)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ye){return b(Q,ye)}validate(Q){return this.defaultValue}}class g{constructor(Q,ye,Be,He){this.id=Q,this.name=ye,this.defaultValue=Be,this.schema=He}applyUpdate(Q,ye){return b(Q,ye)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ye,Be){return Be}}function t(Z,Q){return typeof Z>"u"?Q:Z==="false"?!1:!!Z}e.boolean=t;class i extends g{constructor(Q,ye,Be,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Be),super(Q,ye,Be,He)}validate(Q){return t(Q,this.defaultValue)}}function r(Z,Q,ye,Be){if(typeof Z>"u")return Q;let He=parseInt(Z,10);return isNaN(He)?Q:(He=Math.max(ye,He),He=Math.min(Be,He),He|0)}e.clampedInt=r;class c extends g{static clampedInt(Q,ye,Be,He){return r(Q,ye,Be,He)}constructor(Q,ye,Be,He,Xe,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Be,st.minimum=He,st.maximum=Xe),super(Q,ye,Be,st),this.minimum=He,this.maximum=Xe}validate(Q){return c.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function o(Z,Q,ye,Be){if(typeof Z>"u")return Q;const He=l.float(Z,Q);return l.clamp(He,ye,Be)}e.clampedFloat=o;class l extends g{static clamp(Q,ye,Be){return Q<ye?ye:Q>Be?Be:Q}static float(Q,ye){if(typeof Q=="number")return Q;if(typeof Q>"u")return ye;const Be=parseFloat(Q);return isNaN(Be)?ye:Be}constructor(Q,ye,Be,He,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,ye,Be,Xe),this.validationFn=He}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class n extends g{static string(Q,ye){return typeof Q!="string"?ye:Q}constructor(Q,ye,Be,He=void 0){typeof He<"u"&&(He.type="string",He.default=Be),super(Q,ye,Be,He)}validate(Q){return n.string(Q,this.defaultValue)}}function s(Z,Q,ye,Be){return typeof Z!="string"?Q:Be&&Z in Be?Be[Z]:ye.indexOf(Z)===-1?Q:Z}e.stringSet=s;class a extends g{constructor(Q,ye,Be,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=He,Xe.default=Be),super(Q,ye,Be,Xe),this.c=He}validate(Q){return s(Q,this.defaultValue,this.c)}}class d extends k{constructor(Q,ye,Be,He,Xe,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Xe,vt.default=He),super(Q,ye,Be,vt),this.c=Xe,this.d=st}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function v(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ye,Be){return Be===0?Q.accessibilitySupport:Be}}class I extends k{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{insertSpace:t(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function y(Z){switch(Z){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(Z){switch(Z){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class W extends p{constructor(){super(140)}compute(Q,ye,Be){const He=["monaco-editor"];return ye.get(39)&&He.push(ye.get(39)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),ye.get(73)==="default"?He.push("mouse-default"):ye.get(73)==="copy"&&He.push("mouse-copy"),ye.get(110)&&He.push("showUnused"),ye.get(138)&&He.push("showDeprecated"),He.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Q,ye,Be){return Be&&Q.emptySelectionClipboard}}class U extends k{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:$.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:$.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{cursorMoveOnType:t(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ye.loop,this.defaultValue.loop)}}}class z extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?z.OFF:Q==="true"?z.ON:Q:Q?z.ON:z.OFF}}e.EditorFontLigatures=z;class F extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?F.OFF:Q==="true"?F.TRANSLATE:Q:Q?F.TRANSLATE:F.OFF}compute(Q,ye,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class O extends p{constructor(){super(50)}compute(Q,ye,Be){return Q.fontInfo}}class X extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Q){const ye=l.float(Q,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(ye,6,100)}compute(Q,ye,Be){return Q.fontInfo.fontSize}}class $e extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$e.d,maximum:$e.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$e.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(c.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,$e.d,$e.e))}}class Ee extends k{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{multiple:s(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??s(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??s(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??s(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??s(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??s(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends k{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:$.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),delay:c.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:t(ye.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ye.above,this.defaultValue.above)}}}var Ce;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ce||(e.RenderMinimap=Ce={}));class de extends p{constructor(){super(143)}compute(Q,ye,Be){return de.computeLayout(ye,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const ye=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let He=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(He=Math.max(He,ye-1));const Xe=(Be+Q.viewLineCount+He)/(Q.pixelRatio*Q.height),st=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:He,desiredRatio:Xe,minimapLineCount:st}}static c(Q,ye){const Be=Q.outerWidth,He=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=ye.stableMinimapLayoutInput,vt=st&&Q.outerHeight===st.outerHeight&&Q.lineHeight===st.lineHeight&&Q.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Q.pixelRatio===st.pixelRatio&&Q.scrollBeyondLastLine===st.scrollBeyondLastLine&&Q.paddingTop===st.paddingTop&&Q.paddingBottom===st.paddingBottom&&Q.minimap.enabled===st.minimap.enabled&&Q.minimap.side===st.minimap.side&&Q.minimap.size===st.minimap.size&&Q.minimap.showSlider===st.minimap.showSlider&&Q.minimap.renderCharacters===st.minimap.renderCharacters&&Q.minimap.maxColumn===st.minimap.maxColumn&&Q.minimap.scale===st.minimap.scale&&Q.verticalScrollbarWidth===st.verticalScrollbarWidth&&Q.isViewportWrapping===st.isViewportWrapping,Dt=Q.lineHeight,Oe=Q.typicalHalfwidthCharacterWidth,Kt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let yt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,Ot=Q.minimap.size,Gt=Q.minimap.side,Bt=Q.verticalScrollbarWidth,St=Q.viewLineCount,Lt=Q.remainingWidth,Wt=Q.isViewportWrapping,Ye=Ht?2:3;let Vt=Math.floor(Xe*He);const qt=Vt/Xe;let ct=!1,gt=!1,Nt=Ye*yt,Pt=yt/Xe,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Me,desiredRatio:ve,minimapLineCount:H}=de.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Kt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:He,lineHeight:Dt,pixelRatio:Xe});if(St/H>1)ct=!0,gt=!0,yt=1,Nt=1,Pt=yt/Xe;else{let je=!1,Qe=yt+1;if(Ot==="fit"){const qe=Math.ceil((Ie+St+Me)*Nt);Wt&&vt&&Lt<=ye.stableFitRemainingWidth?(je=!0,Qe=ye.stableFitMaxMinimapScale):je=qe>Vt}if(Ot==="fill"||je){ct=!0;const qe=yt;Nt=Math.min(Dt*Xe,Math.max(1,Math.floor(1/ve))),Wt&&vt&&Lt<=ye.stableFitRemainingWidth&&(Qe=ye.stableFitMaxMinimapScale),yt=Math.min(Qe,Math.max(1,Math.floor(Nt/Ye))),yt>qe&&(At=Math.min(2,yt/qe)),Pt=yt/Xe/At,Vt=Math.ceil(Math.max(Jt,Ie+St+Me)*Nt),Wt?(ye.stableMinimapLayoutInput=Q,ye.stableFitRemainingWidth=Lt,ye.stableFitMaxMinimapScale=yt):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const ft=Math.floor(jt*Pt),kt=Math.min(ft,Math.max(0,Math.floor((Lt-Bt-2)*Pt/(Oe+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(Xe*kt);const Ct=Rt/Xe;Rt=Math.floor(Rt*At);const Ve=Ht?1:2,zt=Gt==="left"?0:Be-kt-Bt;return{renderMinimap:Ve,minimapLeft:zt,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:yt,minimapLineHeight:Nt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:qt}}static computeLayout(Q,ye){const Be=ye.outerWidth|0,He=ye.outerHeight|0,Xe=ye.lineHeight|0,st=ye.lineNumbersDigitCount|0,vt=ye.typicalHalfwidthCharacterWidth,Dt=ye.maxDigitWidth,Oe=ye.pixelRatio,Kt=ye.viewLineCount,Ht=Q.get(135),yt=Ht==="inherit"?Q.get(134):Ht,jt=yt==="inherit"?Q.get(130):yt,Ot=Q.get(133),Gt=ye.isDominatedByLongLines,Bt=Q.get(57),St=Q.get(67).renderType!==0,Lt=Q.get(68),Wt=Q.get(104),Ye=Q.get(83),Vt=Q.get(72),qt=Q.get(102),ct=qt.verticalScrollbarSize,gt=qt.verticalHasArrows,Nt=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=Q.get(43),ft=Q.get(109)!=="never";let kt=Q.get(65);At&&ft&&(kt+=16);let Rt=0;if(St){const pt=Math.max(st,Lt);Rt=Math.round(pt*Dt)}let Ct=0;Bt&&(Ct=Xe*ye.glyphMarginDecorationLaneCount);let Ve=0,zt=Ve+Ct,Jt=zt+Rt,Ie=Jt+kt;const Me=Be-Ct-Rt-kt;let ve=!1,H=!1,Le=-1;yt==="inherit"&&Gt?(ve=!0,H=!0):jt==="on"||jt==="bounded"?H=!0:jt==="wordWrapColumn"&&(Le=Ot);const je=de.c({outerWidth:Be,outerHeight:He,lineHeight:Xe,typicalHalfwidthCharacterWidth:vt,pixelRatio:Oe,scrollBeyondLastLine:Wt,paddingTop:Ye.top,paddingBottom:Ye.bottom,minimap:Vt,verticalScrollbarWidth:ct,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:H},ye.memory||new P);je.renderMinimap!==0&&je.minimapLeft===0&&(Ve+=je.minimapWidth,zt+=je.minimapWidth,Jt+=je.minimapWidth,Ie+=je.minimapWidth);const Qe=Me-je.minimapWidth,qe=Math.max(1,Math.floor((Qe-ct-2)/vt)),it=gt?Nt:0;return H&&(Le=Math.max(1,qe),jt==="bounded"&&(Le=Math.min(Le,Ot))),{width:Be,height:He,glyphMarginLeft:Ve,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:kt,contentLeft:Ie,contentWidth:Qe,minimap:je,viewportColumn:qe,isWordWrapMinified:ve,isViewportWrapping:H,wrappingColumn:Le,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:ct,height:He-2*it,right:0}}}}e.EditorLayoutInfoComputer=de;class pe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,ye,Be){return ye.get(2)===2?"advanced":Be}}class re extends k{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:$.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class Re extends k{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:$.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends k{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:$.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:s(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(ye.fontFamily,this.defaultValue.fontFamily),padding:t(ye.padding,this.defaultValue.padding)}}}class Y extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):c.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,ye,Be){return Be<0?c.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:$.localize(63,null)})}compute(Q,ye,Be){return Q.fontInfo.lineHeight}}class ie extends k{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Q.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:$.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),autohide:t(ye.autohide,this.defaultValue.autohide),size:s(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ye.side,this.defaultValue.side,["right","left"]),showSlider:s(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ye.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ye.scale,1,1,3),maxColumn:c.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(Z){return Z==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class ne extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{top:c.clampedInt(ye.top,0,0,1e3),bottom:c.clampedInt(ye.bottom,0,0,1e3)}}}class le extends k{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:$.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),cycle:t(ye.cycle,this.defaultValue.cycle)}}}class ce extends p{constructor(){super(141)}compute(Q,ye,Be){return Q.pixelRatio}}class we extends k{constructor(){const Q={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Q.strings,description:$.localize(82,null)},comments:{anyOf:ye,default:Q.comments,description:$.localize(83,null)},other:{anyOf:ye,default:Q.other,description:$.localize(84,null)}},default:Q,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Oe=Q?"on":"off";return{comments:Oe,strings:Oe,other:Oe}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ye,comments:Be,strings:He}=Q,Xe=["on","inline","off"];let st,vt,Dt;return typeof ye=="boolean"?st=ye?"on":"off":st=s(ye,this.defaultValue.other,Xe),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.comments,Xe),typeof He=="boolean"?Dt=He?"on":"off":Dt=s(He,this.defaultValue.strings,Xe),{other:st,comments:vt,strings:Dt}}}var _;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class he extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Q){let ye=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ye=4,Be=Q):Q==="interval"?ye=3:Q==="relative"?ye=2:Q==="on"?ye=1:ye=0),{renderType:ye,renderFn:Be}}}function te(Z){const Q=Z.get(97);return Q==="editable"?Z.get(90):Q!=="on"}e.filterValidationDecorations=te;class ae extends k{constructor(){const Q=[],ye={type:"number",description:$.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Q,description:$.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const ye=[];for(const Be of Q)if(typeof Be=="number")ye.push({column:c.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const He=Be;ye.push({column:c.clampedInt(He.column,0,0,1e4),color:He.color})}return ye.sort((Be,He)=>Be.column-He.column),ye}return this.defaultValue}}class ge extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Se(Z,Q){if(typeof Z!="string")return Q;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends k{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q,Be=c.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=c.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(ye.vertical,this.defaultValue.vertical),horizontal:Se(ye.horizontal,this.defaultValue.horizontal),useShadows:t(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:c.clampedInt(ye.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:He,verticalSliderSize:c.clampedInt(ye.verticalSliderSize,He,0,1e3),scrollByPage:t(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends k{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Q,ye){let Be=!1;ye.allowedCharacters&&Q&&(L.$en(Q.allowedCharacters,ye.allowedCharacters)||(Q={...Q,allowedCharacters:ye.allowedCharacters},Be=!0)),ye.allowedLocales&&Q&&(L.$en(Q.allowedLocales,ye.allowedLocales)||(Q={...Q,allowedLocales:ye.allowedLocales},Be=!0));const He=super.applyUpdate(Q,ye);return Be?new u(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{nonBasicASCII:x(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,ye){if(typeof Q!="object"||!Q)return ye;const Be={};for(const[He,Xe]of Object.entries(Q))Xe===!0&&(Be[He]=!0);return Be}}class G extends k{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:$.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),mode:s(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends k{constructor(){const Q={enabled:M.$0r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$0r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends k{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Q.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Q.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Q.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{bracketPairs:x(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(Z,Q,ye){const Be=ye.indexOf(Z);return Be===-1?Q:ye[Be]}class ue extends k{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Q.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Q.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{insertMode:s(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ye.showIcons,this.defaultValue.showIcons),showStatusBar:t(ye.showStatusBar,this.defaultValue.showStatusBar),preview:t(ye.preview,this.defaultValue.preview),previewMode:s(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ye.showMethods,this.defaultValue.showMethods),showFunctions:t(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ye.showFields,this.defaultValue.showFields),showVariables:t(ye.showVariables,this.defaultValue.showVariables),showClasses:t(ye.showClasses,this.defaultValue.showClasses),showStructs:t(ye.showStructs,this.defaultValue.showStructs),showInterfaces:t(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ye.showModules,this.defaultValue.showModules),showProperties:t(ye.showProperties,this.defaultValue.showProperties),showEvents:t(ye.showEvents,this.defaultValue.showEvents),showOperators:t(ye.showOperators,this.defaultValue.showOperators),showUnits:t(ye.showUnits,this.defaultValue.showUnits),showValues:t(ye.showValues,this.defaultValue.showValues),showConstants:t(ye.showConstants,this.defaultValue.showConstants),showEnums:t(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ye.showKeywords,this.defaultValue.showKeywords),showWords:t(ye.showWords,this.defaultValue.showWords),showColors:t(ye.showColors,this.defaultValue.showColors),showFiles:t(ye.showFiles,this.defaultValue.showFiles),showReferences:t(ye.showReferences,this.defaultValue.showReferences),showFolders:t(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ye.showSnippets,this.defaultValue.showSnippets),showUsers:t(ye.showUsers,this.defaultValue.showUsers),showIssues:t(ye.showIssues,this.defaultValue.showIssues)}}}class Ne extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ze extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ye,Be){return ye.get(2)===2?0:Be}}class Je extends p{constructor(){super(144)}compute(Q,ye,Be){const He=ye.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class tt extends k{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),showDropSelector:s(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends k{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ye=Q;return{enabled:t(ye.enabled,this.defaultValue.enabled),showPasteSelector:s(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?rt:A.$k?nt:et,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var dt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new d(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new tt),stickyScroll:ze(new Re),experimentalWhitespaceRendering:ze(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:$.localize(254,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new O),fontLigatures2:ze(new z),fontSize:ze(new X),fontWeight:ze(new $e),fontVariations:ze(new F),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>l.clamp(Z,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new re),lineDecorationsWidth:ze(new Y),lineHeight:ze(new B),lineNumbers:ze(new he),lineNumbersMinChars:ze(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new ie),mouseStyle:ze(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(282,null),$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:$.localize(286,null)})),overviewRulerLanes:ze(new c(82,"overviewRulerLanes",3,0,3)),padding:ze(new ne),pasteAs:ze(new _e),parameterHints:ze(new le),peekWidgetDefaultFocus:ze(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(287,null),$.localize(288,null)],description:$.localize(289,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:$.localize(290,null)})),quickSuggestions:ze(new we),quickSuggestionsDelay:ze(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(291,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new ge),renameOnType:ze(new i(92,"renameOnType",!1,{description:$.localize(292,null),markdownDeprecationMessage:$.localize(293,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:$.localize(294,null),restricted:!0})),renderFinalNewline:ze(new a(94,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(295,null)})),renderLineHighlight:ze(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(296,null)],description:$.localize(297,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(298,null)})),renderValidationDecorations:ze(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(299,null),$.localize(300,null),$.localize(301,null),""],description:$.localize(302,null)})),revealHorizontalRightPadding:ze(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:$.localize(303,null)})),rulers:ze(new ae),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(304,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:$.localize(305,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:$.localize(306,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:$.localize(307,null),included:A.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:$.localize(308,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(309,null),$.localize(310,null),$.localize(311,null)],description:$.localize(312,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:$.localize(313,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:$.localize(314,null)})),inlayHints:ze(new se),snippetSuggestions:ze(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(315,null),$.localize(316,null),$.localize(317,null),$.localize(318,null)],description:$.localize(319,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:$.localize(320,null)})),stopRenderingLineAfter:ze(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(321,null)})),suggestFontSize:ze(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:$.localize(324,null)})),suggestSelection:ze(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabCompletion:ze(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),tabIndex:ze(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:$.localize(337,null)})),wordBreak:ze(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null)],description:$.localize(340,null)})),wordSeparators:ze(new n(129,"wordSeparators",R.$$r,{description:$.localize(341,null)})),wordWrap:ze(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(342,null),$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(347,null)})),wordWrapOverride1:ze(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(348,null)})),pixelRatio:ze(new ce),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:$.localize(349,null)})),layoutInfo:ze(new de),wrappingInfo:ze(new Je),wrappingIndent:ze(new Ze),wrappingStrategy:ze(new pe)}}),define(Pe[148],Ae([9,10]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Ae([9,10]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Ae([9,10]),function(be,e){return be.create("vs/workbench/common/configuration",e)}),define(Pe[171],Ae([9,10]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Pe[172],Ae([9,10]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Pe[173],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Ae([9,10]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Ae([9,10]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Ae([1,0,11,150]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var A;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(A||(e.TokenType=A={}));function M(...f){switch(f.length){case 1:return(0,L.localize)(0,null,f[0]);case 2:return(0,L.localize)(1,null,f[0],f[1]);case 3:return(0,L.localize)(2,null,f[0],f[1],f[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const k=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:k,lexeme:u,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const k=this.c.substring(this.d,this.e),u=D.b.get(k);u?this.k(u):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,k=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l($);return}const p=this.c.charCodeAt(P);if(k)k=!1;else if(p===47&&!u){P++;break}else p===91?u=!0:p===92?k=!0:p===93&&(u=!1);P++}for(;P<this.c.length&&D.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=D}),define(Pe[182],Ae([1,0,25,31,152,294]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Ro=D;function f(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(R);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$So=f;function P(i){if(!i)return null;const r=i.majorBase,c=i.majorMustEqual,o=i.minorBase;let l=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(l=!1),s=!1);let a=0;if(i.preRelease){const d=$.exec(i.preRelease);if(d){const[,v,m,I]=d;a=Date.UTC(Number(v),Number(m)-1,Number(I))}}return{majorBase:r,majorMustEqual:c,minorBase:o,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$To=P;function k(i,r,c){let o;typeof i=="string"?o=P(f(i)):o=i;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let n;if(typeof c=="string"?n=P(f(c)):n=c,!o||!n)return!1;const s=o.majorBase,a=o.minorBase,d=o.patchBase;let v=n.majorBase,m=n.minorBase,I=n.patchBase;const S=n.notBefore;let h=n.majorMustEqual,w=n.minorMustEqual,y=n.patchMustEqual;return n.isMinimum?s>v?!0:s<v?!1:a>m?!0:a<m||l&&l<S?!1:d>=I:(s===1&&v===0&&(!h||!w||!y)&&(v=1,m=0,I=0,h=!0,w=!1,y=!1),s<v?!1:s>v?!h:a<m?!1:a>m?!w:d<I?!1:d>I?!y:!(l&&l<S))}e.$Uo=k;function u(i,r,c,o,l){const n=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return n.push([L.default.Error,A.localize(0,null)]),n;if(typeof o.name!="string")return n.push([L.default.Error,A.localize(1,null,"name")]),n;if(typeof o.version!="string")return n.push([L.default.Error,A.localize(2,null,"version")]),n;if(!o.engines)return n.push([L.default.Error,A.localize(3,null,"engines")]),n;if(typeof o.engines.vscode!="string")return n.push([L.default.Error,A.localize(4,null,"engines.vscode")]),n;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return n.push([L.default.Error,A.localize(5,null,"extensionDependencies")]),n;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return n.push([L.default.Error,A.localize(6,null,"activationEvents")]),n;if(typeof o.main>"u"&&typeof o.browser>"u")return n.push([L.default.Error,A.localize(7,null,"activationEvents","main","browser")]),n}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&n.push([L.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return n.push([L.default.Error,A.localize(9,null,"main")]),n;{const d=(0,E.$zg)(c,o.main);(0,E.$tg)(d,c)||n.push([L.default.Warning,A.localize(10,null,d.path,c.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return n.push([L.default.Error,A.localize(11,null,"browser")]),n;{const d=(0,E.$zg)(c,o.browser);(0,E.$tg)(d,c)||n.push([L.default.Warning,A.localize(12,null,d.path,c.path)])}}if(!M.valid(o.version))return n.push([L.default.Error,A.localize(13,null)]),n;const s=[];if(!b(i,r,o,l,s))for(const d of s)n.push([L.default.Error,d]);return n}e.$Vo=u;function b(i,r,c,o,l){return o||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(i,r,c.engines.vscode,l)}e.$Wo=b;function p(i,r,c){return i==="*"||g(r,c,i)}e.$Xo=p;function g(i,r,c,o=[]){const l=P(f(c));if(!l)return o.push(A.localize(14,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(A.localize(15,null,c)),!1}else if(!l.majorMustEqual)return o.push(A.localize(16,null,c)),!1;return k(i,r,l)?!0:(o.push(A.localize(17,null,i,c)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,c=i.length;r<c;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class E{constructor(A,M=[],R=!1){this.ctor=A,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Sh=E}),define(Pe[70],Ae([1,0,69]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.InstantiationType=void 0;const L=[];var A;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function M($,D,f){D instanceof E.$Sh||(D=new E.$Sh(D,[],!!f)),L.push([$,D])}e.$Dr=M;function R(){return L}e.$Er=R}),define(Pe[183],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$hq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const f=this.c(D,R);if(f)return f;R.delete($)}}}e.$iq=L}),define(Pe[4],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Uh=A("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function A(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,P)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Vh=A;function M(R){return R}e.$Wh=M}),define(Pe[40],Ae([1,0,16,2,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,A.$Vh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$qi=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$ri=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=D;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ti=f;function P(i,r){const c=Object.create(null);for(const o in i)k(c,o,i[o],r);return c}e.$ui=P;function k(i,r,c,o){const l=r.split("."),n=l.pop();let s=i;for(let a=0;a<l.length;a++){const d=l[a];let v=s[d];switch(typeof v){case"undefined":v=s[d]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(v)}`);return}s=v}if(typeof s=="object"&&s!==null)try{s[n]=c}catch{o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$vi=k;function u(i,r){const c=r.split(".");b(i,c)}e.$wi=u;function b(i,r){const c=r.shift();if(r.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const o=i[c];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete i[c])}}function p(i,r,c){function o(s,a){let d=s;for(const v of a){if(typeof d!="object"||d===null)return;d=d[v]}return d}const l=r.split("."),n=o(i,l);return typeof n>"u"?c:n}e.$xi=p;function g(i,r,c){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?E.$Ef(i[o])&&E.$Ef(r[o])?g(i[o],r[o],c):c&&(i[o]=r[o]):i[o]=r[o])})}e.$yi=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$zi=t}),define(Pe[34],Ae([1,0,21,12,181,4,149,11]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$j),D.set("isLinux",E.$k),D.set("isWindows",E.$i),D.set("isWeb",E.$o),D.set("isMacNative",E.$j&&!E.$o),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function f(Y,B){if(D.get(Y)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(Y,B)}e.$Ri=f;const P=Object.prototype.hasOwnProperty;var k;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const u={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),p=(0,R.localize)(1,null),g=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),r=(0,R.localize)(5,null),c=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=u){this.k=B,this.d=new A.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const me=this.D(),ne=me.type===17?r:void 0;throw this.h.push({message:i,offset:me.offset,lexeme:A.$Qi.getLexeme(me),additionalInfo:ne}),l.c}return ie}catch(ie){if(ie!==l.c)throw ie;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ie=this.o();B.push(ie)}return B.length===1?B[0]:n.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ie=this.s();B.push(ie)}return B.length===1?B[0]:n.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,t),ie?.negate()}case 17:return this.z(),C.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ie=this.l();return this.A(1,t),ie}case 17:{const ie=B.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const le=ne.lexeme,ce=le.lastIndexOf("/"),we=ce===le.length-1?void 0:this.w(le.substring(ce+1));let _;try{_=new RegExp(le.substring(1,ce),we)}catch{throw this.B("REGEX",ne)}return O.create(ie,_)}switch(ne.type){case 10:case 19:{const le=[ne.lexeme];this.z();let ce=this.D(),we=0;for(let ge=0;ge<ne.lexeme.length;ge++)ne.lexeme.charCodeAt(ge)===40?we++:ne.lexeme.charCodeAt(ge)===41&&we--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:we++;break;case 1:we--;break;case 10:case 18:for(let ge=0;ge<ce.lexeme.length;ge++)ce.lexeme.charCodeAt(ge)===40?we++:ne.lexeme.charCodeAt(ge)===41&&we--}if(we<0)break;le.push(A.$Qi.getLexeme(ce)),this.z(),ce=this.D()}const _=le.join(""),he=_.lastIndexOf("/"),te=he===_.length-1?void 0:this.w(_.substring(he+1));let ae;try{ae=new RegExp(_.substring(1,he),te)}catch{throw this.B("REGEX",ne)}return n.regex(ie,ae)}case 18:{const le=ne.lexeme;this.z();let ce=null;if(!(0,L.$Fe)(le)){const we=le.indexOf("/"),_=le.lastIndexOf("/");if(we!==_&&we>=0){const he=le.slice(we+1,_),te=le[_+1]==="i"?"i":"";try{ce=new RegExp(he,te)}catch{throw this.B("REGEX",ne)}}}if(ce===null)throw this.B("REGEX",ne);return O.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const ne=this.u();return n.notIn(ie,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return n.equals(ie,ne);switch(ne){case"true":return n.has(ie);case"false":return n.not(ie);default:return n.equals(ie,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return n.notEquals(ie,ne);switch(ne){case"true":return n.not(ie);case"false":return n.has(ie);default:return n.notEquals(ie,ne)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),F.create(ie,this.u());case 7:return this.z(),K.create(ie,this.u());case 8:return this.z(),U.create(ie,this.u());case 13:return this.z(),n.in(ie,this.u());default:return n.has(ie)}}case 20:throw this.h.push({message:c,offset:B.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ie){if(this.C(B))return this.z();throw this.B(ie,this.D())}B(B,ie,me){const ne=(0,R.localize)(8,null,B,A.$Qi.getLexeme(ie)),le=ie.offset,ce=A.$Qi.getLexeme(ie);return this.h.push({message:ne,offset:le,lexeme:ce,additionalInfo:me}),l.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=l;class n{static false(){return v.INSTANCE}static true(){return m.INSTANCE}static has(B){return I.create(B)}static equals(B,ie){return S.create(B,ie)}static notEquals(B,ie){return y.create(B,ie)}static regex(B,ie){return O.create(B,ie)}static in(B,ie){return h.create(B,ie)}static notIn(B,ie){return w.create(B,ie)}static not(B){return C.create(B)}static and(...B){return Ee.create(B,null,!0)}static or(...B){return De.create(B,null,!0)}static greater(B,ie){return K.create(B,ie)}static greaterEquals(B,ie){return U.create(B,ie)}static smaller(B,ie){return z.create(B,ie)}static smallerEquals(B,ie){return F.create(B,ie)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ti=n;function s(Y){const B=new l({regexParsingWithErrorRecovery:!1});return Y.map(ie=>(B.parse(ie),B.lexingErrors.length>0?B.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,R.localize)(9,null,me.additionalInfo):(0,R.localize)(10,null),offset:me.offset,length:me.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.$Ui=s;function a(Y,B){const ie=Y?Y.substituteConstants():void 0,me=B?B.substituteConstants():void 0;return!ie&&!me?!0:!ie||!me?!1:ie.equals(me)}e.$Vi=a;function d(Y,B){return Y.cmp(B)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return m.INSTANCE}}e.$Wi=v;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return v.INSTANCE}}e.$Xi=m;class I{static create(B,ie=null){const me=D.get(B);return typeof me=="boolean"?me?m.INSTANCE:v.INSTANCE:new I(B,ie)}constructor(B,ie){this.key=B,this.c=ie,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:de(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=D.get(this.key);return typeof B=="boolean"?B?m.INSTANCE:v.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Yi=I;class S{static create(B,ie,me=null){if(typeof ie=="boolean")return ie?I.create(B,me):C.create(B,me);const ne=D.get(B);return typeof ne=="boolean"?ie===(ne?"true":"false")?m.INSTANCE:v.INSTANCE:new S(B,ie,me)}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?m.INSTANCE:v.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Zi=S;class h{static create(B,ie){return new h(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.f),me=B.getValue(this.d);return Array.isArray(ie)?ie.includes(me):typeof me=="string"&&typeof ie=="object"&&ie!==null?P.call(ie,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$1i=h;class w{static create(B,ie){return new w(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=11,this.c=h.create(B,ie)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=w;class y{static create(B,ie,me=null){if(typeof ie=="boolean")return ie?C.create(B,me):I.create(B,me);const ne=D.get(B);return typeof ne=="boolean"?ie===(ne?"true":"false")?v.INSTANCE:m.INSTANCE:new y(B,ie,me)}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?v.INSTANCE:m.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$3i=y;class C{static create(B,ie=null){const me=D.get(B);return typeof me=="boolean"?me?v.INSTANCE:m.INSTANCE:new C(B,ie)}constructor(B,ie){this.c=B,this.d=ie,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:de(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=D.get(this.c);return typeof B=="boolean"?B?v.INSTANCE:m.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$4i=C;function W(Y,B){if(typeof Y=="string"){const ie=parseFloat(Y);isNaN(ie)||(Y=ie)}return typeof Y=="string"||typeof Y=="number"?B(Y):v.INSTANCE}class K{static create(B,ie,me=null){return W(ie,ne=>new K(B,ne,me))}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$5i=K;class U{static create(B,ie,me=null){return W(ie,ne=>new U(B,ne,me))}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$6i=U;class z{static create(B,ie,me=null){return W(ie,ne=>new z(B,ne,me))}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$7i=z;class F{static create(B,ie,me=null){return W(ie,ne=>new F(B,ne,me))}constructor(B,ie,me){this.c=B,this.d=ie,this.f=me,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:pe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$8i=F;class O{static create(B,ie){return new O(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ie=this.f?this.f.source:"",me=B.f?B.f.source:"";return ie<me?-1:ie>me?1:0}equals(B){if(B.type===this.type){const ie=this.f?this.f.source:"",me=B.f?B.f.source:"";return this.d===B.d&&ie===me}return!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$9i=O;class X{static create(B){return new X(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new X(this.c.map(B))}negate(){return this.c}}e.$0i=X;function $e(Y){let B=null;for(let ie=0,me=Y.length;ie<me;ie++){const ne=Y[ie].substituteConstants();if(Y[ie]!==ne&&B===null){B=[];for(let le=0;le<ie;le++)B[le]=Y[le]}B!==null&&(B[ie]=ne)}return B===null?Y:B}class Ee{static create(B,ie,me){return Ee.d(B,ie,me)}constructor(B,ie){this.expr=B,this.c=ie,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,me=this.expr.length;ie<me;ie++){const ne=d(this.expr[ie],B.expr[ie]);if(ne!==0)return ne}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,me=this.expr.length;ie<me;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=$e(this.expr);return B===this.expr?this:Ee.create(B,this.c,!1)}evaluate(B){for(let ie=0,me=this.expr.length;ie<me;ie++)if(!this.expr[ie].evaluate(B))return!1;return!0}static d(B,ie,me){const ne=[];let le=!1;for(const ce of B)if(ce){if(ce.type===1){le=!0;continue}if(ce.type===0)return v.INSTANCE;if(ce.type===6){ne.push(...ce.expr);continue}ne.push(ce)}if(ne.length===0&&le)return m.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(d);for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];for(;ne.length>1;){const ce=ne[ne.length-1];if(ce.type!==9)break;ne.pop();const we=ne.pop(),_=ne.length===0,he=De.create(ce.expr.map(te=>Ee.create([te,we],null,me)),null,_);he&&(ne.push(he),ne.sort(d))}if(ne.length===1)return ne[0];if(me){for(let ce=0;ce<ne.length;ce++)for(let we=ce+1;we<ne.length;we++)if(ne[ce].negate().equals(ne[we]))return v.INSTANCE;if(ne.length===1)return ne[0]}return new Ee(ne,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new Ee(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());this.c=De.create(B,this,!0)}return this.c}}e.$$i=Ee;class De{static create(B,ie,me){return De.d(B,ie,me)}constructor(B,ie){this.expr=B,this.c=ie,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,me=this.expr.length;ie<me;ie++){const ne=d(this.expr[ie],B.expr[ie]);if(ne!==0)return ne}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,me=this.expr.length;ie<me;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=$e(this.expr);return B===this.expr?this:De.create(B,this.c,!1)}evaluate(B){for(let ie=0,me=this.expr.length;ie<me;ie++)if(this.expr[ie].evaluate(B))return!0;return!1}static d(B,ie,me){let ne=[],le=!1;if(B){for(let ce=0,we=B.length;ce<we;ce++){const _=B[ce];if(_){if(_.type===0){le=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){ne=ne.concat(_.expr);continue}ne.push(_)}}if(ne.length===0&&le)return v.INSTANCE;ne.sort(d)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];if(me){for(let ce=0;ce<ne.length;ce++)for(let we=ce+1;we<ne.length;we++)if(ne[ce].negate().equals(ne[we]))return m.INSTANCE;if(ne.length===1)return ne[0]}return new De(ne,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new De(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());for(;B.length>1;){const ie=B.shift(),me=B.shift(),ne=[];for(const le of se(ie))for(const ce of se(me))ne.push(Ee.create([le,ce],null,!1));B.unshift(De.create(ne,null,!1))}this.c=De.create(B,this,!0)}return this.c}}e.$_i=De;class Ce extends I{static{this.d=[]}static all(){return Ce.d.values()}constructor(B,ie,me){super(B,null),this.f=ie,typeof me=="object"?Ce.d.push({...me,key:B}):me!==!0&&Ce.d.push({key:B,description:me,type:ie!=null?typeof ie:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$aj=Ce,e.$bj=(0,M.$Vh)("contextKeyService");function de(Y,B){return Y<B?-1:Y>B?1:0}function pe(Y,B,ie,me){return Y<ie?-1:Y>ie?1:B<me?-1:B>me?1:0}function re(Y,B){if(Y.type===0||B.type===1)return!0;if(Y.type===9)return B.type===9?Re(Y.expr,B.expr):!1;if(B.type===9){for(const ie of B.expr)if(re(Y,ie))return!0;return!1}if(Y.type===6){if(B.type===6)return Re(B.expr,Y.expr);for(const ie of Y.expr)if(re(ie,B))return!0;return!1}return Y.equals(B)}e.$cj=re;function Re(Y,B){let ie=0,me=0;for(;ie<Y.length&&me<B.length;){const ne=Y[ie].cmp(B[me]);if(ne<0)return!1;ne===0&&ie++,me++}return ie===Y.length}function se(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[184],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,E.$Vh)("environmentService"),e.$4h=(0,E.$Wh)(e.$3h)}),define(Pe[96],Ae([1,0,151,4]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function A(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=A;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function R(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=R;function $(i,r){return r==="web"&&!i.includes("web")}e.$ao=$;function D(i,r,c){return $(r,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}e.$bo=D;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$co=f;var P;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var k;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$do=(0,L.$Vh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$eo=t,e.$fo=(0,L.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,L.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,L.$Vh)("IExtensionTipsService"),e.$ko=(0,E.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[41],Ae([1,0,50,19,12,16,2,153,4,21,13,44]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,D.$Vh)("fileService");function u(re){return re.create===!0}e.$fk=u;var b;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var p;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function g(re){const Re=re;return!!Re&&typeof Re.onDidChange=="function"}e.$gk=g;var t;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(re){return!!(re.capabilities&2)}e.$hk=i;function r(re){return!!(re.capabilities&8)}e.$ik=r;function c(re){return!!(re.capabilities&131072)}e.$jk=c;function o(re){return!!(re.capabilities&4)}e.$kk=o;function l(re){return!!(re.capabilities&16)}e.$lk=l;function n(re){return i(re)?!!(re.capabilities&16384):!1}e.$mk=n;function s(re){return i(re)?!!(re.capabilities&32768):!1}e.$nk=s;function a(re){return!!(re.capabilities&65536)}e.$ok=a;function d(re){return!!(re.capabilities&2048)}e.$pk=d;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class m extends Error{static create(Re,se){const Y=new m(Re.toString(),se);return h(Y,se),Y}constructor(Re,se){super(Re),this.code=se}}e.$qk=m;function I(re,Re){return m.create(re,Re)}e.$rk=I;function S(re){return re||I((0,$.localize)(0,null),v.Unknown)}e.$sk=S;function h(re,Re){return re.name=Re?`${Re} (FileSystemError)`:"FileSystemError",re}e.$tk=h;function w(re){if(!re)return v.Unknown;if(re instanceof m)return re.code;const Re=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Re)return v.Unknown;switch(Re[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$uk=w;function y(re){if(re instanceof F)return re.fileOperationResult;switch(w(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$vk=y;var C;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class W{constructor(Re,se,Y){this.resource=Re,this.operation=se,this.target=Y}isOperation(Re){return this.operation===Re}}e.$wk=W;var K;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class U{static{this.a=null}constructor(Re,se){this.c=se,this.b=void 0,this.d=new k.$U(()=>{const Y=E.$2h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new k.$U(()=>{const Y=E.$2h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new k.$U(()=>{const Y=E.$2h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Re){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==U.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(Re,...se){return this.h(Re,{includeChildren:!1},...se)}affects(Re,...se){return this.h(Re,{includeChildren:!0},...se)}h(Re,se,...Y){if(!Re)return!1;const B=Y.length>0;return!!((!B||Y.includes(1))&&(this.d.value.get(Re)||se.includeChildren&&this.d.value.findSuperstr(Re))||(!B||Y.includes(0))&&(this.f.value.get(Re)||se.includeChildren&&this.f.value.findSuperstr(Re))||(!B||Y.includes(2))&&(this.g.value.findSubstr(Re)||se.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$xk=U;function z(re,Re,se){return!re||!Re||re===Re||Re.length>re.length?!1:(Re.charAt(Re.length-1)!==L.sep&&(Re+=L.sep),se?(0,A.$7e)(re,Re):re.indexOf(Re)===0)}e.$yk=z;class F extends Error{constructor(Re,se,Y){super(Re),this.fileOperationResult=se,this.options=Y}}e.$zk=F;class O extends F{constructor(Re,se,Y,B){super(Re,se,B),this.fileOperationResult=se,this.size=Y}}e.$Ak=O;class X extends F{constructor(Re,se,Y){super(Re,2,Y),this.stat=se}}e.$Bk=X;var $e;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})($e||(e.FileOperationResult=$e={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var Ee;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Jk="";function De(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Kk=De;async function Ce(re,Re){if(!Re.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(se=>{const Y=Re.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(Y.dispose(),se())})})}e.$Lk=Ce;class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Re){return(0,M.$Gf)(Re)||(Re=0),Re<de.KB?(0,$.localize)(1,null,Re.toFixed(0)):Re<de.MB?(0,$.localize)(2,null,(Re/de.KB).toFixed(2)):Re<de.GB?(0,$.localize)(3,null,(Re/de.MB).toFixed(2)):Re<de.TB?(0,$.localize)(4,null,(Re/de.GB).toFixed(2)):(0,$.localize)(5,null,(Re/de.TB).toFixed(2))}}e.$Mk=de;function pe(re){const Re=typeof re=="string"||re?.scheme===P.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===P.Schemas.file?1024*de.MB:Re?10*de.MB:f.$o?50*de.MB:1024*de.MB}e.$Nk=pe}),define(Pe[71],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class E{constructor(...A){this.a=new Map;for(const[M,R]of A)this.set(M,R)}set(A,M){const R=this.a.get(A);return this.a.set(A,M),R}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Th=E}),define(Pe[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const P=!1;class k extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new D.$Th,i=!1,r,c=P){this.f=t,this.g=i,this.h=r,this.i=c,this.o=new Set,this.f.set($.$Uh,this),this._globalGraph=c?r?._globalGraph??new R.$iq(o=>o):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const r=p.traceInvocation(this.i,t);let c=!1;try{return t({get:l=>{if(c)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(l,r);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...i)}finally{c=!0,r.stop()}}createInstance(t,...i){let r,c;return t instanceof M.$Sh?(r=p.traceCreation(this.i,t.ctor),c=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=p.traceCreation(this.i,t),c=this.j(t,i,r)),r.stop(),c}j(t,i=[],r){const c=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),o=[];for(const n of c){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(s)}const l=c.length>0?c[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const n=l-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Sh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Sh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const c=new R.$iq(n=>n.id.toString());let o=0;const l=[{id:t,desc:i,_trace:r}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),o++>1e3)throw new k(c);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.$Sh){const d={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};c.insertEdge(n,d),l.push(d)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new k(c);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Sh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}c.removeNode(s)}}return this.l(t)}s(t,i,r=[],c,o){if(this.f.get(t)instanceof M.$Sh)return this.t(t,i,r,c,o);if(this.h)return this.h.s(t,i,r,c,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],c,o){if(c){const l=new u(void 0,this.g,this,this.i);l.c=String(t);const n=new Map,s=new E.$eh(()=>{const a=l.j(i,r,o);for(const[d,v]of n){const m=a[d];if(typeof m=="function")for(const I of v)m.apply(a,I)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let I=n.get(d);return I||(I=new f.$2c,n.set(d,I)),(h,w,y)=>{const C=I.push([h,w,y]);return(0,A.$Pc)(C)}}if(d in a)return a[d];const v=s.value;let m=v[d];return typeof m!="function"||(m=m.bind(v),a[d]=m),m},set(a,d,v){return s.value[d]=v,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,r,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$jq=u;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new p(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function r(o,l){const n=[],s=new Array(o+1).join("	");for(const[a,d,v]of l.h)if(d&&v){i=!0,n.push(`${s}CREATES -> ${a}`);const m=r(o+1,v);m&&n.push(m)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(c.join(`
`))}}e.$kq=p}),define(Pe[15],Ae([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,u.$Vh)("logService"),e.$ej=(0,u.$Vh)("loggerService");function b(){return new Date().toISOString()}function p(h){return(0,f.$Gf)(h)}e.$fj=p;var g;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$gj=g.Info;function t(h,w,y){switch(w){case g.Trace:h.trace(y);break;case g.Debug:h.debug(y);break;case g.Info:h.info(y);break;case g.Warning:h.warn(y);break;case g.Error:h.error(y);break;case g.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(h,w=!1){let y="";for(let C=0;C<h.length;C++){let W=h[C];if(W instanceof Error&&(W=(0,E.$Gi)(W,w)),typeof W=="object")try{W=JSON.stringify(W)}catch{}y+=(C>0?" ":"")+W}return y}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new L.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==g.Off&&this.b<=w}}e.$ij=r;class c extends r{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...y){this.f(g.Trace)&&this.g(g.Trace,i([w,...y],!0))}debug(w,...y){this.f(g.Debug)&&this.g(g.Debug,i([w,...y]))}info(w,...y){this.f(g.Info)&&this.g(g.Info,i([w,...y]))}warn(w,...y){this.f(g.Warning)&&this.g(g.Warning,i([w,...y]))}error(w,...y){if(this.f(g.Error))if(w instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=w.stack,this.g(g.Error,i(C))}else this.g(g.Error,i([w,...y]))}flush(){}}e.$jj=c;class o extends r{constructor(w=e.$gj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...y){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}debug(w,...y){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}info(w,...y){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}warn(w,...y){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...y):console.warn(`[main ${b()}]`,w,...y))}error(w,...y){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...y):console.error(`[main ${b()}]`,w,...y))}dispose(){}flush(){}}e.$kj=o;class l extends r{constructor(w=e.$gj,y=!0){super(),this.g=y,this.setLevel(w)}trace(w,...y){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...y):console.log(w,...y))}debug(w,...y){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...y):console.log(w,...y))}info(w,...y){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...y):console.log(w,...y))}warn(w,...y){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...y):console.log(w,...y))}error(w,...y){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...y):console.error(w,...y))}dispose(){}flush(){}}e.$lj=l;class n extends r{constructor(w,y=e.$gj){super(),this.g=w,this.setLevel(y)}trace(w,...y){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(w),...y])}debug(w,...y){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(w),...y])}info(w,...y){this.f(g.Info)&&this.g.log(g.Info,[this.h(w),...y])}warn(w,...y){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(w),...y])}error(w,...y){this.f(g.Error)&&this.g.log(g.Error,[this.h(w),...y])}h(w){return typeof w=="string"?w:(0,E.$Gi)(w,this.f(g.Trace))}dispose(){}flush(){}}e.$mj=n;class s extends r{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const y of this.g)y.setLevel(w);super.setLevel(w)}trace(w,...y){for(const C of this.g)C.trace(w,...y)}debug(w,...y){for(const C of this.g)C.debug(w,...y)}info(w,...y){for(const C of this.g)C.info(w,...y)}warn(w,...y){for(const C of this.g)C.warn(w,...y)}error(w,...y){for(const C of this.g)C.error(w,...y)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$nj=s;class a extends M.$Rc{constructor(w,y,C){if(super(),this.h=w,this.j=y,this.b=new R.$zc,this.c=this.B(new L.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Rd),this.onDidChangeVisibility=this.g.event,C)for(const W of C)this.b.set(W.resource,{logger:void 0,info:W})}m(w){return(0,f.$Cf)(w)?[...this.b.values()].find(y=>y.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,y){const C=this.n(w),W=(0,f.$Cf)(w)?w:y?.id??(0,A.$Ji)(C.toString()).toString(16);let K=this.b.get(C)?.logger;const U=y?.logLevel==="always"?g.Trace:y?.logLevel;K||(K=this.s(C,U??this.getLogLevel(C)??this.h,{...y,id:W}));const z={logger:K,info:{resource:C,id:W,logLevel:U,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this.b.set(C,z),K}n(w){return(0,f.$Cf)(w)?(0,D.$zg)(this.j,`${w}.log`):w}setLogLevel(w,y){if(P.URI.isUri(w)){const C=w,W=y,K=this.b.get(C);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([C,W]))}else{this.h=w;for(const[C,W]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,y){const C=this.m(w);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(w){let y;return w&&(y=this.b.get(w)?.info.logLevel),y??this.h}registerLogger(w){const y=this.b.get(w.resource);y?y.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const y=this.b.get(w);y&&(y.logger&&y.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=a;class d{constructor(){this.onDidChangeLogLevel=new L.$Rd().event}setLevel(w){}getLevel(){return g.Info}trace(w,...y){}debug(w,...y){}info(w,...y){}warn(w,...y){}error(w,...y){}critical(w,...y){}dispose(){}flush(){}}e.$pj=d;class v extends d{}e.$qj=v;function m(h){if(h.verbose)return g.Trace;if(typeof h.logLevel=="string"){const w=S(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gj}e.$rj=m;function I(h){switch(h){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$sj=I;function S(h){switch(h){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$tj=S,e.$uj=new k.$aj("logLevel",I(g.Info))}),define(Pe[187],Ae([1,0,6,15]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;class A extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$nj([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$XN=A}),define(Pe[98],Ae([1,0,31,154,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function f(p,g){return g-p}D.compare=f;const P=Object.create(null);P[D.Error]=(0,L.localize)(0,null),P[D.Warning]=(0,L.localize)(1,null),P[D.Info]=(0,L.localize)(2,null);function k(p){return P[p]||""}D.toString=k;function u(p){switch(p){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=u;function b(p){switch(p){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=b}(R||(e.MarkerSeverity=R={}));var $;(function(D){const f="";function P(u){return k(u,!0)}D.makeKey=P;function k(u,b){const p=[f];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(f),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(f),u.severity!==void 0&&u.severity!==null?p.push(R.toString(u.severity)):p.push(f),u.message&&b?p.push(u.message.replace("\xA6","\\\xA6")):p.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(f),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(f),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(f),p.push(f),p.join("\xA6")}D.makeKeyOptionalMessage=k})($||(e.IMarkerData=$={})),e.$gt=(0,A.$Vh)("markerService")}),define(Pe[188],Ae([1,0,5,31,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$7u=e.Severity=void 0,e.Severity=L.default,e.$7u=(0,A.$Vh)("notificationService");var M;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new f,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$8u=D;class f{infinite(){}done(){}total(k){}worked(k){}}e.$9u=f}),define(Pe[99],Ae([1,0,12,2,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QU=e.$PU=e.$OU=e.$NU=e.$MU=void 0,e.$MU=(0,A.$Vh)("openerService");function M(f,P){return L.URI.isUri(f)?(0,E.$6e)(f.scheme,P):(0,E.$7e)(f,P+":")}e.$NU=M;function R(f,...P){return P.some(k=>M(f,k))}e.$OU=R;function $(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$PU=$;function D(f){let P;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return k&&(P={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$QU=D}),define(Pe[189],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,E.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,E,L){var A=arguments.length,M=A<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(be,e,E,L);else for(var $=be.length-1;$>=0;$--)(R=be[$])&&(M=(A<3?R(M):A>3?R(e,E,M):R(e,E))||M);return A>3&&M&&Object.defineProperty(e,E,M),M},We=this&&this.__param||function(be,e){return function(E,L){e(E,L,be)}};define(Pe[72],Ae([1,0,14,20,6,4]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.ProgressLocation=e.$0u=void 0,e.$0u=(0,M.$Vh)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$$u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$_u=$;class D{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$av=D;let f=class extends A.$Rc{constructor(u,b){super(),this.a=new E.$ih,b.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,A.$Pc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$bv=f,e.$bv=f=Ke([We(1,e.$0u)],f);class P extends A.$Rc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Qc)}start(u){this.stop();const b=++this.a,p=new L.$2d;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Pc)(()=>p.cancel())),this.b.add((0,A.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:p.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$cv=P,e.$dv=(0,M.$Vh)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class A{constructor(){this.a=new Map}add(R,$){E.ok(L.$Cf(R)),E.ok(L.$Ef($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$mn=new A}),define(Pe[73],Ae([1,0,5,30]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function A($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,f){this.a[A(D)]=f,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$mn.add(e.$nn.JSONContribution,R)}),define(Pe[54],Ae([1,0,18,5,16,148,40,73,30]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var f;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$rn={Configuration:"base.contributions.configuration"};var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const k=D.$mn.as($.$nn.JSONContribution);class u{constructor(){this.h=new Set,this.i=new L.$Rd,this.onDidSchemaChange=this.i.event,this.j=new L.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=new Set;this.n(n,s,a),k.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(n){const s=new Set;this.o(n,s),k.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=new Set;this.o(s,a),this.n(n,!1,a),k.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const a=[];for(const{overrides:d,source:v}of n)for(const m in d)if(s.add(m),e.$Bn.test(m)){const I=this.a.get(m),S=I?.valuesSources??new Map;if(v)for(const C of Object.keys(d[m]))S.set(C,v);const h={...I?.value||{},...d[m]};this.a.set(m,{source:v,value:h,valuesSources:S});const w=(0,R.$zi)(m),y={type:"object",default:h,description:M.localize(1,null,w),$ref:e.$yn,defaultDefaultValue:h,source:A.$Cf(v)?void 0:v,defaultValueSource:v};a.push(...g(m)),this.d[m]=y,this.b.properties[m]=y}else{this.a.set(m,{value:d[m],source:v});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(a)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:a,source:d}of n)for(const v in a){const m=this.a.get(v),I=A.$Cf(d)?d:d?.id,S=A.$Cf(m?.source)?m?.source:m?.source?.id;if(I===S)if(s.add(v),this.a.delete(v),e.$Bn.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(n){let s=!1;const a=new Set;n.removedDefaults&&(this.l(n.removedDefaults,a),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,a),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,a),n.addedConfigurations&&this.n(n.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,a){n.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(n,s){const a=d=>{if(d.properties)for(const v in d.properties){s.add(v);const m=this.d[v];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[v],this.s(v,d.properties[v])}d.allOf?.forEach(v=>a(v))};for(const d of n){a(d);const v=this.c.indexOf(d);v!==-1&&this.c.splice(v,1)}}p(n,s=!0,a,d,v=3,m){v=A.$Lf(n.scope)?v:n.scope;const I=n.properties;if(I)for(const h in I){const w=I[h];if(s&&c(h,w)){delete I[h];continue}if(w.source=a,w.defaultDefaultValue=I[h].default,this.w(h,w),e.$Bn.test(h)?w.scope=void 0:(w.scope=A.$Lf(w.scope)?v:w.scope,w.restricted=A.$Lf(w.restricted)?!!d?.includes(h):w.restricted),I[h].hasOwnProperty("included")&&!I[h].included){this.f[h]=I[h],delete I[h];continue}else this.d[h]=I[h],I[h].policy?.name&&this.e.set(I[h].policy.name,h);!I[h].deprecationMessage&&I[h].markdownDeprecationMessage&&(I[h].deprecationMessage=I[h].markdownDeprecationMessage),m.add(h)}const S=n.allOf;if(S)for(const h of S)this.p(h,s,a,d,v,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=a=>{const d=a.properties;if(d)for(const m in d)this.r(m,d[m]);a.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$sn.properties[n]=s,s.scope){case 1:e.$tn.properties[n]=s;break;case 2:e.$un.properties[n]=s;break;case 6:e.$vn.properties[n]=s;break;case 3:e.$wn.properties[n]=s;break;case 4:e.$xn.properties[n]=s;break;case 5:e.$xn.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$sn.properties[n],s.scope){case 1:delete e.$tn.properties[n];break;case 2:delete e.$un.properties[n];break;case 6:delete e.$vn.properties[n];break;case 3:delete e.$wn.properties[n];break;case 4:case 5:delete e.$xn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(s,a),e.$sn.properties[s]=a,e.$tn.properties[s]=a,e.$un.properties[s]=a,e.$vn.properties[s]=a,e.$wn.properties[s]=a,e.$xn.properties[s]=a}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=n,e.$tn.patternProperties[e.$An]=n,e.$un.patternProperties[e.$An]=n,e.$vn.patternProperties[e.$An]=n,e.$wn.patternProperties[e.$An]=n,e.$xn.patternProperties[e.$An]=n,this.i.fire()}w(n,s){const a=this.a.get(n);let d=a?.value,v=a?.source;A.$Jf(d)&&(d=s.defaultDefaultValue,v=void 0),A.$Jf(d)&&(d=i(s.type)),s.default=d,s.defaultValueSource=v}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$An=`^(${b})+$`,e.$Bn=new RegExp(e.$An);function g(l){const n=[];if(e.$Bn.test(l)){let s=p.exec(l);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=p.exec(l)}}return(0,E.$Lb)(n)}e.$Cn=g;function t(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.$Dn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=i;const r=new u;D.$mn.add(e.$rn.Configuration,r);function c(l,n){return l.trim()?e.$Bn.test(l)?M.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,l,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Fn=c;function o(){const l=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Gn=o}),define(Pe[190],Ae([1,0,18,5,119,6,28,26,16,2,40,54,30]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function b(s){return Object.isFrozen(s)?s:$.$bn(s)}class p{constructor(a={},d=[],v=[],m){this.b=a,this.c=d,this.d=v,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof p)return d;const v=new g("");return v.parseRaw(d),v.configurationModel});this.f=a.reduce((d,v)=>v===d?v:d.merge(v),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,P.$xi)(this.contents,a):this.contents}inspect(a,d){const v=this.rawConfiguration.getValue(a),m=d?this.rawConfiguration.getOverrideValue(a,d):void 0,I=d?this.rawConfiguration.override(d).getValue(a):v;return{value:v,override:m,merged:I}}getOverrideValue(a,d){const v=this.i(d);return v?a?(0,P.$xi)(v,a):v:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const v of this.overrides)v.identifiers.includes(a)&&d.push(...v.keys);return E.$Lb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return E.$Lb(a)}override(a){let d=this.a.get(a);return d||(d=this.g(a),this.a.set(a,d)),d}merge(...a){const d=$.$an(this.contents),v=$.$an(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of a)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(d,S.contents);for(const h of S.overrides){const[w]=v.filter(y=>E.$tb(y.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=E.$Lb(w.keys)):v.push($.$an(h))}for(const h of S.keys)m.indexOf(h)===-1&&m.push(h)}return new p(d,m,v,I.every(S=>S instanceof p)?void 0:I)}g(a){const d=this.i(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const v={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let I=this.contents[m];const S=d[m];S&&(typeof I=="object"&&typeof S=="object"?(I=$.$an(I),this.h(I,S)):I=S),v[m]=I}return new p(v,this.keys,this.overrides)}h(a,d){for(const v of Object.keys(d)){if(v in a&&D.$Ef(a[v])&&D.$Ef(d[v])){this.h(a[v],d[v]);continue}a[v]=$.$an(d[v])}}i(a){let d=null,v=null;const m=I=>{I&&(v?this.h(v,I):v=$.$an(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===a?d=I.contents:I.identifiers.includes(a)&&m(I.contents);return m(d),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.j(a,d,!0)}setValue(a,d){this.j(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,P.$wi)(this.contents,a),k.$Bn.test(a)&&this.overrides.splice(this.overrides.findIndex(v=>E.$tb(v.identifiers,(0,k.$Cn)(a))),1))}j(a,d,v){(0,P.$vi)(this.contents,a,d,m=>console.error(m)),v=v||this.keys.indexOf(a)===-1,v&&this.keys.push(a),k.$Bn.test(a)&&this.overrides.push({identifiers:(0,k.$Cn)(a),keys:Object.keys(this.contents[a]),contents:(0,P.$ui)(this.contents[a],m=>console.error(m))})}}e.$Hn=p;class g{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!D.$Lf(a)){const v=this.g(a);this.parseRaw(v,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:v,keys:m,overrides:I,restricted:S,hasExcludedProperties:h}=this.h(a,d);this.b=new p(v,m,I,h?[a]:void 0),this.c=S||[]}g(a){let d={},v=null,m=[];const I=[],S=[];function h(y){Array.isArray(m)?m.push(y):v!==null&&(m[v]=y)}const w={onObjectBegin:()=>{const y={};h(y),I.push(m),m=y,v=null},onObjectProperty:y=>{v=y},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const y=[];h(y),I.push(m),m=y,v=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:h,onError:(y,C,W)=>{S.push({error:y,offset:C,length:W})}};if(a)try{A.$0m(a,w),d=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return d}h(a,d){const v=u.$mn.as(k.$rn.Configuration).getConfigurationProperties(),m=this.i(a,v,!0,d);a=m.raw;const I=(0,P.$ui)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),S=Object.keys(a),h=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:I,keys:S,overrides:h,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(a,d,v,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:I};const S={},h=[];for(const w in a)if(k.$Bn.test(w)&&v){const y=this.i(a[w],d,!1,m);S[w]=y.raw,I=I||y.hasExcludedProperties,h.push(...y.restricted)}else{const y=d[w],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&h.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&y?.restricted))?S[w]=a[w]:I=!0}return{raw:S,restricted:h,hasExcludedProperties:I}}j(a,d){const v=[];for(const m of Object.keys(a))if(k.$Bn.test(m)){const I={};for(const S in a[m])I[S]=a[m][S];v.push({identifiers:(0,k.$Cn)(m),keys:Object.keys(I),contents:(0,P.$ui)(I,d)})}return v}}e.$In=g;class t extends M.$Rc{constructor(a,d,v,m){super(),this.c=a,this.f=d,this.g=m,this.b=this.B(new L.$Rd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&v.isEqual(I.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=t;class i{constructor(a,d,v,m,I,S,h,w,y,C,W,K,U){this.a=a,this.b=d,this.c=v,this.overrideIdentifiers=m,this.d=I,this.f=S,this.g=h,this.h=w,this.i=y,this.j=C,this.k=W,this.l=K,this.m=U}get value(){return b(this.c)}n(a,d,v){const m=a.inspect(d,v);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,d,v,m,I=new p,S=new p,h=new R.$zc,w=new p,y=new R.$zc){this.c=a,this.d=d,this.f=v,this.g=m,this.h=I,this.i=S,this.j=h,this.l=w,this.m=y,this.a=null,this.b=new R.$zc,this.n=null}getValue(a,d,v){return this.p(a,d,v).getValue(a)}updateValue(a,d,v={}){let m;v.resource?(m=this.m.get(v.resource),m||(m=new p,this.m.set(v.resource,m))):m=this.l,d===void 0?m.removeValue(a):m.setValue(a,d),v.resource||(this.a=null)}inspect(a,d,v){const m=this.p(a,d,v),I=this.t(d.resource,v),S=d.resource?this.m.get(d.resource)||this.l:this.l,h=new Set;for(const w of m.overrides)for(const y of w.identifiers)m.getOverrideValue(a,y)!==void 0&&h.add(y);return new i(a,d,m.getValue(a),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,I||void 0,S)}keys(a){const d=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,d){this.j.set(a,d),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const v=[];if(!d){const{added:m,updated:I,removed:S}=l(this.c,a);d=[...m,...I,...S]}for(const m of d)for(const I of(0,k.$Cn)(m)){const S=this.c.getKeysForOverrideIdentifier(I),h=a.getKeysForOverrideIdentifier(I),w=[...h.filter(y=>S.indexOf(y)===-1),...S.filter(y=>h.indexOf(y)===-1),...S.filter(y=>!$.$en(this.c.override(I).getValue(y),a.override(I).getValue(y)))];v.push([I,w])}return this.updateDefaultConfiguration(a),{keys:d,overrides:v}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:v,removed:m}=l(this.d,a),I=[...d,...v,...m];return I.length&&this.updatePolicyConfiguration(a),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:v,removed:m,overrides:I}=l(this.applicationConfiguration,a),S=[...d,...v,...m];return S.length&&this.updateApplicationConfiguration(a),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:v,removed:m,overrides:I}=l(this.localUserConfiguration,a),S=[...d,...v,...m];return S.length&&this.updateLocalUserConfiguration(a),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:v,removed:m,overrides:I}=l(this.remoteUserConfiguration,a),S=[...d,...v,...m];return S.length&&this.updateRemoteUserConfiguration(a),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:v,removed:m,overrides:I}=l(this.workspaceConfiguration,a),S=[...d,...v,...m];return S.length&&this.updateWorkspaceConfiguration(a),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(a,d){const v=this.folderConfigurations.get(a),{added:m,updated:I,removed:S,overrides:h}=l(v,d),w=[...m,...I,...S];return(w.length||!v)&&this.updateFolderConfiguration(a,d),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:v,updated:m,removed:I,overrides:S}=l(d,void 0);return{keys:[...v,...m,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,d,v){let m=this.q(d,v);return d.overrideIdentifier&&(m=m.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(m=m.merge(this.d)),m}q({resource:a},d){let v=this.r();if(d&&a){const m=d.getFolder(a);m&&(v=this.s(m.uri)||v);const I=this.m.get(a);I&&(v=v.merge(I))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let d=this.b.get(a);if(!d){const v=this.r(),m=this.j.get(a);m?(d=v.merge(m),this.b.set(a,d)):d=v}return d}t(a,d){if(d&&a){const v=d.getFolder(a);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,d)=>{const{contents:v,overrides:m,keys:I}=this.j.get(d);return a.push([d,{contents:v,overrides:m,keys:I}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.i.keys.forEach(d=>a.add(d)),this.j.forEach(d=>d.keys.forEach(v=>a.add(v))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(v=>a.add(v))),[...a.values()]}v(a){const d=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.i.getKeysForOverrideIdentifier(a).forEach(v=>d.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(a).forEach(m=>d.add(m))),[...d.values()]}static parse(a){const d=this.w(a.defaults),v=this.w(a.policy),m=this.w(a.application),I=this.w(a.user),S=this.w(a.workspace),h=a.folders.reduce((w,y)=>(w.set(f.URI.revive(y[0]),this.w(y[1])),w),new R.$zc);return new r(d,v,m,I,new p,S,h,new p,new R.$zc)}static w(a){return new p(a.contents,a.keys,a.overrides)}}e.$Kn=r;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,d=new Map;for(const m of s)m.keys.forEach(I=>a.add(I)),m.overrides.forEach(([I,S])=>{const h=(0,R.$wc)(d,I,new Set);S.forEach(w=>h.add(w))});const v=[];return d.forEach((m,I)=>v.push([I,[...m.values()]])),{keys:[...a.values()],overrides:v}}e.$Ln=c;class o{constructor(a,d,v,m){this.change=a,this.f=d,this.g=v,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of a.keys)this.affectedKeys.add(I);for(const[,I]of a.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,d){const v=this.a+a,m=this.d.indexOf(v);if(m<0)return!1;const I=m+v.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,w=this.g.getValue(a,d,this.h);return!$.$en(h,w)}return!0}}e.$Mn=o;function l(s,a){const{added:d,removed:v,updated:m}=n(a?.rawConfiguration,s?.rawConfiguration),I=[],S=s?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const w=h.filter(y=>!S.includes(y));for(const y of w)I.push([y,a.getKeysForOverrideIdentifier(y)])}if(s){const w=S.filter(y=>!h.includes(y));for(const y of w)I.push([y,s.getKeysForOverrideIdentifier(y)])}if(a&&s){for(const w of S)if(h.includes(w)){const y=n({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});I.push([w,[...y.added,...y.removed,...y.updated]])}}return{added:d,removed:v,updated:m,overrides:I}}function n(s,a){const d=s?a?s.keys.filter(I=>a.keys.indexOf(I)===-1):[...s.keys]:[],v=a?s?a.keys.filter(I=>s.keys.indexOf(I)===-1):[...a.keys]:[],m=[];if(s&&a){for(const I of a.keys)if(s.keys.indexOf(I)!==-1){const S=(0,P.$xi)(a.contents,I),h=(0,P.$xi)(s.contents,I);$.$en(S,h)||m.push(I)}}return{added:d,removed:v,updated:m}}}),define(Pe[100],Ae([1,0,11,4]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,L.$Vh)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class R{constructor(k,u){this.host=k,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=R;var $;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(k){return k instanceof D&&k._code===$.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===$.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===$.NoResolverFound}static isInvalidAuthority(k){return k instanceof D&&k._code===$.InvalidAuthority}static isHandled(k){return k instanceof D&&k.isHandled}constructor(k,u=$.Unknown,b){super(k),this._message=k,this._code=u,this._detail=b,this.isHandled=u===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Yk=D;function f(P){const k=P.indexOf("+");return k===-1?P:P.substring(0,k)}e.$Zk=f}),define(Pe[55],Ae([1,0,13]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function L(f){return f.scheme===E.Schemas.vscodeRemote?f.authority:void 0}e.$1k=L;function A(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$2k=A;function M(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$3k=M;function R(f){const{host:P,port:k}=D(f);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:k}}e.$4k=R;function $(f,P){let{host:k,port:u}=D(f);return typeof u>"u"&&(u=P),{host:k,port:u}}e.$5k=$;function D(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const k=f.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,c=typeof i=="string"?i:i.value;return E.$6e(r,c)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$_l=D;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$am=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=P;function k(g){return u(g)}e.$cm=k;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$dm=u;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$em=b;function p(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,A.$2k)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$fm=p,e.$gm=(0,L.$Vh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const f=this.readActivationEvents(D);f.length>0&&($[L.$_l.toKey(D.identifier)]=f)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let D=0;D<$.length;D++)$[D]==="onUri"&&($[D]=`onUri:${L.$_l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const D in R.contributes){const f=this.a.get(D);if(!f)continue;const P=R.contributes[D],k=Array.isArray(P)?P:[P];try{f(k,$)}catch(u){(0,E.$Z)(u)}}return $}}e.$xF=A,e.$yF=new A}),define(Pe[191],Ae([1,0,21,74,38]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,f,P,k,u,b,p,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=p,i.sessionID=(0,A.$ig)()+Date.now(),i.commitHash=k,i.version=u,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$h)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=P,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let r=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),E.$l&&(i["common.snap"]="true");const o=M(f);return o&&(i["common.platformDetail"]=o),i}e.$no=R;function $(D){const f=L.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return D.some(k=>P===k)}e.$oo=$}),define(Pe[192],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,E.$Vh)("telemetryService"),e.$jl=(0,E.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var A;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Pe[56],Ae([1,0,26,16,5,40,55,191,192]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class f{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$po=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=P,e.$ro=new P;class k{async publicLog(v,m,I){}async publicLogError(v,m,I){}}e.$so=k,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function u(d,v){return A.Event.debounce(v.onDidChangeConfiguration,(I,S)=>{const h=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:h}},1e3,!0)(I=>{I.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$wo=u;function b(d,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!d.enableTelemetry)}e.$xo=b;function p(d,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$yo=p;function g(d){const v=d.getValue(D.$ql),m=d.getValue(D.$rl);if(d.getValue(D.$sl)===!1||m===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=g;function t(d){const v={},m={},I={};c(d,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const h=I[S];typeof h=="number"?m[S]=h:typeof h=="boolean"?m[S]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${h.length}`),v[S]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(v[S]=h)}return{properties:v,measurements:m}}e.$Ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const v=(0,R.$2k)(d);return i.has(v)?v:"other"}e.$Bo=r;function c(d,v,m=0,I){if(d)for(const S of Object.getOwnPropertyNames(d)){const h=d[S],w=I?I+S:S;Array.isArray(h)?v[w]=(0,E.$fn)(h):h instanceof Date?v[w]=h.toISOString():(0,L.$Ef)(h)?m<2?c(h,v,m+1,w+"."):v[w]=(0,E.$fn)(h):v[w]=h}}function o(d,v){const m=d.msftInternalDomains||[],I=v.getValue("telemetry.internalTesting");return(0,$.$oo)(m)||I}e.$Co=o;function l(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Do=l;function n(d,v){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let m=d;const I=[];for(const y of v)for(;;){const C=y.exec(d);if(!C)break;I.push([C.index,y.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const y=h.exec(d);if(!y)break;const C=I.some(([W,K])=>y.index<K&&W<h.lastIndex);!S.test(y[0])&&!C&&(m+=d.substring(w,y.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<d.length&&(m+=d.substr(w)),m}function s(d){if(!d)return d;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of v)if(m.regex.test(d))return`<REDACTED: ${m.label}>`;return d}function a(d,v){return(0,E.$cn)(d,m=>{if(m instanceof f||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=n(I,v);for(const S of v)I=I.replace(S,"");return I=s(I),I}})}e.$Eo=a}),define(Pe[193],Ae([1,0,12,96,22,21,2,11,74,56]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function P(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,E.$1e)(a.id,d.id)===0}e.$Fo=P;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const v=d.manifest?d.manifest.version:d.version,m=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,v,m)}static parse(d){const v=k.exec(d);return v&&v[1]&&v[2]?new u({id:v[1]},v[2],v[4]||void 0):null}constructor(d,v,m="undefined"){this.version=v,this.targetPlatform=m,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?P(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Go=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(a){const d=b.exec(a);return d&&d[1]?[t(d[1]),d[2]]:[t(a),void 0]}e.$Ho=p;function g(a,d){return`${a}.${d}`}e.$Io=g;function t(a){return a.toLowerCase()}e.$Jo=t;function i(a,d){return t(g(a??A.$8l,d))}e.$Ko=i;function r(a,d){const v=[],m=I=>{for(const S of v)if(S.some(h=>P(d(h),d(I))))return S;return null};for(const I of a){const S=m(I);S?S.push(I):v.push([I])}return v}e.$Lo=r;function c(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Mo=c;function o(a){return{id:new f.$po(a.identifier.id),name:new f.$po(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$No=o,e.$Oo=new A.$_l("pprice.better-merge");function l(a,d){const v=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&v.every(S=>!P(S.identifier,{id:I}))){const S=a.filter(h=>P(h.identifier,{id:I}));S.length===1&&(v.push(S[0]),m.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$Po=l;async function n(a,d){if(!M.$k)return!1;let v;try{v=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){d.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,d){const v=await n(a,d),m=(0,L.$_n)(v?"alpine":M.$u,D.$dc);return d.debug("ComputeTargetPlatform:",m),m}e.$Qo=s}),define(Pe[194],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=void 0;function E(D){return[...D.entries()]}e.$rr=E;function L(D){return D?[...D.entries()]:[]}e.$sr=L;function A(D){return new Map(D)}e.$tr=A;function M(D){return new Map(D??[])}e.$ur=M;function R(D){return Array.from(D.entries()).map(f=>[f[0],E(f[1].map),L(f[1].descriptionMap)])}e.$vr=R;function $(D){return new Map(D.map(f=>[f[0],{map:A(f[1]),descriptionMap:M(f[2])}]))}e.$wr=$}),define(Pe[195],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqb=void 0;class E{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,M,R=5){const $=M(D=>{const f=typeof D=="string"?D:D.data;let P=this.a.get(A);if(P){P.data.push(f);return}const k=setTimeout(()=>this.flushBuffer(A),R);P={data:[f],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(A),$.dispose()}},this.a.set(A,P)});return $}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const M=this.a.get(A);M&&(this.a.delete(A),this.b(A,M.data.join("")))}}e.$nqb=E}),define(Pe[196],Ae([1,0,14,90,45,5,16,2,155,73,30]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var k;(function(o){function l(n,s){let a=n.defaults;for(;A.ThemeIcon.isThemeIcon(a);){const d=p.getIcon(a.id);if(!d)return;a=d.defaults}return a}o.getDefinition=l})(k||(e.IconContribution=k={}));var u;(function(o){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=l;function n(s){const a=d=>(0,R.$Cf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Cf)(d.format)&&(0,R.$Cf)(d.location)))return{weight:a(s.weight),style:a(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}o.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,n,s,a){const d=this.b[l];if(d){if(s&&!d.description){d.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return d}const v={id:l,description:s,defaults:n,deprecationMessage:a};this.b[l]=v;const m={$ref:"#/definitions/icons"};return a&&(m.deprecationMessage=a),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const n=this.e.enum.indexOf(l);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,n){const s=this.f[l];return s||(this.f[l]=n,this.a.fire(),n)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(d,v)=>d.id.localeCompare(v.id),n=d=>{for(;A.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(d=>this.b[d]);for(const d of a.filter(v=>!!v.description).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|${A.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of a.filter(v=>!A.ThemeIcon.isThemeIcon(v.defaults)).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|`);return s.join(`
`)}}const p=new b;P.$mn.add(e.$_v.IconContribution,p);function g(o,l,n,s){return p.registerIcon(o,l,n,s)}e.$aw=g;function t(){return p}e.$bw=t;function i(){const o=(0,L.$Yj)();for(const l in o){const n="\\"+o[l].toString(16);p.registerIcon(l,{fontCharacter:n})}}i(),e.$cw="vscode://schemas/icons";const r=P.$mn.as(f.$nn.JSONContribution);r.registerSchema(e.$cw,p.getIconSchema());const c=new E.$0g(()=>r.notifySchemaChanged(e.$cw),200);p.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$dw=g("widget-close",L.$1j.close,(0,D.localize)(2,null)),e.$ew=g("goto-previous-location",L.$1j.arrowUp,(0,D.localize)(3,null)),e.$fw=g("goto-next-location",L.$1j.arrowDown,(0,D.localize)(4,null)),e.$gw=A.ThemeIcon.modify(L.$1j.sync,"spin"),e.$hw=A.ThemeIcon.modify(L.$1j.loading,"spin")}),define(Pe[197],Ae([1,0,5,40,4,15]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.ProvidedOnAutoForward=e.$gv=e.TunnelPrivacyId=e.TunnelProtocol=e.$fv=e.$ev=void 0,e.$ev=(0,A.$Vh)("tunnelService"),e.$fv=(0,A.$Vh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$gv=D;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$hv=P,e.$iv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(t){return e.$iv.indexOf(t)>=0}e.$jv=k,e.$kv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$kv.indexOf(t)>=0}e.$lv=u;function b(t,i,r,c){if(r===1)return!1;if(r===2&&u(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$mv=b;class p{constructor(i,r,c){this.remoteAddress=i,this.localAddress=r,this.b=c,this.a=new E.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$nv=p;let g=class{constructor(i,r){this.j=i,this.k=r,this.a=new E.$Rd,this.onTunnelOpened=this.a.event,this.b=new E.$Rd,this.onTunnelClosed=this.b.event,this.c=new E.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const c of r){const o=Array.from(c.values());for(const l of o){const n=await l.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,c,o,l){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:c,privacy:o,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(u(i)||k(i))&&(i=e.$iv[0]);const c=this.r(i,r);if(c)return++c.refcount,c.value}openTunnel(i,r,c,o,l,n=!1,s,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${l}.`);const d=this.f??i;if(!d)return;if(r||(r="localhost"),o||(o=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(d,r,c,o,l,n,s,a);return v?v.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const c=r.get(i.tunnelRemotePort);c&&(c.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,c))}}}}async o(i,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=c.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const c=this.e.get(i);if(c&&c.has(r)){const o=c.get(r);o.refcount=0,await this.o(i,r,o)}}p(i,r,c){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:c})}async q(i,r){const c=this.e.get(i);if(c){const o=c.get(r),l=o?await o.value:void 0;(!l||typeof l=="string")&&c.delete(r),c.size===0&&this.e.delete(i)}}r(i,r){const c=[i];k(i)?(c.push(...e.$iv),c.push(...e.$kv)):u(i)&&c.push(...e.$kv);const o=c.map(l=>this.e.get(l));for(const l of o){const n=l?.get(r);if(n)return n}}canTunnel(i){return!!P(i)}t(i,r,c,o,l,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${o}.`);const a=c;this.i.add(a);const d=o===void 0?c:o,v={elevationRequired:l?this.isPortPrivileged(d):!1},m={remoteAddress:{host:r,port:c},localAddressPort:o,privacy:n,public:n?n!==$.Private:void 0,protocol:s},I=i.forwardPort(m,v);return I?(this.p(r,c,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),I}};e.$ov=g,e.$ov=g=Ke([We(0,M.$dj),We(1,L.$pi)],g)}),define(Pe[198],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$pv=void 0,e.$pv=(0,E.$Vh)("editSessionIdentityService");var L;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Pe[199],Ae([1,0,13]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$8J=L;function A(D){if(D.folders.length)return D.folders.every(f=>L(f.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$9J=A;function M(D){return A(D)?.scheme}e.$0J=M;function R(D){return A(D)?.authority}e.$$J=R;function $(D){return A(D)!==void 0}e.$_J=$}),define(Pe[47],Ae([1,0,156,19,50,25,2,4,13]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,$.$Vh)("contextService");function f(d){const v=d;return typeof v?.id=="string"&&R.URI.isUri(v.uri)}e.$6h=f;function P(d){return typeof d?.id=="string"&&!f(d)&&!u(d)}e.$7h=P,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function k(d,v){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,L.$mc)(d)}:v?e.$8h:e.$9h;const m=d;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$0h=k;function u(d){const v=d;return typeof v?.id=="string"&&R.URI.isUri(v.configPath)}e.$$h=u;function b(d){const v=d;if(v?.uri)return{id:v.id,uri:R.URI.revive(v.uri)};const m=d;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(d?.id)return{id:d.id}}e.$_h=b;var p;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function g(d){const v=d;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$ai=g;function t(d){const v=d;return!!(v&&typeof v=="object"&&R.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$bi=t;class i{constructor(v,m,I,S,h){this.h=v,this.j=I,this.k=S,this.l=h,this.c=A.$2h.forUris(this.l,()=>!0),this.folders=m}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=A.$2h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=i;class r{constructor(v,m){this.raw=m,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$zg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=r;function c(d){return new r({uri:d,index:0,name:(0,M.$vg)(d)},{uri:d.toString()})}e.$ei=c,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,E.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function o(d,v){return M.$qg.isEqualOrParent(d,v.untitledWorkspacesHome)}e.$ji=o;function l(d){let v;return R.URI.isUri(d)?v=d:v=d.configuration,v?.scheme===D.Schemas.tmp}e.$ki=l,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(d){return d.id===e.$li}e.$mi=n;function s(d,v){return!o(d,v)&&!l(d)}e.$ni=s;function a(d){return(typeof d=="string"?(0,L.$nc)(d):(0,M.$xg)(d))===e.$gi}e.$oi=a}),define(Pe[75],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;class E{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const M=this.c++;return this.b.set(M,A),this.e(),M}get(A,M){return this.b.has(A)?this.b.get(A)[M]:void 0}delete(A){this.b.delete(A),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Adc=E}),define(Pe[42],Ae([1,0,13,25,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$og($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Ddc=M,e.$Edc=(0,A.$Vh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$QM=(0,E.$Vh)("IExtHostInitDataService")}),define(Pe[200],Ae([1,0,161,15,187,27]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;let R=class extends A.$XN{constructor(D,f,P){const k=P.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",u=P.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(f.createLogger(k,{name:u}))}};e.$Kfc=R,e.$Kfc=R=Ke([We(1,L.$ej),We(2,M.$QM)],R)}),define(Pe[201],Ae([1,0,14]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new E.$0g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const k of f.values())k.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const f=new E.$ih;return this.h.set(R,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$mec=L;class A extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$nec=A}),define(Pe[202],Ae([1,0,5,2]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class A{constructor(R){this.c=R,this.a=new E.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,f){const k=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,f);this.b.fire(k)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$afc=A}),define(Pe[17],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,E.$Vh)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$BM=L}),define(Pe[203],Ae([1,0,22,5]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class A{#e;constructor(R,$){this.b=new L.$Rd,this.onDidChange=this.b.event,this.a=E.$_l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$uec=A}),define(Pe[57],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0,e.$Wdc=(0,E.$Vh)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Xdc=L}),define(Pe[204],Ae([1,0,24]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdb=e.$gdb=void 0;class L{constructor(){this.buffers=[]}add(D){let f=this.buffers.indexOf(D);return f<0&&(f=this.buffers.length,this.buffers.push(D)),f}}function A($,D){if(D.serializeBuffersForPostMessage){const f=new L,k=JSON.stringify($,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p)};if(ArrayBuffer.isView(p)){const g=M(p);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p.buffer),view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=f.buffers.map(b=>{const p=new Uint8Array(b);return E.$fe.wrap(p)});return{message:k,buffers:u}}else return{message:JSON.stringify($),buffers:[]}}e.$gdb=A;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const f=D.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),P=D.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,t=f[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,P),arrayBuffers:f}}e.$hdb=R}),define(Pe[102],Ae([1,0,171,16,2,6,4,30,41,13,39,134,31]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var b;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function g(se){const Y=se;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$fE=g;function t(se,Y,B){for(const ie of B.visibleEditorPanes)if(ie.group.id===Y&&se.matches(ie.input))return ie.getViewState()}e.$gE=t;function i(se){if(I(se))return!1;const Y=se;return A.URI.isUri(Y?.resource)}e.$hE=i;function r(se){if(I(se))return!1;const Y=se;return Y?.original!==void 0&&Y.modified!==void 0}e.$iE=r;function c(se){if(I(se))return!1;const Y=se;return Array.isArray(Y?.resources)}e.$jE=c;function o(se){if(I(se)||r(se))return!1;const Y=se;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$kE=o;function l(se){if(I(se))return!1;const Y=se;return Y?Y.resource===void 0||Y.resource.scheme===f.Schemas.untitled||Y.forceUntitled===!0:!1}e.$lE=l;function n(se){if(I(se))return!1;const Y=se;return A.URI.isUri(Y?.base?.resource)&&A.URI.isUri(Y?.input1?.resource)&&A.URI.isUri(Y?.input2?.resource)&&A.URI.isUri(Y?.result?.resource)}e.$mE=n;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class d{constructor(){this.a=new Map}registerSource(Y,B){let ie=this.a.get(Y);return ie||(ie={source:Y,label:B},this.a.set(Y,ie)),ie.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$nE=new d;var v;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class m extends M.$Rc{}e.$oE=m;function I(se){return se instanceof m}e.$pE=I;function S(se){const Y=se;return A.URI.isUri(Y?.preferredResource)}function h(se){const Y=se;return I(Y?.primary)&&I(Y?.secondary)}e.$qE=h;function w(se){const Y=se;return I(Y?.modified)&&I(Y?.original)}e.$rE=w;function y(se,Y,B,ie,me){return Re(ie,[(0,k.$Fi)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const ne={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(Y,ne)}}),(0,k.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>me.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$sE=y;function C(se){return I(se?.editor)}e.$tE=C;function W(se){const Y=se;return C(se)&&Y?.group!==void 0}e.$uE=W;function K(se){const Y=se;return typeof Y?.groupId=="number"&&I(Y.editor)}e.$vE=K;var U;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var z;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var F;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class O{getOriginalUri(Y,B){if(!Y)return;if(n(Y))return e.$xE.getOriginalUri(Y.result,B);if(B?.supportSideBySide){const{primary:me,secondary:ne}=this.a(Y);if(me&&ne){if(B?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(me,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===F.ANY)return this.getOriginalUri(me,{filterByScheme:B.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===F.PRIMARY?me:ne}}if(r(Y)||c(Y)||o(Y)||n(Y))return;const ie=S(Y)?Y.preferredResource:Y.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}a(Y){return h(Y)||o(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||r(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,B){if(!Y)return;if(n(Y))return e.$xE.getCanonicalUri(Y.result,B);if(B?.supportSideBySide){const{primary:me,secondary:ne}=this.a(Y);if(me&&ne){if(B?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(me,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===F.ANY)return this.getCanonicalUri(me,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===F.PRIMARY?me:ne}}if(r(Y)||c(Y)||o(Y)||n(Y))return;const ie=Y.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}b(Y,B){if(Array.isArray(B)){if(B.some(ie=>Y.scheme===ie))return Y}else if(B===Y.scheme)return Y}}var X;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function $e(se,Y,B,ie){if(!se.isSticky(Y))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return B===X.MOUSE||B===X.KEYBOARD;case"mouse":return B===X.MOUSE;case"keyboard":return B===X.KEYBOARD}return!1}e.$wE=$e,e.$xE=new O;var Ee;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(Ee||(e.CloseDirection=Ee={}));class De{constructor(){this.c=new Map,this.d=new Map}start(Y){const B=this.a=Y.get(R.$Uh);for(const[ie,me]of this.c)this.e(ie,me,B);this.c.clear()}e(Y,B,ie){const me=ie.createInstance(B);this.d.set(Y,me)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,L.$Nf)(this.b)}registerEditorSerializer(Y,B){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,B,this.a):this.c.set(Y,B),(0,M.$Pc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}$.$mn.add(e.$aE.EditorFactory,new De);async function Ce(se,Y,B){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const me=A.URI.revive(ie.fileUri);if(!me){B.info("Cannot resolve the path because it is not valid.",ie);return}if(!await Y.canHandleResource(me)){B.info("Cannot resolve the path because it cannot be handled",ie);return}let le=ie.exists,ce=ie.type;if(typeof le!="boolean"||typeof ce!="number")try{ce=(await Y.stat(me)).isDirectory?D.FileType.Directory:D.FileType.Unknown,le=!0}catch(_){B.error(_),le=!1}if(!le&&ie.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ie);return}if(ce===D.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ie);return}const we={...ie.options,pinned:!0};return le?{resource:me,options:we}:{resource:me,options:we,forceUntitled:!0}}))}e.$yE=Ce;var de;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(de||(e.EditorsOrder=de={}));function pe(se){const Y=se;if(!Y)return!1;const B=Y;if(B.modified)return pe(B.modified);const ie=Y;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$zE=pe;function re(se){return(0,P.$Hi)(se)}e.$AE=re;function Re(se,Y,B){const ie=(0,P.$Ii)(se,Y);return ie.forceMessage=B?.forceMessage,ie.forceSeverity=B?.forceSeverity,ie.allowDialog=B?.allowDialog,ie}e.$BE=Re}),define(Pe[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,L.localize)(0,null),e.$EE=(0,k.$aw)("default-view-icon",P.$1j.window,(0,L.localize)(1,null));var u;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$FE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=p;class g extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(a,d,v){const m=this.get(a.id);if(m)return m;const I=a;return I.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,d,[]).push(I),v?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:d}),I}deregisterViewContainer(a){for(const d of this.g.keys()){const v=this.g.get(d),m=v?.indexOf(a);if(m!==-1){v?.splice(m,1),v.length===0&&this.g.delete(d),this.f.fire({viewContainer:a,viewContainerLocation:d});return}}}get(a){return this.all.filter(d=>d.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(v=>v?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(d=>this.getViewContainerLocation(d)===a)}}$.$mn.add(u.ViewContainersRegistry,new g);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,a){const d=s.group??t.More,v=a.group??t.More;return d!==v?d.localeCompare(v):(s.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(a,d){this.registerViews2([{views:a,viewContainer:d}])}registerViews2(a){a.forEach(({views:d,viewContainer:v})=>this.r(d,v)),this.c.fire(a)}deregisterViews(a,d){const v=this.s(a,d);v.length&&this.f.fire({views:v,viewContainer:d})}moveViews(a,d){for(const v of this.m.keys())if(v!==d){const m=this.s(a,v);m.length&&(this.r(m,d),this.g.fire({views:m,from:v,to:d}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const d of this.j){const v=(this.m.get(d)||[]).filter(m=>m.id===a)[0];if(v)return v}return null}getViewContainer(a){for(const d of this.j)if((this.m.get(d)||[]).filter(m=>m.id===a)[0])return d;return null}registerViewWelcomeContent(a,d){return this.n.add(a,d),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,d),this.h.fire(a)})}registerViewWelcomeContent2(a,d){const v=new Map;for(const[m,I]of d)this.n.add(a,I),v.set(m,(0,M.$Pc)(()=>{this.n.delete(a,I),this.h.fire(a)}));return this.h.fire(a),v}getViewWelcomeContent(a){const d=[];return this.n.forEach(a,v=>d.push(v)),d.sort(i)}r(a,d){let v=this.m.get(d);v||(v=[],this.m.set(d,v),this.j.push(d));for(const m of a){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));v.push(m)}}s(a,d){const v=this.m.get(d);if(!v)return[];const m=[],I=[];for(const S of v)a.includes(S)?m.push(S):I.push(S);return m.length&&(I.length?this.m.set(d,I):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),m}}$.$mn.add(u.ViewsRegistry,new r),e.$HE=(0,A.$Vh)("viewsService"),e.$IE=(0,A.$Vh)("viewDescriptorService");var c;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(a,d){this.c=!1,this.d=!1,(0,f.$dn)(this,a),this.d=!!d,this.resolve=async v=>{if(d&&!this.c){const m=await d(v);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=l;class n extends Error{constructor(a){super((0,L.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$KE=n}),define(Pe[206],Ae([1,0,2,29,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$_E=e.$$E=void 0;function M(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof E.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(L.$As.isIRange)}e.$$E=M;function R(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(M)}e.$_E=R;var $;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$aF=(0,A.$Vh)("IChatService")}),define(Pe[207],Ae([1,0,5,14,173]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Rd,this.n=new E.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,f,P){const k={command:$};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(k.seq);if(b){this.f.delete(k.seq);const p={type:"response",seq:0,request_seq:k.seq,success:!1,command:$,message:(0,A.localize)(0,null,P,$)};b(p)}},P)}return f&&this.f.set(k.seq,f),k.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Yg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,f=this.f.get(D.request_seq);f&&(this.f.delete(D.request_seq),f(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,f)=>$.set(f,D)),await(0,L.$Yg)(500),$.forEach((D,f)=>{D({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Mdb=M}),define(Pe[208],Ae([1,0,174,34,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$lH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$kH=e.MemoryRangeType=e.$jH=e.State=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new L.$aj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$qG=new L.$aj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$rG=new L.$aj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$sG="debugUx",e.$tG=new L.$aj(e.$sG,"default",{type:"string",description:E.localize(3,null)}),e.$uG=new L.$aj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$vG=new L.$aj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$wG=new L.$aj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$xG=new L.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$yG=new L.$aj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$zG=new L.$aj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$AG=new L.$aj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$BG=new L.$aj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$CG=new L.$aj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$DG=new L.$aj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$EG=new L.$aj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$FG=new L.$aj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$GG=new L.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$HG=new L.$aj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$IG=new L.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$JG=new L.$aj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$KG=new L.$aj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$LG=new L.$aj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$MG=new L.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$NG=new L.$aj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$OG=new L.$aj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$PG=new L.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$QG=new L.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$RG=new L.$aj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$SG=new L.$aj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$TG=new L.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$UG=new L.$aj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$VG=new L.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$WG=new L.$aj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$XG=new L.$aj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$YG=new L.$aj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$ZG=new L.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$1G=new L.$aj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$2G=new L.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$3G=new L.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$4G=new L.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$5G=new L.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$6G=new L.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$7G=new L.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$8G=new L.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$9G=new L.$aj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$0G=new L.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$$G=new L.$aj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$_G=new L.$aj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$aH=new L.$aj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$bH=new L.$aj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$cH=new L.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$dH=new L.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=u=>E.localize(52,null,u);e.$eH=M,e.$fH="editor.contrib.debug",e.$gH="editor.contrib.breakpoint",e.$hH="debug",e.$iH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(R||(e.State=R={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$jH=$;var D;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$kH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$lH=(0,A.$Vh)("debugService");var k;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Pe[209],Ae([1,0,12,2,19,26,13,29,20,18]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const P=/{([^}]+)}/g;function k(S,h,w){return S.replace(P,function(y,C){return h&&C.length>0&&C[0]!=="_"?y:w&&w.hasOwnProperty(C)?w[C]:y})}e.$fF=k;function u(S){const h={};for(const w of Object.keys(S))w.startsWith("!")||(h[w]=S[w]);return h}e.$gF=u;function b(S){return S.configuration.request==="attach"&&!p(S)&&(!S.parentSession||b(S.parentSession))}e.$hF=b;function p(S){let h=S.configuration.type;if(h)return h==="vslsShare"&&(h=S.configuration.adapterProxy.configuration.type),(0,E.$6e)(h,"extensionhost")||(0,E.$6e)(h,"pwa-extensionhost")?S:S.parentSession?p(S.parentSession):void 0}e.$iF=p;function g(S){return S.type&&(S.label||S.program||S.runtime)}e.$jF=g;function t(S,h,w){let y,C=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const U=K.index+1,z=U+K[0].length;if(U<=h&&z>=w){y=K[0],C=U;break}}if(y){const U=/\w+/g;let z=null;for(;(z=U.exec(y))&&!(z.index+1+C+z[0].length>=w););z&&(y=y.substring(0,U.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.$kF=t;async function i(S,h,w,y){if(S.evaluatableExpressionProvider.has(h)){const C=S.evaluatableExpressionProvider.ordered(h),W=(0,f.$Gb)(await Promise.all(C.map(async K=>{try{return await K.provideEvaluatableExpression(h,w,y??D.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const U=W[0].range;return K||(K=h.getLineContent(w.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:K}}}else{const C=h.getLineContent(w.lineNumber),{start:W,end:K}=t(C,w.column,w.column),U=C.substring(W-1,K);return{matchingExpression:U,range:new $.$As(w.lineNumber,W,w.lineNumber,W+U.length)}}return null}e.$lF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(S){return!!(S&&S.match(r))}e.$mF=c;function o(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(c(S.path))return L.URI.parse(S.path);if((0,A.$hc)(S.path))return L.URI.file(S.path)}return S.path}function l(S){if(typeof S.path=="object"){const h=L.URI.revive(S.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return S.path}function n(S,h){const w=h?o:l,y=(0,M.$an)(S);return a(y,(C,W)=>{C&&W&&(W.path=w(W))}),y}e.$nF=n;function s(S,h){const w=h?o:l,y=(0,M.$an)(S);return a(y,(C,W)=>{!C&&W&&(W.path=w(W))}),y}e.$oF=s;function a(S,h){switch(S.type){case"event":{const w=S;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=S;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(y=>h(!1,y));break;default:break}break}case"response":{const w=S;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(y=>h(!1,y.source));break;case"loadedSources":w.body.sources.forEach(y=>h(!1,y));break;case"scopes":w.body.scopes.forEach(y=>h(!1,y.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(y=>h(!1,y.source));break;case"setBreakpoints":w.body.breakpoints.forEach(y=>h(!1,y.source));break;case"disassemble":w.body?.instructions.forEach(C=>h(!1,C.location));break;default:break}break}}}function d(S){return S.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):v(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:v(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$pF=d;function v(S,h){return typeof S!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:S-h}async function m(S,h){const w=S.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const y=h.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:y.input,groupId:y.group.id})}await S.reloadConfiguration()}e.$qF=m;const I=(S,h)=>!S||!h?S===h:S.name===h.name&&S.path===h.path&&S.sourceReference===h.sourceReference;e.$rF=I}),define(Pe[76],Ae([1,0,24,33,67,68,13,19,21,34]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.$DI=e.$CI=e.$BI=e.CellStatusbarAlignment=e.$AI=e.$zI=e.$yI=e.NotebookEditorPriority=e.$xI=e.$wI=e.$vI=e.$uI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$tI=e.$sI=e.$rI=e.$qI=e.CellKind=e.$pI=e.$oI=e.$nI=void 0,e.$nI="workbench.editor.notebook",e.$oI="workbench.editor.notebookTextDiffEditor",e.$pI="workbench.editor.interactive";var P;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(P||(e.CellKind=P={})),e.$qI=["application/json","application/javascript","text/html","image/svg+xml",M.$Wr.latex,M.$Wr.markdown,"image/png","image/jpeg",M.$Wr.text],e.$rI=[M.$Wr.latex,M.$Wr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Wr.text],e.$sI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$tI="_notAvailable";var k;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var u;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var g;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(O){O.scheme=R.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],$e=new RegExp(`^[${X.join("")}]+`),Ee=7;function De(se,Y){const B=Y.toString(Ee),me=`${B.length<X.length?X[B.length-1]:"z"}${B}s${(0,E.$ze)(E.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:O.scheme,fragment:me})}O.generate=De;function Ce(se){if(se.scheme!==O.scheme)return;const Y=se.fragment.indexOf("s");if(Y<0)return;const B=parseInt(se.fragment.substring(0,Y).replace($e,""),Ee),ie=(0,E.$ye)(se.fragment.substring(Y+1)).toString();if(!isNaN(B))return{handle:B,notebook:se.with({scheme:ie,fragment:null})}}O.parse=Ce;function de(se,Y){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}O.generateCellOutputUri=de;function pe(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!Y)return;const B=Y[1]&&Y[1]!==""?Y[1]:void 0,ie=Y[2];return{outputId:B,notebook:se.with({scheme:ie||R.Schemas.file,fragment:null})}}O.parseCellOutputUri=pe;function re(se,Y,B){return O.generate(se,Y).with({scheme:B})}O.generateCellPropertyUri=re;function Re(se,Y){if(se.scheme===Y)return O.parse(se.with({scheme:O.scheme}))}O.parseCellPropertyUri=Re})(c||(e.CellUri=c={}));const o=O=>D.$i?O.replace(/\//g,"\\"):O;class l{constructor(X=[],$e=e.$qI){this.e=$e,this.d=[...new Set(X)].map(Ee=>({pattern:Ee,matches:L.$Cj(o(Ee))}))}sort(X){const $e=new Map(A.Iterable.map(X,De=>[De,o(De)]));let Ee=[];for(const{matches:De}of this.d)for(const[Ce,de]of $e)if(De(de)){Ee.push(Ce),$e.delete(Ce);break}return $e.size&&(Ee=Ee.concat([...$e.keys()].sort((De,Ce)=>this.e.indexOf(De)-this.e.indexOf(Ce)))),Ee}prioritize(X,$e){const Ee=this.f(X);if(Ee===-1){this.d.unshift({pattern:X,matches:L.$Cj(o(X))});return}const De=new Set($e.map(de=>this.f(de,Ee)));De.delete(-1);const Ce=Array.from(De).sort();this.d.splice(Ee+1,0,...Ce.map(de=>this.d[de]));for(let de=Ce.length-1;de>=0;de--)this.d.splice(Ce[de],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,$e=this.d.length){const Ee=o(X);for(let De=0;De<$e;De++)if(this.d[De].matches(Ee))return De;return-1}}e.$uI=l;function n(O,X,$e,Ee=(De,Ce)=>De===Ce){const De=[];function Ce(re,Re,se){if(Re===0&&se.length===0)return;const Y=De[De.length-1];Y&&Y.start+Y.deleteCount===re?(Y.deleteCount+=Re,Y.toInsert.push(...se)):De.push({start:re,deleteCount:Re,toInsert:se})}let de=0,pe=0;for(;;){if(de===O.length){Ce(de,0,X.slice(pe));break}if(pe===X.length){Ce(de,O.length-de,[]);break}const re=O[de],Re=X[pe];if(Ee(re,Re)){de+=1,pe+=1;continue}$e(Re)?(Ce(de,1,[]),de+=1):(Ce(de,0,[Re]),pe+=1)}return De}e.$vI=n,e.$wI=new f.$aj("notebookEditorCursorAtBoundary","none"),e.$xI=new f.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(O){const X=O;return!!((typeof X.include=="string"||L.$Dj(X.include))&&(typeof X.exclude=="string"||L.$Dj(X.exclude)))}e.$yI=a;function d(O,X,$e){if(Array.isArray(O.viewType)&&O.viewType.indexOf(X)>=0||O.viewType===X)return!0;if(O.filenamePattern){const Ee=a(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,De=a(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(L.$Bj(Ee,(0,$.$mc)($e.fsPath).toLowerCase()))return!(De&&L.$Bj(De,(0,$.$mc)($e.fsPath).toLowerCase()))}return!1}e.$zI=d,e.$AI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var v;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class m{static{this.d="notebook/"}static create(X){return`${m.d}${X}`}static parse(X){if(X.startsWith(m.d))return X.substring(m.d.length)}}e.$BI=m;function I(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$CI=I;const S=new TextDecoder;function h(O){const X=[];let $e=!1;for(const de of O)(X.length===0||$e)&&(X.push(de),$e=!0);let Ee=C(X);const De=E.$fe.concat(X.map(de=>E.$fe.wrap(de))),Ce=F(De);return Ee=Ee||Ce.byteLength!==De.byteLength,{data:Ce,didCompression:Ee}}e.$DI=h,e.$EI=`${String.fromCharCode(27)}[A`;const w=e.$EI.split("").map(O=>O.charCodeAt(0)),y=10;function C(O){let X=!1;return O.forEach(($e,Ee)=>{if(Ee===0||$e.length<e.$EI.length)return;const De=O[Ee-1],Ce=$e.subarray(0,e.$EI.length);if(Ce[0]===w[0]&&Ce[1]===w[1]&&Ce[2]===w[2]){const de=De.lastIndexOf(y);if(de===-1)return;X=!0,O[Ee-1]=De.subarray(0,de),O[Ee]=$e.subarray(e.$EI.length)}}),X}function W(O){let X=O;do O=X,X=O.replace(/[^\n]\x08/gm,"");while(X.length<O.length);return O}function K(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const X=O.match(/^(.*)\r+/m)[1];let $e=O.match(/\r+(.*)$/m)[1];$e=$e+X.slice($e.length,X.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,$e)}return O}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function F(O){return!O.buffer.includes(U)&&!O.buffer.includes(z)?O:E.$fe.fromString(K(W(S.decode(O.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,38,22,41,100,76]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p){"use strict";var g,t,i,r,c,o,l,n,s,a,d,v,m,I,S,h,w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$pM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TestRunProfileKind=e.TestResultState=e.$8L=e.$7L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6L=e.$5L=e.$4L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.ColorThemeKind=e.$WL=e.$VL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UL=e.DebugConsoleMode=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OL=e.$NL=e.FileChangeType=e.$ML=e.$LL=e.$KL=e.$JL=e.InlineCompletionTriggerKind=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.ConfigurationTarget=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mL=e.ViewBadge=e.ProgressLocation=e.$lL=e.$kL=e.TaskScope=e.ShellQuoting=e.$jL=e.$iL=e.$hL=e.TaskPanelKind=e.TaskRevealKind=e.$gL=e.TerminalLocation=e.$fL=e.$eL=e.$dL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cL=e.$bL=e.$aL=e.$_K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$K=e.StatusBarAlignment=e.ViewColumn=e.$0K=e.$9K=e.$8K=e.$7K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6K=e.$5K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.LanguageStatusSeverity=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CodeActionTriggerKind=e.$SK=e.$RK=e.SymbolTag=e.SymbolKind=e.$QK=e.DocumentHighlightKind=e.$PK=e.$OK=e.$NK=e.$MK=e.DiagnosticSeverity=e.DiagnosticTag=e.$LK=e.$KK=e.FileEditType=e.$JK=e.$IK=e.$HK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const ke=oe.length===1?[]:oe[1];return Reflect.construct(j,ke,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[ke,...Ge]=oe;return Reflect.construct(j,Ge,ke.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let U=g=class{static from(...N){let oe=N;return new g(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$AK=U,e.$AK=U=g=Ke([C],U);let z=t=class{static Min(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let ke=1;ke<N.length;ke++){const Ge=N[ke];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...N){if(N.length===0)throw new TypeError;let oe=N[0];for(let ke=1;ke<N.length;ke++){const Ge=N[ke];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(N){if(!N)return!1;if(N instanceof t)return!0;const{line:oe,character:ke}=N;return typeof oe=="number"&&typeof ke=="number"}static of(N){if(N instanceof t)return N;if(this.isPosition(N))return new t(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,oe){if(N<0)throw(0,L.$6)("line must be non-negative");if(oe<0)throw(0,L.$6)("character must be non-negative");this.c=N,this.e=oe}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,oe=0){if(N===null||oe===null)throw(0,L.$6)();let ke;return typeof N>"u"?ke=0:typeof N=="number"?ke=N:(ke=typeof N.lineDelta=="number"?N.lineDelta:0,oe=typeof N.characterDelta=="number"?N.characterDelta:0),ke===0&&oe===0?this:new t(this.line+ke,this.character+oe)}with(N,oe=this.character){if(N===null||oe===null)throw(0,L.$6)();let ke;return typeof N>"u"?ke=this.line:typeof N=="number"?ke=N:(ke=typeof N.line=="number"?N.line:this.line,oe=typeof N.character=="number"?N.character:this.character),ke===this.line&&oe===this.character?this:new t(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$BK=z,e.$BK=z=t=Ke([C],z);let F=i=class{static isRange(N){return N instanceof i?!0:N?z.isPosition(N.start)&&z.isPosition(N.end):!1}static of(N){if(N instanceof i)return N;if(this.isRange(N))return new i(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,oe,ke,Ge){let xe,at;if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new z(N,oe),at=new z(ke,Ge)):z.isPosition(N)&&z.isPosition(oe)&&(xe=z.of(N),at=z.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(N){return i.isRange(N)?this.contains(N.start)&&this.contains(N.end):z.isPosition(N)?!(z.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const oe=z.Max(N.start,this.c),ke=z.Min(N.end,this.e);if(!oe.isAfter(ke))return new i(oe,ke)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const oe=z.Min(N.start,this.c),ke=z.Max(N.end,this.end);return new i(oe,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,oe=this.end){if(N===null||oe===null)throw(0,L.$6)();let ke;return N?z.isPosition(N)?ke=N:(ke=N.start||this.start,oe=N.end||this.end):ke=this.start,ke.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(ke,oe)}toJSON(){return[this.start,this.end]}};e.$CK=F,e.$CK=F=i=Ke([C],F);let O=r=class extends F{static isSelection(N){return N instanceof r?!0:N?F.isRange(N)&&z.isPosition(N.anchor)&&z.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,oe,ke,Ge){let xe,at;if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"?(xe=new z(N,oe),at=new z(ke,Ge)):z.isPosition(N)&&z.isPosition(oe)&&(xe=z.of(N),at=z.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$DK=O,e.$DK=O=r=Ke([C],O);const X=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.$6)("connectionToken")};class $e{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,oe,ke){if(typeof N!="string"||N.length===0)throw(0,L.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.$6)("port");typeof ke<"u"&&X(ke),this.host=N,this.port=Math.round(oe),this.connectionToken=ke}}e.$EK=$e;class Ee{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,oe){this.makeConnection=N,this.connectionToken=oe,typeof oe<"u"&&X(oe)}}e.$FK=Ee;class De extends Error{static NotAvailable(N,oe){return new De(N,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(N){return new De(N,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,oe=b.RemoteAuthorityResolverErrorCode.Unknown,ke){super(N),this._message=N,this._code=oe,this._detail=ke,Object.setPrototypeOf(this,De.prototype)}}e.$GK=De;var Ce;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Ce||(e.EndOfLine=Ce={}));var de;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(de||(e.EnvironmentVariableMutatorType=de={}));let pe=c=class{static isTextEdit(N){return N instanceof c?!0:N?F.isRange(N)&&typeof N.newText=="string":!1}static replace(N,oe){return new c(N,oe)}static insert(N,oe){return c.replace(new F(N,N),oe)}static delete(N){return c.replace(N,"")}static setEndOfLine(N){const oe=new c(new F(new z(0,0),new z(0,0)),"");return oe.newEol=N,oe}get range(){return this.c}set range(N){if(N&&!F.isRange(N))throw(0,L.$6)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,L.$6)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,L.$6)("newEol");this.f=N}constructor(N,oe){this.c=N,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$HK=pe,e.$HK=pe=c=Ke([C],pe);let re=o=class{static isNotebookCellEdit(N){return N instanceof o?!0:N?_t.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,oe){return new o(N,oe)}static insertCells(N,oe){return new o(new _t(N,N),oe)}static deleteCells(N){return new o(N,[])}static updateCellMetadata(N,oe){const ke=new o(new _t(N,N),[]);return ke.newCellMetadata=oe,ke}static updateNotebookMetadata(N){const oe=new o(new _t(0,0),[]);return oe.newNotebookMetadata=N,oe}constructor(N,oe){this.range=N,this.newCells=oe}};e.$IK=re,e.$IK=re=o=Ke([C],re);class Re{static isSnippetTextEdit(N){return N instanceof Re?!0:N?F.isRange(N.range)&&B.isSnippetString(N.snippet):!1}static replace(N,oe){return new Re(N,oe)}static insert(N,oe){return Re.replace(new F(N,N),oe)}constructor(N,oe){this.range=N,this.snippet=oe}}e.$JK=Re;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,oe,ke,Ge){this.c.push({_type:1,from:N,to:oe,options:ke,metadata:Ge})}createFile(N,oe,ke){this.c.push({_type:1,from:void 0,to:N,options:oe,metadata:ke})}deleteFile(N,oe,ke){this.c.push({_type:1,from:N,to:void 0,options:oe,metadata:ke})}e(N,oe,ke){this.c.push({_type:3,metadata:ke,uri:N,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(N,oe,ke,Ge){const xe=oe.start,at=oe.end;(xe!==at||ke.length>0)&&this.c.push({_type:5,uri:N,index:xe,count:at-xe,cells:ke,metadata:Ge})}g(N,oe,ke,Ge){this.c.push({_type:3,metadata:Ge,uri:N,edit:{editType:3,index:oe,metadata:ke}})}replace(N,oe,ke,Ge){this.c.push({_type:2,uri:N,edit:new pe(oe,ke),metadata:Ge})}insert(N,oe,ke,Ge){this.replace(N,new F(oe,oe),ke,Ge)}delete(N,oe,ke){this.replace(N,oe,"",ke)}has(N){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===N.toString())}set(N,oe){if(oe)for(const ke of oe){if(!ke)continue;let Ge,xe;Array.isArray(ke)?(Ge=ke[0],xe=ke[1]):Ge=ke,re.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(N,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(N,Ge.newNotebookMetadata,xe):this.f(N,Ge.range,Ge.newCells,xe):Re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:N,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:N,edit:Ge,metadata:xe})}else{for(let ke=0;ke<this.c.length;ke++){const Ge=this.c[ke];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===N.toString()&&(this.c[ke]=void 0);break}}(0,E.$Hb)(this.c)}}get(N){const oe=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===N.toString()&&oe.push(ke.edit);return oe}entries(){const N=new M.$zc;for(const oe of this.c)if(oe._type===2){let ke=N.get(oe.uri);ke||(ke=[oe.uri,[]],N.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$KK=Y,e.$KK=Y=Ke([C],Y);let B=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=l.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,oe=this.e++){if(typeof N=="function"){const ke=new l;ke.e=this.e,N(ke),this.e=ke.e,N=ke.value}else N=l.c(N);return this.value+="${",this.value+=oe,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,oe=this.e++){const ke=N.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(N,oe){if(typeof oe=="function"){const ke=new l;ke.e=this.e,oe(ke),this.e=ke.e,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$LK=B,e.$LK=B=l=Ke([C],B);var ie;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var me;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let ne=n=class{static isLocation(N){return N instanceof n?!0:N?F.isRange(N.range)&&f.URI.isUri(N.uri):!1}constructor(N,oe){if(this.uri=N,oe)if(F.isRange(oe))this.range=F.of(oe);else if(z.isPosition(oe))this.range=new F(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$MK=ne,e.$MK=ne=n=Ke([C],ne);let le=class{static is(N){return N?typeof N.message=="string"&&N.location&&F.isRange(N.location.range)&&f.URI.isUri(N.location.uri):!1}constructor(N,oe){this.location=N,this.message=oe}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.location.range.isEqual(oe.location.range)&&N.location.uri.toString()===oe.location.uri.toString()}};e.$NK=le,e.$NK=le=Ke([C],le);let ce=class{constructor(N,oe,ke=me.Error){if(!F.isRange(N))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=N,this.message=oe,this.severity=ke}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,oe){return N===oe?!0:!N||!oe?!1:N.message===oe.message&&N.severity===oe.severity&&N.code===oe.code&&N.severity===oe.severity&&N.source===oe.source&&N.range.isEqual(oe.range)&&(0,E.$tb)(N.tags,oe.tags)&&(0,E.$tb)(N.relatedInformation,oe.relatedInformation,le.isEqual)}};e.$OK=ce,e.$OK=ce=Ke([C],ce);let we=class{constructor(N,oe){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=oe}};e.$PK=we,e.$PK=we=Ke([C],we);var _;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(_||(e.DocumentHighlightKind=_={}));let he=class{constructor(N,oe=_.Text){this.range=N,this.kind=oe}toJSON(){return{range:this.range,kind:_[this.kind]}}};e.$QK=he,e.$QK=he=Ke([C],he);var te;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let ge=s=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,oe,ke,Ge,xe){this.name=N,this.kind=oe,this.containerName=xe,typeof ke=="string"&&(this.containerName=ke),Ge instanceof ne?this.location=Ge:ke instanceof F&&(this.location=new ne(Ge,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$RK=ge,e.$RK=ge=s=Ke([C],ge);let Se=a=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(a.validate)}constructor(N,oe,ke,Ge,xe){this.name=N,this.detail=oe,this.kind=ke,this.range=Ge,this.selectionRange=xe,this.children=[],a.validate(this)}};e.$SK=Se,e.$SK=Se=a=Ke([C],Se);var T;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let V=class{constructor(N,oe){this.title=N,this.kind=oe}};e.$TK=V,e.$TK=V=Ke([C],V);let G=class{static{d=this}static{this.c="."}constructor(N){this.value=N}append(N){return new d(this.value?this.value+d.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+d.c)}};e.$UK=G,e.$UK=G=d=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(N,oe){if(this.range=N,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VK=J,e.$VK=J=Ke([C],J);class q{constructor(N,oe,ke,Ge,xe,at){this.kind=N,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$WK=q;class x{constructor(N,oe){this.fromRanges=oe,this.from=N}}e.$XK=x;class ue{constructor(N,oe){this.fromRanges=oe,this.to=N}}e.$YK=ue;var Ne;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ue=class{constructor(N,oe){this.range=N,this.command=oe}get isResolved(){return!!this.command}};e.$ZK=Ue,e.$ZK=Ue=Ke([C],Ue);let Ze=v=class{#e;static isMarkdownString(N){return N instanceof v?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,oe=!1){this.#e=new A.$9j(N,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,oe){return this.#e.appendCodeblock(oe??"",N),this}};e.$1K=Ze,e.$1K=Ze=v=Ke([C],Ze);let Je=class{constructor(N,oe){this.label=N,this.documentation=oe}};e.$2K=Je,e.$2K=Je=Ke([C],Je);let tt=class{constructor(N,oe){this.label=N,this.documentation=oe,this.parameters=[]}};e.$3K=tt,e.$3K=tt=Ke([C],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4K=_e,e.$4K=_e=Ke([C],_e);var et;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(N){this.value=N}};e.$5K=nt,e.$5K=nt=Ke([C],nt);let ze=class{constructor(N,oe,ke){this.position=N,this.label=oe,this.kind=ke}};e.$6K=ze,e.$6K=ze=Ke([C],ze);var dt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(dt||(e.CompletionTriggerKind=dt={}));var Z;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var Q;(function(j){j[j.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let ye=class{constructor(N,oe){this.label=N,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7K=ye,e.$7K=ye=Ke([C],ye);let Be=class{constructor(N=[],oe=!1){this.items=N,this.isIncomplete=oe}};e.$8K=Be,e.$8K=Be=Ke([C],Be);let He=class{constructor(N,oe,ke){this.insertText=N,this.range=oe,this.command=ke}};e.$9K=He,e.$9K=He=Ke([C],He);let Xe=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$0K=Xe,e.$0K=Xe=Ke([C],Xe);var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Dt(j,N){return`${k.$_l.toKey(j)}.${N}`}e.$$K=Dt;var Oe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var yt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ot;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(j){function N(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=N}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function N(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=N}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(N,oe){if(oe&&!f.URI.isUri(oe))throw(0,L.$6)("target");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.target=oe}};e.$_K=Bt,e.$_K=Bt=Ke([C],Bt);let St=class{constructor(N,oe,ke,Ge){this.red=N,this.green=oe,this.blue=ke,this.alpha=Ge}};e.$aL=St,e.$aL=St=Ke([C],St);let Lt=class{constructor(N,oe){if(oe&&!(oe instanceof St))throw(0,L.$6)("color");if(!F.isRange(N)||N.isEmpty)throw(0,L.$6)("range");this.range=N,this.color=oe}};e.$bL=Lt,e.$bL=Lt=Ke([C],Lt);let Wt=class{constructor(N){if(!N||typeof N!="string")throw(0,L.$6)("label");this.label=N}};e.$cL=Wt,e.$cL=Wt=Ke([C],Wt);var Ye;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ye||(e.ColorFormat=Ye={}));var Vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ct{constructor(N,oe,ke){if(this.startIndex=N,this.length=oe,this.tooltip=ke,typeof N!="number"||N<0)throw(0,L.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.$6)("tooltip")}}e.$dL=ct;class gt{constructor(N){this.uri=N}}e.$eL=gt;class Nt{constructor(N){this.terminalCommand=N}}e.$fL=Nt;var Pt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(N){if(this.options=N,typeof N!="object")throw(0,L.$6)("options")}}e.$gL=At;var ft;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Rt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(N){switch(N){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(N,oe){if(this.label=oe,typeof N!="string"||typeof oe!="string")throw(0,L.$6)("name");this.c=N}get id(){return this.c}};e.$hL=Rt,e.$hL=Rt=m=Ke([C],Rt);function Ct(j){let N="";for(let oe=0;oe<j.length;oe++)N+=j[oe].replace(/,/g,",,")+",";return N}let Ve=class{constructor(N,oe,ke){if(typeof N!="string")throw(0,L.$6)("process");this.e=[],this.c=N,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=ke):this.f=oe)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,L.$6)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)N.push(oe);return Ct(N)}};e.$iL=Ve,e.$iL=Ve=Ke([C],Ve);let zt=class{constructor(N,oe,ke){if(this.f=[],Array.isArray(oe)){if(!N)throw(0,L.$6)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N,this.f=oe,this.g=ke}else{if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N,this.g=oe}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,L.$6)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,L.$6)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)N.push(typeof oe=="string"?oe:oe.value);return Ct(N)}};e.$jL=zt,e.$jL=zt=Ke([C],zt);var Jt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ie;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ie||(e.TaskScope=Ie={}));class Me{constructor(N){this.c=N}computeId(){return"customExecution"+(0,P.$ig)()}set callback(N){this.c=N}get callback(){return this.c}}e.$kL=Me;let ve=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,oe,ke,Ge,xe,at){this.j=!1,this.k=this.definition=N;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=ke,this.execution=Ge,ht=xe,this.j=!0):oe===Ie.Global||oe===Ie.Workspace?(this.target=oe,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,ht=at):(this.target=oe,this.m=this.name=ke,this.t=this.source=Ge,this.execution=xe,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ve?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$ig)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,L.$6)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const oe=this.k.type;(I.g===oe||I.e===oe||I.f===oe||I.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$lL=ve,e.$lL=ve=I=Ke([C],ve);var H;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(H||(e.ProgressLocation=H={}));var Le;(function(j){function N(oe){const ke=oe;return(0,D.$Gf)(ke.value)?ke.tooltip&&!(0,D.$Cf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=N})(Le||(e.ViewBadge=Le={}));let je=S=class{static isTreeItem(N,oe){const ke=N;if(ke.checkboxState!==void 0){const Ge=(0,D.$Gf)(ke.checkboxState)?ke.checkboxState:(0,D.$Ef)(ke.checkboxState)&&(0,D.$Gf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,xe=!(0,D.$Gf)(ke.checkboxState)&&(0,D.$Ef)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,D.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(N instanceof S)return!0;if(ke.label!==void 0&&!(0,D.$Cf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$Cf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$Cf)(ke.iconPath)&&!f.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$Cf)(ke.iconPath.id))){const Ge=ke.iconPath;if(!Ge||!(0,D.$Cf)(Ge.light)&&!f.URI.isUri(Ge.light)&&!(0,D.$Cf)(Ge.dark)&&!f.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$Cf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!f.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$Cf)(ke.tooltip)&&!(ke.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Qe.None&&ke.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$Cf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(N,oe=Qe.None){this.collapsibleState=oe,f.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$mL=je,e.$mL=je=S=Ke([C],je);var Qe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let it=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$nL=it,e.$nL=it=Ke([C],it);class pt extends it{}e.$oL=pt;class $t extends pt{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$pL=$t;class bt{constructor(N,oe,ke,Ge){this.name=N,this.uri=oe,this._itemId=ke,this.c=Ge}data(){return this.c()}}e.$qL=bt;let ut=class{#e=new Map;constructor(N){for(const[oe,ke]of N??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(ke):this.#e.set(this.#t(oe),[ke])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,oe){this.#e.set(this.#t(N),[oe])}forEach(N,oe){for(const[ke,Ge]of this.#e)for(const xe of Ge)N.call(oe,xe,ke,this)}*[Symbol.iterator](){for(const[N,oe]of this.#e)for(const ke of oe)yield[N,ke]}#t(N){return N.toLowerCase()}};e.$rL=ut,e.$rL=ut=Ke([C],ut);let Mt=class{constructor(N){this.insertText=N}};e.$sL=Mt,e.$sL=Mt=Ke([C],Mt);let Qt=class{constructor(N,oe){this.label=oe,this.insertText=N}};e.$tL=Qt,e.$tL=Qt=Ke([C],Qt);let Xt=class{constructor(N,oe){this.id=N,this.color=oe}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$uL=Xt,e.$uL=Xt=Ke([C],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(N){this.id=N}};e.$vL=si,e.$vL=si=Ke([C],si);var ki;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let It=class{get base(){return this.c}set base(N){this.c=N,this.e=f.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,oe){if(typeof N!="string"&&(!N||!f.URI.isUri(N)&&!f.URI.isUri(N.uri)))throw(0,L.$6)("base");if(typeof oe!="string")throw(0,L.$6)("pattern");typeof N=="string"?this.baseUri=f.URI.file(N):f.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wL=It,e.$wL=It=Ke([C],It);const Zi=new WeakMap;function ln(j,N){Zi.set(j,N)}e.$xL=ln;let Et=class{constructor(N,oe,ke,Ge){this.enabled=typeof N=="boolean"?N:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Zi.get(this)??(0,P.$ig)()),this.c}};e.$yL=Et,e.$yL=Et=Ke([C],Et);let gi=class extends Et{constructor(N,oe,ke,Ge,xe){if(super(oe,ke,Ge,xe),N===null)throw(0,L.$6)("location");this.location=N}};e.$zL=gi,e.$zL=gi=Ke([C],gi);let mi=class extends Et{constructor(N,oe,ke,Ge,xe){super(oe,ke,Ge,xe),this.functionName=N}};e.$AL=mi,e.$AL=mi=Ke([C],mi);let oi=class extends Et{constructor(N,oe,ke,Ge,xe,at,ht){if(super(Ge,xe,at,ht),!oe)throw(0,L.$6)("dataId");this.label=N,this.dataId=oe,this.canPersist=ke}};e.$BL=oi,e.$BL=oi=Ke([C],oi);let Si=class{constructor(N,oe,ke){this.command=N,this.args=oe||[],this.options=ke}};e.$CL=Si,e.$CL=Si=Ke([C],Si);let Ii=class{constructor(N,oe){this.port=N,this.host=oe}};e.$DL=Ii,e.$DL=Ii=Ke([C],Ii);let Ft=class{constructor(N){this.path=N}};e.$EL=Ft,e.$EL=Ft=Ke([C],Ft);let $i=class{constructor(N){this.implementation=N}};e.$FL=$i,e.$FL=$i=Ke([C],$i);let Ci=class{constructor(N,oe,ke){this.session=N,this.threadId=oe,this.frameId=ke}};e.$GL=Ci,e.$GL=Ci=Ke([C],Ci);let ai=class{constructor(N,oe){this.session=N,this.threadId=oe}};e.$HL=ai,e.$HL=ai=Ke([C],ai);let ci=class{constructor(N,oe){this.range=N,this.expression=oe}};e.$IL=ci,e.$IL=ci=Ke([C],ci);var lt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let Pi=class{constructor(N,oe){this.range=N,this.text=oe}};e.$JL=Pi,e.$JL=Pi=Ke([C],Pi);let xt=class{constructor(N,oe,ke=!0){this.range=N,this.variableName=oe,this.caseSensitiveLookup=ke}};e.$KL=xt,e.$KL=xt=Ke([C],xt);let ni=class{constructor(N,oe){this.range=N,this.expression=oe}};e.$LL=ni,e.$LL=ni=Ke([C],ni);let pi=class{constructor(N,oe){this.frameId=N,this.stoppedLocation=oe}};e.$ML=pi,e.$ML=pi=Ke([C],pi);var Xi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=h=class extends Error{static FileExists(N){return new h(N,u.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(N){return new h(N,u.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(N){return new h(N,u.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(N){return new h(N,u.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(N){return new h(N,u.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(N){return new h(N,u.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(N,oe=u.FileSystemProviderErrorCode.Unknown,ke){super(f.URI.isUri(N)?N.toString(!0):N),this.code=ke?.name??"Unknown",(0,u.$tk)(this,oe),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$NL=Ai,e.$NL=Ai=h=Ke([C],Ai);let Ri=class{constructor(N,oe,ke){this.start=N,this.end=oe,this.kind=ke}};e.$OL=Ri,e.$OL=Ri=Ke([C],Ri);var Mi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(N,oe=[]){this.tokenTypes=N,this.tokenModifiers=oe}}e.$PL=Fi;function Ti(j){return typeof j>"u"||(0,D.$Df)(j)}class Ni{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let oe=0,ke=N.tokenTypes.length;oe<ke;oe++)this.j.set(N.tokenTypes[oe],oe);for(let oe=0,ke=N.tokenModifiers.length;oe<ke;oe++)this.k.set(N.tokenModifiers[oe],oe)}}push(N,oe,ke,Ge,xe){if(typeof N=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(N,oe,ke,Ge,xe);if(F.isRange(N)&&typeof oe=="string"&&Ti(ke))return this.m(N,oe,ke);throw(0,L.$6)()}m(N,oe,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=N.start.line,xe=N.start.character,at=N.end.character-N.start.character,ht=this.j.get(oe);let Ut=0;if(ke)for(const Zt of ke){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(Ge,xe,at,ht,Ut)}n(N,oe,ke,Ge,xe){if(this.f&&(N<this.c||N===this.c&&oe<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<Ut;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let at=N,ht=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=ke,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=N,this.e=oe}static o(N){const oe=[],ke=N.length/5|0;for(let ht=0;ht<ke;ht++)oe[ht]=ht;oe.sort((ht,Ut)=>{const Zt=N[5*ht],ei=N[5*Ut];if(Zt===ei){const ii=N[5*ht+1],ri=N[5*Ut+1];return ii-ri}return Zt-ei});const Ge=new Uint32Array(N.length);let xe=0,at=0;for(let ht=0;ht<ke;ht++){const Ut=5*oe[ht],Zt=N[Ut+0],ei=N[Ut+1],ii=N[Ut+2],ri=N[Ut+3],Qi=N[Ut+4],Sn=Zt-xe,Tn=Sn===0?ei-at:ei,Yi=5*ht;Ge[Yi+0]=Sn,Ge[Yi+1]=Tn,Ge[Yi+2]=ii,Ge[Yi+3]=ri,Ge[Yi+4]=Qi,xe=Zt,at=ei}return Ge}build(N){return this.f?new Oi(new Uint32Array(this.g),N):new Oi(Ni.o(this.g),N)}}e.$QL=Ni;class Oi{constructor(N,oe){this.resultId=oe,this.data=N}}e.$RL=Oi;class hi{constructor(N,oe,ke){this.start=N,this.deleteCount=oe,this.data=ke}}e.$SL=hi;class hn{constructor(N,oe){this.resultId=oe,this.edits=N}}e.$TL=hn;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let zi=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$UL=zi,e.$UL=zi=Ke([C],zi);var vi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class bi{static validate(N){if(typeof N.badge=="string"){let oe=(0,$.$df)(N.badge,0);if(oe<N.badge.length&&(oe+=(0,$.$df)(N.badge,oe)),N.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Xt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,oe,ke){this.badge=N,this.tooltip=oe,this.color=ke}}e.$VL=bi;let wi=class{constructor(N){this.kind=N}};e.$WL=wi,e.$WL=wi=Ke([C],wi);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(N){return N instanceof _t?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,oe){if(N<0)throw(0,L.$6)("start must be positive");if(oe<0)throw(0,L.$6)("end must be positive");N<=oe?(this.c=N,this.e=oe):(this.c=oe,this.e=N)}with(N){let oe=this.c,ke=this.e;return N.start!==void 0&&(oe=N.start),N.end!==void 0&&(ke=N.end),oe===this.c&&ke===this.e?this:new _t(oe,ke)}}e.$XL=_t;class di{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(oe=>di.isNotebookCellData(oe))}static isNotebookCellData(N){return!0}constructor(N,oe,ke,Ge,xe,at,ht){this.kind=N,this.value=oe,this.languageId=ke,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=ht,di.validate(this)}}e.$YL=di;class dn{constructor(N){this.cells=N}}e.$ZL=dn;class Yt{static isNotebookCellOutputItem(N){return N instanceof Yt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const oe={name:N.name,message:N.message,stack:N.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(N){return Yt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Yt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,oe="application/octet-stream"){return new Yt(N,oe)}static#e=new TextEncoder;static text(N,oe=R.$Wr.text){const ke=Yt.#e.encode(String(N));return new Yt(ke,oe)}static json(N,oe="text/x-json"){const ke=JSON.stringify(N,void 0,"	");return Yt.text(ke,oe)}constructor(N,oe){this.data=N,this.mime=oe;const ke=(0,R.$1r)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$1L=Yt;class yi{static isNotebookCellOutput(N){return N instanceof yi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,oe=!1){const ke=new Set,Ge=new Set;for(let xe=0;xe<N.length;xe++){const at=N[xe],ht=(0,R.$1r)(at.mime);if(!ke.has(ht)||(0,p.$CI)(ht)){ke.add(ht);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?N:N.filter((xe,at)=>!Ge.has(at))}constructor(N,oe,ke){this.items=yi.ensureUniqueMimeTypes(N,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,P.$ig)(),this.metadata=oe??ke)}}e.$2L=yi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Te;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Te||(e.NotebookEditorRevealType=Te={}));class ti{constructor(N,oe){this.text=N,this.alignment=oe}}e.$3L=ti;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var mt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class fn{constructor(N,oe=[]){this.uri=N,this.provides=(0,E.$2b)(oe)}}e.$4L=fn;class gn{constructor(N){this.label=N}}e.$5L=gn;let Di=class{constructor(N,oe){this.label=N,this.timestamp=oe}};e.$6L=Di,e.$6L=Di=Ke([C],Di);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var fi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(fi||(e.ExtensionRuntime=fi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(N,oe){this.ranges=N,this.wordPattern=oe}}e.$7L=mn;class $n{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$8L=$n;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(N=void 0,oe=void 0,ke=void 0,Ge=!1){this.include=N,this.exclude=oe,this.profile=ke,this.continuous=Ge}};e.$9L=Wi,e.$9L=Wi=Ke([C],Wi);let Vi=w=class{static diff(N,oe,ke){const Ge=new w(N);return Ge.expectedOutput=oe,Ge.actualOutput=ke,Ge}constructor(N){this.message=N}};e.$0L=Vi,e.$0L=Vi=w=Ke([C],Vi);let qi=class{constructor(N){this.id=N}};e.$$L=qi,e.$$L=qi=Ke([C],qi);let li=class{constructor(N,oe){this.covered=N,this.total=oe}};e.$_L=li,e.$_L=li=Ke([C],li);let Ki=y=class{static fromDetails(N,oe){const ke=new li(0,0),Ge=new li(0,0),xe=new li(0,0);for(const ht of oe)if("branches"in ht){ke.total+=1,ke.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Ge.total+=1,Ge.covered+=Ut.executionCount>0?1:0}else xe.total+=1,xe.covered+=ht.executionCount>0?1:0;const at=new y(N,ke,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(N,oe,ke,Ge){this.uri=N,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Ge}};e.$aM=Ki,e.$aM=Ki=y=Ke([C],Ki);let Hi=class{constructor(N,oe,ke=[]){this.executionCount=N,this.location=oe,this.branches=ke}};e.$bM=Hi,e.$bM=Hi=Ke([C],Hi);let Gi=class{constructor(N,oe){this.executionCount=N,this.location=oe}};e.$cM=Gi,e.$cM=Gi=Ke([C],Gi);let Ji=class{constructor(N,oe){this.executionCount=N,this.location=oe}};e.$dM=Ji,e.$dM=Ji=Ke([C],Ji);var un;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var ee;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ee||(e.WorkspaceTrustState=ee={}));var fe;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(fe||(e.PortAutoForwardAction=fe={}));class Fe{constructor(N,oe,ke,Ge,xe,at){this.kind=N,this.name=oe,this.detail=ke,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$eM=Fe;class ot{constructor(N){this.uri=N}}e.$fM=ot;class wt{constructor(N,oe){this.original=N,this.modified=oe}}e.$gM=wt;class Tt{constructor(N,oe,ke,Ge){this.base=N,this.input1=oe,this.input2=ke,this.result=Ge}}e.$hM=Tt;class In{constructor(N,oe){this.uri=N,this.viewType=oe}}e.$iM=In;class Cn{constructor(N){this.viewType=N}}e.$jM=Cn;class Pn{constructor(N,oe){this.uri=N,this.notebookType=oe}}e.$kM=Pn;class An{constructor(N,oe,ke){this.original=N,this.modified=oe,this.notebookType=ke}}e.$lM=An;class Rn{constructor(){}}e.$mM=Rn;class Mn{constructor(N,oe){this.uri=N,this.inputBoxUri=oe}}e.$nM=Mn;class Ln{constructor(N){this.providerId=N}}e.$oM=Ln;var pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var yn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(N,oe){this.role=N,this.content=oe}}e.$pM=Fn;var En;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Dn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var kn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Pe[103],Ae([1,0,53,13,12,295,147,7,18]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$DM=e.$CM=void 0;const f=new Map;function P(p,g){g?f.set(p,g):f.delete(p)}e.$CM=P;function k(p){return f.get(p)}class u extends M.$3u{constructor(g,t,i,r,c,o,l,n){super(t,i,r,c),this.c=g,this.m=o,this.q=l,this.notebook=n,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,D.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===L.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,E.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,E.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,c=t.end.line,o=[];o.push(this.f[r].substring(t.start.character));for(let l=r+1;l<c;l++)o.push(this.f[l]);return o.push(this.f[c].substring(0,t.end.character)),o.join(i)}t(g){let t;if(g instanceof $.$BK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new $.$BK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof $.$CK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new $.$CK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof $.$BK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const c=this.f[t].length;i<0?(i=0,r=!0):i>c&&(i=c,r=!0)}return r?new $.$BK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=k(this.m);else if((0,A.$Se)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,R.$cs)(i.character+1,(0,R.$as)(t),this.f[i.line],0);if(r)return new $.$CK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$DM=u;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$CK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$CK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EM=b}),define(Pe[210],Ae([1,0,7,17,5]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;let M=class{constructor($){this.a=new E.$WL(E.ColorThemeKind.Dark),this.b=new A.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$WL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$yfc=M,e.$yfc=M=Ke([We(0,L.$AM)],M)}),define(Pe[211],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.CellExecutionUpdateType=void 0;var L;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$GI=(0,E.$Vh)("INotebookExecutionService")}),define(Pe[212],Ae([1,0,6,29,144,93]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MOb=void 0;class R extends E.$Rc{constructor(D,f,P){super(),this._source=D,this.b=f,this.c=P,this.a=void 0}f(D){const f=D.getLineCount();return new L.$As(1,1,f,this.g(D,f))}g(D,f){if(f<1||f>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(f)+1}get inputTextBuffer(){if(!this.b){const D=new A.$NB;D.acceptChunk(this._source);const f=D.finish(!0),{textBuffer:P,disposable:k}=f.create(1);this.b=P,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const f=new A.$NB;f.acceptChunk(D);const P=f.finish(!0),{textBuffer:k,disposable:u}=P.create(1);return this.B(u),k})),this.a}findInInputs(D){const P=new M.$BB(D,!1,!1,null).parseSearchRequest();if(!P)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,P,!0,5e3)}findInOutputs(D){const P=new M.$BB(D,!1,!1,null).parseSearchRequest();return P?this.outputTextBuffers.map(k=>{const u=k.findMatchesLineByLine(this.f(k),P,!0,5e3);if(u.length!==0)return{textBuffer:k,matches:u}}).filter(k=>!!k):[]}}e.$MOb=R}),define(Pe[48],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class A{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new A([$]);const f=[R.id];for(let P=D;P&&P.id!==$;P=P.parent)f.push(P.id);return f.push($),new A(f.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new A(R.split("\0"))}static join(R,$){return new A([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:A.isChild(R,$)?2:A.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new A(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new A(this.path,R)}compare(R){if(typeof R=="string")return A.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$rJ=A}),define(Pe[58],Ae([1,0,2,29,48]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$xJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$wJ=e.$vJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$uJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$tJ=e.$sJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$sJ=[2,4,8,16,32,64];const D=S=>"runId"in S;e.$tJ=D;var f;(function(S){S.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),S.deserialize=h=>({range:L.$As.lift(h.range),uri:E.URI.revive(h.uri)})})(f||(e.IRichLocation=f={}));var P;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(P||(e.TestMessageType=P={}));var k;(function(S){S.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.serialize(h.location)}),S.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.deserialize(h.location)})})(k||(e.ITestErrorMessage=k={}));const u=(S,h)=>`${h?"s":"e"}${S}`;e.$uJ=u;var b;(function(S){S.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.serialize(h.location)}),S.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.deserialize(h.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(S){S.serialize=h=>h.type===0?k.serialize(h):b.serialize(h),S.deserialize=h=>h.type===0?k.deserialize(h):b.deserialize(h)})(p||(e.ITestMessage=p={}));var g;(function(S){S.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),S.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.serialize)}),S.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(S,h)=>S+t+h;e.$vJ=i;const r=S=>{const h=S.indexOf(t);return{ctrlId:S.slice(0,h),tagId:S.slice(h+1)}};e.$wJ=r;var c;(function(S){S.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),S.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?E.URI.revive(h.uri):void 0,range:h.range?L.$As.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(c||(e.ITestItem=c={}));var o;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var l;(function(S){S.serialize=h=>({expand:h.expand,item:c.serialize(h.item)}),S.deserialize=h=>({controllerId:A.$rJ.root(h.item.extId),expand:h.expand,item:c.deserialize(h.item)})})(l||(e.InternalTestItem=l={}));var n;(function(S){S.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},S.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?L.$As.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const s=(S,h)=>{h.expand!==void 0&&(S.expand=h.expand),h.item!==void 0&&(S.item=S.item?Object.assign(S.item,h.item):h.item)};e.$xJ=s;var a;(function(S){S.serializeWithoutMessages=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serializeWithoutMessages)}),S.serialize=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serialize)}),S.deserialize=h=>({...l.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var d;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(d||(e.DetailType=d={}));var v;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var m;(function(S){S.deserialize=h=>h.op===0?{op:h.op,item:l.deserialize(h.item)}:h.op===1?{op:h.op,item:n.deserialize(h.item)}:h.op===2?{op:h.op,uri:E.URI.revive(h.uri),docv:h.docv}:h,S.serialize=h=>h.op===0?{op:h.op,item:l.serialize(h.item)}:h.op===1?{op:h.op,item:n.serialize(h.item)}:h})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const y of h)switch(y.op){case 0:this.j(l.deserialize(y.item),w);break;case 1:this.k(n.deserialize(y.item),w);break;case 3:this.l(y.itemId,w);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}w.complete?.()}j(h,w){const y=A.$rJ.parentId(h.item.extId)?.toString();let C;if(!y)C=this.p(h),this.f.add(C),this.d.set(h.item.extId,C);else if(this.d.has(y)){const W=this.d.get(y);W.children.add(h.item.extId),C=this.p(h,W),this.d.set(h.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(C),h.expand===2&&this.g++,C}k(h,w){const y=this.d.get(h.extId);if(y)return h.expand!==void 0&&(y.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$xJ)(y,h),w.update?.(y),y}l(h,w){const y=this.d.get(h);if(!y)return;const C=A.$rJ.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const W=[[h]];for(;W.length;)for(const K of W.pop()){const U=this.d.get(K);U&&(W.push(U.children),this.d.delete(K),w.remove?.(U,U!==y),U.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$yJ=I}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.TestItemEventOp=void 0;var D;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const f=(r,c)=>r===c,k=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:f,label:f,description:f,error:f,sortText:f,tags:(r,c)=>!(r.length!==c.length||r.some(o=>!c.includes(o)))}),u=(r,c)=>{let o;for(const[l,n]of k)n(r[l],c[l])||(o?o[l]=c[l]:o={[l]:c[l]});return o};class b extends A.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new E.$0g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===c.uri){o.docv=c.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===c.item.extId){(0,R.$xJ)(o.item,c.item);return}if(o.op===0&&o.item.item.extId===c.item.extId){(0,R.$xJ)(o.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,o){const l=this.tree.get(c);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const n=this.L(l);return n.isOpen()?this.J(l,o-1):n.wait().then(()=>this.J(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,o-1)):this.J(l,o-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,o){switch(o.op){case 3:this.N($.$rJ.joinToString(c.fullId,o.id));break;case 0:this.y(o.item,c);break;case 5:for(const l of o.ops)this.u(c,l);break;case 1:this.z(o.new,o.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:o.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$4c)(o)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,o){const l=$.$rJ.fromExtHostTestItem(c,this.root.id,o?.actual),n=this.s.getApiFor(c);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(c.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:c,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,o);return}if(s.actual===c){this.G(c,s,o);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(l.toString()),this.y(c,o);const a=this.s.getChildren(s.actual),d=s.actual,v=u(this.s.toITestItem(d),this.s.toITestItem(c));this.s.getApiFor(d).listener=void 0,s.actual=c,s.expand=0,v&&(v.hasOwnProperty("tags")&&(this.z(c.tags,d.tags,l.toString()),delete v.tags),this.u(s,{op:4,update:v})),this.H(c,s,o);for(const[m,I]of a)this.s.getChildren(c).get(I.id)||this.N($.$rJ.joinToString(l,I.id));this.w(s.actual.uri)}z(c,o,l){const n=new Set(o.map(s=>s.id));for(const s of c)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:c.map(s=>(0,R.$vJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(c){const o=this.j.get(c.id);o?o.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$vJ)(this.s.controllerId,c.id)}}))}D(c){const o=this.j.get(c);o&&!--o.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,R.$vJ)(this.s.controllerId,c)}))}F(c,o){this.s.getApiFor(c).parent=o&&o.actual!==this.root?o.actual:void 0}G(c,o,l){this.F(c,l);const n=this.s.getApiFor(c);n.parent=l?.actual,n.listener=s=>this.u(o,s),this.I(o)}H(c,o,l){this.G(c,o,l);for(const[n,s]of this.s.getChildren(c))this.y(s,o)}I(c){let o;this.h?c.resolveBarrier?o=c.resolveBarrier.isOpen()?3:2:o=c.actual.canResolveChildren?1:0:o=0,o!==c.expand&&(c.expand=o,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:o}}),o===1&&c.expandLevels!==void 0&&this.L(c))}J(c,o){if(o<0)return;const l=[];for(const[n,s]of this.s.getChildren(c.actual)){const a=this.expand($.$rJ.joinToString(c.fullId,s.id),o);(0,E.$Kg)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new E.$Wg;return s.open(),s}c.expand=2,this.M(c);const o=c.resolveBarrier=new E.$Wg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(c.actual===this.root?void 0:c.actual)}catch(s){l(s)}return(0,E.$Kg)(n)?n.catch(l).then(()=>{o.open(),this.I(c)}):(o.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const o=this.tree.get(c);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const l=[o];for(;l.length;){const n=l.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,a]of this.s.getChildren(n.actual))l.push(this.tree.get($.$rJ.joinToString(n.fullId,a.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$qM=b;class p extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$rM=p;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sM=g;class t extends Error{constructor(c,o,l){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$tM=t;const i=(r,c,o)=>{let l=new Map;return{get size(){return l.size},forEach(n,s){for(const a of l.values())n.call(s,a,this)},[Symbol.iterator](){return l.entries()},replace(n){const s=new Map,a=new Set(l.keys()),d={op:5,ops:[]};for(const v of n){if(!(v instanceof o))throw new g(v.id);const m=c(v).controllerId;if(m!==r.controllerId)throw new t(v.id,m,r.controllerId);if(s.has(v.id))throw new p(v.id);s.set(v.id,v),a.delete(v.id),d.ops.push({op:0,item:v})}for(const v of a.keys())d.ops.push({op:3,id:v});r.listener?.(d),l=s},add(n){if(!(n instanceof o))throw new g(n.id);l.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){l.delete(n)&&r.listener?.({op:3,id:n})},get(n){return l.get(n)},toJSON(){return Array.from(l.values())}}};e.$uM=i}),define(Pe[104],Ae([1,0,77]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;const L=new WeakMap,A=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$vM=A;const M=R=>{const $=L.get(R);if(!$)throw new E.$sM(R?.id||"<unknown>");return $};e.$wM=M}),define(Pe[78],Ae([1,0,13,2]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_tb=e.$$tb=e.$0tb=e.$9tb=e.$8tb=void 0,e.$8tb="vscode-cdn.net",e.$9tb=`vscode-resource.${e.$8tb}`,e.$0tb=`'self' https://*.${e.$8tb}`;function A($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$9tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$$tb=A;function M($){return $.replace(/./g,D=>{const f=D.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?D:"-"+f.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,f)=>String.fromCharCode(parseInt(f,16)))}e.$_tb=R}),define(Pe[213],Ae([1,0,5,6,78]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;class M{constructor($,D,f){this.d=$,this.e=D,this.f=f,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const P=D.getVisibleTextEditors();for(const k of this.c.values())P.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,f,P,k){let u;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){u=c;break}if(!u)throw new Error("not a visible editor");const b=this,p=this.a++,g=new E.$Rd,t=new E.$Rd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,A.$$tb)(c,b.f)}get cspSource(){return A.$0tb}set options(c){this.b=c,b.d.$setOptions(p,c)}get options(){return this.b}set html(c){this.a=c,b.d.$setHtml(p,c)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(c){return b.d.$postMessage(p,c)}},r=new class{constructor(){this.editor=$,this.line=D,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,D+1,f,P||{},k.identifier,k.extensionLocation),this.c.set(p,{editor:$,inset:r,onDidReceiveMessage:g}),r}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$Udc=M}),define(Pe[214],Ae([1,0,4]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.VariableKind=e.$mN=void 0,e.$mN=(0,E.$Vh)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class A extends Error{constructor(R,$){super($),this.variable=R}}e.$nN=A}),define(Pe[215],Ae([1,0,19,74,16,26,21,94,177,214,12]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,p,g,t){this.h=new Map,this.a=b,this.b=p,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(R.$i){const p=Object.create(null);return Object.keys(b).forEach(g=>{p[g.toLowerCase()]=b[g]}),p}return b}resolveWithEnvironment(b,p,g){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,g)}async resolveAsync(b,p){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,p)}async j(b,p,g,t){const i=M.$an(p);R.$i&&i.windows?Object.keys(i.windows).forEach(c=>i[c]=i.windows[c]):R.$j&&i.osx?Object.keys(i.osx).forEach(c=>i[c]=i.osx[c]):R.$k&&i.linux&&Object.keys(i.linux).forEach(c=>i[c]=i.linux[c]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,p,g){return this.j(b,p,g)}async resolveAnyMap(b,p,g){const t=new Map;return{newConfig:await this.j(b,p,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,g,t,i){if(A.$Cf(g))return this.m(b,p,g,t,i);if(Array.isArray(g))return Promise.all(g.map(r=>this.l(b,p,r,t,i)));if(A.$Ef(g)){const r=Object.create(null),c=await Promise.all(Object.keys(g).map(async o=>[await this.m(b,p,o,t,i),await this.l(b,p,g[o],t,i)]));for(const[o,l]of c)r[o]=l;return r}return g}m(b,p,g,t,i){return(0,P.$Xe)(g,k.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(k.VARIABLE_LHS))return r;let o=await this.o(b,r,c,p,t);return i?.set(c,o),o!==r&&A.$Cf(o)&&o.match(k.VARIABLE_REGEXP)&&(o=await this.m(b,p,o,t,i)),o})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,g,t,i){let r;const c=g.split(":");c.length>1&&(g=c[0],r=c[1]);const o=s=>{const a=this.a.getFilePath();if(a)return(0,$.$zv)(a);throw new f.$nN(s,(0,D.localize)(0,null,p))},l=s=>{const a=o(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$zv)(d)}throw new f.$nN(s,(0,D.localize)(1,null,p,E.$mc(a)))},n=s=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new f.$nN(s,(0,D.localize)(2,null,p,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$nN(s,(0,D.localize)(3,null,p)):new f.$nN(s,(0,D.localize)(4,null,p))};switch(g){case"env":if(r){if(b.env){const s=b.env[R.$i?r.toLowerCase():r];if(A.$Cf(s))return s}return""}throw new f.$nN(f.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(A.$Lf(s))throw new f.$nN(f.VariableKind.Config,(0,D.localize)(6,null,p,r));if(A.$Ef(s))throw new f.$nN(f.VariableKind.Config,(0,D.localize)(7,null,p,r));return s}throw new f.$nN(f.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(f.VariableKind.Command,p,r,i,"command");case"input":return this.p(f.VariableKind.Input,p,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new f.$nN(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,r));return this.n(s.extensionLocation)}throw new f.$nN(f.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,$.$zv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$zv)(this.n(n(f.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$zv)(E.$mc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$nN(f.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$nN(f.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$nN(f.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return o(f.VariableKind.File);case"fileWorkspaceFolder":return l(f.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$mc(l(f.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return t||r?E.$kc(this.n(n(f.VariableKind.RelativeFile)),o(f.VariableKind.RelativeFile)):o(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(o(f.VariableKind.RelativeFileDirname));if(t||r){const a=E.$kc(this.n(n(f.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return E.$lc(o(f.VariableKind.FileDirname));case"fileExtname":return E.$nc(o(f.VariableKind.FileExtname));case"fileBasename":return E.$mc(o(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(o(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(o(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return E.sep;default:try{const s=r?`${g}:${r}`:g;return this.p(f.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(b,p,g,t,i){if(g&&t){const r=i===void 0?t[g]:t[i+":"+g];if(typeof r=="string")return r;throw new f.$nN(b,(0,D.localize)(14,null,p))}return p}}e.$BN=k}),define(Pe[105],Ae([1,0,4,102]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,E.$Vh)("editorGroupsService");var A;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function f(p){const g=p;return(0,L.$pE)(g?.editor)&&(0,L.$pE)(g?.replacement)}e.$HC=f;var P;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function u(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$IC=u;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=b}),define(Pe[216],Ae([1,0,4,105]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,E.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function A(M){const R=M;return typeof M=="number"||(0,L.$IC)(R)}e.$NC=A}),define(Pe[217],Ae([1,0,4,184]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=void 0,e.$VJ=(0,E.$Wh)(L.$3h)}),define(Pe[106],Ae([1,0,22,5,19,6]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T5b=e.$S5b=e.$R5b=e.$Q5b=e.$P5b=void 0;class R{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$P5b=R;class ${static isHostExtension(i,r,c){if(r.getExtensionDescription(i))return!1;const o=c.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new L.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(p),this.f=new E.$bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=g(this.e,r),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=g(this.e,c.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,c)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,a){this.addNode(s),this.addNode(a),this.c.has(s)?this.c.get(s).push(a):this.c.set(s,[a])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,a){const d=r.getArcs(s);for(let v=0;v<d.length;v++)if(!a.has(d[v]))return!1;return!0}getNodes(){return this.e}},c=new E.$bm;for(const s of i)if(c.set(s.identifier,s),s.extensionDependencies)for(const a of s.extensionDependencies)r.addArc(E.$_l.toKey(s.identifier),E.$_l.toKey(a));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const l=r.getNodes().filter(s=>!o.has(s));let n;do{n=!1;for(let s=0;s<l.length;s++){const a=l[s];r.hasOnlyGoodArcs(a,o)&&(l.splice(s,1),s--,o.add(a),n=!0)}}while(n);return l.map(s=>c.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$Q5b=$;class D{constructor(i,r){this.versionId=i,this.extensions=r}}e.$R5b=D;class f{constructor(i){this.d=new u,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new P(this,r)}deltaExtensions(i,r,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$S5b=f;class P extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$T5b=P;class k{constructor(i){this.name=i,this.promise=new Promise((r,c)=>{this.c=r})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new k(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function p(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==c)return r-c;const o=A.$fc.basename(t.extensionLocation.path),l=A.$fc.basename(i.extensionLocation.path);return o<l?-1:o>l?1:0}function g(t,i){const r=new E.$am(i);return t.filter(c=>!r.has(c.identifier))}}),define(Pe[79],Ae([1,0,24]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(L||(e.UIKind=L={}));var A;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var M;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(f){const P=E.$fe.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$hm=R;function $(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$im=$;var D;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=void 0;let b=class extends k.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new L.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:D.$uo,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,A.$fj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,c){const o=this.getTelemetryDetails(),l=new p(r,c,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,r,c){this.f=i,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:r["common.uikind"]="web";break;case R.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$2k)((0,D.$Bo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((c,o)=>{const l=c.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(c=>{for(const o of c)o.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const o=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(i.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(r),l=!0);return l}};e.$RM=b,e.$RM=b=Ke([We(0,M.$QM),We(1,A.$ej)],b);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,c,o,l,n,s){this.g=c,this.h=o,this.i=l,this.j=n,this.a=new L.$Rd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,D.$Eo)(r,[]),this.c&&(r=(0,f.$dn)(r,this.c)),this.b||(r=(0,f.$dn)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const c={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,D.$Eo)(c,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$SM=p;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$TM=g,e.$UM=(0,E.$Vh)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,193,101,22,4]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new R.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,$.$Vh)("extensionService");class D{constructor(l){this.dependency=l}}e.$KF=D;var f;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,n,s){this.c=l,this.d=n.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$yF.createActivationEventsMap(this.d)}}set(l,n,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],d=[],v=[],m=[],I=k(this.d),S=k(n),h=(K,U)=>K.extensionLocation.toString()===U.extensionLocation.toString()||K.isBuiltin===U.isBuiltin||K.isUserBuiltin===U.isUserBuiltin||K.isUnderDevelopment===U.isUnderDevelopment;for(const K of this.d){const U=S.get(K.identifier);if(!U){a.push(K.identifier),I.delete(K.identifier);continue}if(!h(K,U)){a.push(K.identifier),I.delete(K.identifier);continue}}for(const K of n){const U=I.get(K.identifier);if(!U){d.push(K);continue}if(!h(U,K)){a.push(U.identifier),I.delete(U.identifier);continue}}const w=new R.$am(this.e),y=new R.$am(s);for(const K of this.e)y.has(K)||v.push(K);for(const K of s)w.has(K)||m.push(K);const C=M.$yF.createActivationEventsMap(d),W={versionId:l,toRemove:a,toAdd:d,addActivationEvents:C,myToRemove:v,myToAdd:m};return this.delta(W),W}delta(l){if(this.c>=l.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:a,myToAdd:d}=l,v=new R.$am(n),m=new R.$am(a);for(let I=0;I<this.d.length;I++)v.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of d)this.e.push(I);return this.f=null,l}containsExtension(l){for(const n of this.e)if(R.$_l.equals(n,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const s=M.$yF.readActivationEvents(n);for(const a of s)l.add(a)}return l}}e.$LF=P;function k(o){const l=new R.$bm;for(const n of o)l.set(n.identifier,n);return l}function u(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$MF=u;function b(o,l){if(!u(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$NF=b;class p{constructor(l,n,s,a){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=a}}e.$OF=p;class g{constructor(l,n){this.description=l,this.value=n}}e.$PF=g;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Ko)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$QF=i;function r(o,l){return{identifier:new R.$_l((0,A.$Io)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$RF=r;class c{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,n){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=c}),define(Pe[218],Ae([1,0,11,106,22,23,15,14]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=e.$hec=e.$gec=e.$fec=e.$eec=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,r,c,o){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=o}}e.$eec=D;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$fec=f;class P{constructor(i,r,c,o,l,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=c,this.module=o,this.exports=l,this.subscriptions=n}}e.$gec=P;class k extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$hec=k;class u extends P{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$iec=u;class b extends P{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,r,c,o){this.g=o,this.a=i,this.b=r,this.c=c,this.d=new A.$bm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,c]of this.d)i.push(c.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const c=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(c.map(o=>({id:o.identifier,reason:{startup:r,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const c=this.a.getExtensionDescription(i);if(!c)throw new Error(`Extension '${i}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(i){const r=i.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(l));return this.c.onExtensionActivationError(i.id,l,new M.$KF(i.id.value)),n}const c=[],o=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of o){if(this.m(l))continue;const n=this.d.get(l);if(n){c.push(n);continue}if(this.l(l)){c.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;c.push(this.j({id:s.identifier,reason:i.reason}));continue}const a=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),v=this.k(i,r.displayName,[],new b(d));return this.c.onExtensionActivationError(r.identifier,d,new M.$KF(l)),v}return this.k(i,r.displayName,c,null)}k(i,r,c,o){const l=new g(i.id,r,i.reason,c,o,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$Q5b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$jec=p,e.$jec=p=Ke([We(3,R.$dj)],p);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,c,o,l,n,s){this.c=i,this.d=r,this.f=c,this.g=o,this.h=l,this.j=n,this.k=s,this.a=new $.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new b(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ke([We(6,R.$dj)],g)}),define(Pe[8],Ae([1,0,18,24,126,219,52,28,120,51,68,26,16,2,29,80,98,104,102,76,48,58,216,7,23]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$zM=e.$yM=e.MarkdownString=e.$xM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ie){function Me(H){const{selectionStartLineNumber:Le,selectionStartColumn:je,positionLineNumber:Qe,positionColumn:qe}=H,it=new s.$BK(Le-1,je-1),pt=new s.$BK(Qe-1,qe-1);return new s.$DK(it,pt)}Ie.to=Me;function ve(H){const{anchor:Le,active:je}=H;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ie.from=ve})(d||(e.Selection=d={}));var v;(function(Ie){function Me(H){if(!H)return;const{start:Le,end:je}=H;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ie.from=Me;function ve(H){if(!H)return;const{startLineNumber:Le,startColumn:je,endLineNumber:Qe,endColumn:qe}=H;return new s.$CK(Le-1,je-1,Qe-1,qe-1)}Ie.to=ve})(v||(e.Range=v={}));var m;(function(Ie){function Me(ve){switch(ve){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ie.to=Me})(m||(e.TokenType=m={}));var I;(function(Ie){function Me(H){return new s.$BK(H.lineNumber-1,H.column-1)}Ie.to=Me;function ve(H){return{lineNumber:H.line+1,column:H.character+1}}Ie.from=ve})(I||(e.Position=I={}));var S;(function(Ie){function Me(Le,je,Qe){return(0,E.$Gb)((0,E.$2b)(Le).map(qe=>ve(qe,je,Qe)))}Ie.from=Me;function ve(Le,je,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:H(Le.scheme,je),pattern:Z.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function H(Le,je){return je&&typeof Le=="string"?je.transformOutgoingScheme(Le):Le}})(S||(e.DocumentSelector=S={}));var h;(function(Ie){function Me(H){switch(H){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ie.from=Me;function ve(H){switch(H){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ie.to=ve})(h||(e.DiagnosticTag=h={}));var w;(function(Ie){function Me(H){let Le;return H.code&&((0,u.$Cf)(H.code)||(0,u.$Gf)(H.code)?Le=String(H.code):Le={value:String(H.code.value),target:H.code.target}),{...v.from(H.range),message:H.message,source:H.source,code:Le,severity:C.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(y.from),tags:Array.isArray(H.tags)?(0,E.$Gb)(H.tags.map(h.from)):void 0}}Ie.from=Me;function ve(H){const Le=new s.$OK(v.to(H),H.message,C.to(H.severity));return Le.source=H.source,Le.code=(0,u.$Cf)(H.code)?H.code:H.code?.value,Le.relatedInformation=H.relatedInformation&&H.relatedInformation.map(y.to),Le.tags=H.tags&&(0,E.$Gb)(H.tags.map(h.to)),Le}Ie.to=ve})(w||(e.Diagnostic=w={}));var y;(function(Ie){function Me(H){return{...v.from(H.location.range),message:H.message,resource:H.location.uri}}Ie.from=Me;function ve(H){return new s.$NK(new s.$MK(H.resource,v.to(H)),H.message)}Ie.to=ve})(y||(e.DiagnosticRelatedInformation=y={}));var C;(function(Ie){function Me(H){switch(H){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Me;function ve(H){switch(H){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ie.to=ve})(C||(e.DiagnosticSeverity=C={}));var W;(function(Ie){function Me(H){return typeof H=="number"&&H>=s.ViewColumn.One?H-1:H===s.ViewColumn.Beside?n.$MC:n.$LC}Ie.from=Me;function ve(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=ve})(W||(e.ViewColumn=W={}));function K(Ie){return typeof Ie.range<"u"}function U(Ie){return Ie.length===0?!0:!!K(Ie[0])}e.$xM=U;var z;(function(Ie){function Me(qe){return qe.map(Ie.from)}Ie.fromMany=Me;function ve(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let it;if(ve(qe)){const{language:ut,value:Mt}=qe;it={value:"```"+ut+`
`+Mt+"\n```\n"}}else s.$1K.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const pt=Object.create(null);it.uris=pt;const $t=ut=>{try{let Mt=b.URI.parse(ut,!0);Mt=Mt.with({query:Le(Mt.query,pt)}),pt[ut]=Mt}catch{}return""},bt=new D.marked.Renderer;return bt.link=$t,bt.image=ut=>typeof ut=="string"?$t(R.$dk(ut).href):"",(0,D.marked)(it.value,{renderer:bt}),it}Ie.from=H;function Le(qe,it){if(!qe)return qe;let pt;try{pt=(0,f.$rh)(qe)}catch{}if(!pt)return qe;let $t=!1;return pt=(0,k.$cn)(pt,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=bt,$t=!0,ut}else return}),$t?JSON.stringify(pt):qe}function je(qe){const it=new s.$1K(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,it}Ie.to=je;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ie.from(qe)}Ie.fromStrict=Qe})(z||(e.MarkdownString=z={}));function F(Ie){return U(Ie)?Ie.map(Me=>({range:v.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?z.fromMany(Me.hoverMessage):Me.hoverMessage?z.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ie.map(Me=>({range:v.from(Me)}))}e.$yM=F;function O(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?b.URI.file(Ie):Ie}e.$zM=O;var X;(function(Ie){function Me(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?O(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ie.from=Me})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var $e;(function(Ie){function Me(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Ie.from=Me})($e||(e.ThemableDecorationRenderOptions=$e={}));var Ee;(function(Ie){function Me(ve){if(typeof ve>"u")return ve;switch(ve){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Me})(Ee||(e.DecorationRangeBehavior=Ee={}));var De;(function(Ie){function Me(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?Ee.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?$e.from(ve.light):void 0,dark:ve.dark?$e.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Ie.from=Me})(De||(e.DecorationRenderOptions=De={}));var Ce;(function(Ie){function Me(H){return{text:H.newText,eol:H.newEol&&et.from(H.newEol),range:v.from(H.range)}}Ie.from=Me;function ve(H){const Le=new s.$HK(v.to(H.range),H.text);return Le.newEol=typeof H.eol>"u"?void 0:et.to(H.eol),Le}Ie.to=ve})(Ce||(e.TextEdit=Ce={}));var de;(function(Ie){function Me(H,Le){const je={edits:[]};if(H instanceof s.$KK){const Qe=new $.$Ac;for(const qe of H._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of H._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,L.$ze)(L.$fe.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),je.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?je.edits.push({resource:qe.uri,textEdit:Ce.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?je.edits.push({resource:qe.uri,textEdit:{range:v.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?je.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&je.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return je}Ie.from=Me;function ve(H){const Le=new s.$KK,je=new $.$zc;for(const Qe of H.edits)if(Qe.textEdit){const qe=Qe,it=b.URI.revive(qe.resource),pt=v.to(qe.textEdit.range),$t=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let ut;bt?ut=s.$JK.replace(pt,new s.$LK($t)):ut=s.$HK.replace(pt,$t);const Mt=je.get(it);Mt?Mt.push(ut):je.set(it,[ut])}else Le.renameFile(b.URI.revive(Qe.oldResource),b.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of je)Le.set(Qe,qe);return Le}Ie.to=ve})(de||(e.WorkspaceEdit=de={}));var pe;(function(Ie){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function ve(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ie.from=ve;function H(Le){for(const je in Me)if(Me[je]===Le)return Number(je);return s.SymbolKind.Property}Ie.to=H})(pe||(e.SymbolKind=pe={}));var re;(function(Ie){function Me(H){switch(H){case s.SymbolTag.Deprecated:return 1}}Ie.from=Me;function ve(H){switch(H){case 1:return s.SymbolTag.Deprecated}}Ie.to=ve})(re||(e.SymbolTag=re={}));var Re;(function(Ie){function Me(H){return{name:H.name,kind:pe.from(H.kind),tags:H.tags&&H.tags.map(re.from),containerName:H.containerName,location:me.from(H.location)}}Ie.from=Me;function ve(H){const Le=new s.$RK(H.name,pe.to(H.kind),H.containerName,me.to(H.location));return Le.tags=H.tags&&H.tags.map(re.to),Le}Ie.to=ve})(Re||(e.WorkspaceSymbol=Re={}));var se;(function(Ie){function Me(H){const Le={name:H.name||"!!MISSING: name!!",detail:H.detail,range:v.from(H.range),selectionRange:v.from(H.selectionRange),kind:pe.from(H.kind),tags:H.tags?.map(re.from)??[]};return H.children&&(Le.children=H.children.map(Me)),Le}Ie.from=Me;function ve(H){const Le=new s.$SK(H.name,H.detail,pe.to(H.kind),v.to(H.range),v.to(H.selectionRange));return(0,E.$Kb)(H.tags)&&(Le.tags=H.tags.map(re.to)),H.children&&(Le.children=H.children.map(ve)),Le}Ie.to=ve})(se||(e.DocumentSymbol=se={}));var Y;(function(Ie){function Me(H){const Le=new s.$WK(pe.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ie.to=Me;function ve(H,Le,je){if(Le=Le??H._sessionId,je=je??H._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,name:H.name,detail:H.detail,kind:pe.from(H.kind),uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(re.from)}}Ie.from=ve})(Y||(e.CallHierarchyItem=Y={}));var B;(function(Ie){function Me(ve){return new s.$XK(Y.to(ve.from),ve.fromRanges.map(H=>v.to(H)))}Ie.to=Me})(B||(e.CallHierarchyIncomingCall=B={}));var ie;(function(Ie){function Me(ve){return new s.$YK(Y.to(ve.to),ve.fromRanges.map(H=>v.to(H)))}Ie.to=Me})(ie||(e.CallHierarchyOutgoingCall=ie={}));var me;(function(Ie){function Me(H){return{range:H.range&&v.from(H.range),uri:H.uri}}Ie.from=Me;function ve(H){return new s.$MK(b.URI.revive(H.uri),v.to(H.range))}Ie.to=ve})(me||(e.location=me={}));var ne;(function(Ie){function Me(H){const Le=H,je=H;return{originSelectionRange:Le.originSelectionRange?v.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:je.uri,range:v.from(Le.targetRange?Le.targetRange:je.range),targetSelectionRange:Le.targetSelectionRange?v.from(Le.targetSelectionRange):void 0}}Ie.from=Me;function ve(H){return{targetUri:b.URI.revive(H.uri),targetRange:v.to(H.range),targetSelectionRange:H.targetSelectionRange?v.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?v.to(H.originSelectionRange):void 0}}Ie.to=ve})(ne||(e.DefinitionLink=ne={}));var le;(function(Ie){function Me(H){return{range:v.from(H.range),contents:z.fromMany(H.contents)}}Ie.from=Me;function ve(H){return new s.$PK(H.contents.map(z.to),v.to(H.range))}Ie.to=ve})(le||(e.Hover=le={}));var ce;(function(Ie){function Me(H){return{range:v.from(H.range),expression:H.expression}}Ie.from=Me;function ve(H){return new s.$IL(v.to(H.range),H.expression)}Ie.to=ve})(ce||(e.EvaluatableExpression=ce={}));var we;(function(Ie){function Me(H){if(H instanceof s.$JL)return{type:"text",range:v.from(H.range),text:H.text};if(H instanceof s.$KL)return{type:"variable",range:v.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof s.$LL)return{type:"expression",range:v.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Me;function ve(H){switch(H.type){case"text":return{range:v.to(H.range),text:H.text};case"variable":return{range:v.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:v.to(H.range),expression:H.expression}}}Ie.to=ve})(we||(e.InlineValue=we={}));var _;(function(Ie){function Me(H){return{frameId:H.frameId,stoppedLocation:v.from(H.stoppedLocation)}}Ie.from=Me;function ve(H){return new s.$ML(H.frameId,v.to(H.stoppedLocation))}Ie.to=ve})(_||(e.InlineValueContext=_={}));var he;(function(Ie){function Me(H){return{range:v.from(H.range),kind:H.kind}}Ie.from=Me;function ve(H){return new s.$QK(v.to(H.range),H.kind)}Ie.to=ve})(he||(e.DocumentHighlight=he={}));var te;(function(Ie){function Me(ve){switch(ve){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ie.to=Me})(te||(e.CompletionTriggerKind=te={}));var ae;(function(Ie){function Me(ve){return{triggerKind:te.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ie.to=Me})(ae||(e.CompletionContext=ae={}));var ge;(function(Ie){function Me(H){switch(H){case s.CompletionItemTag.Deprecated:return 1}}Ie.from=Me;function ve(H){switch(H){case 1:return s.CompletionItemTag.Deprecated}}Ie.to=ve})(ge||(e.CompletionItemTag=ge={}));var Se;(function(Ie){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function ve(je){return Me.get(je)??9}Ie.from=ve;const H=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(je){return H.get(je)??s.CompletionItemKind.Property}Ie.to=Le})(Se||(e.CompletionItemKind=Se={}));var T;(function(Ie){function Me(ve,H){const Le=new s.$7K(ve.label);return Le.insertText=ve.insertText,Le.kind=Se.to(ve.kind),Le.tags=ve.tags?.map(ge.to),Le.detail=ve.detail,Le.documentation=R.$$j(ve.documentation)?z.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,p.$As.isIRange(ve.range)?Le.range=v.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:v.to(ve.range.insert),replacing:v.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new s.$LK(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof s.$CK?new s.$HK(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(je=>Ce.to(je))),Le.command=H&&ve.command?H.fromInternal(ve.command):void 0,Le}Ie.to=Me})(T||(e.CompletionItem=T={}));var V;(function(Ie){function Me(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:z.fromStrict(H.documentation)}}Ie.from=Me;function ve(H){return{label:H.label,documentation:R.$$j(H.documentation)?z.to(H.documentation):H.documentation}}Ie.to=ve})(V||(e.ParameterInformation=V={}));var G;(function(Ie){function Me(H){return{label:H.label,documentation:z.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(V.from):[],activeParameter:H.activeParameter}}Ie.from=Me;function ve(H){return{label:H.label,documentation:R.$$j(H.documentation)?z.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(V.to):[],activeParameter:H.activeParameter}}Ie.to=ve})(G||(e.SignatureInformation=G={}));var J;(function(Ie){function Me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.from):[]}}Ie.from=Me;function ve(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(G.to):[]}}Ie.to=ve})(J||(e.SignatureHelp=J={}));var q;(function(Ie){function Me(ve,H){const Le=new s.$6K(I.to(H.position),typeof H.label=="string"?H.label:H.label.map(x.to.bind(void 0,ve)),H.kind&&ue.to(H.kind));return Le.textEdits=H.textEdits&&H.textEdits.map(Ce.to),Le.tooltip=R.$$j(H.tooltip)?z.to(H.tooltip):H.tooltip,Le.paddingLeft=H.paddingLeft,Le.paddingRight=H.paddingRight,Le}Ie.to=Me})(q||(e.InlayHint=q={}));var x;(function(Ie){function Me(ve,H){const Le=new s.$5K(H.label);return Le.tooltip=R.$$j(H.tooltip)?z.to(H.tooltip):H.tooltip,g.Command.is(H.command)&&(Le.command=ve.fromInternal(H.command)),H.location&&(Le.location=me.to(H.location)),Le}Ie.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Ie){function Me(H){return H}Ie.from=Me;function ve(H){return H}Ie.to=ve})(ue||(e.InlayHintKind=ue={}));var Ne;(function(Ie){function Me(H){return{range:v.from(H.range),url:H.target,tooltip:H.tooltip}}Ie.from=Me;function ve(H){let Le;if(H.url)try{Le=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new s.$_K(v.to(H.range),Le)}Ie.to=ve})(Ne||(e.DocumentLink=Ne={}));var Ue;(function(Ie){function Me(H){const Le=new s.$cL(H.label);return H.textEdit&&(Le.textEdit=Ce.to(H.textEdit)),H.additionalTextEdits&&(Le.additionalTextEdits=H.additionalTextEdits.map(je=>Ce.to(je))),Le}Ie.to=Me;function ve(H){return{label:H.label,textEdit:H.textEdit?Ce.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Le=>Ce.from(Le)):void 0}}Ie.from=ve})(Ue||(e.ColorPresentation=Ue={}));var Ze;(function(Ie){function Me(H){return new s.$aL(H[0],H[1],H[2],H[3])}Ie.to=Me;function ve(H){return[H.red,H.green,H.blue,H.alpha]}Ie.from=ve})(Ze||(e.Color=Ze={}));var Je;(function(Ie){function Me(H){return{range:v.from(H.range)}}Ie.from=Me;function ve(H){return new s.$VK(v.to(H.range))}Ie.to=ve})(Je||(e.SelectionRange=Je={}));var tt;(function(Ie){function Me(ve){switch(ve){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ie.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var _e;(function(Ie){function Me(H){switch(H){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Me;function ve(H){switch(H){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ie.to=ve})(_e||(e.TextEditorLineNumbersStyle=_e={}));var et;(function(Ie){function Me(H){if(H===s.EndOfLine.CRLF)return 1;if(H===s.EndOfLine.LF)return 0}Ie.from=Me;function ve(H){if(H===1)return s.EndOfLine.CRLF;if(H===0)return s.EndOfLine.LF}Ie.to=ve})(et||(e.EndOfLine=et={}));var rt;(function(Ie){function Me(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ie){function Me(H){const Le={start:H.start+1,end:H.end+1};return H.kind&&(Le.kind=ze.from(H.kind)),Le}Ie.from=Me;function ve(H){const Le={start:H.start-1,end:H.end-1};return H.kind&&(Le.kind=ze.to(H.kind)),Le}Ie.to=ve})(nt||(e.FoldingRange=nt={}));var ze;(function(Ie){function Me(H){if(H)switch(H){case s.FoldingRangeKind.Comment:return g.$pt.Comment;case s.FoldingRangeKind.Imports:return g.$pt.Imports;case s.FoldingRangeKind.Region:return g.$pt.Region}}Ie.from=Me;function ve(H){if(H)switch(H.value){case g.$pt.Comment.value:return s.FoldingRangeKind.Comment;case g.$pt.Imports.value:return s.FoldingRangeKind.Imports;case g.$pt.Region.value:return s.FoldingRangeKind.Region}}Ie.to=ve})(ze||(e.FoldingRangeKind=ze={}));var dt;(function(Ie){function Me(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?v.from(ve.selection):void 0,override:typeof ve.override=="boolean"?r.$bE.id:void 0}}Ie.from=Me})(dt||(e.TextEditorOpenOptions=dt={}));var Z;(function(Ie){function Me(je){return je instanceof s.$wL?je.toJSON():typeof je=="string"?je:ve(je)||H(je)?new s.$wL(je.baseUri??je.base,je.pattern).toJSON():je}Ie.from=Me;function ve(je){const Qe=je;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function H(je){const Qe=je;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(je){return typeof je=="string"?je:new s.$wL(b.URI.revive(je.baseUri),je.pattern)}Ie.to=Le})(Z||(e.GlobPattern=Z={}));var Q;(function(Ie){function Me(ve){if(ve){if(Array.isArray(ve))return ve.map(Me);if(typeof ve=="string")return ve;{const H=ve;return{language:H.language,scheme:H.scheme,pattern:Z.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ie.from=Me})(Q||(e.LanguageSelector=Q={}));var ye;(function(Ie){function Me(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Le=>Array.isArray(Le)&&Le.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Qe=>Qe instanceof s.$CK)))}Ie.is=Me;function ve(H){return{documents:H.documents.map(Le=>Le.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Qe=>v.from(Qe))})))}}Ie.from=ve})(ye||(e.MappedEditsContext=ye={}));var Be;(function(Ie){function Me(H){return{start:H.start,end:H.end}}Ie.from=Me;function ve(H){return new s.$XL(H.start,H.end)}Ie.to=ve})(Be||(e.NotebookRange=Be={}));var He;(function(Ie){function Me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ie.to=Me;function ve(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ie.from=ve})(He||(e.NotebookCellExecutionSummary=He={}));var Xe;(function(Ie){function Me(ve){if(ve===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(ve===c.NotebookCellExecutionState.Pending)return;if(ve===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ie.to=Me})(Xe||(e.NotebookCellExecutionState=Xe={}));var st;(function(Ie){function Me(H){switch(H){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}Ie.from=Me;function ve(H){switch(H){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}Ie.to=ve})(st||(e.NotebookCellKind=st={}));var vt;(function(Ie){function Me(H){const Le={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)s.$YL.validate(je),Le.cells.push(Dt.from(je));return Le}Ie.from=Me;function ve(H){const Le=new s.$ZL(H.cells.map(Dt.to));return(0,u.$Pf)(H.metadata)||(Le.metadata=H.metadata),Le}Ie.to=ve})(vt||(e.NotebookData=vt={}));var Dt;(function(Ie){function Me(H){return{cellKind:st.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:He.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Kt.from):[]}}Ie.from=Me;function ve(H){return new s.$YL(st.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Kt.to):void 0,H.metadata,H.internalMetadata?He.to(H.internalMetadata):void 0)}Ie.to=ve})(Dt||(e.NotebookCellData=Dt={}));var Oe;(function(Ie){function Me(H){return{mime:H.mime,valueBytes:L.$fe.wrap(H.data)}}Ie.from=Me;function ve(H){return new s.$1L(H.valueBytes.buffer,H.mime)}Ie.to=ve})(Oe||(e.NotebookCellOutputItem=Oe={}));var Kt;(function(Ie){function Me(H){return{outputId:H.id,items:H.items.map(Oe.from),metadata:H.metadata}}Ie.from=Me;function ve(H){const Le=H.items.map(Oe.to);return new s.$2L(Le,H.outputId,H.metadata)}Ie.to=ve})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ie){function Me(Le){return H(Le)?{include:Z.from(Le.include)??void 0,exclude:Z.from(Le.exclude)??void 0}:Z.from(Le)??void 0}Ie.from=Me;function ve(Le){return H(Le)?{include:Z.to(Le.include),exclude:Z.to(Le.exclude)}:Z.to(Le)}Ie.to=ve;function H(Le){const je=Le;return je?!(0,u.$Lf)(je.include)&&!(0,u.$Lf)(je.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ie){function Me(ve,H,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ie.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var jt;(function(Ie){function Me(ve,H,Le){const je=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:H.toInternal(je,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ie.from=Me})(jt||(e.NotebookKernelSourceAction=jt={}));var Ot;(function(Ie){function Me(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ie.from=Me})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Ie){function Me(H){return{uri:H.uri,provides:H.provides}}Ie.from=Me;function ve(H){return new s.$4L(b.URI.revive(H.uri),H.provides)}Ie.to=ve})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ie){function Me(H){return{message:z.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:v.from(H.location.range),uri:H.location.uri}}}Ie.from=Me;function ve(H){const Le=new s.$0L(typeof H.message=="string"?H.message:z.to(H.message));return Le.actualOutput=H.actual,Le.expectedOutput=H.expected,Le.contextValue=H.contextValue,Le.location=H.location?me.to(H.location):void 0,Le}Ie.to=ve})(Bt||(e.TestMessage=Bt={}));var St;(function(Ie){Ie.namespace=l.$vJ,Ie.denamespace=l.$wJ})(St||(e.TestTag=St={}));var Lt;(function(Ie){function Me(H){const Le=(0,i.$wM)(H).controllerId;return{extId:o.$rJ.fromExtHostTestItem(H,Le).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>St.namespace(Le,je.id)),range:p.$As.lift(v.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&z.fromStrict(H.error)||null}}Ie.from=Me;function ve(H){return{parent:void 0,error:void 0,id:o.$rJ.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Le=>{const{tagId:je}=St.denamespace(Le);return new s.$$L(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ie.toPlain=ve})(Lt||(e.TestItem=Lt={})),function(Ie){function Me(H){return{id:H.id}}Ie.from=Me;function ve(H){return new s.$$L(H.id)}Ie.to=ve}(St||(e.TestTag=St={}));var Wt;(function(Ie){const Me=(H,Le)=>{const je=[];for(const[qe,it]of Le)o.$rJ.compare(it.item.extId,qe)===2&&(Le.delete(qe),je.push(it));const Qe={...Lt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(Bt.to)})),children:je.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function ve(H){const Le=[],je=new Map;for(const Qe of H.items){je.set(Qe.item.extId,Qe);const qe=o.$rJ.root(Qe.item.extId);H.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:H.completedAt,results:Le.map(Qe=>Me(Qe,je))}}Ie.to=ve})(Wt||(e.TestResults=Wt={}));var Ye;(function(Ie){function Me(je){return{covered:je.covered,total:je.covered}}function ve(je){return"line"in je?I.from(je):v.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:ve(je.location),type:1,branches:je.branches.length?je.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ve(Qe.location)})):void 0}:{type:0,count:je.executionCount,location:ve(je.location)}}Ie.fromDetailed=H;function Le(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(H)}}Ie.fromFile=Le})(Ye||(e.TestCoverage=Ye={}));var Vt;(function(Ie){function Me(ve){switch(ve){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ie.to=Me})(Vt||(e.CodeActionTriggerKind=Vt={}));var qt;(function(Ie){function Me(H){const Le=new s.$eM(pe.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Le._sessionId=H._sessionId,Le._itemId=H._itemId,Le}Ie.to=Me;function ve(H,Le,je){if(Le=Le??H._sessionId,je=je??H._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,kind:pe.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(re.from)}}Ie.from=ve})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Ie){function Me(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ie.from=Me})(ct||(e.ViewBadge=ct={}));var gt;(function(Ie){function Me(je,Qe,qe){const it=Qe.fileData;return it?new s.$pL(new s.$qL(it.name,b.URI.revive(it.uri),it.id,(0,M.$cb)(()=>qe(it.id)))):je===P.$Wr.uriList&&Qe.uriListData?new s.$oL(Le(Qe.uriListData)):new s.$oL(Qe.asString)}Ie.to=Me;async function ve(je,Qe){const qe=await Qe.asString();if(je===P.$Wr.uriList)return{asString:qe,fileData:void 0,uriListData:H(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Ie.from=ve;function H(je){return A.$0s.split(je).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Le(je){return A.$0s.create(je.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt||(e.DataTransferItem=gt={}));var Nt;(function(Ie){function Me(H,Le){const je=H.items.map(([Qe,qe])=>[Qe,gt.to(Qe,qe,Le)]);return new s.$rL(je)}Ie.toDataTransfer=Me;async function ve(H){const Le={items:[]},je=[];for(const[Qe,qe]of H)je.push((async()=>{Le.items.push([Qe,await gt.from(Qe,qe)])})());return await Promise.all(je),Le}Ie.from=ve})(Nt||(e.DataTransfer=Nt={}));var Pt;(function(Ie){function Me(ve){return{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Ie.from=Me})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Ie){function Me(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:Pt.from(ve)}Ie.from=Me})(At||(e.ChatFollowup=At={}));var ft;(function(Ie){function Me(H){const Le=new s.$pM(kt.to(H.role),H.content);return Le.name=H.name,Le}Ie.to=Me;function ve(H){return{role:kt.from(H.role),content:H.content,name:H.name}}Ie.from=ve})(ft||(e.ChatMessage=ft={}));var kt;(function(Ie){function Me(H){switch(H){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ie.to=Me;function ve(H){switch(H){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ie.from=ve})(kt||(e.ChatMessageRole=kt={}));var Rt;(function(Ie){function Me(Le){const je={};for(const Qe of Object.keys(Le))je[Qe]=Le[Qe].map(Ie.to);return je}Ie.objectTo=Me;function ve(Le){return{level:Ct.to(Le.level),value:Le.value,description:Le.description}}Ie.to=ve;function H(Le){return{level:Ct.from(Le.level),value:Le.value,description:Le.description}}Ie.from=H})(Rt||(e.ChatVariable=Rt={}));var Ct;(function(Ie){function Me(H){switch(H){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ie.to=Me;function ve(H){switch(H){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ie.from=ve})(Ct||(e.ChatVariableLevel=Ct={}));var Ve;(function(Ie){function Me(ve){switch(ve){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ie.to=Me})(Ve||(e.InteractiveEditorResponseFeedbackKind=Ve={}));var zt;(function(Ie){function Me(ve,H){return"placeholder"in H&&"resolvedContent"in H?{placeholder:H.placeholder}:"markdownContent"in H?((0,a.$NF)(ve,"chatAgents2Additions"),{content:z.from(H.markdownContent)}):"content"in H?typeof H.content=="string"?H:((0,a.$NF)(ve,"chatAgents2Additions"),{content:z.from(H.content)}):"documents"in H?{documents:H.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(je=>v.from(je))}))}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:v.from(H.reference.range)}:H.reference}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:v.from(H.inlineReference.range)}:H.inlineReference,title:H.title}:("agentName"in H&&(0,a.$NF)(ve,"chatAgents2Additions"),H)}Ie.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Jt;(function(Ie){function Me(ve,H,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand}:"uri"in ve?{uri:ve.uri}:H.toInternal(ve,Le)}Ie.from=Me})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Pe[220],Ae([1,0,2,11,7,8,186]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class ${constructor(f,P,k,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=k,this.g=u,this.a=new R.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,k,u)=>{const p={dispose:this.a.push([P,k,f])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(f,P){const k=E.URI.revive(f);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),p=[];try{for(const g of[...this.a]){if(u)break;const t=this.d.getDocument(k),i=await this.h(g,{document:t,reason:M.TextDocumentSaveReason.to(P)});p.push(i)}}finally{clearTimeout(b)}return p}h([f,P,k],u){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(k,f,P,u).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,k,u){const b=[],p=Date.now(),{document:g,reason:t}=u,{version:i}=g,r=Object.freeze({document:g,reason:t,waitUntil(c){if(Object.isFrozen(b))throw(0,L.$7)("waitUntil can not be called async");b.push(Promise.resolve(c))}});try{P.apply(k,[r])}catch(c){return Promise.reject(c)}return Object.freeze(b),new Promise((c,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),c(n)}).catch(n=>{clearTimeout(l),o(n)})}).then(c=>{const o={edits:[]};for(const l of c)if(Array.isArray(l)&&l.every(n=>n instanceof A.$HK))for(const{newText:n,newEol:s,range:a}of l)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Pec=$}),define(Pe[221],Ae([1,0,13,2,8,7,76]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=void 0;class ${constructor(k,u,b,p){this.start=k,this.deletedCount=u,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new M.$XL(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,u,b){this.notebook=k,this.h=u,this.j=b,this.handle=b.handle,this.uri=L.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(A.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return k.g},set mime(p){k.g=p},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(b)}return this.f}setOutputs(k){this.a=k.map(A.NotebookCellOutput.to)}setOutputItems(k,u,b){const p=b.map(A.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===k);if(g&&(u||(g.items.length=0),g.items.push(...p),g.items.length>1&&g.items.every(t=>R.$CI(t.mime)))){const t=new Map,i=[];g.items.forEach(r=>{let c;t.has(r.mime)?c=t.get(r.mime):(c=[],t.set(r.mime,c),i.push(r.mime)),c.push(r.data)}),g.items.length=0,i.forEach(r=>{const c=R.$DI(t.get(r));g.items.push({mime:r,data:c.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Uec=D;class f{static{this.a=0}constructor(k,u,b,p,g){this.k=k,this.l=u,this.m=b,this.uri=p,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,u={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===E.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(b){return b=k.n(b),k.b[b].apiCell},getCells(b){return(b?k.p(b):k.b).map(g=>g.apiCell)},save(){return k.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,u,b){this.g=k.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of k.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const r=g[i],c=t.get(r.cell);if(c===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,o-1)}else p.cellChanges[c]={...p.cellChanges[c],...r}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let u=k.start|0,b=k.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),k.with({start:u,end:b})}p(k){k=this.o(k);const u=[];for(let b=k.start;b<k.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,u,b){if(this.j)return;const p=[],g=[],t=[];if(k.reverse().forEach(i=>{const c=i[2].map(n=>{const s=new D(this,this.l,n);return u||g.push(D.asModelAddData(this.apiNotebook,n)),s}),o=new $(i[0],i[1],[],c),l=this.b.splice(i[0],i[1],...c);for(const n of l)t.push(n.uri),o.deletedItems.push(n.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of p)b.push(i.asApiEvent())}s(k,u,b,p){const g=this.b.splice(k,u);this.b.splice(b,0,...g);const t=[new $(k,u,g.map(i=>i.apiCell),[]),new $(b,0,[],g)];for(const i of t)p.push(i.asApiEvent())}t(k,u){this.b[k].setOutputs(u)}u(k,u,b,p){this.b[k].setOutputItems(u,b,p)}v(k,u){const b=this.b[k];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(k,u){const b=this.b[k];b.apiCell.mime=u}x(k,u){this.b[k].setMetadata(u)}y(k,u){this.b[k].setInternalMetadata(u)}getCellFromApiCell(k){return this.b.find(u=>u.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(u=>u.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Vec=f}),define(Pe[222],Ae([1,0,5,2,8,7]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class R{constructor(D,f,P,k={timeout:1500,errors:3}){this.b=D,this.c=f,this.d=P,this.f=k,this.a=new E.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(f,P,k)=>{const u=function(p){f.call(P,p)};return u.extension=D,this.a.event(u,void 0,k)}}async $participateInSave(D,f,P){const k=L.URI.revive(D),u=this.c.getNotebookDocument(k);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:A.TextDocumentSaveReason.to(f)},P,async(g,t)=>{const i=Date.now(),r=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&r&&(r instanceof M.$KK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const g of b){const{edits:t}=A.WorkspaceEdit.from(g);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$_ec=R}),define(Pe[107],Ae([1,0,11,8,7]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,f,P,k,u){this.id=$,this.f=D,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=P,this.c=u}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(A.$XL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,f){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),f??A.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$Wec=M}),define(Pe[223],Ae([1,0,11,5,15,8]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;let R=class{constructor(D,f){this.c=D,this.d=f,this.a=new L.$Rd({onListenerError:E.$1}),this.b=new L.$Rd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,f);const P=this.d.getEditorById(D);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const f in D)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(D[f]))}};e.$bfc=R,e.$bfc=R=Ke([We(0,A.$dj)],R)}),define(Pe[224],Ae([1,0,8,72,163,20,66,11]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class D{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,p){const g=this.b++,{title:t,location:i,cancellable:r}=b,c={label:(0,A.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(g,{location:E.ProgressLocation.from(i),title:t,source:c,cancellable:r},u.isUnderDevelopment?void 0:u.identifier.value).catch($.$1),this.d(g,p,!!r)}d(u,b,p){let g;p&&(g=new M.$2d,this.c.set(u,g));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),g?.dispose()};let i;try{i=b(new P(this.a,u),p&&g?g.token:M.CancellationToken.None)}catch(r){throw t(u),r}return i.then(r=>t(u),r=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$ifc=D;function f(k,u){return k.message=u.message,typeof u.increment=="number"&&(typeof k.increment=="number"?k.increment+=u.increment:k.increment=u.increment),k}class P extends L.$_u{constructor(u,b){super(p=>this.throttledReport(p)),this.c=u,this.d=b}throttledReport(u){this.c.$progressReport(this.d,u)}}Ke([(0,R.$ph)(100,(k,u)=>f(k,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=e.$NM=e.$MM=void 0;const f=(c,o,l,n)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!l(s,a)){const d=s;s=a,c.listener?.(n(a,d))}}}},P=(c,o)=>c===o,k={range:(c,o)=>c===o?!0:!c||!o?!1:c.isEqual(o),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(c,o)=>!(c.length!==o.length||c.some(l=>!o.find(n=>l.id===n.id)))},u=c=>o=>({op:4,update:c(o)}),b=(c,o)=>({range:(()=>{let l;const n=u(s=>({range:E.$As.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){c.listener?.({op:6}),k.range(l,s)||(l=s,c.listener?.(n(s)))}}})(),label:f(c,o,k.label,u(l=>({label:l}))),description:f(c,void 0,k.description,u(l=>({description:l}))),sortText:f(c,void 0,k.sortText,u(l=>({sortText:l}))),canResolveChildren:f(c,!1,k.canResolveChildren,l=>({op:2,state:l})),busy:f(c,!1,k.busy,u(l=>({busy:l}))),error:f(c,void 0,k.error,u(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:f(c,[],k.tags,(l,n)=>({op:1,new:l.map($.TestTag.from),old:n.map($.TestTag.from)}))}),p=c=>{const o=A.$rJ.fromString(c.extId),l=new t(o.controllerId,o.localId,c.label,D.URI.revive(c.uri)||void 0);return l.range=$.Range.to(c.range||void 0),l.description=c.description||void 0,l.sortText=c.sortText||void 0,l.tags=c.tags.map(n=>$.TestTag.to({id:(0,R.$wJ)(n).tagId})),l},g=c=>{let o;for(const l of c.tests){const n=p(l.item);(0,L.$wM)(n).parent=o,o=n}return o};e.$MM=g;class t{constructor(o,l,n,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,L.$vM)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,M.$uM)(a,L.$wM,t),enumerable:!0,writable:!1},...b(a,n)})}}e.$NM=t;class i extends t{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$OM=i;class r extends M.$qM{constructor(o,l,n){super({controllerId:o,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:L.$wM,getChildren:s=>s.children,root:new i(o,l),toITestItem:$.TestItem.from})}}e.$PM=r}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=void 0;class ${static{this.c=new A.$FM("TextEditorDecorationType")}constructor(u,b,p){const g=$.c.nextId();u.$registerTextEditorDecorationType(b.identifier,g,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.$HM=$;class D{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let p=null;if(u instanceof R.$BK)p=new R.$CK(u,u);else if(u instanceof R.$CK)p=u;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(u,b){this.k(),this.l(new R.$CK(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof R.$CK)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,p){const g=this.c.validateRange(u);this.g.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=u}}class f{constructor(u,b,p,g){this.c=u,this.d=b,this._accept(p),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let p=!1;if(typeof u.tabSize<"u"){const g=this.l(u.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,p=!0,b.tabSize=g)}if(typeof u.indentSize<"u"){const g=this.n(u.indentSize);g==="tabSize"?(p=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,p=!0,b.indentSize=g)}if(typeof u.insertSpaces<"u"){const g=this.p(u.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,p=!0,b.insertSpaces=g)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,p=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,p=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$IM=f;class P{constructor(u,b,p,g,t,i,r,c){this.id=u,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,p),this.e=r,this.f=c;const o=this;this.value=Object.freeze({get document(){return g.value},set document(l){throw new L.$8("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof R.$DK))throw(0,L.$6)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(n=>!(n instanceof R.$DK)))throw(0,L.$6)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(g.value,n);return l(s),o.m(s)},insertSnippet(l,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o.c.map(d=>M.Range.from(d));else if(n instanceof R.$BK){const{lineNumber:d,column:v}=M.Position.from(n);a=[{startLineNumber:d,startColumn:v,endLineNumber:d,endColumn:v}]}else if(n instanceof R.$CK)a=[M.Range.from(n)];else{a=[];for(const d of n)if(d instanceof R.$CK)a.push(M.Range.from(d));else{const{lineNumber:v,column:m}=M.Position.from(d);a.push({startLineNumber:v,startColumn:m,endLineNumber:v,endColumn:m})}}return b.$tryInsertSnippet(u,g.value.version,l.value,a,s)},setDecorations(l,n){const s=n.length===0;s&&!o.h.has(l.key)||(s?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(M.$xM(n))return b.$trySetDecorations(u,l.key,M.$yM(n));{const a=new Array(4*n.length);for(let d=0,v=n.length;d<v;d++){const m=n[d];a[4*d]=m.start.line+1,a[4*d+1]=m.start.character+1,a[4*d+2]=m.end.line+1,a[4*d+3]=m.end.character+1}return b.$trySetDecorationsFast(u,l.key,a)}}))},revealRange(l,n){o.n(()=>b.$tryRevealRange(u,M.Range.from(l),n||R.TextEditorRevealType.Default))},show(l){b.$tryShowEditor(u,M.ViewColumn.from(l))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,E.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,E.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,E.ok)(!this.g),this.f=u}_acceptSelections(u){(0,E.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const r=p[t].end;if(p[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$JM=P}),define(Pe[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;function i(o,l){if((0,P.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class r extends R.$Rc{constructor(l,n,s){super(),this.f=l,this.g=n,this.h=s,this.a=new Map,this.b=new g.$u8;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(v=>a(v)?this.r(v):v):d})}registerTreeDataProvider(l,n,s){const a=this.createTreeView(l,{treeDataProvider:n},s);return{dispose:()=>a.dispose()}}createTreeView(l,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.dropMimeTypes??[],d=n.dragAndDropController?.dragMimeTypes??[],v=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,I=this.m(l,n,s),S={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:v,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(l,S),w={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$NF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$NF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(y){(0,b.$$j)(y)&&(0,t.$NF)(s,"treeViewMarkdownMessage"),I.message=y},get title(){return I.title},set title(y){I.title=y},get description(){return I.description},set description(y){I.description=y},get badge(){return I.badge},set badge(y){y!==void 0&&f.ViewBadge.isViewBadge(y)?I.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(I.badge=void 0)},reveal:(y,C)=>I.reveal(y,C),dispose:async()=>{await h,this.a.delete(l),I.dispose()}};return this.B(w),w}$getChildren(l,n){const s=this.a.get(l);return s?s.getChildren(n):Promise.reject(new $.$KE(l))}async $handleDrop(l,n,s,a,d,v,m,I){const S=this.a.get(l);if(!S)return Promise.reject(new $.$KE(l));const h=u.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,n,w)).buffer);return m===l&&I&&await this.j(h,S,I,d,v),S.onDrop(h,a,d)}async j(l,n,s,a,d){const v=this.b.removeDragOperationTransfer(d);if(v)(await v)?.forEach((m,I)=>{m&&l.set(I,m)});else if(d&&n.handleDrag){const m=n.handleDrag(s,l,a);this.b.addDragOperationTransfer(d,m),await m}return l}async $handleDrag(l,n,s,a){const d=this.a.get(l);if(!d)return Promise.reject(new $.$KE(l));const v=await this.j(new f.$rL,d,n,a,s);if(!(!v||a.isCancellationRequested))return u.DataTransfer.from(v)}async $hasResolve(l){const n=this.a.get(l);if(!n)throw new $.$KE(l);return n.hasResolve}$resolve(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);return a.resolveTreeItem(n,s)}$setExpanded(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setExpanded(n,s)}$setSelectionAndFocus(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setSelectionAndFocus(n,s)}$setVisible(l,n){const s=this.a.get(l);if(!s){if(!n)return;throw new $.$KE(l)}s.setVisible(n)}$changeCheckboxState(l,n){const s=this.a.get(l);if(!s)throw new $.$KE(l);s.setCheckboxState(n)}m(l,n,s){const a=this.B(new c(l,n,this.f,this.g.converter,this.h,s));return this.a.set(l,a),a}r(l){const n=this.a.get(l.$treeViewId);return n&&"$treeItemHandle"in l?n.getExtensionElement(l.$treeItemHandle):n&&"$focusedTreeItem"in l&&l.$focusedTreeItem?n.focusedElement:null}}e.$Bfc=r;class c extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,P.$Lf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,n,s,a,d,v){if(super(),this.I=l,this.J=s,this.L=a,this.M=d,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$2d,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const w of v.contributes.views[h])w.id===l&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let m,I;const S=M.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(y=>I=y),this.G=this.G.then(()=>m)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(S(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const y=I;return m=null,this.$(w).then(()=>y())})),h&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const n=l?this.getExtensionElement(l):void 0;if(l&&!n)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(n)),s?s.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,n){n=n||{select:!0,focus:!1};const s=(0,P.$Lf)(n.select)?!0:n.select,a=(0,P.$Lf)(n.focus)?!1:n.focus,d=(0,P.$Lf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(v=>this.W(l,v[v.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:v.map(I=>I.item)},{select:s,focus:a,expand:d})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:s,focus:a,expand:d})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,n){const s=this.getExtensionElement(l);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,n){const s=!(0,k.$tb)(this.s,l);this.s=l;const a=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const n=(await Promise.all(l.map(async s=>{const a=this.getExtensionElement(s.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,n,s){const a=[];for(const d of l){const v=this.getExtensionElement(d);v&&a.push(v)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,n,s){const a=n?this.getExtensionElement(n):void 0;if(!(!a&&n||!this.g?.handleDrop))return(0,D.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const a=this.m.get(s);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,s,n)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(l){return this.U(l).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}U(l){const n=this.m.get(l);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,D.$Qg)(()=>this.f.getParent(l))}W(l,n){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Qg)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const v=this.m.get(d);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let n;if(typeof l=="string"){const s=this.getExtensionElement(l);n=s?this.m.get(s):void 0}else n=l;return n&&n.children||void 0}return this.h}async Y(l){this.rb(l);const n=new p.$2d(this.Z.token);try{const s=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(n.token.isCancellationRequested)return;const d=await Promise.all((0,k.$Gb)(a||[]).map(async v=>{const m=await this.f.getTreeItem(v);return m&&!n.token.isCancellationRequested?this.db(v,m,s):null}));return n.token.isCancellationRequested?void 0:(0,k.$Gb)(d)}finally{n.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const n=new Set,s=l.map(d=>this.m.get(d));for(const d of s)if(d&&!n.has(d.item.handle)){let v=d;for(;v&&v.parent&&s.findIndex(m=>v&&v.parent&&m&&m.item.handle===v.parent.item.handle)===-1;){const m=this.j.get(v.parent.item.handle);v=m?this.m.get(m):void 0}v&&!v.parent&&n.add(d.item.handle)}const a=[];return n.forEach(d=>{const v=this.j.get(d);if(v){const m=this.m.get(v);m&&(!m.parent||!n.has(m.parent.item.handle))&&a.push(d)}}),a}bb(l){const n={};return Promise.all(l.map(s=>this.cb(s).then(a=>{a&&(n[s]=a.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(l){const n=this.getExtensionElement(l);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,D.$Qg)(()=>this.f.getTreeItem(n)).then(a=>{if(a){const d=this.ib(n,a,s.parent);return this.pb(n,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(l,n,s){const a=this.ib(l,n,s);if(n.id&&this.j.has(a.item.handle))throw new Error((0,E.localize)(0,null,n.id));return this.ob(l,a),this.qb(a,s),a}eb(l){return f.$1K.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,n){return n?{...this.L.toInternal(n,l),originalId:n.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let n,s,a;return typeof l.checkboxState=="number"?n=l.checkboxState:(n=l.checkboxState.state,s=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:a}}hb(l){if(!f.$mL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,n,s){this.hb(n);const a=this.B(new R.$Qc),d=this.kb(l,n,s),v=this.lb(n);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(a,n.command),contextValue:n.contextValue,icon:v,iconDark:this.mb(n)||v,themeIcon:this.jb(n),collapsibleState:(0,P.$Lf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof f.$uL?l.iconPath:void 0}kb(l,{id:n,label:s,resourceUri:a},d,v){if(n)return`${c.b}/${n}`;const m=i(s,this.N),I=d?d.item.handle:c.a;let S=m?m.label:a?(0,L.$wg)(a):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const h=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(d)||[];let y,C=0;do{if(y=`${I}/${C}:${S}`,v||!this.j.has(y)||h===y)break;C++}while(C<=w.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof f.$uL))return typeof l.iconPath=="string"||A.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof f.$uL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return A.URI.isUri(l)?l:A.URI.file(l)}ob(l,n){this.j.set(n.item.handle,l),this.m.set(l,n)}pb(l,n,s,a){this.j.delete(n.item.handle),this.m.delete(l),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,n);const d=this.X(a)||[],v=d.filter(m=>m.item.handle===s.item.handle)[0];v&&d.splice(d.indexOf(v),1,n)}qb(l,n){n?(n.children||(n.children=[]),n.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}n.children=void 0}}else this.tb()}sb(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Ae([1,0,179,11,31,96,73,30,22,226,189,101]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const u=$.$mn.as(R.$nn.JSONContribution);class b{constructor(l,n,s){this.a=l,this.b=n,this.c=s}d(l,n){this.a({type:l,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(A.default.Error,l)}warn(l){this.d(A.default.Warning,l)}info(l){this.d(A.default.Info,l)}}e.$TF=b;class p{static a(l){const n=new D.$am;for(let s=0,a=l.length;s<a;s++)n.add(l[s].description.identifier);return n}static compute(l,n){if(!l||!l.length)return new p(n,[]);if(!n||!n.length)return new p([],l);const s=this.a(l),a=this.a(n),d=n.filter(m=>!s.has(m.description.identifier)),v=l.filter(m=>!a.has(m.description.identifier));return new p(d,v)}constructor(l,n){this.added=l,this.removed=n}}e.$UF=p;class g{constructor(l,n){this.name=l,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$VF=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$$l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionKind:{description:E.localize(52,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const n=new g(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,n),l.activationEventsGenerator&&k.$yF.register(l.extensionPoint,l.activationEventsGenerator),e.$WF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(i,e.$WF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$mn.add(c.ExtensionsRegistry,new r),e.$YF=$.$mn.as(c.ExtensionsRegistry),u.registerSchema(i,e.$WF),u.registerSchema(P.$wj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Pe[228],Ae([1,0,175,16,26,227,34,5]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var f;(function(u){function b(p,g,t){if(!p)return;const i=L.$Cf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const r=[];if(Array.isArray(p.required))for(const c of p.required)L.$Cf(c)&&r.push(c);return{extensionId:g.value,taskType:i,required:r,properties:p.properties?A.$an(p.properties):{},when:p.when?R.$Ti.deserialize(p.when):void 0}}u.from=b})(f||(f={}));const P=M.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const p of u)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{P.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const i of t.added){const r=i.value;for(const c of r){const o=f.from(c,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const g={type:"object",additionalProperties:!1};p.required.length>0&&(g.required=p.required.slice(0)),p.properties!==void 0?g.properties=A.$an(p.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[p.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$8F=new k}),define(Pe[229],Ae([1,0,176,16,25,26,34,228]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new R.$aj("taskRunning",!1,E.localize(0,null)),e.$$F={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$_F="$customized",function(F){function O(X){if(!X)return F.Strong;switch(X.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=O}(D||(e.ShellQuoting=D={}));var f;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(P||(e.RevealKind=P={})),function(F){function O(X){switch(X.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=O}(P||(e.RevealKind=P={}));var k;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(F){function O(X){switch(X.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=O}(k||(e.RevealProblemKind=k={}));var u;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(u||(e.PanelKind=u={})),function(F){function O(X){switch(X.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=O}(u||(e.PanelKind=u={}));var b;(function(F){F.defaults={echo:!0,reveal:P.Always,revealProblems:k.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function O($e){switch($e.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=O;function X($e){switch($e){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=X}(p||(e.RuntimeType=p={}));var g;(function(F){function O(X){return L.$Cf(X)?X:X.value}F.value=O})(g||(e.CommandString=g={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function O($e){return $e===F.Clean._id||$e===F.Build._id||$e===F.Rebuild._id||$e===F.Test._id}F.is=O;function X($e){if($e!==void 0)return L.$Cf($e)?O($e)?{_id:$e,isDefault:!1}:void 0:$e}F.from=X})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function O(X){switch(X){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=O})(r||(e.TaskSourceKind=r={}));var c;(function(F){F.parallel="parallel",F.sequence="sequence"})(c||(e.DependsOrder=c={}));var o;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class n{constructor(O,X,$e,Ee,De,Ce){this._label="",this._id=O,X&&(this._label=X),$e&&(this.type=$e),this.runOptions=Ee,this.configurationProperties=De,this._source=Ce}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,X=!1){if(O===void 0)return!1;if(L.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||X&&O===this._id;const $e=this.getDefinition(!0);return $e!==void 0&&$e._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$aG=n;class s extends n{constructor(O,X,$e,Ee,De,Ce,de,pe){super(O,$e,void 0,de,pe,X),this.command={},this._source=X,this.hasDefinedMatchers=Ce,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case p.Shell:X="shell";break;case p.Process:X="process";break;case p.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let X=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(X+=this._source.kind);const $e={type:e.$_F,folder:O,id:X};return JSON.stringify($e)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$bG=s;class a extends n{constructor(O,X,$e,Ee,De,Ce,de){super(O,$e,Ee,Ce,de,X),this._source=X,this.configures=De}static is(O){return O instanceof a}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let X=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(X+=this._source.kind);const $e={type:e.$_F,folder:O,id:X};return JSON.stringify($e)}}e.$cG=a;class d extends n{constructor(O,X,$e,Ee,De,Ce,de,pe,re){super(O,$e,Ee,pe,re,X),this.defines=De,this.hasDefinedMatchers=de,this.command=Ce,this.icon=re.icon,this.hide=re.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof d}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new d(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$dG=d;class v extends n{constructor(O,X,$e,Ee,De,Ce){super(O,$e,Ee,De,Ce,X),this._source=X}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new v(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$eG=v;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(O){this.c=new Map;for(let X=0;X<O.length;X++)this.c.set(O[X].uri.toString(),X)}compare(O,X){const $e=O.getWorkspaceFolder(),Ee=X.getWorkspaceFolder();if($e&&Ee){let De=this.c.get($e.uri.toString());De=De===void 0?0:De+1;let Ce=this.c.get(Ee.uri.toString());return Ce=Ce===void 0?0:Ce+1,De===Ce?O._label.localeCompare(X._label):De-Ce}else return!$e&&Ee?-1:$e&&!Ee?1:0}}e.$fG=S;var h;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(F){function O(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function X(pe,re,Re){return{...O(pe),kind:"start",terminalId:re,resolvedVariables:Re}}F.start=X;function $e(pe,re,Re){return{...O(pe),kind:"processStarted",terminalId:re,processId:Re}}F.processStarted=$e;function Ee(pe,re,Re){return{...O(pe),kind:"processEnded",terminalId:re,exitCode:Re}}F.processEnded=Ee;function De(pe,re,Re){return{...O(pe),kind:"terminated",exitReason:Re,terminalId:re}}F.terminated=De;function Ce(pe,re,Re){return{...O(re),kind:pe,terminalId:Re}}F.general=Ce;function de(){return{kind:"changed"}}F.changed=de})(C||(e.TaskEvent=C={}));var W;(function(F){function O($e){const Ee=Object.keys($e).sort();let De="";for(const Ce of Ee){let de=$e[Ce];de instanceof Object?de=O(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),De+=Ce+","+de+","}return De}function X($e){const De={_key:O($e),type:$e.taskType};return Object.assign(De,$e),De}F.create=X})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(K||(e.TaskSettingId=K={}));var U;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var z;(function(F){function O(X,$e){const Ee=$.$8F.get(X.type);if(Ee===void 0){const pe=M.$an(X);return delete pe._key,W.create(pe)}const De=Object.create(null);De.type=Ee.taskType;const Ce=new Set;Ee.required.forEach(pe=>Ce.add(pe));const de=Ee.properties;for(const pe of Object.keys(de)){const re=X[pe];if(re!=null)De[pe]=re;else if(Ce.has(pe)){const Re=de[pe];if(Re.default!==void 0)De[pe]=M.$an(Re.default);else switch(Re.type){case"boolean":De[pe]=!1;break;case"number":case"integer":De[pe]=0;break;case"string":De[pe]="";break;default:$e.error(E.localize(2,null,JSON.stringify(X,void 0,0),pe));return}}}return W.create(De)}F.createTaskIdentifier=O})(z||(e.TaskDefinition=z={}))}),define(Pe[230],Ae([1,0,11]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.$U5b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$U5b=L;class A extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$V5b=A}),define(Pe[49],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.$vv=e.$uv=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$uv=E;const L=[];function A($){const D=new E($);return L[D.nid]=D,D}e.$vv=A;function M($){return L[$].sid}e.$wv=M;class R{constructor(D){this.value=D}}e.$xv=R}),define(Pe[3],Ae([1,0,49]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$xK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var A;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput",g[g.ChatEditorInput=10]="ChatEditorInput"})(A||(e.TabInputKind=A={}));var M;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class k{static{this.a=0}static mixin(t){return t._id=k.a++,t}}e.$xK=k;var u;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$yK={MainThreadAuthentication:(0,E.$vv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$vv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$vv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$vv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$vv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$vv)("MainThreadClipboard"),MainThreadCommands:(0,E.$vv)("MainThreadCommands"),MainThreadComments:(0,E.$vv)("MainThreadComments"),MainThreadConfiguration:(0,E.$vv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$vv)("MainThreadConsole"),MainThreadDebugService:(0,E.$vv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$vv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$vv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$vv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$vv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$vv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$vv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$vv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$vv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$vv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$vv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$vv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$vv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$vv)("MainThreadLanguages"),MainThreadLogger:(0,E.$vv)("MainThreadLogger"),MainThreadMessageService:(0,E.$vv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$vv)("MainThreadOutputService"),MainThreadProgress:(0,E.$vv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$vv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$vv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$vv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$vv)("MainThreadSecretState"),MainThreadStorage:(0,E.$vv)("MainThreadStorage"),MainThreadSpeech:(0,E.$vv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$vv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$vv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$vv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$vv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$vv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$vv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$vv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$vv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$vv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$vv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$vv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$vv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$vv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$vv)("MainThreadSCM"),MainThreadSearch:(0,E.$vv)("MainThreadSearch"),MainThreadShare:(0,E.$vv)("MainThreadShare"),MainThreadTask:(0,E.$vv)("MainThreadTask"),MainThreadWindow:(0,E.$vv)("MainThreadWindow"),MainThreadLabelService:(0,E.$vv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$vv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$vv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$vv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$vv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$vv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$vv)("MainThreadInteractive"),MainThreadChat:(0,E.$vv)("MainThreadChat"),MainThreadInlineChat:(0,E.$vv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$vv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$vv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$vv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$vv)("MainThreadTimeline"),MainThreadTesting:(0,E.$vv)("MainThreadTesting"),MainThreadLocalization:(0,E.$vv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$vv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$vv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$vv)("MainThreadIssueReporter")},e.$zK={ExtHostCommands:(0,E.$vv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$vv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$vv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$vv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$vv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$vv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$vv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$vv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$vv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$vv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$vv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$vv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$vv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$vv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$vv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$vv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$vv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$vv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$vv)("ExtHostStatusBar"),ExtHostShare:(0,E.$vv)("ExtHostShare"),ExtHostExtensionService:(0,E.$vv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$vv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$vv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$vv)("ExtHostSCM"),ExtHostSearch:(0,E.$vv)("ExtHostSearch"),ExtHostTask:(0,E.$vv)("ExtHostTask"),ExtHostWorkspace:(0,E.$vv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$vv)("ExtHostWindow"),ExtHostWebviews:(0,E.$vv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$vv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$vv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$vv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$vv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$vv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$vv)("ExtHostProgress"),ExtHostComments:(0,E.$vv)("ExtHostComments"),ExtHostSecretState:(0,E.$vv)("ExtHostSecretState"),ExtHostStorage:(0,E.$vv)("ExtHostStorage"),ExtHostUrls:(0,E.$vv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$vv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$vv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$vv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$vv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$vv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$vv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$vv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$vv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$vv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$vv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$vv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$vv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$vv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$vv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$vv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$vv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$vv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$vv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$vv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$vv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$vv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$vv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$vv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$vv)("ExtHostTimeline"),ExtHostTesting:(0,E.$vv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$vv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$vv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$vv)("ExtHostIssueReporter")}}),define(Pe[231],Ae([1,0,3,7]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$yK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(R);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiRelatedInformationProvider(f,$),new L.$AK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Bdc=A}),define(Pe[81],Ae([1,0,4,15,3,17]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=e.$Hdc=void 0,e.$Hdc=(0,E.$Vh)("IExtHostApiDeprecationService");let R=class{constructor(D,f){this.c=f,this.a=new Set,this.b=D.getProxy(A.$yK.MainThreadTelemetry)}report(D,f,P){const k=this.d(D,f);this.a.has(k)||(this.a.add(k),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:D}))}d(D,f){return`${D}-${f.identifier.value}`}};e.$Idc=R,e.$Idc=R=Ke([We(0,M.$AM),We(1,L.$dj)],R),e.$Jdc=Object.freeze(new class{report($,D,f){}})}),define(Pe[232],Ae([1,0,5,3,7,22]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class R{constructor(f){this.b=new Map,this.c=[],this.d=new E.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=f.getProxy(L.$yK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,k,u={}){const b=M.$_l.toKey(f.identifier),p=[...k].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const g=f.displayName||f.name;return this.a.$getSession(P,k,b,g,u)})}async getSessions(f,P,k){const u=M.$_l.toKey(f.identifier),b=[...k].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(P);const p=f.displayName||f.name;return this.a.$getSessions(P,k,u,p)})}async removeSession(f,P){const k=this.b.get(f);return k?k.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,k,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:k,options:u??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===f)||this.c.push({id:f,label:P});const b=k.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(f,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new A.$AK(()=>{b.dispose(),this.b.delete(f);const p=this.c.findIndex(g=>g.id===f);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,k){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,k));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const k=this.b.get(f);if(k)return Promise.resolve(k.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$Mdc=R;class ${constructor(){this.a=new Map}getOrCreate(f,P){const k=this.a.get(f);if(k)return k;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Pe[233],Ae([1,0,3,17,8]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$yK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>D.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,f){const P=A.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$Ndc=M,e.$Ndc=M=Ke([We(0,L.$AM)],M)}),define(Pe[234],Ae([1,0,5,67,6,3,8]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class ${static{this.a=0}constructor(P,k){this.extension=P,this.provider=k,this.handle=$.a++}}class D{static{this.a=0}constructor(P){this.b=new Map,this.c=new Map,this.d=new E.$Rd,this.onDidPerformUserAction=this.d.event,this.e=P.getProxy(M.$yK.MainThreadChat)}registerChatProvider(P,k,u){const b=new $(P,u);return this.b.set(b.handle,b),this.e.$registerChatProvider(b.handle,k),(0,A.$Pc)(()=>{this.e.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}transferChatSession(P,k){const u=L.Iterable.find(this.c.keys(),b=>this.c.get(b)===P)??0;typeof u=="number"&&this.e.$transferChatSession(u,k)}sendInteractiveRequestToProvider(P,k){this.e.$sendRequestToProvider(P,k)}async $prepareChat(P,k){const u=this.b.get(P);if(!u)return;const b=await u.provider.prepareSession(k);if(!b)return;const p=D.a++;return this.c.set(p,b),{id:p,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $provideWelcomeMessage(P,k){const u=this.b.get(P);if(!u||!u.provider.provideWelcomeMessage)return;const b=await u.provider.provideWelcomeMessage(k);if(b)return b.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(g=>R.ChatReplyFollowup.from(g)):R.MarkdownString.from(p))}async $provideSampleQuestions(P,k){const u=this.b.get(P);if(!u||!u.provider.provideSampleQuestions)return;const b=await u.provider.provideSampleQuestions(k);if(b)return b?.map(p=>R.ChatReplyFollowup.from(p))}$releaseSession(P){this.c.delete(P)}async $onDidPerformUserAction(P){this.d.fire(P)}}e.$Odc=D}),define(Pe[235],Ae([1,0,14,20,39,5,60,16,2,157,72,3,8,7,206,23]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class t{static{this.a=0}constructor(c,o,l){this.i=o,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(k.$yK.MainThreadChatAgents2)}createChatAgent(c,o,l){const n=t.a++,s=new i(c,o,this.d,n,l);return this.b.set(n,s),this.d.$registerAgent(n,o,{}),s.apiAgent}async $invokeAgent(c,o,l,n,s,a){this.g.delete(o);const d=this.b.get(c);if(!d)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let v=!1;function m(){if(v)throw new Error("Only valid while executing the command")}const I=new E.$ih;a.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,I.p);const S=n.command?await d.validateSlashCommand(n.command):void 0,h=R.$Nd.create(!1);let w;try{const y=d.invoke({prompt:n.message,variables:u.ChatVariable.objectTo(n.variables),slashCommand:S},{history:s.history.map(u.ChatMessage.to)},new P.$_u(C=>{m(),typeof w>"u"&&"content"in C&&(w=h.elapsed());const W=u.ChatResponseProgress.from(d.extension,C);if("placeholder"in C&&"resolvedContent"in C){const K=Promise.all([this.d.$handleProgressChunk(l,W),C.resolvedContent]);(0,E.$Mg)(K,a).then(U=>{if(!U)return;const[z,F]=U;this.d.$handleProgressChunk(l,F,z??void 0)})}else this.d.$handleProgressChunk(l,W)}),a);return await(0,E.$Mg)(Promise.resolve(y).then(C=>{if(C){this.g.set(o,C);let W=this.h.get(o);W||(W=new Map,this.h.set(o,W)),W.set(l,C);const K={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:C.errorDetails,timings:K}}else this.g.delete(o)}),a)}catch(y){return this.j.error(y,d.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,A.$Gi)(y)),responseIsIncomplete:!0}}}finally{v=!0,I.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,o){const l=this.b.get(c);return l?l.provideSlashCommand(o):[]}$provideFollowups(c,o,l){const n=this.b.get(c);if(!n)return Promise.resolve([]);const s=this.g.get(o);return s?n.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);if(!a)return;let d;switch(n){case p.InteractiveSessionVoteDirection.Down:d=b.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:d=b.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:a,kind:d}))}$acceptAction(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);a&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:a}))}}e.$Qdc=t;class i{constructor(c,o,l,n,s){this.extension=c,this.r=o,this.s=l,this.t=n,this.u=s,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(c){this.o.fire(c)}acceptAction(c){this.q.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$Mf)(this.b));const o=this.b.find(l=>l.name===c);if(!o)throw new Error(`Unknown slashCommand: ${c}`);return o}async provideSlashCommand(c){if(!this.a)return[];const o=await this.a.provideSlashCommands(c);return o?(this.b=o,o.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate,sampleRequest:l.sampleRequest}))):[]}async provideFollowups(c,o){if(!this.d)return[];const l=await this.d.provideFollowups(c,o);return l?l.map(n=>u.ChatFollowup.from(n)):[]}get apiAgent(){let c=!1,o=!1;const l=()=>{c||o||(o=!0,queueMicrotask(()=>{this.s.$updateAgent(this.t,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$uL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:u.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:u.MarkdownString.from(this.l),sampleRequest:this.m}),o=!1}))},n=this;return{get name(){return n.r},get description(){return n.g??""},set description(s){n.g=s,l()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,l()},get iconPath(){return n.i},set iconPath(s){n.i=s,l()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,l()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,l()},get isDefault(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,g.$NF)(n.extension,"defaultChatAgent"),n.j=s,l()},get helpTextPrefix(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.k},set helpTextPrefix(s){if((0,g.$NF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPrefix is only available on the default chat agent");n.k=s,l()},get helpTextPostfix(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.l},set helpTextPostfix(s){if((0,g.$NF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPostfix is only available on the default chat agent");n.l=s,l()},get isSecondary(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.n},set isSecondary(s){(0,g.$NF)(n.extension,"defaultChatAgent"),n.n=s,l()},get sampleRequest(){return n.m},set sampleRequest(s){n.m=s,l()},get onDidReceiveFeedback(){return n.o.event},onDidPerformAction:(0,g.$MF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){c=!0,n.a=void 0,n.d=void 0,n.o.dispose(),n.s.$unregisterAgent(n.t)}}}invoke(c,o,l,n){return this.u(c,o,l,n)}}}),define(Pe[236],Ae([1,0,20,6,3,8,72,22,14,5]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;class P{constructor(p,g){this.stream=new D.$mh,this.stream=g??new D.$mh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class k{constructor(p,g){this.a=new f.$Rd,this.b=new Map,this.c=new D.$mh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let g=this.b.get(p.index);g||(this.b.size===0?g=new P(p.index,this.c):g=new P(p.index),this.b.set(p.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(p.part)}}class u{static{this.a=1}constructor(p,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new $.$bm,this.b=p.getProxy(A.$yK.MainThreadChatProvider)}registerProvider(p,g,t,i){const r=u.a++;return this.c.set(r,{extension:p,provider:t}),this.b.$registerProvider(r,g,{extension:p,displayName:i.name??p.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(p,g,t,i,r){const c=this.c.get(p);if(!c)return;const o=new R.$_u(async l=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:l.index,part:l.part})});return c.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,r)}allowListExtensionWhile(p,g){this.f.set(p,g),g.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,g){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,r,c){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const o=new E.$2d(c),l=Math.random()*1e6|0,n=t.b.$fetchResponse(p,g,l,i.map(M.ChatMessage.from),r??{},o.token),s=new k(n,o);return t.e.set(l,{res:s}),n.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,g){const t=this.e.get(p);t&&t.res.handleFragment(g)}}e.$Pdc=u}),define(Pe[237],Ae([1,0,6,3,11,8]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$yK.MainThreadChatVariables)}async $resolveVariable(D,f,P){const k=this.b.get(D);if(k)try{const u=await k.resolver.resolve(k.data.name,{message:f},P);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,A.$1)(u)}}registerVariableResolver(D,f,P,k){const u=R.a++;return this.b.set(u,{extension:D.identifier,data:{name:f,description:P},resolver:k}),this.c.$registerVariable(u,{name:f,description:P}),(0,E.$Pc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Rdc=R}),define(Pe[238],Ae([1,0,3]),function(be,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class L{constructor(M){const R=M.getProxy(E.$yK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$Sdc=L}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,131,2,6,4,17,108,24,49,39,60,56,59]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=void 0;let s=class{#e;#t;#i;constructor(S,h,w){this.b=new Map,this.c=new Map,this.#e=S.getProxy(R.$yK.MainThreadCommands),this.d=h,this.#i=w,this.#t=S.getProxy(R.$yK.MainThreadTelemetry),this.converter=new a(this,y=>{const C=this.c.get(y);return C?.result===v.Void?C:void 0},h),this.f=[{processArgument(y){return(0,f.$sh)(y)}},{processArgument(y){return(0,M.$cn)(y,function(C){if(P.$As.isIRange(C))return A.Range.to(C);if(k.$zs.isIPosition(C))return A.Position.to(C);if(P.$As.isIRange(C.range)&&u.URI.isUri(C.uri))return A.location.to(C);if(C instanceof i.$fe)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const h=this.registerCommand(!1,S.id,async(...w)=>{const y=S.args.map((W,K)=>{if(!W.validate(w[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof w[K]=="object"?JSON.stringify(w[K],null,"	"):w[K]} `);return W.convert(w[K])}),C=await this.executeCommand(S.internalId,...y);return S.result.convert(C,w,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new L.$AK(()=>{h.dispose(),this.c.delete(S.id)})}registerCommand(S,h,w,y,C,W){if(this.d.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this.b.has(h))throw new Error(`command '${h}' already exists`);return this.b.set(h,{callback:w,thisArg:y,metadata:C,extension:W}),S&&this.#e.$registerCommand(h),new L.$AK(()=>{this.b.delete(h)&&S&&this.#e.$unregisterCommand(h)})}executeCommand(S,...h){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,h,!0)}async g(S,h,w){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,h,!1);{let y=!1;const C=(0,M.$cn)(h,function(W){if(W instanceof L.$BK)return A.Position.from(W);if(W instanceof L.$CK)return A.Range.from(W);if(W instanceof L.$MK)return A.location.from(W);if(L.$XL.isNotebookRange(W))return A.NotebookRange.from(W);if(W instanceof ArrayBuffer)return y=!0,i.$fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return y=!0,i.$fe.wrap(W);if(W instanceof i.$fe)return y=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,y?new r.$xv(C):C,w);return(0,f.$sh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,h,!1);throw W}}}async h(S,h,w){const y=this.b.get(S);if(!y)throw new Error("Unknown command");const{callback:C,thisArg:W,metadata:K}=y;if(K?.args)for(let z=0;z<K.args.length;z++)try{(0,E.$Tf)(h[z],K.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[z].name}' - ${K.args[z].description}`)}const U=o.$Nd.create();try{return await C.apply(W,h)}catch(z){if(S===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...h);F&&(S=F.command)}if(this.d.error(z,S,y.extension?.identifier),!w)throw z;if(y.extension?.identifier){const F=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",F,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Gi)(z)),this.id=S,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,S,U.elapsed())}}j(S,h,w){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new l.$po(h),duration:w})}$executeContributedCommand(S,...h){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const w=this.b.get(S);return w?(h=h.map(y=>this.f.reduce((C,W)=>W.processArgument(C,w.extension?.identifier),y)),this.h(S,h,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(h=>(S&&(h=h.filter(w=>w[0]!=="_")),h))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[h,w]of this.b){const{metadata:y}=w;y&&(S[h]=y)}return Promise.resolve(S)}};e.$VM=s,e.$VM=s=Ke([We(0,g.$AM),We(1,D.$dj),We(2,n.$UM)],s),e.$WM=(0,p.$Vh)("IExtHostCommands");class a{constructor(S,h,w){this.d=S,this.f=h,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,h){if(!S)return;const w={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return w;const y=this.f(S.command);if(y)w.id=y.internalId,w.arguments=y.args.map((C,W)=>C.convert(S.arguments&&S.arguments[W]));else if((0,$.$Kb)(S.arguments)){const C=`${S.command} /${++this.c}`;this.b.set(C,S),h.add((0,b.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),w.$ident=C,w.id=this.delegatingCommandId,w.arguments=[C],this.g.trace("CommandsConverter#CREATE",S.command,C)}return w}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const h=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],h?h.command:"MISSING"),h?this.d.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$XM=a;class d{static{this.Uri=new d("uri","Uri of a text document",S=>u.URI.isUri(S),S=>S)}static{this.Position=new d("position","A position in a text document",S=>L.$BK.isPosition(S),A.Position.from)}static{this.Range=new d("range","A range in a text document",S=>L.$CK.isRange(S),A.Range.from)}static{this.Selection=new d("selection","A selection in a text document",S=>L.$DK.isSelection(S),A.Selection.from)}static{this.Number=new d("number","",S=>typeof S=="number",S=>S)}static{this.String=new d("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=d.Arr(d.String)}static Arr(S){return new d(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,h=>Array.isArray(h)&&h.every(w=>S.validate(w)),h=>h.map(w=>S.convert(w)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",S=>S instanceof L.$WK,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",S=>S instanceof L.$eM,A.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",S=>S instanceof t.$NM,A.TestItem.from)}constructor(S,h,w,y){this.name=S,this.description=h,this.validate=w,this.convert=y}optional(){return new d(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,h){return new d(S??this.name,h??this.description,this.validate,this.convert)}}e.$YM=d;class v{static{this.Void=new v("no result",S=>S)}constructor(S,h){this.description=S,this.convert=h}}e.$ZM=v;class m{constructor(S,h,w,y,C){this.id=S,this.internalId=h,this.description=w,this.args=y,this.result=C}}e.$1M=m}),define(Pe[239],Ae([1,0,18,13,2,80,95,34,99,32,8,7]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;const u=[new f.$1M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of DocumentHighlight-instances.",p(P.DocumentHighlight.to))),new f.$1M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class r extends k.$RK{static to(o){const l=new r(o.name,P.SymbolKind.to(o.kind),o.containerName||"",new k.$MK(i[0],P.Range.to(o.range)));return l.detail=o.detail,l.range=l.location.range,l.selectionRange=P.Range.to(o.selectionRange),l.children=o.children?o.children.map(r.to):[],l}}return t.map(r.to)})),new f.$1M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$YM.Uri,new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$1M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$YM.Uri,f.$YM.Range,new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$1M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$YM.Uri,f.$YM.Position,new f.$YM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$YM("options","Formatting options",t=>!0,t=>t)],new f.$ZM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$1M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$1M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Location-instances.",p(P.location.to))),new f.$1M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of Hover-instances.",p(P.Hover.to))),new f.$1M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$YM.Uri,new f.$YM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>k.$BK.isPosition(i)),t=>t.map(P.Position.from))],new f.$ZM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const c of i.reverse())r=new k.$VK(P.Range.to(c),r);return r}))),new f.$1M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$YM.String.with("query","Search string")],new f.$ZM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$1M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$1M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$YM.CallHierarchyItem],new f.$ZM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$1M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$YM.CallHierarchyItem],new f.$ZM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$1M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$1M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("newName","The new symbol name")],new f.$ZM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$1M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$YM.Uri,f.$YM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$ZM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$1M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$YM.Uri],new f.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$PL(t.tokenTypes,t.tokenModifiers)})),new f.$1M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$YM.Uri],new f.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$E$)(t);if(i.type==="full")return new k.$RL(i.data,void 0)})),new f.$1M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$YM.Uri,f.$YM.Range.optional()],new f.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new k.$PL(t.tokenTypes,t.tokenModifiers)})),new f.$1M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$YM.Uri,f.$YM.Range],new f.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$E$)(t);if(i.type==="full")return new k.$RL(i.data,void 0)})),new f.$1M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$YM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$ZM("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new k.$8K([]);const c=t.suggestions.map(o=>P.CompletionItem.to(o,r));return new k.$8K(c,t.incomplete)})),new f.$1M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$YM.Uri,f.$YM.Position,f.$YM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$ZM("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$1M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$YM.Uri,f.$YM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$ZM("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>p(c=>new k.$ZK(P.Range.to(c.range),c.command&&r.fromInternal(c.command)))(t))),new f.$1M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$YM.Uri,new f.$YM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>k.$CK.isRange(t),t=>k.$DK.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$YM.String.with("kind","Code action kind to return code actions for").optional(),f.$YM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$ZM("A promise that resolves to an array of Command-instances.",(t,i,r)=>p(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const o=new k.$TK(c.title,c.kind?new k.$UK(c.kind):void 0);return c.edit&&(o.edit=P.WorkspaceEdit.to(c.edit)),c.command&&(o.command=r.fromInternal(c.command)),o.isPreferred=c.isPreferred,o}})(t))),new f.$1M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new k.$bL(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$1M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$YM("color","The color to show and insert",t=>t instanceof k.$aL,P.Color.from),new f.$YM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$ZM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$1M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$YM.Uri,f.$YM.Range],new f.$ZM("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(P.InlayHint.to.bind(void 0,r)))),new f.$1M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$YM.Uri],new f.$ZM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$1M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$ZM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$1M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$YM.Uri,f.$YM.Range,new f.$YM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof k.$CK,t=>P.InlineValueContext.from(t))],new f.$ZM("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$1M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$YM("uriOrString","Uri-instance or string (only http/https)",t=>A.URI.isUri(t)||typeof t=="string"&&(0,D.$OU)(t,L.Schemas.http,L.Schemas.https),t=>t),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$YM.String.with("label","").optional()],f.$ZM.Void),new f.$1M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$YM.Uri.with("resource","Resource to open"),f.$YM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$ZM.Void),new f.$1M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$YM.Uri.with("left","Left-hand side resource of the diff editor"),f.$YM.Uri.with("right","Right-hand side resource of the diff editor"),f.$YM.String.with("title","Human readable title for the diff editor").optional(),new f.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$ZM.Void),new f.$1M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$YM.String.with("title","Human readable title for the changes editor"),new f.$YM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[r,c,o]=i;if(!A.URI.isUri(r)||!A.URI.isUri(c)&&c!==void 0&&c!==null||!A.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],f.$ZM.Void),new f.$1M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$YM.Uri,f.$YM.Position],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$1M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$YM.TypeHierarchyItem],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$1M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$YM.TypeHierarchyItem],new f.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$1M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$YM.TestItem],f.$ZM.Void),new f.$1M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$YM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$ZM.Void),new f.$1M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$YM.String.with("name","The context key name"),new f.$YM("value","The context key value",()=>!0,t=>t)],f.$ZM.Void),new f.$1M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$YM.Uri,f.$YM.StringArray,new f.$YM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$ZM("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ui)}}e.$Ldc=b;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$lt(r)?i.push(P.DefinitionLink.to(r)):i.push(P.location.to(r));return i}}),define(Pe[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;function b(p,g,t){const i=p.getProxy(k.$yK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$bm,g.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const S=I.getCommentThread(m.commentThreadHandle);return S?S.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const S=I.getCommentThread(m.thread.commentThreadHandle);return S?m.$mid===8?S.value:{thread:S.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const S=I.getCommentThread(m.thread.commentThreadHandle);if(!S)return m;const h=m.commentUniqueId,w=S.getCommentByUniqueId(h);return w||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const S=I.getCommentThread(m.thread.commentThreadHandle);if(!S)return m;const h=m.text,w=m.commentUniqueId,y=S.getCommentByUniqueId(w);return y?(typeof y.body=="string"?y.body=h:y.body=new P.$1K(h),y):m}return m}})}createCommentController(m,I,S){const h=r.a++,w=new o(m,h,I,S);this.b.set(w.handle,w);const y=this.c.get(m.identifier)||[];return y.push(w),this.c.set(m.identifier,y),w.value}async $createCommentThreadTemplate(m,I,S){const h=this.b.get(m);h&&h.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(m,I,S){const h=this.b.get(m);h&&h.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,S){const h=this.b.get(m);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(R.URI.revive(I));return(0,E.$Qg)(async()=>{const y=await h.commentingRangeProvider.provideCommentingRanges(w,S);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(W=>f.Range.from(W)),fileComments:y.fileComments}),C})}$toggleReaction(m,I,S,h,w){const y=this.b.get(m);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,E.$Qg)(()=>{const C=y.getCommentThread(I);if(C){const W=C.getCommentByUniqueId(h.uniqueIdInThread);if(y!==void 0&&W&&y.reactionHandler)return y.reactionHandler(W,s(w))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,S,h,w,y,C,W){this.m=I,this.n=S,this.o=h,this.p=w,this.q=y,this.extensionDescription=C,this.r=W,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(U){K.range=U},get comments(){return K.comments},set comments(U){K.comments=U},get collapsibleState(){return K.collapsibleState},set collapsibleState(U){K.collapsibleState=U},get canReply(){return K.canReply},set canReply(U){K.canReply=U},get contextValue(){return K.contextValue},set contextValue(U){K.contextValue=U},get label(){return K.label},set label(U){K.label=U},get state(){return K.state},set state(U){K.state=U},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};m("range")&&(I.range=f.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(S=>l(this,S,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=a(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=d(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const S=I[0],h=I[1];if(m===h)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$oh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,S,h){this.f=m,this.g=I,this.h=S,this.i=h,this.a=new Map,i.$registerCommentController(this.handle,S,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(y){w.options=y},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(y){w.commentingRangeProvider=y},get reactionHandler(){return w.reactionHandler},set reactionHandler(y){w.reactionHandler=y},createCommentThread(y,C,W){return w.createCommentThread(y,C,W).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,S){I===void 0&&(0,u.$NF)(this.f,"fileComments");const h=new c(this.id,this.handle,void 0,m,I,S,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(m,I){const S=new c(this.id,this.handle,void 0,R.URI.revive(m),f.Range.to(I),[],this.f,!0);return S.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(m,I){const S=this.a.get(m);S&&(S.range=f.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(v,m,I,S){let h=I.get(m);return h||(h=++v.commentHandle,I.set(m,h)),m.state!==void 0&&(0,u.$NF)(S,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:h,body:typeof m.body=="string"?m.body:f.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>n(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(v){return{label:v.label,iconPath:v.iconPath?f.$zM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function s(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function a(v){if(v!==void 0)switch(v){case P.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(v){if(v!==void 0)switch(v){case P.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$Vdc=b}),define(Pe[241],Ae([1,0,26,3,27,17]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let R=class{constructor(P,k){this.a=P.getProxy(L.$yK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,k){const u=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,k,b,arguments)}})}e(P,k,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(b,this.b)}),this.c&&this.f(P,u,b)}};e.$Jfc=R,e.$Jfc=R=Ke([We(0,M.$AM),We(1,A.$QM)],R);const $=1e5;function D(f,P){const k=[];if(f.length)for(let u=0;u<f.length;u++){let b=f[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}k.push(b)}if(P){const u=new Error().stack;u&&k.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,E.$fn)(k);return u.length>$?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,19,23]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(L.$yK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=u.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(i,null);return}const o=(0,D.$2b)(c);if(o.length<=u.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const l=o.map(a=>({uri:a,rank:(0,f.$Ke)(a.path,"/")})),n=(0,D.$yb)(l,(a,d)=>a.rank-d.rank||(0,f.$Ye)(a.uri.path,d.uri.path)),s=[];e:for(const a of n){let d;for(const v of a){const m=(0,P.$lc)(v.uri.path);if(d!==m&&(d=m,s.push(v.uri)>=u.d))break e}}this.g.$onDidChange(i,s)});return new A.$AK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:o}=this.f.get(g);return await Promise.all(t.map(async l=>{try{const{uri:n,id:s}=l,a=await Promise.resolve(c.provideFileDecoration(E.URI.revive(n),i));if(!a)return;try{A.$VL.validate(a),a.badge&&typeof a.badge!="string"&&(0,k.$NF)(o,"codiconDecoration"),r[s]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${d}`)}}catch(n){this.h.error(n)}})),r}};e.$Lec=b,e.$Lec=b=u=Ke([We(0,R.$AM),We(1,$.$dj)],b),e.$Mec=(0,M.$Vh)("IExtHostDecorations")}),define(Pe[242],Ae([1,0,158,98,2,3,7,8,5,15,28,42]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0;class b{#e;#t;#i;constructor(t,i,r,c,o,l,n,s){this.d=t,this.e=i,this.f=r,this.g=c,this.h=o,this.c=!1,this.f=Math.max(c,r),this.#i=new P.$zc(a=>l.getComparisonKey(a)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(A.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let l;t=[...t].sort(b.k);for(const n of t){const[s,a]=n;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,r.push(s),this.#i.set(s,[])),a)this.#i.get(s)?.push(...a);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let o=0;for(const l of r){let n=[];const s=this.#i.get(l);if(s)if(s.length>this.g){n=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const v of s)if(v.severity===a[d]&&n.push({...$.Diagnostic.from(v),modelVersionId:this.h(l)})===this.g)break e;n.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(l)}));if(c.push([l,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,c)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,c]of this)t.call(i,r,c,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Fdc=b;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,c){this.j=i,this.k=r,this.l=c,this.g=new Map,this.h=new D.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,u._mapper),this.f=t.getProxy(M.$yK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:c,h:o,j:l,k:n,l:s}=this,a=new class{$changeMany(m,I){c.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){c.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){c.dispose()}};let d;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,d=i;else if(!r.has(i))d=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do d=i+u.c++;while(r.has(d))}return new class extends b{constructor(){super(i,d,u.e,u.d,m=>s.getDocument(m)?.version,n.extUri,a,o),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const c of this.g.values())c.forEach((o,l)=>{let n=i.get(o.toString());typeof n>"u"&&(n=r.length,i.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(...l)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(A.URI.revive(i),r.map($.Diagnostic.to))}};e.$Gdc=p,e.$Gdc=p=u=Ke([We(1,f.$dj),We(2,k.$Edc)],p)}),define(Pe[243],Ae([1,0,2,3,23]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class M{constructor($){this.a=$.getProxy(L.$yK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,A.$NF)($,"showLocal"),this.a.$showOpenDialog(D).then(f=>f?f.map(P=>E.URI.revive(P)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$Nec=M}),define(Pe[244],Ae([1,0,11,2,7,3,13,20,12]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class f{static{this.a=0}constructor(k,u,b){this.d=u,this.e=b,this.b=new Map,this.c=k.getProxy(M.$yK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,u){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const b=f.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,k);let p;return typeof u.onDidChange=="function"&&(p=u.onDidChange(g=>{if(g.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,D.$Te)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,t)},E.$Z)})),new A.$AK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(k,u){const b=this.b.get(k);return b?Promise.resolve(b.provideTextDocumentContent(L.URI.revive(u),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Oec=f}),define(Pe[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class u{constructor(p,g){this.a=new E.$Rd({onListenerError:k.$1}),this.b=new E.$Rd({onListenerError:k.$1}),this.c=new E.$Rd({onListenerError:k.$1}),this.d=new E.$Rd({onListenerError:k.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=p.getProxy(M.$yK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const g=this.g.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this.g.getDocument(p);if(g)return Promise.resolve(g);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const r=A.URI.revive(i);return(0,D.$Nf)(this.g.getDocument(r))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(g=>A.URI.revive(g))}$acceptModelLanguageChanged(p,g){const t=A.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(p){const g=A.URI.revive(p),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,g){const t=A.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,t){const i=A.URI.revive(p),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(g);let c;g.isUndoing?c=P.TextDocumentChangeReason.Undo:g.isRedoing&&(c=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$bn)({document:r.document,contentChanges:g.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:c}))}setWordDefinitionFor(p,g){(0,R.$CM)(p,g)}}e.$Cdc=u}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,44]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new L.$Rd,this.e=new L.$Rd,this.f=new L.$Rd,this.g=new L.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],n=[],s=[];if(o.removedDocuments)for(const a of o.removedDocuments){const d=M.URI.revive(a),v=this.c.get(d);v?.unref()&&(this.c.delete(d),l.push(v.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const d=M.URI.revive(a.uri);let v=this.c.get(d);if(v&&d.scheme!==p.Schemas.vscodeNotebookCell&&d.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);v||(v=new i(new D.$DM(this.h.getProxy($.$yK.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,v),n.push(v.value)),v.ref()}if(o.removedEditors)for(const a of o.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&s.push(d)}if(o.addedEditors)for(const a of o.addedEditors){const d=M.URI.revive(a.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const v=this.c.get(d).value,m=new P.$JM(a.id,this.h.getProxy($.$yK.MainThreadTextEditors),this.i,new t.$U(()=>v.document),a.selections.map(k.Selection.to),a.options,a.visibleRanges.map(I=>k.Range.to(I)),typeof a.editorPosition=="number"?k.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,m)}o.newActiveEditor!==void 0&&(E.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Mc)(l),(0,A.$Mc)(s),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return g.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$KM=r,e.$KM=r=Ke([We(0,f.$AM),We(1,u.$dj)],r),e.$LM=(0,R.$Vh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0,e.$cec=(0,R.$Vh)("IExtHostEditorTabs");class k{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.$fM(M.URI.revive(this.b.input.uri));case 2:return new P.$gM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new P.$hM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new P.$iM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.$jM(this.b.input.viewType);case 4:return new P.$kM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.$lM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.$mM;case 9:return new P.$nM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new P.$oM(this.b.input.providerId);default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new k(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return f.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new k(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new L.$Rd,this.c=new L.$Rd,this.e=[],this.a=t.getProxy($.$yK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,A.$Nf)(t.e.find(o=>o.groupId===r)?.apiObject)},close:async(r,c)=>{const o=Array.isArray(r)?r:[r];return o.length?p(o[0])?this.j(o,c):this.i(o,c):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(a=>a.groupId)),r=new Set(t.map(a=>a.groupId)),c=(0,E.$K)(i,r),o=this.e.filter(a=>c.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],n=[];this.e=t.map(a=>{const d=new u(a,()=>this.d);return c.added.includes(d.groupId)?l.push(d.apiObject):n.push(d.apiObject),d});const s=(0,A.$Nf)(t.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:o,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const c of t){const o=this.g(c);if(!o)throw new Error("Tab close: Invalid tab not found!");r.push(o.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const c of t){const o=this.h(c);if(!o)throw new Error("Group close: Invalid group not found!");r.push(o.groupId)}return this.a.$closeGroup(r,i)}};e.$dec=b,e.$dec=b=Ke([We(0,D.$AM)],b);function p(g){return g.tabs!==void 0}}),define(Pe[247],Ae([1,0,3,7]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$yK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(R);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector($,D);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(R,$,D){const f=this.b;return this.b++,this.a.set(f,D),this.c.$registerAiEmbeddingVectorProvider($,f),new L.$AK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Qec=A}),define(Pe[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class u{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,r,c=14,o=14;for(const l of g){let n=i?(0,D.$8e)(i,l):0;for(n===0?r=1:r=o;n<l.length;n++)n+1===l.length?(c=o,o=9):o+=1,t.push([r,l.toUpperCase().charCodeAt(n),o]),t.push([r,l.toLowerCase().charCodeAt(n),o]),r=o;i=l,o=c}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$FZ(t)}}provideDocumentLinks(g){this.c();const t=[],i=$.$GZ.computeLinks({getLineContent(r){return g.lineAt(r-1).text},getLineCount(){return g.lineCount}},this.b);for(const r of i){const c=R.DocumentLink.to(r);c.target&&t.push(c)}return t}}class b{constructor(g,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(L.$yK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const c=this.h++;this.b.add(t),this.d.add(t),this.c.set(c,i);let o=2;r.isCaseSensitive&&(o+=1024),r.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$NF)(g,"fsChunks"),o+=4);let l;r.isReadonly&&(0,k.$$j)(r.isReadonly)&&((0,P.$NF)(g,"readonlyMessage"),l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,t,o,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const a=[];for(const d of s){const{uri:v,type:m}=d;if(v.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:v,type:I})}this.a.$onFileSystemChange(c,a)});return(0,A.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:r,size:c,permissions:o}=g;return{type:t,ctime:i,mtime:r,size:c,permissions:o}}$stat(g,t){return Promise.resolve(this.l(g).stat(E.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(E.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(E.URI.revive(t))).then(i=>f.$fe.wrap(i))}$writeFile(g,t,i,r){return Promise.resolve(this.l(g).writeFile(E.URI.revive(t),i.buffer,r))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(E.URI.revive(t),i))}$rename(g,t,i,r){return Promise.resolve(this.l(g).rename(E.URI.revive(t),E.URI.revive(i),r))}$copy(g,t,i,r){const c=this.l(g);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(E.URI.revive(t),E.URI.revive(i),r))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(E.URI.revive(t)))}$watch(g,t,i,r){const c=this.l(g).watch(E.URI.revive(i),r);this.f.set(t,c)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const r=this.l(g);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(E.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,r){const c=this.l(g);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const o=f.$fe.alloc(r);return Promise.resolve(c.read(t,i,o.buffer,0,r)).then(l=>o.slice(0,l))}$write(g,t,i,r){const c=this.l(g);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(t,i,r.buffer,0,r.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Rec=b}),define(Pe[63],Ae([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;let p=b=class{constructor(t,i){this.b=new Map,this.c=new P.$7g,this.a=t.getProxy(E.$yK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let o;const l=r.b.get(c.scheme);return l?(await r.a.$ensureActivation(c.scheme),o=await l.impl.stat(c)):o=await r.a.$stat(c),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===L.FilePermission.Readonly?1:void 0}}catch(o){b.e(o)}},async readDirectory(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(o){return b.e(o)}},async createDirectory(c){try{const o=r.b.get(c.scheme);return o&&!o.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(o.impl,o.extUri,c)):await r.a.$mkdir(c)}catch(o){return b.e(o)}},async readFile(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(o){return b.e(o)}},async writeFile(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(l.impl.writeFile(c,o,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$fe.wrap(o))}catch(l){return b.e(l)}},async delete(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await l.impl.delete(c,{recursive:!1,...o})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return b.e(l)}},async rename(c,o,l){try{return await r.a.$rename(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},async copy(c,o,l){try{return await r.a.$copy(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},isWritableFileSystem(c){const o=i.getCapabilities(c);if(typeof o=="number")return!(o&2048)}})}async d(t,i,r){const c=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&L.FileType.Directory))throw A.$NL.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(L.$uk(o)!==L.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(r)),r=i.dirname(r)}for(let o=c.length-1;o>=0;o--){r=i.joinPath(r,c[o]);try{await t.createDirectory(r)}catch(l){if(L.$uk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof A.$NL)throw t;if(t instanceof L.$qk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw A.$NL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw A.$NL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw A.$NL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw A.$NL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw A.$NL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw A.$NL.Unavailable(t.message);default:throw new A.$NL(t.message,t.name)}if(!(t instanceof Error))throw new A.$NL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw A.$NL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw A.$NL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw A.$NL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw A.$NL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw A.$NL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw A.$NL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw A.$NL.Unavailable(t.message);default:throw new A.$NL(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?k.$pg:k.$rg,isReadonly:!!r?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??k.$pg}};e.$4dc=p,e.$4dc=p=b=Ke([We(0,$.$AM),We(1,D.$Edc)],p),e.$5dc=(0,R.$Vh)("IExtHostConsumerFileSystem")}),define(Pe[249],Ae([1,0,5,33,2,3,8,7,44]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,p,g,t,i,r){this.a=Math.random(),this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const c=(0,L.$Cj)(i),o=typeof i=="string",l=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const a of s.created){const d=A.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const a of s.changed){const d=A.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const a of s.deleted){const d=A.URI.revive(a);c(d.fsPath)&&(!o||p.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$AK.from(this.i(b,g,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,p,g,t,i){const r=$.$AK.from();if(typeof g=="string")return r;const c=b.getProxy(M.$yK.MainThreadFileSystemEventService);let o=!1;return(g.pattern.includes(L.$yj)||g.pattern.includes(L.$zj))&&(o=!0),c.$watch(p.identifier.value,this.a,g.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$AK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class P{constructor(b){this.a=b,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(A.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(A.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(b,p,g){this.j=b,this.k=p,this.l=g,this.a=new E.$Rd,this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.g=new E.$Td,this.h=new E.$Td,this.i=new E.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,p,g,t){return new f(this.j,b,p,this.a.event,R.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new P(b))}$onDidRunFileOperation(b,p){switch(b){case 2:this.b.fire(Object.freeze({files:p.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(g=>A.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,p){return(g,t,i)=>{const r=function(o){g.call(t,o)};return r.extension=b,p.event(r,void 0,i)}}async $onWillRunFileOperation(b,p,g,t){switch(b){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:A.URI.revive(i.source),newUri:A.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:p.map(i=>A.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>A.URI.revive(i.target))},g,t)}}async n(b,p,g,t){const i=new Set,r=[];if(await b.fireAsync(p,t,async(o,l)=>{const n=Date.now(),s=await Promise.resolve(o);s instanceof $.$KK&&(r.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,o]of r){const{edits:l}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(l)}return{edit:c,extensionNames:Array.from(i)}}}e.$Sec=k}),define(Pe[250],Ae([1,0,6,2,3,8,7,32,14]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=void 0;class f{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=f.a++}}class P{constructor(b){this.session=b,this.responses=[]}}class k{static{this.a=0}constructor(b,p,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(A.$yK.MainThreadInlineChat),p.registerApiCommand(new $.$1M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$YM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$ZM.Void))}registerProvider(b,p,g){const t=new f(b,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g.label,b.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,p,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(L.URI.revive(p)),c=M.Selection.to(g),o=await i.provider.prepareInteractiveEditorSession({document:r,selection:c},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=k.a++;return this.d.set(l,new P(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(b,p,g,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(p.id);if(!r)return;const c={prompt:g.prompt,selection:M.Selection.to(g.selection),wholeRange:M.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let o=!1;const l={report:async v=>{if(!g.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:v.message,edits:v.edits?.map(M.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:R.$1K.isMarkdownString(v.content)?v.content.value:v.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,c,l,t));let s;try{s=await(0,D.$Mg)(n,t)}finally{o=!0}if(!s)return;const a=r.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(k.h(s)){const{edits:v,contents:m}=s,I=m!==void 0?M.MarkdownString.from(m):void 0;return v instanceof R.$KK?{...d,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(v),message:I}:{...d,id:a,type:"editorEdit",edits:v.map(M.TextEdit.from),message:I}}return{...d,id:a,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(b,p,g,t){const i=this.b.get(b),r=this.d.get(p),c=r?.responses[g];if(i&&c){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,o)}}$releaseSession(b,p){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$Tec=k}),define(Pe[251],Ae([1,0,2,32]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class A{constructor(R,$,D,f,P){this.a=$,this.b=D,this.c=f;const k=new L.$1M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$YM("showOptions","Show Options",u=>!0,u=>u),new L.$YM("resource","Interactive resource Uri",u=>!0,u=>u),new L.$YM("controllerId","Notebook controller Id",u=>!0,u=>u),new L.$YM("title","Interactive editor title",u=>!0,u=>u)],new L.$ZM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:E.URI.revive(u.notebookUri),inputUri:E.URI.revive(u.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,$,D,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$7ec=A}),define(Pe[252],Ae([1,0,3,7]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class A{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$yK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const f=await D.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const f=await D.provideIssueData($);if(!f)throw new Error("Issue data provider returned no result");return f}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const f=await D.provideIssueTemplate($);if(!f)throw new Error("Issue template provider returned no result");return f}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$AK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$AK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$8ec=A}),define(Pe[253],Ae([1,0,6,3]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class A{constructor(R){this.b=0,this.a=R.getProxy(L.$yK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$9ec=A}),define(Pe[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,95,89,75,60,11,14,23,160]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class a{constructor(T,V){this.d=T,this.e=V}async provideDocumentSymbols(T,V){const G=this.d.getDocument(T),J=await this.e.provideDocumentSymbols(G,V);if(!(0,P.$Jb)(J))return J[0]instanceof M.$SK?J.map(A.DocumentSymbol.from):a.f(J)}static f(T){T=T.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const V=[],G=[];for(const J of T){const q={name:J.name||"!!MISSING: name!!",kind:A.SymbolKind.from(J.kind),tags:J.tags?.map(A.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:A.Range.from(J.location.range),selectionRange:A.Range.from(J.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const x=G[G.length-1];if(f.$As.containsRange(x.range,q.range)&&!f.$As.equalsRange(x.range,q.range)){x.children?.push(q),G.push(q);break}G.pop()}}return V}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,V,G){this.g=T,this.h=V,this.j=G,this.e=new r.$Adc("CodeLens"),this.f=new Map}async provideCodeLenses(T,V){const G=this.g.getDocument(T),J=await this.j.provideCodeLenses(G,V);if(!J||V.isCancellationRequested)return;const q=this.e.add(J),x=new g.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ue.lenses.push({cacheId:[q,Ne],range:A.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ue}async resolveCodeLens(T,V){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let J;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?J=G:J=await this.j.resolveCodeLens(G,V),J||(J=G),V.isCancellationRequested)return;const q=T.cacheId&&this.f.get(T.cacheId[0]);if(q)return T.command=this.h.toInternal(J.command??d.d,q),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function v(Se){return Array.isArray(Se)?Se.map(A.DefinitionLink.from):Se?[A.DefinitionLink.from(Se)]:[]}class m{constructor(T,V){this.d=T,this.e=V}async provideDefinition(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideDefinition(J,q,G);return v(x)}}class I{constructor(T,V){this.d=T,this.e=V}async provideDeclaration(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideDeclaration(J,q,G);return v(x)}}class S{constructor(T,V){this.d=T,this.e=V}async provideImplementation(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideImplementation(J,q,G);return v(x)}}class h{constructor(T,V){this.d=T,this.e=V}async provideTypeDefinition(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideTypeDefinition(J,q,G);return v(x)}}class w{constructor(T,V){this.d=T,this.e=V}async provideHover(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideHover(J,q,G);if(!(!x||(0,P.$Jb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new M.$CK(q,q)),A.Hover.from(x)}}class y{constructor(T,V){this.d=T,this.e=V}async provideEvaluatableExpression(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideEvaluatableExpression(J,q,G);if(x)return A.EvaluatableExpression.from(x)}}class C{constructor(T,V){this.d=T,this.e=V}async provideInlineValues(T,V,G,J){const q=this.d.getDocument(T),x=await this.e.provideInlineValues(q,A.Range.to(V),A.InlineValueContext.to(G),J);if(Array.isArray(x))return x.map(ue=>A.InlineValue.from(ue))}}class W{constructor(T,V){this.d=T,this.e=V}async provideDocumentHighlights(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideDocumentHighlights(J,q,G);if(Array.isArray(x))return x.map(A.DocumentHighlight.from)}}class K{constructor(T,V){this.d=T,this.e=V}async provideLinkedEditingRanges(T,V,G){const J=this.d.getDocument(T),q=A.Position.to(V),x=await this.e.provideLinkedEditingRanges(J,q,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Gb)(x.ranges.map(A.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(T,V){this.d=T,this.e=V}async provideReferences(T,V,G,J){const q=this.d.getDocument(T),x=A.Position.to(V),ue=await this.e.provideReferences(q,x,G,J);if(Array.isArray(ue))return ue.map(A.location.from)}}class z{static{this.d=1e3}constructor(T,V,G,J,q,x,ue){this.g=T,this.h=V,this.j=G,this.k=J,this.l=q,this.m=x,this.n=ue,this.e=new r.$Adc("CodeAction"),this.f=new Map}async provideCodeActions(T,V,G,J){const q=this.g.getDocument(T),x=u.$Cs.isISelection(V)?A.Selection.to(V):A.Range.to(V),ue=[];for(const _e of this.j.getDiagnostics(T))if(x.intersection(_e.range)&&ue.push(_e)>z.d)break;const Ne={diagnostics:ue,only:G.only?new M.$UK(G.only):void 0,triggerKind:A.CodeActionTriggerKind.to(G.trigger)},Ue=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,P.$Kb)(Ue)||J.isCancellationRequested)return;const Ze=this.e.add(Ue),Je=new g.$Qc;this.f.set(Ze,Je);const tt=[];for(let _e=0;_e<Ue.length;_e++){const et=Ue[_e];et&&(z.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Je)})):(Ne.only&&(et.kind?Ne.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ze,_e],title:et.title,command:et.command&&this.h.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(A.Diagnostic.from),edit:et.edit&&A.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$MF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ze,actions:tt}}async resolveCodeAction(T,V){const[G,J]=T,q=this.e.get(G,J);if(!q||z.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,V)??q;let ue;x.edit&&(ue=A.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Ue=this.f.get(G);Ue&&(Ne=this.h.toInternal(x.command,Ue))}return{edit:ue,command:Ne}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,J,q){this.d=T,this.e=V,this.f=G,this.g=J,this.h=q}async prepareDocumentPaste(T,V,G,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(T),x=V.map(Ue=>A.Range.to(Ue)),ue=A.DataTransfer.toDataTransfer(G,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,x,ue,J),J.isCancellationRequested)return;const Ne=Array.from(ue).filter(([,Ue])=>!(Ue instanceof M.$oL));return A.DataTransfer.from(Ne)}async providePasteEdits(T,V,G,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(V),ue=G.map(Ze=>A.Range.to(Ze)),Ne=A.DataTransfer.toDataTransfer(J,async Ze=>(await this.d.$resolvePasteFileData(this.g,T,Ze)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ue,Ne,q);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:F.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?A.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class O{constructor(T,V){this.d=T,this.e=V}async provideDocumentFormattingEdits(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideDocumentFormattingEdits(J,V,G);if(Array.isArray(q))return q.map(A.TextEdit.from)}}class X{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeFormattingEdits(T,V,G,J){const q=this.d.getDocument(T),x=A.Range.to(V),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,G,J);if(Array.isArray(ue))return ue.map(A.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,V,G,J){(0,k.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(T),x=V.map(A.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,G,J);if(Array.isArray(ue))return ue.map(A.TextEdit.from)}}class $e{constructor(T,V){this.d=T,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,V,G,J,q){const x=this.d.getDocument(T),ue=A.Position.to(V),Ne=await this.e.provideOnTypeFormattingEdits(x,ue,G,J,q);if(Array.isArray(Ne))return Ne.map(A.TextEdit.from)}}class Ee{constructor(T,V){this.e=T,this.f=V,this.d=new r.$Adc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,V){const G=await this.e.provideWorkspaceSymbols(T,V);if(!(0,P.$Kb)(G))return{symbols:[]};const J=this.d.add(G),q={cacheId:J,symbols:[]};for(let x=0;x<G.length;x++){const ue=G[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...A.WorkspaceSymbol.from(ue),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(T,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const J=await this.e.resolveWorkspaceSymbol(G,V);return J&&(0,L.$dn)(T,A.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideRenameEdits(T,V,G,J){const q=this.d.getDocument(T),x=A.Position.to(V);try{const ue=await this.e.provideRenameEdits(q,x,G,J);return ue?A.WorkspaceEdit.from(ue):void 0}catch(ue){const Ne=De.g(ue);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(T,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(T),q=A.Position.to(V);try{const x=await this.e.prepareRename(J,q,G);let ue,Ne;if(M.$CK.isRange(x)?(ue=x,Ne=J.getText(x)):(0,k.$Ef)(x)&&(ue=x.range,Ne=x.placeholder),!ue||!Ne)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(ue),text:Ne}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ce{constructor(T,V){this.resultId=T,this.tokens=V}}class de{constructor(T,V){this.f=T,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,V,G){const J=this.f.getDocument(T),q=V!==0?this.d.get(V):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,G):await this.g.provideDocumentSemanticTokens(J,G);return q&&this.d.delete(V),x?(x=de.h(x),this.o(de.n(q,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return de.j(T)?de.k(T)?T:new M.$RL(new Uint32Array(T.data),T.resultId):de.l(T)?de.m(T)?T:new M.$TL(T.edits.map(V=>new M.$SL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const V of T.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(T,V){if(!de.j(V)||!T||!T.tokens)return V;const G=T.tokens,J=G.length,q=V.data,x=q.length;let ue=0;const Ne=Math.min(J,x);for(;ue<Ne&&G[ue]===q[ue];)ue++;if(ue===J&&ue===x)return new M.$TL([],V.resultId);let Ue=0;const Ze=Ne-ue;for(;Ue<Ze&&G[J-Ue-1]===q[x-Ue-1];)Ue++;return new M.$TL([{start:ue,deleteCount:J-ue-Ue,data:q.subarray(ue,x-Ue)}],V.resultId)}o(T,V){if(de.j(T)){const G=this.e++;return this.d.set(G,new Ce(T.resultId,T.data)),(0,t.$D$)({id:G,type:"full",data:T.data})}if(de.l(T)){const G=this.e++;return de.j(V)?this.d.set(G,new Ce(V.resultId,V.data)):this.d.set(G,new Ce(T.resultId)),(0,t.$D$)({id:G,type:"delta",deltas:(T.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class pe{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeSemanticTokens(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideDocumentRangeSemanticTokens(J,A.Range.to(V),G);return q?this.f(q):null}f(T){return(0,t.$D$)({id:0,type:"full",data:T.data})}}class re{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,V,G,J,q){this.f=T,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new r.$Adc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,V,G,J){const q=this.f.getDocument(T),x=A.Position.to(V),ue=q.getWordRangeAtPosition(x)||new M.$CK(x,x),Ne=ue.with({end:x}),Ue=new c.$Nd,Ze=await this.h.provideCompletionItems(q,x,J,A.CompletionContext.to(G));if(!Ze||J.isCancellationRequested)return;const Je=Array.isArray(Ze)?new M.$8K(Ze):Ze,tt=re.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new g.$Qc;this.e.set(tt,_e);const et=[],rt={x:tt,b:et,a:{replace:A.Range.from(ue),insert:A.Range.from(Ne)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],dt=this.l(ze,[tt,nt],Ne,ue);et.push(dt)}return rt}async resolveCompletionItem(T,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const J=this.l(G,T),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const x=this.l(q,T);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,L.$en)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V,G,J){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,q),ue={x:V,a:T.label,b:T.kind!==void 0?A.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(A.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:A.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(A.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=T.textEdit.newText):typeof T.insertText=="string"?ue.h=T.insertText:T.insertText instanceof M.$LK&&(ue.h=T.insertText.value,ue.i|=4);let Ne;return T.textEdit?Ne=T.textEdit.range:T.range&&(Ne=T.range),M.$CK.isRange(Ne)?ue.j=A.Range.from(Ne):Ne&&(!G?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ue.j={insert:A.Range.from(Ne.inserting),replace:A.Range.from(Ne.replacing)}),ue}}class Re{async provideInlineCompletions(T,V,G,J){}disposeCompletions(T){}handleDidShowCompletionItem(T,V,G){}handlePartialAccept(T,V,G){}}class se extends Re{constructor(T,V,G,J){super(),this.f=T,this.g=V,this.h=G,this.j=J,this.d=new Y,this.e=(0,n.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,V,G,J){const q=this.g.getDocument(T),x=A.Position.to(V),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:A.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},J);if(!ue||J.isCancellationRequested)return;const Ne=Array.isArray(ue)?ue:ue.items,Ue=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ze=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Ne}),items:Ne.map((_e,et)=>{let rt;_e.command&&(Je||(Je=new g.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?A.Range.from(_e.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Ue.map(_e=>(Je||(Je=new g.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,V,G){const J=this.d.get(T)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,G)}handlePartialAccept(T,V,G){const J=this.d.get(T)?.items[V];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,G)}}class Y{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const V=this.e++;return this.d.set(V,T),V}disposeReferenceId(T){const V=this.d.get(T);return this.d.delete(T),V}get(T){return this.d.get(T)}}class B{constructor(T,V){this.e=T,this.f=V,this.d=new r.$Adc("SignatureHelp")}async provideSignatureHelp(T,V,G,J){const q=this.e.getDocument(T),x=A.Position.to(V),ue=this.g(G),Ne=await this.f.provideSignatureHelp(q,x,J,ue);if(Ne){const Ue=this.d.add([Ne]);return{...A.SignatureHelp.from(Ne),id:Ue}}}g(T){let V;if(T.activeSignatureHelp){const G=A.SignatureHelp.to(T.activeSignatureHelp),J=this.d.get(T.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...T,activeSignatureHelp:V}}releaseSignatureHelp(T){this.d.delete(T)}}class ie{constructor(T,V,G,J,q){this.f=T,this.g=V,this.h=G,this.j=J,this.k=q,this.d=new r.$Adc("InlayHints"),this.e=new Map}async provideInlayHints(T,V,G){const J=this.f.getDocument(T),q=A.Range.to(V),x=await this.h.provideInlayHints(J,q,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new g.$Qc);const Ne={hints:[],cacheId:ue};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Ne.hints.push(this.m(x[Ue],[ue,Ue]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Ne}async resolveInlayHint(T,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.h.resolveInlayHint(G,V);if(J&&this.l(J))return this.m(J,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(V&&!V.contains(T.position))}m(T,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:A.MarkdownString.fromStrict(T.tooltip),position:A.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(A.TextEdit.from),kind:T.kind&&A.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?J.label=T.label:J.label=T.label.map(q=>{const x={label:q.value};return x.tooltip=A.MarkdownString.fromStrict(q.tooltip),M.$MK.isLocation(q.location)&&(x.location=A.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,G)),x}),J}}class me{constructor(T,V){this.e=T,this.f=V,this.d=new r.$Adc("DocumentLink")}async provideLinks(T,V){const G=this.e.getDocument(T),J=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(me.g).map(A.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ue=0;ue<J.length;ue++){if(!me.g(J[ue]))continue;const Ne=A.DocumentLink.from(J[ue]);Ne.cacheId=[q,ue],x.links.push(Ne)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const J=await this.f.resolveDocumentLink(G,V);if(!(!J||!me.g(J)))return A.DocumentLink.from(J)}releaseLinks(T){this.d.delete(T)}}class ne{constructor(T,V){this.d=T,this.e=V}async provideColors(T,V){const G=this.d.getDocument(T),J=await this.e.provideDocumentColors(G,V);return Array.isArray(J)?J.map(x=>({color:A.Color.from(x.color),range:A.Range.from(x.range)})):[]}async provideColorPresentations(T,V,G){const J=this.d.getDocument(T),q=A.Range.to(V.range),x=A.Color.to(V.color),ue=await this.e.provideColorPresentations(x,{document:J,range:q},G);if(Array.isArray(ue))return ue.map(A.ColorPresentation.from)}}class le{constructor(T,V){this.d=T,this.e=V}async provideFoldingRanges(T,V,G){const J=this.d.getDocument(T),q=await this.e.provideFoldingRanges(J,V,G);if(Array.isArray(q))return q.map(A.FoldingRange.from)}}class ce{constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideSelectionRanges(T,V,G){const J=this.d.getDocument(T),q=V.map(A.Position.to),x=await this.e.provideSelectionRanges(J,q,G);if(!(0,P.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ne=0;Ne<q.length;Ne++){const Ue=[];ue.push(Ue);let Ze=q[Ne],Je=x[Ne];for(;;){if(!Je.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(A.SelectionRange.from(Je)),!Je.parent)break;Ze=Je.range,Je=Je.parent}}return ue}}class we{constructor(T,V){this.f=T,this.g=V,this.d=new i.$FM(""),this.e=new Map}async prepareSession(T,V,G){const J=this.f.getDocument(T),q=A.Position.to(V),x=await this.g.prepareCallHierarchy(J,q,G);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideCallsTo(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,G);if(q)return q.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(ue=>A.Range.from(ue))}))}async provideCallsFrom(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,G);if(q)return q.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(ue=>A.Range.from(ue))}))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),J=A.CallHierarchyItem.from(V,T,G.size.toString(36));return G.set(J._itemId,V),J}j(T,V){return this.e.get(T)?.get(V)}}class _{constructor(T,V){this.f=T,this.g=V,this.d=new i.$FM(""),this.e=new Map}async prepareSession(T,V,G){const J=this.f.getDocument(T),q=A.Position.to(V),x=await this.g.prepareTypeHierarchy(J,q,G);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideSupertypes(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,G);if(q)return q.map(x=>this.h(T,x))}async provideSubtypes(T,V,G){const J=this.j(T,V);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,G);if(q)return q.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),J=A.TypeHierarchyItem.from(V,T,G.size.toString(36));return G.set(J._itemId,V),J}j(T,V){return this.e.get(T)?.get(V)}}class he{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,J,q){this.d=T,this.e=V,this.f=G,this.g=J,this.h=q}async provideDocumentOnDropEdits(T,V,G,J,q){const x=this.e.getDocument(V),ue=A.Position.to(G),Ne=A.DataTransfer.toDataTransfer(J,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Ze)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ue,Ne,q);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:he.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?A.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class te{constructor(T,V){this.d=T,this.e=V}async provideMappedEdits(T,V,G,J){const q=E.URI.revive(T),x=this.d.getDocument(q),ue=G.documents.map(Ze=>Ze.map(Je=>({uri:E.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(tt=>A.Range.to(tt))}))),Ne={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,V,Ne,J);return Ue?A.WorkspaceEdit.from(Ue):null}}class ae{constructor(T,V){this.adapter=T,this.extension=V}}class ge{static{this.d=0}constructor(T,V,G,J,q,x,ue,Ne){this.g=V,this.h=G,this.j=J,this.k=q,this.l=x,this.m=ue,this.n=Ne,this.f=new Map,this.e=T.getProxy($.$yK.MainThreadLanguageFeatures)}o(T,V){return A.DocumentSelector.from(T,this.g,V)}p(T){return new M.$AK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return ge.d++}async s(T,V,G,J,q,x=!1){const ue=this.f.get(T);if(!ue||!(ue.adapter instanceof V))return J;const Ne=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ue.adapter,ue.extension);return Promise.resolve(Ue).catch(Ze=>{(0,o.$3)(Ze)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(ue.extension.identifier,Ze))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,l.$Ng)(Ue,q):Ue}t(T,V){const G=this.q();return this.f.set(G,new ae(T,V)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,V,G,J){const q=this.t(new a(this.h,G),T),x=J&&J.label||ge.u(T);return this.e.$registerDocumentSymbolProvider(q,this.o(V,T),x),this.p(q)}$provideDocumentSymbols(T,V,G){return this.s(T,a,J=>J.provideDocumentSymbols(E.URI.revive(V),G),void 0,G)}registerCodeLensProvider(T,V,G){const J=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new d(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(J,this.o(V,T),q);let x=this.p(J);if(q!==void 0){const ue=G.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=M.$AK.from(x,ue)}return x}$provideCodeLenses(T,V,G){return this.s(T,d,J=>J.provideCodeLenses(E.URI.revive(V),G),void 0,G)}$resolveCodeLens(T,V,G){return this.s(T,d,J=>J.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(T,V){this.s(T,d,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(T,V,G){const J=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(J,this.o(V,T)),this.p(J)}$provideDefinition(T,V,G,J){return this.s(T,m,q=>q.provideDefinition(E.URI.revive(V),G,J),[],J)}registerDeclarationProvider(T,V,G){const J=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(J,this.o(V,T)),this.p(J)}$provideDeclaration(T,V,G,J){return this.s(T,I,q=>q.provideDeclaration(E.URI.revive(V),G,J),[],J)}registerImplementationProvider(T,V,G){const J=this.t(new S(this.h,G),T);return this.e.$registerImplementationSupport(J,this.o(V,T)),this.p(J)}$provideImplementation(T,V,G,J){return this.s(T,S,q=>q.provideImplementation(E.URI.revive(V),G,J),[],J)}registerTypeDefinitionProvider(T,V,G){const J=this.t(new h(this.h,G),T);return this.e.$registerTypeDefinitionSupport(J,this.o(V,T)),this.p(J)}$provideTypeDefinition(T,V,G,J){return this.s(T,h,q=>q.provideTypeDefinition(E.URI.revive(V),G,J),[],J)}registerHoverProvider(T,V,G,J){const q=this.t(new w(this.h,G),T);return this.e.$registerHoverProvider(q,this.o(V,T)),this.p(q)}$provideHover(T,V,G,J){return this.s(T,w,q=>q.provideHover(E.URI.revive(V),G,J),void 0,J)}registerEvaluatableExpressionProvider(T,V,G,J){const q=this.t(new y(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,T)),this.p(q)}$provideEvaluatableExpression(T,V,G,J){return this.s(T,y,q=>q.provideEvaluatableExpression(E.URI.revive(V),G,J),void 0,J)}registerInlineValuesProvider(T,V,G,J){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(x,this.o(V,T),q);let ue=this.p(x);if(q!==void 0){const Ne=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ue=M.$AK.from(ue,Ne)}return ue}$provideInlineValues(T,V,G,J,q){return this.s(T,C,x=>x.provideInlineValues(E.URI.revive(V),G,J,q),void 0,q)}registerDocumentHighlightProvider(T,V,G){const J=this.t(new W(this.h,G),T);return this.e.$registerDocumentHighlightProvider(J,this.o(V,T)),this.p(J)}$provideDocumentHighlights(T,V,G,J){return this.s(T,W,q=>q.provideDocumentHighlights(E.URI.revive(V),G,J),void 0,J)}registerLinkedEditingRangeProvider(T,V,G){const J=this.t(new K(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,T)),this.p(J)}$provideLinkedEditingRanges(T,V,G,J){return this.s(T,K,async q=>{const x=await q.provideLinkedEditingRanges(E.URI.revive(V),G,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?ge.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(T,V,G){const J=this.t(new U(this.h,G),T);return this.e.$registerReferenceSupport(J,this.o(V,T)),this.p(J)}$provideReferences(T,V,G,J,q){return this.s(T,U,x=>x.provideReferences(E.URI.revive(V),G,J,q),void 0,q)}registerCodeActionProvider(T,V,G,J){const q=new g.$Qc,x=this.t(new z(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(V,T),{providedKinds:J?.providedCodeActionKinds?.map(ue=>ue.value),documentation:J?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},ge.u(T),!!G.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(T,V,G,J,q){return this.s(T,z,x=>x.provideCodeActions(E.URI.revive(V),G,J,q),void 0,q)}$resolveCodeAction(T,V,G){return this.s(T,z,J=>J.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(T,V){this.s(T,z,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(T,V,G){const J=this.t(new O(this.h,G),T);return this.e.$registerDocumentFormattingSupport(J,this.o(V,T),T.identifier,T.displayName||T.name),this.p(J)}$provideDocumentFormattingEdits(T,V,G,J){return this.s(T,O,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),G,J),void 0,J)}registerDocumentRangeFormattingEditProvider(T,V,G){const J=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new X(this.h,G),T);return this.e.$registerRangeFormattingSupport(q,this.o(V,T),T.identifier,T.displayName||T.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(T,V,G,J,q){return this.s(T,X,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(T,V,G,J,q){return this.s(T,X,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(V),G,J,q),void 0,q)}registerOnTypeFormattingEditProvider(T,V,G,J){const q=this.t(new $e(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,T),J,T.identifier),this.p(q)}$provideOnTypeFormattingEdits(T,V,G,J,q,x){return this.s(T,$e,ue=>ue.provideOnTypeFormattingEdits(E.URI.revive(V),G,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(T,V){const G=this.t(new Ee(V,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,V,G){return this.s(T,Ee,J=>J.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,V,G){return this.s(T,Ee,J=>J.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(T,V){this.s(T,Ee,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(T,V,G){const J=this.t(new De(this.h,G,this.l),T);return this.e.$registerRenameSupport(J,this.o(V,T),De.supportsResolving(G)),this.p(J)}$provideRenameEdits(T,V,G,J,q){return this.s(T,De,x=>x.provideRenameEdits(E.URI.revive(V),G,J,q),void 0,q)}$resolveRenameLocation(T,V,G,J){return this.s(T,De,q=>q.resolveRenameLocation(E.URI.revive(V),G,J),void 0,J)}registerDocumentSemanticTokensProvider(T,V,G,J){const q=this.t(new de(this.h,G),T),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,T),J,x);let ue=this.p(q);if(x){const Ne=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$AK.from(ue,Ne)}return ue}$provideDocumentSemanticTokens(T,V,G,J){return this.s(T,de,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),G,J),null,J)}$releaseDocumentSemanticTokens(T,V){this.s(T,de,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,V,G,J){const q=this.t(new pe(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,T),J),this.p(q)}$provideDocumentRangeSemanticTokens(T,V,G,J){return this.s(T,pe,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),G,J),null,J)}registerCompletionItemProvider(T,V,G,J){const q=this.t(new re(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(q,this.o(V,T),J,re.supportsResolving(G),T.identifier),this.p(q)}$provideCompletionItems(T,V,G,J,q){return this.s(T,re,x=>x.provideCompletionItems(E.URI.revive(V),G,J,q),void 0,q)}$resolveCompletionItem(T,V,G){return this.s(T,re,J=>J.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(T,V){this.s(T,re,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(T,V,G,J){const q=new se(T,this.h,G,this.j.converter),x=this.t(q,T);return this.e.$registerInlineCompletionsSupport(x,this.o(V,T),q.supportsHandleEvents,p.$_l.toKey(T.identifier.value),J?.yieldTo?.map(ue=>p.$_l.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(T,V,G,J,q){return this.s(T,Re,x=>x.provideInlineCompletions(E.URI.revive(V),G,J,q),void 0,q)}$handleInlineCompletionDidShow(T,V,G,J){this.s(T,Re,async q=>{q.handleDidShowCompletionItem(V,G,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,V,G,J){this.s(T,Re,async q=>{q.handlePartialAccept(V,G,J)},void 0,void 0)}$freeInlineCompletionsList(T,V){this.s(T,Re,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(T,V,G,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new B(this.h,G),T);return this.e.$registerSignatureHelpProvider(x,this.o(V,T),q),this.p(x)}$provideSignatureHelp(T,V,G,J,q){return this.s(T,B,x=>x.provideSignatureHelp(E.URI.revive(V),G,J,q),void 0,q)}$releaseSignatureHelp(T,V){this.s(T,B,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(T,V,G){const J=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ie(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(q,this.o(V,T),typeof G.resolveInlayHint=="function",J,ge.u(T));let x=this.p(q);if(J!==void 0){const ue=G.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=M.$AK.from(x,ue)}return x}$provideInlayHints(T,V,G,J){return this.s(T,ie,q=>q.provideInlayHints(E.URI.revive(V),G,J),void 0,J)}$resolveInlayHint(T,V,G){return this.s(T,ie,J=>J.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(T,V){this.s(T,ie,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(T,V,G){const J=this.t(new me(this.h,G),T);return this.e.$registerDocumentLinkProvider(J,this.o(V,T),typeof G.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(T,V,G){return this.s(T,me,J=>J.provideLinks(E.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(T,V,G){return this.s(T,me,J=>J.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(T,V){this.s(T,me,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(T,V,G){const J=this.t(new ne(this.h,G),T);return this.e.$registerDocumentColorProvider(J,this.o(V,T)),this.p(J)}$provideDocumentColors(T,V,G){return this.s(T,ne,J=>J.provideColors(E.URI.revive(V),G),[],G)}$provideColorPresentations(T,V,G,J){return this.s(T,ne,q=>q.provideColorPresentations(E.URI.revive(V),G,J),void 0,J)}registerFoldingRangeProvider(T,V,G){const J=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new le(this.h,G),T)),this.e.$registerFoldingRangeProvider(J,this.o(V,T),T.identifier,q);let x=this.p(J);if(q!==void 0){const ue=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$AK.from(x,ue)}return x}$provideFoldingRanges(T,V,G,J){return this.s(T,le,q=>q.provideFoldingRanges(E.URI.revive(V),G,J),void 0,J)}registerSelectionRangeProvider(T,V,G){const J=this.t(new ce(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(J,this.o(V,T)),this.p(J)}$provideSelectionRanges(T,V,G,J){return this.s(T,ce,q=>q.provideSelectionRanges(E.URI.revive(V),G,J),[],J)}registerCallHierarchyProvider(T,V,G){const J=this.t(new we(this.h,G),T);return this.e.$registerCallHierarchyProvider(J,this.o(V,T)),this.p(J)}$prepareCallHierarchy(T,V,G,J){return this.s(T,we,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideCallHierarchyIncomingCalls(T,V,G,J){return this.s(T,we,q=>q.provideCallsTo(V,G,J),void 0,J)}$provideCallHierarchyOutgoingCalls(T,V,G,J){return this.s(T,we,q=>q.provideCallsFrom(V,G,J),void 0,J)}$releaseCallHierarchy(T,V){this.s(T,we,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(T,V,G){const J=this.t(new _(this.h,G),T);return this.e.$registerTypeHierarchyProvider(J,this.o(V,T)),this.p(J)}$prepareTypeHierarchy(T,V,G,J){return this.s(T,_,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,J)),void 0,J)}$provideTypeHierarchySupertypes(T,V,G,J){return this.s(T,_,q=>q.provideSupertypes(V,G,J),void 0,J)}$provideTypeHierarchySubtypes(T,V,G,J){return this.s(T,_,q=>q.provideSubtypes(V,G,J),void 0,J)}$releaseTypeHierarchy(T,V){this.s(T,_,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(T,V,G,J){const q=this.q();this.f.set(q,new ae(new he(this.e,this.h,G,q,T),T));const x=(0,n.$MF)(T,"dropMetadata")&&J?he.toInternalProviderId(T.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,T),x,(0,n.$MF)(T,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(T,V,G,J,q,x){return this.s(T,he,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(V,E.URI.revive(G),J,q,x)),void 0,void 0)}registerMappedEditsProvider(T,V,G){const J=this.t(new te(this.h,G),T);return this.e.$registerMappedEditsProvider(J,this.o(V,T)),this.p(J)}$provideMappedEdits(T,V,G,J,q){return this.s(T,te,x=>Promise.resolve(x.provideMappedEdits(V,G,J,q)),null,q)}registerDocumentPasteEditProvider(T,V,G,J){const q=this.q();this.f.set(q,new ae(new F(this.e,this.h,G,q,T),T));const x=F.toInternalProviderId(T.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(V,T),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(T,V,G,J,q){return this.s(T,F,x=>x.prepareDocumentPaste(E.URI.revive(V),G,J,q),void 0,q)}$providePasteEdits(T,V,G,J,q,x){return this.s(T,F,ue=>ue.providePasteEdits(V,E.URI.revive(G),J,q,x),void 0,x)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:ge.w(T.decreaseIndentPattern),increaseIndentPattern:ge.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?ge.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?ge.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:ge.w(T.beforeText),afterText:T.afterText?ge.w(T.afterText):void 0,previousLineText:T.previousLineText?ge.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(ge.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(T){return T.map(ge.C)}setLanguageConfiguration(T,V,G){const{wordPattern:J}=G;if(J&&(0,D.$Se)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const q=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ge.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ge.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ge.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?ge.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,x),this.p(q)}$setWordDefinitions(T){for(const V of T)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Kdc=ge}),define(Pe[255],Ae([1,0,3,8,7,31,14,6,23]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;class f{constructor(k,u,b,p){this.c=u,this.d=b,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(E.$yK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,u){await this.a.$changeLanguage(k,u);const b=this.c.getDocumentData(k);if(!b)throw new Error(`document '${k.toString()}' NOT found`);return b.document}async tokenAtPosition(k,u){const b=k.version,p=L.Position.from(u),g=await this.a.$tokensAtPosition(k.uri,p),t={type:A.StandardTokenType.Other,range:k.getWordRangeAtPosition(u)??new A.$CK(u.line,u.character,u.line,u.character)};if(!g)return t;const i={range:L.Range.to(g.range),type:L.TokenType.to(g.type)};return!i.range.contains(u)||b!==k.version?t:i}createLanguageStatusItem(k,u,b){const p=this.f++,g=this.a,t=this.g,i=`${k.identifier.value}/${u}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);t.add(i);const r={selector:b,id:u,name:k.displayName??k.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const o=new $.$Qc,l=()=>{if(c?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${u}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,R.$Zg)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:i,name:r.name??k.displayName??k.name,source:k.displayName??k.name,selector:L.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===A.LanguageStatusSeverity.Error?M.default.Error:r.severity===A.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,o),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){o.dispose(),c?.dispose(),g.$removeLanguageStatus(p),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,l()},get selector(){return r.selector},set selector(s){r.selector=s,l()},get text(){return r.text},set text(s){r.text=s,l()},set text2(s){(0,D.$NF)(k,"languageStatusText"),r.text=s,l()},get text2(){return(0,D.$NF)(k,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,l()},get severity(){return r.severity},set severity(s){r.severity=s,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,l()},get command(){return r.command},set command(s){r.command=s,l()},get busy(){return r.busy},set busy(s){r.busy=s,l()}};return l(),n}}e.$0ec=f}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;let P=class{constructor(u,b,p){this.f=p,this.d=new Map,this.a=b.getProxy($.$yK.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===E.$g}getMessage(u,b){const{message:p,args:g,comment:t}=b;if(this.c)return(0,L.$He)(p,g??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(u)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$He)(r??p,g??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(p),t=JSON.parse(g);b=u.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${g.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:p})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(b)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$vec=P,e.$vec=P=Ke([We(0,D.$QM),We(1,f.$AM),We(2,R.$dj)],P),e.$wec=(0,M.$Vh)("IExtHostLocalizationService")}),define(Pe[256],Ae([1,0,15,3,27,17,2,51]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let D=class extends E.$oj{constructor(k,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,$.$sh)(b))),this.r=k.getProxy(L.$yK.MainThreadLogger)}$setLogLevel(k,u){u?this.setLogLevel(R.URI.revive(u),k):this.setLogLevel(k)}setVisibility(k,u){super.setVisibility(k,u),this.r.$setVisibility(k,u)}s(k,u,b){return new f(this.r,k,u,b)}};e.$Ifc=D,e.$Ifc=D=Ke([We(0,M.$AM),We(1,A.$QM)],D);class f extends E.$jj{constructor(k,u,b,p){super(p?.logLevel==="always"),this.r=k,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(k,u){const b=[[k,u]];this.m?this.u(b):this.n.push(...b)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=void 0,e.$xec=(0,L.$Vh)("IExtHostManagedSockets");let $=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(E.$yK.MainThreadManagedSockets)}setFactory(k,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(k,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const u=++this.b,b=await this.c.makeConnection(),p=new A.$Qc;return this.d.set(u,new f(u,b,p)),p.add((0,A.$Pc)(()=>this.d.delete(u))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(u,g?.stack??g?.message),p.dispose()})),p.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(u,R.$fe.wrap(g)))),u}$remoteSocketWrite(k,u){this.d.get(k)?.actual.send(u.buffer)}$remoteSocketEnd(k){const u=this.d.get(k);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$yec=$,e.$yec=$=Ke([We(0,M.$AM)],$);class D{constructor(k,u){this.socketFactoryId=k,this.makeConnection=u}}class f extends A.$Rc{constructor(k,u,b){super(),this.socketId=k,this.actual=u,this.B(b)}}}),define(Pe[257],Ae([1,0,3,15,23]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;function M($){return $&&$.title}let R=class{constructor(D,f){this.b=f,this.a=D.getProxy(E.$yK.MainThreadMessageService)}showMessage(D,f,P,k,u){const b={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof k=="string"||M(k)?p=[k,...u]:(b.modal=k?.modal,b.useCustom=k?.useCustom,b.detail=k?.detail,p=u),b.useCustom&&(0,A.$NF)(D,"resolvers");const g=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:c}=i;g.push({title:r,isCloseAffordance:!!c,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,b,g).then(t=>{if(typeof t=="number")return p[t]})}};e.$$ec=R,e.$$ec=R=Ke([We(1,L.$dj)],R)}),define(Pe[258],Ae([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;let c=class{constructor(m,I,S,h,w){this.l=I,this.m=S,this.n=h,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(k.$yK.MainThreadNotebookKernels);const y=new u.$1M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$YM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const W=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:W}}else if(C&&"notebookEditor"in C){const W=this.m.getIdByEditor(C.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return C})],u.$ZM.Void);this.n.registerApiCommand(y)}createNotebookController(m,I,S,h,w,y){for(const pe of this.i.values())if(pe.controller.id===I&&f.$_l.equals(m.identifier,pe.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,W=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${m.identifier}'`);let U=!1;const z=new M.$Rd,F=new M.$Rd,O={id:d(m.identifier,I),notebookType:S,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:h||m.identifier.value,preloads:y?y.map(b.NotebookRendererScript.from):[]};let X=w??K,$e;this.a.$addKernel(C,O).catch(pe=>{console.log(pe),U=!0});let Ee=0;const De=()=>{if(U)return;const pe=++Ee;Promise.resolve().then(()=>{pe===Ee&&this.a.$updateKernel(C,O)})},Ce=new $.$zc,de={get id(){return I},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return O.label},set label(pe){O.label=pe??m.displayName??m.name,De()},get detail(){return O.detail??""},set detail(pe){O.detail=pe,De()},get description(){return O.description??""},set description(pe){O.description=pe,De()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(pe){O.supportedLanguages=pe,De()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){O.supportsExecutionOrder=pe,De()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(pe){X=pe??K},get interruptHandler(){return $e},set interruptHandler(pe){$e=pe,O.supportsInterrupt=!!pe,De()},createNotebookCellExecution(pe){if(U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(pe.notebook.uri))throw W.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return W._createNotebookCellExecution(pe,d(m.identifier,this.id))},createNotebookExecution(pe){if((0,i.$NF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(pe.uri))throw W.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return W._createNotebookExecution(pe,d(m.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${C}], DISPOSED`),U=!0,this.i.delete(C),z.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(pe,re){re===p.NotebookControllerAffinity2.Hidden&&(0,i.$NF)(m,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(C,pe.uri,re)},onDidReceiveMessage:F.event,postMessage(pe,re){return(0,i.$NF)(m,"notebookMessaging"),W.a.$postMessage(C,re&&W.m.getIdByEditor(re),pe)},asWebviewUri(pe){return(0,i.$NF)(m,"notebookMessaging"),(0,g.$$tb)(pe,W.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:de,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:Ce}),de}getIdByController(m){for(const[I,S]of this.i)if(S.controller===m)return d(S.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const S=this.f++,h=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const w={dispose:()=>{this.e.delete(S),h.a.$removeKernelDetectionTask(S)}};return this.e.set(S,w),w}registerKernelSourceActionProvider(m,I,S){const h=this.h++,w=typeof S.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,y=this;this.g.set(h,S),this.o.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,I);let C;return w!==void 0&&(C=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),y.a.$removeKernelSourceActionProvider(h,h),C?.dispose()}}}async $provideKernelSourceActions(m,I){const S=this.g.get(m);if(S){const h=new R.$Qc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(y=>b.NotebookKernelSourceAction.from(y,this.n.converter,h))}return[]}$acceptNotebookAssociation(m,I,S){const h=this.i.get(m);if(h){const w=this.m.getNotebookDocument(D.URI.revive(I));S?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),S),h.onDidChangeSelection.fire({selected:S,notebook:w.apiNotebook})}}async $executeCells(m,I,S){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(D.URI.revive(I)),y=[];for(const C of S){const W=w.getCell(C);W&&y.push(W.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),y.length),await h.controller.executeHandler.call(h.controller,y,w.apiNotebook,h.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,S){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(D.URI.revive(I));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const y of S){const C=w.getCell(y);C&&this.b.get(C.uri)?.cancel()}if(h.controller.interruptHandler){const y=this.c.get(w.uri);S.length&&Array.isArray(y)&&y.length&&y.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,S){const h=this.i.get(m);if(!h)return;const w=this.m.getEditorById(I);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:S}))}$cellExecutionChanged(m,I,S){const w=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(w){const y=S?b.NotebookCellExecutionState.to(S):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:w.apiCell,state:y})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new l(I,h,this.a);this.b.set(h.uri,w);const y=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),y.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(m,I){const S=this.m.getNotebookDocument(m.uri),h=m.getCells().find(C=>{const W=S.getCellFromApiCell(C);return W&&this.b.has(W.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const w=new s(I,S,this.a),y=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),y.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[w,y]),w.asApiObject()}};e.$cfc=c,e.$cfc=c=Ke([We(4,P.$dj)],c);var o;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(o||(o={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,S){super(),this.m=I,this.n=S,this.b=l.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new A.$2d),this.h=new a(10,h=>this.s(h)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$xv(I))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const S=p.$2L.ensureUniqueMimeTypes(I.items,!0);return S===I.items?b.NotebookCellOutput.from(I):b.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(m,I,S){const h=this.w(I),w=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:S,outputs:w})}async C(m,I,S){return m=p.$2L.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(S){m.j=S,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(S){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,h){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$xv({runEndTime:h,lastRunSuccess:S}))},clearOutput(S){return m.t(),m.z([],S,!1)},appendOutput(S,h){return m.t(),m.z(S,h,!0)},replaceOutput(S,h){return m.t(),m.z(S,h,!1)},appendOutputItems(S,h){return m.t(),m.C(S,h,!0)},replaceOutputItems(S,h){return m.t(),m.C(S,h,!1)}})}}var n;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(n||(n={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,S){super(),this.h=I,this.j=S,this.b=s.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new A.$2d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$ih,this.b=Date.now(),(0,L.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function d(v,m){return`${v.value}/${m}`}e.$dfc=d}),define(Pe[259],Ae([1,0,5,3,107]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$yK.MainThreadNotebookRenderers)}$postRendererMessage($,D,f){const P=this.c.getEditorById($);this.a.get(D)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(P=>P.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(P,k,u)=>this.d(D).event(P,k,u),postMessage:(P,k)=>{A.$Wec.apiEditorsToExtHost.has(P)&&([P,k]=[k,P]);const u=k&&A.$Wec.apiEditorsToExtHost.get(k);return this.b.$postMessage(u?.id,D,P)}}}d($){let D=this.a.get($);return D||(D=new E.$Rd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$efc=M}),define(Pe[260],Ae([1,0,6,16,2,23,3]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class ${constructor(f){this.b=new Map,this.a=f.getProxy(R.$yK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,k){if((0,M.$NF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,k),this.a.$registerProfileContentHandler(P,k.name,k.description,f.identifier.value),(0,E.$Pc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,k,u){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(P,k,u)}async $readProfile(f,P,k){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,L.$Cf)(P)?P:A.URI.revive(P),k)}}e.$hfc=$}),define(Pe[261],Ae([1,0,2,3,14,8]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class R{static{this.a=0}constructor(D,f){this.d=f,this.c=new Map,this.b=D.getProxy(L.$yK.MainThreadQuickDiff)}$provideOriginalResource(D,f,P){const k=E.URI.revive(f),u=this.c.get(D);return u?(0,A.$Qg)(()=>u.provideOriginalResource(k,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(D,f,P,k){const u=R.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(D,this.d),P,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$jfc=R}),define(Pe[262],Ae([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;function p(g,t,i){const r=g.getProxy(M.$yK.MainThreadQuickOpen);class c{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,h,w=E.CancellationToken.None){this.c=void 0;const y=Promise.resolve(S),C=++this.f,W=r.$show(C,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),K={},U=W.then(()=>K);return Promise.race([U,y]).then(z=>{if(z===K)return;const F=(0,u.$MF)(I,"quickPickItemTooltip");return y.then(O=>{const X=[];for(let $e=0;$e<O.length;$e++){const Ee=O[$e];if(typeof Ee=="string")X.push({label:Ee,handle:$e});else if(Ee.kind===$.QuickPickItemKind.Separator)X.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const De=Ee.iconPath?a(Ee.iconPath):void 0;X.push({label:Ee.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:F?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:$e})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=$e=>{h.onDidSelectItem(O[$e])}),r.$setItems(C,X),W.then($e=>{if(typeof $e=="number")return O[$e];if(Array.isArray($e))return $e.map(Ee=>O[Ee])})})}).then(void 0,z=>{if(!(0,D.$3)(z))return r.$setError(C,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=E.CancellationToken.None){return this.d=I?.validateInput,r.$input(I,typeof this.d=="function",S).then(void 0,h=>{if(!(0,D.$3)(h))return Promise.reject(h)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let h;switch(S.severity){case $.InputBoxValidationSeverity.Info:h=P.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=P.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=P.default.Error;break;default:h=S.message?P.default.Error:P.default.Ignore;break}return{content:S.message,severity:h}}async showWorkspaceFolderPick(I,S=E.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(y=>y.uri.toString()===h.uri.toString())}createQuickPick(I){const S=new d(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new v(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const h=this.e.get(I);h instanceof d&&h._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const h=this.e.get(I);h instanceof d&&h._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,h){const w=this.e.get(I);w instanceof d&&w._fireDidTriggerItemButton(S,h)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class o{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Rd,this.q=new L.$Rd,this.r=new L.$Rd,this.s=new L.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,h)=>{const w=S===$.$UL.Back?-1:h;this.o.set(w,S)}),this.z({buttons:I.map((S,h)=>({...a(S.iconPath),tooltip:S.tooltip,handle:S===$.$UL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const h=I[S];this.u[S]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$uL)return{id:m.id};const I=s(m),S=n(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof S=="string"?R.URI.file(S):S}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function a(m){const I=l(m);let S,h;return"id"in I?h=k.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:h}}class d extends o{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Rd,this.L=[],this.M=new L.$Rd,this.N=new L.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((w,y)=>{this.C.set(y,w),this.D.set(w,y)});const S=(0,u.$MF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<I.length;w++){const y=I[w];if(y.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:y.label});else{y.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?a(y.iconPath):void 0;h.push({handle:w,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:S?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((W,K)=>({...a(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,f.$Gb)(I.map(h=>this.C.get(h)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,f.$Gb)(I.map(h=>this.C.get(h)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const h=this.C.get(I);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[S];w&&this.N.fire({button:w,item:h})}}class v extends o{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new c(t,i)}e.$kfc=p}),define(Pe[263],Ae([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=void 0;function i(y){if(y)return typeof y.iconPath=="string"?E.URI.file(y.iconPath):E.URI.isUri(y.iconPath)||u.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function r(y){if(y?.icon){if(E.URI.isUri(y.icon))return y.icon;if(u.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function c(y){if(y.icon){if(E.URI.isUri(y.icon))return y.icon;if(u.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function o(y,C){if(!y.iconPath&&!C.iconPath)return 0;if(y.iconPath){if(!C.iconPath)return 1}else return-1;const W=typeof y.iconPath=="string"?y.iconPath:E.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,K=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,f.$xq)(W,K)}function l(y,C){let W=0;if(y.strikeThrough!==C.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==C.faded)return y.faded?1:-1;if(y.tooltip!==C.tooltip)return(y.tooltip||"").localeCompare(C.tooltip||"");if(W=o(y,C),W!==0)return W;if(y.light&&C.light)W=o(y.light,C.light);else{if(y.light)return 1;if(C.light)return-1}if(W!==0)return W;if(y.dark&&C.dark)W=o(y.dark,C.dark);else{if(y.dark)return 1;if(C.dark)return-1}return W}function n(y,C){if(y.command!==C.command)return y.command<C.command?-1:1;if(y.title!==C.title)return y.title<C.title?-1:1;if(y.tooltip!==C.tooltip){if(y.tooltip!==void 0&&C.tooltip!==void 0)return y.tooltip<C.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(y.arguments===C.arguments)return 0;if(y.arguments)if(C.arguments){if(y.arguments.length!==C.arguments.length)return y.arguments.length-C.arguments.length}else return 1;else return-1;for(let W=0;W<y.arguments.length;W++){const K=y.arguments[W],U=C.arguments[W];if(K!==U)return K<U?-1:1}return 0}function s(y,C){let W=(0,f.$xq)(y.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(W!==0)return W;if(y.command&&C.command)W=n(y.command,C.command);else{if(y.command)return 1;if(C.command)return-1}if(W!==0)return W;if(y.decorations&&C.decorations)W=l(y.decorations,C.decorations);else{if(y.decorations)return 1;if(C.decorations)return-1}return W}function a(y,C){for(let W=0;W<y.length;W++)if(y[W]!==C[W])return!1;return!0}function d(y,C){return y.command===C.command&&y.title===C.title&&y.tooltip===C.tooltip&&(y.arguments&&C.arguments?a(y.arguments,C.arguments):y.arguments===C.arguments)}function v(y,C){return(0,D.$tb)(y,C,d)}function m(y,C){return y===C?!0:!y||!C?!1:y.id===C.id&&y.label===C.label&&y.upstream?.id===C.upstream?.id&&y.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,p.$NF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,p.$NF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,p.$NF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,p.$NF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const W=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:r(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,W??null)}get document(){return(0,p.$NF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,W,K,U,z,F){this.m=C,this.n=W,this.o=z,this.p=F,this.d="",this.e=new L.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=K,this.#e=U}showValidationMessage(C,W){(0,p.$NF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,W)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$lfc=I;class S{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,W,K,U,z){this.q=C,this.s=W,this.t=K,this.u=U,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=S.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,W){const K=this.h.get(C);return K?(0,R.$Qg)(()=>this.s.executeCommand(K.command,...K.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),K=(0,D.$Cb)(this.o,C,s).map(F=>{const O=F.toInsert.map(X=>{const $e=this.e++;this.g.set($e,X);const Ee=X.resourceUri;let De;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"||X.command.command==="vscode.changes"){const me=new M.$Qc;De=this.s.converter.toInternal(X.command,me),this.j.set($e,me)}else this.h.set($e,X.command);const Ce=i(X.decorations),de=X.decorations&&i(X.decorations.light)||Ce,pe=X.decorations&&i(X.decorations.dark)||Ce,re=[de,pe],Re=X.decorations&&X.decorations.tooltip||"",se=X.decorations&&!!X.decorations.strikeThrough,Y=X.decorations&&!!X.decorations.faded,B=X.contextValue||"";return{rawResource:[$e,Ee,re,Re,se,Y,B,De],handle:$e}});return{start:F.start,deleteCount:F.deleteCount,toInsert:O}}),U=K.map(({start:F,deleteCount:O,toInsert:X})=>[F,O,X.map($e=>$e.rawResource)]),z=K.reverse();for(const{start:F,deleteCount:O,toInsert:X}of z){const $e=X.map(De=>De.handle),Ee=this.n.splice(F,O,...$e);for(const De of Ee)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=C,U}dispose(){this.l=!0,this.m.fire()}}class h{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let W;(0,p.$MF)(this.y,"quickDiffProvider")&&(W=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:W})}get historyProvider(){return(0,p.$NF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,p.$NF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,p.$NF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const W=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,W??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const W=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,p.$NF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,p.$NF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const W=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(K=>K.map(U=>this.z.converter.toInternal(U,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&v(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const W=(C||[]).map(K=>this.z.converter.toInternal(K,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(C,W,K,U,z,F,O){this.y=C,this.z=U,this.A=z,this.B=F,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Rd,this.onDidChangeSelection=this.w.event,this.x=h.d++,this.D=new Map,this.E=new Set,this.#e=K;const X=E.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new I(C,U,W,this.#e,this.x,X),this.#e.$registerSourceControl(this.x,z,F,O,X)}createResourceGroup(C,W){const K=new S(this.#e,this.z,this.x,C,W),U=L.Event.once(K.onDidDispose)(()=>this.D.delete(K));return this.D.set(K,U),this.eventuallyAddResourceGroups(),K}eventuallyAddResourceGroups(){const C=[],W=[];for(const[K,U]of this.D){U.dispose();const z=K.onDidUpdateResourceStates(()=>{this.E.add(K),this.eventuallyUpdateResourceStates()});L.Event.once(K.onDidDispose)(()=>{this.E.delete(K),z.dispose(),this.e.delete(K.handle),this.#e.$unregisterGroup(this.x,K.handle)}),C.push([K.handle,K.id,K.label,K.features]);const F=K._takeResourceStateSnapshot();F.length>0&&W.push([K.handle,F]),this.e.set(K.handle,K)}this.#e.$registerGroups(this.x,C,W),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(W=>{const K=W._takeResourceStateSnapshot();K.length!==0&&C.push([W.handle,K])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,A.$oh)(100)],h.prototype,"eventuallyAddResourceGroups",null),Ke([(0,A.$oh)(100)],h.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,W,K,U){this.l=W,this.m=K,this.n=U,this.g=new Map,this.h=new k.$bm,this.j=new L.$Rd,this.e=C.getProxy($.$yK.MainThreadSCM),this.f=C.getProxy($.$yK.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const F=this.g.get(z.sourceControlHandle);if(!F)return z;const O=F.getResourceGroup(z.groupHandle);return O?O.getResourceState(z.handle):z}else if(z&&z.$mid===4){const F=this.g.get(z.sourceControlHandle);return F?F.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const F=this.g.get(z.handle);return F||z}return z}})}createSourceControl(C,W,K,U){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,W,K,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const z=t.d++,F=new h(C,this.m,this.e,this.l,W,K,U);this.g.set(z,F);const O=this.h.get(C.identifier)||[];return O.push(F),this.h.set(C.identifier,O),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const W=this.h.get(C.identifier),K=W&&W[W.length-1];return K&&K.inputBox}$provideOriginalResource(C,W,K){const U=E.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",C,U.toString());const z=this.g.get(C);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Qg)(()=>z.quickDiffProvider.provideOriginalResource(U,K)).then(F=>F||null)}$onInputBoxValueChange(C,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const K=this.g.get(C);return K&&K.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(C,W,K,U){this.n.trace("ExtHostSCM#$executeResourceCommand",C,W,K);const z=this.g.get(C);if(!z)return Promise.resolve(void 0);const F=z.getResourceGroup(W);return F?F.$executeResourceCommand(K,U):Promise.resolve(void 0)}$validateInput(C,W,K){this.n.trace("ExtHostSCM#$validateInput",C);const U=this.g.get(C);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Qg)(()=>U.inputBox.validateInput(W,K)).then(z=>{if(!z)return Promise.resolve(void 0);const F=b.MarkdownString.fromStrict(z.message);return F?Promise.resolve([F,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,W,K){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(W,K)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,W,K,U){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,K,U)??void 0}async $provideHistoryItems(C,W,K,U){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(W,K,U))?.map(O=>({...O,icon:c(O)}))??void 0}async $provideHistoryItemChanges(C,W,K){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(W,K)??void 0}};e.$mfc=w,e.$mfc=w=t=Ke([We(3,P.$dj)],w)}),define(Pe[84],Ae([1,0,3,5,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=e.$sec=void 0;class M{constructor($){this.b=new L.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$yK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,f){return this.a.$setPassword($,D,f)}delete($,D){return this.a.$deletePassword($,D)}}e.$sec=M,e.$tec=(0,A.$Vh)("IExtHostSecretState")}),define(Pe[264],Ae([1,0,3,8,2]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$yK.MainThreadShare)}async $provideShare($,D,f){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:A.URI.revive(D.resourceUri)},f)??void 0}registerShareProvider($,D){const f=M.a++;return this.c.set(f,D),this.b.$registerShareProvider(f,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$nfc=M}),define(Pe[265],Ae([1,0,20,6,3]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(A.$yK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const f=this.c.get($);if(!f)return;const P=new L.$Qc,k=new E.$2d;this.d.set(D,k);const u=P.add(f.provideSpeechToTextSession(k.token));P.add(u.onDidChange(b=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,b)})),P.add(k.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,f){const P=M.a++;return this.c.set(P,f),this.b.$registerProvider(P,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(P),this.c.delete(P)})}}e.$ofc=M}),define(Pe[266],Ae([1,0,7,3,164,6,8,16]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=e.$pfc=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$vL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$vL("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,p,g,t,i=E.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=u,this.#t=b,t&&g){this.c=(0,E.$$K)(g.identifier,t);const c=p.get(this.c);c&&(i=c.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(D.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(r)}u(u){if((0,$.$Gf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!D.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,A.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const g=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,g,this.r?.internal,p,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$pfc=D;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new E.$AK(()=>{const p=this.b.indexOf(b);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,b){this.e=new Map,this.a=u.getProxy(L.$yK.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,p,g){return new D(this.a,this.b,this.e,u,b,p,g)}setStatusBarMessage(u,b){const p=this.c.setMessage(u);let g;return typeof b=="number"?g=setTimeout(()=>p.dispose(),b):typeof b<"u"&&b.then(()=>p.dispose(),()=>p.dispose()),new E.$AK(()=>{p.dispose(),clearTimeout(g)})}}e.$qfc=P}),define(Pe[85],Ae([1,0,3,5,4]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=e.$kec=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$yK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,f){const P=await this.a.$initializeExtensionStorage($,D);let k;return P&&(k=this.d($,D,P)),k||f}setValue($,D,f){return this.a.$setValue($,D,f)}$acceptValue($,D,f){const P=this.d($,D,f);P&&this.b.fire({shared:$,key:D,value:P})}d($,D,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${P}`)}}}e.$kec=M,e.$lec=(0,A.$Vh)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0,e.$6dc=(0,E.$Vh)("IExtensionStoragePaths");let $=class{constructor(f,P,k){this.d=P,this.f=k,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return R.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(R.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(f){if(this.c)return R.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return R.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7dc=$,e.$7dc=$=Ke([We(0,L.$QM),We(1,A.$dj),We(2,M.$5dc)],$)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,20,38,195,45,14,8,32]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=e.$pec=e.$oec=void 0,e.$oec=(0,A.$Vh)("IExtHostTerminalService");class c{constructor(h,w,y,C){this.l=h,this._id=w,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,U=!0){W.q(),W.l.$sendText(W._id,K,U)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??w?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:g.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,y,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:g.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$pec=c;class o{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new E.$Rd,this.onProcessData=this.a.event,this.b=new E.$Rd,this.d=new E.$Rd,this.onDidChangeProperty=this.d.event,this.f=new E.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,y){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Rd,this.onDidChangeShell=this.N.event,this.O=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$yK.MainThreadTerminalService),this.y=new p.$nqb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:C=>{const W=K=>{const U=K;return this.W(U.instanceId)?.value};switch(C?.$mid){case 15:return W(C);default:{if(Array.isArray(C))for(let K=0;K<C.length&&C[K].$mid===15;K++)C[K]=W(C[K]);return C}}}}),this.B({dispose:()=>{for(const[C,W]of this.g)W.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const y=new c(this.a,(0,b.$ig)(),h,h.name),C=new o(h.pty);return y.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,v(h.iconPath),m(h.color)).then(W=>{const K=this.S(W,C);this.h[W]=K}),this.f.push(y),y.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const y=h.location.parentTerminal;if(y){const C=this.f.find(W=>W.value===y);C&&(w.resolvedExtHostIdentifier=C._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const C=new o(w),W=this.S(h,C);this.h[h]=W}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const y=this.W(h);y&&(this.b=y,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const y=this.W(h);y&&this.O.fire({terminal:y.value,data:w})}async $acceptTerminalDimensions(h,w,y){const C=this.W(h);C&&C.setDimensions(w,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(h,w){const y=this.W(h);y&&this.P.fire({terminal:y.value,...w})}async $acceptTerminalMaximumDimensions(h,w,y){this.g.get(h)?.resize(w,y)}async $acceptTerminalTitleChange(h,w){const y=this.W(h);y&&(y.name=w)}async $acceptTerminalClosed(h,w,y){const C=this.Y(this.f,h);if(C!==null){const W=this.f.splice(C,1)[0];W.setExitStatus(w,y),this.H.fire(W.value)}}$acceptTerminalOpened(h,w,y,C){if(w){const U=this.Y(this.f,w);if(U!==null){this.f[U]._id=h,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},K=new c(this.a,h,W,y);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const y=this.W(h);if(!y)return{message:(0,f.localize)(0,null,h)};y.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async U=>{U===y.value&&(K.dispose(),W())})});const C=this.g.get(h);C?C.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const y=new $.$Qc;y.add(w.onProcessReady(W=>this.a.$sendProcessReady(h,W.pid,W.cwd,W.windowsPty))),y.add(w.onDidChangeProperty(W=>this.a.$sendProcessProperty(h,W))),this.y.startBuffering(h,w.onProcessData),y.add(w.onProcessExit(W=>this.U(h,W))),this.g.set(h,w);const C=this.j[h];return C&&w instanceof o&&(w.startSendingEvents(C.initialDimensions),delete this.j[h]),y}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,y){try{this.g.get(h)?.resize(w,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new D.$AK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,y){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,y),this.a.$registerProfileProvider(w,h.identifier.value),new D.$AK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,y){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,y),this.a.$registerQuickFixProvider(h,w),new D.$AK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const y=new u.$2d().token;if(y.isCancellationRequested)return;const C=this.D.get(h);if(!C)return;const W=await C.provideTerminalQuickFixes(w,y);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new $.$Qc;if(this.w.value=K,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const U=[];for(const z of W){const F=i.TerminalQuickFix.from(z,this.Q.converter,K);F&&U.push(F)}return U}async $createContributedProfileTerminal(h,w){const y=new u.$2d().token;let C=await this.C.get(h)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,w);return}this.createTerminalFromOptions(C.options,w)}}async $provideLinks(h,w){const y=this.W(h);if(!y)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const W=new u.$2d;this.G.set(h,W);const K=[],U={terminal:y.value,line:w},z=[];for(const X of this.z)z.push(t.Promises.withAsyncBody(async $e=>{W.token.onCancellationRequested(()=>$e({provider:X,links:[]}));const Ee=await X.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||$e({provider:X,links:Ee})}));const F=await Promise.all(z);if(W.token.isCancellationRequested)return[];const O=new Map;for(const X of F)X&&X.links.length>0&&K.push(...X.links.map($e=>{const Ee={id:l++,startIndex:$e.startIndex,length:$e.length,label:$e.tooltip};return O.set(Ee.id,{provider:X.provider,link:$e}),Ee}));return this.F.set(h,O),K}$activateLink(h,w){const y=this.F.get(h)?.get(w);y&&y.provider.handleTerminalLink(y.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const y=this.h[h];y&&(y.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const y=this.Y(h,w);return y!==null?h[y]:null}Y(h,w){const y=h.findIndex(C=>C._id===w);return y===-1?null:y}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new s,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const y=(0,k.$rr)(w.map),C=(0,k.$sr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const y=w[0],C=new s(w[1]);this.$(y,C)})}$acceptDefaultProfile(h,w){const y=this.s;this.s=h,this.u=w,y?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$qec=n,e.$qec=n=Ke([We(1,r.$WM),We(2,R.$AM)],n);class s{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let y=this.a.get(w);return y||(y=new a(this,h),this.a.set(w,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(h,w,y,C){this.f(h,{value:w,type:D.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(h,w,y,C){this.f(h,{value:w,type:D.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(h,w,y,C){this.f(h,{value:w,type:D.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(h,w.scope),C=this.map.get(y),W=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==w.value||C.type!==w.type||C.options?.applyAtProcessCreation!==W.applyAtProcessCreation||C.options?.applyAtShellIntegration!==W.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const K=this.g(h,w.scope),U={variable:h,...w,options:W};this.map.set(K,U),this.d.fire()}}get(h,w){const y=this.g(h,w),C=this.map.get(y);return C?I(C):void 0}g(h,w){const y=this.h(w);return y.length?`${h}:::${y}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(h)&&w.set(C.variable,I(C));return w}delete(h,w){const y=this.g(h,w);this.map.delete(y),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,y]of this.map)y.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const y=this.h(w),C=this.descriptionMap.get(y);if(!C||C.description!==h){let W;typeof h=="string"?W=h:W=h?.value.split(`

`)[0];const K={description:W,scope:w};this.descriptionMap.set(y,K),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new E.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,y){this.b.replace(h,w,y,this.d)}append(h,w,y){this.b.append(h,w,y,this.d)}prepend(h,w,y){this.b.prepend(h,w,y,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((y,C)=>h.call(w,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends n{constructor(h,w){super(!1,h,w)}createTerminal(h,w,y){throw new P.$$}createTerminalFromOptions(h,w){throw new P.$$}};e.$rec=d,e.$rec=d=Ke([We(0,r.$WM),We(1,R.$AM)],d);function v(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function m(S){return g.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const h={...S};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[267],Ae([1,0,298,14,24,20,5,219,97,6,26,16,38,3,17,108,8,7,48,77,58,23]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=e.$vfc=e.$ufc=void 0;let n=class extends f.$Rc{constructor(U,z,F){super(),this.u=F,this.f=this.B(new R.$Rd),this.g=new Map,this.s=this.B(new R.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(b.$yK.MainThreadTesting),this.m=new y(this.h),this.j=new v(this.h),z.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const X=O,$e=X.tests[X.tests.length-1].item.extId;return this.g.get(r.$rJ.root($e))?.collection.tree.get($e)?.actual??(0,g.$MM)(O)}case 18:{const{extId:X,message:$e}=O;return{test:this.g.get(r.$rJ.root(X))?.collection.tree.get(X)?.actual,message:t.TestMessage.to($e)}}default:return O}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await z.executeCommand("_testing.getExplorerSelection"),X=$e=>{const Ee=this.g.get(r.$rJ.root($e));if(Ee)return r.$rJ.isRoot($e)?Ee.controller:Ee.collection.tree.get($e)?.actual};return{include:O?.include.map(X).filter(k.$Kf)||[],exclude:O?.exclude.map(X).filter(k.$Kf)||[]}})}createTestController(U,z,F,O){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const X=new f.$Qc,$e=X.add(new g.$PM(z,F,this.u));$e.root.label=F;const Ee=new Map,De=new Set,Ce=this.h,de={items:$e.root.children,get label(){return F},set label(re){F=re,$e.root.label=re,Ce.$updateController(z,{label:F})},get refreshHandler(){return O},set refreshHandler(re){O=re,Ce.$updateController(z,{canRefresh:!!re})},get id(){return z},createRunProfile:(re,Re,se,Y,B,ie)=>{let me=(0,D.$Ji)(re);for(;Ee.has(me);)me++;return new C(this.h,Ee,U,De,this.s.event,z,me,re,Re,se,Y,B,ie)},createTestItem(re,Re,se){return new g.$NM(z,re,Re,se)},createTestRun:(re,Re,se=!0)=>this.j.createTestRun(U,z,$e,re,Re,se),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const Re=re instanceof Array?re:[re];this.h.$markTestRetired(Re.map(se=>r.$rJ.fromExtHostTestItem(se,z).toString()))}},set resolveHandler(re){$e.resolveHandler=re},get resolveHandler(){return $e.resolveHandler},dispose:()=>{X.dispose()}};Ce.$registerTestController(z,F,!!O),X.add((0,f.$Pc)(()=>Ce.$unregisterTestController(z)));const pe={controller:de,collection:$e,profiles:Ee,extension:U,activeProfiles:De};return this.g.set(z,pe),X.add((0,f.$Pc)(()=>this.g.delete(z))),X.add($e.onDidGenerateDiff(re=>Ce.$publishDiff(z,re.map(o.TestsDiffOp.serialize)))),de}createTestObserver(){return this.m.checkout()}async runTests(U,z=M.CancellationToken.None){const F=m(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(F.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(X=>r.$rJ.fromExtHostTestItem(X,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:W[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(X=>X.id)},z)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,F){return(0,E.$qb)(this.j.trackers,X=>X.id===U?X.getCoverage(z):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,z,F,O){return(0,E.$qb)(this.j.trackers,$e=>$e.id===U?$e.getCoverage(z):void 0)?.resolveFileCoverage(F,O)??Promise.resolve([])}$configureRunProfile(U,z){this.g.get(U)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(U){const z=new Map;for(const[F,O]of Object.entries(U)){const X=this.g.get(F);if(!X)continue;const $e=new Map,Ee=O.filter(Ce=>!X.activeProfiles.has(Ce)),De=[...X.activeProfiles].filter(Ce=>!O.includes(Ce));for(const Ce of Ee)$e.set(Ce,!0),X.activeProfiles.add(Ce);for(const Ce of De)$e.set(Ce,!1),X.activeProfiles.delete(Ce);$e.size&&z.set(F,$e)}this.s.fire(z)}async $refreshTests(U,z){await this.g.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,P.$bn)(t.TestResults.to(z))).concat(this.results).sort((z,F)=>F.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,z){const F=this.g.get(r.$rJ.fromString(U).controllerId)?.collection;F&&(await F.expand(U,z<0?1/0:z),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(o.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(F=>this.w(F,!1,z)))}async $startContinuousRun(U,z){const F=new M.$2d(z),O=await Promise.all(U.map(X=>this.w(X,!0,F.token)));return!z.isCancellationRequested&&!O.some(X=>X.error)&&await new Promise(X=>z.onCancellationRequested(X)),F.dispose(!0),O}async w(U,z,F){const O=this.g.get(U.controllerId);if(!O)return{};const{collection:X,profiles:$e,extension:Ee}=O,De=$e.get(U.profileId);if(!De)return{};const Ce=U.testIds.map(Re=>X.tree.get(Re)).filter(k.$Kf),de=U.excludeExtIds.map(Re=>O.collection.tree.get(Re)).filter(k.$Kf).filter(Re=>Ce.some(se=>se.fullId.compare(Re.fullId)===2));if(!Ce.length)return{};const pe=new i.$9L(Ce.some(Re=>Re.actual instanceof g.$OM)?void 0:Ce.map(Re=>Re.actual),de.map(Re=>Re.actual),De,z),re=(0,o.$tJ)(U)&&this.j.prepareForMainThreadTestRun(pe,I.fromInternal(U,O.collection),Ee,F);try{return await De.runHandler(pe,F),{}}catch(Re){return{error:String(Re)}}finally{re&&(re.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(re.onEnd),re.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$ufc=n,e.$ufc=n=Ke([We(0,p.$AM)],n);const s=1e4;var a;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(a||(a={}));class d extends f.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(U,z,F){super(),this.m=U,this.s=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(F));const O=this.B(new L.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const z=this.m.id,F=this.m.controllerId,O=(0,u.$ig)(),X=new S(this.s,z,O),$e=de=>(pe,...re)=>{if(De){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(pe)&&(this.y(pe),de(pe,...re))},Ee=(de,pe)=>{const re=pe instanceof Array?pe.map(t.TestMessage.from):[t.TestMessage.from(pe)];if(de.uri&&de.range){const Re={range:t.Range.from(de.range),uri:de.uri};for(const se of re)se.location=se.location||Re}this.s.$appendTestMessagesInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),re)};let De=!1;const Ce={isPersisted:this.m.isPersisted,token:this.h.token,name:U,get coverageProvider(){return X.coverageProvider},set coverageProvider(de){X.coverageProvider=de},enqueued:$e(de=>{this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),1)}),skipped:$e(de=>{this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),5)}),started:$e(de=>{this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),2)}),errored:$e((de,pe,re)=>{Ee(de,pe),this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),6,re)}),failed:$e((de,pe,re)=>{Ee(de,pe),this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,F).toString(),4,re)}),passed:$e((de,pe)=>{this.s.$updateTestStateInRun(z,O,r.$rJ.fromExtHostTestItem(de,this.m.controllerId).toString(),3,pe)}),appendOutput:(de,pe,re)=>{De||(re&&(this.m.isIncluded(re)?this.y(re):re=void 0),this.s.$appendOutputToRun(z,O,A.$fe.fromString(de),pe&&t.location.from(pe),re&&r.$rJ.fromExtHostTestItem(re,F).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(z,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:Ce,coverage:X}),this.s.$startedTestRunTask(z,{id:O,name:U,running:!0}),Ce}u(){for(const{run:U}of this.f.values())U.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(U){if(!(U instanceof g.$NM))throw new c.$sM(U.id);if(this.g.has(r.$rJ.fromExtHostTestItem(U,this.m.controllerId).toString()))return;const z=[],F=this.m.colllection.root;for(;;){const O=t.TestItem.from(U);if(z.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),U===F))break;U=U.parent||F}this.s.$addTestsToRun(this.m.controllerId,this.m.id,z)}dispose(){this.w(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,z,F,O){return this.f(U,z,F,O)}cancelRunById(U){for(const z of this.c.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,z,F,O,X,$e){const Ee=this.c.get(O);if(Ee)return Ee.createRun(X);const De=I.fromPublic(z,F,O,$e),Ce=m(O);this.d.$startedExtensionTestRun({controllerId:z,continuous:!!O.continuous,profile:Ce&&{group:W[Ce.kind],id:Ce.profileId},exclude:O.exclude?.map(pe=>r.$rJ.fromExtHostTestItem(pe,F.root.id).toString())??[],id:De.id,include:O.include?.map(pe=>r.$rJ.fromExtHostTestItem(pe,F.root.id).toString())??[F.root.id],persist:$e});const de=this.f(O,De,U);return R.Event.once(de.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),de.dispose()}),de.createRun(X)}f(U,z,F,O){const X=new d(z,this.d,O);return this.c.set(U,X),R.Event.once(X.onEnd)(()=>this.c.delete(U)),X}}e.$vfc=v;const m=K=>{if(K.profile){if(!(K.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(U,z,F,O){return new I(U,(0,u.$ig)(),F.include?.map(X=>r.$rJ.fromExtHostTestItem(X,U).toString())??[U],F.exclude?.map(X=>r.$rJ.fromExtHostTestItem(X,U).toString())??[],O,z)}static fromInternal(U,z){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,F,O,X,$e){this.controllerId=U,this.id=z,this.isPersisted=X,this.colllection=$e,this.c=F.map(Ee=>Ee+"\0"),this.d=O.map(Ee=>Ee+"\0")}isIncluded(U){const z=r.$rJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(z===F||z.startsWith(F))return!1;for(const F of this.c)if(z===F||z.startsWith(F))return!0;return!1}}e.$wfc=I;class S{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,z,F){this.f=U,this.g=z,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.d=void 0,z}}async resolveFileCoverage(U,z){const F=await this.d;let O=F?.[U];return!this.c||!F||!O?[]:(O.detailedCoverage||(O=F[U]=await this.c.resolveFileCoverage?.(O,z)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const z=r.$rJ.parentId(U.item.extId);if(z&&this.g.has(z.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:z,f:F}=this;return{get added(){return[...U].map(O=>O.revived)},get updated(){return[...z].map(O=>O.revived)},get removed(){return[...F].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$yJ{constructor(){super(...arguments),this.q=new R.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,z){return{...U,revived:t.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}o(){return new h(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,$.$cb)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,l.$NF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$NF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,U=>U.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(k.$Kf))}constructor(U,z,F,O,X,$e,Ee,De,Ce,de,pe=!1,re=void 0,Re=!1){this.controllerId=$e,this.profileId=Ee,this.d=De,this.kind=Ce,this.runHandler=de,this.f=pe,this._tag=re,this.g=Re,this.#e=U,this.#r=z,this.#t=F,this.#i=O,this.#o=X,z.set(Ee,this);const se=W[Ce];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${Ce}`);this.#e.$publishTestRunProfile({profileId:Ee,controllerId:$e,tag:re?t.TestTag.namespace(this.controllerId,re.id):null,label:De,group:se,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$xfc=C;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[268],Ae([1,0,18,11,5,3,109,8,7]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class f{constructor(k,u){this.i=u,this.a=new A.$Rd({onListenerError:L.$1}),this.b=new A.$Rd({onListenerError:L.$1}),this.c=new A.$Rd({onListenerError:L.$1}),this.d=new A.$Rd({onListenerError:L.$1}),this.f=new A.$Rd({onListenerError:L.$1}),this.g=new A.$Rd({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(M.$yK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const u=this.i.allEditors();return k?u:u.map(b=>b.value)}async showTextDocument(k,u,b){let p;typeof u=="number"?p={position:$.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?p={position:$.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?$.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(k.uri,p),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,u){return new R.$HM(this.h,k,u).value}$acceptEditorPropertiesChanged(k,u){const b=this.i.getEditor(k);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const p=u.selections.selections.map($.Selection.to);b._acceptSelections(p)}if(u.visibleRanges){const p=E.$Gb(u.visibleRanges.map($.Range.to));b._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:$.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=D.TextEditorSelectionChangeKind.fromValue(u.selections.source),g=u.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:p})}if(u.visibleRanges){const p=E.$Gb(u.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(k){for(const u in k){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const p=$.ViewColumn.to(k[u]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$Tdc=f}),define(Pe[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,L.$Vh)("IExtHostTimeline");class P{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$yK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&D.$_l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:E.URI.revive(g.uri);return this.c.get(g.source)?.get(k(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,p,g,t){return this.b.get(b)?.provider.provideTimeline(E.URI.revive(p),g,t)}registerTimelineProvider(b,p,g,t){const i=new M.$Qc,r=this.d(p.id,t,i).bind(this);let c;p.onDidChange&&(c=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const o=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(l,n,s){n?.resetCache&&(i.clear(),o.get(p.id)?.clear());const a=await p.provideTimeline(l,n,s);if(a==null)return;const d=r(l,n);return{...a,source:p.id,items:a.items.map(d)}},dispose(){for(const l of o.values())l.get(p.id)?.clear();c?.dispose(),i.dispose()}},g)}d(b,p,g){return(t,i)=>{let r;if(i?.cacheResults){let c=this.c.get(b);c===void 0&&(c=new Map,this.c.set(b,c));const o=k(t);r=c.get(o),r===void 0&&(r=new Map,c.set(o,r))}return c=>{const{iconPath:o,...l}=c,n=`${b}|${c.id??c.timestamp}`;r?.set(n,c);let s,a,d;c.iconPath&&(o instanceof R.$uL?d={id:o.id,color:o.color}:E.URI.isUri(o)?(s=o,a=o):{light:s,dark:a}=o);let v;return R.$1K.isMarkdownString(l.tooltip)?v=$.MarkdownString.from(l.tooltip):(0,f.$Cf)(l.tooltip)?v=l.tooltip:R.$1K.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=$.MarkdownString.from(l.detail)):(0,f.$Cf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=l.detail),{...l,id:l.id??void 0,handle:n,source:b,command:c.command?p.toInternal(c.command,g):void 0,icon:s,iconDark:a,themeIcon:d,tooltip:v,accessibilityInformation:c.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Afc=P;function k(u){return u?.toString()}}),define(Pe[87],Ae([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Swb=e.$Rwb=e.TunnelDtoConverter=void 0;class b extends D.$nv{}var p;(function(t){function i(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:c.protocol}}t.fromApiTunnel=i;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==D.TunnelPrivacyId.ConstantPrivate&&c.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}t.fromServiceTunnel=r})(p||(e.TunnelDtoConverter=p={})),e.$Rwb=(0,R.$Vh)("IExtHostTunnelService");let g=class extends A.$Rc{constructor(i,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$yK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,i.displayName);if(c){const o=new b(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const c=this.u();return this.r.set(c,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,c),new u.$AK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(i,r,c,o,l){const n=[];for(const a of i){const d=this.r.get(a);if(!d)return[];n.push(...await Promise.all(r.map(async v=>{let m;try{m=await d.provider.providePortAttributes({port:v,pid:c,commandLine:o},l)}catch{m=await d.provider.providePortAttributes(v,c,o,l)}return{providedAttributes:m,port:v}})))}const s=n.filter(a=>!!a.providedAttributes);return s.length>0?s.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await i.provideTunnel(o,l,new E.$2d().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,A.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const c=i.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,A.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const c=this.g.get(i.host);c.has(i.port)&&(r&&c.get(i.port).disposeListener.dispose(),await c.get(i.port).tunnel.dispose(),c.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const o=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:l}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),c=i.filter((o,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${c.map(o=>o.port).join(", ")}`),c}};e.$Swb=g,e.$Swb=g=Ke([We(0,k.$AM),We(1,P.$QM),We(2,$.$dj)],g)}),define(Pe[270],Ae([1,0,6,13,2,3]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$yK.MainThreadUriOpeners)}registerExternalUriOpener(D,f,P,k){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=k.schemes.find(b=>!R.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,k.schemes,D,k.label),(0,E.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(D,f,P){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const u=A.URI.revive(f);return k.canOpenExternalUri(u,P)}async $openUri(D,f,P){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(A.URI.revive(f.resolvedUri),{sourceUri:A.URI.revive(f.sourceUri)},P)}}e.$Cfc=R}),define(Pe[271],Ae([1,0,3,2,6,11,22]),function(be,e,E,L,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class ${static{this.a=0}constructor(f){this.c=new R.$am,this.d=new Map,this.b=f.getProxy(E.$yK.MainThreadUrls)}registerUriHandler(f,P){const k=f.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const u=$.a++;return this.c.add(k),this.d.set(u,P),this.b.$registerUriHandler(u,k,f.displayName||f.name),(0,A.$Pc)(()=>{this.c.delete(k),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const k=this.d.get(f);if(!k)return Promise.resolve(void 0);try{k.handleUri(L.URI.revive(P))}catch(u){(0,M.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(f){return L.URI.revive(await this.b.$createAppUri(f))}}e.$Dfc=$}),define(Pe[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=e.$0dc=e.$9dc=e.$8dc=void 0;class k{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,l,n,s,a,d,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#s=n,this.#o=s,this.#r=a,this.#n=d,this.#l=u(d),this.#d=b(d),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,f.$$tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+f.$0tb}return f.$0tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$en(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const l=(0,D.$gdb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#n.extensionLocation?.scheme===A.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,v,m,I)=>{const S=R.URI.from({scheme:v||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(S,{isRemote:l,authority:n}).toString();return`${a}${h}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,v,m,I)=>{const S=R.URI.from({scheme:v||"file",path:decodeURIComponent(m)}),h=(0,f.$$tb)(S,{isRemote:l,authority:n}).toString();return`${a}${h}${I}`})}}e.$8dc=k;function u(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$9dc=u;function b(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends L.$Rc{constructor(o,l,n,s,a){super(),this.c=l,this.f=n,this.g=s,this.h=a,this.b=new Map,this.a=o.getProxy(P.$yK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,n){const s=this.j(o);if(s){const{message:a}=(0,D.$hdb)(l,n.value);s._onMessageEmitter.fire(a)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,n){const s=new k(o,this.a,i(l),this.c,this.f,n,this.h);this.b.set(o,s);const a=s._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$0dc=p;function g(c){return{id:c.identifier,location:c.extensionLocation}}e.$$dc=g;function t(c,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(c,o)}}e.$_dc=t;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(o=>R.URI.from(o))}}function r(c,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(Pe[272],Ae([1,0,20,97,6,13,25,2,8,65,75,3,7]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class b{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new P.$Adc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class p{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,d){const v=this.b(s,a.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const m=new b(a,d);return this.a.set(v,m),m}delete(s,a){const d=this.b(s,a.uri);this.a.delete(d)}b(s,a){return`${s}@@@${a}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(s,a,d){return this.b(0,s,a,d)}addCustomProvider(s,a,d){return this.b(1,s,a,d)}get(s){return this.a.get(s)}b(s,a,d,v){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:d,provider:v}),new u.$AK(()=>this.a.delete(a))}}class i{constructor(s,a,d,v,m){this.d=a,this.f=d,this.g=v,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(k.$yK.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,d,v){const m=new A.$Qc;return c(d)?(m.add(this.b.addTextProvider(a,s,d)),this.a.$registerTextEditorProvider((0,f.$$dc)(s),a,v.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,f.$9dc)(s))):(m.add(this.b.addCustomProvider(a,s,d)),r(d)&&m.add(d.onDidChangeCustomDocument(I=>{const S=this.i(a,I.document.uri);if(o(I)){const h=S.addEdit(I);this.a.$onDidEdit(I.document.uri,a,h,I.label)}else this.a.$onContentChange(I.document.uri,a)})),this.a.$registerCustomEditorProvider((0,f.$$dc)(s),a,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,f.$9dc)(s))),u.$AK.from(m,new u.$AK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,d,v,m){const I=this.b.get(a);if(!I)throw new Error(`No provider found for '${a}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${a}'`);const S=$.URI.revive(s),h=await I.provider.openCustomDocument(S,{backupId:d,untitledDocumentData:v?.buffer},m);let w;return r(I.provider)&&this.f&&(w=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(a,h,w),{editable:r(I.provider)}}async $disposeCustomDocument(s,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const v=$.URI.revive(s),{document:m}=this.i(a,v);this.c.delete(a,m),m.dispose()}async $resolveCustomEditor(s,a,d,v,m,I){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);const h=D.ViewColumn.to(m),w=this.g.createNewWebview(a,v.contentOptions,S.extension),y=this.h.createNewWebviewPanel(a,d,v.title,h,v.options,w,v.active),C=$.URI.revive(s);switch(S.type){case 1:{const{document:W}=this.i(d,C);return S.provider.resolveCustomEditor(W,y,I)}case 0:{const W=this.d.getDocument(C);return S.provider.resolveCustomTextEditor(W,y,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,d){this.i(a,s).disposeEdits(d)}async $onMoveCustomEditor(s,a,d){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(a),S=this.d.getDocument(I);await v.provider.moveCustomTextEditor(S,m,E.CancellationToken.None)}async $undo(s,a,d,v){return this.i(a,s).undo(d,v)}async $redo(s,a,d,v){return this.i(a,s).redo(d,v)}async $revert(s,a,d){const v=this.i(a,s);await this.j(a).revertCustomDocument(v.document,d),v.disposeBackup()}async $onSave(s,a,d){const v=this.i(a,s);await this.j(a).saveCustomDocument(v.document,d),v.disposeBackup()}async $onSaveAs(s,a,d,v){const m=this.i(a,s);return this.j(a).saveCustomDocumentAs(m.document,$.URI.revive(d),v)}async $backup(s,a,d){const v=this.i(a,s),I=await this.j(a).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},d);return v.updateBackup(I),I.id}i(s,a){const d=this.c.get(s,$.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$bec=i;function r(n){return!!n.onDidChangeCustomDocument}function c(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function l(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,L.$Ji)(s)+""}}),define(Pe[273],Ae([1,0,5,6,2,38,8,65,3,7]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class P extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(p,g,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=g,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,A.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#s=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!g})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends L.$Rc{static c(){return(0,M.$ig)()}constructor(p,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$yK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,g,t,i,r={}){const c=typeof i=="object"?i.viewColumn:i,o={viewColumn:R.ViewColumn.from(c),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$9dc)(p),n=k.c();this.f.$createWebviewPanel((0,$.$$dc)(p),n,g,{title:t,panelOptions:u(r),webviewOptions:(0,$.$_dc)(p,this.m,r),serializeBuffersForPostMessage:l},o);const s=this.j.createNewWebview(n,r,p);return this.createNewWebviewPanel(n,g,t,c,r,s,!0)}$onDidChangeWebviewPanelViewStates(p){const g=Object.keys(p);g.sort((t,i)=>{const r=p[t],c=p[i];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const r=p[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:R.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:p}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,$.$9dc)(p)}),new f.$AK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(p,g,t,i){const r=this.h.get(g);if(!r)throw new Error(`No serializer found for '${g}'`);const{serializer:c,extension:o}=r,l=this.j.createNewWebview(p,t.webviewOptions,o),n=this.createNewWebviewPanel(p,g,t.title,i,t.panelOptions,l,t.active);await c.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(p,g,t,i,r,c,o){const l=new P(p,this.f,c,{viewType:g,title:t,viewColumn:i,panelOptions:r,active:o});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$aec=k;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[274],Ae([1,0,5,6,65,8,3,7]),function(be,e,E,L,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class D extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(k,u,b,p,g,t){super(),this.#r=!1,this.#u=this.B(new E.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Rd),this.onDidDispose=this.#l.event,this.#i=b,this.#a=p,this.#e=k,this.#t=u,this.#o=g,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#r||(this.#n=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#r)throw new Error("Webview is disposed")}}class f{constructor(k,u){this.d=u,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$yK.MainThreadWebviewViews)}registerWebviewViewProvider(k,u,b,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:k}),this.a.$registerWebviewViewProvider((0,A.$$dc)(k),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$9dc)(k)}),new $.$AK(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(k,u,b,p,g){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:r}=t,c=this.d.createNewWebview(k,{},r),o=new D(k,this.a,u,b,c,!0);this.c.set(k,o),await i.resolveWebviewView(o,{state:p},g)}async $onDidChangeWebviewViewVisibility(k,u){this.e(k)._setVisible(u)}async $disposeWebviewView(k){const u=this.e(k);this.c.delete(k),u.dispose(),this.d.deleteWebview(k)}e(k){const u=this.c.get(k);if(!u)throw new Error("No webview found");return u}}e.$Efc=f}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(be,e,E,L,A,M,R,$,D,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=e.$Ffc=void 0;let k=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,f.$NF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new E.$Rd,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(L.$yK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let g;if(typeof b=="string"){g=b;try{b=A.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.$Fe)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,p)}async asExternalUri(b,p){if((0,R.$Fe)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,p);return A.URI.from(g)}};e.$Ffc=k,e.$Ffc=k=P=Ke([We(0,D.$AM)],k),e.$Gfc=(0,$.$Vh)("IExtHostWindow")}),define(Pe[275],Ae([1,0,241,27,17]),function(be,e,E,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;let M=class extends E.$Jfc{constructor($,D){super($,D)}f($,D,f){D.apply(console,f)}};e.$Rhc=M,e.$Rhc=M=Ke([We(0,A.$AM),We(1,L.$QM)],M)}),define(Pe[276],Ae([1,0,14,24,20,11,5,6,139,230,49]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.ResponsiveState=e.RequestInitiator=e.$X5b=e.$W5b=void 0;function u(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(C,W){this.jsonString=C,this.referencedBuffers=W}}function t(y,C=null,W=!1){const K=[];return{jsonString:(W?u:JSON.stringify)(y,(z,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof L.$fe){const O=K.push(F)-1;return{[b]:O}}if(C)return C(z,F)}return F}),referencedBuffers:K}}e.$W5b=t;function i(y,C,W){return JSON.parse(y,(K,U)=>{if(U){const z=U[b];if(typeof z=="number")return C[z];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$X5b=i;function r(y,C){return JSON.stringify(y,C)}function c(y){return y?(C,W)=>W&&W.$mid===1?y.transformOutgoing(W):W:null}var o;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends $.$Rc{static{k=s}static{this.a=3*1e3}constructor(C,W=null,K=null){super(),this[k]=!0,this.b=this.B(new R.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=W,this.g=K,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,z=P.$uv.count;U<z;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$0g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const W=this.w[C];delete this.w[C],W.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Um)(C,this.g):C}getProxy(C){const{nid:W,sid:K}=C;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(C,W){const K={get:(U,z)=>(typeof z=="string"&&!U[z]&&z.charCodeAt(0)===36&&(U[z]=(...F)=>this.U(C,z,F)),z===a?W:U[z])};return new Proxy(Object.create(null),K)}set(C,W){return this.m[C.nid]=W,W}assertRegistered(C){for(let W=0,K=C.length;W<K;W++){const U=C[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(C){if(this.j)return;const W=C.byteLength,K=m.read(C,0),U=K.readUInt8(),z=K.readUInt32();switch(U){case 1:case 2:{let{rpcId:F,method:O,args:X}=S.deserializeRequestJSONArgs(K);this.g&&(X=(0,D.$Um)(X,this.g)),this.M(W,z,F,O,X,U===2);break}case 3:case 4:{let{rpcId:F,method:O,args:X}=S.deserializeRequestMixedArgs(K);this.g&&(X=(0,D.$Um)(X,this.g)),this.M(W,z,F,O,X,U===4);break}case 5:{this.f?.logIncoming(W,z,0,"ack"),this.G(z);break}case 6:{this.N(W,z);break}case 7:{this.O(W,z,void 0);break}case 9:{let F=S.deserializeReplyOKJSON(K);this.g&&(F=(0,D.$Um)(F,this.g)),this.O(W,z,F);break}case 10:{const F=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,z,F);break}case 8:{const F=S.deserializeReplyOKVSBuffer(K);this.O(W,z,F);break}case 11:{let F=S.deserializeReplyErrError(K);this.g&&(F=(0,D.$Um)(F,this.g)),this.P(W,z,F);break}case 12:{this.P(W,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,W,K,U,z,F){this.f?.logIncoming(C,W,1,`receiveRequest ${(0,P.$wv)(K)}.${U}(`,z);const O=String(W);let X,$e;if(F){const De=new A.$2d;z.push(De.token),X=this.Q(K,U,z),$e=()=>De.cancel()}else X=this.Q(K,U,z),$e=n;this.u[O]=$e;const Ee=S.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),X.then(De=>{delete this.u[O];const Ce=S.serializeReplyOK(W,De,this.h);this.f?.logOutgoing(Ce.byteLength,W,1,"reply:",De),this.c.send(Ce)},De=>{delete this.u[O];const Ce=S.serializeReplyErr(W,De);this.f?.logOutgoing(Ce.byteLength,W,1,"replyErr:",De),this.c.send(Ce)})}N(C,W){this.f?.logIncoming(C,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(C,W,K){this.f?.logIncoming(C,W,0,"receiveReply:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U],z.resolveOk(K)}P(C,W,K){this.f?.logIncoming(C,W,0,"receiveReplyErr:",K);const U=String(W);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U];let F;K&&(K.$isError?(F=new Error,F.name=K.name,F.message=K.message,F.stack=K.stack):F=K),z.resolveErr(F)}Q(C,W,K){try{return Promise.resolve(this.S(C,W,K))}catch(U){return Promise.reject(U)}}S(C,W,K){const U=this.m[C];if(!U)throw new Error("Unknown actor "+(0,P.$wv)(C));const z=U[W];if(typeof z!="function")throw new Error("Unknown method "+W+" on actor "+(0,P.$wv)(C));return z.apply(U,K)}U(C,W,K){if(this.j)return new f.$V5b;let U=null;if(K.length>0&&A.CancellationToken.isCancellationToken(K[K.length-1])&&(U=K.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const z=S.serializeRequestArguments(K,this.h),F=++this.t,O=String(F),X=new f.$U5b,$e=new $.$Qc;U&&$e.add(U.onCancellationRequested(()=>{const De=S.serializeCancel(F);this.f?.logOutgoing(De.byteLength,F,0,"cancel"),this.c.send(S.serializeCancel(F))})),this.w[O]=new v(X,$e),this.F(F);const Ee=S.serializeRequest(F,C,W,z,!!U);return this.f?.logOutgoing(Ee.byteLength,F,0,`request: ${(0,P.$wv)(C)}.${W}(`,K),this.c.send(Ee),X}}e.$Y5b=d;class v{constructor(C,W){this.a=C,this.b=W}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,W,K){const U=new m(L.$fe.alloc(K+1+4),0);return U.writeUInt8(C),U.writeUInt32(W),U}static read(C,W){return new m(C,W)}get buffer(){return this.a}constructor(C,W){this.a=C,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+C).toString();return this.b+=C,K}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C);return this.b+=C,W}static sizeMixedArray(C){let W=0;W+=1;for(let K=0,U=C.length;K<U;K++){const z=C[K];switch(W+=1,z.type){case 1:W+=this.sizeLongString(z.value);break;case 2:W+=this.sizeVSBuffer(z.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(z.value);for(let F=0;F<z.buffers.length;++F)W+=this.sizeVSBuffer(z.buffers[F]);break;case 4:break}}return W}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let W=0,K=C.length;W<K;W++){const U=C[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let z=0;z<U.buffers.length;++z)this.writeBuffer(U.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const W=new Array(C);for(let K=0;K<C;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),F=this.readLongString(),O=[];for(let X=0;X<z;++X)O.push(this.readVSBuffer());W[K]=new P.$xv(i(F,O,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class S{static a(C){for(let W=0,K=C.length;W<K;W++)if(C[W]instanceof L.$fe||C[W]instanceof P.$xv||typeof C[W]>"u")return!0;return!1}static serializeRequestArguments(C,W){if(this.a(C)){const K=[];for(let U=0,z=C.length;U<z;U++){const F=C[U];if(F instanceof L.$fe)K[U]={type:2,value:F};else if(typeof F>"u")K[U]={type:4};else if(F instanceof P.$xv){const{jsonString:O,referencedBuffers:X}=t(F.value,W);K[U]={type:3,value:L.$fe.fromString(O),buffers:X}}else K[U]={type:1,value:L.$fe.fromString(r(F,W))}}return{type:1,args:K}}return{type:0,args:r(C,W)}}static serializeRequest(C,W,K,U,z){switch(U.type){case 0:return this.b(C,W,K,U.args,z);case 1:return this.c(C,W,K,U.args,z)}}static b(C,W,K,U,z){const F=L.$fe.fromString(K),O=L.$fe.fromString(U);let X=0;X+=m.sizeUInt8(),X+=m.sizeShortString(F),X+=m.sizeLongString(O);const $e=m.alloc(z?2:1,C,X);return $e.writeUInt8(W),$e.writeShortString(F),$e.writeLongString(O),$e.buffer}static deserializeRequestJSONArgs(C){const W=C.readUInt8(),K=C.readShortString(),U=C.readLongString();return{rpcId:W,method:K,args:JSON.parse(U)}}static c(C,W,K,U,z){const F=L.$fe.fromString(K);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(F),O+=m.sizeMixedArray(U);const X=m.alloc(z?4:3,C,O);return X.writeUInt8(W),X.writeShortString(F),X.writeMixedArray(U),X.buffer}static deserializeRequestMixedArgs(C){const W=C.readUInt8(),K=C.readShortString(),U=C.readMixedArray(),z=new Array(U.length);for(let F=0,O=U.length;F<O;F++){const X=U[F];typeof X=="string"?z[F]=JSON.parse(X):z[F]=X}return{rpcId:W,method:K,args:z}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,W,K){if(typeof W>"u")return this.d(C);if(W instanceof L.$fe)return this.e(C,W);if(W instanceof P.$xv){const{jsonString:U,referencedBuffers:z}=t(W.value,K,!0);return this.g(C,U,z)}else return this.f(C,u(W,K))}static d(C){return m.alloc(7,C,0).buffer}static e(C,W){let K=0;K+=m.sizeVSBuffer(W);const U=m.alloc(8,C,K);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,W){const K=L.$fe.fromString(W);let U=0;U+=m.sizeLongString(K);const z=m.alloc(9,C,U);return z.writeLongString(K),z.buffer}static g(C,W,K){const U=L.$fe.fromString(W);let z=0;z+=m.sizeUInt32,z+=m.sizeLongString(U);for(const O of K)z+=m.sizeVSBuffer(O);const F=m.alloc(10,C,z);F.writeUInt32(K.length),F.writeLongString(U);for(const O of K)F.writeBuffer(O);return F.buffer}static deserializeReplyOKJSON(C){const W=C.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(C,W){const K=C.readUInt32(),U=C.readLongString(),z=[];for(let F=0;F<K;++F)z.push(C.readVSBuffer());return new P.$xv(i(U,z,W))}static serializeReplyErr(C,W){const K=W?u(M.$2(W),null):void 0;if(typeof K!="string")return this.h(C);const U=L.$fe.fromString(K);let z=0;z+=m.sizeLongString(U);const F=m.alloc(11,C,z);return F.writeLongString(U),F.buffer}static deserializeReplyErrError(C){const W=C.readLongString();return JSON.parse(W)}static h(C){return m.alloc(12,C,0).buffer}}var h;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[277],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){D.postMessage(f,P)}},onmessage:{get(){return D.onmessage},set(f){D.onmessage=f}}}),D.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,f=new Blob([D],{type:"application/javascript"}),P=URL.createObjectURL(f),k=new MessageChannel,u=P,b={type:"_newWorker",id:u,port:k.port2,url:P,options:$};M(b,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(p){k.port1.onmessage=p}},onmessageerror:{get(){return k.port1.onmessageerror},set(p){k.port1.onmessageerror=p}}}),k.port1.addEventListener("messageerror",p=>{const g=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(g)}),k.port1.addEventListener("message",p=>{const g=new MessageEvent("message",{data:p.data});this.dispatchEvent(g)}),k.port1.start()}}e.$Thc=L}),define(Pe[278],Ae([1,0,5,30,34,4]),function(be,e,E,L,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.OutputChannelUpdateMode=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0,e.$JJ="text/x-code-output",e.$KJ="output",e.$LJ="Log",e.$MJ="text/x-code-log-output",e.$NJ="log",e.$OJ="workbench.panel.output",e.$PJ=new A.$aj("inOutput",!1),e.$QJ=new A.$aj("activeLogOutput",!1),e.$RJ=new A.$aj("outputView.scrollLock",!1),e.$SJ=(0,M.$Vh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$TJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}L.$mn.add(e.$TJ.OutputChannels,new $),e.$UJ=new A.$aj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,278,63,27,42,136,24,16,41,5,6]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class i extends R.$jj{get disposed(){return this.n}constructor(l,n,s,a,d){super(),this.id=l,this.name=n,this.r=s,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const n=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(l,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:n))}hide(){this.s.$close(this.id)}g(l,n){this.m+=u.$fe.fromString(n).byteLength,(0,R.log)(this.r,l,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(l){this.append(l)}}let c=class{constructor(l,n,s,a,d,v){this.i=n,this.j=s,this.k=a,this.l=d,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$yK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,k.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(l,n,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,d=(0,b.$Cf)(n)?n:void 0;if((0,b.$Cf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const m=this.i.environment.extensionLogLevel?.find(([S])=>M.$_l.equals(s.identifier,S))?.[1];m&&(v=(0,R.$tj)(m));const I=a?this.o(l,v,s):this.n(l,d,s);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),a?this.r(l,v??this.m.getLevel(),I):this.q(l,I)}async n(l,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,d,n,s.identifier.value);return new i(m,l,v,this.a,s)}async o(l,n,s){const a=await this.p(s),d=l.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(a,`${d}.log`),m=`${s.identifier.value}.${d}`,I=this.l.createLogger(v,{id:m,name:l,logLevel:n,extensionId:s.identifier.value});return new r(m,l,I,this.a,s)}p(l){let n=this.d.get(l.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,p.$uk)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}q(l,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(d){a(),n.then(v=>v.append(d))},appendLine(d){a(),n.then(v=>v.appendLine(d))},clear(){a(),n.then(d=>d.clear())},replace(d){a(),n.then(v=>v.replace(d))},show(d,v){a(),n.then(m=>m.show(d,v))},hide(){a(),n.then(d=>d.hide())},dispose(){s=!0,n.then(d=>d.dispose())}}}r(l,n,s){const a=new t.$Qc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},v=a.add(new g.$Rd);function m(I){n=I,v.fire(I)}return s.then(I=>{a.add(I),I.logLevel!==n&&m(I.logLevel),a.add(I.onDidChangeLogLevel(S=>m(S)))}),{...this.q(l,s),get logLevel(){return n},onDidChangeLogLevel:v.event,trace(I,...S){d(),s.then(h=>h.trace(I,...S))},debug(I,...S){d(),s.then(h=>h.debug(I,...S))},info(I,...S){d(),s.then(h=>h.info(I,...S))},warn(I,...S){d(),s.then(h=>h.warn(I,...S))},error(I,...S){d(),s.then(h=>h.error(I,...S))},dispose(){a.dispose()}}}};e.$ffc=c,e.$ffc=c=Ke([We(0,A.$AM),We(1,f.$QM),We(2,D.$5dc),We(3,P.$Edc),We(4,R.$ej),We(5,R.$dj)],c),e.$gfc=(0,L.$Vh)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,E.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await A.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Yg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Ae([1,0,170,54,30,47,40,6,5,113,21,26]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$pH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$qH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$rH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$sH={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this.a=new D.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const b=new u;A.$mn.add(e.$sH.ConfigurationMigration,b);let p=class extends $.$Rc{constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const o of c.added)await this.f(o,b.migrations)})),this.c(b.migrations),this.B(b.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(c=>this.g(c,i?.uri))])}async g(i,r){const c=this.a.inspect(i.key,{resource:r}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[l,n]of o){const s=[];for(const d of c.overrideIdentifiers??[]){const v=await this.h(i,{resource:r,overrideIdentifier:d},l);for(const m of v??[]){let I=s.find(([[S,h]])=>S===m[0]&&(0,k.$en)(h.value,m[1].value));I||s.push(I=[m,[]]),I[1].push(d)}}const a=await this.h(i,{resource:r},l,c);for(const d of a??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,v],m])=>this.a.updateValue(d,v.value,{resource:r,overrideIdentifiers:m},n)))}}async h(i,r,c,o){const l=(o??this.a.inspect(i.key,r))[c];if(l===void 0)return;const n=a=>this.a.inspect(a,r)[c],s=await i.migrateFn(l,n);return Array.isArray(s)?s:[[i.key,s]]}};e.$tH=p,e.$tH=p=Ke([We(0,R.$pi),We(1,M.$5h)],p);let g=class extends $.$Rc{constructor(i){super(),(async()=>{if(!P.$i&&(await i.getEnvironment())?.os!==1)return;A.$mn.as(L.$rn.Configuration).registerConfiguration({...e.$rH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$uH=g,e.$uH=g=Ke([We(0,f.$zm)],g)}),define(Pe[280],Ae([1,0,33,13,19,25,178,279,54,4,30]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcb=e.$Acb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$zcb=e.$ycb=void 0,e.$ycb=(0,f.$Vh)("editorResolverService"),e.$zcb="workbench.editorAssociations";const k=P.$mn.as(D.$rn.Configuration),u={...$.$qH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(u);var b;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(b||(e.RegisteredEditorPriority=b={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function g(i){switch(i){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}e.$Acb=g;function t(i,r){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(r.scheme))return!1;const l=typeof i=="string"&&i.indexOf(A.$fc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$wg)(r);return E.$Bj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$Bcb=t}),define(Pe[281],Ae([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(be,e,E,L,A,M,R,$,D,f,P,k,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0,e.$aK=(0,D.$Vh)("pathService");let p=b=class{constructor(t,i,r,c){this.d=t,this.e=i,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(c=>this.h(t,c,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Zf)(r??(0,R.$wg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const r=(0,f.$0J)(i.getWorkspace());if(r)return r;const c=i.getWorkspace().folders[0];if(c)return c.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?A.$ec:A.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const c=t.indexOf("/",2);c===-1?(i=t.substring(2),t="/"):(i=t.substring(2,c),t=t.substring(c)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$bK=p,e.$bK=p=b=Ke([We(1,u.$zm),We(2,k.$VJ),We(3,P.$5h)],p)}),define(Pe[114],Ae([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$QI=e.$PI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$PI=E;class L{constructor(R,$,D,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,f)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$QI=L;var A;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Pe[43],Ae([1,0,18,33,26,46,12,4,19,11,114,14]),function(be,e,E,L,A,M,R,$,D,f,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchErrorCode=e.$6I=e.$5I=e.SearchSortOrder=e.ViewMode=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchCompletionExitCode=e.$ZI=e.$YI=e.$XI=e.QueryType=e.SearchProviderType=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$RI="workbench.view.search",e.$SI="workbench.panel.search",e.$TI="workbench.view.search",e.$UI="search-result",e.$VI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",p=(u.length+b.length+5)*2;e.$WI=(0,$.$Vh)("searchService");var g;(function(de){de[de.file=0]="file",de[de.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(de){de[de.File=1]="File",de[de.Text=2]="Text"})(t||(e.QueryType=t={}));function i(de){return!!de.preview}e.$XI=i;function r(de){return!!de.resource}e.$YI=r;function c(de){return!!de.message}e.$ZI=c;var o;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor(pe){this.resource=pe,this.results=[]}}e.$1I=l;class n{constructor(pe,re,Re,se){this.ranges=re,this.webviewIndex=se;const Y=Array.isArray(re)?re:[re];if(Re&&Re.matchLines===1&&s(Y)){pe=(0,R.$vf)(pe,Re.matchLines);let B="",ie=0,me=0;const ne=Math.floor(Re.charsPerLine/5),le=[];for(const ce of Y){const we=Math.max(ce.startColumn-ne,0),_=ce.startColumn+Re.charsPerLine;if(we>me+ne+p){const he=u+(we-me)+b;B+=he+pe.slice(we,_),ie+=we-(me+he.length)}else B+=pe.slice(me,_);le.push(new d(0,ce.startColumn-ie,ce.endColumn-ie)),me=_}this.preview={text:B,matches:Array.isArray(this.ranges)?le:le[0]}}else{const B=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,E.$1b)(re,ie=>new a(ie.startLineNumber-B,ie.startColumn,ie.endLineNumber-B,ie.endColumn))}}}}e.$2I=n;function s(de){const pe=de[0].startLineNumber;for(const re of de)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class a{constructor(pe,re,Re,se){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Re,this.endColumn=se}}e.$3I=a;class d extends a{constructor(pe,re,Re){super(pe,re,pe,Re)}}e.$4I=d;var v;(function(de){de.List="list",de.Tree="tree"})(v||(e.ViewMode=v={}));var m;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(de,pe=!0){const re=de&&de.files&&de.files.exclude,Re=pe&&de&&de.search&&de.search.exclude;if(!re&&!Re)return;if(!re||!Re)return re||Re;let se=Object.create(null);return se=A.$dn(se,A.$an(re)),se=A.$dn(se,A.$an(Re),!0),se}e.$5I=I;function S(de,pe){return de.excludePattern&&L.$Bj(de.excludePattern,pe)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&L.$Bj(de.includePattern,pe)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(re=>{const Re=re.folder.fsPath;if(M.$2f(pe,Re)){const se=D.$kc(Re,pe);return!re.includePattern||!!L.$Bj(re.includePattern,se)}else return!1}):!1:!0}e.$6I=S;var h;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor(pe,re){super(pe),this.code=re}}e.$7I=w;function y(de){const pe=de.message;if((0,f.$3)(de))return new w(pe,h.canceled);try{const re=JSON.parse(pe);return new w(re.message,re.code)}catch{return new w(pe,h.other)}}e.$8I=y;function C(de){const pe={message:de.message,code:de.code};return new Error(JSON.stringify(pe))}e.$9I=C;function W(de){return de.type==="error"?!0:de.type==="success"}e.$0I=W;function K(de){return de.type==="success"}e.$$I=K;function U(de){return!!de.path}e.$_I=U;function z(de,pe){const re=de.searchPath?de.searchPath:de.relativePath;return(0,R.$sf)(re,pe)}e.$aJ=z;class F{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$bJ=F;function O(de,pe){const re={...de||{},...pe||{}};return Object.keys(re).filter(Re=>{const se=re[Re];return typeof se=="boolean"&&se})}e.$cJ=O;class X{constructor(pe,re){this.c=null,this.a={...pe.excludePattern||{},...re.excludePattern||{}},this.b=L.$Cj(this.a);let Re=pe.includePattern;re.includePattern&&(Re?Re={...Re,...re.includePattern}:Re=re.includePattern),Re&&(this.c=L.$Cj(Re))}matchesExcludesSync(pe,re,Re){return!!(this.b&&this.b(pe,re,Re))}includedInQuerySync(pe,re,Re){return!(this.b&&this.b(pe,re,Re)||this.c&&!this.c(pe,re,Re))}includedInQuery(pe,re,Re){const se=this.b(pe,re,Re),Y=()=>this.c?!!this.c(pe,re,Re):!0;return(0,k.$Kg)(se)?se.then(B=>B?!1:Y()):Y()}hasSiblingExcludeClauses(){return $e(this.a)}}e.$dJ=X;function $e(de){for(const pe in de)if(typeof de[pe]!="boolean")return!0;return!1}function Ee(de){if(!de)return;let pe;return re=>(pe||(pe=(de()||Promise.resolve([])).then(Re=>Re?Ce(Re):{})),pe.then(Re=>!!Re[re]))}e.$eJ=Ee;function De(de){if(!de)return;let pe;return re=>{if(!pe){const Re=de();pe=Re?Ce(Re):{}}return!!pe[re]}}e.$fJ=De;function Ce(de){const pe={};for(const re of de)pe[re]=!0;return pe}}),define(Pe[35],Ae([1,0,18,14,20,5,6,50,13,121,25,12,2,169,4,15,188,47,42,27,17,8,7,57,43,3,51]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=e.$Ydc=void 0;function m(K,U,z){return new P.$og(F=>w(F,z)).isEqual(K,U)}function I(K,U,z){return m(K.uri,U.uri,z)?0:(0,k.$Ye)(K.uri.toString(),U.uri.toString())}function S(K,U,z){return K.index!==U.index?K.index<U.index?-1:1:m(K.uri,U.uri,z)?(0,k.$Ye)(K.name,U.name):(0,k.$Ye)(K.uri.toString(),U.uri.toString())}function h(K,U,z,F){const O=K.slice(0).sort(($e,Ee)=>z($e,Ee,F)),X=U.slice(0).sort(($e,Ee)=>z($e,Ee,F));return(0,E.$Db)(O,X,($e,Ee)=>z($e,Ee,F))}function w(K,U){const z=U.getCapabilities(K.scheme);return!(z&&z&1024)}class y extends i.$ci{static toExtHostWorkspace(U,z,F,O){if(!U)return{workspace:null,added:[],removed:[]};const{id:X,name:$e,folders:Ee,configuration:De,transient:Ce,isUntitled:de}=U,pe=[],re=z;z?Ee.forEach((B,ie)=>{const me=u.URI.revive(B.uri),ne=y.o(F||z,me,O);ne?(ne.name=B.name,ne.index=B.index,pe.push(ne)):pe.push({uri:me,name:B.name,index:ie})}):pe.push(...Ee.map(({uri:B,name:ie,index:me})=>({uri:u.URI.revive(B),name:ie,index:me}))),pe.sort((B,ie)=>B.index<ie.index?-1:1);const Re=new y(X,$e,pe,!!Ce,De?u.URI.revive(De):null,!!de,B=>w(B,O)),{added:se,removed:Y}=h(re?re.workspaceFolders:[],Re.workspaceFolders,I,O);return{workspace:Re,added:se,removed:Y}}static o(U,z,F){for(let O=0;O<U.folders.length;O++){const X=U.workspaceFolders[O];if(m(X.uri,z,F))return X}}constructor(U,z,F,O,X,$e,Ee){super(U,F.map(De=>new i.$di(De)),O,X,Ee),this.t=z,this.u=$e,this.q=[],this.s=$.$2h.forUris(Ee),F.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,z){return z&&this.s.get(U)&&(U=(0,P.$yg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let C=class{constructor(U,z,F,O,X){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=O,this.s=F,this.t=X,this.j=new f.$Wl,this.k=new L.$Wg,this.o=U.getProxy(d.$yK.MainThreadWorkspace),this.q=U.getProxy(d.$yK.MainThreadMessageService);const $e=z.workspace;this.l=$e?new y($e.id,$e.name,[],!!$e.transient,$e.configuration?u.URI.revive($e.configuration):null,!!$e.isUntitled,Ee=>w(Ee,F)):void 0}$initializeWorkspace(U,z){this.v=z,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:D.Schemas.untitled,path:(0,P.$wg)((0,P.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,z,F,...O){const X=[];if(Array.isArray(O)&&O.forEach(de=>{u.URI.isUri(de.uri)&&!X.some(pe=>m(pe.uri,de.uri,this.s))&&X.push({uri:de.uri,name:de.name||(0,P.$vg)(de.uri)})}),this.n||[z,F].some(de=>typeof de!="number"||de<0)||F===0&&X.length===0)return!1;const $e=this.x?this.x.workspaceFolders:[];if(z+F>$e.length)return!1;const Ee=$e.slice(0);Ee.splice(z,F,...X.map(de=>({uri:de.uri,name:de.name||(0,P.$vg)(de.uri),index:void 0})));for(let de=0;de<Ee.length;de++){const pe=Ee[de];if(Ee.some((re,Re)=>Re!==de&&m(pe.uri,re.uri,this.s)))return!1}Ee.forEach((de,pe)=>de.index=pe);const{added:De,removed:Ce}=h($e,Ee,S,this.s);if(De.length===0&&Ce.length===0)return!1;if(this.o){const de=U.displayName||U.name;this.o.$updateWorkspaceFolders(de,z,F,X).then(void 0,pe=>{this.n=void 0;const re={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,de,pe.toString()),re,[])})}return this.y(Ee),!0}getWorkspaceFolder(U,z){if(this.x)return this.x.getWorkspaceFolder(U,z)}async getWorkspaceFolder2(U,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,z)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,z){let F,O="";if(typeof U=="string"?(F=u.URI.file(U),O=U):typeof U<"u"&&(F=U,O=U.fsPath),!F)return O;const X=this.getWorkspaceFolder(F,!0);if(!X)return O;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let $e=(0,P.$Bg)(X.uri,F);return z&&X.name&&($e=`${X.name}/${$e}`),$e}y(U){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:z,added:F,removed:O}=y.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:O}))}findFiles(U,z,F,O,X=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let $e;if(z===null?$e=!1:z&&(typeof z=="string"?$e=z:$e=z.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:Ee,folder:De}=W(l.GlobPattern.from(U));return this.o.$startFileSearch(Ee??null,De??null,$e??null,F??null,X).then(Ce=>Array.isArray(Ce)?Ce.map(de=>u.URI.revive(de)):[])}async findTextInFiles(U,z,F,O,X=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const $e=this.j.getNext(),Ee=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:De,folder:Ce}=W(l.GlobPattern.from(z.include)),de=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,pe={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:Ee,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:De,excludePattern:de},re=!1;if(this.u[$e]=Re=>{if(re)return;const se=u.URI.revive(Re.resource);Re.results.forEach(Y=>{const B=(0,v.$sh)(Y);(0,a.$XI)(B)?F({uri:se,preview:{text:B.preview.text,matches:(0,E.$1b)(B.preview.matches,ie=>new n.$CK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,E.$1b)(B.ranges,ie=>new n.$CK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):F({uri:se,text:B.text,lineNumber:B.lineNumber})})},X.isCancellationRequested)return{};try{const Re=await this.o.$startTextSearch(U,Ce??null,pe,$e,X);return delete this.u[$e],Re||{}}catch(Re){throw delete this.u[$e],Re}}$handleTextSearchResult(U,z){this.u[z]?.(U)}async save(U){const z=await this.o.$save(U,{saveAs:!1});return u.URI.revive(z)}async saveAs(U){const z=await this.o.$save(U,{saveAs:!0});return u.URI.revive(z)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,z){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,z);const F=this.t.transformOutgoingScheme(U),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,F),(0,R.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(U,z){this.h.info("Getting edit session identifier for workspaceFolder",U);const F=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const O=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!O),!O)return;const X=await O.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(U,z,F,O){this.h.info("Getting edit session identifier for workspaceFolder",U);const X=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const $e=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!$e),!$e)return;const Ee=await $e.provideEditSessionIdentityMatch?.(z,F,O);if(this.h.info("Provider returned edit session identifier match result: ",Ee),!!Ee)return Ee}getOnWillCreateEditSessionIdentityEvent(U){return(z,F,O)=>{const X=function(Ee){z.call(F,Ee)};return X.extension=U,this.A.event(X,void 0,O)}}async $onWillCreateEditSessionIdentity(U,z,F){const O=await this.resolveWorkspaceFolder(u.URI.revive(U));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},z,async(X,$e)=>{const Ee=Date.now();await Promise.resolve(X),Date.now()-Ee>F&&this.h.warn("SLOW edit session create-participant",$e.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(U,z){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,z);const F=this.t.transformOutgoingScheme(U),O=this.z++;return this.o.$registerCanonicalUriProvider(O,F),(0,R.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(U,z,F){const O=this.B.get(U.scheme);if(!O)return;const X=await O.provideCanonicalUri?.(u.URI.revive(U),z,F);if(X)return X}async $provideCanonicalUri(U,z,F){return this.provideCanonicalUri(u.URI.revive(U),{targetScheme:z},F)}};e.$Ydc=C,e.$Ydc=C=Ke([We(0,o.$AM),We(1,c.$QM),We(2,r.$Edc),We(3,g.$dj),We(4,s.$Wdc)],C),e.$Zdc=(0,p.$Vh)("IExtHostWorkspace");function W(K){let U,z;return K&&(typeof K=="string"?U=K:(U=K.pattern,z=u.URI.revive(K.baseUri))),{includePattern:U,folder:z}}}),define(Pe[36],Ae([1,0,26,5,35,3,7,190,54,16,14,4,17,15,2]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=void 0;function g(s,a){if(a){const d=a.split(".");let v=s;for(let m=0;v&&m<d.length;m++)v=v[d[m]];return v}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(a,d,v){this.a=a.getProxy(M.$yK.MainThreadConfiguration),this.c=d,this.b=v,this.d=new P.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new n(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(a,d))}};e.$1dc=l,e.$1dc=l=Ke([We(0,u.$AM),We(1,A.$Zdc),We(2,b.$dj)],l);class n{constructor(a,d,v,m){this.a=new L.$Rd,this.b=a,this.f=m,this.c=d,this.e=$.$Kn.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Kn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,v))}getConfiguration(a,d,v){const m=o(d)||{},I=this.g(a?g(this.e.getValue(void 0,m,this.c.workspace),a):this.e.getValue(void 0,m,this.c.workspace));a&&this.h(a,m,v?.identifier);function S(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(I,w)<"u"},get:(w,y)=>{this.h(a?`${a}.${w}`:w,m,v?.identifier);let C=g(I,w);if(typeof C>"u")C=y;else{let W;const K=(U,z)=>{if((0,f.$Ef)(U)){let F;const O=()=>{W=W||(0,E.$an)(I),F=F||g(W,z)};return new Proxy(U,{get:(X,$e)=>{if(typeof $e=="string"&&$e.toLowerCase()==="tojson")return O(),()=>F;if(W)return F=F||g(W,z),F[$e];const Ee=X[$e];return typeof $e=="string"?K(Ee,`${z}.${$e}`):Ee},set:(X,$e,Ee)=>(O(),F&&(F[$e]=Ee),!0),deleteProperty:(X,$e)=>(O(),F&&delete F[$e],!0),defineProperty:(X,$e,Ee)=>(O(),F&&Object.defineProperty(F,$e,Ee),!0)})}return Array.isArray(U)?(0,E.$an)(U):U};C=K(C,w)}return C},update:(w,y,C,W)=>{w=a?`${a}.${w}`:w;const K=S(C);return y!==void 0?this.b.$updateConfigurationOption(K,w,y,m,W):this.b.$removeConfigurationOption(K,w,m,W)},inspect:w=>{w=a?`${a}.${w}`:w;const y=this.e.inspect(w,m,this.c.workspace);if(y)return{key:w,defaultValue:(0,E.$an)(y.policy?.value??y.default?.value),globalValue:(0,E.$an)(y.user?.value??y.application?.value),workspaceValue:(0,E.$an)(y.workspace?.value),workspaceFolderValue:(0,E.$an)(y.workspaceFolder?.value),defaultLanguageValue:(0,E.$an)(y.default?.override),globalLanguageValue:(0,E.$an)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,E.$an)(y.workspace?.override),workspaceFolderLanguageValue:(0,E.$an)(y.workspaceFolder?.override),languageIds:(0,E.$an)(y.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$dn)(h,I,!1),Object.freeze(h)}g(a){const d=v=>(0,f.$Ef)(v)?new Proxy(v,{get:(m,I)=>d(m[I]),set:(m,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return d(a)}h(a,d,v){const m=D.$Bn.test(a)?4:this.d.get(a),I=v?`[${v.value}] `:"";if(m===4){typeof d?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){d?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const v=new $.$Mn(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>v.affectsConfiguration(m,o(I))})}k(a){return a.reduce((d,v)=>(d.set(v[0],v[1]),d),new Map)}}e.$2dc=n,e.$3dc=(0,k.$Vh)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,35,61,36,20,64,17,27,4,13,21,15,81,229,11]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=e.$rfc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(K){function U(F){if(F!=null)return F}K.from=U;function z(F){if(F!=null)return F}K.to=z})(l||(l={}));var n;(function(K){function U(F){if(F!=null)return F}K.from=U;function z(F){if(F!=null)return F}K.to=z})(n||(n={}));var s;(function(K){function U(F){if(F!=null)return F}K.from=U;function z(F){if(F!=null)return F}K.to=z})(s||(s={}));var a;(function(K){function U(O){if(O){const X=O;return X&&!!X.process}else return!1}K.is=U;function z(O){if(O==null)return;const X={process:O.process,args:O.args};return O.options&&(X.options=s.from(O.options)),X}K.from=z;function F(O){if(O!=null)return new R.$iL(O.process,O.args,O.options)}K.to=F})(a||(a={}));var d;(function(K){function U(F){if(F!=null)return F}K.from=U;function z(F){if(F!=null)return F}K.to=z})(d||(d={}));var v;(function(K){function U(O){if(O){const X=O;return X&&(!!X.commandLine||!!X.command)}else return!1}K.is=U;function z(O){if(O==null)return;const X={};return O.commandLine!==void 0?X.commandLine=O.commandLine:(X.command=O.command,X.args=O.args),O.options&&(X.options=d.from(O.options)),X}K.from=z;function F(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$jL(O.commandLine,O.options):new R.$jL(O.command,O.args?O.args:[],O.options)}K.to=F})(v||(v={}));var m;(function(K){function U(O){if(O){const X=O;return X&&X.customExecution==="customExecution"}else return!1}K.is=U;function z(O){return{customExecution:"customExecution"}}K.from=z;function F(O,X){return X.get(O)}K.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(K){function U(z,F){let O;return z.scope!==void 0&&typeof z.scope!="number"?O=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?O=F.workspaceFile:O=c.$9F),{id:z._id,workspaceFolder:O}}K.from=U})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}K.from=U})(S||(S={}));var h;(function(K){function U(O,X){if(O==null)return[];const $e=[];for(const Ee of O){const De=z(Ee,X);De&&$e.push(De)}return $e}K.fromMany=U;function z(O,X){if(O==null)return;let $e;O.execution instanceof R.$iL?$e=a.from(O.execution):O.execution instanceof R.$jL?$e=v.from(O.execution):O.execution&&O.execution instanceof R.$kL&&($e=m.from(O.execution));const Ee=l.from(O.definition);let De;return O.scope?typeof O.scope=="number"?De=O.scope:De=O.scope.uri:De=R.TaskScope.Workspace,!Ee||!De?void 0:{_id:O._id,definition:Ee,name:O.name,source:{extensionId:X.identifier.value,label:O.source,scope:De},execution:$e,isBackground:O.isBackground,group:S.from(O.group),presentationOptions:n.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}K.from=z;async function F(O,X,$e){if(O==null)return;let Ee;a.is(O.execution)?Ee=a.to(O.execution):v.is(O.execution)?Ee=v.to(O.execution):m.is(O.execution)&&(Ee=m.to(O._id,$e));const De=l.to(O.definition);let Ce;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Ce=O.source.scope:Ce=await X.resolveWorkspaceFolder(E.URI.revive(O.source.scope)):Ce=R.TaskScope.Workspace),!De||!Ce)return;const de=new R.$lL(De,Ce,O.name,O.source.label,Ee,O.problemMatchers);return O.isBackground!==void 0&&(de.isBackground=O.isBackground),O.group!==void 0&&(de.group=R.$hL.from(O.group._id),de.group&&O.group.isDefault&&(de.group=new R.$hL(de.group.id,de.group.label),O.group.isDefault===!0&&(de.group.isDefault=O.group.isDefault))),O.presentationOptions&&(de.presentationOptions=n.to(O.presentationOptions)),O._id&&(de._id=O._id),O.detail&&(de.detail=O.detail),de}K.to=F})(h||(e.TaskDTO=h={}));var w;(function(K){function U(F){return F}K.from=U;function z(F){if(F)return Object.assign(Object.create(null),F)}K.to=z})(w||(w={}));class y{#e;constructor(U,z,F){this._id=z,this.a=F,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let C=class{constructor(U,z,F,O,X,$e,Ee,De){this.q=new A.$Rd,this.r=new A.$Rd,this.s=new A.$Rd,this.t=new A.$Rd,this.a=U.getProxy(M.$yK.MainThreadTask),this.b=F,this.c=O,this.d=X,this.e=$e,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,F){if(!F)return new R.$AK(()=>{});const O=this.w();return this.j.set(O,{type:z,provider:F,extension:U}),this.a.$registerTaskProvider(O,z),new R.$AK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(U,z){this.a.$registerTaskSystem(U,z)}fetchTasks(U){return this.a.$fetchTasks(w.from(U)).then(async z=>{const F=[];for(const O of z){const X=await h.to(O,this.b,this.m);X&&F.push(X)}return F})}get taskExecutions(){const U=[];return this.k.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,z,F){const O=this.m.get(U.id);O&&(this.o.set(U.id,O),this.e.attachPtyToTerminal(z,await O.callback(F))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const z=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const z=await this.y(U.id);this.s.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const z=await this.y(U.id);this.t.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));const O=[],X=(0,L.$Qg)(()=>F.provider.provideTasks(P.CancellationToken.None)).then($e=>this.u(z,O,F,$e));return new Promise($e=>{X.then(Ee=>{Promise.all(O).then(()=>{$e(Ee)})})})}async $resolveTask(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(z.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${F.type}].`);const O=await h.to(z,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const X=await F.provider.resolveTask(O,P.CancellationToken.None);if(!X)return;this.z(X,F);const $e=h.from(X,F.extension);if(!$e)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is($e.execution)&&await this.x($e,X,!0),await this.v($e)}w(){return this.h++}async x(U,z,F){const O=await this.a.$createTaskId(U);!F&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,z.execution)),this.m.set(O,z.execution)}async y(U,z){if(typeof U=="string"){const X=this.l.get(U);if(!X)throw new o.$ab("Unexpected: The specified task is missing an execution");return X}const F=this.l.get(U.id);if(F)return F;const O=new Promise((X,$e)=>{function Ee(De,Ce,de){de?X(new y(De,Ce.id,de)):$e("Unexpected: Task does not exist.")}z?Ee(this,U,z):h.to(U.task,this.b,this.m).then(De=>Ee(this,U,De))});return this.l.set(U.id,O),O.then(X=>(this.k.set(U.id,X),X),X=>Promise.reject(X))}z(U,z){U._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const F=this.n.values();let O=F.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=F.next()}};e.$rfc=C,e.$rfc=C=Ke([We(0,u.$AM),We(1,b.$QM),We(2,$.$Zdc),We(3,D.$LM),We(4,f.$3dc),We(5,k.$oec),We(6,i.$dj),We(7,r.$Hdc)],C);let W=class extends C{constructor(U,z,F,O,X,$e,Ee,De){super(U,z,F,O,X,$e,Ee,De),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const F=h.from(z,U);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,z,!1);else throw new o.$$;const O=await this.y(await this.a.$getTaskExecution(F),z);return this.a.$executeTask(F).catch(X=>{throw new Error(X)}),O}u(U,z,F,O){const X=[];if(O)for(const $e of O){if(this.z($e,F),!$e.definition||!U[$e.definition.type]){const De=$e.source?$e.source:"No task source";this.f.warn(`The task [${De}, ${$e.name}] uses an undefined task type. The task will be ignored in the future.`)}const Ee=h.from($e,F.extension);Ee&&m.is(Ee.execution)?(X.push(Ee),z.push(this.x(Ee,$e,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:F.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,F){}};e.$sfc=W,e.$sfc=W=Ke([We(0,u.$AM),We(1,b.$QM),We(2,$.$Zdc),We(3,D.$LM),We(4,f.$3dc),We(5,k.$oec),We(6,i.$dj),We(7,r.$Hdc)],W),e.$tfc=(0,p.$Vh)("IExtHostTask")}),define(Pe[282],Ae([1,0,43,29]),function(be,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=void 0;function A(R){return"cellResults"in R}e.$lJ=A,e.$mJ="rawCell#";function M(R,$){let D=-1;const f=[];let P=[];return R.forEach(u=>{u.range.startLineNumber!==D&&P.length>0&&(f.push([...P]),P=[]),P.push(u),D=u.range.endLineNumber}),P.length>0&&f.push([...P]),f.map(u=>{const b=[],p=u[0].range.startLineNumber,g=u[u.length-1].range.endLineNumber;for(let t=p;t<=g;t++)b.push($.getLineContent(t));return new E.$2I(b.join(`
`)+`
`,u.map(t=>new L.$As(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$nJ=M}),define(Pe[283],Ae([1,0,162,24,5,6,28,12,16,2,41,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,I,S,h,w,y){this.q=S,this.r=h,this.s=w,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new A.$Rd({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$Rd({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$Rd({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$Rd({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Adc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(u.$yK.MainThreadNotebook),this.c=m.getProxy(u.$yK.MainThreadNotebookDocuments),this.d=m.getProxy(u.$yK.MainThreadNotebookEditors),this.i=I.converter,I.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const W=C.notebookEditor?.notebookUri,K=C.cell.handle,z=this.g.get(W)?.getCell(K);if(z)return z.apiCell}if(C&&C.$mid===14){const W=C.uri,K=this.g.get(W);if(K)return K.apiNotebook}return C}}),d.B(I)}getEditorById(m){const I=this.h.get(m);if(!I)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return I}getIdByEditor(m){for(const[I,S]of this.h)if(S.apiEditor===m)return I}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,I){const S=this.g.get(m);if(!S&&!I)throw new Error(`NO notebook document for '${m}'`);return S}static u(m,I){if(!I)return;const S=I.filenamePattern.map(h=>p.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(I.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:I.displayName,filenamePattern:S,exclusive:I.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,I,S){const h=d.a++,w=typeof S.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(h,S),this.b.$registerNotebookCellStatusBarItemProvider(h,w,I);let y;return w!==void 0&&(y=S.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(w))),new g.$AK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,w),y?.dispose()})}async createNotebookDocument(m){const I=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return f.URI.revive(I)}async openNotebookDocument(m){const I=this.g.get(m);if(I)return I.apiNotebook;const S=await this.c.$tryOpenNotebook(m),h=this.g.get(f.URI.revive(S));return(0,D.$Nf)(h?.apiNotebook)}async showNotebookDocument(m,I){f.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let S;typeof I=="object"?S={position:p.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(p.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0}:S={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,S),w=h&&this.h.get(h)?.apiEditor;if(w)return w;throw h?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,I,S,h){const w=this.f.get(m),y=f.URI.revive(I),C=this.g.get(y);if(!C||!w)return;const W=C.getCellFromIndex(S);if(!W)return;const K=await w.provideCellStatusBarItems(W.apiCell,h);if(!K)return;const U=new M.$Qc,z=this.p.add([U]),O=(Array.isArray(K)?K:[K]).map(X=>p.NotebookStatusBarItem.from(X,this.i,U));return{cacheId:z,items:O}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,I,S,h,w){if((0,$.$Fe)(I))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:I,serializer:S,options:h}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},I,p.NotebookDocumentContentOptions.from(h),d.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,I,S){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.deserializeNotebook(I.buffer,S);return new t.$xv(p.NotebookData.from(w))}async $notebookToData(m,I,S){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.serializeNotebook(p.NotebookData.to(I.value),S);return L.$fe.wrap(w)}async $saveNotebook(m,I,S,h,w){const y=f.URI.revive(I),C=this.x.get(m);if(!C)throw new Error("NO serializer found");const W=this.g.get(y);if(!W)throw new Error("Document NOT found");if(W.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new P.$zk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,h);const K={metadata:(0,o.$in)(W.apiNotebook.metadata,X=>!(C.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of W.apiNotebook.getCells()){const $e=new g.$YL(X.kind,X.document.getText(),X.document.languageId,X.mime,C.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);$e.metadata=(0,o.$in)(X.metadata,Ee=>!(C.options?.transientCellMetadata??{})[Ee]),K.cells.push($e)}const U=await C.serializer.serializeNotebook(K,w);await this.s.value.writeFile(y,U);const z=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:z.basename(y),isFile:(F.type&P.FileType.File)!==0,isDirectory:(F.type&P.FileType.Directory)!==0,isSymbolicLink:(F.type&P.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&P.FilePermission.Locked),etag:P.$Kk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(m,I,S,h,w){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(F,O,X)=>{await Promise.all(F.map(async $e=>await Promise.all($e.filenamePatterns.map(Ee=>{const De={...X,type:1,filePattern:Ee};return this.t.doInternalFileSearchWithCustomCallback(De,O,Ce=>{Ce.forEach(de=>{C.has(de)||h.some(re=>$e.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Re=>(0,a.$Bcb)(Re,de)))||C.add(de)})})}))))})(S,w,I);const K=new R.$zc;let U=!1;const z=Array.from(C).map(async F=>{const O=[];try{if(w.isCancellationRequested)return;if(I.maxResults&&[...K.values()].reduce((De,Ce)=>De+Ce.cellResults.length,0)>I.maxResults){U=!0;return}const X=[],$e=this.g.get(F);if($e)$e.apiNotebook.getCells().forEach(Ce=>X.push({input:Ce.document.getText(),outputs:Ce.outputs.flatMap(de=>de.items.map(pe=>pe.data.toString()))}));else{const De=await this.s.value.readFile(F),Ce=L.$fe.fromString(De.toString()),de=await y.deserializeNotebook(Ce.buffer,w);if(w.isCancellationRequested)return;p.NotebookData.from(de).cells.forEach(re=>X.push({input:re.source,outputs:re.outputs.flatMap(Re=>Re.items.map(se=>se.valueBytes.toString()))}))}if(w.isCancellationRequested)return;X.forEach((De,Ce)=>{const de=I.contentPattern.pattern,pe=new n.$MOb(De.input,void 0,De.outputs),re=pe.findInInputs(de),Re=pe.findInOutputs(de),se=Re.flatMap(Y=>(0,s.$nJ)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(re.length>0||Re.length>0){const Y={index:Ce,contentResults:(0,s.$nJ)(re,pe.inputTextBuffer),webviewResults:se};O.push(Y)}});const Ee={resource:F,cellResults:O};K.set(F,Ee);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...K.values()]}}async y(m,I){const S=await this.s.value.stat(m);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==P.$Jk&&typeof S.mtime=="number"&&typeof S.size=="number"&&I.mtime<S.mtime&&I.etag!==P.$Kk({mtime:I.mtime,size:S.size}))throw new P.$zk((0,E.localize)(1,null),3,I)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,I,S){if(this.h.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const h=new r.$Wec(I,this.d,m,S.visibleRanges.map(p.NotebookRange.to),S.selections.map(p.NotebookRange.to),typeof S.viewColumn=="number"?p.ViewColumn.to(S.viewColumn):void 0);this.h.set(I,h)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const S of m.value.removedDocuments){const h=f.URI.revive(S),w=this.g.get(h);w&&(w.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(w.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===h.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const S=[];for(const h of m.value.addedDocuments){const w=f.URI.revive(h.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const y=new i.$Vec(this.c,this.q,this.r,w,h);S.push(...h.cells.map(C=>i.$Uec.asModelAddData(y.apiNotebook,C))),this.g.get(w)?.dispose(),this.g.set(w,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const S of m.value.addedEditors){if(this.h.has(S.id))return;const h=f.URI.revive(S.documentUri),w=this.g.get(h);w&&this.A(w,S.id,S)}const I=[];if(m.value.removedEditors)for(const S of m.value.removedEditors){const h=this.h.get(S);h&&(this.h.delete(S),this.k?.id===h.id&&(this.k=void 0),I.push(h))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const S=new Set;this.l.forEach(h=>S.add(h.id));for(const h of this.h.values()){const w=S.has(h.id);h._acceptVisibility(w)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const I=b.$YM.String.with("notebookType","A notebook type"),S=new b.$1M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new b.$YM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>L.$fe.wrap(w))],new b.$ZM("Notebook Data",w=>p.NotebookData.to(w.value))),h=new b.$1M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new b.$YM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$xv(p.NotebookData.from(w)))],new b.$ZM("Bytes",w=>w.buffer));m.registerApiCommand(S),m.registerApiCommand(h)}}e.$6ec=d}),define(Pe[284],Ae([1,0,19,20,39,33,25,60,43]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class f{constructor(u,b,p){this.k=u,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$Cj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$Cj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((p,g)=>{const t=i=>{this.f++,u(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),c=E.$mc(r);this.j&&this.j(r,c)||this.v(t,{base:i,basename:c})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,A.$Gi)(i)))})})}async p(u,b){const p=new L.$2d,g=this.q(u),t=this.r(),i=new D.$dJ(this.k,u),r=!i.hasSiblingExcludeClauses();let c;try{this.h.add(p),c=$.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,p.token),l=c.elapsed(),n=$.$Nd.create();return this.g&&!this.e||(o&&o.forEach(s=>{const a=E.$fc.relative(u.folder.path,s.path);if(r){const d=E.$mc(s.path);this.v(b,{base:u.folder,relativePath:a,basename:d});return}this.s(t,u.folder,a,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:l,postProcessTime:n.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const b=(0,D.$cJ)(this.k.includePattern,u.includePattern),p=(0,D.$cJ)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,p,g){if(p===this.a){const i=E.$mc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const r=E.$mc(i),c=E.$lc(i);let o=u[c];o||(o=u[c]=[],t(c)),o.push({base:b,relativePath:i,basename:r})}t(p)}u({rootEntries:u,pathToEntries:b},p,g){const t=this,i=this.a;function r(c){const o=(0,D.$fJ)(()=>c.map(l=>l.basename));for(let l=0,n=c.length;l<n;l++){const s=c[l],{relativePath:a,basename:d}=s;if(p.matchesExcludesSync(a,d,i!==d?o:void 0))continue;const v=b[a];if(v)r(v);else{if(a===i)continue;t.v(g,s)}if(t.e)break}}r(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,p,g){const t=this.c(u.cacheKey),i=new f(u,b,t&&t.token);let r=0;const c=o=>{r+=o.length,p(o.map(l=>this.d(l)))};return this.e(i,P.a,c,g).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:o.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new L.$2d),this.b.get(u)}d(u){return u.relativePath?{resource:R.$zg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,p,g){const t=g.onCancellationRequested(()=>{u.cancel()}),i=c=>{c&&(r.push(c),b>0&&r.length>=b&&(p(r),r=[]))};let r=[];return u.search(i).then(c=>(r.length&&p(r),t.dispose(),c),c=>(r.length&&p(r),t.dispose(),Promise.reject(c)))}}e.$Xec=P}),define(Pe[285],Ae([1,0,18,246,33,94,28,13,19,25,12,16,2,93,180,40,15,47,105,281,43]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=void 0;let l=class{constructor(w,y,C,W,K){this.a=w,this.b=y,this.c=C,this.d=W,this.e=K}text(w,y,C={}){w=this.f(w,C);const W=this.a.getValue(),K=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(i.$ei),C),type:2,contentPattern:w,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(w,y){const C=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const W={...w,wordSeparators:C.editor.wordSeparators};return this.j(w,y)&&(W.isCaseSensitive=!0),this.k(w)&&(W.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),W}file(w,y={}){return{...this.h(w,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(w,y){return w?(w=Array.isArray(w)?w.map(v):v(w),y?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),W=this.g(y.excludePattern,y.expandPatterns),K=w.length>1,U=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(O=>this.q(O,y,W)):w.map(O=>this.r(O,y,W,K))).filter(O=>!!O),z={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:W.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=E.$Gb(E.$Qb(this.c.groups.map(Ee=>Ee.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const X=O.filter(Ee=>(0,o.$6I)(z,Ee.fsPath)),$e=this.i(X);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($e)),{...z,...$e}}const F=y.extraFileResources&&y.extraFileResources.filter(O=>(0,o.$6I)(z,O.fsPath));return z.extraFileResources=F&&F.length?F:void 0,z}i(w){const y=[],C=new R.$zc,W={};let K=!1;return w.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,f.$Dg)(U)){const F=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$lc(U.fsPath)});let O=C.get(F);O||(K=!0,O={folder:F,includePattern:{}},y.push(O),C.set(F,O));const X=D.$kc(F.fsPath,U.fsPath);(0,k.$Nf)(O.includePattern)[X.replace(/\\/g,"/")]=!0}else U.fsPath&&(K=!0,W[U.fsPath]=!0)}),{folderQueries:y,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(w,y){if(y.isSmartCase){if(w.isRegExp){if(P.$tf(w.pattern,!0))return!0}else if(P.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$CB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const y=$e=>D.$hc($e)||/^\.\.?([\/\\]|$)/.test($e),W=(Array.isArray(w)?w:a(w)).map($e=>{const Ee=this.e.resolvedUserHome;return Ee?(0,M.$Bv)($e,Ee.scheme===$.Schemas.file?Ee.fsPath:Ee.path):$e}),K=L.$J(W,$e=>y($e)?"searchPaths":"exprSegments"),U=(K.exprSegments||[]).map($e=>P.$Oe($e,"/")).map($e=>P.$Oe($e,"\\")).map($e=>($e[0]==="."&&($e="*"+$e),d($e))),z={},F=this.m(K.searchPaths||[]);F&&F.length&&(z.searchPaths=F);const O=E.$Qb(U),X=s(...O);return X&&(z.pattern=X),z}l(w,y){return y.disregardExcludeSettings?void 0:(0,o.$5I)(w,!y.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const y=w.flatMap(W=>{let{pathPortion:K,globPortion:U}=n(W);return U&&(U=m(U)),this.n(K).flatMap(F=>this.o(F,U))}),C=new Map;return y.forEach(W=>{const K=W.searchPath.toString(),U=C.get(K);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):C.set(K,{searchPath:W.searchPath,pattern:W.pattern?s(W.pattern):void 0})}),Array.from(C.values())}n(w){if(D.$hc(w)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==$.Schemas.file?[{searchPath:y[0].uri.with({path:w})}]:[{searchPath:u.URI.file(D.$gc(w))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(w=v(w),w.startsWith("../")||w===".."){const W=D.$fc.resolve(y.path,w);return[{searchPath:y.with({path:W})}]}const C=m(w);return[{searchPath:y,pattern:C}]}else{if(w==="./"||w===".\\")return[];{const y=w.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const U=y.match(new RegExp(`^${P.$Je(K.name)}(?:/(.*)|$)`));return U?{match:U,folder:K}:null}).filter(k.$Kf);if(W.length)return W.map(K=>{const U=K.match[1];return{searchPath:K.folder.uri,pattern:U&&m(U)}});{const K=w.match(/\.[\/\\](.+)[\/\\]?/),U=K?K[1]:w,z=p.localize(0,null,U);throw new Error(z)}}}}o(w,y){const C=w.pattern&&y?`${w.pattern}/${y}`:w.pattern||y,W=[{searchPath:w.searchPath,pattern:C}];return C&&!C.endsWith("**")&&W.push({searchPath:w.searchPath,pattern:C+"/**"}),W}q(w,y,C){const W=this.r((0,i.$ei)(w.searchPath),y,C,!1);return W?{...W,includePattern:w.pattern}:null}r(w,y,C,W){let K;const U=u.URI.isUri(w)?w:w.uri;if(C.searchPaths){const $e=C.searchPaths.filter(Ee=>(0,f.$sg)(Ee.searchPath,U))[0];if($e&&!$e.pattern)return null;$e&&(K=$e.pattern)}const z=this.a.getValue({resource:U}),O={...this.l(z,y)||{},...K||{}},X=u.URI.isUri(w)?(0,f.$wg)(w):w.name;return{folder:U,folderName:W?X:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$cK=l,e.$cK=l=Ke([We(0,g.$pi),We(1,i.$5h),We(2,r.$GC),We(3,t.$dj),We(4,c.$aK)],l);function n(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const y=w.index,C=h.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let W=h.substr(0,C.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:h.substr((C.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((w,y)=>(w[y]=!0,w),Object.create(null)):void 0}function a(h){return A.$Aj(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function m(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(h){return h.replace(/([?*[\]])/g,"[$1]")}function S(h,w){h=E.$Lb(h,W=>W.toString());const y=[],C=w.getWorkspace();return h&&h.forEach(W=>{let K;if(w.getWorkbenchState()===2)K=(0,f.$Bg)(C.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const U=w.getWorkspaceFolder(W);if(U){const z=U.name;if(C.folders.filter(O=>O.name===z).length===1){const O=(0,f.$Bg)(U.uri,W);O===""?K=`./${U.name}`:K=`./${U.name}/${O}`}else K=W.fsPath}}K&&y.push(I(K))}),y}e.$dK=S}),define(Pe[286],Ae([1,0,25,2,20,11,4,285,43,47]),function(be,e,E,L,A,M,R,$,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7qb=e.$6qb=void 0;const P=7e3;function k(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],c=[];for(const d of i)if(/^workspaceContains:/.test(d)){const v=d.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||g.forceUsingSearch?c.push(v):r.push(v)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let o;const l=new Promise((d,v)=>{o=d}),n=d=>o({activationEvent:d}),s=Promise.all(r.map(d=>u(g,d,n))).then(()=>{}),a=b(g,t.identifier,c,n);return Promise.all([s,a]).then(()=>{o(void 0)}),l}e.$6qb=k;async function u(g,t,i){for(const r of g.folders)if(await g.exists(E.$zg(L.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,r){if(i.length===0)return Promise.resolve(void 0);const c=new A.$2d,o=g.checkExists(g.folders,i,c.token),l=setTimeout(async()=>{c.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await o}catch(s){M.$3(s)||M.$Z(s)}c.dispose(),clearTimeout(l),n&&r(`workspaceContains:${i.join(",")}`)}function p(g,t,i,r){const c=g.get(R.$Uh),o=g.get(D.$WI),n=c.createInstance($.$cK).file(t.map(s=>(0,f.$ei)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$7qb=p}),define(Pe[37],Ae([1,0,159,19,88,25,14,6,50,2,15,3,36,218,85,35,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v,m,I,S,h,w,y,C,W,K,U,z,F,O){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=e.$Bec=e.$Aec=e.$zec=void 0,e.$zec=(0,a.$Vh)("IHostUtils");let $e=X=class extends $.$Rc{constructor(Y,B,ie,me,ne,le,ce,we,_,he,te,ae){super(),this.X=ae,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ie,this.f=ce,this.j=me,this.m=ne,this.s=le,this.t=_,this.u=he,this.w=te,this.y=this.g.getProxy(k.$yK.MainThreadWorkspace),this.z=this.g.getProxy(k.$yK.MainThreadTelemetry),this.C=this.g.getProxy(k.$yK.MainThreadExtensionService),this.D=new R.$Wg,this.F=new R.$Wg,this.G=new R.$Wg,this.H=new R.$Wg,this.I=new Re(this.f.extensions.activationEvents),this.L=new i.$Q5b(this.I,this.f.extensions.allExtensions);const ge=new c.$am(this.f.extensions.myExtensions);this.J=new i.$Q5b(this.I,pe(this.L,ge)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Ce(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Ce(this.J)}`)),this.M=new p.$kec(this.g,this.s),this.N=new C.$sec(this.g),this.O=we,this.h=Y.createChild(new I.$Th([p.$lec,this.M],[C.$tec,this.N])),this.P=this.B(new b.$jec(this.J,this.L,{onExtensionActivationError:(Se,T,V)=>{this.C.$onExtensionActivationError(Se,r.$2(T),V)},actualActivateExtension:async(Se,T)=>{if(i.$Q5b.isHostExtension(Se,this.J,this.L))return await this.C.$activateExtension(Se,T),new b.$iec;const V=this.J.getExtensionDescription(Se);return this.db(V,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){r.$Z(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this.cb(ne))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(me=>{this.s.error(me)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new c.$_l(B.identifier.value),extensionLocation:f.URI.revive(B.extensionLocation)}}Z(Y,B){return this.P.activateByEvent(Y,B)}$(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.$(Y,B).then(()=>{const ie=this.P.getActivatedExtension(Y);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===K.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(Y.fsPath);return f.URI.file(B)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new re(Y))),this.Q}async bb(Y){const B=D.$2h.forUris(ie=>M.$qg.ignorePathCasing(ie));return await Promise.all(Y.map(async ie=>{if(this.ub(ie)){const me=await this.ab(ie.extensionLocation);B.set(me,ie)}})),B}cb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const ie=this.P.getActivatedExtension(Y);if(!ie)return B;try{typeof ie.module.deactivate=="function"&&(B=Promise.resolve(ie.module.deactivate()).then(void 0,me=>(this.s.error(me),Promise.resolve(void 0))))}catch(me){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(me)}try{(0,$.$Mc)(ie.subscriptions)}catch(me){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(me)}return B}async db(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,B).then(ie=>{const me=ie.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,B),this.eb(Y,B,"success",me),ie},ie=>{throw this.eb(Y,B,"failure"),ie})}eb(Y,B,ie,me){const ne=De(Y,B);this.z.$publicLog2("extensionActivationTimes",{...ne,...me||{},outcome:ie})}fb(Y,B){const ie=De(Y,B);this.z.$publicLog2("activatePlugin",ie);const me=this.ub(Y);if(!me)return Promise.resolve(new b.$hec(b.$eec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ne=new b.$fec(B.startup);return Promise.all([this.vb(Y,(0,M.$zg)(Y.extensionLocation,me),ne),this.gb(Y)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),X.hb(this.s,Y.identifier,le[0],le[1],ne))).then(le=>(A.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),le))}gb(Y){const B=new l.$nec(Y,this.M),ie=new l.$mec(Y.identifier.value,!1,this.M),me=new W.$uec(Y,this.N),ne=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,le=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([B.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let we,_;const he=(0,t.$MF)(Y,"ipc")?this.f.messagePorts?.get(c.$_l.toKey(Y.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ie,secrets:me,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(te){return L.$ic(Y.extensionLocation.fsPath,te)},get storagePath(){return ce.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Y).fsPath},get logPath(){return L.$ic(ce.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return f.URI.joinPath(ce.f.logsLocation,Y.identifier.value)},get storageUri(){return ce.O.workspaceValue(Y)},get globalStorageUri(){return ce.O.globalValue(Y)},get extensionMode(){return ne},get extension(){return we===void 0&&(we=new de(ce,Y.identifier,Y,le,!1)),we},get extensionRuntime(){return(0,t.$NF)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!_){if(!he)return;const te=w.Event.buffer(w.Event.fromDOMEventEmitter(he,"message",ae=>ae.data));he.start(),_={onDidReceiveMessage:te,postMessage:he.postMessage.bind(he)}}return _}})})}static hb(Y,B,ie,me,ne){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(Y,B,ie,me,ne).then(le=>new b.$gec(!1,null,ne.build(),ie,le,me.subscriptions))}static ib(Y,B,ie,me,ne){if(typeof ie.activate=="function")try{ne.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const le=typeof global=="object"?global:self,ce=ie.activate.apply(le,[me]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ce).then(we=>(ne.activateResolveStop(),we))}catch(le){return Promise.reject(le)}else return Promise.resolve(ie)}jb(Y,B){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,ie=>{this.s.error(ie)})}kb(Y,B=0){const me=Date.now();(0,F.$B)(()=>{for(let ne=B;ne<Y.length;ne+=1){const le=Y[ne];for(const ce of le.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-me>50){this.kb(Y,ne);break}else this.jb(le,ce)}})}lb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(B)this.kb(ie);else for(const me of ie)if(me.activationEvents)for(const ne of me.activationEvents)ne==="onStartupFinished"&&this.jb(me,ne)})}mb(){const Y=this.Z("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.nb(le.added)));const B=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(B),me=this.pb(),ne=Promise.all([me,Y,ie]).then(()=>{});return Promise.race([ne,(0,R.$Yg)(1e4)]).then(()=>{this.lb()}),ne}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(Y,B))).then(()=>{})}async ob(Y,B){if(this.isActivated(B.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.s,folders:Y.map(le=>le.uri),forceUsingSearch:ie||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ce,we)=>this.y.$checkExists(le,ce,we)},ne=await(0,y.$6qb)(me,B);if(ne)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ne.activationEvent}).then(void 0,le=>this.s.error(le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(E.localize(0,null));const ie=await this.vb(null,B,new b.$fec(!1));if(!ie||typeof ie.run!="function")throw new Error(E.localize(1,null,B.toString()));return new Promise((me,ne)=>{const le=(_,he)=>{_?(F.$t&&this.s.error("Test runner called back with error",_),ne(_)):(F.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),me(typeof he=="number"&&he>0?1:0))},ce=(0,M.$ng)(B),we=ie.run(ce,le);we&&we.then&&we.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),me(0)}).catch(_=>{F.$t&&this.s.error("Test runner finished with error",_),ne(_ instanceof Error&&_.stack?_.stack:String(_))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.R[Y]=B,(0,$.$Pc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.sb(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const B=Y.indexOf("+");if(B===-1)throw new n.$GK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Y.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(Y,B){const ie=z.$Nd.create(!1),me=()=>`[resolveAuthority(${(0,s.$Zk)(Y)},${B})][${ie.elapsed()}ms] `,ne=J=>this.s.info(`${me()}${J}`),le=J=>this.s.warn(`${me()}${J}`),ce=(J,q=void 0)=>this.s.error(`${me()}${J}`,q),we=J=>{if(J instanceof n.$GK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},_=async J=>{ne(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw ce(`no resolver for ${x}`),new n.$GK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},he=Y.split(/@|%40/g).reverse();ne(`activating remote resolvers ${he.join(" -> ")}`);let te;try{te=await Promise.all(he.map(_)).catch(async J=>{if(!(J instanceof n.$GK)||J._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return le(`resolving nested authorities failed: ${J.message}`),[await _(Y)]})}catch(J){return we(J)}const ae=new R.$9g;ae.cancelAndSet(()=>ne("waiting..."),1e3);let ge,Se;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of te.entries())try{if(J===te.length-1)ne("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${q}`),ge=await x.resolve(ue,{resolveAttempt:B,execServer:Se}),A.mark(`code/extHost/didResolveAuthorityOK/${q}`),ne("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$FK.isManagedResolvedAuthority(ge)?ge:void 0));else{if(ne(`invoking resolveExecServer() for ${ue}`),A.mark(`code/extHost/willResolveExecServer/${q}`),Se=await x.resolveExecServer?.(ue,{resolveAttempt:B,execServer:Se}),!Se)throw new n.$GK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return A.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Ne),ae.dispose(),we(Ne)}ae.dispose();const T={environmentTunnels:ge.environmentTunnels,features:ge.tunnelFeatures},V={extensionHostEnv:ge.extensionHostEnv,isTrusted:ge.isTrusted,authenticationSession:ge.authenticationSessionForInitializingExtensions?{id:ge.authenticationSessionForInitializingExtensions.id,providerId:ge.authenticationSessionForInitializingExtensions.providerId}:void 0};ne(`returned ${n.$FK.isManagedResolvedAuthority(ge)?"managed authority":`${ge.host}:${ge.port}`}`);let G;if(n.$FK.isManagedResolvedAuthority(ge)){const J=B;this.X.setFactory(J,ge.makeConnection),G={authority:Y,connectTo:new s.$Wk(J),connectionToken:ge.connectionToken}}else G={authority:Y,connectTo:new s.$Xk(ge.host,ge.port),connectionToken:ge.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:T}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(Y)})`);const{resolver:ie}=await this.sb(Y);if(!ie)return null;const me=f.URI.revive(B);if(typeof ie.getCanonicalURI>"u")return me;const ne=await(0,R.$Qg)(()=>ie.getCanonicalURI(me));return ne||me}$startExtensionHost(Y){Y.toAdd.forEach(me=>me.extensionLocation=f.URI.revive(me.extensionLocation));const{globalRegistry:B,myExtensions:ie}=Ee(this.I,this.L,this.J,Y);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ie),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Ce(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Ce(this.J)}`)),this.rb()}$activateByEvent(Y,B){return B===1?this.D.wait().then(ie=>this.Z(Y,!1)):this.G.wait().then(ie=>this.Z(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(le=>le.extensionLocation=f.URI.revive(le.extensionLocation));const{globalRegistry:B,myExtensions:ie}=Ee(this.I,this.L,this.J,Y),me=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(me),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ie),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Ce(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Ce(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=o.$fe.alloc(Y),ie=Math.random()%256;for(let me=0;me<Y;me++)B.writeUInt8(ie,me);return B}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$Aec=$e,e.$Aec=$e=X=Ke([We(0,a.$Uh),We(1,e.$zec),We(2,m.$AM),We(3,g.$Zdc),We(4,u.$3dc),We(5,P.$dj),We(6,d.$QM),We(7,v.$6dc),We(8,S.$Rwb),We(9,h.$oec),We(10,U.$wec),We(11,O.$xec)],$e);function Ee(se,Y,B,ie){se.addActivationEvents(ie.addActivationEvents);const me=new i.$Q5b(se,Y.getAllExtensionDescriptions());me.deltaExtensions(ie.toAdd,ie.toRemove);const ne=new c.$am(B.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)ne.delete(ce);for(const ce of ie.myToAdd)ne.add(ce);const le=pe(me,ne);return{globalRegistry:me,myExtensions:le}}function De(se,Y){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function Ce(se){return se.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Bec=(0,a.$Vh)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Y,B,ie,me,ne){this.#e=Y,this.#t=B,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=L.$gc((0,M.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=me,this.isFromDifferentExtensionHost=ne}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Cec=de;function pe(se,Y){return se.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class re{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Dec=re;class Re{constructor(Y){this.a=new c.$bm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Pe[287],Ae([1,0,88,2,3,36,23,22,17,27,4,37,15,12]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;let g=class{constructor(o,l,n,s,a,d,v){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.h=d,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$Lfc=g,e.$Lfc=g=Ke([We(2,P.$Uh),We(3,M.$3dc),We(4,k.$Bec),We(5,f.$QM),We(6,u.$dj)],g);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const l=(0,b.$Je)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,n,s,a]=l,d=p.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),n+d+a}c(o){return o.replace(/\\/g,"/")}};t=p=Ke([We(0,f.$QM)],t);class i{constructor(o,l,n,s,a){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new $.$bm}load(o,l){const n=this.d.findSubstr(l);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,d)=>s+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$HF,this.e,this.f)}return this.b}}let r=class{constructor(o,l,n){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=n.getProxy(A.$yK.MainThreadTelemetry);const s=n.getProxy(A.$yK.MainThreadWindow);this.c=(a,d)=>{const v=L.URI.parse(a);return d?this.g(a,d):v.scheme==="http"||v.scheme==="https"?s.$openUri(v,a,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?s.$openUri(v,a,{}):this.g(a,d)}}load(o,l,n){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=n(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([We(2,D.$AM)],r)}),define(Pe[116],Ae([1,0,44,6,19,74,4,61,62,37,7,35,215,36]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=void 0,e.$Eec=(0,R.$Vh)("IExtHostVariableResolverProvider");class p extends u.$BN{constructor(i,r,c,o,l,n,s){function a(){if(c){const d=c.activeEditor();if(d)return d.document.uri;const v=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof P.$gM||v.input instanceof P.$lM)return v.input.modified;if(v.input instanceof P.$fM||v.input instanceof P.$kM||v.input instanceof P.$iM)return v.input.uri}}}super({getFolderUri:d=>{const v=n.folders.filter(m=>m.name===d);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(d,v)=>l.getConfiguration(void 0,d).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return A.$gc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=a();if(d){const v=r.getWorkspaceFolder(d);if(v)return A.$gc(v.uri.fsPath)}}},getSelectedText:()=>{if(c){const d=c.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(c){const d=c.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>i.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let g=class extends L.$Rc{constructor(i,r,c,o,l){super(),this.b=i,this.c=r,this.g=c,this.h=o,this.j=l,this.a=new E.$U(async()=>{const n=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,n,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Fec=g,e.$Fec=g=Ke([We(0,f.$Bec),We(1,k.$Zdc),We(2,$.$LM),We(3,b.$3dc),We(4,D.$cec)],g)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,37,17,7,35,207,209,36,116]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0,e.$Gec=(0,M.$Vh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,d,v,m,I){this.E=a,this.F=d,this.G=v,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Rd,this.n=new L.$Rd,this.o=new L.$Rd,this.u=new L.$Rd,this.k=s.getProxy(R.$yK.MainThreadDebugService),this.y=new L.$Rd,this.A=new L.$Rd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(h=>{this.J(S)}),this.J(S)})}asDebugSourceUri(s,a){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,m="?";return a&&(v+=`${m}session=${encodeURIComponent(a.id)}`,m="&"),v+=`${m}ref=${d.sourceReference}`,A.URI.parse(v)}else{if(d.path)return A.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const a=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const m of v)(0,b.$jF)(m)&&a.push(m.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){const a=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(a,[],[]);const d=[],v=new Map;for(const m of a)if(m instanceof P.$zL){let I=v.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},v.set(m.location.uri.toString(),I),d.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof P.$AL&&d.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const a=s.filter(I=>this.w.delete(I.id));this.U([],a,[]);const d=a.filter(I=>I instanceof P.$zL).map(I=>I.id),v=a.filter(I=>I instanceof P.$AL).map(I=>I.id),m=a.filter(I=>I instanceof P.$BL).map(I=>I.id);return this.k.$unregisterBreakpoints(d,v,m)}startDebugging(s,a,d){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,d){if(!a)return new P.$AK(()=>{});const v=this.d++;return this.f.push({type:s,handle:v,provider:a}),this.k.$registerDebugConfigurationProvider(s,d,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,v),new P.$AK(()=>{this.f=this.f.filter(m=>m.provider!==a),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(s,a,d){if(!d)return new P.$AK(()=>{});if(!this.Q(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:a,handle:v,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(a,v),new P.$AK(()=>{this.h=this.h.filter(m=>m.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new P.$AK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:a}),new P.$AK(()=>{this.j=this.j.filter(v=>v.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let d;const v=await this.W(s);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,a)}K(s,a){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,a){const d=this,v=await this.V(a);return this.S(this.N(v.type),v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const I=this.M(m),S=this.K(I,v);if(!S)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const h=S;return this.B.set(s,h),this.R(v).then(w=>(w&&this.C.set(s,w),h.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const C=y,W={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(C.arguments.value);W.body={signature:K},h.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,h.sendResponse(W)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(y),y=(0,b.$oF)(y,!0),d.k.$acceptDAMessage(s,y)}),h.onError(y=>{w&&w.onError&&w.onError(y),this.k.$acceptDAError(s,y.name,y.message,y.stack)}),h.onExit(y=>{w&&w.onExit&&w.onExit(y??void 0,void 0),this.k.$acceptDAExit(s,y??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(s,a){a=(0,b.$nF)(a,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(a),this.B.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.C.get(s);this.C.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],d=[],v=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let S;if(m.type==="function")S=new P.$AL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")S=new P.$BL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const h=A.URI.revive(m.uri);S=new P.$zL(new P.$MK(h,new P.$BK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,P.$xL)(S,I),this.w.set(I,S),a.push(S)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),d.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof P.$AL&&m.type==="function"){const S=I;S.enabled=m.enabled,S.condition=m.condition,S.hitCondition=m.hitCondition,S.logMessage=m.logMessage,S.functionName=m.functionName}else if(I instanceof P.$zL&&m.type==="source"){const S=I;S.enabled=m.enabled,S.condition=m.condition,S.hitCondition=m.hitCondition,S.logMessage=m.logMessage,S.location=new P.$MK(A.URI.revive(m.uri),new P.$BK(m.line,m.character))}v.push(I)}}}this.U(a,d,v)}async $acceptStackFrameFocus(s){let a;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?a=new P.$HL(d,s.threadId):a=new P.$GL(d,s.threadId,s.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(s,a,d){return(0,E.$Qg)(async()=>{const v=this.P(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(a);return v.provideDebugConfigurations(m,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(s,a,d,v){return(0,E.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(a);return m.resolveDebugConfiguration(I,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,d,v){return(0,E.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(a);return m.resolveDebugConfigurationWithSubstitutedVariables(I,d,v)})}async $provideDebugAdapter(s,a){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(a);return this.S(d,v).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const v={session:await this.V(s),event:a.event,body:a.body};this.u.fire(v)}M(s){if(s instanceof P.$CL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$DL)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$EL)return{type:"pipeServer",path:s.path};if(s instanceof P.$FL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const a=this.h.filter(d=>d.type===s);if(a.length>0)return a[0].factory}O(s){const a=this.h.filter(d=>d.handle===s);if(a.length>0)return a[0].factory}P(s){const a=this.f.filter(d=>d.handle===s);if(a.length>0)return a[0].provider}Q(s,a){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===a)return!0}}return!1}R(s){const d=s.configuration.type,v=this.j.filter(m=>m.type===d||m.type==="*").map(m=>(0,E.$Qg)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(v).then(m=>{const I=m.filter(S=>!!S);if(I.length>0)return new c(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,a){const d=a.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new P.$DL(d));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Qg)(()=>s.createDebugAdapterDescriptor(a,this.T(a,m))).then(I=>{if(I)return I})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,v))}T(s,a){}U(s,a,d){(s.length>0||a.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:a,changed:d}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const d=await this.W(s.folderUri),v=s.parent?this.l.get(s.parent):void 0;a=new i(this.k,s.id,s.type,s.name,d,s.configuration,v),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=A.URI.revive(s);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$Hec=t,e.$Hec=t=Ke([We(0,f.$AM),We(1,k.$Zdc),We(2,D.$Bec),We(3,p.$3dc),We(4,$.$cec),We(5,g.$Eec)],t);class i{constructor(s,a,d,v,m,I,S){this.d=s,this.f=a,this.g=d,this.h=v,this.i=m,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Iec=i;class r{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$Jec=r;class c{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(d=>d.onExit?d.onExit(s,a):void 0)}}class o extends u.$Mdb{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,a,d,v,m,I){super(s,a,d,v,m,I)}};e.$Kec=l,e.$Kec=l=Ke([We(0,f.$AM),We(1,k.$Zdc),We(2,D.$Bec),We(3,p.$3dc),We(4,$.$cec),We(5,g.$Eec)],l)}),define(Pe[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,37,59]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0;class t{static async installEarlyHandler(c){Error.stackTraceLimit=100;const o=c.get($.$dj),n=c.get(u.$AM).getProxy(M.$yK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{o.error(s);const a=E.$2(s);n.$onUnexpectedError(a)})}static async installFullHandler(c){const o=c.get($.$dj),l=c.get(u.$AM),n=c.get(p.$Bec),s=c.get(g.$UM),a=l.getProxy(M.$yK.MainThreadExtensionService),d=l.getProxy(M.$yK.MainThreadErrors),v=await n.getExtensionPathIndex(),m=new WeakMap;function I(w,y){if(m.has(w))return m.get(w).stack;let C="",W,K;for(const z of y)C+=`
	at ${z.toString()}`,K=z.getFileName(),!W&&K&&(W=v.findSubstr(A.URI.file(K)));const U=`${w.name||"Error"}: ${w.message||""}${C}`;return m.set(w,{extensionIdentifier:W?.identifier,stack:U}),U}const S=Symbol("prepareStackTrace wrapped");let h=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===I||!w||w[S]){h=w||I;return}h=function(y,C){return I(y,C),w.call(Error,y,C)},Object.assign(h,{[S]:!0})}}),E.setUnexpectedErrorHandler(w=>{o.error(w);const y=E.$2(w),C=m.get(w);if(!C?.extensionIdentifier){d.$onUnexpectedError(y);return}a.$onExtensionRuntimeError(C.extensionIdentifier,y);const W=s.onExtensionError(C.extensionIdentifier,w);o.trace("forwarded error to extension?",W,C)})}}e.$Mfc=t;class i{constructor(c,o,l,n,s){this.a=l,this.b=new R.$Y5b(c,null,n),o=i.e(o,this.b);const a=new f.$Th(...(0,D.$Er)());a.set(P.$QM,{_serviceBrand:void 0,...o,messagePorts:s}),a.set(u.$AM,new u.$BM(this.b)),a.set(b.$Wdc,new b.$Xdc(n)),a.set(p.$zec,l);const d=new k.$jq(a,!0);d.invokeFunction(t.installEarlyHandler),this.d=d.invokeFunction(v=>v.get($.$dj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=d.invokeFunction(v=>v.get(p.$Bec)),this.c.initialize(),d.invokeFunction(t.installFullHandler)}async asBrowserUri(c){const o=this.b.getProxy(M.$yK.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,o){c.extensions.allExtensions.forEach(n=>{n.extensionLocation=A.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),c.environment.appRoot=A.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(n=>A.URI.revive(o.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=A.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.$Nfc=i}),define(Pe[289],Ae([1,0,18,14,20,39,13,19,25,2,43]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class k{constructor(r,c,o,l){this.d=r,this.e=c,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(r,c){const o=this.d.folderQueries||[],l=new A.$2d(c);return new Promise((n,s)=>{this.a=new b(r);let a=!1;const d=(v,m)=>{if(!a&&!this.b){const I=this.h(v);g(v)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),v=this.j(v,this.d.maxResults-this.c));const S=this.h(v);this.c+=S,(S>0||!g(v))&&this.a.add(v,m)}};Promise.all(o.map((v,m)=>this.k(v,I=>d(I,m),l.token))).then(v=>{l.dispose(),this.a.flush();const m=v.some(I=>!!I&&!!I.limitHit);n({limitHit:this.b||m,messages:(0,E.$Qb)(v.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},v=>{l.dispose();const m=(0,M.$Gi)(v);s(new Error(m))})})}h(r){return g(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,c),preview:{matches:l.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,o){const l=new P.$dJ(this.d,r),n=[],s={report:v=>{if(!this.l(v))return;const m=r.folder.scheme===R.Schemas.file?(0,P.$eJ)(()=>this.f.readdir(D.$yg(v.uri))):void 0,I=D.$Bg(r.folder,v.uri);if(I){const S=l.includedInQuery(I,$.$mc(I),m);(0,L.$Kg)(S)?n.push(S.then(h=>{h&&c(v)})):S&&c(v)}}},a=this.n(r),d=await this.e.provideTextSearchResults(u(this.d.contentPattern),a,s,o);return n.length&&await Promise.all(n),d}l(r){if(g(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,P.$cJ)(this.d.includePattern,r.includePattern),o=(0,P.$cJ)(this.d.excludePattern,r.excludePattern),l={folder:f.URI.from(r.folder),excludes:o,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$Yec=k;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!D.$sg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(p(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$Zec=b;function p(i){return g(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$1ec=g;class t{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2ec=t}),define(Pe[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,A.$Vh)("IExtHostSearch");let k=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(L.$yK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$Xec}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,E.$Pc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,E.$Pc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,r){const c=u(i),o=this.h.get(g);if(o)return this.j.fileSearch(c,o,l=>{this.c.$handleFileMatch(g,t,l.map(n=>n.resource))},r);throw new Error("unknown provider: "+g)}async doInternalFileSearchWithCustomCallback(g,t,i){return{messages:[]}}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,r){const c=this.e.get(g);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const o=u(i);return this.q(o,c).search(n=>this.c.$handleTextMatch(g,t,n),r)}$enableExtensionHostSearch(){}q(g,t){return new P.$Yec(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$4ec=k,e.$4ec=k=Ke([We(0,R.$AM),We(1,$.$Wdc),We(2,D.$dj)],k);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>f.URI.revive(g))}}e.$5ec=u;function b(p){return{...p,folder:f.URI.revive(p.folder)}}}),define(Pe[290],Ae([1,0,20,11,5,6,13,31,2,146,142,129,92,22,41,15,99,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,36,272,117,110,242,243,244,220,245,61,62,247,37,248,63,249,42,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,35,208,79,23,114]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v,m,I,S,h,w,y,C,W,K,U,z,F,O,X,$e,Ee,De,Ce,de,pe,re,Re,se,Y,B,ie,me,ne,le,ce,we,_,he,te,ae,ge,Se,T,V,G,J,q,x,ue,Ne,Ue,Ze,Je,tt,_e,et,rt,nt,ze,dt,Z,Q,ye,Be,He,Xe,st,vt,Dt,Oe,Kt,Ht,yt,jt,Ot,Gt,Bt,St,Lt,Wt,Ye,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;function qt(ct){const gt=ct.get(B.$QM),Nt=ct.get(Y.$Edc),Pt=ct.get(Re.$5dc),At=ct.get(pe.$Bec),ft=ct.get(St.$Zdc),kt=ct.get(Z.$UM),Rt=ct.get(W.$3dc),Ct=ct.get(Ht.$Wdc),Ve=ct.get(Ue.$AM),zt=ct.get(nt.$lec),Jt=ct.get(ze.$6dc),Ie=ct.get(g.$ej),Me=ct.get(g.$dj),ve=ct.get(vt.$Rwb),H=ct.get(s.$Hdc),Le=ct.get(Bt.$Gfc),je=ct.get(tt.$tec),Qe=ct.get(Ce.$cec),qe=ct.get(he.$xec);Ve.set(o.$zK.ExtHostFileSystemInfo,Nt),Ve.set(o.$zK.ExtHostLogLevelServiceShape,Ie),Ve.set(o.$zK.ExtHostWorkspace,ft),Ve.set(o.$zK.ExtHostConfiguration,Rt),Ve.set(o.$zK.ExtHostExtensionService,At),Ve.set(o.$zK.ExtHostStorage,zt),Ve.set(o.$zK.ExtHostTunnelService,ve),Ve.set(o.$zK.ExtHostWindow,Le),Ve.set(o.$zK.ExtHostSecretState,je),Ve.set(o.$zK.ExtHostTelemetry,kt),Ve.set(o.$zK.ExtHostEditorTabs,Qe),Ve.set(o.$zK.ExtHostManagedSockets,qe);const it=Ve.set(o.$zK.ExtHostDecorations,ct.get(z.$Mec)),pt=Ve.set(o.$zK.ExtHostDocumentsAndEditors,ct.get(De.$LM)),$t=Ve.set(o.$zK.ExtHostCommands,ct.get(y.$WM)),bt=Ve.set(o.$zK.ExtHostTerminalService,ct.get(Q.$oec)),ut=Ve.set(o.$zK.ExtHostDebugService,ct.get(U.$Gec)),Mt=Ve.set(o.$zK.ExtHostSearch,ct.get(Je.$3ec)),Qt=Ve.set(o.$zK.ExtHostTask,ct.get(dt.$tfc)),Xt=Ve.set(o.$zK.ExtHostOutputService,ct.get(J.$gfc)),si=Ve.set(o.$zK.ExtHostLocalization,ct.get(_.$wec)),ki=Ve.set(o.$zK.ExtHostUrls,new yt.$Dfc(Ve)),It=Ve.set(o.$zK.ExtHostDocuments,new Ee.$Cdc(Ve,pt)),Zi=Ve.set(o.$zK.ExtHostDocumentContentProviders,new X.$Oec(Ve,pt,Me)),ln=Ve.set(o.$zK.ExtHostDocumentSaveParticipant,new $e.$Pec(Me,It,Ve.getProxy(o.$yK.MainThreadBulkEdits))),Et=Ve.set(o.$zK.ExtHostNotebook,new ae.$6ec(Ve,$t,pt,It,Pt,Mt)),gi=Ve.set(o.$zK.ExtHostNotebookDocuments,new Se.$afc(Et)),mi=Ve.set(o.$zK.ExtHostNotebookEditors,new T.$bfc(Me,Et)),oi=Ve.set(o.$zK.ExtHostNotebookKernels,new V.$cfc(Ve,gt,Et,$t,Me)),Si=Ve.set(o.$zK.ExtHostNotebookRenderers,new G.$efc(Ve,Et)),Ii=Ve.set(o.$zK.ExtHostNotebookDocumentSaveParticipant,new ge.$_ec(Me,Et,Ve.getProxy(o.$yK.MainThreadBulkEdits))),Ft=Ve.set(o.$zK.ExtHostEditors,new Be.$Tdc(Ve,pt)),$i=Ve.set(o.$zK.ExtHostTreeViews,new st.$Bfc(Ve.getProxy(o.$yK.MainThreadTreeViews),$t,Me)),Ci=Ve.set(o.$zK.ExtHostEditorInsets,new w.$Udc(Ve.getProxy(o.$yK.MainThreadEditorInsets),Ft,gt.remote)),ai=Ve.set(o.$zK.ExtHostDiagnostics,new F.$Gdc(Ve,Me,Nt,pt)),ci=Ve.set(o.$zK.ExtHostLanguages,new we.$0ec(Ve,It,$t.converter,Ct)),lt=Ve.set(o.$zK.ExtHostLanguageFeatures,new ce.$Kdc(Ve,Ct,It,$t,ai,Me,H,kt)),Pi=Ve.set(o.$zK.ExtHostFileSystem,new re.$Rec(Ve,lt)),xt=Ve.set(o.$zK.ExtHostFileSystemEventService,new se.$Sec(Ve,Me,pt)),ni=Ve.set(o.$zK.ExtHostQuickOpen,(0,Ne.$kfc)(Ve,ft,$t)),pi=Ve.set(o.$zK.ExtHostSCM,new Ze.$mfc(Ve,$t,It,Me)),Xi=Ve.set(o.$zK.ExtHostQuickDiff,new ue.$jfc(Ve,Ct)),Ai=Ve.set(o.$zK.ExtHostShare,new _e.$nfc(Ve,Ct)),Ri=Ve.set(o.$zK.ExtHostComments,(0,C.$Vdc)(Ve,$t,It)),Mi=Ve.set(o.$zK.ExtHostProgress,new x.$ifc(Ve.getProxy(o.$yK.MainThreadProgress))),xi=Ve.set(o.$zK.ExtHosLabelService,new le.$9ec(Ve)),Li=Ve.set(o.$zK.ExtHostTheming,new He.$yfc(Ve)),ui=Ve.set(o.$zK.ExtHostAuthentication,new a.$Mdc(Ve)),_i=Ve.set(o.$zK.ExtHostTimeline,new Xe.$Afc(Ve,$t)),Fi=Ve.set(o.$zK.ExtHostWebviews,new jt.$0dc(Ve,gt.remote,ft,Me,H)),Ti=Ve.set(o.$zK.ExtHostWebviewPanels,new Ot.$aec(Ve,Fi,ft)),Ni=Ve.set(o.$zK.ExtHostCustomEditors,new K.$bec(Ve,It,Jt,Fi,Ti)),Oi=Ve.set(o.$zK.ExtHostWebviewViews,new Gt.$Efc(Ve,Fi)),hi=Ve.set(o.$zK.ExtHostTesting,new ye.$ufc(Ve,$t,pt)),hn=Ve.set(o.$zK.ExtHostUriOpeners,new Kt.$Cfc(Ve)),en=Ve.set(o.$zK.ExtHostProfileContentHandlers,new q.$hfc(Ve));Ve.set(o.$zK.ExtHostInteractive,new me.$7ec(Ve,Et,pt,$t,Me));const zi=Ve.set(o.$zK.ExtHostInlineChat,new ie.$Tec(Ve,$t,It,Me)),vi=Ve.set(o.$zK.ExtHostChatProvider,new I.$Pdc(Ve,Me)),tn=Ve.set(o.$zK.ExtHostChatAgents2,new m.$Qdc(Ve,vi,Me)),nn=Ve.set(o.$zK.ExtHostChatVariables,new S.$Rdc(Ve)),bi=Ve.set(o.$zK.ExtHostChat,new v.$Odc(Ve)),wi=Ve.set(o.$zK.ExtHostAiRelatedInformation,new l.$Bdc(Ve)),rn=Ve.set(o.$zK.ExtHostAiEmbeddingVector,new de.$Qec(Ve)),_t=Ve.set(o.$zK.ExtHostIssueReporter,new ne.$8ec(Ve)),di=Ve.set(o.$zK.ExtHostStatusBar,new rt.$qfc(Ve,$t.converter)),dn=Ve.set(o.$zK.ExtHostSpeech,new et.$ofc(Ve)),Yt=Object.values(o.$zK);Ve.assertRegistered(Yt);const yi=new d.$Ndc(Ve,pt),sn=new h.$Sdc(Ve),Ei=new te.$$ec(Ve,Me),Ui=new O.$Nec(Ve);return n.$Ldc.register($t),function(Te,ti,ji){const mt=function(){let ee=!Te.isUnderDevelopment;function fe(){ee||(Me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")fe();else{const wt=ot;typeof wt.scheme>"u"&&fe(),typeof wt.exclusive=="boolean"&&(0,Ye.$NF)(Te,"documentFiltersExclusive")}return ot}}(),fn={getSession(ee,fe,Fe){return ui.getSession(Te,ee,fe,Fe)},getSessions(ee,fe){return(0,Ye.$NF)(Te,"authGetSessions"),ui.getSessions(Te,ee,fe)},async hasSession(ee,fe){return(0,Ye.$NF)(Te,"authSession"),!!await ui.getSession(Te,ee,fe,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,fe,Fe,ot){return ui.registerAuthenticationProvider(ee,fe,Fe,ot)}},gn={registerCommand(ee,fe,Fe){return $t.registerCommand(!0,ee,fe,Fe,void 0,Te)},registerTextEditorCommand(ee,fe,Fe){return $t.registerCommand(!0,ee,(...ot)=>{const wt=Ft.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Tt=>{fe.apply(Fe,[wt,Tt,...ot])}).then(Tt=>{Tt||Me.warn("Edits from command "+ee+" were not applied.")},Tt=>{Me.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ee,fe,Fe)=>((0,Ye.$NF)(Te,"diffCommand"),$t.registerCommand(!0,ee,async(...ot)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);fe.apply(Fe,[Tt,...ot])},void 0,void 0,Te)),executeCommand(ee,...fe){return $t.executeCommand(ee,...fe)},getCommands(ee=!1){return $t.getCommands(ee)}},Di={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$NF)(Te,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$NF)(Te,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Z.$TM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,fe){return Z.$SM.validateSender(ee),kt.instantiateLogger(Te,ee,fe)},openExternal(ee,fe){return Le.openUri(ee,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===gt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!gt.remote.authority})}catch(fe){if((0,t.$NU)(ee,R.Schemas.http)||(0,t.$NU)(ee,R.Schemas.https))return ee;throw fe}},get remoteName(){return(0,i.$2k)(gt.remote.authority)},get remoteAuthority(){return(0,Ye.$NF)(Te,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Me.getLevel()},get onDidChangeLogLevel(){return Me.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Ye.$NF)(Te,"handleIssueUri"),_t.registerIssueUriRequestHandler(Te,ee)},registerIssueDataProvider(ee){return(0,Ye.$NF)(Te,"handleIssueUri"),_t.registerIssueDataProvider(Te,ee)},get appQuality(){return(0,Ye.$NF)(Te,"resolvers"),gt.quality},get appCommit(){return(0,Ye.$NF)(Te,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Di);const on={createTestController(ee,fe,Fe){return hi.createTestController(Te,ee,fe,Fe)},createTestObserver(){return(0,Ye.$NF)(Te,"testObserver"),hi.createTestObserver()},runTests(ee){return(0,Ye.$NF)(Te,"testObserver"),hi.runTests(ee)},get onDidChangeTestResults(){return(0,Ye.$NF)(Te,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ye.$NF)(Te,"testObserver"),hi.results}},fi=gt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,an={getExtension(ee,fe){(0,Ye.$MF)(Te,"extensionsAny")||(fe=!1);const Fe=ti.mine.getExtensionDescription(ee);if(Fe)return new pe.$Cec(At,Te.identifier,Fe,fi,!1);if(fe){const ot=ti.all.getExtensionDescription(ee);if(ot)return new pe.$Cec(At,Te.identifier,ot,fi,!0)}},get all(){const ee=[];for(const fe of ti.mine.getAllExtensionDescriptions())ee.push(new pe.$Cec(At,Te.identifier,fe,fi,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$NF)(Te,"extensionsAny");const ee=new b.$am(ti.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),fe=[];for(const Fe of ti.all.getAllExtensionDescriptions()){const ot=!ee.has(Fe.identifier);fe.push(new pe.$Cec(At,Te.identifier,Fe,fi,ot))}return fe},get onDidChange(){return(0,Ye.$MF)(Te,"extensionsAny")?A.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Te.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,fe){return ci.changeLanguage(ee.uri,fe)},match(ee,fe){const Fe=It.getDocumentData(fe.uri)?.notebook;return(0,P.$LE)(Dt.LanguageSelector.from(ee),fe.uri,fe.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,fe,Fe){return lt.registerCodeActionProvider(Te,mt(ee),fe,Fe)},registerDocumentPasteEditProvider(ee,fe,Fe){return(0,Ye.$NF)(Te,"documentPaste"),lt.registerDocumentPasteEditProvider(Te,mt(ee),fe,Fe)},registerCodeLensProvider(ee,fe){return lt.registerCodeLensProvider(Te,mt(ee),fe)},registerDefinitionProvider(ee,fe){return lt.registerDefinitionProvider(Te,mt(ee),fe)},registerDeclarationProvider(ee,fe){return lt.registerDeclarationProvider(Te,mt(ee),fe)},registerImplementationProvider(ee,fe){return lt.registerImplementationProvider(Te,mt(ee),fe)},registerTypeDefinitionProvider(ee,fe){return lt.registerTypeDefinitionProvider(Te,mt(ee),fe)},registerHoverProvider(ee,fe){return lt.registerHoverProvider(Te,mt(ee),fe,Te.identifier)},registerEvaluatableExpressionProvider(ee,fe){return lt.registerEvaluatableExpressionProvider(Te,mt(ee),fe,Te.identifier)},registerInlineValuesProvider(ee,fe){return lt.registerInlineValuesProvider(Te,mt(ee),fe,Te.identifier)},registerDocumentHighlightProvider(ee,fe){return lt.registerDocumentHighlightProvider(Te,mt(ee),fe)},registerLinkedEditingRangeProvider(ee,fe){return lt.registerLinkedEditingRangeProvider(Te,mt(ee),fe)},registerReferenceProvider(ee,fe){return lt.registerReferenceProvider(Te,mt(ee),fe)},registerRenameProvider(ee,fe){return lt.registerRenameProvider(Te,mt(ee),fe)},registerDocumentSymbolProvider(ee,fe,Fe){return lt.registerDocumentSymbolProvider(Te,mt(ee),fe,Fe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Te,ee)},registerDocumentFormattingEditProvider(ee,fe){return lt.registerDocumentFormattingEditProvider(Te,mt(ee),fe)},registerDocumentRangeFormattingEditProvider(ee,fe){return lt.registerDocumentRangeFormattingEditProvider(Te,mt(ee),fe)},registerOnTypeFormattingEditProvider(ee,fe,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Te,mt(ee),fe,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ee,fe,Fe){return lt.registerDocumentSemanticTokensProvider(Te,mt(ee),fe,Fe)},registerDocumentRangeSemanticTokensProvider(ee,fe,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Te,mt(ee),fe,Fe)},registerSignatureHelpProvider(ee,fe,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Te,mt(ee),fe,Fe):lt.registerSignatureHelpProvider(Te,mt(ee),fe,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ee,fe,...Fe){return lt.registerCompletionItemProvider(Te,mt(ee),fe,Fe)},registerInlineCompletionItemProvider(ee,fe,Fe){return fe.handleDidShowCompletionItem&&(0,Ye.$NF)(Te,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$NF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ye.$NF)(Te,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Te,mt(ee),fe,Fe)},registerDocumentLinkProvider(ee,fe){return lt.registerDocumentLinkProvider(Te,mt(ee),fe)},registerColorProvider(ee,fe){return lt.registerColorProvider(Te,mt(ee),fe)},registerFoldingRangeProvider(ee,fe){return lt.registerFoldingRangeProvider(Te,mt(ee),fe)},registerSelectionRangeProvider(ee,fe){return lt.registerSelectionRangeProvider(Te,ee,fe)},registerCallHierarchyProvider(ee,fe){return lt.registerCallHierarchyProvider(Te,ee,fe)},registerTypeHierarchyProvider(ee,fe){return lt.registerTypeHierarchyProvider(Te,ee,fe)},setLanguageConfiguration:(ee,fe)=>lt.setLanguageConfiguration(Te,ee,fe),getTokenInformationAtPosition(ee,fe){return(0,Ye.$NF)(Te,"tokenInformation"),ci.tokenAtPosition(ee,fe)},registerInlayHintsProvider(ee,fe){return lt.registerInlayHintsProvider(Te,ee,fe)},createLanguageStatusItem(ee,fe){return ci.createLanguageStatusItem(Te,ee,fe)},registerDocumentDropEditProvider(ee,fe,Fe){return lt.registerDocumentOnDropEditProvider(Te,ee,fe,(0,Ye.$MF)(Te,"dropMetadata")?Fe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,fe,Fe){const ot=await(D.URI.isUri(ee)?Promise.resolve(Bi.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(ot,fe,Fe)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Te,ee)},onDidChangeActiveTextEditor(ee,fe,Fe){return Ft.onDidChangeActiveTextEditor(ee,fe,Fe)},onDidChangeVisibleTextEditors(ee,fe,Fe){return Ft.onDidChangeVisibleTextEditors(ee,fe,Fe)},onDidChangeTextEditorSelection(ee,fe,Fe){return Ft.onDidChangeTextEditorSelection(ee,fe,Fe)},onDidChangeTextEditorOptions(ee,fe,Fe){return Ft.onDidChangeTextEditorOptions(ee,fe,Fe)},onDidChangeTextEditorVisibleRanges(ee,fe,Fe){return Ft.onDidChangeTextEditorVisibleRanges(ee,fe,Fe)},onDidChangeTextEditorViewColumn(ee,fe,Fe){return Ft.onDidChangeTextEditorViewColumn(ee,fe,Fe)},onDidCloseTerminal(ee,fe,Fe){return bt.onDidCloseTerminal(ee,fe,Fe)},onDidOpenTerminal(ee,fe,Fe){return bt.onDidOpenTerminal(ee,fe,Fe)},onDidChangeActiveTerminal(ee,fe,Fe){return bt.onDidChangeActiveTerminal(ee,fe,Fe)},onDidChangeTerminalDimensions(ee,fe,Fe){return(0,Ye.$NF)(Te,"terminalDimensions"),bt.onDidChangeTerminalDimensions(ee,fe,Fe)},onDidChangeTerminalState(ee,fe,Fe){return bt.onDidChangeTerminalState(ee,fe,Fe)},onDidWriteTerminalData(ee,fe,Fe){return(0,Ye.$NF)(Te,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(ee,fe,Fe)},onDidExecuteTerminalCommand(ee,fe,Fe){return(0,Ye.$NF)(Te,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(ee,fe,Fe)},get state(){return Le.getState(Te)},onDidChangeWindowState(ee,fe,Fe){return Le.onDidChangeWindowState(ee,fe,Fe)},showInformationMessage(ee,...fe){return Ei.showMessage(Te,$.default.Info,ee,fe[0],fe.slice(1))},showWarningMessage(ee,...fe){return Ei.showMessage(Te,$.default.Warning,ee,fe[0],fe.slice(1))},showErrorMessage(ee,...fe){return Ei.showMessage(Te,$.default.Error,ee,fe[0],fe.slice(1))},showQuickPick(ee,fe,Fe){return ni.showQuickPick(Te,ee,fe,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,fe){return ni.showInput(ee,fe)},showOpenDialog(ee){return Ui.showOpenDialog(Te,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,fe,Fe){let ot,wt,Tt;return typeof ee=="string"?(ot=ee,wt=fe,Tt=Fe):(wt=ee,Tt=fe),di.createStatusBarEntry(Te,ot,wt,Tt)},setStatusBarMessage(ee,fe){return di.setStatusBarMessage(ee,fe)},withScmProgress(ee){return H.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Mi.withProgress(Te,{location:Oe.ProgressLocation.SourceControl},(fe,Fe)=>ee({report(ot){}}))},withProgress(ee,fe){return Mi.withProgress(Te,ee,fe)},createOutputChannel(ee,fe){return Xt.createOutputChannel(ee,fe,Te)},createWebviewPanel(ee,fe,Fe,ot){return Ti.createWebviewPanel(Te,ee,fe,Fe,ot)},createWebviewTextEditorInset(ee,fe,Fe,ot){return(0,Ye.$NF)(Te,"editorInsets"),Ci.createWebviewEditorInset(ee,fe,Fe,ot,Te)},createTerminal(ee,fe,Fe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,fe,Fe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,fe){return bt.registerProfileProvider(Te,ee,fe)},registerTerminalQuickFixProvider(ee,fe){return(0,Ye.$NF)(Te,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Te.identifier.value,fe)},registerTreeDataProvider(ee,fe){return $i.registerTreeDataProvider(ee,fe,Te)},createTreeView(ee,fe){return $i.createTreeView(ee,fe,Te)},registerWebviewPanelSerializer:(ee,fe)=>Ti.registerWebviewPanelSerializer(Te,ee,fe),registerCustomEditorProvider:(ee,fe,Fe={})=>Ni.registerCustomEditorProvider(Te,ee,fe,Fe),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Te)},registerUriHandler(ee){return ki.registerUriHandler(Te,ee)},createQuickPick(){return ni.createQuickPick(Te)},createInputBox(){return ni.createInputBox(Te)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,fe,Fe){return Li.onDidChangeActiveColorTheme(ee,fe,Fe)},registerWebviewViewProvider(ee,fe,Fe){return Oi.registerWebviewViewProvider(Te,ee,fe,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,fe,Fe){return Et.onDidChangeActiveNotebookEditor(ee,fe,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,fe,Fe){return mi.onDidChangeNotebookEditorSelection(ee,fe,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,fe,Fe){return mi.onDidChangeNotebookEditorVisibleRanges(ee,fe,Fe)},showNotebookDocument(ee,fe){return Et.showNotebookDocument(ee,fe)},registerExternalUriOpener(ee,fe,Fe){return(0,Ye.$NF)(Te,"externalUriOpener"),hn.registerExternalUriOpener(Te.identifier,ee,fe,Fe)},registerProfileContentHandler(ee,fe){return(0,Ye.$NF)(Te,"profileContentHandlers"),en.registrProfileContentHandler(Te,ee,fe)},registerQuickDiffProvider(ee,fe,Fe,ot){return(0,Ye.$NF)(Te,"quickDiffProvider"),Xi.registerQuickDiffProvider(mt(ee),fe,Fe,ot)},get tabGroups(){return Qe.tabGroups},registerShareProvider(ee,fe){return(0,Ye.$NF)(Te,"shareProvider"),Ai.registerShareProvider(mt(ee),fe)}},Bi={get rootPath(){return H.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ee){throw new L.$8("rootPath")},getWorkspaceFolder(ee){return ft.getWorkspaceFolder(ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ee){throw new L.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ee){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(ee,fe,...Fe)=>ft.updateWorkspaceFolders(Te,ee,fe||0,...Fe),onDidChangeWorkspaceFolders:function(ee,fe,Fe){return ft.onDidChangeWorkspace(ee,fe,Fe)},asRelativePath:(ee,fe)=>ft.getRelativePath(ee,fe),findFiles:(ee,fe,Fe,ot)=>ft.findFiles(ee,fe,Fe,Te.identifier,ot),findTextInFiles:(ee,fe,Fe,ot)=>{(0,Ye.$NF)(Te,"findTextInFiles");let wt,Tt;return typeof fe=="object"?(wt=fe,Tt=Fe):(wt={},Tt=fe,ot=Fe),ft.findTextInFiles(ee,wt||{},Tt,Te.identifier,ot)},save:ee=>((0,Ye.$NF)(Te,"saveEditor"),ft.save(ee)),saveAs:ee=>((0,Ye.$NF)(Te,"saveEditor"),ft.saveAs(ee)),saveAll:ee=>ft.saveAll(ee),applyEdit(ee,fe){return yi.applyWorkspaceEdit(ee,Te,fe)},createFileSystemWatcher:(ee,fe,Fe,ot)=>{let wt;return typeof fe=="boolean"?wt={ignoreCreateEvents:!!fe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:fe&&((0,Ye.$NF)(Te,"createFileSystemWatcher"),wt={...fe,correlate:!0}),xt.createFileSystemWatcher(ft,Te,ee,wt)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new L.$8("textDocuments")},openTextDocument(ee){let fe;const Fe=ee;if(typeof ee=="string")fe=Promise.resolve(D.URI.file(ee));else if(D.URI.isUri(ee))fe=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")fe=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ot=>It.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(ee,fe,Fe)=>It.onDidAddDocument(ee,fe,Fe),onDidCloseTextDocument:(ee,fe,Fe)=>It.onDidRemoveDocument(ee,fe,Fe),onDidChangeTextDocument:(ee,fe,Fe)=>It.onDidChangeDocument(ee,fe,Fe),onDidSaveTextDocument:(ee,fe,Fe)=>It.onDidSaveDocument(ee,fe,Fe),onWillSaveTextDocument:(ee,fe,Fe)=>ln.getOnWillSaveTextDocumentEvent(Te)(ee,fe,Fe),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,fe){let Fe;if(D.URI.isUri(ee))Fe=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Fe=D.URI.revive(await Et.createNotebookDocument({viewType:ee,content:fe}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,fe,Fe){return gi.onDidSaveNotebookDocument(ee,fe,Fe)},onDidChangeNotebookDocument(ee,fe,Fe){return gi.onDidChangeNotebookDocument(ee,fe,Fe)},onWillSaveNotebookDocument(ee,fe,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Te)(ee,fe,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,fe,Fe,ot){return Et.registerNotebookSerializer(Te,ee,fe,Fe,(0,Ye.$MF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,fe,Fe)=>ji.onDidChangeConfiguration(ee,fe,Fe),getConfiguration(ee,fe){return fe=arguments.length===1?void 0:fe,ji.getConfiguration(ee,fe,Te)},registerTextDocumentContentProvider(ee,fe){return Zi.registerTextDocumentContentProvider(ee,fe)},registerTaskProvider:(ee,fe)=>(H.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Te,ee,fe)),registerFileSystemProvider(ee,fe,Fe){return(0,M.$Oc)(Pi.registerFileSystemProvider(Te,ee,fe,Fe),Pt.addFileSystemProvider(ee,fe,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(ee,fe)=>((0,Ye.$NF)(Te,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,fe)),registerTextSearchProvider:(ee,fe)=>((0,Ye.$NF)(Te,"textSearchProvider"),Mt.registerTextSearchProvider(ee,fe)),registerRemoteAuthorityResolver:(ee,fe)=>((0,Ye.$NF)(Te,"resolvers"),At.registerRemoteAuthorityResolver(ee,fe)),registerResourceLabelFormatter:ee=>((0,Ye.$NF)(Te,"resolvers"),xi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$NF)(Te,"resolvers"),At.getRemoteExecServer(ee)),onDidCreateFiles:(ee,fe,Fe)=>xt.onDidCreateFile(ee,fe,Fe),onDidDeleteFiles:(ee,fe,Fe)=>xt.onDidDeleteFile(ee,fe,Fe),onDidRenameFiles:(ee,fe,Fe)=>xt.onDidRenameFile(ee,fe,Fe),onWillCreateFiles:(ee,fe,Fe)=>xt.getOnWillCreateFileEvent(Te)(ee,fe,Fe),onWillDeleteFiles:(ee,fe,Fe)=>xt.getOnWillDeleteFileEvent(Te)(ee,fe,Fe),onWillRenameFiles:(ee,fe,Fe)=>xt.getOnWillRenameFileEvent(Te)(ee,fe,Fe),openTunnel:ee=>((0,Ye.$NF)(Te,"tunnels"),ve.openTunnel(Te,ee).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ye.$NF)(Te,"tunnels"),ve.getTunnels()},onDidChangeTunnels:(ee,fe,Fe)=>((0,Ye.$NF)(Te,"tunnels"),ve.onDidChangeTunnels(ee,fe,Fe)),registerPortAttributesProvider:(ee,fe)=>((0,Ye.$NF)(Te,"portsAttributes"),ve.registerPortsAttributesProvider(ee,fe)),registerTunnelProvider:(ee,fe)=>((0,Ye.$NF)(Te,"tunnelFactory"),ve.registerTunnelProvider(ee,fe)),registerTimelineProvider:(ee,fe)=>((0,Ye.$NF)(Te,"timeline"),_i.registerTimelineProvider(ee,fe,Te.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ee=>((0,Ye.$NF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,fe,Fe)=>ft.onDidGrantWorkspaceTrust(ee,fe,Fe),registerEditSessionIdentityProvider:(ee,fe)=>((0,Ye.$NF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ee,fe)),onWillCreateEditSessionIdentity:(ee,fe,Fe)=>((0,Ye.$NF)(Te,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Te)(ee,fe,Fe)),registerCanonicalUriProvider:(ee,fe)=>((0,Ye.$NF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ee,fe)),getCanonicalUri:(ee,fe,Fe)=>((0,Ye.$NF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(ee,fe,Fe))},cn={get inputBox(){return H.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),pi.getLastInputBox(Te)},createSourceControl(ee,fe,Fe){return pi.createSourceControl(Te,ee,fe,Fe)}},Wi={createCommentController(ee,fe){return Ri.createCommentController(Te,ee,fe)}},Vi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(ee,fe,Fe){return ut.onDidStartDebugSession(ee,fe,Fe)},onDidTerminateDebugSession(ee,fe,Fe){return ut.onDidTerminateDebugSession(ee,fe,Fe)},onDidChangeActiveDebugSession(ee,fe,Fe){return ut.onDidChangeActiveDebugSession(ee,fe,Fe)},onDidReceiveDebugSessionCustomEvent(ee,fe,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ee,fe,Fe)},onDidChangeBreakpoints(ee,fe,Fe){return ut.onDidChangeBreakpoints(ee,fe,Fe)},onDidChangeStackFrameFocus(ee,fe,Fe){return(0,Ye.$NF)(Te,"debugFocus"),ut.onDidChangeStackFrameFocus(ee,fe,Fe)},registerDebugConfigurationProvider(ee,fe,Fe){return ut.registerDebugConfigurationProvider(ee,fe,Fe||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,fe){return ut.registerDebugAdapterDescriptorFactory(Te,ee,fe)},registerDebugAdapterTrackerFactory(ee,fe){return ut.registerDebugAdapterTrackerFactory(ee,fe)},startDebugging(ee,fe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ee,fe,{parentSession:Fe}):ut.startDebugging(ee,fe,Fe||{})},stopDebugging(ee){return ut.stopDebugging(ee)},addBreakpoints(ee){return ut.addBreakpoints(ee)},removeBreakpoints(ee){return ut.removeBreakpoints(ee)},asDebugSourceUri(ee,fe){return ut.asDebugSourceUri(ee,fe)}},qi={registerTaskProvider:(ee,fe)=>Qt.registerTaskProvider(Te,ee,fe),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Te,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,fe,Fe)=>Qt.onDidStartTask(ee,fe,Fe),onDidEndTask:(ee,fe,Fe)=>Qt.onDidEndTask(ee,fe,Fe),onDidStartTaskProcess:(ee,fe,Fe)=>Qt.onDidStartTaskProcess(ee,fe,Fe),onDidEndTaskProcess:(ee,fe,Fe)=>Qt.onDidEndTaskProcess(ee,fe,Fe)},li={createNotebookController(ee,fe,Fe,ot,wt){return oi.createNotebookController(Te,ee,fe,Fe,ot,(0,Ye.$MF)(Te,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,fe)=>Et.registerNotebookCellStatusBarItemProvider(Te,ee,fe),createRendererMessaging(ee){return Si.createRendererMessaging(Te,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$NF)(Te,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Te,ee)},registerKernelSourceActionProvider(ee,fe){return(0,Ye.$NF)(Te,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Te,ee,fe)},onDidChangeNotebookCellExecutionState(ee,fe,Fe){return(0,Ye.$NF)(Te,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,fe,Fe)}},Ki={t(...ee){if(typeof ee[0]=="string"){const fe=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return si.getMessage(Te.identifier.value,{message:fe,args:Fe})}return si.getMessage(Te.identifier.value,ee[0])},get bundle(){return si.getBundle(Te.identifier.value)},get uri(){return si.getBundleUri(Te.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,fe){return(0,Ye.$NF)(Te,"interactive"),zi.registerProvider(Te,ee,fe={label:fe?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(ee,fe){return(0,Ye.$NF)(Te,"interactive"),bi.registerChatProvider(Te,ee,fe)},sendInteractiveRequestToProvider(ee,fe){return(0,Ye.$NF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(ee,fe)},get onDidPerformUserAction(){return(0,Ye.$NF)(Te,"interactiveUserActions"),bi.onDidPerformUserAction},transferChatSession(ee,fe){return(0,Ye.$NF)(Te,"interactive"),bi.transferChatSession(ee,fe)}},Gi={getRelatedInformation(ee,fe){return(0,Ye.$NF)(Te,"aiRelatedInformation"),wi.getRelatedInformation(Te,ee,fe)},registerRelatedInformationProvider(ee,fe){return(0,Ye.$NF)(Te,"aiRelatedInformation"),wi.registerRelatedInformationProvider(Te,ee,fe)},registerEmbeddingVectorProvider(ee,fe){return(0,Ye.$NF)(Te,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(Te,ee,fe)}},Ji={registerChatResponseProvider(ee,fe,Fe){return(0,Ye.$NF)(Te,"chatProvider"),vi.registerProvider(Te.identifier,ee,fe,Fe)},requestChatAccess(ee){return(0,Ye.$NF)(Te,"chatRequestAccess"),vi.requestChatResponseProvider(Te.identifier,ee)},registerVariable(ee,fe,Fe){return(0,Ye.$NF)(Te,"chatVariables"),nn.registerVariableResolver(Te,ee,fe,Fe)},registerMappedEditsProvider(ee,fe){return(0,Ye.$NF)(Te,"mappedEditsProvider"),lt.registerMappedEditsProvider(Te,ee,fe)},createChatAgent(ee,fe){return(0,Ye.$NF)(Te,"chatAgents2"),tn.createChatAgent(Te,ee,fe)}},un={registerSpeechProvider(ee,fe){return(0,Ye.$NF)(Te,"speech"),dn.registerProvider(Te.identifier,ee,fe)}};return{version:gt.version,ai:Gi,authentication:fn,commands:gn,comments:Wi,chat:Ji,debug:Vi,env:Di,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Oe.$yL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$pM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,CallHierarchyIncomingCall:Oe.$XK,CallHierarchyItem:Oe.$WK,CallHierarchyOutgoingCall:Oe.$YK,CancellationError:L.$4,CancellationTokenSource:E.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Oe.$TK,CodeActionKind:Oe.$UK,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$ZK,Color:Oe.$aL,ColorInformation:Oe.$bL,ColorPresentation:Oe.$cL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$7K,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$8K,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$kL,DebugAdapterExecutable:Oe.$CL,DebugAdapterInlineImplementation:Oe.$FL,DebugAdapterNamedPipeServer:Oe.$EL,DebugAdapterServer:Oe.$DL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$OK,DiagnosticRelatedInformation:Oe.$NK,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$AK,DocumentHighlight:Oe.$QK,DocumentHighlightKind:Oe.DocumentHighlightKind,DocumentLink:Oe.$_K,DocumentSymbol:Oe.$SK,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$IL,InlineValueText:Oe.$JL,InlineValueVariableLookup:Oe.$KL,InlineValueEvaluatableExpression:Oe.$LL,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:A.$Rd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$VL,FileDecoration2:Oe.$VL,FileSystemError:Oe.$NL,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Oe.$OL,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$AL,InlineCompletionItem:Oe.$9K,InlineCompletionList:Oe.$0K,Hover:Oe.$PK,IndentAction:k.IndentAction,Location:Oe.$MK,MarkdownString:Oe.$1K,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Oe.$2K,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$BK,ProcessExecution:Oe.$iL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$UL,Range:Oe.$CK,RelativePattern:Oe.$wL,Selection:Oe.$DK,SelectionRange:Oe.$VK,SemanticTokens:Oe.$RL,SemanticTokensBuilder:Oe.$QL,SemanticTokensEdit:Oe.$SL,SemanticTokensEdits:Oe.$TL,SemanticTokensLegend:Oe.$PL,ShellExecution:Oe.$jL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$4K,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$3K,SnippetString:Oe.$LK,SourceBreakpoint:Oe.$zL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$RK,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$lL,TaskGroup:Oe.$hL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$dL,TerminalQuickFixExecuteTerminalCommand:Oe.$fL,TerminalQuickFixOpener:Oe.$eL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$gL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$HK,SnippetTextEdit:Oe.$JK,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$vL,ThemeIcon:Oe.$uL,TreeItem:Oe.$mL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$eM,UIKind:Wt.UIKind,Uri:D.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$KK,DocumentDropEdit:Oe.$sL,DocumentPasteEdit:Oe.$tL,InlayHint:Oe.$6K,InlayHintLabelPart:Oe.$5K,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$GK,ResolvedAuthority:Oe.$EK,ManagedResolvedAuthority:Oe.$FK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$6L,NotebookRange:Oe.$XL,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$YL,NotebookData:Oe.$ZL,NotebookRendererScript:Oe.$4L,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$2L,NotebookCellOutputItem:Oe.$1L,NotebookCellStatusBarItem:Oe.$3L,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$IK,NotebookKernelSourceAction:Oe.$5L,PortAttributes:Oe.$8L,LinkedEditingRanges:Oe.$7L,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$9L,TestMessage:Oe.$0L,TestMessage2:Oe.$0L,TestTag:Oe.$$L,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Oe.$rL,DataTransferItem:Oe.$nL,CoveredCount:Oe.$_L,FileCoverage:Oe.$aM,StatementCoverage:Oe.$bM,BranchCoverage:Oe.$cM,FunctionCoverage:Oe.$dM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$fM,TabInputTextDiff:Oe.$gM,TabInputTextMerge:Oe.$hM,TabInputCustom:Oe.$iM,TabInputNotebook:Oe.$kM,TabInputNotebookDiff:Oe.$lM,TabInputWebview:Oe.$jM,TabInputTerminal:Oe.$mM,TabInputInteractiveWindow:Oe.$nM,TabInputChat:Oe.$oM,TelemetryTrustedValue:r.$po,LogLevel:g.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Oe.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$GL,ThreadFocus:Oe.$HL,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$Hfc=qt}),define(Pe[291],Ae([1,0,70,112,35,110,36,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,256,15,116,82,83]),function(be,e,E,L,A,M,R,$,D,f,P,k,u,b,p,g,t,i,r,c,o,l,n,s,a,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Dr)(d.$wec,d.$vec,1),(0,E.$Dr)(s.$ej,n.$Ifc,1),(0,E.$Dr)(g.$Hdc,g.$Idc,1),(0,E.$Dr)($.$WM,$.$VM,0),(0,E.$Dr)(R.$3dc,R.$1dc,0),(0,E.$Dr)(i.$5dc,i.$4dc,0),(0,E.$Dr)(k.$Gec,k.$Kec,0),(0,E.$Dr)(M.$Mec,M.$Lec,0),(0,E.$Dr)(D.$LM,D.$KM,0),(0,E.$Dr)(v.$xec,v.$yec,0),(0,E.$Dr)(r.$Edc,r.$Ddc,0),(0,E.$Dr)(L.$gfc,L.$ffc,1),(0,E.$Dr)(u.$3ec,u.$4ec,0),(0,E.$Dr)(b.$lec,b.$kec,0),(0,E.$Dr)(P.$tfc,P.$sfc,0),(0,E.$Dr)(f.$oec,f.$rec,0),(0,E.$Dr)(p.$Rwb,p.$Swb,0),(0,E.$Dr)(t.$Gfc,t.$Ffc,0),(0,E.$Dr)(A.$Zdc,A.$Ydc,0),(0,E.$Dr)(c.$tec,c.$sec,0),(0,E.$Dr)(o.$UM,o.$RM,0),(0,E.$Dr)(l.$cec,l.$dec,0),(0,E.$Dr)(a.$Eec,a.$Fec,0)}),define(Pe[292],Ae([1,0,290,37,2,287,7,14,275]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class f extends M.$Lfc{j(){}getModule(b,p){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends L.$Aec{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Rhc);const b=this.h.invokeFunction(E.$Hfc);this.r=this.h.createInstance(f,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,p,g){p=p.with({path:k(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=A.URI.revive(await this.C.$asBrowserUri(p)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const c=await r.text(),o=`${p.toString(!0)}#vscode-extension`,l=`${c}
//# sourceURL=${o}`;let n;try{n=new Function("module","exports","require",l)}catch(v){throw console.error(t?`Loading code for extension ${t} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}b&&await this.w.initializeLocalizedMessages(b);const s={},a={exports:s},d=v=>{const m=this.r.getModule(v,p);if(m===void 0)throw new Error(`Cannot load module '${v}'`);return m};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(a,s,d),a.exports!==s?a.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Yg)(10)}}e.$Shc=P;function k(u,b){return u.endsWith(b)?u:u+b}}),define(Pe[293],Ae([1,0,69,70,15,37,200,86,292]),function(be,e,E,L,A,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$Dr)(A.$dj,new E.$Sh(R.$Kfc,[!0],!0)),(0,L.$Dr)(M.$Bec,D.$Shc,0),(0,L.$Dr)($.$6dc,$.$7dc,0)}),define(Pe[299],Ae([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(be,e,E,L,A,M,R,$,D,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function g(n){self.fetch=async function(s,a){return s instanceof Request||b(String(s))&&(s=(await n(P.URI.parse(String(s)))).toString(!0)),p(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,d,v,m){(async()=>(b(a.toString())&&(a=(await n(P.URI.parse(a.toString()))).toString(!0)),super.open(s,a,d??!0,v,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=f.$gg.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function w(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const y=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?y(W,K):y(w(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,U,z,F){return super.open(W,w(K),U??!0,z,F)}};const C=importScripts.bind(self);self.importScripts=(...W)=>{C(...W.map(w))},C(h)}.toString()}('${s}'))`;a=a||{},a.name=a.name||$.$mc(s.toString());const m=new Blob([v],{type:"application/javascript"}),I=URL.createObjectURL(m);return new n(I,a)}}else self.Worker=class extends R.$Thc{constructor(n,s){super(u,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){k()}};class i{constructor(){const s=new MessageChannel,a=new L.$Rd;let d=!1;u(s.port2,[s.port2]),s.port1.onmessage=v=>{const{data:m}=v;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$fe.wrap(new Uint8Array(m,0,m.byteLength));if((0,A.$im)(I,2)){d=!0,c("received terminate message from renderer");return}a.fire(I)},this.protocol={onMessage:a.event,send:v=>{if(!d){const m=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const a=n.onMessage(d=>{a.dispose();const v=JSON.parse(d.toString());n.send((0,A.$hm)(0)),s({protocol:n,initData:v})});n.send((0,A.$hm)(1))})}let c=n=>k();function o(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){o(s)&&r(n.protocol).then(a=>{D.mark("code/extHost/didWaitForInitData");const d=new M.$Nfc(a.protocol,a.initData,t,null,s.data);g(v=>d.asBrowserUri(v)),c=v=>d.terminate(v)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/345c8d0927402d41f42402411d856eeec4013e5e/core/vs/workbench/api/worker/extensionHostWorker.js.map
